/* ========================================== */
/* Database d:\medyczne\bazy_sql\medyczna.gdb */
/* ========================================== */

CREATE DATABASE "D:\PROGRAMY\medyczne\BAZA_SQL\medyczna.gdb" PAGE_SIZE 1024
  USER "sysdba" PASSWORD "masterkey"
  DEFAULT CHARACTER SET DOS852;

/* ------------------------ */
/* Definicje domen - oglne */
/* ------------------------ */

CREATE DOMAIN UZYTKOWNIK    AS VARCHAR(40) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN KLUCZ         AS INTEGER;
CREATE DOMAIN TYP           AS VARCHAR(1)  CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN IDENT         AS VARCHAR(3)  CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN DIDENT        AS VARCHAR(5)  CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN NUMER         AS VARCHAR(10) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN SYMBOL        AS VARCHAR(15) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN DUZY_SYMBOL   AS VARCHAR(30) CHARACTER SET DOS852 COLLATE PDOX_PLK;

CREATE DOMAIN OPIS          AS VARCHAR(60) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN DUZY_OPIS     AS VARCHAR(100) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN DUZA_NAZWA    AS VARCHAR(40) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN MALA_NAZWA    AS VARCHAR(20) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN NAZWISKO      AS VARCHAR(30) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN IMIE          AS VARCHAR(20) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN PLEC          AS VARCHAR(1);
CREATE DOMAIN PESEL         AS VARCHAR(11);
CREATE DOMAIN NIP           AS VARCHAR(13);
CREATE DOMAIN REGON         AS VARCHAR(9);
CREATE DOMAIN DOWOD         AS VARCHAR(9);
CREATE DOMAIN NRUBEZPIECZ   AS VARCHAR(11);   /* ZMIENIONE DALEJ NA 25 */

CREATE DOMAIN WOJEWODZTWO   AS VARCHAR(2);
CREATE DOMAIN POWIAT        AS VARCHAR(2);
CREATE DOMAIN GMINA         AS VARCHAR(2);
CREATE DOMAIN RODZAJGMINY   AS VARCHAR(1);
CREATE DOMAIN KOD_TERYT     AS VARCHAR(7);
CREATE DOMAIN KASACHORYCH   AS VARCHAR(2);

CREATE DOMAIN KRAJ          AS VARCHAR(15) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN MIEJSCOWOSC   AS VARCHAR(40) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN ULICA         AS VARCHAR(25) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN DOM           AS VARCHAR(10);
CREATE DOMAIN LOKAL         AS VARCHAR(5);
CREATE DOMAIN KOD_POCZTOWY  AS VARCHAR(6);
CREATE DOMAIN TEL_FAX       AS VARCHAR(30);

CREATE DOMAIN BANK          AS VARCHAR(40) CHARACTER SET DOS852;
CREATE DOMAIN KONTO         AS VARCHAR(40);

CREATE DOMAIN PARAMETRY     AS BLOB SUB_TYPE TEXT SEGMENT SIZE 80;
CREATE DOMAIN UWAGI         AS BLOB SUB_TYPE TEXT SEGMENT SIZE 80;
CREATE DOMAIN DOKUMENT      AS BLOB SUB_TYPE TEXT SEGMENT SIZE 80;
CREATE DOMAIN GRAFIKA       AS BLOB SUB_TYPE 0 SEGMENT SIZE 512;
CREATE DOMAIN XML           AS BLOB SUB_TYPE TEXT SEGMENT SIZE 80  CHARACTER SET UNICODE_FSS;
CREATE DOMAIN XML2          AS BLOB SUB_TYPE 0 SEGMENT SIZE 80;

CREATE DOMAIN KLUCZEKONT   AS VARCHAR(106); /* 15 poziomw */

CREATE DOMAIN ILOSC         AS DOUBLE PRECISION;
CREATE DOMAIN WARTOSC       AS DOUBLE PRECISION;
CREATE DOMAIN JM            AS VARCHAR(3) CHARACTER SET DOS852 COLLATE PDOX_PLK;

CREATE DOMAIN TAKNIE        AS VARCHAR(1);

CREATE DOMAIN BOOLEAN AS INTEGER CHECK (VALUE IN (0,1));
CREATE DOMAIN NUMERY_DNI_TYGODNIA AS INTEGER CHECK (VALUE IN (1,2,3,4,5,6,7));

CREATE DOMAIN NR_INSTALACJI    AS VARCHAR(38) CHARACTER SET DOS852 COLLATE PDOX_PLK;
CREATE DOMAIN TRESC_SMS   AS VARCHAR(160) CHARACTER SET ASCII;

/*==========================================================================*/
/* Pliki systemowe */
/* =============== */

CREATE TABLE BAZA
       (RODZAJ       SYMBOL NOT NULL,         /* Nie uzywane, zawsze MEDYCYNA, SZPITAL lub podobnie */
        ODSWIEZONO   TIMESTAMP,
        WERSJA       DOUBLE PRECISION,
        KODOWANIE    VARCHAR(3),              /* DOS, ISO, UTF */
        PROGRAMY     DOUBLE PRECISION,
        DEKLARACJAVAT INTEGER);               /* Nr biezacej deklaracji vat */

CREATE UNIQUE INDEX BAZA_RODZAJ ON BAZA(RODZAJ);

INSERT INTO BAZA(RODZAJ, WERSJA, PROGRAMY) VALUES('SZPITAL', 17.08, 17.00);
COMMIT WORK;


/*---*/

CREATE TABLE MIN_WERSJE_PROG
       (NAZWA_PROG       SYMBOL NOT NULL,
        WERSJA           DOUBLE PRECISION);

CREATE UNIQUE INDEX MIN_WERSJE_PROG_NAZWA ON MIN_WERSJE_PROG(NAZWA_PROG);


/* INSERT INTO MIN_WERSJE_PROG(NAZWA_PROG, WERSJA) VALUES('PLACE', 6.02); */
COMMIT WORK;

/*---*/

SET TERM ^ ;
CREATE PROCEDURE CZAS_SERWERA
RETURNS(
  CZAS  TIMESTAMP)
AS
BEGIN
  CZAS = CURRENT_TIMESTAMP;
  SUSPEND;
END^
COMMIT WORK ^
SET TERM ; ^

/* zmienne programu */

CREATE TABLE SYSTEM
       (ROK          INTEGER,
        MIESIAC      INTEGER,
        BIEZACY      TAKNIE,
        ZMIENNE      PARAMETRY,
        WYKAZYDANYCH PARAMETRY,
        FORMATY      PARAMETRY,
        LOGO         GRAFIKA,
        TYPLOGO      VARCHAR(1));   /* grafika - jpG, Bmp */

CREATE UNIQUE INDEX SYSTEM_INDEX1     ON SYSTEM(ROK, MIESIAC);

CREATE TABLE SYSTEMU_DANE
       (KONWERSJA    TAKNIE,     /* Wskanik wykonania konwersji w ADMIN */
        ZMIENNE      PARAMETRY,
        WYKAZYDANYCH PARAMETRY,
        FORMATY      PARAMETRY,
        LOGO         GRAFIKA,
        TYPLOGO      VARCHAR(1),   /* grafika - jpG, Bmp */

        WPORTALU     TAKNIE,

        EPUAP_CERT_EPUAP  BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        EPUAP_CERT_WLASNY BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        EPUAP_HASLO  VARCHAR(50)),

        JPK_CERT_JPK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        SMS_CERT_WLASNY BLOB SUB_TYPE 0 SEGMENT SIZE 80,

        P1_CERT_P1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        P1_HASLO      VARCHAR(50),
        P1_TLS_NUMER  VARCHAR(30),
        P1_HASLO_TLS  VARCHAR(50),
        P1_TRANSFORMATA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        P1_TNAZWAPLIKU  VARCHAR(50),     /* Nazwa pliku transformaty */

        ZSMOPL_CERT_ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        ZSMOPL_HASLO  VARCHAR(50));

COMMIT WORK;

CREATE UNIQUE INDEX SYSTEMU_DANE_INDEX1     ON SYSTEMU_DANE(KONWERSJA);   /* Musi by - inaczej dodatkowe transakcje s tworzone */


CREATE TABLE RYSUNKI
       (IDENT        SYMBOL NOT NULL,
        NAZWA        DUZA_NAZWA NOT NULL,
        RYSUNEK      GRAFIKA,
        TYPRYSUNKU   VARCHAR(1),    /* grafika - jpG, Bmp */
        PRIMARY KEY(IDENT));


/* ........................................................................ */

/* zapis ladu i aktualnych etapw przetwarzania */

CREATE TABLE SLAD
       (OSOBYKLUCZ   KLUCZ NOT NULL,
        OTWARCIEBAZY TIMESTAMP NOT NULL,
        CZAS         TIMESTAMP NOT NULL,
        KLUCZ        KLUCZ, /* dla logowania z internetu klucz osoby fizycznej */
        TYP          TYP,   /* Otwarcie, Zamknicie, D usuwanie, I - internet, U inne, X - odblokowanie uzytkownika */
        KOD          TYP,   /* Poprawne, Bdne */
        PROGRAMUID   MALA_NAZWA,
        ZAKLADUKLUCZ KLUCZ,
        INFO         PARAMETRY);

CREATE UNIQUE INDEX SLAD_INDEX1      ON SLAD(OSOBYKLUCZ, OTWARCIEBAZY, CZAS);
CREATE        INDEX SLAD_XKLUCZTYPKOD ON SLAD(KLUCZ, TYP, KOD);
CREATE        INDEX SLAD_XOTWARCIECZAS ON SLAD(OTWARCIEBAZY, CZAS);

/*
lad dziaa internetowych
*/

CREATE TABLE ISLAD
       (KLUCZ        KLUCZ NOT NULL,   /* GET_UNIQUE_KEY_GEN */
        DOTYCZY      KLUCZ NOT NULL,
        TYPDOTYCZY   TYP NOT NULL,     /* P - pracownicy, C - osoby fizyczne */
        CZAS         TIMESTAMP NOT NULL,
        TYP          TYP,   /* I logowanie z internetu, H - bdne haso */
        INFO         DUZY_OPIS,
        PRIMARY KEY(KLUCZ));

CREATE INDEX ISLAD_DOTYCZY     ON ISLAD(DOTYCZY, CZAS);

/*---*/

CREATE TABLE PRACUJACY
       (OSOBYKLUCZ     KLUCZ NOT NULL,
        OTWARCIEBAZY   TIMESTAMP NOT NULL,
        IDPOLACZENIA   KLUCZ NOT NULL,         /* Do nowej wersji systemu */
        OSOBYNAZWA     UZYTKOWNIK,
        KOMPUTER       MALA_NAZWA,
        PROGRAMUID     MALA_NAZWA,
        DZIALANIE      TYP,  /* Otwarcie, Ksigowanie, M nowy miesic, Inne */
        CZAS           TIMESTAMP,
        ODSWIEZANO     TIMESTAMP,              /* Do nowej wersji systemu */
        ZAKLADUKLUCZ   KLUCZ,
        ZASOBY         VARCHAR(200),
        PHI_LIC        INTEGER,                /* 0 (null) lub 1 gdy licencja Pharmindex jest uywana */
        CENTRALA_LIC   INTEGER);               /* 0 (null) lub 1 gdy licencja Call center jest uywana */

CREATE UNIQUE INDEX PRACUJACY_INDEX1 ON PRACUJACY(OSOBYKLUCZ, IDPOLACZENIA, OTWARCIEBAZY);


CREATE TABLE ZASOBY
       (ZASOB          VARCHAR(100) NOT NULL,
        OSOBA          INTEGER NOT NULL,
        IDPOLACZENIA   KLUCZ NOT NULL,             /* Do nowej wersji systemu */
        TRYB           TYP,           /* '0' - do odczytu, '1' - do zapisu */
        ILOSC          INTEGER,       /* ilosc blokowan */
        PRIMARY KEY(ZASOB, OSOBA, IDPOLACZENIA));

/* --- */

CREATE TABLE PODPOWIEDZIMEMO
       (ADRES          VARCHAR(100) NOT NULL,
        ZAKLAD         INTEGER NOT NULL,
        OSOBA          INTEGER NOT NULL,
        PODPOWIEDZI    PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(ADRES, ZAKLAD, OSOBA));


/* ........................................................................ */

/* opis wydrukw */

CREATE TABLE WYDRUKI
       (KLUCZ        KLUCZ NOT NULL,
        OPIS         PARAMETRY,
        TYP          IDENT,
        RODZAJ       IDENT,
        WARUNKI      PARAMETRY,
        WARUNEK      TAKNIE,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE GENERATOR WYDRUKI_GEN^

CREATE TRIGGER CREATE_WYDRUKI FOR WYDRUKI
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(WYDRUKI_GEN, 1);
END ^

CREATE PROCEDURE DAJ_WYDRUK
RETURNS (WYDRUK INTEGER)
AS BEGIN
  WYDRUK = GEN_ID(WYDRUKI_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* Opis schematw importu danych */

CREATE TABLE SCHEMATYIMPORTU
(
  KLUCZ	        KLUCZ NOT NULL,
  NAZWA	        DUZA_NAZWA,
  SCHEMAT	      PARAMETRY,
  UTWORZYL	    KLUCZ,
  ZMIENIAL	    KLUCZ,
  UTWORZONO	    TIMESTAMP,
  ZMIENIANO	    TIMESTAMP,
  TYPSCHEMATU	  MALA_NAZWA,
  RODZAJ	      MALA_NAZWA,
  ZRODLO        OPIS,
 PRIMARY KEY (KLUCZ));

CREATE GENERATOR SCHEMATYIMPORTU_GEN;

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_SCHEMATYIMPORTU FOR SCHEMATYIMPORTU
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(SCHEMATYIMPORTU_GEN, 1);
END ^

COMMIT WORK ^

CREATE PROCEDURE DAJ_SCHEMATYIMPORTU
RETURNS(SCHEMATYIMPORTU INTEGER)
AS BEGIN
  SCHEMATYIMPORTU = GEN_ID(SCHEMATYIMPORTU_GEN,1);
END ^

SET TERM ; ^

COMMIT WORK;

/* ........................................................................ */

/* Nowy system */

CREATE TABLE PROFILE_UZYTKOWNIKOW
       (KLUCZ        KLUCZ NOT NULL,
        NAZWA        OPIS,
        PRIMARY KEY(KLUCZ));


CREATE TABLE PRAWA_UZYTKOWNIKOW
       (OSOBA        KLUCZ NOT NULL,      /* Klucz osoby lub profilu */
        KTO          TYP NOT NULL,        /* O - osoba, P - profil */
        RODZAJ       TYP,                 /* P - program, F - formatka, U - uytkownicy (bez nowych pozycji,
                                             R - raport, T - tak/nie, E - rejestr finansowy, ... */

        DOTYCZY      INTEGER NOT NULL,    /* Zakad, klucz rejestru, ..., lub 0 */

        ZAKLADKA     SYMBOL NOT NULL,     /* Identyfikuje zakadk formy uprawnie */
        PRAWO        SYMBOL NOT NULL,     /* Identyfikuje uprawnienie w ramach zakadki */
        NAZWA        OPIS,

        WARTOSC      DUZY_SYMBOL,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(OSOBA, KTO, DOTYCZY, ZAKLADKA, PRAWO));


CREATE TABLE WYDRUKI_FR
       (KLUCZ        KLUCZ NOT NULL,
        TYP          SYMBOL,
        PODTYP       SYMBOL,
        GLOWNY       TAKNIE,   /* T - gwny, null - pozostae */
        DOTYCZY      INTEGER,  /* zakad, procedura, lista pac, ... */

        NAZWA        DUZY_OPIS,
        RAPORT       PARAMETRY,
        OPIS         PARAMETRY,
        DANE         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE  INDEX WYDRUKI_FR_XTYP  ON WYDRUKI_FR(TYP, PODTYP);

CREATE TABLE WARUNKI_FR
       (KLUCZ        KLUCZ NOT NULL,
        TYP          SYMBOL,
        PODTYP       SYMBOL,

        NAZWA        DUZY_OPIS,
        WARUNEK      PARAMETRY,
        OPIS         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE  INDEX WARUNKI_FR_XTYP  ON WARUNKI_FR(TYP, PODTYP);

/* ........................................................................ */


CREATE TABLE DEFINICJE_ZADAN
       (KLUCZ           KLUCZ NOT NULL,
        TYP             VARCHAR(2) NOT NULL,   /* [ZadaniaSAxon]
                                                  B=Backup,
                                                  KM=Komunikat,
                                                  LE=Laboratorium eksport,
                                                  LI=Laboratorium import,
                                                  EW=Ewus,
                                                  PE=PACS eksport,
                                                  PI=PACS import  */
        NAZWA           VARCHAR(100),
        DANE            PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,
        PRIMARY KEY(KLUCZ));


CREATE TABLE HARMONOGRAM
       (KLUCZ           KLUCZ NOT NULL,
        ZADANIE         KLUCZ NOT NULL,

        URUCHAMIANIE    TYP NOT NULL,           /* [TypHarmonogramu]
                                                   J=Jeden raz
                                                   C=Codziennie  */

        WAZNY_OD        TIMESTAMP,              /* Dla jednorazowego data wykonania */
        URUCHOM         TIMESTAMP,              /* Data i godzina lub tylko godzina */
        ZAKONCZ         TIMESTAMP,              /* Data i godzina lub tylko godzina */
        DNITYGODNIA     VARCHAR(25),            /* Dla codziennie [DniTygodnia] 1 (pon) ... 7 */
        CZESTOTLIWOSC   INTEGER,                /* W minutach */
        POZIOM          INTEGER,                /* Dla przyrostowego kopiowania 0, 1, 2, 3 */
        WYGASA          TIMESTAMP,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(ZADANIE) REFERENCES DEFINICJE_ZADAN(KLUCZ),
        PRIMARY KEY(KLUCZ));


CREATE TABLE PROCES_SYSTEMOWY
       (KLUCZ           KLUCZ NOT NULL,
        ZADANIE         KLUCZ NOT NULL,
        HARMONOGRAM     KLUCZ NOT NULL,

        IDPOLACZENIA    KLUCZ,        /* Identyfikator sesji programu */

        URUCHOMIONY     TIMESTAMP,
        ZAKONCZONY      TIMESTAMP,
        POPRAWNOSC      TAKNIE,

        DANE            PARAMETRY,    /* Pobierane z DANE z Definicje_zadan, ewentualnie uzupenione podczas wykonania */
        LOG             UWAGI,
        BLEDY           UWAGI,

        FOREIGN KEY(ZADANIE) REFERENCES DEFINICJE_ZADAN(KLUCZ),
        FOREIGN KEY(HARMONOGRAM) REFERENCES HARMONOGRAM(KLUCZ),
        PRIMARY KEY(KLUCZ));


CREATE TABLE KOMUNIKATY
       (KLUCZ           KLUCZ NOT NULL,
        ZADANIE         KLUCZ,          /* Gdy jest zadanie nie bedzie nadawcy */
        HARMONOGRAM     KLUCZ,
        PROCES          KLUCZ,          /* Gdy jest zadanie to klucz procesu zadania */

        NADAWCA_PROGRAM VARCHAR(20),    /* chyba nie bedzie uzywane */
        NADAWCA_OSOBA   KLUCZ,

        ODBIORCA_PROGRAM VARCHAR(20),
        ODBIORCA_OSOBA   KLUCZ,
        ODBIORCA_GRUPA   TYP,
        ODBIORCA_ZAKLAD  KLUCZ,

        UTWORZONY       TIMESTAMP,
        WAZNY_OD        TIMESTAMP,
        WYGASA          TIMESTAMP,

        PIERWSZYZAMYKA  TAKNIE,         /* T oznacza, e komunikat bedzie traktowany jako odczytany
                                           przez wszystkich po pierwszym odczycie */

        TYTUL           VARCHAR(100),
        TRESC           UWAGI,

        PRIMARY KEY(KLUCZ));

CREATE TABLE ODEBRANE_KOMUNIKATY
       (KOMUNIKAT       KLUCZ NOT NULL,
        OSOBA           KLUCZ NOT NULL,
        ODEBRANO        TIMESTAMP,

        FOREIGN KEY(KOMUNIKAT) REFERENCES KOMUNIKATY(KLUCZ),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ));

/* ........................................................................ */

CREATE TABLE KOMUNIKATY_PORTALU
   (KLUCZ             KLUCZ NOT NULL,       /* KOMUNIKAT_GEN w portalu*/
    DZIEN             INTEGER NOT NULL,

    SESJA             KLUCZ,       /* odwolanie do sesji w portalu */
    LP                INTEGER,     /* numer kolejny dzialania w sesji */

    STATUS            TYP,                  /* Do wyslania, Wyslany, E - blad, N - nie dotyczy  */
    RODZAJ            DIDENT,               /* rodzaj komunikatu */
    PODRODZAJ         DIDENT,               /* podrodzaj komunikatu */

    DOTYCZY           KLUCZ NOT NULL,       /* adresat */
    TYPDOTYCZY        TYP NOT NULL,         /* P - pracownicy (lekarze), C - pacjenci, K - firmy (nie wystapi) */

    PACJENT           KLUCZ NOT NULL,
    OSOBA             KLUCZ NOT NULL,

    OPISPACJENTA      VARCHAR(60),
    NAZWISKOIMIE      VARCHAR(60),          /* nadawca komunikatu */ 

    UTWORZONY         TIMESTAMP,            /* utworzony */
    ODEBRANY          TIMESTAMP,
    BLAD              VARCHAR(100),

    INFO              XML2,                 /* tresc komunikatu */
    ZAWARTOSC         TYP NOT NULL,         /* Memo, Json, Xml, Html */
    ZALACZNIK         VARCHAR(100),         /* adres pliku zalacznika */

    ODCZYTANY         TAKNIE,               /* dla zamowienia recept T oznacza utworzenie recepty */

    PRIMARY KEY(KLUCZ));

CREATE INDEX KOM_PORTALU_XPACJENT ON KOMUNIKATY_PORTALU(PACJENT);
CREATE INDEX KOM_PORTALU_XOSOBA ON KOMUNIKATY_PORTALU(OSOBA, ODCZYTANY);
CREATE INDEX KOM_PORTALU_XDZIEN ON KOMUNIKATY_PORTALU(DZIEN, RODZAJ);


CREATE TABLE SERIE_KOM_PORTALU
   (DZIEN             INTEGER NOT NULL,
    RODZAJ            DIDENT NOT NULL,      /* rodzaj komunikatu */
    PODRODZAJ         DIDENT,               /* podrodzaj komunikatu */

    PACJENT           KLUCZ NOT NULL,
    OSOBA             KLUCZ NOT NULL,

    OPISPACJENTA      VARCHAR(60),
    NAZWISKOIMIE      VARCHAR(60),          /* nadawca komunikatu */

    UTWORZONY         TIMESTAMP,            /* utworzony */

    PRIMARY KEY(DZIEN, RODZAJ, PACJENT, OSOBA));

CREATE INDEX SERIE_KOM_PORTALU_XPACJENT ON SERIE_KOM_PORTALU(PACJENT);
CREATE INDEX SERIE_KOM_PORTALU_XOSOBA ON SERIE_KOM_PORTALU(OSOBA);
CREATE INDEX SERIE_KOM_PORTALU_XUTWORZONY ON SERIE_KOM_PORTALU(UTWORZONY);

/* --- */

CREATE TABLE POMIARY_PACJENTOW
    (KLUCZ            KLUCZ NOT NULL,               /* DAJ_PACJENTA */
     UPACJENTA        KLUCZ NOT NULL,
     PACJENT          KLUCZ NOT NULL,
     CZAS             TIMESTAMP NOT NULL,
     RODZAJ           DIDENT,
     OPIS             VARCHAR(100),
     DANE             PARAMETRY,
     AUTOMAT          TAKNIE,

     POBYT           KLUCZ,
     ZAKLAD          KLUCZ,
     WIZYTA          INTEGER,

     UTWORZYL      KLUCZ,
     ZMIENIAL      KLUCZ,
     UTWORZONO     TIMESTAMP,
     ZMIENIANO     TIMESTAMP,

     FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
     PRIMARY KEY(KLUCZ));

CREATE INDEX POMIARYPAC_XUPACJENTA ON POMIARY_PACJENTOW(UPACJENTA);
CREATE INDEX POMIARYPAC_XCZAS ON POMIARY_PACJENTOW(CZAS);
CREATE INDEX POMIARYPAC_XPOBYT ON POMIARY_PACJENTOW(POBYT, ZAKLAD, WIZYTA);

/* --- */

CREATE TABLE EROZLICZENIA
   (KLUCZ             KLUCZ NOT NULL,     /* Z portalu, ujemne z systemu - przedpata za wizyt
                                             z systemu (CF_PWT) nie jest powiazana z portalem */
    PACJENT           KLUCZ NOT NULL,
    CZAS              TIMESTAMP,

    ID_CENNIK         KLUCZ,              /* Dane pochodza z systemu lokalnego */
    ID_CENA           KLUCZ,
    NAZWA_CENY        VARCHAR(60),

    OSOBA             KLUCZ NOT NULL,      /* moze byc 0 */
    ZAKLAD            KLUCZ NOT NULL,      /* moze byc 0 */

    ROK               INTEGER NOT NULL,
    MIESIAC           INTEGER NOT NULL,

    TYP               TYP NOT NULL,         /* Miesieczny ryczalt, Jednostkowe rozliczanie */
    DZIALANIE         NUMER NOT NULL,       /* czat, ..., SMS, ..., zgodnie z umowa */
    INNYKLUCZ         KLUCZ,                /* odwolanie do rekordu, ktrego dotyczy rozliczenie, zalezy od dzialania */

    ILOSC             ILOSC,
    WINIEN            WARTOSC,
    MA                WARTOSC,
    RABAT             WARTOSC,
    SPOSOB            TYP,                  /* Internet (PayU), Firma, Anulowano (z firmy),  Rejestracja (bez powizania z portalem) */

    PRIMARY KEY(KLUCZ));

CREATE INDEX EROZLICZENIA_XPACJENT ON EROZLICZENIA(PACJENT);
CREATE INDEX EROZLICZENIA_XOSOBA ON EROZLICZENIA(OSOBA);
CREATE INDEX EROZLICZENIA_XZAKLAD ON EROZLICZENIA(ZAKLAD);
CREATE INDEX EROZLICZENIA_XOKRES ON EROZLICZENIA(ROK, MIESIAC);
CREATE INDEX EROZLICZENIA_XINNYKLUCZ ON EROZLICZENIA(INNYKLUCZ);

/* --- */

CREATE TABLE OPINIE
   (CZAS             TIMESTAMP NOT NULL,
    OSOBA            KLUCZ NOT NULL,
    KLUCZ            KLUCZ NOT NULL,
    PUNKTY           ILOSC,
    PODPIS           VARCHAR(30),
    TRESC            UWAGI,

    PRIMARY KEY(OSOBA, CZAS, KLUCZ));

/* --- */

CREATE TABLE FILIE_DLA_PORTALU
    (KLUCZ           INTEGER NOT NULL,
     NAZWA           OPIS,
     AKTYWNA         TAKNIE,

     PRIMARY KEY(KLUCZ));


/* ........................................................................ */

/* wykaz pracownikw i uytkownikw */

CREATE TABLE OSOBY
       (KLUCZ         KLUCZ NOT NULL,
        CZYUZYTKOWNIK TAKNIE,
        NAZWA         UZYTKOWNIK,
        HASLO         MALA_NAZWA,
        OSTATNIAZMHASLA  TIMESTAMP,

        AKTYWNA       TAKNIE,
        WPORTALU      TAKNIE,
        OBCA          TAKNIE,
        REJ_INTERNET  TAKNIE, /* rejestracja przez internet */
        TYP           TYP,    /* T - techniczne, rne od NULL ignorowane w pacach */

        NAZWISKO      VARCHAR(50) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        IMIE          IMIE,
        DRUGIEIMIE    IMIE,
        PLEC          PLEC,

        DATAURODZENIA TIMESTAMP,
        MIEJSCEURODZ  MIEJSCOWOSC,

        NUMER         NUMER,
        PESEL         PESEL,
        NIP           NIP,
        TYPDOWODU     TYP,
        DOWOD         DOWOD,

        IDENT_P1      VARCHAR(50),

        RODZAJNRPODATKOWEGO  TYP,
        NRPODATKOWY          VARCHAR(30),
        OBOWIAZEKPODATKOWY   TYP,

        GRUPA         TYP,
        SYMBOL        SYMBOL,       /* Numer uprawnie zawodowych */
        SPECJALNOSC   DUZA_NAZWA,
        GRUPASPEC     SYMBOL,
        TYP_PERSONELU IDENT,        /* wartoci 1-31 wedug sownika MZ */

		SPEC1          VARCHAR(5),  /* Klasyfikacja MZ */
		SPEC2          VARCHAR(5),
		
        ZNL_IDENT      VARCHAR(20),

        ADRKRAJ        KRAJ,
        ADRWOJEWODZTWO MIEJSCOWOSC,
        ADRPOWIAT      MIEJSCOWOSC;
        ADRKODTERYT    KOD_TERYT,
        ADRMIEJSCOWOSC MIEJSCOWOSC,
        ADRKODPOCZTOWY KOD_POCZTOWY,
        ADRPOCZTA      MIEJSCOWOSC,
        ADRULICA       ULICA,
        ADRDOM         DOM,
        ADRLOKAL       LOKAL,
        ADRTELEFON     TEL_FAX,
        ADRSKRYTKA     ULICA,
        ADRMAIL        DUZY_OPIS,

        ADRGMINA       ULICA,
        ADRFAX         TEL_FAX,

        KOD_ZAWODU     VARCHAR(7),
        NAZWRODOWE     NAZWISKO,
        OBYWATELSTWO   NAZWISKO,

        MSZKRAJ        KRAJ,
        MSZPOWIAT      MIEJSCOWOSC,
        MSZKODTERYT    KOD_TERYT,
        MSZWOJEWODZTWO MIEJSCOWOSC,
        MSZPOCZTA      MIEJSCOWOSC,
        MSZKODPOCZTOWY KOD_POCZTOWY,
        MSZMIEJSCOWOSC MIEJSCOWOSC,
        MSZGMINA       ULICA,
        MSZULICA       ULICA,
        MSZDOM         DOM,
        MSZLOKAL       LOKAL,
        MSZTELEFON     TEL_FAX,
        MSZFAX         TEL_FAX,
        MSZMAIL        DUZY_OPIS,
        MSZSKRYTKA     ULICA,

        KORKRAJ        KRAJ,
        KORWOJEWODZTWO MIEJSCOWOSC,
        KORPOWIAT      MIEJSCOWOSC,
        KORKODTERYT    KOD_TERYT,
        KORGMINA       ULICA,
        KORKODPOCZTOWY KOD_POCZTOWY,
        KORMIEJSCOWOSC MIEJSCOWOSC,
        KORPOCZTA      MIEJSCOWOSC,
        KORSKRYTKA     ULICA,
        KORULICA       ULICA,
        KORDOM         DOM,
        KORLOKAL       LOKAL,
        KORTELEFON     TEL_FAX,
        KORFAX         TEL_FAX,
        KORMAIL        DUZY_OPIS,

        PRAWODOEMERYTPOCZ  TIMESTAMP,
        NIESPRAWNOSCPOCZ   TIMESTAMP,
        NIESPRAWNOSCKON    TIMESTAMP,

        NR_EMERYTURY DUZY_SYMBOL,

        PRAWODOEMERYT      TYP,
        NIEPELNOSPRAWNOSC  TYP,

        KODNFZ        IDENT,

        GRAFIK        KLUCZ,      /* Uywane tylko w przychodni (?) */
        GRUPAPROWIZYJNA   KLUCZ;

        PRAWA         PARAMETRY,  /* Stary - uprawnienia, nowy - rozne parametry */
        EKRAN         PARAMETRY,  /* w nowym wykorzystywane do pamieci formatek */

        /* osobowe - kadry */

        MATKA             IMIE,
        MATKA_NAZW_RODOWE NAZWISKO,
        OJCIEC            IMIE,
        ZAWIADOMIC        UWAGI,
        URZADPRACY        TAKNIE,
        DOD_UMIEJETNOSCI  UWAGI,

        /* wojsko - kadry */

        WOJ_STOSUNEK      OPIS,
        WOJ_STOPIEN       OPIS,
        WOJ_NR_SPECJ      OPIS,
        WOJ_WKU           OPIS,
        WOJ_NR_KSIAZKI    OPIS,
        WOJ_PRZYDZIAL     OPIS,

        /* wyksztacenie - kadry */

        KDR_ZAWOD        OPIS,
        KDR_TYTUL        OPIS,
        KDR_SPECJALNOSC  OPIS,
        KDR_STOPIEN      OPIS,

        WYKSZTALCENIE    IDENT,
        NARODOWOSC       DUZA_NAZWA,

        JEZYK1           DUZA_NAZWA,
        JEZYKMOWA1       TYP,
        JEZYKPISMO1      TYP,

        JEZYK2           DUZA_NAZWA,
        JEZYKMOWA2       TYP,
        JEZYKPISMO2      TYP,

        JEZYK3           DUZA_NAZWA,
        JEZYKMOWA3       TYP,
        JEZYKPISMO3      TYP,

        UWAGI         UWAGI,

        CERT          BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        HCERT         VARCHAR(300),                   /* po zaszyfrowaniu jest dlugie */

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE        INDEX OSOBY_XCZYNAZWA       ON OSOBY(CZYUZYTKOWNIK, NAZWA);
CREATE        INDEX OSOBY_XUNAZWA         ON OSOBY(NAZWA);
CREATE        INDEX OSOBY_XNAZWISKO       ON OSOBY(NAZWISKO);
/*
CREATE        INDEX OSOBY_XNAZWIMIE       ON OSOBY(NAZWISKO, IMIE);
CREATE        INDEX OSOBY_XGRUPANAZWIMIE  ON OSOBY(GRUPA, NAZWISKO, IMIE);
*/
CREATE        INDEX OSOBY_XNUMER          ON OSOBY(NUMER);
CREATE        INDEX OSOBY_XSYMBOL         ON OSOBY(SYMBOL);
CREATE INDEX OSOBY_XGRUPAPROWIZYJNA    ON OSOBY(GRUPAPROWIZYJNA);
CREATE        INDEX OSOBY_XZNL_IDENT       ON OSOBY(ZNL_IDENT);

SET TERM ^ ;
CREATE GENERATOR OSOBY_GEN^

CREATE TRIGGER CREATE_OSOBY FOR OSOBY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(OSOBY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_OSOBE
RETURNS (OSOBA INTEGER)
AS BEGIN
  OSOBA = GEN_ID(OSOBY_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/*---*/

CREATE TABLE RODZINA_PRACOWNIKOW
       (OSOBA         KLUCZ NOT NULL,
        KLUCZ         KLUCZ NOT NULL,
        NAZWISKO      NAZWISKO,
        IMIE          IMIE,
        PLEC          PLEC,
        DATAURODZENIA TIMESTAMP,
        DATAUPRAWNIEN TIMESTAMP,

        PESEL         PESEL,
        NIP           NIP,
        TYPDOWODU     TYP,
        DOWOD         DOWOD,

        ADRGMINA       ULICA,
        ADRMIEJSCOWOSC MIEJSCOWOSC,
        ADRKODPOCZTOWY KOD_POCZTOWY,
        ADRULICA       ULICA,
        ADRDOM         DOM,
        ADRLOKAL       LOKAL,
        ADRTELEFON     TEL_FAX,
        ADRFAX         TEL_FAX,

        POKREWIENSTWO      IDENT,
        GOSPODARSTWO       TYP,
        NIEPELNOSPRAWNOSC  TYP,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,


        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_RODZINE_PRACOWNIKOW FOR RODZINA_PRACOWNIKOW
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

COMMIT WORK;

/*---*/

CREATE TABLE PRACOWNICY
       (OSOBA         KLUCZ NOT NULL,
        GDZIE         KLUCZ NOT NULL,  /* Klucz zakadu lub firmy wg typu */
        TYP           TYP NOT NULL,    /* Zakad, Firma */
        PRIMARY KEY(OSOBA, GDZIE, TYP));

		
CREATE TABLE OSOBY_NIESPRAWNOSC
       (OSOBA              KLUCZ NOT NULL,
        NIESPRAWNOSCPOCZ   TIMESTAMP NOT NULL,
        NIESPRAWNOSCKON    TIMESTAMP,
        NIEPELNOSPRAWNOSC  TYP,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(OSOBA, NIESPRAWNOSCPOCZ));
		
/*==========================================================================*/
/* Sowniki danych */
/* =============== */

/* Kody terytorialne GUS */

CREATE TABLE POWIATY
       (WOJEWODZTWO  WOJEWODZTWO NOT NULL,
        POWIAT       POWIAT NOT NULL,
        NAZWA        DUZA_NAZWA,
        DODNAZWA     MALA_NAZWA);

CREATE UNIQUE INDEX POWIATY_INDEX1    ON POWIATY(WOJEWODZTWO, POWIAT);

/* --- */

CREATE TABLE GMINY
       (WOJEWODZTWO  WOJEWODZTWO NOT NULL,
        POWIAT       POWIAT NOT NULL,
        GMINA        GMINA NOT NULL,
        RODZAJGMINY  RODZAJGMINY,
        NAZWA        DUZA_NAZWA,
        DODNAZWA     MALA_NAZWA);

CREATE UNIQUE INDEX GMINY_INDEX1    ON GMINY(WOJEWODZTWO, POWIAT, GMINA, RODZAJGMINY);

/*---*/

CREATE TABLE KODY_MIAST
  (KOD_GMINY   KOD_TERYT NOT NULL,
   KOD_MIASTA  KOD_TERYT NOT NULL,
   MIASTO      DUZA_NAZWA,

   PRIMARY KEY(KOD_GMINY, KOD_MIASTA));

CREATE INDEX KODY_MIAST_MIASTO  ON KODY_MIAST(MIASTO);

/* --- */

CREATE TABLE UBEZPIECZYCIELE_UE
   (ID               INTEGER NOT NULL,
    KOD_INST         VARCHAR(20),
	KRAJ             VARCHAR(3),
    NAZWA            VARCHAR(100),
    MIASTO           VARCHAR(40),
    ULICA            VARCHAR(40),
    KOD_POCZT        VARCHAR(10),
    FAX              VARCHAR(15),
    TELEFON          VARCHAR(15),
    EMAIL            VARCHAR(100),
	WWW              VARCHAR(100),
    WAZNE_OD         TIMESTAMP,
    WAZNE_DO         TIMESTAMP,
    STATUS           VARCHAR(1),
    FUNKCJA_1        VARCHAR(1),
    FUNKCJA_2        VARCHAR(1), 
    DATA_MOD         TIMESTAMP,
	KOD_NOWEJ        INTEGER,
	
	PRIMARY KEY(ID));
	
CREATE INDEX UB_UE_KOD_INST  ON UBEZPIECZYCIELE_UE(KOD_INST);
CREATE INDEX UB_UE_KRAJ  ON UBEZPIECZYCIELE_UE(KRAJ);
CREATE INDEX UB_UE_NAZWA  ON UBEZPIECZYCIELE_UE(NAZWA);
CREATE INDEX UB_UE_MIASTO  ON UBEZPIECZYCIELE_UE(MIASTO);
	
 	

/* ........................................................................ */

/* Budynki, lokale, ka */

CREATE TABLE BUDYNKI
       (IDENT        DIDENT NOT NULL,
        NAZWA        DUZA_NAZWA,
        UWAGI        UWAGI);

CREATE UNIQUE INDEX BUDYNKI_INDEX1    ON BUDYNKI(IDENT);

/* --- */

CREATE TABLE LOKALE
       (BUDYNEK      DIDENT NOT NULL,
        IDENT        DIDENT NOT NULL,
        NAZWA        DUZA_NAZWA,
        GRUPA        TYP,
        POWIERZCHNIA ILOSC,
        ZAKLAD       KLUCZ,
        UWAGI        UWAGI);

CREATE UNIQUE INDEX LOKALE_INDEX1    ON LOKALE(BUDYNEK, IDENT);
CREATE        INDEX LOKALE_XZAKLAD   ON LOKALE(ZAKLAD);

/* --- */

CREATE TABLE LOZKA
       (KLUCZ        KLUCZ NOT NULL,
        BUDYNEK      DIDENT,
        LOKAL        DIDENT,
        NUMER        DIDENT,
        NR_INWENT    SYMBOL,
        RODZAJ       TYP,
        PLEC         PLEC,
        STAN         TYP,
        ZAKLAD       KLUCZ,
        PACJENT      KLUCZ,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE        INDEX LOZKA_XIDENT       ON LOZKA(BUDYNEK, LOKAL, NUMER);
CREATE        INDEX LOZKA_XZAKLADSTAN  ON LOZKA(ZAKLAD, STAN, BUDYNEK, LOKAL, NUMER);
CREATE        INDEX LOZKA_XZAKLAD      ON LOZKA(ZAKLAD, BUDYNEK, LOKAL, NUMER);
CREATE        INDEX LOZKA_XNR_INWENT   ON LOZKA(NR_INWENT);

SET TERM ^ ;
CREATE GENERATOR LOZKA_GEN^

CREATE TRIGGER CREATE_LOZKA FOR LOZKA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(LOZKA_GEN, 1);
END ^

CREATE PROCEDURE DAJ_LOZKO
RETURNS (LOZKO INTEGER)
AS BEGIN
  LOZKO = GEN_ID(LOZKA_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* ........................................................................ */

/* Jednostki organizacyjne */

CREATE TABLE ZAKLADY
       (KLUCZ        KLUCZ NOT NULL,
        NADRZEDNY    KLUCZ,
        SZEF         KLUCZ,
        FIRMA        KLUCZ,
        IDENT        SYMBOL,
        NAZWA        DUZY_OPIS,
        NAZWA_JEDN   DUZY_OPIS,
		REGON14      VARCHAR(15),

        ADRWOJEWODZTWO MIEJSCOWOSC,
        ADRGMINA       ULICA,
        ADRPOWIAT      MIEJSCOWOSC,
        ADRPOCZTA      MIEJSCOWOSC,
        ADRKODTERYT    KOD_TERYT,
        ADRMIEJSCOWOSC MIEJSCOWOSC,
        ADRKODPOCZTOWY KOD_POCZTOWY,
        ADRULICA       ULICA,
		ADRUL_PLAC     VARCHAR(3),
        ADRDOM         DOM,
        ADRLOKAL       LOKAL,

        PODMIOT_FINANSOWY KLUCZ,

        TELEFON      TEL_FAX,
        GRUPA        TYP,
        POZ_TYP      IDENT,
        TYPODDZIALU  TYP,
        POZ          TAKNIE,
        AKTYWNY      TAKNIE,
        WPORTALU     TAKNIE,

        WYKLUCZ_Z_KADR TAKNIE,
        REJ_INTERNET   TAKNIE, /* rejestracja przez internet */

        ZESTAW       NUMER,            /* oddzial, gabinet */
        ZESTAW1      NUMER,            /* oddzial - dla programu pielegniarki */
        ZESTAWPAC    NUMER,            /* pacjent */
        ZESTAWOBS    NUMER,            /* obserwacje oddzialu */
        ZESTAWPIEL   NUMER,            /* dzialania pielegniarki */

        MPK          KLUCZ,            /* Odwoanie do obiektu kosztowego */
        TYP_MPK      TYP,              /* N - nieruchomoci, B - Budynki czynszowe, O - osiedla,
                                          W - wze wodny, C - wze cieplny */

        VATTYP       TYP,              /* Do zakupw */

        SYMBOL       SYMBOL,
        SYMBOL1      SYMBOL,
        JEDNOSTKA    SYMBOL,
        NRJEDNOSTKI  SYMBOL,
        NUMERKSIEGI  INTEGER,
        MODULOBSLUGI TAKNIE,
        AUTOPRZYJECIE TAKNIE,          /* dla oddz, dla Przychodni - czy grafik */
        BLOKADADANYCH TAKNIE,
        KOLEJKI_OCZ   TAKNIE,
        DNIBEZKOLEJKI INTEGER,
        MINODSTEPKOLEJKI INTEGER,
        LOZKA        TAKNIE,
		SWIAD_DLA_DZIECI TAKNIE,
        DANE         PARAMETRY,

        UMOWA        DUZA_NAZWA,
        KOD_ODDZ_NFZ VARCHAR(16),       /*kod techniczny oddziau wg NFZ*/
        KOD_PLATNIKA VARCHAR(5),        /*kod patnika dla oddziau ?*/
        CENTR_KOD_KOM INTEGER,

        INSTALACJA_NFZ KLUCZ,
        BLOKADANFZ    TAKNIE,           /* T blokuje eksport do NFZ */
        WSK_DATY_SWIADCZEN   TAKNIE,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(NADRZEDNY) REFERENCES ZAKLADY(KLUCZ));

CREATE        INDEX ZAKLADY_XIDENT          ON ZAKLADY(IDENT);
CREATE        INDEX ZAKLADY_GRUPAIDENT      ON ZAKLADY(GRUPA, IDENT);
CREATE        INDEX ZAKLADY_XMPK            ON ZAKLADY(MPK);
CREATE        INDEX ZAKLADY_XPODMIOT        ON ZAKLADY(PODMIOT_FINANSOWY);

SET TERM ^ ;
CREATE GENERATOR ZAKLADY_GEN^

CREATE TRIGGER CREATE_ZAKLADY FOR ZAKLADY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(ZAKLADY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_ZAKLAD
RETURNS (ZAKLAD INTEGER)
AS BEGIN
  ZAKLAD = GEN_ID(ZAKLADY_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^


SET TERM ^ ;

CREATE PROCEDURE ZAKLADY_NADRZEDNE(
  ZAKLAD INTEGER)
RETURNS(
  KLUCZ INTEGER,
  NAZWA VARCHAR(100))
AS
DECLARE VARIABLE NADRZEDNY INTEGER;
BEGIN
  KLUCZ = 0;
  NAZWA = '';
  NADRZEDNY = :ZAKLAD;

  WHILE (NADRZEDNY > 0)
  DO BEGIN
    SELECT KLUCZ, NADRZEDNY, NAZWA
    FROM ZAKLADY
    WHERE KLUCZ = :NADRZEDNY
    INTO :KLUCZ, :NADRZEDNY, :NAZWA;
  END
  SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^



/* Zlecenia stale - do czego to suy ??? */

CREATE TABLE ZLECENIA_STALE
       (KLUCZ        KLUCZ NOT NULL,
        SZEF         KLUCZ,
        IDENT        DIDENT,
        NAZWA        DUZA_NAZWA,

        WAZNE_OD     TIMESTAMP,
        WAZNE_DO     TIMESTAMP,

        DANE         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

SET TERM ^ ;

CREATE TRIGGER CREATE_ZLECENIA_STALE FOR ZLECENIA_STALE
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(ZAKLADY_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^


/* ........................................................................ */

/* Opis procedur */

CREATE TABLE POJECIA
       (KLUCZ        KLUCZ NOT NULL,
        IDENT        NUMER,
        NAZWA        DUZA_NAZWA,
        GRUPA        TYP,
        IMPORT       DUZY_SYMBOL,
        DOMYSLNE     VARCHAR(150),

        TYPWARTOSCI  TYP,
        JM           JM,
        FORMAT       DUZA_NAZWA,

        ZAKRES       PARAMETRY,
        NORMY        PARAMETRY,
        KODY_IMPORTU PARAMETRY,

        SUMOWAC_DO   NUMER,
        PUNKTY       PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE        INDEX POJECIA_XIDENT          ON POJECIA(IDENT);
CREATE        INDEX POJECIA_XNAZWA          ON POJECIA(NAZWA);
CREATE        INDEX POJECIA_XGRUPAIDENT     ON POJECIA(GRUPA, IDENT);


SET TERM ^ ;
CREATE GENERATOR POJECIA_GEN^

CREATE TRIGGER CREATE_POJECIA FOR POJECIA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(POJECIA_GEN, 1);
END ^

CREATE PROCEDURE DAJ_POJECIE
RETURNS (POJECIE INTEGER)
AS BEGIN
  POJECIE = GEN_ID(POJECIA_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE FORMATKI
       (KLUCZ        KLUCZ NOT NULL,
        IDENT        NUMER,
        HTML         VARCHAR(50), /* nazwa pliku formatki w internecie */
        NAZWA        MALA_NAZWA,

        OPIS         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE        INDEX FORMATKI_XIDENT          ON FORMATKI(IDENT);

SET TERM ^ ;
CREATE GENERATOR FORMATKI_GEN^

CREATE TRIGGER CREATE_FORMATKI FOR FORMATKI
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(FORMATKI_GEN, 1);
END ^

CREATE PROCEDURE DAJ_FORMATKE
RETURNS (FORMATKA INTEGER)
AS BEGIN
  FORMATKA = GEN_ID(FORMATKI_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE ZESTAWY
       (ZESTAW       NUMER NOT NULL,
        FORMATKA     KLUCZ NOT NULL,

        PRIMARY KEY(ZESTAW, FORMATKA),
        FOREIGN KEY(FORMATKA) REFERENCES FORMATKI(KLUCZ));

/* --- */

CREATE TABLE POLA
       (FORMATKA     KLUCZ NOT NULL,
        NUMER        INTEGER,
        POJECIE      KLUCZ NOT NULL,

        PRIMARY KEY(FORMATKA, POJECIE),
        FOREIGN KEY(POJECIE) REFERENCES POJECIA(KLUCZ));

/* --- */

CREATE TABLE PROCEDURY
       (KLUCZ         KLUCZ NOT NULL,
        TYP           TYP,
        SYMBOL        DUZY_SYMBOL,
        MKPM          SYMBOL,
        MKPM_NFZ      SYMBOL,  /* dodatkowy symbol do rozlicze z NFZ */
        NAZWA         VARCHAR(250),
        AKTYWNA       TAKNIE,
        NFZ           TAKNIE,   /* wysyka do NFZ wg sownika ICD w XML */
        INTERNET      TAKNIE,   /* wprowadzanie danych z internetu */
        HTML          VARCHAR(50), /* nazwa pliku nagwkowego ankisty w internecie */
        HTMLK         VARCHAR(50), /* nazwa pliku koczcego ankiety w internecie */

        TECHNICZNE    TAKNIE,
        WERSJA        INTEGER,                  /* Nowa wersja ICD 9 */
        STARA_MKPM    SYMBOL,                   /* tutaj i niej przepisano stare wartoci */
        STARA_NAZWA   VARCHAR(250)   CHARACTER SET DOS852,

        KODBADANIANFZ SYMBOL,
        DO_ZESTAWOW_POZ    TAKNIE,
        KOLEJKI_OCZ   TAKNIE,

        NADRZEDNA     KLUCZ,
        GLOWNA        TAKNIE,    /* G - glowna na oddziale szpitala */
        PUNKTY        INTEGER,
        CENA          WARTOSC,

        ZESTAW        NUMER,
        ZZESTAW       NUMER,   /* Zestaw dla zlecenia */

        DATA_OD       TIMESTAMP,
        DATA_DO       TIMESTAMP,

        ID_TABELI_PROC VARCHAR(5),

        UWAGI         UWAGI,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(NADRZEDNA) REFERENCES PROCEDURY(KLUCZ));

CREATE INDEX PROCEDURY_XSYMBOL      ON PROCEDURY(SYMBOL);
CREATE INDEX PROCEDURY_XTYPSYMBOL   ON PROCEDURY(TYP, SYMBOL);
CREATE INDEX PROCEDURY_XMKPM        ON PROCEDURY(MKPM);
CREATE INDEX PROCEDURY_XMKPM_NFZ    ON PROCEDURY(MKPM_NFZ);
CREATE INDEX PROCEDURY_XTYPMKPM     ON PROCEDURY(TYP, MKPM);
CREATE INDEX PROCEDURY_XNAZWA       ON PROCEDURY(NAZWA);

SET TERM ^ ;
CREATE GENERATOR PROCEDURY_GEN^

CREATE TRIGGER CREATE_PROCEDURY FOR PROCEDURY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(PROCEDURY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_PROCEDURE
RETURNS (PROCEDURA INTEGER)
AS BEGIN
  PROCEDURA = GEN_ID(PROCEDURY_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE PROCEDURYZAKLADU
       (ZAKLAD        KLUCZ NOT NULL,
        PROCEDURA     KLUCZ NOT NULL,

        STATUS        TYP,

        WYK_ZAKLAD    KLUCZ,  /* Np. pracownia wykonujca */
        WYK_FIRMA     KLUCZ,  /* Firma zewntrzna */

        IMPORT        VARCHAR(100), /* Identyfikatory schematow importu (urzdzenia zewntrznego) */

        UWAGI         UWAGI,   /* dane konwersji symboli procedur */

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(ZAKLAD, PROCEDURA),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ),

        FOREIGN KEY(WYK_ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

/* UWAGA : Dodatkowy obcy klucz zdefiniowany po tablicy FIRMY */


/* ........................................................................ */

/* ICD-10 3 lub 4 znaki */

CREATE TABLE ICD_10
       (ROZDZIAL           VARCHAR(7) NOT NULL,
        GRUPA              VARCHAR(7) NOT NULL,
        PODGRUPA           VARCHAR(7) NOT NULL,
        KOD                VARCHAR(3) NOT NULL,
        KOD4               VARCHAR(2) NOT NULL,
        ODNOSNIK           TYP,
        ETYKIETA           VARCHAR(256) CHARACTER SET DOS852 COLLATE PDOX_PLK,

        PRIMARY KEY(ROZDZIAL, GRUPA, PODGRUPA, KOD, KOD4));

CREATE INDEX ICD_10_XKOD      ON ICD_10(KOD, KOD4);

/*==========================================================================*/
/* Pliki z danymi */
/* ============== */

/* PACJENCI - wykaz pacjentw */

CREATE TABLE PACJENCI
       (KLUCZ        KLUCZ NOT NULL,
        TELEKLUCZ    KLUCZ,
        NUMER        NUMER,
        NAZWISKO     VARCHAR(50) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        IMIE         IMIE,
        DRUGIEIMIE   IMIE,
        PESEL        PESEL,
        NIP          NIP,
        TYPDOWODU    TYP,
        DOWOD        MALA_NAZWA,
        INNE_DOKUMENTY VARCHAR(100),
        PLEC         PLEC,

        AKTYWNY      TAKNIE,

        ZDJECIE      INTEGER,   /* odwolanie do bazy dokumentow */

        NAZWISKO_DO_KORESPONDENCJI DUZY_OPIS,
        ZWROT_GRZECZN IDENT,
        NAZWISKA_WLASCICIELI DUZY_OPIS,

        ID_ZEWN      KLUCZ,     /* do polaczenia z programem swiadczeniodawcy */

        CUDZTYP      TYP,       /* dokumenty cudzoziemca */
        CUDZDOKUMENT MALA_NAZWA,
        CUDZWAZNOSC  TIMESTAMP,

        CUDZTYP2     TYP,        /* U - Unia, C - cudzoziemiec inny */
        NR_PAC_UE    MALA_NAZWA, /* do polaczenia z programem swiadczeniodawcy */
        UCHODZCA     TAKNIE,

        DATAURODZENIA TIMESTAMP,
        MIEJSCEURODZ  MIEJSCOWOSC,
        DATAZGONU     TIMESTAMP,

        ADRKODTERYT    KOD_TERYT,
        ADRMIEJSCOWOSC MIEJSCOWOSC,
        ADRKODPOCZTOWY KOD_POCZTOWY,
        ADRULICA       VARCHAR(50) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        ADRDOM         DOM,
        ADRLOKAL       LOKAL,
        ADRTELEFON     TEL_FAX,
        ADRMAIL        DUZY_OPIS,
        ADRSMS         VARCHAR(15),
        ADRKOD_MIASTA  KOD_TERYT,
        ADRPANSTWO     IDENT,    /* kody unijne */
        ADRSKRYTKA     DUZY_SYMBOL,

        MSZKODTERYT    KOD_TERYT,
        MSZMIEJSCOWOSC MIEJSCOWOSC,
        MSZKODPOCZTOWY KOD_POCZTOWY,
        MSZULICA       VARCHAR(50) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        MSZDOM         DOM,
        MSZLOKAL       LOKAL,
        MSZTELEFON     TEL_FAX,
        MSZKOD_MIASTA  KOD_TERYT,
        MSZSKRYTKA     DUZY_SYMBOL,

        NIESPRAWNOSCTYP  TYP,
        NIESPRAWNOSCPOCZ TIMESTAMP,
        NIESPRAWNOSCKON  TIMESTAMP,

        UBEZPIECZENIE    TYP,
        NRUBEZPIECZ      VARCHAR(25),
        UBEZPIECZYCIEL   KLUCZ,
        UBEZPWAZNOSC     TIMESTAMP,
        ZGLASZAJACY      INTEGER,  /* do ubezpieczenia */

        UMOWA_UBEZP_IND  MALA_NAZWA,

        DPSLUBDOMDZIECKA VARCHAR(10),
        NAUKA            TYP,

        KASACHORYCH    KASACHORYCH,
        ADRESDLAKCH    TYP,
        ZAPISDOKCH     TIMESTAMP,
        STARAKCH       KASACHORYCH,

        ZOZ            KLUCZ,
        STARYZOZ       KLUCZ,
        ZAPISDOZOZ     TIMESTAMP,
        ZMIANYDLAKCH   TIMESTAMP,

        LEKARZ         KLUCZ,
        PIELEGNIARKA   KLUCZ,
        POLOZNA        KLUCZ,
        DEKLARACJA     TAKNIE,

        data_lek  TIMESTAMP,
        data_piel TIMESTAMP,
        data_pol  TIMESTAMP,

        NR_DEKL_LEK  KLUCZ,
        NR_DEKL_PIEL KLUCZ,
        NR_DEKL_POL  KLUCZ,

        ZALICZONO_LEK  TAKNIE,
        ZALICZONO_PIEL TAKNIE,
        ZALICZONO_POL  TAKNIE,

        WYB_LEK        TYP,
        WYB_PIEL       TYP,
        WYB_POL        TYP,

        BANK           BANK,
        KONTO          KONTO,

        WYSLANE        TAKNIE,
        UPRAWNIENIE_PO VARCHAR(8), /*PO-MON   : onierz suby zasadniczej MON, */
                                   /*PO-MSWIA : funkcjonariusz w subie kandydackiej (suba zasadnicza) MSWIA*/
                                   /*PO-MS    : funkcjonariusz w subie kandydackiej (suba zasadnicza) MS*/
        DOK_PO_NAZWA MALA_NAZWA,
        DOK_PO_NUMER MALA_NAZWA,
        DOK_PO_DATA_WYST  TIMESTAMP,
        DOK_PO_DATA_DO    TIMESTAMP,

        BLEDY_NFZ          DUZY_OPIS, /* 4-znakowe kody bledow rozdzielone srednikami */
        SPRAWDZONO_NFZ     TIMESTAMP,  /* Czy obsluzono pole BLEDY_NFZ : null - nie byo, data do porwnania ze ZMIENIANO */

        TEST_CWU       VARCHAR(5),  /* Centr.Wyk.Ubezp 11 - Ok, 10 - nieubezpieczony, 0 - brak w wykazie */
        DATA_CWU       TIMESTAMP,
        UPR_REC        VARCHAR(5),  /* Z CWU */

        W_AP_KOLCE     TAKNIE,
        DATA_AP_KOLCE  TIMESTAMP,
        ID_AP_KOLCE    VARCHAR(20),

        W_AP_DILO     TAKNIE,       /* nie uywane */
        DATA_AP_DILO  TIMESTAMP,
        ID_AP_DILO    VARCHAR(20),

        STUDENT       TAKNIE,

        IHASLO         VARCHAR(20),

        UPOWAZNIENIE_INFO    UWAGI,
        UPOWAZNIENIE_ODBIOR  UWAGI,

        POCHODZENIEDANYCH VARCHAR(100),
        ZGODA_OSOBOWE     TYP,
        DATA_OSOBOWE      TIMESTAMP,
        ZGODA_MARKETING   TYP,
        DATA_MARKETING    TIMESTAMP,

        DANE           PARAMETRY,
        UWAGI          UWAGI,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(LEKARZ) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY (POLOZNA) REFERENCES OSOBY (KLUCZ),
        FOREIGN KEY(PIELEGNIARKA) REFERENCES OSOBY(KLUCZ));

CREATE        INDEX PACJENCI_XTELEKLUCZ    ON PACJENCI(TELEKLUCZ);
CREATE        INDEX PACJENCI_XNUMER        ON PACJENCI(NUMER);
CREATE        INDEX PACJENCI_XNRUBEZPIECZ  ON PACJENCI(NRUBEZPIECZ);
CREATE        INDEX PACJENCI_XUBEZPIECZYCIEL ON PACJENCI(UBEZPIECZYCIEL);
CREATE        INDEX PACJENCI_XNAZWISKOIMIE ON PACJENCI(NAZWISKO /* , IMIE */);
CREATE        INDEX PACJENCI_XPESEL        ON PACJENCI(PESEL);
CREATE        INDEX PACJENCI_XDOWOD        ON PACJENCI(TYPDOWODU, DOWOD);

/* Wycofane

CREATE        INDEX PACJENCI_XZOZ          ON PACJENCI(ZOZ, ZAPISDOZOZ);
CREATE        INDEX PACJENCI_XSTARYZOZ     ON PACJENCI(STARYZOZ, ZAPISDOZOZ);
CREATE        INDEX PACJENCI_XZOZNAZWIMIE  ON PACJENCI(ZOZ, NAZWISKO, IMIE);
CREATE        INDEX PACJENCI_XLEKNAZWIMIE  ON PACJENCI(LEKARZ, NAZWISKO, IMIE);
*/

CREATE TABLE UPRAWNIENIA_DODATKOWE(
  KLUCZ             KLUCZ NOT NULL,
  PACJENT           KLUCZ NOT NULL, 
  UPRAWNIENIE_PO    VARCHAR(8) NOT NULL, 
  DOK_PO_NAZWA      MALA_NAZWA,
  DOK_PO_NUMER      MALA_NAZWA,
  DOK_PO_DATA_WYST  TIMESTAMP,
  DOK_PO_DATA_DO    TIMESTAMP,
  DOK_PO_NPWZ       VARCHAR(15),

  UTWORZYL       KLUCZ,
  ZMIENIAL       KLUCZ,
  UTWORZONO      TIMESTAMP,
  ZMIENIANO      TIMESTAMP,
  
  PRIMARY KEY(KLUCZ),
  FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ));

COMMIT WORK;


CREATE TABLE ODPOWIEDZI_EWUS
       (PACJENT      KLUCZ NOT NULL,
        DATA_CWU     TIMESTAMP NOT NULL,
        TEST_CWU     VARCHAR(5),         /* 11 - potwierdzone ub, 10 - brak ub., 0 - brak w wykazie, -1 - Pesel nieaktualny,
                                            OSW - oswiadczenie wlasne, OSO - oswiadczenie opiekuna */
        NR_OSW       INTEGER,            /* z generatora pobytow - dla oswiadczen bezposrednio (numer oswiadczenia),
                                            dla eWus szpitala z uprawnienia.klucz, eWus pozostaly - null  */                        
        DOK_UBEZP_OSW_PDST    TYP,
        DOK_UBEZP_TYTUL_UBEZP IDENT,    
        DANE         PARAMETRY,
        PRIMARY KEY(PACJENT, DATA_CWU));




CREATE TABLE AP_KOLCE
       (PACJENT      KLUCZ NOT NULL,
        DATA         TIMESTAMP NOT NULL,
        ZLECENIE     KLUCZ,
        TYP          TYP,                /* Standardowa, Onkologiczna */
        DZIALANIE    VARCHAR(10),        /* Kod kolejek centranych */
        RODZAJ       INTEGER,            /* 1 - do kolejki, 2 - zmiana terminu, 3 - wykonanie, 4 - rezygnacja */
        POPRAWNE     TAKNIE,             /* przy bledzie ! */
        WYSYLKA      PARAMETRY,
        ODPOWIEDZ    PARAMETRY,
        PRIMARY KEY(PACJENT, DATA));


CREATE TABLE DEFINICJE_KART_PACJENTA
       (KLUCZ        KLUCZ NOT NULL,  /* z generatora ogolnego */
        NAZWA        DUZA_NAZWA,
        ZESTAW       NUMER,           /* opis danych karty */
        ZESTAW_REJ   NUMER,           /* opis danych karty - dla rejestracji*/
        TYP          TYP,             /* Przychodnia, Szpital - zawsze P, wspolnie dla szpitala i przychodni */
        WREJESTRACJI TAKNIE,
        UWAGI        PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE TABLE SKL_DEFINICJI_KARTYPAC       /* dla szcepien role te pelni HARMONOGRAM_SZCZEPIEN */
       (DEFINICJA    KLUCZ NOT NULL,
        LP           INTEGER NOT NULL,
        NAZWA        DUZA_NAZWA,
        TYP          VARCHAR(2) NOT NULL, /* DB - w gabinecie, DG - diagnostyka, DL - laboratorium, DA - zabieg, DS - szpital, DI - inne */
        ROK          INTEGER,
        MIESIAC      INTEGER,
        DZIEN        INTEGER,
        GABINET      KLUCZ,
        TYPWIZYTY    VARCHAR(5),
        PROCEDURA    KLUCZ,
        LABORATORIUM PARAMETRY,
        AKTYWNE      TAKNIE,
        UWAGI        PARAMETRY,
        PRIMARY KEY(DEFINICJA, LP));



CREATE TABLE KARTA_PACJENTA
       (KLUCZ        KLUCZ NOT NULL,  /* z generatora dla pacjentw */
        PACJENT      KLUCZ NOT NULL,
        DEFINICJA    KLUCZ,

        TYP          TYP,             /* S - szczepienia, D - definiowalne */
        DATA_OD      TIMESTAMP,
        DATA_DO      TIMESTAMP,
        ZAKONCZONE   TAKNIE,

        DANE         PARAMETRY,
        UWAGI        PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ));

CREATE  INDEX KARTA_PACJENTA_XDEFINICJA    ON KARTA_PACJENTA(DEFINICJA);

CREATE TABLE SKLADNIKI_KARTYPAC
       (KARTA        KLUCZ NOT NULL,
        TYP          VARCHAR(2) NOT NULL, /* SH - szczepienia, harmonogram i wykonanie, D. - definiowalne, R. - recznie wprowadzone */
        DOTYCZY      KLUCZ NOT NULL,      /* SH - zlecenie typ E, w pozostaych przypadkach z generatora dla zlece DAJ_ZLECENIE */
        DEFINICJA    KLUCZ,
        LP           INTEGER,
        DATA         TIMESTAMP,
        NAZWA        DUZA_NAZWA,
        GABINET      KLUCZ,
        PROCEDURA    KLUCZ,
        LABORATORIUM PARAMETRY,
        ZLECENIE     KLUCZ,
        WYKONANIE    KLUCZ,               /* dla laboratorium pobyt, Id_NFZ dla RuchPrzychodni, dla szpitala DaneRuchuSzpitalnego.Klucz */
        UWAGI        PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KARTA, TYP, DOTYCZY));

CREATE INDEX SKLADNIKI_KARTYPAC_XDEF     ON SKLADNIKI_KARTYPAC(DEFINICJA, LP);
CREATE INDEX SKLADNIKI_KARTYPAC_XZLEC    ON SKLADNIKI_KARTYPAC(ZLECENIE);

CREATE TABLE HARMONOGRAM_SZCZEPIEN        /* Pelni role definicji dla szczepien - dokladniej skladniki definicji */
       (KLUCZ        KLUCZ NOT NULL,      /* z generatora dla zlecen */
        TYP          TYP NOT NULL,        /* Dziecko */
        PROCEDURA    KLUCZ NOT NULL,
        AKTYWNE      TAKNIE,

        ROK          INTEGER,
        MIESIAC      INTEGER,
        DZIEN        INTEGER,
        UWAGI        PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ),
        PRIMARY KEY(KLUCZ));

CREATE TABLE WYDANIE_DOKUMENTACJI
        (PACJENT     KLUCZ NOT NULL,
		 LP          INTEGER NOT NULL,
		 DATA        TIMESTAMP NOT NULL,
		 SPOSOB      TYP,
		 OKRES_OD    TIMESTAMP,
		 OKRES_DO    TIMESTAMP,
		 ZAKRES      PARAMETRY,
		 KOMU        PARAMETRY,
         KTO 		 PARAMETRY,
		 ZWROT_ORYG  TIMESTAMP,
		 PODSTAWA    VARCHAR(50),
		 DARMOWE     TAKNIE,

		 UTWORZYL     KLUCZ,
         ZMIENIAL     KLUCZ,
         UTWORZONO    TIMESTAMP,
         ZMIENIANO    TIMESTAMP,

         PRIMARY KEY(PACJENT, LP));
		 
CREATE INDEX WYDDOK_XDATA ON WYDANIE_DOKUMENTACJI(DATA);		 
        
/* --- */

CREATE TABLE WYROBY_MEDYCZNE
       (KLUCZ           KLUCZ NOT NULL,  /* GET_UNIQUE_KEY_GEN */
        WERSJA          KLUCZ NOT NULL,
        PACJENT         KLUCZ NOT NULL,
        POBYT           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        WIZYTA          INTEGER,  /* Roszerzenie pobytu w gabinecie, oddziale */
        DATA_WYST       TIMESTAMP,
		STATUS          TYP,      /* biezacy : '-' do wysania, oraz wedug NFZ */   
        ANULOWANO       TAKNIE,   /* A przy anulowaniu */
        DATA_ANUL       TIMESTAMP,
		TRYB_ANUL       TYP,      /* Kompletne, Czciowe */
		PRZYCZ_ANUL     PARAMETRY,
		ROK_ANUL        INTEGER,
        MIES_ANUL       INTEGER,
        LB_MIES_ANUL    INTEGER,	

        WYSLANY         TAKNIE,
        PRZYJETY        TAKNIE,
		STATUSDOK       TYP,      /* ostatnie pobranie statusu */
        ANULOWANY       TAKNIE,   /* W NFZ */
        POBRANYDOK      TAKNIE, 		
		
        ID_UPRAW        KLUCZ,    /* Dla dodatkowych ubezpiecze - tabela UPRAWNIENIA */
		
		INSTALACJA_NFZ  KLUCZ,
        UMOWA_NFZ       KLUCZ,    /* Domylnie proponowana przez program gdy jedna */
		
		NR_ZLEC_NFZ     VARCHAR(20),
		ID_DOK_NFZ      VARCHAR(50),
		
		KOBIETA_W_CIAZY TAKNIE,
		RODZAJ          TYP,      /* Okulary, Wyrb medyczny */
		O_ODL_ZRENIC    INTEGER,
		OL1_RODZAJ      TYP,
		OL1_SFERA       WARTOSC,
		OL1_CYLINDER    WARTOSC,
		OL1_OS          INTEGER,
		OL1_PRYZMA      WARTOSC,
		OP1_RODZAJ      TYP,
		OP1_SFERA       WARTOSC,
		OP1_CYLINDER    WARTOSC,
		OP1_OS          INTEGER,
		OP1_PRYZMA      WARTOSC,
		OL2_RODZAJ      TYP,
		OL2_SFERA       WARTOSC,
		OL2_CYLINDER    WARTOSC,
		OL2_OS          INTEGER,
		OL2_PRYZMA      WARTOSC,
		OP2_RODZAJ      TYP,
		OP2_SFERA       WARTOSC,
		OP2_CYLINDER    WARTOSC,
		OP2_OS          INTEGER,
		OP2_PRYZMA      WARTOSC,
		W_KOD_MZ        VARCHAR(20),
		W_KOD_PRZEDM    VARCHAR(20),
		W_NAZWA_PRZEDM  VARCHAR(250),
		W_LEWOSTRONNE   TAKNIE,
		W_PRAWOSTRONNE  TAKNIE,
		W_STOMIA_RODZAJ TYP,
		W_STOMIA_LICZBA INTEGER,
		W_RODZAJ        TYP,    /* Miesieczne, Pozostae */
		W_ORDYNACJA     TYP,    /* Pierwotne (lub puste), Kontynuacja */
		W_LB_NA_MIES    INTEGER,
		W_OKRES         VARCHAR(7),
		W_OKRES_ROK     INTEGER,
		W_OKRES_MIES    INTEGER,
		W_OKRES_DLUG    INTEGER,
		W_LB_SZTUK      INTEGER,
		W_ICD10         VARCHAR(8),
		W_KRYTERIUM     PARAMETRY,  /* wykaz kod=nazwa */
		
		UZASAD_SKROC    UWAGI,
		DOD_INFORMACJE  UWAGI,

        PDFZIPWER       BLOB SUB_TYPE 0 SEGMENT SIZE 512,   /* dokument weryfikacji */
        PDFZIP          BLOB SUB_TYPE 0 SEGMENT SIZE 512,   /* dokument zlecenia */

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ, WERSJA),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

		
CREATE TABLE WYROBY_MEDYCZNE_KOM
       (KLUCZ           KLUCZ NOT NULL,
        WERSJA          KLUCZ NOT NULL,
        LP              KLUCZ NOT NULL,
        DATA_GEN        TIMESTAMP,
		
		OPERACJA        VARCHAR(15),
		ANULOWANIE      TAKNIE,
		
		REQUEST         XML2,
		RESPONSE        XML2, 
		
		STATUS          TYP,      /* '-' do wysania, oraz wedug NFZ - jak w WYROBY_MEDYCZNE */   
		POPRAWNOSC_KOM  TAKNIE, 
		POPRAWNOSC_DOK  TAKNIE,
		BLEDY           PARAMETRY, 
		

        PRIMARY KEY(KLUCZ, WERSJA, LP));


CREATE TABLE WYR_MED_KRYTERIA
       (KOD             INTEGER NOT NULL,
        NAZWA           VARCHAR(1000),

        PRIMARY KEY(KOD));
		
CREATE TABLE WYR_MED_SLOWNIK
       (KOD_PRZEDM      VARCHAR(16) NOT NULL,
        KOD_MZ          VARCHAR(16),
        NAZWA           VARCHAR(250),
        KRYTERIA        VARCHAR(250),

        PRIMARY KEY(KOD_PRZEDM));
		
		

/* --- */		
		
SET TERM ^ ;
CREATE GENERATOR PACJENCI_GEN^

CREATE TRIGGER CREATE_PACJENCI FOR PACJENCI
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(PACJENCI_GEN, 1);
END ^

CREATE PROCEDURE DAJ_PACJENTA
RETURNS (PACJENT INTEGER)
AS BEGIN
  PACJENT = GEN_ID(PACJENCI_GEN,1);
END ^

CREATE PROCEDURE SZUKAJ_PACJENTA(
  PESEL      VARCHAR(11),
  TYPDOWODU  VARCHAR(1),
  DOWOD      VARCHAR(20),
  NUMER      VARCHAR(10),
  UTWORZ     VARCHAR(1))
RETURNS (PACJENT INTEGER)
AS
DECLARE VARIABLE VPAC INTEGER;
BEGIN
  VPAC = 0;

  IF (:PESEL <> '')
  THEN
    SELECT KLUCZ FROM PACJENCI
    WHERE PESEL = :PESEL
    INTO :VPAC;

  IF ((:VPAC = 0 OR :VPAC IS NULL) AND :TYPDOWODU <> '' AND :DOWOD <> '')
  THEN
    SELECT KLUCZ FROM PACJENCI
    WHERE TYPDOWODU = :TYPDOWODU AND DOWOD = :DOWOD
    INTO :VPAC;

  IF ((:VPAC = 0 OR :VPAC IS NULL) AND :NUMER <> '')
  THEN
    SELECT KLUCZ FROM PACJENCI
    WHERE NUMER = :NUMER
    INTO :VPAC;

  IF ((:VPAC = 0 OR :VPAC IS NULL) AND :UTWORZ = 'T')
  THEN BEGIN
    VPAC = GEN_ID(PACJENCI_GEN,1);
    INSERT INTO PACJENCI(KLUCZ) VALUES(:VPAC);
  END

  PACJENT = :VPAC;
  SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^

/* wykaz czonkw rodziny */

CREATE TABLE RODZINA
       (PACJENT       KLUCZ NOT NULL,
        KREWNY        KLUCZ NOT NULL,
        POKREWIENSTWO TYP NOT NULL,
        UTWORZYL       KLUCZ,
        UTWORZONO      TIMESTAMP);

CREATE UNIQUE INDEX RODZINA_INDEX1    ON RODZINA(PACJENT, KREWNY);

/* wykaz zmian dla pacjentw */

CREATE TABLE PACSLAD      /* nieuzywane */
       (PACJENT      KLUCZ NOT NULL,
        TYP          TYP,
        CZAS         TIMESTAMP,
        CZASKCH      TIMESTAMP,
        STARE        PARAMETRY,
        NOWE         PARAMETRY,

        LEKARZ             KLUCZ,
        LEKARZ_WYBOR       TYP,
        LEKARZ_DATA        TIMESTAMP,
        STARYLEKARZ        KLUCZ,
        STARYLEKARZ_WYBOR  TYP,
        STARYLEKARZ_DATA   TIMESTAMP,

        PIELEGNIARKA            KLUCZ,
        PIELEGNIARKA_WYBOR      TYP,
        PIELEGNIARKA_DATA       TIMESTAMP,
        STARAPIELEGNIARKA       KLUCZ,
        STARAPIELEGNIARKA_WYBOR TYP,
        STARAPIELEGNIARKA_DATA  TIMESTAMP,

        POLOZNA            KLUCZ,
        POLOZNA_WYBOR      TYP,
        POLOZNA_DATA       TIMESTAMP,
        STARAPOLOZNA       KLUCZ,
        STARAPOLOZNA_WYBOR TYP,
        STARAPOLOZNA_DATA  TIMESTAMP,

        STARY_NR_DEKL_LEK  KLUCZ,
        STARY_NR_DEKL_PIEL KLUCZ,
        STARY_NR_DEKL_POL  KLUCZ,

        NR_DEKL_LEK  KLUCZ,
        NR_DEKL_PIEL KLUCZ,
        NR_DEKL_POL  KLUCZ,

        ZALICZONO_LEK  TAKNIE, /* T-zaliczono, N-nie zaliczono, B-niezweryfikowana */
        ZALICZONO_PIEL TAKNIE,
        ZALICZONO_POL  TAKNIE,

        STARE_ZALICZONO_LEK  TAKNIE,
        STARE_ZALICZONO_PIEL TAKNIE,
        STARE_ZALICZONO_POL  TAKNIE,

        UTWORZYL     KLUCZ,
        UTWORZONO    TIMESTAMP);

CREATE UNIQUE INDEX PACSLAD_INDEX1    ON PACSLAD(PACJENT, CZAS, UTWORZONO);

/* Procedury NFZ dla pacjentw */

SET TERM ^ ;
CREATE PROCEDURE LEKARZDLAPACJENTA(
  PACJENT  INTEGER,
  DATA     TIMESTAMP,
  WSKAZNIK VARCHAR(1))   /* czy pod uwag maj by brane tylko poprawnie zweryfikowane deklaracje (= 'T'), */
                         /* czy wszystkie aktywne w podanej dacie */
RETURNS (LEKARZ INTEGER)
AS
DECLARE VARIABLE VLEKARZ       INTEGER;
DECLARE VARIABLE VZALICZONO    VARCHAR(1);
DECLARE VARIABLE VDATA         TIMESTAMP;
BEGIN
 LEKARZ = 0;

 /* Najpierw sprawdzamy w danych pacjenta. Jeli daty si nie zgadzaj, lub deklaracja nie jest */
 /* zweryfikowana(przy WSKAZNIK = 'T') - pobieramy dane ze ladu */
 SELECT LEKARZ, ZALICZONO_LEK, DATA_LEK FROM PACJENCI
 WHERE KLUCZ = :PACJENT
 INTO :VLEKARZ, :VZALICZONO, :VDATA;

 IF ((:VLEKARZ > 0) AND (:VDATA <= :DATA) AND 
     (((:VZALICZONO = 'T') AND (:WSKAZNIK = 'T')) OR NOT (:WSKAZNIK = 'T')))
 THEN LEKARZ = :VLEKARZ;

 ELSE BEGIN
  IF (:WSKAZNIK = 'T')
  /* Pobieramy ze ladu ostatni zweryfikowan deklaracj z danym opiekunem */
  THEN SELECT DISTINCT S.STARYLEKARZ, 'T', S.STARYLEKARZ_DATA FROM PACSLAD S
  WHERE S.PACJENT = :PACJENT AND S.STARYLEKARZ > 0 
    AND S.STARYLEKARZ_DATA = (SELECT MAX(X.STARYLEKARZ_DATA) FROM PACSLAD X 
        WHERE X.PACJENT = S.PACJENT AND X.STARE_ZALICZONO_LEK = 'T' AND X.STARYLEKARZ_DATA <= :DATA)
    AND S.STARY_NR_DEKL_LEK = (SELECT MAX(Y.STARY_NR_DEKL_LEK) FROM PACSLAD Y 
        WHERE Y.PACJENT = S.PACJENT AND Y.STARYLEKARZ_DATA = S.STARYLEKARZ_DATA 
        AND Y.STARYLEKARZ = S.STARYLEKARZ AND Y.STARE_ZALICZONO_LEK = 'T')
  INTO :VLEKARZ, :VZALICZONO, :VDATA;

  /* Pobieramy ostatni deklaracj dla podanego dnia - bez wzgldu na to, czy jest zweryfikowana */
  ELSE SELECT DISTINCT S.STARYLEKARZ, S.STARE_ZALICZONO_LEK, S.STARYLEKARZ_DATA FROM PACSLAD S
    WHERE S.PACJENT = :PACJENT AND S.STARYLEKARZ > 0 
      AND S.STARYLEKARZ_DATA = (SELECT MAX(X.STARYLEKARZ_DATA) FROM PACSLAD X 
          WHERE X.PACJENT = S.PACJENT AND X.STARYLEKARZ_DATA <= :DATA)
      AND S.STARY_NR_DEKL_LEK = (SELECT MAX(Y.STARY_NR_DEKL_LEK) FROM PACSLAD Y 
          WHERE Y.PACJENT = S.PACJENT AND Y.STARYLEKARZ_DATA = S.STARYLEKARZ_DATA 
          AND Y.STARYLEKARZ = S.STARYLEKARZ)
    INTO :VLEKARZ, :VZALICZONO, :VDATA;
  
    IF ((:VLEKARZ > 0) AND (:VDATA <= :DATA) AND 
        (((:VZALICZONO = 'T') AND (:WSKAZNIK = 'T')) OR NOT (:WSKAZNIK = 'T')))
    THEN LEKARZ = :VLEKARZ;
 END
 SUSPEND;

END ^

COMMIT WORK ^


CREATE PROCEDURE PIELEGNIARKADLAPACJENTA(
  PACJENT  INTEGER,
  DATA     TIMESTAMP,
  WSKAZNIK VARCHAR(1))
RETURNS (PIELEGNIARKA INTEGER)
AS
DECLARE VARIABLE VPIELEGNIARKA INTEGER;
DECLARE VARIABLE VZALICZONO    VARCHAR(1);
DECLARE VARIABLE VDATA         TIMESTAMP;
BEGIN
 PIELEGNIARKA = 0;

 SELECT PIELEGNIARKA, ZALICZONO_PIEL, DATA_PIEL FROM PACJENCI
 WHERE KLUCZ = :PACJENT
 INTO :VPIELEGNIARKA, :VZALICZONO, :VDATA;

 IF ((:VPIELEGNIARKA > 0) AND (:VDATA <= :DATA) AND 
     (((:VZALICZONO = 'T') AND (:WSKAZNIK = 'T')) OR NOT (:WSKAZNIK = 'T')))
 THEN PIELEGNIARKA = :VPIELEGNIARKA;

 ELSE BEGIN
  IF (:WSKAZNIK = 'T')
  THEN SELECT DISTINCT S.STARAPIELEGNIARKA, 'T', S.STARAPIELEGNIARKA_DATA FROM PACSLAD S
  WHERE S.PACJENT = :PACJENT AND S.STARAPIELEGNIARKA > 0 
    AND S.STARAPIELEGNIARKA_DATA = (SELECT MAX(X.STARAPIELEGNIARKA_DATA) FROM PACSLAD X 
        WHERE X.PACJENT = S.PACJENT AND X.STARE_ZALICZONO_PIEL = 'T' AND X.STARAPIELEGNIARKA_DATA <= :DATA)
    AND S.STARY_NR_DEKL_PIEL = (SELECT MAX(Y.STARY_NR_DEKL_PIEL) FROM PACSLAD Y 
        WHERE Y.PACJENT = S.PACJENT AND Y.STARAPIELEGNIARKA_DATA = S.STARAPIELEGNIARKA_DATA 
        AND Y.STARAPIELEGNIARKA = S.STARAPIELEGNIARKA AND Y.STARE_ZALICZONO_PIEL = 'T')
  INTO :VPIELEGNIARKA, :VZALICZONO, :VDATA;

  ELSE SELECT DISTINCT S.STARAPIELEGNIARKA, S.STARE_ZALICZONO_PIEL, S.STARAPIELEGNIARKA_DATA FROM PACSLAD S
  WHERE S.PACJENT = :PACJENT AND S.STARAPIELEGNIARKA > 0
    AND S.STARAPIELEGNIARKA_DATA = (SELECT MAX(X.STARAPIELEGNIARKA_DATA) FROM PACSLAD X 
        WHERE X.PACJENT = S.PACJENT AND X.STARAPIELEGNIARKA_DATA <= :DATA)
    AND S.STARY_NR_DEKL_PIEL = (SELECT MAX(Y.STARY_NR_DEKL_PIEL) FROM PACSLAD Y 
        WHERE Y.PACJENT = S.PACJENT AND Y.STARAPIELEGNIARKA_DATA = S.STARAPIELEGNIARKA_DATA 
        AND Y.STARAPIELEGNIARKA = S.STARAPIELEGNIARKA)
  INTO :VPIELEGNIARKA, :VZALICZONO, :VDATA;

  IF ((:VPIELEGNIARKA > 0) AND (:VDATA <= :DATA) AND 
      (((:VZALICZONO = 'T') AND (:WSKAZNIK = 'T')) OR NOT (:WSKAZNIK = 'T')))
  THEN PIELEGNIARKA = :VPIELEGNIARKA;

 END
 SUSPEND;

END ^

COMMIT WORK ^


CREATE PROCEDURE POLOZNADLAPACJENTA(
  PACJENT  INTEGER,
  DATA     TIMESTAMP,
  WSKAZNIK VARCHAR(1))
RETURNS (POLOZNA INTEGER)
AS
DECLARE VARIABLE VPOLOZNA   INTEGER;
DECLARE VARIABLE VZALICZONO VARCHAR(1);
DECLARE VARIABLE VDATA      TIMESTAMP;
BEGIN
 POLOZNA = 0;

 SELECT POLOZNA, ZALICZONO_POL, DATA_POL FROM PACJENCI
 WHERE KLUCZ = :PACJENT
 INTO :VPOLOZNA, :VZALICZONO, :VDATA;

 IF ((:VPOLOZNA > 0) AND (:VDATA <= :DATA) AND 
     (((:VZALICZONO = 'T') AND (:WSKAZNIK = 'T')) OR NOT (:WSKAZNIK = 'T')))
 THEN POLOZNA = :VPOLOZNA;

 ELSE BEGIN
  IF (:WSKAZNIK = 'T')
  THEN SELECT DISTINCT S.STARAPOLOZNA, 'T', S.STARAPOLOZNA_DATA FROM PACSLAD S
  WHERE S.PACJENT = :PACJENT AND S.STARAPOLOZNA > 0
    AND S.STARAPOLOZNA_DATA = (SELECT MAX(X.STARAPOLOZNA_DATA) FROM PACSLAD X 
        WHERE X.PACJENT = S.PACJENT AND X.STARE_ZALICZONO_POL = 'T' AND X.STARAPOLOZNA_DATA <= :DATA)
    AND S.STARY_NR_DEKL_POL = (SELECT MAX(Y.STARY_NR_DEKL_POL) FROM PACSLAD Y 
        WHERE Y.PACJENT = S.PACJENT AND Y.STARAPOLOZNA_DATA = S.STARAPOLOZNA_DATA 
        AND Y.STARAPOLOZNA = S.STARAPOLOZNA AND Y.STARE_ZALICZONO_POL = 'T')
  INTO :VPOLOZNA, :VZALICZONO, :VDATA;

  ELSE SELECT DISTINCT S.STARAPOLOZNA, S.STARE_ZALICZONO_POL, S.STARAPOLOZNA_DATA FROM PACSLAD S
  WHERE S.PACJENT = :PACJENT AND S.STARAPOLOZNA > 0
    AND S.STARAPOLOZNA_DATA = (SELECT MAX(X.STARAPOLOZNA_DATA) FROM PACSLAD X 
        WHERE X.PACJENT = S.PACJENT AND X.STARAPOLOZNA_DATA <= :DATA)
    AND S.STARY_NR_DEKL_POL = (SELECT MAX(Y.STARY_NR_DEKL_POL) FROM PACSLAD Y 
        WHERE Y.PACJENT = S.PACJENT AND Y.STARAPOLOZNA_DATA = S.STARAPOLOZNA_DATA 
        AND Y.STARAPOLOZNA = S.STARAPOLOZNA)
  INTO :VPOLOZNA, :VZALICZONO, :VDATA;

  IF ((:VPOLOZNA > 0) AND (:VDATA <= :DATA) AND 
      (((:VZALICZONO = 'T') AND (:WSKAZNIK = 'T')) OR NOT (:WSKAZNIK = 'T')))
  THEN POLOZNA = :VPOLOZNA;

 END
 SUSPEND;

END ^

COMMIT WORK ^

CREATE PROCEDURE NALEZYDOZOZ(
  PACJENT INTEGER,
  ZOZ     INTEGER,
  DATA    TIMESTAMP,
  WSKAZNIK VARCHAR(1))
RETURNS (NALEZY VARCHAR(1))
AS
DECLARE VARIABLE VZOZ      INTEGER;
DECLARE VARIABLE VSTARYZOZ INTEGER;
DECLARE VARIABLE VZAPIS    TIMESTAMP;
DECLARE VARIABLE VOPIEKUN  INTEGER;
BEGIN
 NALEZY = 'N';
 VOPIEKUN = 0;
 SELECT LEKARZ FROM LEKARZDLAPACJENTA(:PACJENT, :DATA, :WSKAZNIK)
 INTO :VOPIEKUN;

 IF (:VOPIEKUN > 0)
 THEN NALEZY = 'T';
 ELSE BEGIN
  SELECT PIELEGNIARKA FROM PIELEGNIARKADLAPACJENTA(:PACJENT, :DATA, :WSKAZNIK)
  INTO :VOPIEKUN;

  IF (:VOPIEKUN > 0)
  THEN NALEZY = 'T';
  ELSE BEGIN
   SELECT POLOZNA FROM POLOZNADLAPACJENTA(:PACJENT, :DATA, :WSKAZNIK)
   INTO :VOPIEKUN;

   IF (:VOPIEKUN > 0)
   THEN NALEZY = 'T';
  END
 END
 
 SUSPEND;
END ^

SET TERM ; ^

COMMIT WORK;


/* ........................................................................ */

/* Firmy - w tym Jednostki Suby Zdrowia */

CREATE TABLE FIRMY
       (KLUCZ          KLUCZ NOT NULL,
        CENTRALA       KLUCZ,
        PORTAL         KLUCZ,
        GRUPA          TYP,             /* Z - Suba Zdrowia */
        AKTYWNA        TAKNIE,

        NAZWA          OPIS,
        NAZWA1         OPIS,
        NAZWA2         OPIS,
        NAZWA3         OPIS,

        SKROT          SYMBOL,          /* Skrt dla KCh */
        IDENT          SYMBOL,          /* Kod ministerialny ?? to nie jest tak traktowane */

        VAT            TYP,             /* Patnik VAT */
        NIP            NIP,
        UE_KRAJ        VARCHAR(2),
        UE_NIP         NIP,
        NIPBEZKRESEK   VARCHAR(10),
        REGON          REGON,
        KOD_US         DIDENT,

        REGON14        VARCHAR(14),
        ZSMOPL_PODMIOT VARCHAR(3),
        ZSMOPL_RODZAJ  VARCHAR(5),
        ZSMOPL_ID      VARCHAR(20),

        KOD_SWIADCZ    MALA_NAZWA, /* Identyfikator firmy dla pakietu wiadczeniodawcy */

        TYP_SWD              IDENT,  /* PL:podmiot leczniczy, PR:praktyka zawodowa, OF:osoba fizyczna inna ni PL,PR */
        KSIEGA_REJESTROWA    SYMBOL, /* I czesc kodu MZ - nr ksigi rejestrowej rejestru podmiotw wykonujcych dziaalno lecznicz. */
        P1_OID         VARCHAR(50),   
        IZBA_LEKARSKA  VARCHAR(50),   

        ADRKODKRAJU    VARCHAR(2),
        ADRKRAJ        KRAJ,
        ADRWOJEWODZTWO MIEJSCOWOSC,
        ADRGMINA       ULICA,
        ADRPOWIAT      MIEJSCOWOSC,
        ADRPOCZTA      MIEJSCOWOSC,
        ADRKODTERYT    KOD_TERYT,
        ADRMIEJSCOWOSC MIEJSCOWOSC,
        ADRKODPOCZTOWY KOD_POCZTOWY,
        ADRULICA       ULICA,
        ADRDOM         DOM,
        ADRLOKAL       LOKAL,
        ADRTELEFON     OPIS,
        ADRSKRYTKA     DUZY_SYMBOL,

        KORKRAJ         KRAJ,
        KORWOJEWODZTWO  MIEJSCOWOSC,
        KORPOWIAT       MIEJSCOWOSC,
        KORGMINA        ULICA,
        KORMIEJSCOWOSC  MIEJSCOWOSC,
        KORKODPOCZTOWY  KOD_POCZTOWY,
        KORKODTERYT     KOD_TERYT,
        KORULICA        ULICA,
        KORDOM          DOM,
        KORLOKAL        LOKAL,
        KORPOCZTA       MIEJSCOWOSC,
        KORTELEFON      TEL_FAX,
        KORFAX          TEL_FAX,
        KORMAIL         DUZY_OPIS,
        KORSKRYTKA      DUZY_SYMBOL,

        BANK           BANK,
        KONTO          KONTO,
        NAZWAPRZ       VARCHAR(54) CHARACTER SET DOS852 COLLATE PDOX_PLK,
		SPLITPAYMENT   TAKNIE,

        KOD_RES_V      TYP,
        KOD_RES_VI     IDENT,
        KOD_FILII      NUMER,

        ODBIERAFRY     DUZA_NAZWA,

        IHASLO         VARCHAR(20),

        DANE           PARAMETRY,
        UWAGI          UWAGI,

        P1_CERT_P1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        P1_HASLO      VARCHAR(50),
        P1_TLS_NUMER  VARCHAR(30),
        P1_HASLO_TLS  VARCHAR(50),

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(KLUCZ));

/* CREATE        INDEX FIRMY_XGRNAZWA  ON FIRMY(GRUPA, NAZWA); USUNITY */
CREATE        INDEX FIRMY_XNAZWA    ON FIRMY(NAZWA);
CREATE        INDEX FIRMY_XNIP      ON FIRMY(NIP);
CREATE        INDEX FIRMY_XUE_NIP   ON FIRMY(UE_NIP);
CREATE        INDEX FIRMY_XNIPBEZKRESEK      ON FIRMY(NIPBEZKRESEK);
CREATE        INDEX FIRMY_XREGON    ON FIRMY(REGON);
CREATE        INDEX FIRMY_XIDENT    ON FIRMY(IDENT);
CREATE        INDEX FIRMY_XKONTO    ON FIRMY(KONTO);

ALTER TABLE PROCEDURYZAKLADU
ADD FOREIGN KEY(WYK_FIRMA)  REFERENCES FIRMY(KLUCZ);

SET TERM ^ ;
CREATE GENERATOR FIRMY_GEN^

CREATE TRIGGER CREATE_FIRMA FOR FIRMY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(FIRMY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_FIRME
RETURNS (FIRMA INTEGER)
AS BEGIN
  FIRMA = GEN_ID(FIRMY_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

/* testy VAT */

CREATE TABLE TESTY_VAT
       (FIRMA          KLUCZ NOT NULL,
        KIEDY          TIMESTAMP,
        STAN_NA        TIMESTAMP,
        ODPOWIEDZ      VARCHAR(200),
		TYP            TYP,          /* NULL - sprawdzanie statusu VAT, K - pobranie kont, S - sprawdzenie konta */ 
        ID             VARCHAR(30),  /* requestId sprawdzenia kont */
        DANE           PARAMETRY,    /* odpowiedz sprawdzenia kont (JSON) */ 		
		
        PRIMARY KEY(FIRMA, KIEDY));


/* Oddziay firm */

CREATE TABLE ODDZIALY
       (CENTRALA       KLUCZ NOT NULL,
        ODDZIAL        KLUCZ NOT NULL,
        UTWORZYL       KLUCZ,
        UTWORZONO      TIMESTAMP);

CREATE UNIQUE INDEX ODDZIALY_INDEX1    ON ODDZIALY(CENTRALA, ODDZIAL);

/* Zaklady firm */

CREATE TABLE ZAKLADY_FIRM
       (FIRMA          KLUCZ NOT NULL,
        NAZWA          VARCHAR(40),
        KOD_VII        VARCHAR(15) NOT NULL,
        KOD_VIII       VARCHAR(15) NOT NULL,
        UTWORZYL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIAL       KLUCZ,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(FIRMA, KOD_VII, KOD_VIII));


/* Podmioty finansowe */

CREATE TABLE PODMIOTY_FINANSOWE
       (FIRMA          KLUCZ NOT NULL,
        ROK            INTEGER,
        MIESIAC        INTEGER,
        ZMIENNE        PARAMETRY,
        WYKAZYDANYCH   PARAMETRY,
        ROCZNE         PARAMETRY,

        UTWORZYL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ));

/* Szkoy deklaracji POZ */


CREATE TABLE SZKOLY_POZ
       (KLUCZ          KLUCZ NOT NULL,
        AKTYWNA        TAKNIE,

        NAZWA          OPIS,
        REGON          VARCHAR(14),

        PLACOWKA       KLUCZ,

        SZKOLA_TYP         DIDENT,
        SZKOLA_TYP_PLAT    IDENT,
        SZKOLA_PROF_FLUOR  TAKNIE,

        ADRWOJEWODZTWO MIEJSCOWOSC,
        ADRGMINA       ULICA,
        ADRPOWIAT      MIEJSCOWOSC,
        ADRMIEJSCOWOSC MIEJSCOWOSC,
        ADRKODPOCZTOWY KOD_POCZTOWY,
        ADRULICA       ULICA,
        ADRDOM         DOM,
        ADRLOKAL       LOKAL,
        ADRTELEFON     OPIS,

        OSTATNIA_KLASA    INTEGER, 

        UWAGI          UWAGI,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        FOREIGN KEY(PLACOWKA) REFERENCES ZAKLADY(KLUCZ),
        PRIMARY KEY(KLUCZ));

/* ........................................................................ */

/* Pobyty - wizyty ambulatoryjne i pobyty w szpitalu */

CREATE TABLE POBYTY
       (KLUCZ        KLUCZ NOT NULL,
        PACJENT      KLUCZ NOT NULL,

        NR_ZESTAWU   MALA_NAZWA,
        GLOWNE_UPRAW INTEGER,
        INSTALACJA   NR_INSTALACJI,

        KLUCZPOZ     MALA_NAZWA,  /* Pakiet wiadczeniodawcy */
        NR_KOREKTY   INTEGER,

        MATKA        KLUCZ,
        NOWORODEK    INTEGER,

        PODSTAWA     TYP,
        SKR_ZAKLAD   KLUCZ,
        SKR_OSOBA    KLUCZ,
        SKR_FIRMA    KLUCZ,
        SKR_LEK_NI   OPIS,
        SKR_LEK_NR   SYMBOL,
        SKR_LEK_TP   IDENT,  /* Typ personelu osoby ze skierowania */
        SKR_KONTRAKT DUZA_NAZWA,
        SKR_JEDN     SYMBOL,
        SKR_JEDN_VIII  SYMBOL,
        SKR_RUM      VARCHAR(20),
        SKR_DATA     TIMESTAMP,
        SKR_NUMERZGL VARCHAR(25),

        SKR_KOD_RES_VI  IDENT,

        ICF_ROZP             PARAMETRY,  
        ICF_ZAK              PARAMETRY,  
        ZAKAZENIE            VARCHAR(6),
        SKR_ROOT             VARCHAR(60),   
        SKR_EXTENSION        VARCHAR(22),
		
        TYPWIZYTY    VARCHAR(5),   /* Dla przychodni i szpitala */
        PROGRAMMED   DIDENT,

        ONKOLOGIA_KARTA VARCHAR(20),
        ONKOLOGIA_ETAP  VARCHAR(1),
        DODATKOWE_KRYTERIUM    VARCHAR(100),

        CHOROBASKR   VARCHAR(6),

        CHOROBAZAS1  VARCHAR(6),
        CHOROBAZAS2  VARCHAR(6),
        CHOROBAZAS3  VARCHAR(6),

        CHOROBAWSP1  VARCHAR(6),
        CHOROBAWSP2  VARCHAR(6),
        CHOROBAWSP3  VARCHAR(6),

        ORPHANET         VARCHAR(12),
        OCENASPRAWNOSCI    TYP,

        PRZ_ODLEZYNY     TAKNIE,

        ZGL_DATA     TIMESTAMP,
        ZGL_TRYB     TYP,
        ZGL_PLAN     TAKNIE,
        ZGL_ZAKLAD   KLUCZ,
        ZGL_OSOBA    KLUCZ,
        ZGL_ROK      INTEGER,
        ZGL_NUMER    INTEGER,
        ZGL_NUMER_NFZ INTEGER,
        WYP_FIRMA    KLUCZ,

        ODM_DATA     TIMESTAMP,    /* Data odmowy */

        KODSWIADCZMZ NUMER,
        KODSWIADCZMZ3 NUMER,
        
        WYP_PLT        VARCHAR(3) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        WYP_PLT_FIRMA  KLUCZ,

        UWAGI        UWAGI,
        RODZAJ       TYP,
/*
                     I=Izba przyj
                     S=Pobyt w szpitalu
                     O=Oczekiwanie na pobyt w szpitalu
                     D=Odmowa przyjcia do szpitala
                     A=Pobyt ambulatoryjny
                     L=Pobyt w laboratorium
                     T=Internet - rezerwacja wizyty
                     Z=Znany Lekarz
					 P=Z systemu P1
*/
        KOSZT        WARTOSC,
        ANULOWANO    TAKNIE,

        UE_DOK_ID       MALA_NAZWA,
        UE_DOK_OSOBA_ST TYP,
        UE_DOK_ART      IDENT,

        PRZYJECIE_62 TAKNIE,            /* Przyjcie do szpitala na podstawie art.62*/
        SYGN_PISMA_ZGODY  DUZY_SYMBOL,

        UBEZP_PODSTAWA TYP,
        DECYZJA_NR     MALA_NAZWA, /* decyzja burmistrza itp. dla podstawy <> 1 */
        DECYZJA_OD     TIMESTAMP,
        DECYZJA_DO     TIMESTAMP,

        SKR_NUMER     MALA_NAZWA,
        SKR_RUM_DATA  TIMESTAMP,

        DOK_UBEZP_PANSTWO         IDENT,
        DOK_UBEZP_TYP_INSTYTUCJI  TYP,             /* N=NFZ, G=Gmina, I=inna, P=penopatny */
        DOK_UBEZP_ODDZIAL_NFZ     IDENT,           /* dla typ = N */
        DOK_UBEZP_GMINA           KOD_TERYT,       /* dla typ = G */
        DOK_UBEZP_GMINA_ORGAN     OPIS,
        DOK_UBEZP_FIRMA_KOD       NUMER,           /* dla typ = I*/
        DOK_UBEZP_FIRMA_AKRONIM   SYMBOL,
        DOK_UBEZP_FIRMA_CWU       DUZY_SYMBOL,

        DOK_UBEZP_TYP_DOKUM       TYP,             /* K=karta, D=decyzja wjta, U=dok. UE, Z-ekuz, C=certyfikat, P=powiadczenie, E=druk E*/
        DOK_UBEZP_RODZAJ_E        DIDENT,          /* rodzaj druku E */
        DOK_UBEZP_NUMER           DUZY_SYMBOL,
        DOK_UBEZP_DATA_WYST       TIMESTAMP,
        DOK_UBEZP_DATA_OD         TIMESTAMP,
        DOK_UBEZP_DATA_DO         TIMESTAMP,
        DOK_UBEZP_TYTUL_UBEZP     IDENT,   /* tytu uprawnienia */
        WSK_ZGODY_PELNOLETNI      IDENT,
        DOK_UBEZP_PODMIOT         DUZY_OPIS,
        DOK_UBEZP_NPWZ            NUMER,
        DOK_UBEZP_NAZWA           DUZY_OPIS, 

        DOK_UBEZP_NIP         NIP,      /* nieuzywane */
        DOK_UBEZP_MIESIAC     INTEGER,
        DOK_UBEZP_ROK         INTEGER,
        DOK_UBEZP_ZUS         DIDENT, /* ZUS, KRUS, MSWiA, MON,SP */
        DOK_UBEZP_ZGLOSZENIE  IDENT,  /* ZUA, ZZA, ZCNA */
        DOK_UBEZP_ID          MALA_NAZWA, /* nieuzywane */
        DOK_UBEZP_OSW_TYP     TYP,
        DOK_UBEZP_OSW_PDST    TYP,

        DOK_UBEZP_POCZATEK    TIMESTAMP,
        DOK_UBEZP_KONIEC      TIMESTAMP,

        REH_IL_MC              INTEGER,
        REH_DNI_OD_WYPISU      INTEGER,
        OCENA_BARTHEL          INTEGER,
        OCENA_ASIA             INTEGER,
        OCENA_GMFES            INTEGER,

        DZIECKO                TAKNIE,
        DYSFUNKCJA_RODZAJ_A    TAKNIE,
        DYSFUNKCJA_STOPIEN_A   INTEGER,
        DYSFUNKCJA_RODZAJ_B    TAKNIE,
        DYSFUNKCJA_STOPIEN_B   INTEGER,
        DYSFUNKCJA_RODZAJ_C    TAKNIE,
        DYSFUNKCJA_STOPIEN_C   INTEGER,
        DYSFUNKCJA_RODZAJ_D    TAKNIE,
        DYSFUNKCJA_STOPIEN_D   INTEGER,
        DYSFUNKCJA_RODZAJ_E    TAKNIE,
        DYSFUNKCJA_STOPIEN_E   INTEGER,
        DYSFUNKCJA_RODZAJ_F    TAKNIE,
        DYSFUNKCJA_STOPIEN_F   INTEGER,
        DYSFUNKCJA_RODZAJ_G    TAKNIE,
        DYSFUNKCJA_STOPIEN_G   INTEGER,
        DYSFUNKCJA_RODZAJ_H    TAKNIE,
        DYSFUNKCJA_STOPIEN_H   INTEGER,
        DYSFUNKCJA_RODZAJ_I    TAKNIE,
        DYSFUNKCJA_STOPIEN_I   INTEGER,
        DYSFUNKCJA_RODZAJ_J    TAKNIE,
        DYSFUNKCJA_STOPIEN_J   INTEGER,
        DYSFUNKCJA_RODZAJ_K    TAKNIE,
        DYSFUNKCJA_STOPIEN_K   INTEGER,

        OCENA_RANKIN       TYP,        /* zasadniczo cyfra - stopie niepenosprawnoci (0-5) */
        KWALIF_WEDLUG      TYP,        /* 1=wg procedury ICD-9, 2=wg choroby ICD-10 */
        KWALIF_PRZYCZYNA   VARCHAR(6),
        KWALIF_PROCEDURA   VARCHAR(8),

        REH_SKALA_NYHA  IDENT;

        DANE         PARAMETRY,

        W_ARCHIWUM_OD TIMESTAMP,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(MATKA) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(SKR_ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(SKR_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZGL_ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(ZGL_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(SKR_FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(WYP_FIRMA) REFERENCES FIRMY(KLUCZ));

CREATE INDEX POBYTY_XZGL_RODZRZN ON POBYTY(RODZAJ, ZGL_ROK, ZGL_ZAKLAD, ZGL_NUMER);
CREATE INDEX POBYTY_XZGL_DATA ON POBYTY(ZGL_DATA, ZGL_ZAKLAD);
CREATE INDEX POBYTY_XZGL_NFZ ON POBYTY(ZGL_ROK, ZGL_NUMER_NFZ);

SET TERM ^ ;
CREATE GENERATOR POBYTY_GEN^

CREATE TRIGGER CREATE_POBYTY FOR POBYTY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(POBYTY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_POBYT
RETURNS (POBYT INTEGER)
AS BEGIN
  POBYT = GEN_ID(POBYTY_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE ZLECENIA
       (KLUCZ          KLUCZ NOT NULL,
        KONTYNUACJA    KLUCZ,             /* dla zlece wielokrotnych - seria zabiegw, indywidualny klucz serii */
                                          /* dla zlece powstaych ze staego - klucz oryginalnego staego */
        PACJENT        KLUCZ,
        POBYT          KLUCZ,
        ZAKLAD         KLUCZ,    /* Zakad, w ktrym utworzono zlecenie, niekoniecznie zlecajcy */
        WIZYTA         INTEGER,  /* wizyta j.w. dla gabinetu lekarskiego */

        ROK            INTEGER,
        MIESIAC        INTEGER,
        NUMER          INTEGER,

        DATA           TIMESTAMP,
        RODZAJ         TYP,     /* J=Jednorazowe, S=Stale, Z=Zewnetrzne, K=Skierowanie */
        CO_DNI         INTEGER,

        TYP            TYP,      /*
                                    I=Na oddzia z Izby Przyj
                                    J=Do Izby przyj z gabinetu
                                    O=Przeniesienie na inny oddzia
                                    Z=Zakoczenie pobytu w szpitalu
                                    C=Oczekiwanie na przyjcie do szpitala / operacj
                                    B=Na badanie lekarskie
                                    L=Do laboratorium
                                    G=Na badanie diagnostyczne
                                    A=Na zabieg
                                    F=Zlec.lek.(farmakoterapia)
                                    R=Recepta - ???
                                    S=Skierowanie wystawione na zewntrz
									T=Skierowanie pobrane z P1
                                    P=Dla pielgniarki
                                    E=Planowane szczepienia
                                 */
        PODTYP         INTEGER,  /* dla typu C (do szpitala) - 0 (null) : do szpitala, 1 : na operacj, 2 : obydwa 
		                            dla typu P (pielgniarka - 0 (null) : zwyke, 1 : leczenie dojelitowe */
        TYPSKIEROWANIA DIDENT,   /* Definiowany sownik dla skierowa na zewntrz */
        PROCEDURA      KLUCZ,
        ZLC_FIRMA      KLUCZ,
        ZLC_ZAKLAD     KLUCZ,
        ZLC_OSOBA      KLUCZ,
        ZDARZENIE      KLUCZ,    /* klucz do Historia z wykonaniem zlecenia - nie dotyczy laboratorium */
        INNYKLUCZ      KLUCZ,    /* wykorzystywane do zapamitania klucza innego
                                   rekordu zwizanego z wykonaniem zlecenia
                                   - Klucz pobytu dla kolejki do szpitala
                                   - W przychodni nie jest wykorzystane, klucz zlecenia
                                     jest zapamitywany w RuchPrzychodni
                                   - zabiegi/diagnostyka/blok operacyjny : oprcz ZDARZENIE powyej take
                                     ZLECENIE w HISTORIA
                                   - Klucz harmonogramu szczepie dla planowanego szczepienia
                                 */

        BLOK           KLUCZ,    /* klucz bloku operacyjnego */
        SALA           DIDENT,   /* sala operacyjna */
        BLOK_NA_KIEDY  TIMESTAMP,
        BLOK_DO_KOGO   KLUCZ,
        BLOK_ZLC_ZAKLAD KLUCZ,

        KODKRESKOWY  VARCHAR(50), /* dla laboratorium */
        EKSPORT        SYMBOL,    /* Identyfikator schematu eksportu - laboratorium */

        W_KOLEJCE      TAKNIE,   /* Wskanik, czy zlecenie wpisane w kolejk */
        NR_KOLEJKI     INTEGER,  /* Dla szpitala (typ = 'C') w ramach ZLC_ZAKLAD (oddzia)
                                    Dla Przychodni (typ IN ('B', 'L', 'G', 'A') w ramach WYK_ZAKLAD
                                    oba w ramach roku */
        PRZYPADEK      TYP,      /* 1 stabilny, 2 pilny */
        PRZYCZ_ZT      VARCHAR(200),  /* Przyczyna zmiany terminu */
		POWOD_ZM_KM    VARCHAR(1000), /* Powd zmiany kategorii medycznej */

        W_AP_KOLCE     TYP,      /* wartoci zgodne ze stan */
		ID_KOLCE       VARCHAR(15),
        DATA_AP_KOLCE  TIMESTAMP,

        W_AP_DILO     TYP,       /* wartoci zgodne ze stan */
		ID_DILO       VARCHAR(15),
        DATA_AP_DILO  TIMESTAMP,

        ONKOLOGIA_KARTA VARCHAR(20),
        ONKOLOGIA_ETAP  VARCHAR(1),
        DODATKOWE_KRYTERIUM    VARCHAR(100),  /* nie uzywane, dla zgodnosci */

        DYZUR          KLUCZ,    /* klucz dyuru lekarskiego */
        POZAGRAFIKIEM  TAKNIE,   /* ! lub null */
        LP_DYZURU      INTEGER,
        NA_KIEDY       TIMESTAMP,
        PILNOSC        TYP,
        DO_KOGO        KLUCZ,
        STAN           TYP,      /* Do realizacji, Obsugiwane, Wykonane,
                                    Rezygnacja z wykonania, T=Zmiana terminu,
                                    E - rezerwa, F - rezygnacja z rezerwacji, G - przeniesienie z rezerwy */
        GOTOWOSC       TAKNIE,   /* Rozszerzenie stanu - wskaznik gotowosci pacjenta do wizyty
                                    istotne np w okulistyce, gdzie pacjent musi byc przygotowany
                                    przez pielegniarki */

        TYPWIZYTY      VARCHAR(5),   /* Dla przychodni i szpitala */

        ZNANYLEKARZ    KLUCZ,     /* identyfikator rezerwacji w ZL */
        WPORTALU       KLUCZ,

        ZNL_NAZWISKO   VARCHAR(50),
        ZNL_IMIE       VARCHAR(20),
        ZNL_MAIL       VARCHAR(100),
        ZNL_TELEFON    VARCHAR(15),

        PRZEDPLATA     WARTOSC,

        /* Skierowanie */

        PODSTAWA     TYP,
        PROGRAMMED   DIDENT,

        SKR_FIRMA    KLUCZ,
        SKR_ZAKLAD   KLUCZ,
        SKR_OSOBA    KLUCZ,
        SKR_LEK_NI   OPIS,
        SKR_LEK_NR   SYMBOL,
        SKR_LEK_TP   IDENT,  /* Typ personelu osoby ze skierowania */
        SKR_KONTRAKT DUZA_NAZWA,
        SKR_JEDN     SYMBOL,
        SKR_JEDN_VIII  SYMBOL,
        SKR_RUM      VARCHAR(20),
        SKR_DATA     TIMESTAMP,
        SKR_NUMERZGL VARCHAR(25),
        SKR_DOSTARCZONE   TAKNIE,

        SKR_ROOT             VARCHAR(60),   
        SKR_EXTENSION        VARCHAR(22),
		
        UBEZP_PODSTAWA   TYP,
        DECYZJA_NR       MALA_NAZWA, /* decyzja burmistrza itp. dla podstawy <> 1 */
        DECYZJA_OD       TIMESTAMP,
        DECYZJA_DO       TIMESTAMP,
        SYGN_PISMA_ZGODY DUZY_SYMBOL,

        DOK_UBEZP_PANSTWO         IDENT,
        DOK_UBEZP_TYP_INSTYTUCJI  TYP,             /* N=NFZ, G=Gmina, I=inna, P=penopatny */
        DOK_UBEZP_ODDZIAL_NFZ     IDENT,           /* dla typ = N */
        DOK_UBEZP_GMINA           KOD_TERYT,       /* dla typ = G */
        DOK_UBEZP_GMINA_ORGAN     OPIS,
        DOK_UBEZP_FIRMA_KOD       NUMER,           /* dla typ = I*/
        DOK_UBEZP_FIRMA_AKRONIM   SYMBOL,
        DOK_UBEZP_FIRMA_CWU       DUZY_SYMBOL,

        DOK_UBEZP_TYP_DOKUM       TYP,             /* K=karta, D=decyzja wjta, U=dok. UE, Z-ekuz, C=certyfikat, P=powiadczenie, E=druk E*/
        DOK_UBEZP_RODZAJ_E        DIDENT,          /* rodzaj druku E */
        DOK_UBEZP_NUMER           DUZY_SYMBOL,
        DOK_UBEZP_DATA_WYST       TIMESTAMP,
        DOK_UBEZP_DATA_OD         TIMESTAMP,
        DOK_UBEZP_DATA_DO         TIMESTAMP,
        DOK_UBEZP_TYTUL_UBEZP     IDENT,   /* tytu uprawnienia */
        DOK_UBEZP_PODMIOT         DUZY_SYMBOL,
        DOK_UBEZP_NPWZ            NUMER,
        DOK_UBEZP_NAZWA           DUZY_OPIS, 


        DOK_UBEZP_NIP         NIP,      /* nieuzywane */
        DOK_UBEZP_MIESIAC     INTEGER,
        DOK_UBEZP_ROK         INTEGER,
        DOK_UBEZP_ZUS         DIDENT, /* ZUS, KRUS, MSWiA, MON,SP */
        DOK_UBEZP_ZGLOSZENIE  IDENT,  /* ZUA, ZZA, ZCNA */
        DOK_UBEZP_ID          MALA_NAZWA, /* nieuzywane */
        DOK_UBEZP_OSW_TYP     TYP,
        DOK_UBEZP_OSW_PDST    TYP,

        DOK_UBEZP_POCZATEK    TIMESTAMP,
        DOK_UBEZP_KONIEC      TIMESTAMP,


        ANULOWANO      TAKNIE,
        PRZYCZYNA_REZYGNACJI  VARCHAR(2), /* 1 wykonanie, 2 rezygnacja, 3 zaprzestanie wykonywania, 5 zmiana terminu,
                                             8 niezgloszenie sie, 10 brak skierowania, 6 zgon, 7 inf. NFZ, 9 inna przyczyna */
                                          /* dodatkowo przy zmianie terminu jego powd - dla AP_KOLCE, w kolejkach zwyklych bez zmian */
        PRZYCZYNA_REZYGNACJI_INNA  VARCHAR(2), /* tylko dla PRZYCZYNA_REZYGNACJI = 9 : 
                                                3 Pacjent omykowo wpisany, 4 Pacjent zoperowany gdzie indziej,
                                                5 Nie kwalifikuje si do operacji ze wzgl. medycznych,
                                                8 Brak kontaktu z pacjentem, 9 Rezygnacja (informacja NFZ),
                                                10 Rezygnacja (inf.osoby trzeciej), 11 Nie kwalifikuje si do leczenia,
                                                12 Zoperowany, zab.czony z innymi procedurami, 13 Inna przyczyna (opis) */
        PRZYCZYNA_REZYGNACJI_OPIS  VARCHAR(1000), /* tylko dla PRZYCZYNA_REZYGNACJI = 9, PRZYCZYNA_REZYGNACJI_INNA = 13 */
                                          /* dodatkowo przy zmianie terminu (10) jego powd - dla AP_KOLCE, w kolejkach zwyklych bez zmian */
        OPEROWANA_STRONA           VARCHAR(1);  /* L-lewa, P-prawa, N-nie dotyczy, B-brak */

        PRZENIESIENIE  KLUCZ,      /* Klucz do starego zlecenia po zmianie terminu */
        ZAWIADOMIC     TAKNIE,     /* Po przeniesieniu */
        PRZYWROCENIE   TYP,        /* 1 - powtorny wpis w przychodni, 2 - przeniesienie z innej przychodni */

        ZMIANA_TERMINU_KOD  VARCHAR(2),
        ZMIANA_TERMINU_OPIS VARCHAR(200),

        CHOROBA      VARCHAR(6),

        DIETA        DIDENT,
        OPISDIETY    DUZY_OPIS,


        WEWNETRZNE   TAKNIE,      /* nieuzywane od 2014 albo i wczesniej, uywane w laboratorium */

        MAT_LAB_POBRAL  KLUCZ,    /* Pobierajcy materia na odziale szpitalnym, ... */
        MAT_LAB_POBRANO TIMESTAMP,

        WYK_FIRMA      KLUCZ,
        WYK_ZAKLAD     KLUCZ,
        WYK_OSOBA      KLUCZ,
        WYK_DATA       TIMESTAMP,

        ZTW_OSOBA      KLUCZ,    /* Akceptacja, zatwierdzenie wykonania */
        ZTW_DATA       TIMESTAMP,

        P1_RODZAJ       VARCHAR(5),  /* SPC - specjalistyka, DGN - diagnostyka, ZBG - zabiegi, SZP - szpital, P1_RL - pobrane z P1 do realizacji, P1_OD - pobrane z P1 i odmowa realizacji */
        P1_KOD_DOSTEPU  VARCHAR(60), /* Chyba nie bedzie uzywany, czesc funkcji P1 go nie obsluguje */
        P1_KLUCZ        VARCHAR(60),
        P1_STATUS       VARCHAR(30),
        P1_ID_ZADANIA   VARCHAR(60),

        ZZESTAW        NUMER,
        DANE           PARAMETRY,
        UWAGI          UWAGI,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ),
        FOREIGN KEY(ZLC_FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(ZLC_ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(ZLC_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(DO_KOGO) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(WYK_FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(WYK_ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(WYK_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(BLOK_DO_KOGO) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZTW_OSOBA) REFERENCES OSOBY(KLUCZ));

        /* Dodatkowy klucz obcy zdefiniowany jest po pliku Historia */

CREATE INDEX ZLECENIA_XTYP ON ZLECENIA(TYP, INNYKLUCZ);
CREATE INDEX ZLECENIA_XDATASTANTYP ON ZLECENIA(DATA, STAN, TYP);
CREATE INDEX ZLECENIA_XSTANTYPDATA ON ZLECENIA(STAN, TYP, DATA);
CREATE INDEX ZLECENIA_XNA_KIEDYSTANTYP ON ZLECENIA(NA_KIEDY, STAN, TYP);
CREATE INDEX ZLECENIA_XNUMER ON ZLECENIA(ZLC_ZAKLAD, TYP, ROK, MIESIAC, NUMER);
CREATE INDEX ZLECENIA_XDYZUR ON ZLECENIA(DYZUR);
CREATE INDEX ZLECENIA_XZDARZENIE ON ZLECENIA(ZDARZENIE);
CREATE INDEX ZLECENIA_XBLOK ON ZLECENIA(BLOK, BLOK_NA_KIEDY);
CREATE INDEX ZLECENIA_XKOLEJKA ON ZLECENIA(WYK_ZAKLAD, ROK, W_KOLEJCE, NR_KOLEJKI);
CREATE INDEX ZLECENIA_XZNANYLEKARZ ON ZLECENIA(ZNANYLEKARZ);
CREATE INDEX ZLECENIA_XWPORTALU ON ZLECENIA(WPORTALU);
CREATE INDEX ZLECENIA_XKONTYNUACJA ON ZLECENIA(KONTYNUACJA);
CREATE INDEX ZLECENIA_XSKR_ZAKLAD ON ZLECENIA(SKR_ZAKLAD);
CREATE INDEX ZLECENIA_XSKR_OSOBA ON ZLECENIA(SKR_OSOBA);
CREATE INDEX ZLECENIA_XP1_KLUCZ ON ZLECENIA(P1_KLUCZ);

/* --- */

CREATE TABLE SKIEROWANIA_P1
       (ZLECENIE          KLUCZ NOT NULL,   /* Odwolanie do rekordu zlecenia */
	    LP                INTEGER NOT NULL, 
		OPERACJA          VARCHAR(3),       /* WYS wysane, PBL po bedzie, ODC odczyt, POB pobrane do realizacji, ODM odmowa realizacji, ANL anulowane, INF informacja o brakach, REZ rezygnacja, ZRZ zrealizowane */
		DATA              TIMESTAMP,
		NPWZ_WYSTAWCY     VARCHAR(30),      /* nie uzywane */  
		NAZWIMIE_WYSTAWCY VARCHAR(50),
		SPECJALNOSCI_WYSTAWCY VARCHAR(50),  /* nie uzywane */
		FIRMA_WYSTAWCY    VARCHAR(80),      /* nie uzywane */
		JEDN_WYSTAWCY     VARCHAR(50),      /* nie uzywane */ 
		STATUS            VARCHAR(30),
		DOKUMENT          PARAMETRY,
		WERYFIKACJA       PARAMETRY,
		KOMENTARZE        PARAMETRY,
        PRIMARY KEY(ZLECENIE, LP));
	   
	   

/* --- */

SET TERM ^ ;
CREATE GENERATOR ZLECENIA_GEN^

CREATE TRIGGER CREATE_ZLECENIA FOR ZLECENIA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(ZLECENIA_GEN, 1);
END ^

CREATE PROCEDURE DAJ_ZLECENIE
RETURNS (ZLECENIE INTEGER)
AS BEGIN
  ZLECENIE = GEN_ID(ZLECENIA_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^


CREATE TABLE PROCEDURY_ZLECENIA
       (ZLECENIE        KLUCZ NOT NULL,
        POZYCJA         INTEGER NOT NULL,
        PROCEDURA       KLUCZ NOT NULL,

        HISTORIA        KLUCZ,    /* klucz do Historia z wykonaniem zlecenia */
        WYK_OSOBA       KLUCZ,
        WYK_DATA        TIMESTAMP,

        UWAGI           UWAGI,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(ZLECENIE, POZYCJA),
/*        FOREIGN KEY(HISTORIA) REFERENCES HISTORIA(KLUCZ),  */
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));

CREATE INDEX PROCEDURY_ZLECENIA_XHISTORIA ON PROCEDURY_ZLECENIA(HISTORIA);

COMMIT WORK;


CREATE TABLE POZ_ZLEC_LEKOW
       (POBYT           KLUCZ NOT NULL,
        ZLECENIE        KLUCZ NOT NULL,
        POZYCJA         INTEGER NOT NULL,

        MATERIAL        KLUCZ,
        PRODUKT         KLUCZ,

        NAZWAIOPIS      VARCHAR(120) CHARACTER SET DOS852,
        ILOSC           WARTOSC,  /* odpowiada dawce materiau */
        JM              JM,
        ZUZYCIE         ILOSC,    /* odpowiada zuyciu ewidencyjnemu */
        JM_ZUZYCIA      JM,

        DROGA_PODANIA   TYP,
        PORA_PODANIA    TYP,
        GODZ_PODANIA    VARCHAR(100),
        CO_DNI          INTEGER,
        DAWKOWANIE      UWAGI,

        DATA_OD         TIMESTAMP,
        DATA_DO         TIMESTAMP,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(ZLECENIE, POZYCJA),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ),
        FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ));


CREATE TABLE POZ_LECZ_DOJELIT
       (ZLECENIE        KLUCZ NOT NULL,
	    TYP             TYP NOT NULL,       /* Z - zlecenie, W - wykonanie */ 
        POZYCJA         INTEGER NOT NULL,
		HISTORIA        KLUCZ,              /* odwoanie realizacji, dla zlecenia 0 */
		DOPOZYCJI       INTEGER,            /* wskazanie pozycji zlecenia */
		BLOKADA         TAKNIE,             /* B - blokada, null (spacja) brak */
		
		DOBA            VARCHAR(10),
		CZAS            PARAMETRY,
		PREPARAT        PARAMETRY,
		SZYBKOSC        PARAMETRY,
		UWAGI           PARAMETRY,          /* nie uzywane */ 
		KCL             INTEGER,
        OBJETOSC        INTEGER,		

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(ZLECENIE, POZYCJA));
		
CREATE INDEX POZ_LECZ_DOJELIT_XHISTORIA ON POZ_LECZ_DOJELIT(HISTORIA);

/* --- */

CREATE TABLE KOLEJKINFZMIESIECZNIE
       (ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        ZAKLAD          INTEGER NOT NULL,
        KATEGORIA       VARCHAR(1) NOT NULL,

        OBSLUZENI       INTEGER,
        DNI_OCZEKIWANIA INTEGER,

        PRIMARY KEY(ROK, MIESIAC, ZAKLAD, KATEGORIA));

/* --- */

CREATE TABLE HISTORIA
       (KLUCZ           KLUCZ NOT NULL,
        PACJENT         KLUCZ,
        POBYT           KLUCZ,
        ZAKLAD          KLUCZ,
        BLOKOPER        KLUCZ,       /* Dla bloku operacyjnego = zaklad */
        APTECZKA        KLUCZ,
        OSOBA           KLUCZ,
        ZLECENIE        KLUCZ,
        ZDARZENIE       KLUCZ,
        NADRZEDNA       KLUCZ,

        WYSLANE         TAKNIE,   /* Pakiet wiadczeniodawcy  */
        ANULOWANO       TAKNIE,

        WIZYTA          INTEGER,  /* Roszerzenie pobytu w gabinecie, oddziale */

        FIRMA           KLUCZ,
        LEK_NI          OPIS,
        LEK_NR          SYMBOL,

        ID_PROCEDURY    MALA_NAZWA,

        DOSTATYSTYKI    TAKNIE,
        DOKASY          TAKNIE,
        GLOWNA          TAKNIE,   /* G - glowna na oddziale szpitala */
        ILOSC           INTEGER,

        IL_EKSPOZYCJI   INTEGER,
        OPIS_EKSPOZYCJI UWAGI,
		
		SZCZ_NAZWA      VARCHAR(50),
		SZCZ_SERIA      VARCHAR(30),
		SZCZ_WAZNOSC    TIMESTAMP,

        NUMER           DUZY_SYMBOL,

        DATA            TIMESTAMP,
        DATA_DO         TIMESTAMP,
        TYP             TYP,
        RODZAJ          TYP,    /* Badanie, obSerwacje, C - pielegniarka, Leki (?), UWAGA - dla lekow z apteczki nie jest L, W - laboratorium */
        PROCEDURA       KLUCZ,
        ZESTAW          NUMER,

        GRAFIKA         KLUCZ,  /* Odwoanie do bazy dokumentw - Dokumenty_teczki */

        TYPPACS         DIDENT, /* Powizanie z systemem PACS */
        ETAPPACS        TYP,

        KOM_LAB         TAKNIE, /* badanie laboratoryjne z komunikatem NTE - na podstawie kom.laboratorium w HL7 */
        DOD_BAD_LAB     TAKNIE, /* rozszezone (posiew, antybiogram, ...) badanie laboratoryjne */
        LAB_OK          TAKNIE, /* wskaznik zapisu wyniku z ORX */

        ZO_ASYSTA1      KLUCZ,
        ZO_ASYSTA2      KLUCZ,
        ZO_PIELEGNIARKA KLUCZ,
        ZO_PIELEGNIARKA1 KLUCZ,
        ZO_ANESTEZJOLOG KLUCZ,
        ZO_PIELEGNIARKAA KLUCZ,
        ZO_ZNIECZ_OD    TIMESTAMP,
        ZO_ZNIECZ_DO    TIMESTAMP,
        ZO_ZNIECZ_RODZ  IDENT,
        ZO_ZNIECZ_OPIS  OPIS,
        ZO_ZGODAPAC     TAKNIE,

        ZO_CHOROBAZAS1  VARCHAR(6),
        ZO_CHOROBAZAS2  VARCHAR(6),
        ZO_CHOROBAZAS3  VARCHAR(6),
        ZO_ROZPOZNANIE  UWAGI,

        DANE            PARAMETRY,
        UWAGI           UWAGI,

        KOSZT        WARTOSC,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(BLOKOPER) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ),
/*        FOREIGN KEY(ZLECENIE) REFERENCES ZLECENIA(KLUCZ),   */
/*        FOREIGN KEY(ZDARZENIE) REFERENCES HISTORIA(KLUCZ),  */
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));

CREATE INDEX HISTORIA_XTYPDATA ON HISTORIA(TYP, DATA);
CREATE INDEX HISTORIA_XDATATYP ON HISTORIA(DATA, TYP);
CREATE INDEX HISTORIA_XZLECENIE ON HISTORIA(ZLECENIE);
CREATE INDEX HISTORIA_XZDARZENIE ON HISTORIA(ZDARZENIE);

/* ALTER TABLE ZLECENIA ADD FOREIGN KEY(ZDARZENIE) REFERENCES HISTORIA(KLUCZ); */

CREATE INDEX ZLECENIA_XZDARZENIE ON ZLECENIA(ZDARZENIE);


SET TERM ^ ;
CREATE GENERATOR HISTORIA_GEN^

CREATE TRIGGER CREATE_HISTORIA FOR HISTORIA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(HISTORIA_GEN, 1);
END ^

CREATE PROCEDURE DAJ_HISTORIA
RETURNS (HISTORIA INTEGER)
AS BEGIN
  HISTORIA = GEN_ID(HISTORIA_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

/* Tablica wskanikowa coby nie tworzy danych o zmianach */

CREATE TABLE HISTORIA_DO_WYPISU
       (HISTORIA        KLUCZ NOT NULL);

CREATE INDEX HISTORIA_XWYPIS ON HISTORIA_DO_WYPISU(KLUCZ);

/* ........................................................................ */


CREATE TABLE BADANIA_POZ
       (KLUCZ        KLUCZ NOT NULL,
        ID_ZESTAWU   VARCHAR(20) NOT NULL,
        PACJENT      KLUCZ NOT NULL,
        ROK          INTEGER NOT NULL,
        MIESIAC      INTEGER NOT NULL,

        WERSJA       INTEGER,
        DATA_WERSJI  TIMESTAMP,

        UMOWA_NFZ    KLUCZ NOT NULL,

        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE INDEX BADANIA_POZ_OKRES  ON BADANIA_POZ(ROK, MIESIAC, ID_ZESTAWU);

SET TERM ^ ;
CREATE GENERATOR BADANIA_POZ_GEN^

CREATE TRIGGER CREATE_BADANIA_POZ FOR BADANIA_POZ
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(BADANIA_POZ_GEN, 1);
END ^

CREATE PROCEDURE DAJ_BADANIE_POZ
RETURNS (BADANIE_POZ INTEGER)
AS BEGIN
  BADANIE_POZ = GEN_ID(BADANIA_POZ_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* ........................................................................ */

/* Ruch chorych w szpitalu */

CREATE TABLE NUMERYKSIAG
       (ROK             INTEGER NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        RODZAJ          TYP NOT NULL,
        NUMER           INTEGER,

        PRIMARY KEY(ROK, ZAKLAD, RODZAJ));

/* --- */

CREATE TABLE DANERUCHUSZPITALNEGO
       (KLUCZ           KLUCZ NOT NULL,
        POBYT           KLUCZ NOT NULL,
        PACJENT         KLUCZ NOT NULL,

        STAN            TYP,
        ANULOWANO       TAKNIE,

        POPRZPOBYT      KLUCZ,
        POPRZWYP_DATA   TIMESTAMP,

        PRZ_DATA     TIMESTAMP,
        PRZ_TRYB     TYP,
        PRZ_OSOBA    KLUCZ,

        WYP_DATA     TIMESTAMP,
        WYP_TRYB     TYP,
        WYP_OSOBA    KLUCZ,
        WYP_TYPPLT   VARCHAR(3),
        WYP_PLATNIK  KLUCZ,

        CHARAKTER   INTEGER,
        TRYB        INTEGER,

        DNI          INTEGER,
        ROZL_ROK     INTEGER,
        ROZL_MIESIAC INTEGER,

        CHOROBAZAS1  VARCHAR(6),
        CHOROBAZAS2  VARCHAR(6),
        CHOROBAZAS3  VARCHAR(6),

        CHOROBAWSP1  VARCHAR(6),
        CHOROBAWSP2  VARCHAR(6),
        CHOROBAWSP3  VARCHAR(6),

        PROCEDURY1   VARCHAR(10),
        PROCEDURY2   VARCHAR(10),
        PROCEDURY3   VARCHAR(10),
        PROCEDURY4   VARCHAR(10),
        PROCEDURY5   VARCHAR(10),

        PRZZGONU1    VARCHAR(6),
        PRZZGONU2    VARCHAR(6),
        PRZZGONU3    VARCHAR(6),

        WYSLANE      TAKNIE,
        WYP_DYSCYPL  TAKNIE,             /*okrela, czy wypis ze szpitala dyscyplinarny, czy nie*/
        PRZZGONUSEK  VARCHAR(6),         /*przyczyna zgonu wg sekcji*/

        BLEDY_NFZ          DUZY_OPIS, /* 4-znakowe kody bledow rozdzielone srednikami */
        SPRAWDZONO_NFZ     TIMESTAMP,  /* Czy obsluzono pole BLEDY_NFZ : null - nie byo, data do porwnania ze ZMIENIANO */

        WYP_ODLEZYNY             TAKNIE,
        WYP_USTANIE_CZYNN_MOZGU  TAKNIE,
        WYP_DATA_ORZECZENIA      TIMESTAMP,
        WYP_DONACJA_NARZADOW     TAKNIE,

        DANE         PARAMETRY,

        KOLEJKA_DATA_WPISU  TIMESTAMP,          /* Proteza do uzupelnienia kolejek oczekujacych */
        KOLEJKA_KATEGORIA   TYP,
        KOLEJKA_PROCEDURA   KLUCZ,
        KOLEJKA_ZAKLAD      KLUCZ;
		
        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(WYP_PLATNIK) REFERENCES FIRMY(KLUCZ),

        FOREIGN KEY(PRZ_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(WYP_OSOBA) REFERENCES OSOBY(KLUCZ),

        PRIMARY KEY(KLUCZ));

CREATE INDEX DRUCHSZPITALNY_XROZL     ON DANERUCHUSZPITALNEGO(ROZL_ROK, ROZL_MIESIAC);
CREATE INDEX DRUCHSZPITALNY_XPRZ      ON DANERUCHUSZPITALNEGO(PRZ_DATA);
CREATE INDEX DRUCHSZPITALNY_XWYP      ON DANERUCHUSZPITALNEGO(WYP_DATA);
CREATE INDEX DRUCHSZPITALNY_XPACRZN   ON DANERUCHUSZPITALNEGO(PACJENT, PRZ_DATA);
CREATE INDEX DRUCHSZPITALNY_XCHORZAS1 ON DANERUCHUSZPITALNEGO(CHOROBAZAS1);

SET TERM ^ ;
CREATE GENERATOR RUCHSZPITALNY_GEN^

CREATE PROCEDURE DAJ_RUCHSZPITALNY
RETURNS (RUCHSZPITALNY INTEGER)
AS BEGIN
  RUCHSZPITALNY = GEN_ID(RUCHSZPITALNY_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE NUMERYRUCHUSZPITALNEGO
       (ROK             INTEGER NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        NUMER           INTEGER NOT NULL,
        NOWORODEK       INTEGER NOT NULL,

        KLUCZDANYCH     KLUCZ NOT NULL,

        FOREIGN KEY(KLUCZDANYCH) REFERENCES DANERUCHUSZPITALNEGO(KLUCZ),
        PRIMARY KEY(ROK, ZAKLAD, NUMER, NOWORODEK));

/* --- */

CREATE VIEW RUCHSZPITALNY AS
SELECT * FROM NUMERYRUCHUSZPITALNEGO N, DANERUCHUSZPITALNEGO D
WHERE D.KLUCZ = N.KLUCZDANYCH;

CREATE VIEW OSTATNIRUCHSZPITALNY AS
SELECT * FROM NUMERYRUCHUSZPITALNEGO N, DANERUCHUSZPITALNEGO D
WHERE D.KLUCZ = N.KLUCZDANYCH AND N.ROK =
 (SELECT MAX(ROK) FROM NUMERYRUCHUSZPITALNEGO X
  WHERE X.KLUCZDANYCH = D.KLUCZ);

/* --- */

CREATE TABLE RUCHODDZIALOWY
       (ROK             INTEGER NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        NUMER           INTEGER NOT NULL,
        POWROT          INTEGER NOT NULL,   /* to jest nieaktualne, zawsze 0 */
        POBYT           KLUCZ NOT NULL,
        PACJENT         KLUCZ NOT NULL,

        ID_SWIADCZENIA  MALA_NAZWA,  /* identyfikator pobytu oddziaowego */

        WIZYTA          INTEGER,  /* Roszerzenie pobytu w oddziale, numeracja */
                                  /* w ramach pobytu w szpitalu, nie oddzialu */
        BLOKOPER        TAKNIE,   /* Wskanik rekordu dla bloku operacyjnego - nie uywane */

        LEKARZ          KLUCZ,
        LOZKO           KLUCZ,
        PRZEPUSTKA      KLUCZ,
        STAN            TYP,
        ANULOWANO       TAKNIE,
        WYPIS           TYP,

        PRZ_DATA     TIMESTAMP,
        PRZ_TRYB     TYP,
        PRZ_OSOBA    KLUCZ,       /* w starym bylo, w nowym sie zgubilo, pozostalo przy wypisie na oddzial */

        WYP_DATA     TIMESTAMP,
        WYP_SWIADCZ  VARCHAR(3),
        WYP_TRYB     TYP,
        WYP_OSOBA    KLUCZ,       /* uzywane tylko przy wypisie na oddzial - zamiast pole kalkulacyjne */

        DNI          INTEGER,
        PROCPOBYTU   DOUBLE PRECISION,

        KALK_KOD     SYMBOL,
        KALK_TYP     TYP,             /* obecnie - kategoria pielegnacji 1,2,3 */
        KALK_ILOSC   ILOSC,

        KODKASY      VARCHAR(5),
        GRKOSZTOWA   TYP,
        KODKASYDOD   VARCHAR(5),

        KodSwiadczMZ NUMER,
        KODSWIADCZMZ3 NUMER,

        CHOROBAZAS1  VARCHAR(6),
        CHOROBAZAS2  VARCHAR(6),
        CHOROBAZAS3  VARCHAR(6),

        CHOROBAWSP1  VARCHAR(6),
        CHOROBAWSP2  VARCHAR(6),
        CHOROBAWSP3  VARCHAR(6),

        ORPHANET   VARCHAR(12),

        PROCEDURY1   VARCHAR(10),
        PROCEDURY2   VARCHAR(10),
        PROCEDURY3   VARCHAR(10),
        PROCEDURY4   VARCHAR(10),
        PROCEDURY5   VARCHAR(10),

        PRZZGONU1    VARCHAR(6),
        PRZZGONU2    VARCHAR(6),
        PRZZGONU3    VARCHAR(6),

        MLECZANY_OAIIT  WARTOSC,

        NWT_TIS              TAKNIE,
        NWT_TUMOR            VARCHAR(2),   
        NWT_NODULES          VARCHAR(2),   
        NWT_METASTASES       VARCHAR(2),   
        NWT_STOPIEN          VARCHAR(4),   
        NWT_I_NAZWA          VARCHAR(30),   
        NWT_I_WYNIK          VARCHAR(80),   
        NWT_I_STADIUM        TYP,

        DOKASY       TAKNIE,
        KALK_KOD1    NUMER,
        KALK_ILOSC1  ILOSC,

        WYSLANE TAKNIE,
        GL_SWIADCZENIE  VARCHAR(5) CHARACTER SET DOS852,
        DOD_SWIADCZENIE VARCHAR(5), /*puste pole - nie dotyczy, '4.23'- transport pacjenta*/
        TRANSPORT_CEL      IDENT,   /* Wypeniane jeli jest dod_swiadczenie <> '' */
        TRANSPORT_DOPLATA  WARTOSC,
        GLOWNY  TAKNIE,             /*czy to gwny oddzia pobytowy pacjenta w ramach pobytu w szpitalu*/

        BLEDY_NFZ          DUZY_OPIS, /* 4-znakowe kody bledow rozdzielone srednikami */
        SPRAWDZONO_NFZ     TIMESTAMP,  /* Czy obsluzono pole BLEDY_NFZ : null - nie byo, data do porwnania ze ZMIENIANO */

        DANE         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(LEKARZ) REFERENCES OSOBY(KLUCZ),

        FOREIGN KEY(PRZ_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(WYP_OSOBA) REFERENCES OSOBY(KLUCZ),

        PRIMARY KEY(ROK, ZAKLAD, NUMER, POWROT));

CREATE INDEX RUCHODDZIALOWY_XSTAN   ON RUCHODDZIALOWY(STAN);
CREATE INDEX RUCHODDZIALOWY_XPRZ    ON RUCHODDZIALOWY(PRZ_DATA);
CREATE INDEX RUCHODDZIALOWY_XWYP    ON RUCHODDZIALOWY(WYP_DATA);
CREATE INDEX RUCHODDZIALOWY_XPACPRZ ON RUCHODDZIALOWY(PACJENT, PRZ_DATA);

/* --- */

CREATE TABLE PRZEPUSTKIODDZIALU
       (POBYT           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        WIZYTA          INTEGER NOT NULL,
        DATA_OD         TIMESTAMP NOT NULL,
        DO_KIEDY        TIMESTAMP,              /* przewidywany powrot */
        DATA_DO         TIMESTAMP,              /* wlasciwy powrot */
        UWAGI           UWAGI,
        KLUCZ           KLUCZ NOT NULL,    /* DAJ_RUCHSZPITALNY */
        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,
        PRIMARY KEY(POBYT, ZAKLAD, WIZYTA, DATA_OD));

CREATE INDEX PRZEPUSTKIODDZIALU_XKLUCZ   ON PRZEPUSTKIODDZIALU(KLUCZ);



CREATE TABLE RUCHZBIORCZO                       /* nieaktualne */
       (ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        WYP_TYPPLT      VARCHAR(3) NOT NULL,
        KALK_KOD        SYMBOL NOT NULL,
        KODKASY         VARCHAR(5) NOT NULL,
        KODKASYDOD      VARCHAR(5) NOT NULL,

        POBYTY          INTEGER,
        PROCPOBYTU      DOUBLE PRECISION,
        DNI             INTEGER,
        DNI_ROZL        ILOSC,
        JEDNODNIOWI     INTEGER,
        DNI_PRZEPUSTKI  INTEGER,
        KALK_ILOSC      ILOSC,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),

        PRIMARY KEY(ROK, MIESIAC, ZAKLAD, KODKASY, KODKASYDOD, WYP_TYPPLT, KALK_KOD));

CREATE INDEX RUCHZBIORCZO_XWYP_TYPPLT ON
  RUCHZBIORCZO(ROK, MIESIAC, WYP_TYPPLT, ZAKLAD, KALK_KOD);

/* ........................................................................ */

/* Ruch chorych w przychodni */


CREATE TABLE RUCHPRZYCHODNI
       (ROK             INTEGER NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        NUMER           INTEGER NOT NULL,
        POBYT           KLUCZ NOT NULL,
        PACJENT         KLUCZ NOT NULL,
        NUMER_NFZ       INTEGER,

        NR_ZESTAWU      MALA_NAZWA,
        ID_SWIADCZENIA  MALA_NAZWA,    /* koniec 2019 wykorzystane chwilowo jako wskanik wystawienia recepty papierowej */
        GLOWNE_UPRAW    INTEGER,
        INSTALACJA      NR_INSTALACJI,

        WIZYTA       INTEGER,          /* Rozszerzenie pobytu, numeracja kolejnych wizyt
                                         w gabinetach, w ramach pobytu */
        ID_NFZ       KLUCZ NOT NULL,   /* identyfikacja numeryczna wizyty w gabinecie - dla NFZ */
                                       /* wykorzystane dodatkowo jako klucz do teczki dokumentw */
        DOKUMENTY    KLUCZ,            /* Klucz teczki dokumentw */

        BLEDNE       TAKNIE,           /* Program wiadczeniodawcy */
        WYSLANE      TAKNIE,

        ANULOWANO    TAKNIE,           /* Zamiast usuwania gdy s rozliczenia z NFZ */

        PRZ_DATA     TIMESTAMP,
        PRZ_OSOBA    KLUCZ,

        BADANIE      KLUCZ,            /* Klucz rekordu HISTORIA podwizanego do wizyty */
        ZLECENIE     KLUCZ,            /* Klucz zlecenia wizyty - z rejestracji, innego gabinetu */
                                       /* Bez indeksu, szukanie dla pacjenta */
        PODSTAWA     TYP,
        TYPWIZYTY    TYP,
        PROGRAMMED   DIDENT,

        INFORMACJADLAKIERUJACEGO TAKNIE,

        KALK_KOD     SYMBOL,           /* Stare ? */
        KALK_TYP     TYP,
        KALK_ILOSC   ILOSC,

        KodSwiadczMZ  NUMER,
        KODSWIADCZMZ3 NUMER,
        KODBADANIADIAGNOSTYKI   IDENT,
        KOD_KONTYNUACJI   VARCHAR(3),   /* Dla pierwszorazowych w AOS: 1-dalsze leczenie w POZ, 2-pozostanie w AOS, 3-skierowanie do innego typu gabinetu AOS */
                                        /*   4-skierowanie do szpitala, 5-zakoczenie leczenia specjalistycznego */

        SKR_FIRMA    KLUCZ,
        SKR_ZAKLAD   KLUCZ,
        SKR_OSOBA    KLUCZ,
        SKR_LEK_NI   OPIS,
        SKR_LEK_NR   SYMBOL,
        SKR_LEK_TP   IDENT,  /* Typ personelu osoby ze skierowania */
        SKR_KONTRAKT DUZA_NAZWA,
        SKR_JEDN     SYMBOL,
        SKR_JEDN_VIII  SYMBOL,
        SKR_RUM      VARCHAR(20),
        SKR_DATA     TIMESTAMP,
        SKR_NUMERZGL VARCHAR(25),

        SKR_ROOT             VARCHAR(60),   
        SKR_EXTENSION        VARCHAR(22),
		
        CHOROBAZAS1  VARCHAR(6),
        CHOROBAZAS2  VARCHAR(6),
        CHOROBAZAS3  VARCHAR(6),

        CHOROBAWSP1  VARCHAR(6),
        CHOROBAWSP2  VARCHAR(6),
        CHOROBAWSP3  VARCHAR(6),
        CHOROBAWSP4  VARCHAR(6),
        CHOROBAWSP5  VARCHAR(6),
        
        ORPHANET   VARCHAR(12),
        OCENASPRAWNOSCI    TYP,
        DODATKOWE_KRYTERIUM    VARCHAR(100),

        ICF           PARAMETRY,  

        WYP_PLT        VARCHAR(3) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        WYP_PLT_FIRMA  KLUCZ,

        UBEZP_PODSTAWA   TYP,
        DECYZJA_NR       MALA_NAZWA, /* decyzja burmistrza itp. dla podstawy <> 1 */
        DECYZJA_OD       TIMESTAMP,
        DECYZJA_DO       TIMESTAMP,
        SYGN_PISMA_ZGODY DUZY_SYMBOL,

        DOK_UBEZP_PANSTWO         IDENT,
        DOK_UBEZP_TYP_INSTYTUCJI  TYP,             /* N=NFZ, G=Gmina, I=inna, P=penopatny */
        DOK_UBEZP_ODDZIAL_NFZ     IDENT,           /* dla typ = N */
        DOK_UBEZP_GMINA           KOD_TERYT,       /* dla typ = G */
        DOK_UBEZP_GMINA_ORGAN     OPIS,
        DOK_UBEZP_FIRMA_KOD       NUMER,           /* dla typ = I*/
        DOK_UBEZP_FIRMA_AKRONIM   SYMBOL,
        DOK_UBEZP_FIRMA_CWU       DUZY_SYMBOL,

        DOK_UBEZP_TYP_DOKUM       TYP,             /* K=karta, D=decyzja wjta, U=dok. UE, Z-ekuz, C=certyfikat, P=powiadczenie, E=druk E*/
        DOK_UBEZP_RODZAJ_E        DIDENT,          /* rodzaj druku E */
        DOK_UBEZP_NUMER           DUZY_SYMBOL,
        DOK_UBEZP_DATA_WYST       TIMESTAMP,
        DOK_UBEZP_DATA_OD         TIMESTAMP,
        DOK_UBEZP_DATA_DO         TIMESTAMP,
        DOK_UBEZP_TYTUL_UBEZP     IDENT,   /* tytu uprawnienia */
        DOK_UBEZP_PODMIOT         DUZY_OPIS,
        DOK_UBEZP_NPWZ            NUMER,
        DOK_UBEZP_NAZWA           DUZY_OPIS, 

        DOK_UBEZP_NIP         NIP,     /* nieuzywane */
        DOK_UBEZP_MIESIAC     INTEGER,
        DOK_UBEZP_ROK         INTEGER,
        DOK_UBEZP_ZUS         DIDENT, /* ZUS, KRUS, MSWiA, MON,SP */
        DOK_UBEZP_ZGLOSZENIE  IDENT,  /* ZUA, ZZA, ZCNA */
        DOK_UBEZP_ID          MALA_NAZWA, /* nieuzywane */
        DOK_UBEZP_OSW_TYP     TYP,
        DOK_UBEZP_OSW_PDST    TYP,

        DOK_UBEZP_POCZATEK    TIMESTAMP,
        DOK_UBEZP_KONIEC      TIMESTAMP,

        TRANSPORT_CEL       IDENT,
        TRANSPORT_DOPLATA   WARTOSC,

        CYKL            TAKNIE,            /* Nie uywane, wycofane */
        DATACYKLU       TIMESTAMP,              /* zamiast tego obsluga w tabeli Sesje_leczenia */
        SESJA_LECZENIA  KLUCZ,

        BLEDY_NFZ          DUZY_OPIS, /* 4-znakowe kody bledow rozdzielone srednikami */
        SPRAWDZONO_NFZ     TIMESTAMP,  /* Czy obsluzono pole BLEDY_NFZ : null - nie byo, data do porwnania ze ZMIENIANO */

        DANE         PARAMETRY,
        UWAGI        PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(SKR_FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(SKR_OSOBA) REFERENCES OSOBY(KLUCZ),

        FOREIGN KEY(PRZ_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),

        PRIMARY KEY(ROK, ZAKLAD, NUMER));

CREATE INDEX RUCHPRZYCHODNI_XPRZ  ON RUCHPRZYCHODNI(PRZ_DATA, ZAKLAD);
CREATE INDEX RUCHPRZYCHODNI_XOSB  ON RUCHPRZYCHODNI(PRZ_OSOBA, PRZ_DATA);
CREATE INDEX RUCHPRZYCHODNI_XNFZ  ON RUCHPRZYCHODNI(ID_NFZ);
CREATE INDEX RUCHPRZYCHODNI_XNUMER_NFZ  ON RUCHPRZYCHODNI(NUMER_NFZ);

SET TERM ^ ;

CREATE TRIGGER CREATE_RUCHPRZYCHODNI FOR RUCHPRZYCHODNI
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.ID_NFZ = 0)
  THEN NEW.ID_NFZ = GEN_ID(POBYTY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_RUCHPRZYCHODNI
RETURNS (ID_NFZ INTEGER)
AS BEGIN
  ID_NFZ = GEN_ID(POBYTY_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE SESJE_LECZENIA
 (KLUCZ    KLUCZ NOT NULL,
  POCZATEK TIMESTAMP,
  KONIEC   TIMESTAMP,
  TYP      TYP, /* C=cykl, S=sesja */
  OPIS     DUZY_OPIS,

  UTWORZYL     KLUCZ,
  ZMIENIAL     KLUCZ,
  UTWORZONO    TIMESTAMP,
  ZMIENIANO    TIMESTAMP,

  PRIMARY KEY(KLUCZ));

COMMIT WORK;

/* --- */

CREATE TABLE PACJENCIPORADNI
       (ZAKLAD          KLUCZ NOT NULL,
        PACJENT         KLUCZ NOT NULL,
        NUMER           INTEGER,
        INTERNET        TAKNIE,   /* wprowadzanie danych z internetu */

        REJESTRACJA     TIMESTAMP,
        KONIEC          TIMESTAMP,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        PRIMARY KEY(ZAKLAD, PACJENT));

CREATE INDEX PACJENCIPORADNI_NUMER ON
  PACJENCIPORADNI(ZAKLAD, NUMER);

/* ........................................................................ */

/* Laboratorium */


CREATE TABLE RUCHLABORATORIUM
       (ROK             INTEGER NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        NUMER           INTEGER NOT NULL,
        PACJENT         KLUCZ NOT NULL, /* Pacjent, zlecenie identyfikuj */
        ZLECENIE        KLUCZ NOT NULL, /* rekord (oprcz Primary key) */
                                        /* - dla prbek i zlece pracowni */
        POBYT           KLUCZ NOT NULL, /* ze zlecenia */

        WEWNETRZNE   TAKNIE,
        PRZ_DATA     TIMESTAMP,
        PRZ_OSOBA    KLUCZ,

        SKR_FIRMA    KLUCZ,
        SKR_LEK_NI   OPIS,
        SKR_LEK_NR   SYMBOL,
        SKR_KONTRAKT DUZA_NAZWA,
        SKR_JEDN     SYMBOL,
        SKR_RUM      VARCHAR(20),
        SKR_DATA     TIMESTAMP,
        SKR_ROOT             VARCHAR(60),   
        SKR_EXTENSION        VARCHAR(22),
		
        DANE         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
/*        FOREIGN KEY(ZLECENIE) REFERENCES ZLECENIA(KLUCZ),  */
        FOREIGN KEY(SKR_FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(PRZ_OSOBA) REFERENCES OSOBY(KLUCZ),

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),

        PRIMARY KEY(ROK, ZAKLAD, NUMER));

CREATE INDEX RUCHLABORATORIUM_XPRZ  ON RUCHLABORATORIUM(PRZ_DATA, ZAKLAD);
CREATE INDEX RUCHLABORATORIUM_XZLECENIE  ON RUCHLABORATORIUM(ZLECENIE);

/* --- */

CREATE TABLE ZLECENIAPRACLAB
       (ROK             INTEGER NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        NUMER           INTEGER NOT NULL,/* Numeracja laboratorium */
        PACJENT         KLUCZ NOT NULL,  /* Pacjent, zlecenie, procedura */
        POBYT           KLUCZ NOT NULL,
        ZLECENIE        KLUCZ NOT NULL,  /* identyfikuj rekord ( oprcz */
        PROCEDURA       KLUCZ NOT NULL,  /* Primary key) - dla pomiarw */

        ZLEC_ZEWNETRZNE INTEGER,         /* Numeracja w ramach zlece na zewntrz - do urzadze, .... */
        WYSLANO      TIMESTAMP,               /* Data i czas wysyki zlecenia (do HL7) */
        KTO_WYSLAL   KLUCZ,

        ANULOWANE    TAKNIE,
        AWYSLANO     TIMESTAMP,               /* Data i czas wysyki anulowania zlecenia (do HL7) */
        AKTO_WYSLAL  KLUCZ,

        PRZ_DATA     TIMESTAMP,
        DO_FIRMY     KLUCZ,

        STAN         TYP,

        WYK_DATA     TIMESTAMP,
        WYK_OSOBA    KLUCZ,

        ZTW_OSOBA      KLUCZ,    /* Akceptacja, zatwierdzenie wykonania */
        ZTW_DATA       TIMESTAMP,

        DANE         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
/*        FOREIGN KEY(ZLECENIE) REFERENCES ZLECENIA(KLUCZ),  */
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ),
        FOREIGN KEY(WYK_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZTW_OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(DO_FIRMY) REFERENCES FIRMY(KLUCZ),

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),

        PRIMARY KEY(ROK, ZAKLAD, NUMER));

CREATE INDEX ZLECENIAPRACLAB_XZSTANPRZ ON ZLECENIAPRACLAB(ZAKLAD, STAN, PRZ_DATA);
CREATE INDEX ZLECENIAPRACLAB_XPRZ_DATA ON ZLECENIAPRACLAB(PRZ_DATA);
CREATE INDEX ZLECENIAPRACLAB_XWYK_DATA ON ZLECENIAPRACLAB(WYK_DATA);
CREATE INDEX ZLECENIAPRACLAB_XZLECENIE ON ZLECENIAPRACLAB(ZLECENIE);

/* --- */

CREATE TABLE PROBKILABOR
       (KLUCZ        KLUCZ NOT NULL,
        ROK          INTEGER NOT NULL,
        ZAKLAD       KLUCZ NOT NULL,
        NUMER        INTEGER NOT NULL,
        OSOBA        KLUCZ,
        ZLECENIE     KLUCZ,
        PACJENT      KLUCZ,

        TYP          TYP,
        DATA         TIMESTAMP,
        MATERIAL     VARCHAR(3),

        KODKRESKOWY  VARCHAR(50),

        SERIA        SYMBOL, /* dotyczy prbek standardowych i kontrolnych */
        ZUZYTA       TAKNIE,

        UWAGI        PARAMETRY,
        DANE         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
/*        FOREIGN KEY(ZLECENIE) REFERENCES ZLECENIA(KLUCZ), */
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ));

CREATE  INDEX PROBKILABOR_XRZNUMER ON PROBKILABOR(ROK, ZAKLAD, NUMER);
CREATE  INDEX PROBKILABOR_XZTS     ON PROBKILABOR(ZAKLAD, TYP, SERIA);
CREATE  INDEX PROBKILABOR_XZLECENIE  ON PROBKILABOR(ZLECENIE);

COMMIT WORK;

SET TERM ^ ;
CREATE GENERATOR PROBKILABOR_GEN^

CREATE TRIGGER CREATE_PROBKILABOR FOR PROBKILABOR
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(PROBKILABOR_GEN, 1);
END ^

CREATE PROCEDURE DAJ_PROBKILABOR
RETURNS (PROBKA INTEGER)
AS BEGIN
  PROBKA = GEN_ID(PROBKILABOR_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE POMIARYLABOR
       (KLUCZ        KLUCZ NOT NULL,
        ZAKLAD       KLUCZ NOT NULL,
        PACJENT      KLUCZ NOT NULL,  /* 0 dla pomiarw kontrolnych */
        ZLECENIE     KLUCZ NOT NULL,  /* zlecenie pacjenta lub 0 */
        PROCEDURA    KLUCZ NOT NULL,
        PROBKA       KLUCZ,
        EKSPORT      SYMBOL,    /* Identyfikator schematu eksportu - laboratorium */

        OSOBA        KLUCZ,
        DATA         TIMESTAMP,

        KOM_LAB         TAKNIE, /* badanie laboratoryjne z komunikatem NTE - na podstawie kom.laboratorium w HL7 */
        DOD_BAD_LAB     TAKNIE, /* rozszezone (posiew, antybiogram, ...) badanie laboratoryjne */
        LAB_OK          TAKNIE, /* wskaznik zapisu wyniku z ORX */

        UWAGI        PARAMETRY,
        DANE         PARAMETRY,

        ZTW_OSOBA    KLUCZ,    /* Akceptacja, zatwierdzenie wykonania */
        ZTW_DATA     TIMESTAMP,
        HISTORIA     KLUCZ,    /* dla zaakceptowanego pomiaru */

        SYMBOL  DUZY_SYMBOL, /* numer faktury - tylko dla pnktu poboru */

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZTW_OSOBA) REFERENCES OSOBY(KLUCZ),
/*        FOREIGN KEY(HISTORIA) REFERENCES HISTORIA(KLUCZ),  */
        FOREIGN KEY(PROBKA) REFERENCES PROBKILABOR(KLUCZ),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));

CREATE  INDEX POMIARYLABOR_XPACZLECPROC ON POMIARYLABOR(PACJENT, ZLECENIE, PROCEDURA, DATA);
CREATE  INDEX POMIARYLABOR_XZAKDATA ON POMIARYLABOR(ZAKLAD, DATA);
CREATE  INDEX POMIARYLABOR_XHISTORIA ON POMIARYLABOR(HISTORIA);

COMMIT WORK;

SET TERM ^ ;
CREATE GENERATOR POMIARYLABOR_GEN^

CREATE TRIGGER CREATE_POMIARYLABOR FOR POMIARYLABOR
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(POMIARYLABOR_GEN, 1);
END ^

CREATE PROCEDURE DAJ_POMIARYLABOR
RETURNS (POMIAR INTEGER)
AS BEGIN
  POMIAR = GEN_ID(POMIARYLABOR_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^


/* =========================================================================== */
/* Obsuga komunikacji z NFZ                                                   */
/* Tabele HISTORIAXML oraz POZYCJEHISTORIXML wykorzystywane s dodatkowo       */
/* przy obsudze podpisu elektronicznego                                       */
/* =========================================================================== */

CREATE TABLE INSTALACJE_NFZ(
  KLUCZ          KLUCZ  NOT NULL,   /* z DAJ_KOMUNIKACJENFZ */
  ODDZIAL        DIDENT, 
  NUMER          MALA_NAZWA, /* krtki nr instalacji */
  DLUGI_NUMER    DUZA_NAZWA, /* dugi nr instalacji */
  FIRMA          KLUCZ NOT NULL, /* firma pobierana do faktury */

  WLASCICIEL        KLUCZ, /* wlasciciel instalacji - podmiot finansowy */
  ADR_MAIL_FIRMY    VARCHAR(150),
  ADR_HOST          VARCHAR(150),
  ADR_HOST_POP3     VARCHAR(150),
  ADR_PORT_POP3     VARCHAR(150),
  ADR_LOGIN         VARCHAR(150),
  ADR_HASLO         VARCHAR(150),
  ADR_SWIADCZEN     VARCHAR(150),
  ADR_KOLEJEK       VARCHAR(150),
  ADR_POZ           VARCHAR(150),
  ADR_DEKLARACJI    VARCHAR(150),
  KOD_SWIADCZ VARCHAR(16),

  PRIMARY KEY(KLUCZ),
  FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ));

/* Rekord odpowiada wysanemu/odebranemu komunikatowi NFZ */

CREATE TABLE KOMUNIKACJANFZ
(KLUCZ          KLUCZ NOT NULL,
 KIERUNEK       TYP,            /* W=Wysane, O=Odebrane */
 TYP            VARCHAR(10),    /* Typ komunikatu: */
                                /* SWIAD = wykaz wiadcze */
                                /* P_SWI = potwierdzenie wiadcze */
                                /* RRSWI = rozliczenie wiadcze */
                                /* P_RSW = potwierdzenie rozliczenia */
                                /* DEKL  = wykaz deklaracji POZ */
                                /* P_DEK = potwierdzenie wykazu deklaracji */
                                /* Z_WDP = wyniki weryfikacji deklaracji POZ */
                                /* Z_RDP = rozliczenie deklaracji POZ */
                                /* PORAD = porady lekarskie w POZ */
                                /* P_POR = potwierdzenie porad POZ */
                                /* ZBPOZ = dane zbiorcze o wiadczeniach POZ */
                                /* LIOCZ = listy oczekujcych  itd. */
 NUMER          INTEGER,        /* Jednoznaczny numer komunikatu w ramach typu - zgodny
                                   z numererm w XML */
                                /* Narastajco - przy wysyce program, odbiorze NFZ */
 RODZAJ_NALICZEN TYP; /* 1=ZPOSP(zaopatrzenie ortopedyczne), 2=SWIAD(jak dotychczas - swiadczenia), 3=DEKL */
 DATA_WYSLANIA  TIMESTAMP,
 OKRES_OD       TIMESTAMP,
 OKRES_DO       TIMESTAMP,
 ROK            INTEGER,
 MIESIAC        INTEGER,
 XML            XML2,

 INSTALACJA_NFZ KLUCZ,
 UMOWA_NFZ      KLUCZ,
 ID_SPRAW       INTEGER,

 KLUCZ_DOD      KLUCZ,      /* Aktualnie odwolanie do ObrotyMagazynu dla FZX */

 NAZWAPLIKU     VARCHAR(200) CHARACTER SET DOS852 COLLATE PDOX_PLK,
 ADRESMAIL      VARCHAR(200) CHARACTER SET DOS852 COLLATE PDOX_PLK,
 NUMER_POTW_PRZES  INTEGER, /* przy wczytywaniu potwierdzenia numer potwierdzanej przesyki */

 PRIMARY KEY(KLUCZ));

CREATE INDEX XKOMUNIKACJANFZ_NUMER ON KOMUNIKACJANFZ(NUMER);
CREATE INDEX XKOMUNIKACJANFZ_KLDOD ON KOMUNIKACJANFZ(KLUCZ_DOD);

CREATE GENERATOR KOMUNIKACJANFZ_GEN;
CREATE GENERATOR HISTORIAXML_GEN;
COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_KOMUNIKACJANFZ FOR KOMUNIKACJANFZ
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(KOMUNIKACJANFZ_GEN, 1);
END ^

CREATE PROCEDURE DAJ_KOMUNIKACJENFZ
RETURNS (KOMUNIKACJANFZ INTEGER)
AS BEGIN
  KOMUNIKACJANFZ = GEN_ID(KOMUNIKACJANFZ_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

/* 
Obsluga komunikacji z NFZ poprzez web service 
*/

CREATE TABLE KOMUNIKACJANFZ_WS  
(KLUCZ          KLUCZ NOT NULL,   /* DAJ_KOMUNIKACJENFZ */
 LP             INTEGER NOT NULL, /* od 1 */
 CZAS           TIMESTAMP,
 KOMUNIKACJANFZ KLUCZ,          /* Odwolanie do KOMUNIKACJANFZ - wysane i pobrane lub 0 */
 KIERUNEK       TYP,            /* W=Wysane, O=Odebrane */
 OBSZAR         VARCHAR(15),    /* AMBSZP, LIOCZ, POZ, FZX, UMX, FAKTURA */
 TYP            VARCHAR(10),    /* Typ komunikatu: jak w KOMUNIKACJANFZ */
 WERSJA         VARCHAR(5),
 NFZ_WERSJA     VARCHAR(5),
 ID_NAD         VARCHAR(30),
 ID_INST_NAD    VARCHAR(50),
 NR_GEN         VARCHAR(15),
 OPERACJA       VARCHAR(15),    /* nazwa dania : putFile, getFileStatus, ... */
 POPRAWNOSC     TAKNIE,
 ID_PLIKU       VARCHAR(50),    /* identyfikator wysanego pliku w NFZ */
 FILE_STATUS    VARCHAR(15),    /* 1  Przyjty, oczekuje na przetworzenie */
                                /* 2  Bd przetwarzania pliku przez system */
                                /* 3  Plik przetworzony przez system */
                                /* 4  Plik oznaczony jako usunity  */
								/* 0 - Odebrany w systemie (wewntrzny AXON) */
								/* -1 - nie dotyczy */
 ZWROTKI        UWAGI,          /* wykaz plikw zwrotnych do pobrania */
 UPO            XML2,           /* textload z response */
 JEST_PLIK      TAKNIE,         /* wskaznik odebrania komunikatu (pliku) odpowiedzi */
 NAZWA_PLIKU    VARCHAR(50),    /* nazwa komunikatu odpowiedzi, jesli istnieje */
 TYP_PLIKU      DIDENT,
 PLIK           XML2,           /* komunikat odpowiedzi, jesli istnieje */
 BLAD           UWAGI,  
 
 PRIMARY KEY(KLUCZ, LP));

CREATE INDEX XKOMUNIKACJANFZ_WS_KOM ON KOMUNIKACJANFZ_WS(KOMUNIKACJANFZ);
 


/* Kolejne wersje umowy z NFZ */

CREATE TABLE UMOWY_NFZ
 (KLUCZ            KLUCZ NOT NULL,
  ANEKS            INTEGER NOT NULL,

  NUMER            DUZA_NAZWA NOT NULL,  /* Peny numer NFZ */
  INSTALACJA_NFZ   KLUCZ,
  PIERWOTNY_NUMER  VARCHAR(50),

  ROK              INTEGER,
  ZAKLADY          VARCHAR(500),/* klucze jednostek, oddzielone rednikami, 1-n, w postaci: ';klucz;klucz;... */
  RODZAJ_SWIADCZENIA   DIDENT,  /* Zakres wg NFZ (szpital, specjalistyka, ...) */
  DATA_PODPISANIA  TIMESTAMP,
  DATA_WCZYTANIA   TIMESTAMP,
  WAZNE_OD         TIMESTAMP,
  WAZNE_DO         TIMESTAMP,
  KOD_PLATNIKA     DIDENT,
  XML              XML2,

  WERSJA_GRUPERA_1   NUMER,
  WERSJA_GRUPERA_2   NUMER,
  WERSJA_GRUPERA_3   NUMER,
  WERSJA_GRUPERA_4   NUMER,
  WERSJA_GRUPERA_5   NUMER,
  WERSJA_GRUPERA_6   NUMER,
  WERSJA_GRUPERA_7   NUMER,
  WERSJA_GRUPERA_8   NUMER,
  WERSJA_GRUPERA_9   NUMER,
  WERSJA_GRUPERA_10  NUMER,
  WERSJA_GRUPERA_11  NUMER,
  WERSJA_GRUPERA_12  NUMER;

  UTWORZYL     KLUCZ,
  ZMIENIAL     KLUCZ,
  UTWORZONO    TIMESTAMP,
  ZMIENIANO    TIMESTAMP,

  PRIMARY KEY(KLUCZ, ANEKS));

COMMIT WORK;

/* Grupy_limitowania - limity na kilka produktw na raz - kod_grupy
   z tabeli PRODUKTY_UMOWY
   na razie nie jest wykorzystywane */
   
CREATE TABLE GRUPY_LIMITOWANIA
       (UMOWA_NFZ       KLUCZ NOT NULL,
        ANEKS           INTEGER NOT NULL,
        KOD_GRUPY       INTEGER NOT NULL,

        PRIMARY KEY(UMOWA_NFZ, ANEKS, KOD_GRUPY));


/* PRODUKTY_KONTRAKTU - Definiuje pewien zakres wiadcze z punktu widzenia
   NFZ w ramach roku. Produkty powtarzaj si w kolejnych latach. Dodatkowo
   pole wyrnik rnicuje produkty - np dla rnych jednostek ten sam
   produkt z innym wyrnikiem  */

/* Wtpliwo - ten sam produkt w rnych oddziaach moe by rnie limitowany ?
   a tutaj brak odniesienia do umowy, kod_platnika nie jest uywany - ustalono
   uywanie podczas odczytu umowy kodu patnika przy generowaniu sownika produktw */

CREATE TABLE PRODUKTY_KONTRAKTU
       (KLUCZ          KLUCZ NOT NULL, /* PRODUKT w Produkty_umowy */
        ID_TABELI_PROD VARCHAR(5),  /* nieaktualne - dotyczy XSP */
        KOD_PROD       MALA_NAZWA,
        NAZWA_PROD     VARCHAR(200) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        KOD_PLATNIKA   DIDENT,    /* oddzia NFZ - numeracja bez pocztkowych zer*/
        ROK            INTEGER,
        STATUS_AKT     TAKNIE,    /* ustawiany przy wczytywaniu umowy - ??? */
        DATA_MOD       TIMESTAMP,      /* stare - XSP */ 
        ZAKLAD         VARCHAR(4),/* pobierany z XML, odpowiada polu ZAKLADY.SYMBOL */
        WYROZNIK       INTEGER,   /* dodatkowe zrnicowanie produktu - nie uywa,
                                     wane w produkty_umowy */

        OKRES_ROZL       TYP,     /* w jakich okresach rozliczanie limitowane narastajco : R=rok, P=p roku, K=kwarta, M=miesic */
        OKRES_SPRAW      TYP,     /* za jakie okresy maj by wystawiane rachunki */
        SCHEMAT_ROZL     DIDENT,  /* sposb rozliczenia: */
                                  /* PWYK= za wykonanie, bez limitw */
                                  /* PLNR= limity narastajco w okresie rozliczeniowym */
                                  /* PLBN= limity zgodne z okresem sprawozdawczym, bez uznania nadwykona i niedowykona */
        TRYB_REALIZACJI  TYP,     /* A=ambulatoryjnie, S=stacjonarnie, D=dowolnie */
        JEDN_ROZLICZ     IDENT,   /* kod jednostki rozliczeniowej - na wszelki wypadek ??? */
        KALKULACJA_KOSZT TAKNIE,  /* czy wymagana kalkulacja kosztw dla pacjentw z UE */
        RYCZALT          TAKNIE,
        TRYB_HOSP        TYP,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(KLUCZ));

COMMIT WORK;

/* wiadczenia zdrowotne, mog dotyczy wielu lat, ale mog by uzupeniane z umowy */

CREATE TABLE SWIADCZENIA
       (KLUCZ         KLUCZ NOT NULL,
        SYMBOL        MALA_NAZWA,
        NAZWA         VARCHAR(2000),
        POZ_TYP       IDENT,            /* ustawiane rcznie - ADMIN - wskanik do zbiorczego zestawienia NFZ*/
        AKTYWNE       TAKNIE,           /* ustawiane rcznie - ADMIN */

        KOD_DOD_NFZ   SYMBOL,           /* do rozliczenia zbiorczego wg. tego kodu */

        ID_TAB_PROD_JEDN VARCHAR(8),    /*id tabeli w PS*/
        KOD_PROD_JEDN    VARCHAR(10),   /*numer produktu w PS*/

        DO_RAPORTU      TAKNIE,  /* czy idzie do raportu statystycznego */
        SCHEM_LECZ      TAKNIE,  /* czy wymagany jest schemat leczenia - chemioterapia lub program terapeutyczny */
        SCHEM_KROTN     IDENT,   /* ile razy moe by wykonany w ramach kontaktu : */
                                 /* K1=tylko raz */
                                 /* KN=1-n razy, podane przez uytkownika */
                                 /* OB=osobodzie bez dnia koca realizacji wiadczenia, chyba e tylko 1 dzie */
                                 /* OZ=osobodzie cznie z dniem koca realizacji wiadczenia */
        SCHEM_ROZL_MIES TYP,     /* w ktrym miesicu rozliczenie: */
                                 /* E=koniec epizodu (hospitalizacji) */
                                 /* K=koniec kontaktu (pobytu na oddziale) */
                                 /* P=koniec wykonania produktu */

        SPRAWDZANIEDEKLARACJI IDENT,  /* X-wszystkie, L-lekarze, P - pielgniarki, O - poone, S - medycyna szkolna */

        ROZL_OSOBODNI TYP,       /* ustawiane w programie : 1 - w szpitalu, 2 - przepustka,
                                    3 - w szpitalu powyzej limitu, 4 - przepustka powyzej limitu, 5,6,7,8 - dla mlodziezy */ 

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE INDEX SWIADCZENIA_XSYMBOL      ON SWIADCZENIA(SYMBOL);

/* Punkty do wiadcze w ramach roku */

CREATE TABLE PUNKTY_SWIADCZEN
       (SWIADCZENIE   KLUCZ NOT NULL,
        ROK           INTEGER NOT NULL,
        ID_PAKIETU    INTEGER NOT NULL,    /* dowizanie do PRODUKTY_UMOWY */
        PUNKTY        WARTOSC,
        NAZWA         VARCHAR(2000),      /* przeniesione z opisu wiadczenia */

        DATA_OD	TIMESTAMP NOT NULL,
        DATA_DO	TIMESTAMP,
        STATUS_AKT     TAKNIE NOT NULL,   /* Faktycznie A - aktualny, N - nie */

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY (SWIADCZENIE, ROK, ID_PAKIETU));

/* Uzupeniane przy czytaniu umowy, mo dotyczy wielu lat, do modyfikacji    */
/* z programu                                                                  */
/* Teoretycznie moliwe jest, e zakad przestanie wykonywa dane wiadczenie  */
/* w kolejnych latach - rczna ingerencja                                      */

/* Do rozwaenia jak zautomatyzowa usuwanie nieaktualnych */

CREATE TABLE SWIADCZENIA_ICD_10
  (SWIADCZENIE  KLUCZ NOT NULL,
   ROZPOZNANIE  VARCHAR(6) CHARACTER SET DOS852 NOT NULL,
   
   PRIMARY KEY(SWIADCZENIE, ROZPOZNANIE),
   FOREIGN KEY(SWIADCZENIE) REFERENCES SWIADCZENIA(KLUCZ));


   
CREATE TABLE SWIADCZENIA_ZAKLADU
       (ZAKLAD        KLUCZ NOT NULL,
        SWIADCZENIE   KLUCZ NOT NULL,

        FOREIGN KEY(SWIADCZENIE) REFERENCES SWIADCZENIA(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

/* Podwizanie do produktw kontraktu - w ramach roku, pr.kontr. jest na konkretny rok */

CREATE TABLE SWIADCZENIA_PRODUKTU
  (PRODUKT             KLUCZ NOT NULL,
   SWIADCZENIE         KLUCZ NOT NULL,

  FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY_KONTRAKTU(KLUCZ),
  FOREIGN KEY(SWIADCZENIE) REFERENCES SWIADCZENIA(KLUCZ));



/* Produkty umowy - limity miesiczne dla konkretnej umowy */

CREATE TABLE PRODUKTY_UMOWY
  (KLUCZ    KLUCZ NOT NULL,
   UMOWA    KLUCZ NOT NULL,
   ANEKS    INTEGER NOT NULL,
   PRODUKT  KLUCZ NOT NULL,       /* odwoanie do PRODUKTY_KONTRAKTU */
   KOD_GRUPY  INTEGER,            /* grupy_limitowania ??? */
   ID_PAKIETU INTEGER NOT NULL,   /* na okoliczno zmiany punktacji - PUNKTY_SWIADCZEN */
   WYROZNIK  INTEGER,             /* odpowiada wyrnikowi PRODUKTY_KONTRAKTU - uwaga inny typ */

   MIESIAC  INTEGER,
   ILOSC    WARTOSC,
   CENA     WARTOSC,

   UTWORZYL     KLUCZ,
   ZMIENIAL     KLUCZ,
   UTWORZONO    TIMESTAMP,
   ZMIENIANO    TIMESTAMP,

   PRIMARY KEY(KLUCZ),
   FOREIGN KEY(UMOWA, ANEKS) REFERENCES UMOWY_NFZ(KLUCZ, ANEKS),
   FOREIGN KEY(PRODUKT)      REFERENCES PRODUKTY_KONTRAKTU(KLUCZ));

COMMIT WORK;

CREATE GENERATOR UMOWY_GEN;
COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_PRODUKTY_UMOWY FOR PRODUKTY_UMOWY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UMOWY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_PRODUKTY_UMOWY
RETURNS (PRODUKT_UMOWY INTEGER)
AS BEGIN
  PRODUKT_UMOWY = GEN_ID(UMOWY_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

/* limity dla zakadW w ramach produktu */
/* suma limitw nie moe przekroczy wartoci pola PRODUKTY_UMOWY.ILOSC */
/* jeli limit = 0, to limit tylko na produkt, a nie na zakad */
/* moliwe, e limit na zakad bdzie podany w % wzgldem limitu na produkt */

CREATE TABLE KOMORKI_PRODUKTU
  (PRODUKT_UMOWY   KLUCZ NOT NULL,     /* W produkcie_umowy jest umowa i miesic */
   ZAKLAD          KLUCZ NOT NULL,

   ILOSC           WARTOSC,
   BO_ROZLICZONO   WARTOSC,
   AKTUALNE        TAKNIE,

   DATA_OD	TIMESTAMP,
   DATA_DO	TIMESTAMP,
   KOD_MIEJSCA_WYK	NUMER,
   KOD_REJONU	SYMBOL,
   KOD_RES_9	SYMBOL,
   KOD_RES_10	IDENT,

   UTWORZYL     KLUCZ,
   ZMIENIAL     KLUCZ,
   UTWORZONO    TIMESTAMP,
   ZMIENIANO    TIMESTAMP,

   PRIMARY KEY(PRODUKT_UMOWY, ZAKLAD),
   FOREIGN KEY(PRODUKT_UMOWY) REFERENCES PRODUKTY_UMOWY(KLUCZ),
   FOREIGN KEY(ZAKLAD)        REFERENCES ZAKLADY(KLUCZ));

COMMIT WORK;

/* --- */

CREATE TABLE SPEC_ROZLICZENIE                 /* SOWNIK SPECJALNEGO ROZLICZENIA */
       (KOD          VARCHAR(15) NOT NULL,
        NAZWA        VARCHAR(250),

        PRIMARY KEY(KOD) );

CREATE TABLE SPEC_ROZLICZENIE_WSP
       (KOD          VARCHAR(15) NOT NULL,
	    LP           INTEGER NOT NULL,  
        DATA_OD      TIMESTAMP,
        DATA_DO      TIMESTAMP,
		WIEK_OD      INTEGER,
		WIEK_DO      INTEGER,
		WSPOLCZYNNIK WARTOSC,

        PRIMARY KEY(KOD, LP) );

/* --- */

/* wiadczenia pacjenta - podwizanie do umowy nastpuje przy wyliczaniu wykonania */
/* na podstawie opisu produktw i podczepionych pod nie wiadcze */

CREATE TABLE SWIADCZENIA_PACJENTA
       (KLUCZ           KLUCZ NOT NULL,
        PACJENT         KLUCZ NOT NULL,
        POBYT           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        WIZYTA          INTEGER,  /* Roszerzenie pobytu w gabinecie, oddziale */
        ID_UPRAW        KLUCZ,    /* Dla dodatkowych ubezpiecze - tabela UPRAWNIENIA */

        INSTALACJA      NR_INSTALACJI,
        ID_SWIADCZENIA  MALA_NAZWA,

        UMOWA_NFZ       KLUCZ,    /* Domylnie proponowana przez program gdy jedna -
                                     wg produkty_kontraktu i produkty_umowy */
        STATUS_NFZ      IDENT,    /* Jak w HistoriaXML */
        ORYGINAL        KLUCZ,    /* Klucz do oryginalnego wiadczenia w przypadku korekty */

        BLOKADANFZ      TAKNIE,   /* Zablokowanie wysyki do nfz - bez wzgldu na warto pola DoKasy i Anulowano */

        PUNKTY_BAZOWE   WARTOSC,
        WERSJA_GRUPERA  NUMER,

        DOKASY          TAKNIE,
        ILOSC           INTEGER,
        PUNKTY          WARTOSC,

        SWIADCZENIE     KLUCZ,

        HISTORIAXML     KLUCZ,
        LP_AKTUALNE     INTEGER,   /* ostatnie dla tego wiadczenia w pozycje historii */
        ANULOWANO       TAKNIE,

        PRODUKT KLUCZ,             /* PRODUKTY_KONTRAKTU */
        DATA_OD TIMESTAMP,
        DATA_DO TIMESTAMP,

        WYROZNIK     INTEGER,      /* z PRODUKTY_UMOWY - przy braku 0 */

        KOSZT        WARTOSC,

        SCHEMAT_CHEM       INTEGER,
        DZIEN_PODANIA_CHEM INTEGER,
        TYP_PARAM_CHEM     TYP,
        WART_PARAM_CHEM    WARTOSC,
        DNI_LEK_DO_DOMU    INTEGER,     /* na ile dni wydano leki do domu przy chemioterapii */
        PRODUKT_CHEMII     INTEGER,

        FL_LEK_DO_DOMU     TAKNIE,
        KOSZT_UE           WARTOSC,
        FL_RATUJACE_ZYCIE  TAKNIE,

        SPEC_ROZL          IDENT,
		SPEC_ROZL_WSP      WARTOSC,         

        MODYFIKATOR        VARCHAR(10),
		MODYF_WARTOSC      WARTOSC,

        WSPOLCZYNNIK       WARTOSC,
        PUNKTY_BEZ_WSP     WARTOSC,

        ILOSC_ROZL         ILOSC,
        OPLATA_PACJENTA    WARTOSC,
        GRUPA_SUBST_CHEM   MALA_NAZWA,
        ILOSC_SUBST_CHEM   ILOSC,
        STOMATOLOGIA_TYP   TYP,        /* umiejscowienie wykonania wiadczenia */
        STOMATOLOGIA_KOD   IDENT,
        STOMATOLOGIA_POW   MALA_NAZWA,

        DIALIZA_PAC_TYP    TYP,     /*  0  pacjent stale leczony w stacji dializ
                                        1  pacjent gocinny */
        DIALIZA_HEMOGL     WARTOSC, /* stenie hemoglobiny w g/dl */

        LEK_RODZAJ         TYP,     /* puste(nie podano leku); 1  Epoetinum;
  2  Darbepoetinum; 3  Mircera */
        LEK_JM             TYP,     /* 1  j.m. ; 2  mg */
        
        LEK_ILOSC          WARTOSC,

        POZ_BARTHEL        INTEGER,  /* kwalifikacja pacjenta do objcia opieka rodowiskow - wg zmodyfikowanej skali Barthel */
        POZ_KWALIFIKACJA   TAKNIE,
        POZ_OPIEKA_DO      TIMESTAMP,
        POZ_EFEKTY_PROG    DUZY_OPIS, /* kody efektw programu profilaktycznego, 4-cyfrowe oddzielone rednikami */

        WART_PARAM_CHEM_MASA  WARTOSC,
        OC_STATUS          TYP,       /*Z  zgoszenie zapytania o moliwo rozliczenia z tytuu OC */
        OC_NR_PISMA        MALA_NAZWA,
        NFZ_ZGODA_PLATNIKA_TYP IDENT,
        NFZ_ZGODA_PLATNIKA MALA_NAZWA,
        DOD_DOKUMENTACJA   DUZY_SYMBOL,

        SPO_BARTHEL  INTEGER,
        SPO_GLASGOW  INTEGER,
        DOD_DOKUMENTACJA_KOD  DUZY_SYMBOL,

        CECHY_OAIIT  DUZY_OPIS,

        OK_ZACMA      TAKNIE,    /* lewe */
        OK_DIOPTRIE   WARTOSC,
        OK_PEKNIECIE  TAKNIE,
        OK_ZAPALENIE  TAKNIE,

        OK_ZACMA_PRAWE      TAKNIE,
        OK_DIOPTRIE_PRAWE   WARTOSC,
        OK_PEKNIECIE_PRAWE  TAKNIE,
        OK_ZAPALENIE_PRAWE  TAKNIE,

        JGP_ICD9     VARCHAR(15),
        TYDZ_CIAZY   INTEGER,

        NR_WERSJI    INTEGER,
        DATA_WERSJI  TIMESTAMP,

        REJESTRACJANFZ     
		TAKNIE,  /* Na tak, jeli kiedykolwiek zostalo poprawnie potwierdzone w NFZ I faz */
        POPRAWNOSC_ST_NFZ  TAKNIE,  /* Ostatnie potwierdzenie I fazy - status poprawny lub bledny */
        BLEDY_NFZ          DUZY_OPIS, /* 4-znakowe kody bledow rozdzielone srednikami */
        SPRAWDZONO_NFZ     TIMESTAMP,  /* Czy obsluzono pole BLEDY_NFZ : null - nie byo, data do porwnania ze ZMIENIANO */

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(SWIADCZENIE) REFERENCES SWIADCZENIA(KLUCZ));

CREATE  INDEX SW_PACJENTA_XHISTORIAXML ON SWIADCZENIA_PACJENTA(HISTORIAXML);
CREATE  INDEX SW_PACJENTA_PRODUKT ON SWIADCZENIA_PACJENTA(PRODUKT, DATA_DO);

/* Tablica wskanikowa odwolujca si do Swiadczenia_pacjenta coby nie tworzy danych o zmianach */

CREATE TABLE BLEDY_PORTALU
       (POBYT        KLUCZ NOT NULL,
        WIZYTA       INTEGER NOT NULL,
        SWIAD_PAC    INTEGER NOT NULL,
        OPIS         PARAMETRY,
        PRIMARY KEY(POBYT, WIZYTA, SWIAD_PAC) );
        
/* ---*/

CREATE TABLE FAKTURY_SWIADCZENIA_PACJENTA
  (SWIADCZENIE_PACJENTA        KLUCZ NOT NULL,
   POZYCJA_OBROTU              KLUCZ NOT NULL,   /* przychod leku */
   ILOSC_SUBST_CZ              WARTOSC,          /* w jednostkach ewidencyjnych */

   PRIMARY KEY(SWIADCZENIE_PACJENTA, POZYCJA_OBROTU),
   FOREIGN KEY(SWIADCZENIE_PACJENTA) REFERENCES SWIADCZENIA_PACJENTA(KLUCZ),
   FOREIGN KEY(POZYCJA_OBROTU) REFERENCES POZYCJAOBROTU(KLUCZ)
  );

/*---*/

CREATE TABLE UPRAWNIENIA
 (KLUCZ                    KLUCZ NOT NULL,  /* jak dla pobytow */
  POBYT                    KLUCZ,
  WIZYTA                   INTEGER,
  IDENT                    INTEGER,
  LP                       INTEGER,
  DOK_UBEZP_PANSTWO        IDENT,
  DOK_UBEZP_TYTUL_UBEZP    IDENT,   /* tytu uprawnienia */
  DOK_UBEZP_TYP_INSTYTUCJI TYP,             /* N=NFZ, G=Gmina, I=inna, P=penopatny */
  DOK_UBEZP_ODDZIAL_NFZ    IDENT,           /* dla typ = N */
  DOK_UBEZP_GMINA          KOD_TERYT,       /* dla typ = G */
  DOK_UBEZP_GMINA_ORGAN    OPIS,
  DOK_UBEZP_FIRMA_KOD      NUMER,           /* dla typ = I*/
  DOK_UBEZP_FIRMA_AKRONIM  SYMBOL,
  DOK_UBEZP_FIRMA_CWU      DUZY_SYMBOL,

  DOK_UBEZP_TYP_DOKUM      TYP,             /* K=karta, D=decyzja wjta, U=dok. UE, Z-ekuz, C=certyfikat, P=powiadczenie, E=druk E*/
  DOK_UBEZP_RODZAJ_E       DIDENT,          /* rodzaj druku E */
  DOK_UBEZP_NUMER          DUZY_SYMBOL,
  DOK_UBEZP_DATA_WYST      TIMESTAMP,
  DOK_UBEZP_DATA_OD        TIMESTAMP,
  DOK_UBEZP_DATA_DO        TIMESTAMP,
  DOK_UBEZP_PODMIOT        DUZY_OPIS,
  DOK_UBEZP_NPWZ           NUMER,
  DOK_UBEZP_NAZWA          DUZY_OPIS, 

        DOK_UBEZP_NIP         NIP,     /* nieuzywane */
        DOK_UBEZP_MIESIAC     INTEGER,
        DOK_UBEZP_ROK         INTEGER,
        DOK_UBEZP_ZUS         DIDENT, /* ZUS, KRUS, MSWiA, MON,SP */
        DOK_UBEZP_ZGLOSZENIE  IDENT,  /* ZUA, ZZA, ZCNA */
        DOK_UBEZP_ID          MALA_NAZWA, /* nieuzywane */
        DOK_UBEZP_OSW_TYP     TYP,
        DOK_UBEZP_OSW_PDST    TYP,

        DOK_UBEZP_POCZATEK    TIMESTAMP,
        DOK_UBEZP_KONIEC      TIMESTAMP,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

  PRIMARY KEY(KLUCZ) );

CREATE INDEX UPRAWNIENIA_XPOBYT ON  UPRAWNIENIA(POBYT, WIZYTA, LP);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_UPRAWNIENIA FOR UPRAWNIENIA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(POBYTY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_UPRAWNIENIA
RETURNS (KLUCZ INTEGER)
AS BEGIN
  KLUCZ = GEN_ID(POBYTY_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/* Rozliczenie wiadcze - tworzone po I Fazie, czy wykonane wiadczenie z umow
   dla danego SWIADCZENIA_PACJENTA w kolejnych miesicach mog wystpi rekordy
   wczeniejsze - nadwyka, ostatni ew. rozliczenie */

CREATE TABLE ROZLICZENIA_SWIADCZEN
 (HISTORIA_XML         KLUCZ NOT NULL,
  UMOWA_NFZ            KLUCZ NOT NULL,
  PRODUKT              KLUCZ NOT NULL,
  SWIADCZENIE_PACJENTA KLUCZ NOT NULL,
  WYROZNIK             INTEGER,
  POPRAWNOSC           IDENT;            /* 00-poprawne (oryginal), 01-storno z programu,
                                            02-negatywna weryfikacja, 03-zmniejszenie limitu umowy,
                                            04-koniecznosc rozl.sw.o wyzszym priorytecie */
  WERSJA_SWIADCZENIA   INTEGER NOT NULL, /* nie oznacza wielu rekordw lecz aktualna
                                          wersja wysyki wiadczenia - ewentualne zmiany SWIADCZENIA_PACJENTA */
  MIESIAC              INTEGER NOT NULL,
  STATUS               TYP,            /* R = rozliczone, N = nadwyka, Z = zignorowane (wykonane, nie do rozliczenia) */
  NR_WERSJI            INTEGER,        /* kolejny rekord rozliczenia */
  OSTATNIA_WERSJA      TAKNIE,         /* gdy rozliczone to zawsze ostatnia_wersja = T */

  SZABLON_RACHUNKU     INTEGER,        /* pobierany z NFZ - NOT NULL - do zapaty */
  TYP_RACH_NFZ         IDENT,          /* 1-ubezpieczeni, 2-koordynacja, 3-zgoda wjta, 4-art.2 ust.1 pkt 3, 5-8 - bezpatnie wg art.12, 9-nieubezpieczeni uprawnieni, 10-OC */
  SZABLON_KOR          INTEGER,        /* Identyfikator szablonu korygowanego */
  TYP_DOKUMENTU        TYP,            /* 1-rachunek, 2-korekta */ /* od I.2012 dodatkowo: 3-rachunek do ugody, 4-korekta do ugody */

  ILOSC_ROZL           WARTOSC,

  PUNKTY_ROZL            WARTOSC,
  CALKOWITA_ILOSC_DNI    INTEGER,
  FINANSOWANA_ILOSC_DNI  INTEGER,
  WERSJA_ZESTAWU         INTEGER,
  ANEKS_UGODOWY          DUZA_NAZWA,

  NR_KOMUNIKATU        INTEGER NOT NULL,

 PRIMARY KEY (UMOWA_NFZ, SWIADCZENIE_PACJENTA, WERSJA_SWIADCZENIA, MIESIAC),
 FOREIGN KEY (HISTORIA_XML) REFERENCES HISTORIAXML (KLUCZ),
 FOREIGN KEY (PRODUKT) REFERENCES PRODUKTY_KONTRAKTU (KLUCZ),
 FOREIGN KEY (SWIADCZENIE_PACJENTA) REFERENCES SWIADCZENIA_PACJENTA (KLUCZ)
);

CREATE INDEX XROZL_SWIAD_UMOWAMIES ON ROZLICZENIA_SWIADCZEN(UMOWA_NFZ, MIESIAC, SZABLON_RACHUNKU);

/* --- */

CREATE TABLE ROZLICZENIA_TRANSPORTU_POZ
  (UMOWA_NFZ          KLUCZ NOT NULL,
   PRODUKT            KLUCZ NOT NULL,
   WYROZNIK           INTEGER NOT NULL,
   SWIADCZENIE        KLUCZ NOT NULL,
   SZABLON_RACHUNKU   INTEGER,
   SZABLON_KOR        INTEGER,
   TYP_RACH_NFZ       IDENT,
   TYP_DOKUMENTU      TYP,
   MIESIAC            INTEGER NOT NULL,   
   NR_KOMUNIKATU      INTEGER NOT NULL,
   ID_SWD_POW         DUZY_SYMBOL,
   UMOWA_POW          DUZA_NAZWA,
   ILOSC              WARTOSC,
   WSP_KORYGUJACY     WARTOSC,

   PRIMARY KEY (UMOWA_NFZ, PRODUKT, WYROZNIK, SWIADCZENIE, MIESIAC, SZABLON_RACHUNKU));


COMMIT WORK;

/* --- */

CREATE TABLE ROZLICZENIA_SIMP
 (UMOWA_NFZ            KLUCZ NOT NULL,
  PRODUKT              KLUCZ NOT NULL,
  SWIADCZENIE_SIMP     KLUCZ NOT NULL,
  WERSJA_SWIADCZENIA   INTEGER NOT NULL, 

  WYROZNIK             INTEGER,
  POPRAWNOSC           IDENT,            /* 00-poprawne (oryginal), 01-storno z programu, */
                                         /* 02-negatywna weryfikacja, 03-zmniejszenie limitu umowy, */
                                         /* 04-koniecznosc rozl.sw.o wyzszym priorytecie */
  MIESIAC              INTEGER NOT NULL,
  SZABLON_RACHUNKU     INTEGER,        /* pobierany z NFZ - NOT NULL - do zapaty */
  TYP_RACH_NFZ         IDENT,          /* 1-ubezpieczeni, 2-koordynacja, 3-zgoda wjta, 4-art.2 ust.1 pkt 3, 5-8 - bezpatnie wg art.12, 9-nieubezpieczeni uprawnieni, 10-OC */
  SZABLON_KOR          INTEGER,        /* Identyfikator szablonu korygowanego */
  TYP_DOKUMENTU        TYP,            /* 1-rachunek, 2-korekta */ /* od I.2012 dodatkowo: 3-rachunek do ugody, 4-korekta do ugody */

  ILOSC_ROZL           WARTOSC,

  PUNKTY_ROZL            WARTOSC,
  WERSJA_ZESTAWU         INTEGER,
  ANEKS_UGODOWY          DUZA_NAZWA,

  NR_KOMUNIKATU        INTEGER NOT NULL,

 PRIMARY KEY (UMOWA_NFZ, SWIADCZENIE_SIMP, WERSJA_SWIADCZENIA, MIESIAC),
 FOREIGN KEY (PRODUKT) REFERENCES PRODUKTY_KONTRAKTU (KLUCZ));

CREATE INDEX XROZL_SIMP_UMOWAMIES ON ROZLICZENIA_SWIADCZEN(UMOWA_NFZ, MIESIAC, SZABLON_RACHUNKU);


/* --- */



/* 1 rekord odpowiada caej hospitalizacji ,wizycie w gabinecie lub deklaracji pacjenta */

CREATE TABLE HISTORIAXML
(KLUCZ                KLUCZ NOT NULL,
 PACJENT              KLUCZ NOT NULL,
 POBYT                KLUCZ NOT NULL, /* Pobyty.klucz (dla typ=S, A, I) */
                                      /* 0 (dla typ = D) */
 WIZYTA               INTEGER, /* Dla szpitala zawsze 0 , dla przychodni z RuchPrzychodni */
 TYP                  TYP,     /* S=pobyt w szpitalu, A=wizyta w gabinecie */
                               /* D=deklaracje, I=izba przyj - odmowa przyjcia ... */  
 STATUS_NFZ           IDENT,   /* Aktualny status - z ostatniego rekordu PozycjeHistoriiXML */
                               /* =Brak, WS=Wyslane sprawozdanie, I faza */
                               /* PS=potwierdzone sprawozdanie, */
                               /* WR=wysane rozliczenie, II faza */
                               /* PR=Potwierdzone rozliczenie, */
                               /* WD=wysane deklaracje, */
                               /* PD=Potwierdzone deklaracje, */
                               /* WRD=Weryfikacja deklaracji, */
                               /* RD=Rozliczenie deklaracji */
                               /* UD=Wczytanie stanu deklaracji z XSP */
                               /* ... */
 WYSYLKA_PO_II_FAZIE  TAKNIE,
 STATUS_PE            TAKNIE,  /* T=podpisane, N=niepodpisane. Warto T dotyczy take czciowych podpisw */
 OSTATNI_LP_PE        INTEGER,
 OSTATNI_LP_NFZ       INTEGER,
 OSTATNIA_ZMIANA      TIMESTAMP,  /* Jakiekolwiek zmiany w rekrodach dotyczcych pobytu */
                             /* zapis natychmiast po dokonaniu tych zmian */
 OSTATNIA_ZMIANA_ROZL TIMESTAMP,  /* j.w. dotyczy zmian majacych wpyw na rozliczenie z NFZ */
 OSTATNIO_WYSLANE     TIMESTAMP,
 OSTATNIO_PODPISANE   TIMESTAMP,  /* Tylko dla caociowego podpisu */
 USUNIETE             TAKNIE,

 STATUS_JGP           IDENT,        /* ZG=dane dla grupera NFZ, OG - odpowied grupera, RG - dane robocze grupera, WG - wasne grupowanie */
 OSTATNI_LP_JGP       INTEGER,
 CZY_GRUPOWAC         TAKNIE,
 OSTATNIO_GRUPOWANE   TIMESTAMP,         /* tu data utworzenia zapytania, przy odpowiedzi nie ruszamy */

 PRIMARY KEY(KLUCZ));

CREATE INDEX XHISTORIAXML_POBYT ON HISTORIAXML(PACJENT, POBYT, WIZYTA, TYP);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_HISTORIAXML FOR HISTORIAXML
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(HISTORIAXML_GEN, 1);
END ^

CREATE PROCEDURE DAJ_HISTORIEXML
RETURNS (HISTORIAXML INTEGER)
AS BEGIN
  HISTORIAXML = GEN_ID(HISTORIAXML_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^



/* Historia zmian w hospitalizacji, wizycie, deklaracjach, */
/* listach oczekujcych, e-podpisie  */
CREATE TABLE POZYCJEHISTORIXML
(HISTORIAXML          KLUCZ NOT NULL,
 LP                   INTEGER NOT NULL,
 WIZYTA               INTEGER,    /* Dla podpisu elektronicznego */
 RODZAJ               IDENT,      /* NFZ, PE (podpis elektroniczny), JGP */

 TYP_DANYCH      IDENT,    /* Dla podpisu elektronicznego */
                           /* 1-szy znak: S-szpital, A-ambulatorium, I-izba przyj */
                           /* 2-gi: grupa danych: P-procedura, R-swiadczenie, Z-zlecenia */
                           /* 3-ci: podgrupa: np. L-leki, B-laboratorium, O-operacja (tylko L-leki, P-procedura) */
 KLUCZ_DANYCH  KLUCZ,      /* podpis caoci - pole puste, czciowy - klucz do elementu podpisywanego (procedury, wiadczenia itd.) */
 OSTATNIA_ZMIANA      TIMESTAMP,  /* Jakiekolwiek zmiana dla podpisu, w pozostalych przypadkach bdzie czas utworzenia */

 DEKLARACJA           KLUCZ,
 WERSJA_DEKLARACJI    INTEGER,

 ROK                  INTEGER,  /* rok i miesic istotne jedynie dla weryfikacji deklaracji */
 MIESIAC              INTEGER,
 DATA_ZG_PRZEN        TIMESTAMP,
 KOD_WERYFIKACJI      NUMER,

 WERSJA_POBYTU        INTEGER,    /* Zmieniane kadorazowo po wysyce I fazy, gdy nowe/modyfikowane dane statystyczne */
 WERSJA_SWIADCZENIA   INTEGER,
 WERSJA_ROZL_POBYTU   INTEGER,    /* Zmieniane kadorazowo podczas wysyki I fazy gdy nowe/modyfikowane dane rozliczeniowe */

 NR_KOMUNIKATU        INTEGER,    /* Numer komunikatu (KOMUNIKACJANFZ.KLUCZ), jeli nie wysano = 0 */
 OSTATNI_NR_KOMUNIKATU INTEGER,
 OPIS_KOMUNIKATU      IDENT,      /* tak jak HistoriaXML.status_nfz, ... */
 POPRAWNOSC           TAKNIE,     /* T=poprawne, N=z bdami, =nie dotyczy */
 XML                  XML2,       /* jeli podpis to podpisywana historia */
                                  /* jeli wysyka, to zawarto wysyki */
                                  /* jeli potwierdzenie to ewentualne bdy */
 PODPIS               UWAGI,      /* jeli podpis to tre podpisu */
 ZNACZNIK_CZASU       TIMESTAMP,

 ILOSC_GRUP           INTEGER,

 UTWORZYL             KLUCZ,
 UTWORZONO            TIMESTAMP,

 PRIMARY KEY(HISTORIAXML, LP),
 FOREIGN KEY(HISTORIAXML) REFERENCES HISTORIAXML(KLUCZ));

COMMIT WORK;

CREATE INDEX HISTORIAXML_DEKLARACJE ON POZYCJEHISTORIXML(DEKLARACJA, OPIS_KOMUNIKATU, ROK, MIESIAC);

/*---*/

/* ATYP : S=pobyt w szpitalu, A=wizyta w gabinecie */
/*        D=deklaracje, I=izba przyjec - odmowa przyjecia ... */  

SET TERM ^ ;

CREATE PROCEDURE WYSYLKI_XML(
  APACJENT   INTEGER,
  APOBYT     INTEGER,
  AWIZYTA    INTEGER,
  ATYP       VARCHAR(1)
  )
RETURNS(
  HISTORIAXML           INTEGER,
  STATUS_NFZ            VARCHAR(3),
  OSTATNIA_ZMIANA       TIMESTAMP,
  OSTATNIA_ZMIANA_ROZL  TIMESTAMP,
  OSTATNIA_WYSYLKA      TIMESTAMP,
  POPRAWNOSC            VARCHAR(1),

  WERSJA_POBYTU         INTEGER,
  WERSJA_ROZLICZENIOWA  INTEGER
  )
AS
DECLARE VARIABLE OSTATNI_LP_NFZ  INTEGER;
DECLARE VARIABLE LP_NFZ_POZ      INTEGER;
BEGIN

  HISTORIAXML = NULL;
  WERSJA_POBYTU         = 0;
  WERSJA_ROZLICZENIOWA  = 0;

  FOR SELECT H.KLUCZ, H.STATUS_NFZ, H.OSTATNIA_ZMIANA,
    H.OSTATNIA_ZMIANA_ROZL, H.OSTATNIO_WYSLANE, H.OSTATNI_LP_NFZ
  FROM HISTORIAXML H
  WHERE H.TYP = :ATYP AND H.PACJENT = :APACJENT AND
    H.POBYT = :APOBYT AND H.WIZYTA = :AWIZYTA
  INTO :HISTORIAXML, :STATUS_NFZ, :OSTATNIA_ZMIANA,
    :OSTATNIA_ZMIANA_ROZL, :OSTATNIA_WYSYLKA, :OSTATNI_LP_NFZ
  DO BEGIN

  FOR SELECT P.POPRAWNOSC, P.WERSJA_POBYTU, P.WERSJA_ROZL_POBYTU, P.LP
  FROM POZYCJEHISTORIXML P
  WHERE P.HISTORIAXML = :HISTORIAXML
    AND NOT P.OPIS_KOMUNIKATU = 'PR' and p.opis_komunikatu is not null and
    p.lp = (select max(px.lp) from pozycjehistorixml px
            where px.historiaxml = p.historiaxml and
            Px.OPIS_KOMUNIKATU in ('WS', 'PS') and px.opis_komunikatu is not null)
  INTO :POPRAWNOSC, :WERSJA_POBYTU, :WERSJA_ROZLICZENIOWA, :LP_NFZ_POZ
  DO BEGIN
  END

  END
  IF (:OSTATNIA_ZMIANA_ROZL IS NULL)  THEN OSTATNIA_ZMIANA_ROZL = '30-DEC-1899';
  IF (:OSTATNIA_WYSYLKA IS NULL)      THEN OSTATNIA_WYSYLKA     = '30-DEC-1899';
/*  IF (:LP_NFZ_POZ <> :OSTATNI_LP_NFZ) THEN POPRAWNOSC = 'N'; */
  IF (:POPRAWNOSC IS NULL) THEN POPRAWNOSC = 'N';

  IF (:HISTORIAXML IS NULL)
  THEN BEGIN
    HISTORIAXML           = 0;
    STATUS_NFZ            = '';
    POPRAWNOSC            = 'N';

    OSTATNIA_ZMIANA       = '30-DEC-1899';
    OSTATNIA_ZMIANA_ROZL  = '30-DEC-1899';
    OSTATNIA_WYSYLKA      = '30-DEC-1899';

  END

  SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^


/*---*/

CREATE TABLE DEKLARACJENFZ
  (NUMER              KLUCZ   NOT NULL,  /* klucz wewntrzny, ale widoczny na zewntrz */
   WERSJA             INTEGER NOT NULL,
   PACJENT            KLUCZ   NOT NULL,
   LISTA              TYP     NOT NULL,  /* L-lekarze, P - pielgniarki, O - poone, S - medycyna szkolna */
   OPIEKUN            KLUCZ   NOT NULL,
   NUMER_PS           KLUCZ,
   PLACOWKA           INTEGER,

   POSW_DRUKU_E       MALA_NAZWA,
   PODTYP             TYP,              /* N  nie dotyczy */
                                        /* S  student w miejscu nauki */
                                        /* U  ucze w miejscu nauki */
                                        /* W  deklaracja skadana w miejscu penienia suby */
                                        /* P  deklaracja skadana w miejscu penienia suby + */
                                        /*     onierz Suby Zasadniczej  poborowy (POO) */
                                        /* O - onierz Suby Zasadniczej  poborowy (POO) */

   PRODUKT            KLUCZ,
   KAPITACJA          TAKNIE,

   POCZATEK           TIMESTAMP  NOT NULL, 
   KONIEC             TIMESTAMP,

   SZKOLA_REGON       SYMBOL,   /* dane tylko dla listy typu S */
   SZKOLA_TYP         DIDENT,
   SZKOLA_TYP_PLAT    IDENT,
   SZKOLA_KLASA       INTEGER,
   SZKOLA_PROF_FLUOR  TAKNIE,

/* Dane osobowe przepisywane z PACJENCI */
   NAZWISKO           NAZWISKO,
   IMIE               IMIE,
   DRUGIEIMIE         IMIE,
   PESEL              PESEL,
   PLEC               PLEC,
   DATAURODZENIA      TIMESTAMP,

   ADRKODTERYT        KOD_TERYT,
   ADRKODPOCZTOWY     KOD_POCZTOWY ,
   ADRMIEJSCOWOSC     MIEJSCOWOSC,
   ADRULICA           ULICA,
   ADRDOM             DOM,
   ADRLOKAL           LOKAL,

   ZGLASZAJACY        INTEGER,    /* do ubezpieczenia */

   UPRAWNIENIE_PO     VARCHAR(8),
   DPSLUBDOMDZIECKA   VARCHAR(10),

   BLEDY_NFZ          DUZY_OPIS, /* 4-znakowe kody bledow rozdzielone srednikami */
   SPRAWDZONO_NFZ     TIMESTAMP,  /* Czy obsluzono pole BLEDY_NFZ : null - nie byo, data do porwnania ze ZMIENIANO */

   POBYT_UPRAWNIENIA INTEGER,

   SAUWAGI    TAKNIE,
   UWAGI      UWAGI,

   UTWORZYL   KLUCZ,
   UTWORZONO  TIMESTAMP,
   ZMIENIAL   KLUCZ,
   ZMIENIANO  TIMESTAMP,

   PRIMARY KEY(NUMER, WERSJA),

   FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
   FOREIGN KEY(OPIEKUN) REFERENCES OSOBY(KLUCZ));

COMMIT WORK;

CREATE GENERATOR DEKLARACJENFZ_GEN;
COMMIT WORK;

SET TERM ^ ;

CREATE PROCEDURE DAJ_DEKLARACJENFZ
RETURNS (DEKLARACJA INTEGER)
AS BEGIN
  DEKLARACJA = GEN_ID(DEKLARACJENFZ_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^


CREATE TABLE ROZLICZENIA_DEKLARACJI
 (HISTORIA_XML         KLUCZ NOT NULL,
  UMOWA_NFZ            KLUCZ NOT NULL,
  PRODUKT              KLUCZ NOT NULL,
  WYROZNIK             INTEGER,
  SWIADCZENIE          KLUCZ NOT NULL,

  SZABLON_RACHUNKU     INTEGER NOT NULL,        /* pobierany z NFZ - NOT NULL - do zapaty */
  SZABLON_KOR          INTEGER,        /* Identyfikator szablonu korygowanego */
  TYP_RACH_NFZ         IDENT,          /* 1-ubezpieczeni, 2-koordynacja, 3-zgoda wjta, 4-art.2 ust.1 pkt 3, 5-8 - bezpatnie wg art.12, 9-nieubezpieczeni uprawnieni, 10-OC, 11-uprawnieni, 12-koordynacja, 13-zgoda burmistrza,wojta */
  TYP_DOKUMENTU        TYP,            /* 1-rachunek, 2-korekta, 3-rachunek do ugody, 4-korekta do ugody */
  MIESIAC              INTEGER NOT NULL,
  WSP_KORYGUJACY       WARTOSC,

  ID_SPRAWOZDANIA      INTEGER NOT NULL, 
  WERSJA_SPRAWOZDANIA  INTEGER NOT NULL, 
  ANEKS_UGODOWY        DUZA_NAZWA,

  DEKLARACJA           KLUCZ NOT NULL,
  WERSJA               KLUCZ NOT NULL,

  POPRAWNOSC           IDENT,          /* 00-poprawne (oryginal), 11 - usunita-import wersji+1 sprawozdania, */
                                       /* 12 - zweryfikowana negatywnie, 13 - zmiana wspczynnika finansowania */
                                       /* 14 - blokada wspczynnika finansowania, 15  aneks do umowy */

  NR_WERSJI            INTEGER,        /* kolejny rekord rozliczenia */
  OSTATNIA_WERSJA      TAKNIE,         /* gdy rozliczone to zawsze ostatnia_wersja = T */

  NR_KOMUNIKATU        INTEGER NOT NULL,

 PRIMARY KEY (UMOWA_NFZ, DEKLARACJA, PRODUKT, SWIADCZENIE, NR_WERSJI, MIESIAC, SZABLON_RACHUNKU),
 FOREIGN KEY (HISTORIA_XML) REFERENCES HISTORIAXML (KLUCZ),
 FOREIGN KEY (PRODUKT) REFERENCES PRODUKTY_KONTRAKTU (KLUCZ),
 FOREIGN KEY (SWIADCZENIE) REFERENCES SWIADCZENIA (KLUCZ),
 FOREIGN KEY (DEKLARACJA,WERSJA) REFERENCES DEKLARACJENFZ (NUMER,WERSJA)
);

CREATE INDEX XROZL_DEKL_UMOWAMIES ON ROZLICZENIA_DEKLARACJI(UMOWA_NFZ, MIESIAC, SZABLON_RACHUNKU);

/* Dotyczy XSP, aktualnie niewykorzystywane */

CREATE TABLE SLAD_EKSPORTOW
       (ROK        INTEGER NOT NULL,
        MIESIAC    INTEGER NOT NULL,
        TYP        TYP NOT NULL,    /* P - pacjenci, H - hospitalizacje, S - wiadczenia */
        RODZAJ     TYP NOT NULL,    /* E - eksport danych, I - import potwierdze */
        NUMER      INTEGER NOT NULL,
        SCIEZKA    DUZY_OPIS,
        DATA       TIMESTAMP,

        PRIMARY KEY(ROK, MIESIAC, TYP, RODZAJ, NUMER));

/* Usugi przychodni - dotyczy XSP, aktualnie niewykorzystywane */

CREATE TABLE TABELE_USL_PRZYCH
       (ID_TAB_USLUG    DIDENT NOT NULL,
        NAZWA_TABELI    VARCHAR(200) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        DATA_OD         TIMESTAMP,
        DATA_DO         TIMESTAMP,
        KOD_PLATNIKA    DIDENT,
        STATUS_AKT      TAKNIE,
        DATA_MOD        TIMESTAMP,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(ID_TAB_USLUG));

COMMIT WORK;

CREATE TABLE USLUGI_PRZYCHODNI
       (KLUCZ          KLUCZ NOT NULL,
        ID_TAB_USLUG   DIDENT NOT NULL,
        KOD_USLUGI     DIDENT,
        NAZWA_USLUGI   VARCHAR(200) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        FL_PROC        TAKNIE,
        STATUS_AKT     TAKNIE,
        DATA_MOD       TIMESTAMP,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ID_TAB_USLUG) REFERENCES TABELE_USL_PRZYCH(ID_TAB_USLUG));

COMMIT WORK;

/* ........................................................................ */

/* Tabele grupera - jednorodne grupy pacjentw */

CREATE TABLE JGP_WERSJA
       (WERSJA        INTEGER NOT NULL,
        ALGORYTM      INTEGER,
        ROK           INTEGER,
        MIESIAC_OD    INTEGER,
        MIESIAC_DO    INTEGER,

        PRIMARY KEY(WERSJA));

/*---*/

CREATE TABLE JGP_WYL_JEDN
       (WERSJA        INTEGER NOT NULL,
        SYMBOL        VARCHAR(15) NOT NULL,
        NAZWA         VARCHAR(60),
        KOD_SWIAD     VARCHAR(20) NOT NULL,
        KODY_ICD      INTEGER NOT NULL,

        PRIMARY KEY(SYMBOL, WERSJA, KOD_SWIAD, KODY_ICD));

/*---*/

CREATE TABLE JGP_GRUPY
       (WERSJA        INTEGER NOT NULL,
        GRUPA         VARCHAR(5) NOT NULL,
        KOD_PROD      VARCHAR(20) NOT NULL,
        NAZWA         VARCHAR(250),

        PRIMARY KEY(GRUPA, KOD_PROD, WERSJA));

CREATE INDEX INDEKS_JGP_GRUPY_XKOD ON JGP_GRUPY(KOD_PROD, WERSJA);

/*---*/

CREATE TABLE JGP_KAT_1B
       (WERSJA        INTEGER NOT NULL,
        KOD_PROD      VARCHAR(20) NOT NULL,
        NAZWA         VARCHAR(250),
        PUNKTY        ILOSC,
        TRYB1         VARCHAR(1),
        HOSP          VARCHAR(1),

        PRIMARY KEY(KOD_PROD, WERSJA));

/*---*/

CREATE TABLE JGP_KAT_1C
       (WERSJA        INTEGER NOT NULL,
        KOD_PROD      VARCHAR(20) NOT NULL,
        NAZWA         VARCHAR(250),
        PUNKTY        ILOSC,
        TRYB1         VARCHAR(1),
        HOSP          VARCHAR(1),

        PRIMARY KEY(KOD_PROD, WERSJA));

/*---*/

CREATE TABLE JGP_MAC_SUM_1C
       (WERSJA        INTEGER NOT NULL,
        KOD_PROD      VARCHAR(20) NOT NULL,
        NAZWA         VARCHAR(250),
        KAT_1A        VARCHAR(1),
        KAT_1B        VARCHAR(1),
        JGP1          VARCHAR(3),
        JGP2          VARCHAR(3),
        JGP3          VARCHAR(3),
        JGP4          VARCHAR(3),
        JGP5          VARCHAR(3),
        SW_1B         VARCHAR(20),

        PRIMARY KEY(KOD_PROD, WERSJA));

/*---*/

CREATE TABLE JGP_ZAKRESY
       (WERSJA        INTEGER NOT NULL,
        KOD_PROD      VARCHAR(20) NOT NULL,
        GRUPA         VARCHAR(5) NOT NULL,
        NAZWA         VARCHAR(250),
        PUNKTY_HOSP   ILOSC,
        PUNKTY_HPLAN  ILOSC,
        PUNKTY_1DZIEN ILOSC,
        WSPOLCZYNNIK  ILOSC,

        PRIMARY KEY(GRUPA, KOD_PROD, WERSJA));

/*---*/

CREATE TABLE JGP_PARAM
       (WERSJA        INTEGER NOT NULL,
        LP            INTEGER NOT NULL,    /* w danych grupa moe wystpi wielokrotnie - alternatywa */
        GRUPA         VARCHAR(5) NOT NULL,
        TYP_LISTY     VARCHAR(5) NOT NULL,
        KOD_LISTY     VARCHAR(10) NOT NULL,
        ALGOR         VARCHAR(3),
        OGR_CPOB      VARCHAR(5),
        OGR_WIEKU     VARCHAR(5),
        LPROC1        VARCHAR(5),
        MPROC1        VARCHAR(3),
        LPROC2        VARCHAR(5),
        MPROC2        VARCHAR(3),
        LPROC3        VARCHAR(5),
        MPROC3        VARCHAR(3),
        RZAS          VARCHAR(5),
        RWSP1         VARCHAR(5),
        RWSP2         VARCHAR(5),
        RWSP3         VARCHAR(5),
        PLEC          VARCHAR(1),
        TPRZYJ        VARCHAR(50),
        TWYP          VARCHAR(50),
        NPROC         VARCHAR(5),
        NRZAS         VARCHAR(5),

        PRIMARY KEY(GRUPA, KOD_LISTY, TYP_LISTY, LP, WERSJA));

/*---*/

CREATE TABLE JGP_LPROC
       (WERSJA        INTEGER NOT NULL,
        TYP_LISTY     VARCHAR(1) NOT NULL,
        KOD_LISTY     VARCHAR(10) NOT NULL,
        KOD_ICD9      VARCHAR(15) NOT NULL,
        RANGA_ICD9    VARCHAR(3) NOT NULL,
        NAZWA         VARCHAR(250),

        PRIMARY KEY(KOD_ICD9, KOD_LISTY, WERSJA));

CREATE INDEX INDEKS_JGP_LPROC ON JGP_LPROC(KOD_LISTY, KOD_ICD9, WERSJA);

/*---*/

CREATE TABLE JGP_LROZP
       (WERSJA        INTEGER NOT NULL,
        TYP_LISTY     VARCHAR(1) NOT NULL,
        KOD_LISTY     VARCHAR(10) NOT NULL,
        KOD_ICD10     VARCHAR(10) NOT NULL,
        NAZWA         VARCHAR(250),

        PRIMARY KEY(KOD_ICD10, KOD_LISTY, WERSJA));

CREATE INDEX INDEKS_JGP_LROZP ON JGP_LROZP(KOD_LISTY, KOD_ICD10, WERSJA);

/*---*/

CREATE TABLE JGP_OSOBODNI
       (WERSJA        INTEGER NOT NULL,
        GRUPA         VARCHAR(5) NOT NULL,
        KOD_PROD      VARCHAR(20) NOT NULL,
        NAZWA         VARCHAR(250),
        DNI_FIN       INTEGER,
        PUNKTY_DO_2DNI ILOSC,
        PUNKT_OSBD     ILOSC,

        PRIMARY KEY(GRUPA, KOD_PROD, WERSJA));

/*---*/

CREATE TABLE JGP_OGR_POB
       (WERSJA        INTEGER NOT NULL,
        KOD           VARCHAR(3) NOT NULL,
        PONIZEJ       INTEGER,
        POMIEDZY_OD   INTEGER,
        POMIEDZY_DO   INTEGER,
        POWYZEJ       INTEGER,
        JEDNOSTKA     TYP,

        PRIMARY KEY(KOD, WERSJA));

/*---*/

CREATE TABLE JGP_OGR_WIEKU
       (WERSJA        INTEGER NOT NULL,
        KOD           VARCHAR(3) NOT NULL,
        PONIZEJ       ILOSC,
        POMIEDZY_OD   ILOSC,
        POMIEDZY_DO   ILOSC,
        POWYZEJ       ILOSC,
        JEDNOSTKA     TYP,

        PRIMARY KEY(KOD, WERSJA));

/*---*/

CREATE TABLE JGP_OGR_PRZYJ
       (WERSJA        INTEGER NOT NULL,
        KOD           VARCHAR(3) NOT NULL,
        TRYB          VARCHAR(50),
        NAZWA         VARCHAR(50),

        PRIMARY KEY(KOD, WERSJA));

/*---*/

CREATE TABLE JGP_OGR_WYPISU
       (WERSJA        INTEGER NOT NULL,
        KOD           VARCHAR(3) NOT NULL,
        TRYB          VARCHAR(50),
        NAZWA         VARCHAR(50),

        PRIMARY KEY(KOD, WERSJA));

/* AOS */

CREATE TABLE JGP_AOS_WERSJE
       (WERSJA        INTEGER NOT NULL,
        OBOWIAZUJEOD  TIMESTAMP,

        PRIMARY KEY(WERSJA));

CREATE TABLE JGP_AOS_GRUPY
       (WERSJA        INTEGER NOT NULL,
        GRUPA         VARCHAR(5) NOT NULL,
        KOD_PROD      VARCHAR(20) NOT NULL,
        NAZWA         VARCHAR(250),
        PUNKTY        WARTOSC,

        PRIMARY KEY(GRUPA, KOD_PROD, WERSJA));

CREATE INDEX INDEKS_JGP_AOS_GRUPY ON JGP_AOS_GRUPY(KOD_PROD, WERSJA);

CREATE TABLE JGP_AOS_LPROC
       (WERSJA        INTEGER NOT NULL,
        KOD_LISTY     VARCHAR(10) NOT NULL,
        KOD_ICD9      VARCHAR(15) NOT NULL,
        RANGA_ICD9    VARCHAR(3),
        NAZWA         VARCHAR(250),

        PRIMARY KEY(KOD_ICD9, KOD_LISTY, WERSJA));

CREATE INDEX INDEKS_JGP_AOS_LPROC ON JGP_AOS_LPROC(KOD_LISTY, KOD_ICD9, WERSJA);

CREATE TABLE JGP_AOS_LROZP
       (WERSJA        INTEGER NOT NULL,
        KOD_LISTY     VARCHAR(10) NOT NULL,
        KOD_ICD10     VARCHAR(15) NOT NULL,
        NAZWA         VARCHAR(250),

        PRIMARY KEY(KOD_ICD10, KOD_LISTY, WERSJA));

CREATE INDEX INDEKS_JGP_AOS_LROZP ON JGP_AOS_LROZP(KOD_LISTY, KOD_ICD10, WERSJA);


CREATE TABLE JGP_AOS_PARAM
       (WERSJA        INTEGER NOT NULL,
        GRUPA         VARCHAR(5) NOT NULL,
        LP            VARCHAR(3) NOT NULL,
        TYP_LISTY     VARCHAR(5) NOT NULL,
        KOD_LISTY     VARCHAR(10) NOT NULL,
        ILOSC         INTEGER,
        MAKSIMUM      INTEGER,
        SPEC_KOM      VARCHAR(50),

        PRIMARY KEY(GRUPA, LP, KOD_LISTY, TYP_LISTY, WERSJA));


CREATE TABLE JGP_AOS_OBCE_PROCEDURY
       (HISTORIA      KLUCZ NOT NULL,
        PACJENT       KLUCZ NOT NULL,
        POBYT         KLUCZ NOT NULL,
        ZAKLAD        KLUCZ NOT NULL,
        WIZYTA        INTEGER NOT NULL,  /* Rozszerzenie pobytu w gabinecie */

/*        FOREIGN KEY(HISTORIA) REFERENCES HISTORIA(KLUCZ), */
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),

        PRIMARY KEY(PACJENT, HISTORIA));    // COBY nie pobra 2 razy

CREATE INDEX OBCE_PROCEDURY_XHISTORIA ON JGP_AOS_OBCE_PROCEDURY(HISTORIA);


/* ........................................................................ */

/* Koszty */


CREATE TABLE KOSZTYMPK
       (ROK            INTEGER NOT NULL,
        MIESIAC        INTEGER NOT NULL,
        ZAKLAD         KLUCZ NOT NULL,
        NAZWA          DUZA_NAZWA,
        RODZAJ         TYP NOT NULL,
        TYP            TYP NOT NULL,
        POBYT          TAKNIE NOT NULL,
        KOSZT          WARTOSC,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(ROK, MIESIAC, ZAKLAD, RODZAJ, TYP, POBYT),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));


/* --- */


CREATE TABLE KOSZTYZBIORCZO
       (ROK          INTEGER NOT NULL,
        MIESIAC      INTEGER NOT NULL,
        ZAKLAD       KLUCZ NOT NULL,

        LOZKA          INTEGER,
        POWIERZCHNIA   ILOSC,
        HOSPITALIZACJE INTEGER,
        DNIPOBYTU      INTEGER,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),

        PRIMARY KEY(ROK, MIESIAC, ZAKLAD));


/* --- */

CREATE TABLE PROCEDURYZBIORCZO
       (ROK            INTEGER NOT NULL,
        MIESIAC        INTEGER NOT NULL,
        ZAKLAD         KLUCZ NOT NULL,
        PROCEDURA      KLUCZ NOT NULL,

        PUNKTY         INTEGER,
        ILOSC          INTEGER,
        POMIARY        INTEGER,   /* Dotyczy laboratorium */

        KOSZTNORMW     WARTOSC,
        KOSZTNORMM     WARTOSC,
        KOSZTNORML     WARTOSC,
        KOSZTNORMP     WARTOSC,

        KOSZTKALKW     WARTOSC,
        KOSZTKALKM     WARTOSC,
        KOSZTKALKL     WARTOSC,
        KOSZTKALKP     WARTOSC,
        KOSZTKALKN     WARTOSC,

        KOSZTPUNKTW    WARTOSC,
        KOSZTPUNKTM    WARTOSC,
        KOSZTPUNKTL    WARTOSC,
        KOSZTPUNKTP    WARTOSC,
        KOSZTPUNKTN    WARTOSC,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(ROK, MIESIAC, ZAKLAD, PROCEDURA),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));


/* ........................................................................ */

CREATE TABLE KOSZTY_OPERACJI
       (HISTORIA        KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        PROCEDURA       KLUCZ NOT NULL,
        WYKONANIE       INTEGER NOT NULL,   /* miejsce wykonania */

        OSOBA           KLUCZ NOT NULL,
        TYP_OSOBY       VARCHAR(3),   /* OPR - operator, AST - asysta, PIN - piel.instr., ANS - anestezjolog, PAN - piel.anest. */
        GODZ_PRACY      DOUBLE PRECISION,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        DATA            TIMESTAMP,
        DATA_DO         TIMESTAMP,

        ZO_ZNIECZ_OD    TIMESTAMP,
        ZO_ZNIECZ_DO    TIMESTAMP,

        KOSZT           DOUBLE PRECISION,
        KOSZT_NFZ       DOUBLE PRECISION,
        KOSZT_PRW       DOUBLE PRECISION,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(HISTORIA, OSOBA),
        FOREIGN KEY(HISTORIA) REFERENCES HISTORIA(KLUCZ),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(WYKONANIE) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));

CREATE INDEX KOSZTYOPER_XOKRES ON KOSZTY_OPERACJI(ROK, MIESIAC, DATA);

/*---*/

CREATE TABLE KOSZTY_LEK_OPERACJI
       (HISTORIA        KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        PROCEDURA       KLUCZ NOT NULL,
        WYKONANIE       INTEGER NOT NULL,   /* miejsce wykonania */

        GRUPA_LEKOW     VARCHAR(3) NOT NULL,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        DATA            TIMESTAMP,
        KOSZT           DOUBLE PRECISION,
        KOSZT_NFZ       DOUBLE PRECISION,
        KOSZT_PRW       DOUBLE PRECISION,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(HISTORIA, GRUPA_LEKOW),
        FOREIGN KEY(HISTORIA) REFERENCES HISTORIA(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(WYKONANIE) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));

CREATE INDEX KOSZTYLEKOPER_XOKRES ON KOSZTY_LEK_OPERACJI(ROK, MIESIAC, DATA);

/*---*/

CREATE TABLE STAWKI_OPERACJI
       (OSOBA           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        WYPLATA         DOUBLE PRECISION,
        GODZ_PRACY      DOUBLE PRECISION,
        STAWKA          DOUBLE PRECISION,
        STAWKA_NFZ      DOUBLE PRECISION,
        STAWKA_PRW      DOUBLE PRECISION,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(OSOBA, ZAKLAD, ROK, MIESIAC),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

CREATE INDEX STAWKIOPER_XOKRES ON STAWKI_OPERACJI(ROK, MIESIAC, OSOBA, ZAKLAD);

/*---*/

CREATE TABLE RODZAJE_KOSZTOW_SZPITALA
       (KLUCZ           KLUCZ NOT NULL,      /* GET_UNIQUE_KEY_GEN */
        NAZWA           DUZA_NAZWA NOT NULL,
        WYRAZENIE       VARCHAR(30),
        AKTYWNE         TAKNIE,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE TABLE STAWKI_KOSZTOW_SZPITALA
       (ZAKLAD          KLUCZ NOT NULL,
        RODZAJ          KLUCZ NOT NULL,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        KOSZT           DOUBLE PRECISION,
        OSOBODNI        INTEGER,              /* dla oddzialu */
        GODZ_PRACY      DOUBLE PRECISION,     /* dla bloku operacyjnego */
        OSOBODZIEN      DOUBLE PRECISION,     /* lub stawka godzinowa dla bloku operacyjnego */

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(ZAKLAD, RODZAJ, ROK, MIESIAC),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

CREATE INDEX STAWKIKSZPIT_XOKRES ON STAWKI_KOSZTOW_SZPITALA(ROK, MIESIAC, ZAKLAD, RODZAJ);


CREATE TABLE KOSZTY_LEK_ODDZIALU
       (POBYT           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        NUMER           KLUCZ NOT NULL,     /* RuchOddzialowy.Numer */

        GRUPA_LEKOW     VARCHAR(3) NOT NULL,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        KOSZT           DOUBLE PRECISION,
        KOSZT_NFZ       DOUBLE PRECISION,
        KOSZT_PRW       DOUBLE PRECISION,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(POBYT, ZAKLAD, NUMER, GRUPA_LEKOW, ROK, MIESIAC),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ));

CREATE INDEX KOSZTYLEKODDZ_XOKRES ON KOSZTY_LEK_ODDZIALU(ROK, MIESIAC, ZAKLAD, POBYT, NUMER, GRUPA_LEKOW);


CREATE TABLE KOSZTY_OSOBODNI_ODDZIALU
       (POBYT           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        NUMER           KLUCZ NOT NULL,     /* RuchOddzialowy.Numer */

        RODZAJ          KLUCZ NOT NULL,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        OSOBODNI        INTEGER,
        KOSZT           DOUBLE PRECISION,
        KOSZT_NFZ       DOUBLE PRECISION,
        KOSZT_PRW       DOUBLE PRECISION,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(POBYT, ZAKLAD, NUMER, RODZAJ, ROK, MIESIAC),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ));

CREATE INDEX KOSZTYOSBODDZ_XOKRES ON KOSZTY_OSOBODNI_ODDZIALU(ROK, MIESIAC, ZAKLAD, POBYT, NUMER, RODZAJ);



CREATE TABLE STAWKI_PROCEDUR_SZPITALA
       (ZAKLAD          KLUCZ NOT NULL,
        TYP             TYP NOT NULL,
        PROCEDURA       KLUCZ NOT NULL,    /* moze byc 0 - obserwacje, ... */

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        ILOSC           INTEGER,
        STAWKA          DOUBLE PRECISION,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(ZAKLAD, TYP, PROCEDURA, ROK, MIESIAC),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

CREATE INDEX STAWKIPROCSZPIT_XOKRES ON STAWKI_PROCEDUR_SZPITALA(ROK, MIESIAC, ZAKLAD, TYP, PROCEDURA);

CREATE TABLE KOSZTY_PROCEDUR_ODDZIALU
       (POBYT           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        WYKONANIE       INTEGER NOT NULL,   /* miejsce wykonania */
        NUMER           KLUCZ NOT NULL,     /* RuchOddzialowy.Numer */

        TYP             TYP NOT NULL,
        PROCEDURA       KLUCZ NOT NULL,    /* moze byc 0 - obserwacje, ... */

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        ILOSC           INTEGER,
        KOSZT           DOUBLE PRECISION,
        KOSZT_NFZ       DOUBLE PRECISION,
        KOSZT_PRW       DOUBLE PRECISION,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(POBYT, ZAKLAD, WYKONANIE, NUMER, TYP, PROCEDURA, ROK, MIESIAC),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(WYKONANIE) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ));

CREATE INDEX KOSZTYPROCODDZ_XOKRES ON KOSZTY_PROCEDUR_ODDZIALU(ROK, MIESIAC, ZAKLAD, WYKONANIE, POBYT, NUMER, TYP, PROCEDURA);

/* ........................................................................ */

CREATE TABLE DEFEWIDENCJIPOMOCNICZEJ
       (IDENT        DIDENT NOT NULL,
        TYP          TYP NOT NULL,
        NAZWA        DUZA_NAZWA,
        POBIERANIE   TYP,
        AKTYWNA      TAKNIE,

        OPIS         PARAMETRY,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(IDENT));


CREATE TABLE EWIDENCJAPOMOCNICZA
       (IDENT        DIDENT NOT NULL,
        ROK          INTEGER NOT NULL,
        MIESIAC      INTEGER NOT NULL,
        ZAKLAD       KLUCZ NOT NULL,
        ILOSC        ILOSC,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(IDENT) REFERENCES DEFEWIDENCJIPOMOCNICZEJ(IDENT),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),

        PRIMARY KEY(IDENT, ROK, MIESIAC, ZAKLAD));

/* --- */

CREATE TABLE INDEKS
       (KLUCZ          KLUCZ NOT NULL,
        TYP            TYP NOT NULL,
        GRUPA          IDENT,
        SYMBOL         DUZA_NAZWA,
        JM             IDENT,
        NAZWA          VARCHAR(120) CHARACTER SET DOS852,

        NAZWA_MNAR     OPIS,
        PRODUCENT      OPIS,          /* Dla rodkw trwaych tylko */
        OPIS           OPIS,
        VAT            TYP,
        SWW            SYMBOL,

        DANE           PARAMETRY,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE INDEX INDEKS_XGRSYM ON INDEKS(GRUPA, SYMBOL);
CREATE INDEX INDEKS_XGRNAZWA ON INDEKS(NAZWA);

SET TERM ^ ;
CREATE GENERATOR INDEKS_GEN^

CREATE TRIGGER CREATE_INDEKS FOR INDEKS
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(INDEKS_GEN, 1);
END ^

CREATE PROCEDURE DAJ_INDEKS
RETURNS (INDEKS INTEGER)
AS BEGIN
  INDEKS = GEN_ID(INDEKS_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE CENNIK
       (DATA         TIMESTAMP NOT NULL,
        INDEKS       KLUCZ NOT NULL,
        ROK          INTEGER NOT NULL,
        MIESIAC      INTEGER NOT NULL,
        CENA         WARTOSC,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(DATA, INDEKS),
        FOREIGN KEY(INDEKS) REFERENCES INDEKS(KLUCZ));

/* --- */

CREATE TABLE NORMY
       (ZAKLAD         KLUCZ NOT NULL,
        PROCEDURA      KLUCZ NOT NULL,
        INDEKS         KLUCZ NOT NULL,
        OSOBY          INTEGER,
        ILOSC          ILOSC,
        WSPOLCZYNNIK   ILOSC,
        NORMA          ILOSC,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(ZAKLAD, PROCEDURA, INDEKS),
        FOREIGN KEY(INDEKS) REFERENCES INDEKS(KLUCZ),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));


/* --- */

CREATE TABLE ZUZYCIE
       (ROK            INTEGER NOT NULL,
        MIESIAC        INTEGER NOT NULL,
        ZAKLAD         KLUCZ NOT NULL,
        PROCEDURA      KLUCZ NOT NULL,
        INDEKS         KLUCZ NOT NULL,

        ZUZ_NORM       ILOSC,    /* Ilo wykonanych procedur w pliku */
        ZUZ_RZECZ      ILOSC,    /* PROCEDURYZBIORCZO */

        CENA           WARTOSC,
        WART_NORM      WARTOSC,
        WART_RZECZ     WARTOSC,

        UTWORZYL       KLUCZ,
        ZMIENIAL       KLUCZ,
        UTWORZONO      TIMESTAMP,
        ZMIENIANO      TIMESTAMP,

        PRIMARY KEY(ROK, MIESIAC, ZAKLAD, PROCEDURA, INDEKS),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(INDEKS) REFERENCES INDEKS(KLUCZ),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));


/* ........................................................................ */

/* Magazyny */

/* UWAGA : wykorzystywana jest tablica INDEKS gdzie typ = 'M'/'L' (materia/lek) */

CREATE TABLE WMAGAZYNIE
       (KLUCZ       	  KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,

        MATERIAL     	  KLUCZ NOT NULL,    /* odniesienie do tablicy INDEKS */
        PRODUKT         KLUCZ,             /* odniesienie do tablicy PRODUKTY (dalej) */
                                           /* obcy klucz zdefiniowany po PRODUKTY */
        SERIA           DUZA_NAZWA,
        DATA_WAZNOSCI   TIMESTAMP,
        KOD_KRESKOWY    SYMBOL,
        STATUS          TYP,               /* Aktualny, Wstrzymany, wYcofany, domyslnie A */

        PACJENT         KLUCZ,
        POBYT           KLUCZ,
        TYPWIZYTY       VARCHAR(5),   /* Dla przychodni i szpitala */

        SKLADOWANIE     OPIS,

      	MINIMUM         ILOSC,
        CENA            WARTOSC,
        ILOSC           ILOSC,
        WARTOSC         WARTOSC,

        DANE            PARAMETRY,

        UTWORZYL     	KLUCZ,
        ZMIENIAL     	KLUCZ,
        UTWORZONO    	TIMESTAMP,
        ZMIENIANO    	TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
	FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ));

CREATE INDEX WMAGAZYNIE_XSERIA ON WMAGAZYNIE(MATERIAL, SERIA, DATA_WAZNOSCI, CENA);
CREATE INDEX WMAGAZYNIE_XKOD_KRESKOWY ON WMAGAZYNIE(KOD_KRESKOWY);

SET TERM ^ ;
CREATE GENERATOR WMAGAZYNIE_GEN^

CREATE TRIGGER CREATE_WMAGAZYNIE FOR WMAGAZYNIE
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(WMAGAZYNIE_GEN, 1);
END ^

CREATE PROCEDURE DAJ_WMAGAZYNIE
RETURNS (WMAGAZYNIE INTEGER)
AS BEGIN
  WMAGAZYNIE = GEN_ID(WMAGAZYNIE_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE OBROTYMAGAZYNU
       (KLUCZ        	KLUCZ NOT NULL,
        ZAKLAD        KLUCZ NOT NULL,
        ZAKLAD_PRZYJ	KLUCZ,   /* tylko dla MM+, MM-, RW, ZW */
        DOKUMENT_MM   KLUCZ,   /* tylko dla MM+ - wskazuje MM- */
        INWENT        KLUCZ,   /* tylko dla IP, IR - wskazuje dok.inwentaryzacyjny */
        FIRMA         KLUCZ,

        DO_FAKTURY    KLUCZ,    /* Obcy klucz zdefiniowany dalej - dokumenty ksigowe */

        ZAMOWIENIE    KLUCZ,   /* odwoanie do tablicy ZAMOWIENIA - dalej */

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        PRZYCH_ROZCH    TYP NOT NULL,
        TYP_DOKUM    	  VARCHAR(3) NOT NULL,
        PODTYP_DOKUM    VARCHAR(3) NOT NULL,
        NR_DOKUM 	      SYMBOL NOT NULL,
        TYP             TYP,   /* Material, Lek */

        ZSMOPL_RODZAJ   VARCHAR(3),
        ZSMOPL_ID       VARCHAR(30),
        ZSMOPL_IMP_DOC  VARCHAR(15),  /* nr zapotrzebowania dla importu docelowego */
        ZSMOPL_WYSLANO  TIMESTAMP, 

        KOM_NFZ         KLUCZ,    /* do komunikatu FZX */
        WERSJA_NFZ      INTEGER,  /* jesli sa korekty to wysylka i dalsza numeracja w tych korektach */
        USUNIECIE_NFZ   TAKNIE,   /* gdy ostatni komunikat usuwal dokument z NFZ */
        POTW_NFZ        KLUCZ,
        POPRAWNOSC_NFZ  TAKNIE,

        KOREKTA         TAKNIE,
        ORYGKLUCZ       KLUCZ,

        PACJENT         KLUCZ,
        POBYT           KLUCZ,
        TYPWIZYTY       VARCHAR(5),   /* Dla przychodni i szpitala */

        ZLECENIE        MALA_NAZWA,
        OPIS            DUZA_NAZWA,
        UMOWA           DUZA_NAZWA,

        PRZYCHOD        WARTOSC,
        ROZCHOD         WARTOSC,

        ZLECAJACY       KLUCZ,
        DATA_WYST     	TIMESTAMP,
        DATA_PLAT     	TIMESTAMP,
        FAKTURA         DUZA_NAZWA,

        ODBIERAJACY     KLUCZ,         /* mylca nazwa - to jest wydajcy / przyjmujacy z / do magazynu */
        POBRAL          KLUCZ,         /* waciwy odbierajcy/zwracajacy, dodano marzec 2012 */
        DATA_ODBIORU    TIMESTAMP,

        DANE            PARAMETRY,

        UTWORZYL     	KLUCZ,
        ZMIENIAL     	KLUCZ,
        UTWORZONO    	TIMESTAMP,
        ZMIENIANO    	TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(ZAKLAD_PRZYJ) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(ZLECAJACY) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ODBIERAJACY) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ));

CREATE INDEX OBROTYMAGAZYNU_XOKRES ON OBROTYMAGAZYNU(
  ZAKLAD, ROK, MIESIAC, PRZYCH_ROZCH, TYP_DOKUM, PODTYP_DOKUM, NR_DOKUM);
CREATE INDEX OBROTYMAGAZYNU_XORYGKLUCZ ON OBROTYMAGAZYNU(ORYGKLUCZ);
CREATE INDEX OBROTYMAGAZYNU_XZAMOWIENIA ON OBROTYMAGAZYNU(ZAMOWIENIE);
CREATE INDEX OBROTYMAGAZYNU_XDOKUMENT_MM ON OBROTYMAGAZYNU(DOKUMENT_MM);
CREATE INDEX OBROTYMAGAZYNU_XINWENT ON OBROTYMAGAZYNU(INWENT);
CREATE INDEX OBROTYMAGAZYNU_XPOBRAL ON OBROTYMAGAZYNU(POBRAL);
CREATE INDEX OBROTYMAGAZYNU_XZSMOPL ON OBROTYMAGAZYNU(ZSMOPL_ID);
CREATE INDEX OBROTYMAGAZYNU_XNFZ ON OBROTYMAGAZYNU(KOM_NFZ);

SET TERM ^ ;
CREATE GENERATOR OBROTYMAGAZYNU_GEN^

CREATE TRIGGER CREATE_OBROTYMAGAZYNU FOR OBROTYMAGAZYNU
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(OBROTYMAGAZYNU_GEN, 1);
END ^

CREATE PROCEDURE DAJ_OBROTYMAGAZYNU
RETURNS (OBROTYMAGAZYNU INTEGER)
AS BEGIN
  OBROTYMAGAZYNU = GEN_ID(OBROTYMAGAZYNU_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE POZYCJAOBROTU
       (KLUCZ           KLUCZ NOT NULL,
        OBROTYMAGAZYNU 	KLUCZ NOT NULL,
        POZYCJA         INTEGER NOT NULL,
        PRZYCH_ROZCH    TYP NOT NULL,
        PODTYP_DOKUM    VARCHAR(3),     /* Dla RW/ZW dodatkowa klasyfikacja jak w nagwku */

        MATERIAL        KLUCZ NOT NULL,    /* odniesienie do tablicy INDEKS */
        WMAGAZYNIE      KLUCZ NOT NULL,

        PACJENT         KLUCZ,
        POBYT           KLUCZ,
        HISTORIA        KLUCZ,
        BEZNFZ          TAKNIE,  /* DLA PRODUKTU CHEMIOTERAPII */

        ILOSC_DAWEK     ILOSC,
        DAWKA           ILOSC,
        ZUZYCIE         ILOSC,
        ILOSC           ILOSC,
        CENA            WARTOSC,
        STARACENA       WARTOSC,
        ILOSCOPAK       ILOSC,
        CENAOPAK        WARTOSC,
        WARTOSC         WARTOSC,
        TAXLABORUM      WARTOSC,

        KATALOG         VARCHAR(12),      /* numer katalogowy dostawcy */

        ZDJETO_ILOSCI   ILOSC,            /* uywane przy rozchodach */
        ZDJETO_WARTOSCI WARTOSC,          /* dla przychodw automatycznie */
        JEST_ZERO        TAKNIE,          /* zerowane */

        PARTIA              KLUCZ,
        PARTIILOSC          ILOSC,
        PARTIWARTOSC        WARTOSC,
        ORYGKLUCZ           KLUCZ,
        ORYGILOSC           ILOSC,
        ORYGWARTOSC         WARTOSC,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(OBROTYMAGAZYNU) REFERENCES OBROTYMAGAZYNU(KLUCZ),
        FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(HISTORIA) REFERENCES HISTORIA(KLUCZ),
        FOREIGN KEY(WMAGAZYNIE) REFERENCES WMAGAZYNIE(KLUCZ));

CREATE UNIQUE INDEX POZYCJAOBROTU_XDOKUMENT ON
    POZYCJAOBROTU(OBROTYMAGAZYNU, POZYCJA);
CREATE INDEX        POZYCJAOBROTU_XMAGAZYN ON
    POZYCJAOBROTU(WMAGAZYNIE, PRZYCH_ROZCH, JEST_ZERO);
CREATE INDEX        POZYCJAOBROTU_XORYGKLUCZ ON
    POZYCJAOBROTU(ORYGKLUCZ);

SET TERM ^ ;
CREATE GENERATOR POZYCJAOBROTU_GEN^

CREATE TRIGGER CREATE_POZYCJAOBROTU FOR POZYCJAOBROTU
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(POZYCJAOBROTU_GEN, 1);
END ^

CREATE PROCEDURE DAJ_POZYCJAOBROTU
RETURNS (POZYCJAOBROTU INTEGER)
AS BEGIN
  POZYCJAOBROTU = GEN_ID(POZYCJAOBROTU_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE LISTAPRZYCHODOWDLAROZCHODU
       (ROZCHOD         KLUCZ NOT NULL,
        PRZYCHOD        KLUCZ NOT NULL,
        KOLEJNOSC       INTEGER,
        ILOSC           ILOSC,
        WARTOSC         WARTOSC,
        KOREKTAWARTOSCI WARTOSC,

        PRIMARY KEY(ROZCHOD, PRZYCHOD),
        FOREIGN KEY(PRZYCHOD) REFERENCES POZYCJAOBROTU(KLUCZ));

COMMIT WORK;

/* --- */

CREATE TABLE OBROTYMIESIECZNE
       (WMAGAZYNIE      KLUCZ NOT NULL,
        MATERIAL        KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        PRZYCHOD        ILOSC,
        WPRZYCHOD       WARTOSC,
        ROZCHOD         ILOSC,
        WROZCHOD        WARTOSC,
        SPRZEDAZ        ILOSC,
        WSPRZEDAZ       WARTOSC,

        PRIMARY KEY(WMAGAZYNIE, ROK, MIESIAC),
        FOREIGN KEY(WMAGAZYNIE) REFERENCES WMAGAZYNIE(KLUCZ),
        FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

/* Inwentaryzacja */

CREATE TABLE INWENTARYZACJA
       (KLUCZ        	KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        NR_DOKUM 	SYMBOL NOT NULL,
        TYP             TYP,

        DATA_WYST  	TIMESTAMP,

        DANE            PARAMETRY,

        UTWORZYL     	KLUCZ,
        ZMIENIAL     	KLUCZ,
        UTWORZONO    	TIMESTAMP,
        ZMIENIANO    	TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

CREATE UNIQUE INDEX INWENTARYZACJA_XOKRES ON INWENTARYZACJA(
  ZAKLAD, ROK, MIESIAC, NR_DOKUM);

CREATE TABLE POZYCJAINWENT
       (INWENTARYZACJA  KLUCZ NOT NULL,
        POZYCJA         INTEGER NOT NULL,

        MATERIAL        KLUCZ NOT NULL,    /* odniesienie do tablicy INDEKS */
        WMAGAZYNIE      KLUCZ NOT NULL,

        PACJENT         KLUCZ,
        POBYT           KLUCZ,

        SPISANO         ILOSC,
        SPISANOOPAK     ILOSC,

        ILOSC           ILOSC,             /* wartoci wyliczane */
        CENA            WARTOSC,
        WARTOSC         WARTOSC,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(INWENTARYZACJA, POZYCJA),
        FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ),
        FOREIGN KEY(WMAGAZYNIE) REFERENCES WMAGAZYNIE(KLUCZ));

COMMIT WORK;

/* Dane do inwentaryzacji - uzupenianie dokumentu */

SET TERM ^ ;

CREATE PROCEDURE DO_INWENTARYZACJI(
  ZAKLAD       INTEGER,
  DATA         TIMESTAMP,
  DATA1        TIMESTAMP)
RETURNS(
  KLUCZ        INTEGER,
  MATERIAL     INTEGER,
  PRODUKT      INTEGER)
AS
DECLARE VARIABLE ILOSC INTEGER;
DECLARE VARIABLE PRZYCHOD INTEGER;
DECLARE VARIABLE ROZCHOD INTEGER;
BEGIN
  FOR SELECT M.Klucz, M.Material, M.Produkt
  FROM WMagazynie M
  WHERE
    M.Zaklad = :ZAKLAD AND
    (M.Ilosc > 0 OR
      (SELECT COUNT(*) FROM ObrotyMagazynu O, PozycjaObrotu P
       WHERE
         O.Klucz = P.ObrotyMagazynu AND P.WMagazynie = M.Klucz AND
         O.Data_wyst > :DATA) > 0)
  INTO :KLUCZ, :MATERIAL, :PRODUKT
  DO BEGIN
    SELECT COUNT(*)
    FROM PozycjaInwent PI, Inwentaryzacja II
    WHERE
      PI.Inwentaryzacja = II.Klucz AND
      PI.WMagazynie = :KLUCZ AND
      II.Data_wyst = :DATA
    INTO :ILOSC;

    IF (:ILOSC = 0)
    THEN BEGIN
      SELECT SUM(P.Ilosc-P.OrygIlosc) FROM ObrotyMagazynu O, PozycjaObrotu P
      WHERE
        O.Klucz = P.ObrotyMagazynu AND P.WMagazynie = :KLUCZ AND
        P.Przych_rozch = '+' AND O.Data_wyst < :DATA1
      INTO :PRZYCHOD;

      IF (:PRZYCHOD > 0)
      THEN BEGIN
        ILOSC = :PRZYCHOD;
        SELECT SUM(P.Ilosc-P.OrygIlosc) FROM ObrotyMagazynu O, PozycjaObrotu P
        WHERE
          O.Klucz = P.ObrotyMagazynu AND P.WMagazynie = :KLUCZ AND
          P.Przych_rozch = '-' AND O.Data_wyst < :DATA1
        INTO :ROZCHOD;

        IF (:ROZCHOD > 0)
        THEN ILOSC = :ILOSC - :ROZCHOD;

        IF (:ILOSC > 0)
        THEN SUSPEND;
      END
    END
  END
END^
COMMIT WORK ^

SET TERM ; ^


/* ........................................................................ */

/* Normy laboratorium */

CREATE TABLE NORMYLABORATORIUM
       (ZAKLAD          KLUCZ NOT NULL,
        PROCEDURA       KLUCZ NOT NULL,
        INDEKS          KLUCZ NOT NULL,

        OSOBY          INTEGER,
        ILOSC          ILOSC,
        WSPOLCZYNNIK   ILOSC,
        NORMA          ILOSC,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(ZAKLAD, PROCEDURA, INDEKS),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(INDEKS) REFERENCES INDEKS(KLUCZ),
        FOREIGN KEY(PROCEDURA) REFERENCES PROCEDURY(KLUCZ));

/* ........................................................................ */

/* Inne dane */

CREATE TABLE ZWOLNIENIA
       (PACJENT         KLUCZ NOT NULL,
        POBYT           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        WIZYTA          KLUCZ NOT NULL,
        LP              INTEGER NOT NULL,

                                          /* e-ZWOLNIENIA */
        NUMER           KLUCZ,            /* Dla podlaczenia dokumentow e-zwolnienia, z ogolnego generatora */
        TRYB            TYP,              /* Biezacy, Alternatywny */
        UZASADNIENIE    VARCHAR(3000),    /* wstecznego dokumentu */
        KODANULOWANIA   TYP,
        PRZYCZYNAANULOWANIA VARCHAR(100),
        PRZYPADEK       INTEGER,          /* Ostatni przypadek uzycia - przypadki biznesowe dokumentacji ZUS */

        DLAKOGO         KLUCZ NOT NULL,
        LEKARZ          KLUCZ NOT NULL,
        DATA            TIMESTAMP,

        UBEZPIECZONY    TYP,
        MAPROFILPUE     TAKNIE,           /* Ma profil PUE na portalu ZUS */

        BLEDYO          XML2,             /* Oryginal blednego zwolnienia */
        BLEDYK          XML2,             /* Kopia blednego zwolnienia */
        BSERIADOK       VARCHAR(2),
        BNUMERDOK       VARCHAR(7),
        OBSLUGABLEDOW   TAKNIE,

        ODDNIA          TIMESTAMP,
        DODNIA          TIMESTAMP,

        SZPITAL         ILOSC,            /* 1 oznacza true */
        SZPITALOD       TIMESTAMP,
        SZPITALDO       TIMESTAMP,

        WSKAZANIA       TYP,
        KOD1            TYP,
        KOD2            TYP,
        KOD3            TYP,
        KOD4            TYP,
        CHOROBA         IDENT,
        KREWNY          TYP,

        PLT_NIP         VARCHAR(10),
        PLT_NIP_TYP     VARCHAR(1),
        PLT_NAZWA       DUZA_NAZWA,
        PLT_KODPOCZT    KOD_POCZTOWY,
        PLT_MIEJSC      MIEJSCOWOSC,
        PLT_ULICA       ULICA,
        PLT_DOM         DOM,
        PLT_LOKAL       LOKAL,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(PACJENT, POBYT, ZAKLAD, WIZYTA, LP),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(LEKARZ) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(DLAKOGO) REFERENCES PACJENCI(KLUCZ));

/* e-ZWOLNIENIA */        

CREATE TABLE PLATNICY_ZWOLNIENIA
       (NUMER           KLUCZ NOT NULL,    /* Do ZWOLNIENIA */
        LP              INTEGER NOT NULL,  /* wewnetrzny numer - wystepuje w odwolaniach w dokumentach, 0 - platnik dla anulowania w trybie alternatywnym, przypadki 7, 8, 9 */

        WYSYLKA         INTEGER,          /* Nr ostatniej wysylki - przypadku uzycia (ponizej) */
        PRZYPADEK       INTEGER,          /* Ostatni przypadek uzycia - przypadki biznesowe dokumentacji ZUS */
                                          /* Okresla jednoczesnie biezacy status dokumentu */
        STATUS          TYP,              /* Status ostatniej wysylki, D - do wyslania, P - poprawna, O - ostrzezenie, B - bledna */

        AKTUALNY        TAKNIE,
        WRAZLIWY        TAKNIE,
        NAZWA           VARCHAR(80),
        NAZWISKO        VARCHAR(50),
        IMIE            VARCHAR(50),
        NIP             NIP,
        PESEL           PESEL,
        PASZPORT        VARCHAR(20),
        PUE             TAKNIE,
        POWIADAMIANIE   TAKNIE,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(NUMER, LP));


CREATE TABLE WYSYLKA_ZWOLNIENIA
       (NUMER           KLUCZ NOT NULL,    /* Do ZWOLNIENIA */
        PLATNIK         INTEGER NOT NULL,  /* Odniesienie do lp platnika */
        WYSYLKA         INTEGER NOT NULL,  /* Nr kolejnej wysylki dla platnika, moze zawierac kilka dokumentow (lp) */
        PRZYPADEK       INTEGER,           /* przypadek uzycia - przypadki biznesowe dokumentacji ZUS */
        STATUS          TYP,               /* Status wysylki, D - do wyslania, P - poprawna, O - ostrzezenie, B - bledna */

        WYSTAWIONO      TIMESTAMP,
        WYSLANO         TIMESTAMP,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(NUMER, PLATNIK, WYSYLKA));


CREATE TABLE DOKUMENTY_ZWOLNIENIA
       (NUMER           KLUCZ NOT NULL,    /* Do ZWOLNIENIA */
        PLATNIK         INTEGER NOT NULL,  /* Odniesienie do lp platnika */
        WYSYLKA         INTEGER NOT NULL,  /* Nr kolejnej wysylki, moze zawierac kilka dokumentow (lp) */
        LP              INTEGER NOT NULL,  /* wewnetrzny numer w ramach wysylki */
        STATUS          TYP,               /* Status wysylki, D - do wyslania, P - poprawna, O - ostrzezenie, B - bledna */

        RODZAJ          DIDENT,
        SERIADOK        VARCHAR(2),
        NUMERDOK        VARCHAR(7),
        OPISBLEDU       VARCHAR(100),

        ODDNIA          TIMESTAMP,
        DODNIA          TIMESTAMP,

        SZPITAL         ILOSC,            /* 1 oznacza true */
        SZPITALOD       TIMESTAMP,
        SZPITALDO       TIMESTAMP,

        IDORYG          VARCHAR(20),
        IDKOPIA         VARCHAR(20),

        NRREFPACZ       VARCHAR(3),
        NRREFORYG       VARCHAR(3),
        NRREFKOPIA      VARCHAR(3),

        ORYGINAL        XML2,
        KOPIA           XML2,
        PORYGINAL       XML2,              /* podpisany */
        PKOPIA          XML2,              /* podpisany */

        UPPO            XML2,
        UPPK            XML2,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(NUMER, PLATNIK, WYSYLKA, LP));


/*==========================================================================*/
/* Finanse */
/* ======= */

/* Definicja planu kont */

CREATE TABLE SKLADNIKIKONT
       (ROK               INTEGER NOT NULL,
        KLUCZ             KLUCZ NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        TYP             TYP,
        RODZAJ          TYP,
        NAZWA           DUZA_NAZWA,
        SYMBOL          SYMBOL,
        BILANS          TYP,

        NADRZEDNY       KLUCZ,
        DOTYCZY         KLUCZ,

        TYPPOZYCJI      TYP,           /* Naleno, Zobowizanie - dla rozrachunkw */

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ, ROK),
        FOREIGN KEY(NADRZEDNY, ROK) REFERENCES SKLADNIKIKONT(KLUCZ, ROK));

CREATE INDEX SKLADNIKIKONT_XROKTYP ON SKLADNIKIKONT(ROK, TYP, RODZAJ, NAZWA);
CREATE INDEX SKLADNIKIKONT_XROKSYMBOL ON SKLADNIKIKONT(ROK, SYMBOL);
CREATE INDEX SKLADNIKIKONT_XROKNAZWA ON SKLADNIKIKONT(ROK, NAZWA);
CREATE INDEX SKLADNIKIKONT_XPODMIOT  ON SKLADNIKIKONT(PODMIOT_FINANSOWY);

SET TERM ^ ;
CREATE GENERATOR SKLADNIKIKONT_GEN^

CREATE TRIGGER CREATE_SKLADNIKIKONT FOR SKLADNIKIKONT
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(SKLADNIKIKONT_GEN, 1);
END ^

CREATE PROCEDURE DAJ_SKLADNIKIKONT
RETURNS (SKLADNIKIKONT INTEGER)
AS BEGIN
  SKLADNIKIKONT = GEN_ID(SKLADNIKIKONT_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/* Wykaz kont */

CREATE TABLE WYKAZKONT
       (ROK               INTEGER NOT NULL,
        KLUCZE            KLUCZEKONT NOT NULL,
        KONTO             DUZA_NAZWA,
        PODMIOT_FINANSOWY KLUCZ,
        PRIMARY KEY(KLUCZE, ROK));

/* Automaty PK */

CREATE TABLE AUTOMATYPK
       (KLUCZ           KLUCZ NOT NULL,
        ROK             INTEGER NOT NULL,
        NAZWA           DUZA_NAZWA,

        PODMIOT_FINANSOWY KLUCZ,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ, ROK));

/* Definicje dokumentw ksigowych */
/*
[TypyDokumentowKsiegowych]
P=Polecenia ksigowania
R=Rejestrowe
K=Raport kasowy
B=Wycig bankowy
M=Magazynowe
E=Apteka
T=rodki trwae
F=Faktury sprzeday
Z=Faktury zakupu
V=Korekty VAT
L=Pace
S=Systemowe
A=Automaty PK
k=Dokumenty kasowe
b=Dokumenty bankowe
C=Czynsze
*/

CREATE TABLE DEFINICJEDOKKSIEGOWYCH
       (KLUCZ           KLUCZ NOT NULL,

        ROK             INTEGER NOT NULL,
        ZAKLAD          KLUCZ,
        AUTOMATPK       KLUCZ,
        LP              INTEGER,
        TYP             TYP,
        TYPSRODKOW      TYP,     /* Srodki, Wyposazenie - nowy program */
        RODZAJ          DIDENT,
        PODRODZAJ       DIDENT,
        NAZWA           DUZA_NAZWA,
        BEZWYKSIEGOWANIA TAKNIE,

        PODMIOT_FINANSOWY KLUCZ,

        KLUCZE          KLUCZEKONT,
        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        SZABLON         varchar(250),
        STRONA          TYP,

        KLUCZE_VAT      KLUCZEKONT,  /* split payment */ 
        TYPDOTYCZY_VAT  TYP,
        DOTYCZY_VAT     KLUCZ,
		ODEJMOWAC_VAT   TAKNIE,
		CZERWONY_VAT    TAKNIE,

        KLUCZE_DRK      KLUCZEKONT,  /* Dodatnie rnice kursowe */
        TYPDOTYCZY_DRK  TYP,
        DOTYCZY_DRK     KLUCZ,

        KLUCZE_URK      KLUCZEKONT,  /* Ujemne rnice kursowe */
        TYPDOTYCZY_URK  TYP,
        DOTYCZY_URK     KLUCZ,

        KLASYFIKACJA1   KLUCZ,
        KLASYFIKACJA2   KLUCZ,
        KLASYFIKACJA3   KLUCZ,

        WYMAGANE1       TAKNIE,
        WYMAGANE2       TAKNIE,
        WYMAGANE3       TAKNIE,

        ZALICZKI        DUZA_NAZWA,

        DANE            PARAMETRY,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ, ROK),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(AUTOMATPK, ROK) REFERENCES AUTOMATYPK(KLUCZ, ROK));

CREATE INDEX DEFDOKKSIEGOWYCH_XKLUCZE ON DEFINICJEDOKKSIEGOWYCH(ROK, KLUCZE);
CREATE INDEX DEFDOKKSIEGOWYCH_XPODMIOT  ON DEFINICJEDOKKSIEGOWYCH(PODMIOT_FINANSOWY);

SET TERM ^ ;
CREATE GENERATOR DEFINICJEDOKKSIEGOWYCH_GEN^

CREATE TRIGGER CREATE_DEFINICJEDOKKSIEGOWYCH FOR DEFINICJEDOKKSIEGOWYCH
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DEFINICJEDOKKSIEGOWYCH_GEN, 1);
END ^

CREATE PROCEDURE DAJ_DEFINICJEDOKKSIEGOWYCH
RETURNS (DEFINICJEDOKKSIEGOWYCH INTEGER)
AS BEGIN
  DEFINICJEDOKKSIEGOWYCH = GEN_ID(DEFINICJEDOKKSIEGOWYCH_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

CREATE TABLE POZDEFINICJIDOKKSIEGOWYCH
       (DEFINICJA       KLUCZ NOT NULL,
        ROK             INTEGER NOT NULL,
        LP              INTEGER NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        IDENT           DIDENT,
        TYPPOZYCJI      TYP,

        OPERACJA        IDENT,
        KLUCZE          KLUCZEKONT,
        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        SZABLON         varchar(250),
        STRONA          TYP,

        ZAKLAD          KLUCZ, 

        DANE            PARAMETRY,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DEFINICJA, ROK, LP));

CREATE INDEX POZDEFDOKKSIEGOWYCH_XKLUCZE ON POZDEFINICJIDOKKSIEGOWYCH(ROK, KLUCZE);
CREATE INDEX POZDEFDOKKSIEGOWYCH_XPODMIOT  ON POZDEFINICJIDOKKSIEGOWYCH(PODMIOT_FINANSOWY);

/* Dokumenty ksigowe */

CREATE TABLE DOKUMENTYKSIEGOWE
       (KLUCZ           KLUCZ NOT NULL,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        ROKVAT           INTEGER,            /* rok stawek VAT */
        VATROK           INTEGER NOT NULL,
        VATMIESIAC       INTEGER NOT NULL,
        VATTYP           TYP,                /* rozliczenie VAT */
        VATKOREKTA       TAKNIE,
        VATORYGKLUCZ     KLUCZ,
        VATORYGSYMBOL    MALA_NAZWA,
        VATORYGDATA_WYST TIMESTAMP,
        VATKOSZTOWY      WARTOSC,
        PARAGON          INTEGER,

        DEFINICJA       KLUCZ NOT NULL,
        AUTOMATPK       KLUCZ,
        ORYGINAL        KLUCZ,       /* Odwoanie do pierwotnego dokumentu */

        TYP_RACH_NFZ     IDENT,      /* 1-ubezpieczeni, 2-koordynacja, 3-zgoda wjta, 4-art.2 ust.1 pkt 3, 5-8 - bezpatnie wg art.12, 9-nieubezpieczeni uprawnieni, 10-OC */
        ODDZIAL_NFZ      KASACHORYCH,
        UMOWA_NFZ        KLUCZ,      /* wskazanie na UMOWY_NFZ.KLUCZ */
        SZABLON_RACH_NFZ INTEGER,    /* dla wykonania - pobierana na podstawie ROZLICZENIA_SWIADCZEN.SZABLON_RACHUNKU, dla kapitacji - nr pliku XML z rozliczeniem */
        KAPITACJA        TAKNIE,     /* Wskanik czy faktura dotyczy wykonania, czy kapitacji (deklaracji) */
        NFZ_PRZYCZYNA_KOREKTY VARCHAR(250),

        ANEKS_UGODOWY     DUZA_NAZWA,

        ROK_ROZL_NFZ      INTEGER,
        MIESIAC_ROZL_NFZ  INTEGER,

        KLASYFIKACJA1   KLUCZ,
        KLASYFIKACJA2   KLUCZ,
        KLASYFIKACJA3   KLUCZ,
        KLASYFIKACJA    VARCHAR(250),

        RODZAJDOK       SYMBOL,

        WLT_DATA        TIMESTAMP,
        WLT_KRAJ        IDENT,
        WLT_KURS        ILOSC,
        WLT_BANK        DUZA_NAZWA,
        WLT_NUMER       SYMBOL,
        WLT_RAZEM       WARTOSC,
        WLT_PLN         WARTOSC,  /* Rwnowarto waluty w PLN */
        WLT_ROZLICZENIE TYP,

        UE_KRAJ_WYSYLKI     VARCHAR(2),
        UE_KRAJ_WYTWORZENIA VARCHAR(2),
        UE_KOD_WAR_DOSTAWY  VARCHAR(3),
        UE_OPIS_WAR_DOSTAWY VARCHAR(100),
        UE_KOD_TRANSAKCJI   VARCHAR(2),
        UE_KOD_TRANSPORTU   VARCHAR(2),
        UE_TROJSTRONNE      VARCHAR(1),

        UC_SAD          DUZA_NAZWA,
        UC_DATA         TIMESTAMP,     /* Data odprawy celnej */
        UC_PODSTAWA_VAT WARTOSC,
        UC_VAT          WARTOSC,

        DRUKOWAL        KLUCZ,
        ZATWIERDZIL     KLUCZ,
        WYSLANO_XML     TAKNIE,

        ZAKLAD          KLUCZ,
        FIRMA           KLUCZ,
        PACJENT         KLUCZ,
        TYPDOTYCZY      TYP,
        TYP             TYP NOT NULL,

        TYP_DOKUM       DIDENT,
        NR_DOKUM        SYMBOL,

        SYMBOL          DUZA_NAZWA,
        ZBIORCZO        DUZA_NAZWA,
        OPIS            VARCHAR(150),
        UMOWA           DUZA_NAZWA,

        DATA_WYST       TIMESTAMP,
        DATA_OTRZ       TIMESTAMP,
        DATA_SPRZ       TIMESTAMP,
        DATA_REJ        TIMESTAMP,
        DATA_PLAT       TIMESTAMP,
        TYP_TER_PLAT    TYP,
        TERMIN_PLAT     INTEGER,

        NETTO           WARTOSC,
        VAT             WARTOSC,
        RAZEM           WARTOSC,
        ZAPLATA         WARTOSC,
        WINIEN          WARTOSC,
        MA              WARTOSC,

        BO              WARTOSC,
        WPLATY          WARTOSC,
        WYPLATY         WARTOSC,

        BO_VAT          WARTOSC,
        WPLATY_VAT      WARTOSC,
        WYPLATY_VAT     WARTOSC,
		SPLITPAYMENT    TAKNIE,     /* WSKANIK PATNOCI SPLITPAYMENT */
		FRASPLITPAYMENT TAKNIE,     /* WSKANIK FAKTURY SPLITPAYMENT */

        DANE            PARAMETRY,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(DEFINICJA, ROK) REFERENCES DEFINICJEDOKKSIEGOWYCH(KLUCZ, ROK),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(AUTOMATPK, ROK) REFERENCES AUTOMATYPK(KLUCZ, ROK),
        FOREIGN KEY(ZATWIERDZIL) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

CREATE INDEX DOKKSIEG_XROKMIESDATA    ON DOKUMENTYKSIEGOWE(ROK, MIESIAC, ZAKLAD, TYP, DATA_REJ, KLUCZ);
CREATE INDEX DOKKSIEG_XVATROKMIESDATA ON DOKUMENTYKSIEGOWE(VATROK, VATMIESIAC, ZAKLAD, TYP, DATA_REJ, KLUCZ);
CREATE INDEX DOKKSIEG_XZAKLAD         ON DOKUMENTYKSIEGOWE(ZAKLAD, ROK, MIESIAC, DATA_REJ, KLUCZ);
CREATE INDEX DOKKSIEG_XORYGINAL       ON DOKUMENTYKSIEGOWE(ORYGINAL);
CREATE INDEX DOKKSIEG_XOKRES          ON DOKUMENTYKSIEGOWE(TYP, ROK, MIESIAC, TYP_DOKUM, NR_DOKUM);
CREATE INDEX DOKKSIEG_XVATORYGKLUCZ   ON DOKUMENTYKSIEGOWE(VATORYGKLUCZ);
CREATE INDEX DOKKSIEG_XNFZ            ON DOKUMENTYKSIEGOWE(UMOWA_NFZ, SZABLON_RACH_NFZ);
CREATE INDEX DOKKSIEG_XPODMIOT        ON DOKUMENTYKSIEGOWE(PODMIOT_FINANSOWY);

SET TERM ^ ;
CREATE GENERATOR DOKUMENTYKSIEGOWE_GEN^

CREATE TRIGGER CREATE_DOKUMENTYKSIEGOWE FOR DOKUMENTYKSIEGOWE
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DOKUMENTYKSIEGOWE_GEN, 1);
END ^

CREATE PROCEDURE DAJ_DOKUMENTYKSIEGOWE
RETURNS (DOKUMENTYKSIEGOWE INTEGER)
AS BEGIN
  DOKUMENTYKSIEGOWE = GEN_ID(DOKUMENTYKSIEGOWE_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^


ALTER TABLE OBROTYMAGAZYNU
ADD  FOREIGN KEY(DO_FAKTURY) REFERENCES DOKUMENTYKSIEGOWE(KLUCZ);



CREATE TABLE POZDOKUMENTOWKSIEGOWYCH
       (DOKUMENT        KLUCZ NOT NULL,
        LP              INTEGER NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        DZIENNIK        INTEGER,

        PODMIOT_FINANSOWY KLUCZ,
        SRODEK          KLUCZ,         /* ewentualne odwoanie do rodka trwaego */
        KLASYFIKACJA    INTEGER,       /* ewentualne odwolanie do dodatkowej klasyfikacji */

        DATA_REJ        TIMESTAMP,          /* W nowym systemie */
        DATA_WYST       TIMESTAMP,
        DATA_OTRZ       TIMESTAMP,
        DATA_PLAT       TIMESTAMP,
        DATA_ZAPLATY    TIMESTAMP,

        KASABANK        INTEGER,       /* Lp dokumentu KB */
        AUTOMATPK       INTEGER,
        DEFINICJA       INTEGER,
        LPDEFINICJI     INTEGER,       /* dodatnia - automat, -200 -> BO, ... */
        TYPPOZYCJI      TYP,           /* Naleno, Zobowizanie */

        WSPOLCZYNNIK    WARTOSC,       /* Wspolczynnik rozksiegowania z automatu - nowy system */

        TYP             TYP,           /* z dokumentu typ */

        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        SYMBOL          DUZA_NAZWA,    /* Symbol dokumentu */

        KLUCZE          KLUCZEKONT,
        WINIEN          WARTOSC,
        MA              WARTOSC,

        WLT_KRAJ        IDENT,
        WLT_WINIEN      WARTOSC,
        WLT_MA          WARTOSC,

        OPISPK          DUZA_NAZWA,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DOKUMENT, LP));

CREATE INDEX POZDOKKSIEG_XKONTO ON POZDOKUMENTOWKSIEGOWYCH(ROK, DOKUMENT, LP);
CREATE INDEX POZDOKKSIEG_XROKMIES ON POZDOKUMENTOWKSIEGOWYCH(ROK, MIESIAC, DOKUMENT, LP);

CREATE INDEX POZDOKKSIEG_XDOTYCZY ON POZDOKUMENTOWKSIEGOWYCH(ROK, TYPDOTYCZY, DOTYCZY, SYMBOL);
CREATE INDEX POZDOKKSIEG_XDEFINICJA ON POZDOKUMENTOWKSIEGOWYCH(ROK, DOKUMENT, LPDEFINICJI);
CREATE INDEX POZDOKKSIEG_XDZIENNIK ON POZDOKUMENTOWKSIEGOWYCH(ROK, DZIENNIK);
CREATE INDEX POZDOKKSIEG_XSRODEK ON POZDOKUMENTOWKSIEGOWYCH(SRODEK);
CREATE INDEX POZDOKKSIEG_XPODMIOT ON POZDOKUMENTOWKSIEGOWYCH(PODMIOT_FINANSOWY);

COMMIT WORK;

CREATE TABLE DOKUMENTYKASYBANKU
       (DOKUMENT        KLUCZ NOT NULL,
        LP              INTEGER NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        DEFINICJA       INTEGER,      /* Klucz typu dokumentu */

        TYP             TYP,          /* Wpata, wYpata */
        NUMER           INTEGER,      /* Numer KW/KP */

        DATA_WYST       TIMESTAMP,

        WLT_DATA        TIMESTAMP,
        WLT_KRAJ        IDENT,
        WLT_KURS        ILOSC,
        WLT_BANK        DUZA_NAZWA,
        WLT_NUMER       SYMBOL,
        WLT_RAZEM       WARTOSC,

        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        SYMBOL          DUZA_NAZWA,    /* Symbol dokumentu */
        OPIS            DUZY_OPIS,
        KLASYFIKACJA    SYMBOL,

        ZALICZKOBIORCA  KLUCZ,
        SYMBOLZAL       DUZA_NAZWA,

        KWOTA           WARTOSC,
        VAT             WARTOSC,       /* VAT dla split payment */
        KASABANK        WARTOSC,       /* Faktyczna kwota wplaty/wyplaty - 0 gdy z zaliczki */
        KASABANK_VAT    WARTOSC,       /* praktycznie powtorzenie VAT */
		
        WINIEN          WARTOSC,
        MA              WARTOSC,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DOKUMENT, LP));

COMMIT WORK;

CREATE INDEX DOKUMENTYKB_XPODMIOT ON DOKUMENTYKASYBANKU(PODMIOT_FINANSOWY);

/* Podsumowanie obrotw  -  chyba ju nieistotne */

CREATE VIEW OBROTYKONT(ROK, MIESIAC, KLUCZE, TYP, DOTYCZY, PODMIOT_FINANSOWY, WINIEN, MA, ILOSC)
AS
SELECT ROK, MIESIAC, KLUCZE, TYPDOTYCZY, DOTYCZY, PODMIOT_FINANSOWY, SUM(WINIEN), SUM(MA), COUNT(*)
FROM POZDOKUMENTOWKSIEGOWYCH
GROUP BY ROK, MIESIAC, KLUCZE, TYPDOTYCZY, DOTYCZY, PODMIOT_FINANSOWY;

COMMIT WORK;

/* Tabela sald */

CREATE TABLE SALDA
       (KLUCZ           KLUCZ NOT NULL,
        ROK             INTEGER NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        NOTA            KLUCZ,         /* do noty odsetkowej (od zapaconych)*/
        LP              INTEGER,       /* nieaktualne */

        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        KLUCZE          KLUCZEKONT,
        SYMBOL          DUZA_NAZWA,    /* Symbol dowodu */

        WINIEN          WARTOSC,       /* obroty */
        MA              WARTOSC,
        SWINIEN         WARTOSC,       /* salda */
        SMA             WARTOSC,
        ROZLICZONE      TAKNIE NOT NULL,

        WLT_WINIEN      WARTOSC,       /* obroty */
        WLT_MA          WARTOSC,
        SWLT_WINIEN     WARTOSC,       /* salda */
        SWLT_MA         WARTOSC,

        ILOSC           INTEGER,
        WLT_ROZLICZONE  TAKNIE,

        ODSETKI         WARTOSC,  /* Odsetki s sumowane z wszystkich not, take od niezapaconych
                                     klucz do salda jest w pozycji noty, i stamtd s aktualizowane */
        DOLICZAC        TAKNIE,   /* Nieaktualne - teraz w notach */
        WLT_KRAJ        IDENT,    /* Dla sald walutowych - sluzy do przechowywania */

        PRIMARY KEY(KLUCZ));

CREATE INDEX SALDA_XNOTA ON SALDA(NOTA, LP);
CREATE INDEX SALDA_XROZLICZ ON SALDA(ROK, ROZLICZONE, TYPDOTYCZY, DOTYCZY, SYMBOL);
CREATE INDEX SALDA_XDOTYCZY ON SALDA(DOTYCZY, ROK, ROZLICZONE, TYPDOTYCZY, SYMBOL);
CREATE INDEX SALDA_XPODMIOT ON SALDA(PODMIOT_FINANSOWY);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_SALDA FOR SALDA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0 OR NEW.KLUCZ IS NULL)
  THEN NEW.KLUCZ = GEN_ID(DOKUMENTYKSIEGOWE_GEN, 1);
  IF (NEW.ODSETKI IS NULL)
  THEN NEW.ODSETKI = 0;
END ^

COMMIT WORK ^
SET TERM ; ^



/* Pozycje sald podczepione pod pozycj ksigowania,
   moe by kilka dla jednego ksigowania - dlatego klucz */ 

CREATE TABLE POZYCJE_SALD
       (KLUCZ           KLUCZ NOT NULL,
        SALDO           KLUCZ NOT NULL,
        DOKUMENT        KLUCZ NOT NULL,
        LP              INTEGER NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        DATA_WYST       TIMESTAMP,
        DATA_OTRZ       TIMESTAMP,
        DATA_PLAT       TIMESTAMP,
        DATA_ZAPLATY    TIMESTAMP,

        BZ_DOKUMENT     KLUCZ,         /* Odwoanie do oryginalnego dokumentu rozrachunkowego */
        BZ_LP           INTEGER,       /* tworzone przy imporcie bilansu zamknicia */
        BZ_DEFINICJA    INTEGER,       /* Odwoanie do oryginalnego rejestru */

        KASABANK        INTEGER,       /* Lp dokumentu KB */
        TYPPOZYCJI      TYP,           /* Naleno, Zobowizanie */

        TYPDOTYCZY      TYP NOT NULL,
        DOTYCZY         KLUCZ NOT NULL,
        SYMBOL          DUZA_NAZWA NOT NULL,    /* Symbol dokumentu */

        KLUCZE          KLUCZEKONT,
        WINIEN          WARTOSC,
        MA              WARTOSC,

        WLT_KRAJ        IDENT,
        WLT_WINIEN      WARTOSC,
        WLT_MA          WARTOSC,

        OPISPK          DUZA_NAZWA,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        FOREIGN KEY(SALDO) REFERENCES SALDA(KLUCZ),
        PRIMARY KEY(KLUCZ));

CREATE INDEX POZYCJE_SALD_XDOKUMLP ON POZYCJE_SALD(DOKUMENT, LP);   /* nie moe by obcy klucz - odczyt BZ */
CREATE INDEX POZYCJE_SALD_XBZ_DOKUMLP ON POZYCJE_SALD(BZ_DOKUMENT, BZ_LP);
CREATE INDEX POZYCJE_SALD_XDOTYCZY ON POZYCJE_SALD(DOTYCZY, TYPDOTYCZY, SYMBOL);
CREATE INDEX POZYCJE_SALD_XPODMIOT ON POZYCJE_SALD(PODMIOT_FINANSOWY);

COMMIT WORK;


/* Procedura obslugi sald */

SET TERM ^ ;

CREATE PROCEDURE DAJ_SALDO(
  PKLUCZ       INTEGER,                /* Dla istniejcego salda */
  PROK         INTEGER,
  PTYPDOTYCZY  VARCHAR(1),
  PDOTYCZY     INTEGER,
  PKLUCZE      VARCHAR(106),
  PSYMBOL      VARCHAR(40),
  PILOSC       INTEGER,                /* 1 : nowe, 0 : zmiana wartosci, -1 : usuwanie */
  PWINIEN      DOUBLE PRECISION,       /* Przyrost WN */
  PMA          DOUBLE PRECISION,       /* Przyrost MA */
  WLT_KRAJ     VARCHAR(3),             /* Przekazanie do przechowania - nie jest kontrolowane*/
  PWLT_WINIEN  DOUBLE PRECISION,       /* Przyrost waluty WN */
  PWLT_MA      DOUBLE PRECISION,       /* Przyrost waluty MA */
  PODMIOT      INTEGER)                /* Podmiot nie jest analizowany - dla rnych
                                          podmiotw bd rne klucze */
RETURNS(
  KLUCZ_SALDA  INTEGER)
AS
DECLARE VARIABLE VWINIEN DOUBLE PRECISION;
DECLARE VARIABLE VMA DOUBLE PRECISION;
DECLARE VARIABLE VSWINIEN DOUBLE PRECISION;
DECLARE VARIABLE VSMA DOUBLE PRECISION;

DECLARE VARIABLE VWLT_WINIEN DOUBLE PRECISION;
DECLARE VARIABLE VWLT_MA DOUBLE PRECISION;
DECLARE VARIABLE VSWLT_WINIEN DOUBLE PRECISION;
DECLARE VARIABLE VSWLT_MA DOUBLE PRECISION;

DECLARE VARIABLE VODSETKI DOUBLE PRECISION;

DECLARE VARIABLE VILOSC INTEGER;
DECLARE VARIABLE ROZLICZONE VARCHAR(1);
DECLARE VARIABLE WLT_ROZLICZONE VARCHAR(1);
BEGIN
  KLUCZ_SALDA = :PKLUCZ;

  VWINIEN = 0;
  VMA = 0;
  VSWINIEN = 0;
  VSMA = 0;

  VWLT_WINIEN = 0;
  VWLT_MA = 0;
  VSWLT_WINIEN = 0;
  VSWLT_MA = 0;

  VODSETKI = 0;

  VILOSC = 0;
  ROZLICZONE = '';
  WLT_ROZLICZONE = '';

  IF (:KLUCZ_SALDA = 0)
  THEN BEGIN
    SELECT KLUCZ, ROZLICZONE, ILOSC, WINIEN, MA, WLT_ROZLICZONE, WLT_WINIEN, WLT_MA, ODSETKI
    FROM SALDA
    WHERE
      ROK = :PROK AND TYPDOTYCZY = :PTYPDOTYCZY AND
      DOTYCZY = :PDOTYCZY AND KLUCZE = :PKLUCZE AND
      SYMBOL = :PSYMBOL AND
      NOTA IS NULL                   /* Salda noty (od zapaconych) s zablokowane */
    INTO
      :KLUCZ_SALDA, :ROZLICZONE, :VILOSC,
      :VWINIEN, :VMA, :WLT_ROZLICZONE, :VWLT_WINIEN, :VWLT_MA, :VODSETKI;
  END
  ELSE BEGIN
    SELECT ROZLICZONE, ILOSC, WINIEN, MA, WLT_ROZLICZONE, WLT_WINIEN, WLT_MA, ODSETKI
    FROM SALDA
    WHERE
      KLUCZ = :KLUCZ_SALDA
    INTO
      :ROZLICZONE, :VILOSC,
      :VWINIEN, :VMA, :WLT_ROZLICZONE, :VWLT_WINIEN, :VWLT_MA, :VODSETKI;
  END

  VWINIEN = :VWINIEN + :PWINIEN;
  VMA = :VMA + :PMA;

  VWLT_WINIEN = :VWLT_WINIEN + :PWLT_WINIEN;
  VWLT_MA = :VWLT_MA + :PWLT_MA;

  VILOSC = :VILOSC + :PILOSC;

  IF (:VWINIEN > :VMA)
  THEN BEGIN
    VSWINIEN = :VWINIEN - :VMA;
    VSMA = 0;
  END
  ELSE BEGIN
    VSWINIEN = 0;
    VSMA = :VMA - :VWINIEN;
  END

  IF (:VWLT_WINIEN > :VWLT_MA)
  THEN BEGIN
    VSWLT_WINIEN = :VWLT_WINIEN - :VWLT_MA;
    VSWLT_MA = 0;
  END
  ELSE BEGIN
    VSWLT_WINIEN = 0;
    VSWLT_MA = :VWLT_MA - :VWLT_WINIEN;
  END

  /* Usuwanie zbdnego opisu salda */

  IF (:VILOSC = 0 AND :KLUCZ_SALDA > 0)
  THEN BEGIN
    DELETE FROM SALDA WHERE KLUCZ = :KLUCZ_SALDA;
    KLUCZ_SALDA = 0;
  END

  /* Usuwanie rozliczenia */

  IF (:VILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    (:VSWINIEN > 0.001 OR :VSMA > 0.001) AND
    :ROZLICZONE = 'T')
  THEN ROZLICZONE = 'N';

  IF (:VILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    (:VSWLT_WINIEN > 0.001 OR :VSWLT_MA > 0.001) AND
    :WLT_ROZLICZONE = 'T')
  THEN WLT_ROZLICZONE = 'N';

  /* Wpisywanie rozliczenia */

  IF (:VILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    :VSWINIEN < 0.001 AND :VSMA < 0.001 AND
    :ROZLICZONE = 'N')
  THEN ROZLICZONE = 'T';

  IF (:VILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    :VSWLT_WINIEN < 0.001 AND :VSWLT_MA < 0.001 AND
    :WLT_ROZLICZONE = 'N')
  THEN WLT_ROZLICZONE = 'T';

  /* Nowe wartoci */

  IF (:VILOSC > 0 AND :KLUCZ_SALDA > 0)
  THEN
    UPDATE SALDA
    SET
      ROZLICZONE = :ROZLICZONE,
      WINIEN = :VWINIEN,
      MA = :VMA,
      SWINIEN = :VSWINIEN,
      SMA = :VSMA,
      WLT_WINIEN = :VWLT_WINIEN,
      WLT_MA = :VWLT_MA,
      SWLT_WINIEN = :VSWLT_WINIEN,
      SWLT_MA = :VSWLT_MA,
      WLT_ROZLICZONE = :WLT_ROZLICZONE,
      ILOSC = :VILOSC,
      ODSETKI = :VODSETKI
    WHERE KLUCZ = :KLUCZ_SALDA;

  /* Nowy opis salda */

  IF (:VILOSC > 0 AND :KLUCZ_SALDA = 0)
  THEN BEGIN
    KLUCZ_SALDA = GEN_ID(DOKUMENTYKSIEGOWE_GEN, 1);
    INSERT INTO SALDA(
      KLUCZ, ROK, TYPDOTYCZY, DOTYCZY,
      KLUCZE, SYMBOL, ROZLICZONE, WLT_KRAJ, PODMIOT_FINANSOWY,
      WINIEN, MA, SWINIEN, SMA,
      WLT_WINIEN, WLT_MA, SWLT_WINIEN, SWLT_MA, WLT_ROZLICZONE, ILOSC, ODSETKI)
    VALUES(
      :KLUCZ_SALDA, :PROK, :PTYPDOTYCZY, :PDOTYCZY,
      :PKLUCZE, :PSYMBOL, 'N', :WLT_KRAJ, :PODMIOT,
      :VWINIEN, :VMA, :VSWINIEN, :VSMA,
      :VWLT_WINIEN, :VWLT_MA, :VSWLT_WINIEN, :VSWLT_MA, 'N', :VILOSC, :VODSETKI);
  END

  SUSPEND;
END^
COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;

/*---*/

SET TERM ^ ;

CREATE PROCEDURE DAJ_TYPSALDA(
  PKLUCZ       INTEGER)
RETURNS(
  TYPSALDA  VARCHAR(1))
AS
DECLARE VARIABLE TYPPOZYCJI VARCHAR(1);
BEGIN
  TYPSALDA = '';

  FOR SELECT DISTINCT TypPozycji
  FROM Pozycje_sald
  WHERE Saldo = :PKLUCZ AND TypPozycji IN ('N', 'Z')
  INTO :TYPPOZYCJI
  DO BEGIN
    IF (TYPSALDA = '')
    THEN TYPSALDA = :TYPPOZYCJI;
    ELSE TYPSALDA = '';
  END

  SUSPEND;
END^
COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;

/* Obsuga pozycji sald */

SET TERM ^ ;

CREATE TRIGGER CREATE_POZYCJE_SALD FOR POZYCJE_SALD
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0 OR NEW.KLUCZ IS NULL)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);

  SELECT KLUCZ_SALDA
  FROM DAJ_SALDO(
    0, NEW.ROK, NEW.TYPDOTYCZY, NEW.DOTYCZY,
    NEW.KLUCZE, NEW.SYMBOL,
    1,
    NEW.WINIEN, NEW.MA, NEW.WLT_KRAJ, NEW.WLT_WINIEN, NEW.WLT_MA,
    NEW.PODMIOT)
  INTO NEW.SALDO;
END ^

SET TERM ; ^

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER UPDATE_POZYCJE_SALD_B FOR POZYCJE_SALD
ACTIVE BEFORE UPDATE POSITION 0
AS BEGIN
  IF (NEW.TYPDOTYCZY <> OLD.TYPDOTYCZY OR
    NEW.DOTYCZY <> OLD.DOTYCZY OR
    NEW.SYMBOL <> OLD.SYMBOL OR
    NEW.KLUCZE <> OLD.KLUCZE OR
    NEW.PODMIOT_FINANSOWY <> OLD.PODMIOT_FINANSOWY)
  THEN BEGIN
    SELECT KLUCZ_SALDA
    FROM DAJ_SALDO(
      0, NEW.ROK, NEW.TYPDOTYCZY, NEW.DOTYCZY,
      NEW.KLUCZE, NEW.SYMBOL,
      1,
      NEW.WINIEN, NEW.MA, NEW.WLT_KRAJ, NEW.WLT_WINIEN, NEW.WLT_MA,
      NEW.PODMIOT_FINANSOWY)
    INTO NEW.SALDO;
  END

  ELSE BEGIN
    SELECT KLUCZ_SALDA
    FROM DAJ_SALDO(
      OLD.SALDO, OLD.ROK, OLD.TYPDOTYCZY, OLD.DOTYCZY,
      OLD.KLUCZE, OLD.SYMBOL,
      0,
      NEW.WINIEN-OLD.WINIEN, NEW.MA-OLD.MA,
      NEW.WLT_KRAJ, NEW.WLT_WINIEN-OLD.WLT_WINIEN, NEW.WLT_MA-OLD.WLT_MA,
      OLD.PODMIOT_FINANSOWY)
    INTO NEW.SALDO;
  END
END ^

CREATE TRIGGER UPDATE_POZYCJE_SALD_A FOR POZYCJE_SALD
ACTIVE AFTER UPDATE POSITION 0
AS
DECLARE VARIABLE DUMMY INTEGER;
BEGIN
  IF (NEW.TYPDOTYCZY <> OLD.TYPDOTYCZY OR
    NEW.DOTYCZY <> OLD.DOTYCZY OR
    NEW.SYMBOL <> OLD.SYMBOL OR
    NEW.KLUCZE <> OLD.KLUCZE OR
    NEW.PODMIOT_FINANSOWY <> OLD.PODMIOT_FINANSOWY)
  THEN BEGIN
    SELECT KLUCZ_SALDA
    FROM DAJ_SALDO(
      OLD.SALDO, OLD.ROK, OLD.TYPDOTYCZY, OLD.DOTYCZY,
      OLD.KLUCZE, OLD.SYMBOL,
      -1,
      -OLD.WINIEN, -OLD.MA, OLD.WLT_KRAJ, -OLD.WLT_WINIEN, -OLD.WLT_MA,
      OLD.PODMIOT_FINANSOWY)
    INTO :DUMMY;
  END
END ^

SET TERM ; ^

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER DELETE_POZYCJE_SALD FOR POZYCJE_SALD
ACTIVE AFTER DELETE POSITION 0
AS
DECLARE VARIABLE DUMMY INTEGER;
BEGIN
  SELECT KLUCZ_SALDA
  FROM DAJ_SALDO(
    OLD.SALDO, OLD.ROK, OLD.TYPDOTYCZY, OLD.DOTYCZY,
    OLD.KLUCZE, OLD.SYMBOL,
    -1,
    -OLD.WINIEN, -OLD.MA, OLD.WLT_KRAJ, -OLD.WLT_WINIEN, -OLD.WLT_MA,
    OLD.PODMIOT)
  INTO :DUMMY;
END ^

COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;


/* Obsuga pozycji ksigowych */

SET TERM ^ ;

CREATE TRIGGER CREATE_POZDOKKSIEG_B FOR POZDOKUMENTOWKSIEGOWYCH
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.WINIEN IS NULL)        THEN NEW.WINIEN = 0;
  IF (NEW.MA IS NULL)            THEN NEW.MA = 0;

  IF (NEW.WLT_WINIEN IS NULL)    THEN NEW.WLT_WINIEN = 0;
  IF (NEW.WLT_MA IS NULL)        THEN NEW.WLT_MA = 0;
END ^

CREATE TRIGGER CREATE_POZDOKKSIEG_A FOR POZDOKUMENTOWKSIEGOWYCH
ACTIVE AFTER INSERT POSITION 0
AS BEGIN
  IF (NEW.TYPDOTYCZY IN ('K', 'P', 'C'))
  THEN
    INSERT INTO POZYCJE_SALD(
      DOKUMENT, LP, ROK, MIESIAC, PODMIOT_FINANSOWY,
      DATA_WYST, DATA_OTRZ, DATA_PLAT, DATA_ZAPLATY,
      KASABANK, TYPPOZYCJI,
      TYPDOTYCZY, DOTYCZY, SYMBOL, KLUCZE,
      WINIEN, MA, WLT_KRAJ, WLT_WINIEN, WLT_MA,
      OPISPK,
      UTWORZYL, UTWORZONO)
    VALUES(
      NEW.DOKUMENT, NEW.LP, NEW.ROK, NEW.MIESIAC, NEW.PODMIOT_FINANSOWY,
      NEW.DATA_WYST, NEW.DATA_OTRZ, NEW.DATA_PLAT, NEW.DATA_ZAPLATY,
      NEW.KASABANK, NEW.TYPPOZYCJI,
      NEW.TYPDOTYCZY, NEW.DOTYCZY, NEW.SYMBOL, NEW.KLUCZE,
      NEW.WINIEN, NEW.MA, NEW.WLT_KRAJ, NEW.WLT_WINIEN, NEW.WLT_MA,
      NEW.OPISPK,
      NEW.UTWORZYL, NEW.UTWORZONO);

END ^

SET TERM ; ^

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER UPDATE_POZDOKKSIEG_B FOR POZDOKUMENTOWKSIEGOWYCH
ACTIVE BEFORE UPDATE POSITION 0
AS BEGIN
  IF (OLD.TYPDOTYCZY IN ('K', 'P', 'C') AND
    (NEW.DZIENNIK IS NULL AND OLD.DZIENNIK IS NULL OR
     NEW.DZIENNIK IS NOT NULL AND OLD.DZIENNIK IS NOT NULL) /* Wyklucza zamykanie miesica */ )
  THEN
    DELETE FROM POZYCJE_SALD
    WHERE DOKUMENT = OLD.DOKUMENT AND LP = OLD.LP;
END ^

CREATE TRIGGER UPDATE_POZDOKKSIEG_A FOR POZDOKUMENTOWKSIEGOWYCH
ACTIVE AFTER UPDATE POSITION 0
AS BEGIN
  IF (NEW.TYPDOTYCZY IN ('K', 'P', 'C') AND
    (NEW.DZIENNIK IS NULL AND OLD.DZIENNIK IS NULL OR
     NEW.DZIENNIK IS NOT NULL AND OLD.DZIENNIK IS NOT NULL) /* Wyklucza zamykanie miesica */ )
  THEN
    INSERT INTO POZYCJE_SALD(
      DOKUMENT, LP, ROK, MIESIAC, PODMIOT_FINANSOWY,
      DATA_WYST, DATA_OTRZ, DATA_PLAT, DATA_ZAPLATY,
      KASABANK, TYPPOZYCJI,
      TYPDOTYCZY, DOTYCZY, SYMBOL, KLUCZE,
      WINIEN, MA, WLT_KRAJ, WLT_WINIEN, WLT_MA,
      OPISPK,
      UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO)
    VALUES(
      NEW.DOKUMENT, NEW.LP, NEW.ROK, NEW.MIESIAC, NEW.PODMIOT_FINANSOWY,
      NEW.DATA_WYST, NEW.DATA_OTRZ, NEW.DATA_PLAT, NEW.DATA_ZAPLATY,
      NEW.KASABANK, NEW.TYPPOZYCJI,
      NEW.TYPDOTYCZY, NEW.DOTYCZY, NEW.SYMBOL, NEW.KLUCZE,
      NEW.WINIEN, NEW.MA, NEW.WLT_KRAJ, NEW.WLT_WINIEN, NEW.WLT_MA,
      NEW.OPISPK,
      NEW.UTWORZYL, NEW.ZMIENIAL, NEW.UTWORZONO, NEW.ZMIENIANO);

END ^

SET TERM ; ^

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER DELETE_POZDOKKSIEG_A FOR POZDOKUMENTOWKSIEGOWYCH
ACTIVE AFTER DELETE POSITION 0
AS
BEGIN
  IF (OLD.TYPDOTYCZY IN ('K', 'P', 'C'))
  THEN
    DELETE FROM POZYCJE_SALD
    WHERE DOKUMENT = OLD.DOKUMENT AND LP = OLD.LP;
END ^

COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;


/* Dane salda dokumentu */

SET TERM ^ ;

CREATE PROCEDURE DANE_SALDA_DOKUMENTU(
  DOKUMENT  INTEGER,
  FIRMA     INTEGER,
  PACJENT   INTEGER,
  ROKSALDA  INTEGER
  )
RETURNS(
  WINIEN           DOUBLE PRECISION,
  MA               DOUBLE PRECISION,
  ROZLICZONE       VARCHAR(1),
  ILOSC_SALD       INTEGER
  )
AS
DECLARE VARIABLE DOTYCZY INTEGER;
DECLARE VARIABLE TYPDOTYCZY VARCHAR(1);
BEGIN
  WINIEN = 0;
  MA = 0;
  ROZLICZONE = 'N';
  ILOSC_SALD = 0;

  DOTYCZY = 0;

  IF (:FIRMA > 0)
  THEN BEGIN
    DOTYCZY = :FIRMA;
    TYPDOTYCZY = 'K';
  END

  ELSE IF (:PACJENT > 0)
  THEN BEGIN
    DOTYCZY = :PACJENT;
    TYPDOTYCZY = 'C';
  END

  IF (:DOTYCZY > 0)
  THEN BEGIN
    FOR SELECT S.SWINIEN, S.SMA, S.ROZLICZONE
    FROM SALDA S
    WHERE
      S.ROK = :ROKSALDA AND S.DOTYCZY = :DOTYCZY AND S.TYPDOTYCZY = :TYPDOTYCZY AND
      (SELECT COUNT(P.KLUCZ) FROM POZYCJE_SALD P
       WHERE
         P.SALDO = S.KLUCZ AND P.ROK = S.ROK AND
         (P.DOKUMENT = :DOKUMENT OR P.BZ_DOKUMENT = :DOKUMENT)) > 0
    INTO :WINIEN, :MA, :ROZLICZONE
    DO BEGIN
      ILOSC_SALD = :ILOSC_SALD + 1;
    END
  END
  SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/* Tabela odsetkowa */

CREATE TABLE ODSETKI
       (TYPDOTYCZY       TYP NOT NULL,     /* ' ' - oglne, Kontrahenci, Pracownicy, paCjenci, miesZkaniowe */
        DTYP             TYP NOT NULL,
        DOTYCZY          KLUCZ NOT NULL,
        DATA             TIMESTAMP NOT NULL,
        PROCENT          DOUBLE PRECISION,

        PRIMARY KEY(TYPDOTYCZY, DTYP, DOTYCZY, DATA));

COMMIT WORK;

SET TERM ^ ;

CREATE PROCEDURE TABELAODSETKOWA(
  PTYPDOTYCZY  VARCHAR(1),
  PGRUPA       VARCHAR(1),
  PDOTYCZY     INTEGER)
RETURNS(
  TYPDOTYCZY  VARCHAR(1),
  DTYP        VARCHAR(1),
  DOTYCZY     INTEGER,
  DATA        TIMESTAMP,
  PROCENT     DOUBLE PRECISION)
AS
DECLARE VARIABLE SADANE INTEGER;
BEGIN
  TYPDOTYCZY = :PTYPDOTYCZY;
  DTYP = :PGRUPA;
  DOTYCZY = :PDOTYCZY;
  SADANE = 0;

  IF (:PTYPDOTYCZY <> ' ' AND :PDOTYCZY > 0)
  THEN BEGIN
    FOR SELECT Data, Procent FROM Odsetki
    WHERE TypDotyczy = :PTYPDOTYCZY AND Dotyczy = :PDOTYCZY
    ORDER BY data
    INTO :DATA, :PROCENT
    DO BEGIN
      SADANE = 1;
      SUSPEND;
    END

    IF (:SADANE = 0 AND :PTYPDOTYCZY = 'K')
    THEN FOR SELECT Data, Procent FROM Odsetki
    WHERE TypDotyczy = :PTYPDOTYCZY AND DTyp <> ' ' AND
      DTyp = (SELECT grupa FROM firmy WHERE klucz = :PDOTYCZY)
    ORDER BY data
    INTO :DATA, :PROCENT
    DO BEGIN
      SADANE = 1;
      SUSPEND;
    END
  END

  IF (:SADANE = 0 AND :PTYPDOTYCZY = 'K' AND :PGRUPA <> ' ' AND :PDOTYCZY = 0)
  THEN FOR SELECT Data, Procent FROM Odsetki
  WHERE TypDotyczy = :PTYPDOTYCZY AND DTyp = :PGRUPA AND Dotyczy = 0
  ORDER BY data
  INTO :DATA, :PROCENT
  DO BEGIN
    SADANE = 1;
    SUSPEND;
  END

  IF (:SADANE = 0 AND :PTYPDOTYCZY <> ' ')
  THEN FOR SELECT Data, Procent FROM Odsetki
  WHERE TypDotyczy = :PTYPDOTYCZY AND DTyp = ' ' AND Dotyczy = 0
  ORDER BY data
  INTO :DATA, :PROCENT
  DO BEGIN
    SADANE = 1;
    SUSPEND;
  END

  IF (:SADANE = 0)
  THEN FOR SELECT Data, Procent FROM Odsetki
  WHERE TypDotyczy = ' ' AND DTyp = ' ' AND Dotyczy = 0
  ORDER BY data
  INTO :DATA, :PROCENT
  DO BEGIN
    SADANE = 1;
    SUSPEND;
  END
END^
COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;

/* Dokumenty sald */

SET TERM ^;

CREATE PROCEDURE SALDANADZIEN(
  PKLUCZE     VARCHAR(106),
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  ODSETKI     DOUBLE PRECISION,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj, S.Odsetki,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol,
    S.Wlt_kraj, S.Odsetki, S.Podmiot_finansowy
  HAVING
    Sum(P.Winien) - Sum(P.Ma) < -0.001 OR
    Sum(P.Winien) - Sum(P.Ma) > 0.001 OR
    Sum(P.Winien) IS NULL OR Sum(P.Ma) IS NULL
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ, :ODSETKI,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)   /* Z bilansu otwarcia - szukamy pierwszego dokumentu */
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P
    WHERE
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE SALDADODNIA(
  PKLUCZE     VARCHAR(106),
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
/*
W STOSUNKU DO PROCEDURY SALDANADZIEN BRAK WARUNKU - S.Rozliczone = 'N' -> HAVING
*/
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)   /* BO */
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P
    WHERE
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

/* indywidualne salda */

SET TERM ^;

CREATE PROCEDURE INDSALDANADZIEN(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  HAVING
    Sum(P.Winien) - Sum(P.Ma) < -0.001 OR
    Sum(P.Winien) - Sum(P.Ma) > 0.001 OR
    Sum(P.Winien) IS NULL OR Sum(P.Ma) IS NULL
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;
    
    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P
    WHERE
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE INDSALDADODNIA(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
/*
W STOSUNKU DO PROCEDURY INDSALDANADZIEN BRAK WARUNKU S.Rozliczone = 'N' - HAVING
*/
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P
    WHERE
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE INDSALDA(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER)
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  DATA_WYST   TIMESTAMP,
  DATA_OTRZ   TIMESTAMP,
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    SELECT Max(P.Data_wyst), Max(P.Data_otrz), Max(P.Data_plat)
    FROM Pozycje_sald P
    WHERE
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_WYST, :DATA_OTRZ, :DATA_PLAT;
    SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

/*------------------------------------*/
/* Dokumenty sald zatwierdzone        */
/*------------------------------------*/

SET TERM ^;

CREATE PROCEDURE SALDANADZIEN_ZATW(
  PKLUCZE     VARCHAR(106),
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Zatwierdzil > 0 AND D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  HAVING
    Sum(P.Winien) - Sum(P.Ma) < -0.001 OR
    Sum(P.Winien) - Sum(P.Ma) > 0.001 OR
    Sum(P.Winien) IS NULL OR Sum(P.Ma) IS NULL
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE SALDADODNIA_ZATW(
  PKLUCZE     VARCHAR(106),
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
/*
W STOSUNKU DO PROCEDURY SALDANADZIEN BRAK WARUNKU S.Rozliczone = 'N' - HAVING
*/
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Zatwierdzil > 0 AND D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

/* indywidualne salda */

SET TERM ^;

CREATE PROCEDURE INDSALDANADZIEN_ZATW(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Zatwierdzil > 0 AND D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  HAVING
    Sum(P.Winien) - Sum(P.Ma) < -0.001 OR
    Sum(P.Winien) - Sum(P.Ma) > 0.001 OR
    Sum(P.Winien) IS NULL OR Sum(P.Ma) IS NULL
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;
    
    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE INDSALDADODNIA_ZATW(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
/*
W STOSUNKU DO PROCEDURY INDSALDANADZIEN BRAK WARUNKU S.Rozliczone = 'N' - HAVING
*/
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Zatwierdzil > 0 AND D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE INDSALDA_ZATW(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER)
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  DATA_WYST   TIMESTAMP,
  DATA_OTRZ   TIMESTAMP,
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    D.Zatwierdzil > 0
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    SELECT Max(P.Data_wyst), Max(P.Data_otrz), Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND D.Zatwierdzil > 0 AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_WYST, :DATA_OTRZ, :DATA_PLAT;
    SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

/*------------------------------------*/
/* Dokumenty sald robocze             */
/*------------------------------------*/

SET TERM ^;

CREATE PROCEDURE SALDANADZIEN_ROB(
  PKLUCZE     VARCHAR(106),
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  HAVING
    Sum(P.Winien) - Sum(P.Ma) < -0.001 OR
    Sum(P.Winien) - Sum(P.Ma) > 0.001 OR
    Sum(P.Winien) IS NULL OR Sum(P.Ma) IS NULL
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE SALDADODNIA_ROB(
  PKLUCZE     VARCHAR(106),
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
/*
W STOSUNKU DO PROCEDURY SALDANADZIEN BRAK WARUNKU S.Rozliczone = 'N' - HAVING
*/
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

/* indywidualne salda */

SET TERM ^;

CREATE PROCEDURE INDSALDANADZIEN_ROB(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  HAVING
    Sum(P.Winien) - Sum(P.Ma) < -0.001 OR
    Sum(P.Winien) - Sum(P.Ma) > 0.001 OR
    Sum(P.Winien) IS NULL OR Sum(P.Ma) IS NULL
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;
    
    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE INDSALDADODNIA_ROB(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER,
  PDATA_REJ   TIMESTAMP,
  PDATA_PLAT  TIMESTAMP,
  TEST_PLAT   VARCHAR(1))
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  NAZWA       VARCHAR(60),
  IDENT       VARCHAR(15),
  GRUPA       VARCHAR(1),
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
/*
W STOSUNKU DO PROCEDURY INDSALDANADZIEN BRAK WARUNKU S.Rozliczone = 'N' - HAVING
*/
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND D.Data_rej < :PDATA_REJ
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:SWINIEN > :SMA)
    THEN BEGIN
      SWINIEN = :SWINIEN - :SMA;
      SMA = 0;
    END
    ELSE BEGIN
      SMA = :SMA - :SWINIEN;
      SWINIEN = 0;
    END

    IF (:WWINIEN > :WMA)
    THEN BEGIN
      WWINIEN = :WWINIEN - :WMA;
      WMA = 0;
    END
    ELSE BEGIN
      WMA = :WMA - :WWINIEN;
      WWINIEN = 0;
    END

    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    NAZWA = '';
    IDENT = '';
    GRUPA = '';

    IF (:TYPDOTYCZY = 'K' AND :DOTYCZY > 0)
    THEN SELECT Nazwa, Ident, Grupa
      FROM Firmy WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT, :GRUPA;

    IF (:TYPDOTYCZY = 'C' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Pacjenci WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    IF (:TYPDOTYCZY = 'P' AND :DOTYCZY > 0)
    THEN SELECT Nazwisko || ' ' || Imie, Numer
      FROM Osoby WHERE Klucz = :DOTYCZY
      INTO :NAZWA, :IDENT;

    SELECT Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_PLAT;

    IF (:TEST_PLAT = 'T')
    THEN BEGIN
      IF (:DATA_PLAT < :PDATA_PLAT)
      THEN SUSPEND;
    END
    ELSE SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE INDSALDA_ROB(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER)
RETURNS(
  SALDO       INTEGER,
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  DATA_WYST   TIMESTAMP,
  DATA_OTRZ   TIMESTAMP,
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    S.Klucz, S.Klucze, S.TypDotyczy, S.Dotyczy, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM
    (Salda S JOIN Pozycje_sald P ON P.Saldo = S.Klucz AND
      S.Rok = :PROK AND S.Klucze LIKE :PKLUCZE AND
      S.Dotyczy = :PDOTYCZY AND S.TypDotyczy = :PTYPDOTYCZY)
    JOIN DokumentyKsiegowe D ON D.Klucz = P.Dokument
  WHERE
    (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0)
  GROUP BY S.Klucz, S.Dotyczy, S.TypDotyczy, S.klucze, S.Symbol, S.Wlt_kraj,
    S.Podmiot_finansowy
  INTO :SALDO, :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P, DokumentyKsiegowe D
      WHERE
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    SELECT Max(P.Data_wyst), Max(P.Data_otrz), Max(P.Data_plat)
    FROM Pozycje_sald P, DokumentyKsiegowe D
    WHERE
      D.Klucz = P.Dokument AND (D.Zatwierdzil IS NULL OR D.Zatwierdzil = 0) AND
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :PKLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_WYST, :DATA_OTRZ, :DATA_PLAT;
    SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

/*-----------------------------------------------------*/
/* Wyraenia */

CREATE TABLE WYRAZENIA
       (ROK             INTEGER NOT NULL,
        KLUCZ           KLUCZ NOT NULL,
        OPERACJA        DIDENT,
        IDENT           VARCHAR(30),
        NAZWA           VARCHAR(50),

        TECHNICZNE      VARCHAR(1),

        PODMIOT_FINANSOWY KLUCZ,

        KLUCZE          KLUCZEKONT,
        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        SZABLON         VARCHAR(250),

        STRONA          IDENT,
        POCZ_OKRESU     IDENT,
        KON_OKRESU      IDENT,

        EWIDENCJA       DIDENT,       /* takze argument wyrazenia VAT7 */

        REJESTRY        VARCHAR(250),
        ROZL_VAT        VARCHAR(25),
        RODZAJ_VAT      TYP,          /* N - naliczony, nalezny,  O - odwrocony,  R - razem (domyslnie) */ 
        WIERSZVAT7      VARCHAR(2),   /* 14, 15 - okresla wiersz deklaracji VAT */

        WSPOLCZYNNIK    DOUBLE PRECISION,
        ZAOKRAGLENIE    INTEGER,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ, ROK));

CREATE INDEX WYRAZENIA_XROKOPER ON WYRAZENIA(ROK, OPERACJA, NAZWA);
CREATE INDEX WYRAZENIA_XROKNAZWA ON WYRAZENIA(ROK, NAZWA);
CREATE INDEX WYRAZENIA_XROKIDNAZWA ON WYRAZENIA(ROK, IDENT, NAZWA);
CREATE INDEX WYRAZENIA_XPODMIOT ON WYRAZENIA(PODMIOT_FINANSOWY);

COMMIT WORK;

SET TERM ^ ;
CREATE GENERATOR WYRAZENIA_GEN^

CREATE TRIGGER CREATE_WYRAZENIA FOR WYRAZENIA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(WYRAZENIA_GEN, 1);
END ^

CREATE PROCEDURE DAJ_WYRAZENIA
RETURNS (WYRAZENIA INTEGER)
AS BEGIN
  WYRAZENIA = GEN_ID(WYRAZENIA_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

CREATE TABLE ARGUMENTY
       (ROK             INTEGER NOT NULL,
        WYRAZENIE       KLUCZ NOT NULL,
        ARGUMENT        KLUCZ NOT NULL,

        LP              INTEGER,
        ZNAK            TYP,

        PODMIOT_FINANSOWY KLUCZ,

        UTWORZYL      KLUCZ,
        UTWORZONO     TIMESTAMP,

        FOREIGN KEY(WYRAZENIE, ROK) REFERENCES WYRAZENIA(KLUCZ, ROK),
        FOREIGN KEY(ARGUMENT, ROK) REFERENCES WYRAZENIA(KLUCZ, ROK),
        PRIMARY KEY(ROK, WYRAZENIE, ARGUMENT));

COMMIT WORK;


/* Tabele wyrae */

CREATE TABLE TABLICEWYRAZEN                       
       (KLUCZ           KLUCZ NOT NULL, /* DAJ_WYRAZENIA */
        NAZWA           OPIS,

        PODMIOT_FINANSOWY KLUCZ,

        TYP             TYP,           /* nie jest uzywane */
		RODZAJ          VARCHAR(10),   /* RODZAJ DO XML */

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));


CREATE TABLE POZYCJETABLICWYRAZEN
       (TABLICAWYRAZEN  KLUCZ NOT NULL,         
        LP              INTEGER NOT NULL,

        GRUPA1          SYMBOL,
        NAZWA1          VARCHAR(50),
        GRUPA2          SYMBOL,
        NAZWA2          VARCHAR(50),
        GRUPA3          SYMBOL,
        NAZWA3          VARCHAR(50),

		RODZAJ          VARCHAR(30),   /* RODZAJ DO XML */
		PODRODZAJ       VARCHAR(30),   /* PODRODZAJ DO XML - pozycja uszczegolawiajaca */

        IDENT           VARCHAR(30),     /* ident wyraenia */
        NAZWA           VARCHAR(80),     /* nazwa na wydruku */

        IDENT1          VARCHAR(30),     /* ident wyraenia */
        IDENT2          VARCHAR(30),     /* ident wyraenia */
        IDENT3          VARCHAR(30),     /* ident wyraenia */
        IDENT4          VARCHAR(30),     /* ident wyraenia */
        IDENT5          VARCHAR(30),     /* ident wyraenia */
        IDENT6          VARCHAR(30),     /* ident wyraenia */
        IDENT7          VARCHAR(30),     /* ident wyraenia */
        IDENT8          VARCHAR(30),     /* ident wyraenia */
        IDENT9          VARCHAR(30),     /* ident wyraenia */

        POCZ_OKRESU     IDENT,
        KON_OKRESU      IDENT,

        OPIS             UWAGI,
        SPOSOBY_WYLICZEN UWAGI,
        MIERNIK          MALA_NAZWA,

        FONT          VARCHAR(100),
        FONT1         VARCHAR(100),
        FONT2         VARCHAR(100),
        FONT3         VARCHAR(100),

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(TABLICAWYRAZEN, LP));
		
/* --- */		

CREATE TABLE SPRAWOZDANIAFIN               
       (KLUCZ           KLUCZ NOT NULL,
        PODMIOT_FINANSOWY KLUCZ,
		ROK             INTEGER,
		LP              INTEGER,
		TYP             TYP,              /* I - inna, M - mala */
		OPIS            VARCHAR(100),

        DATA_OD         TIMESTAMP,
        DATA_DO         TIMESTAMP,
        DATA_SPRZ       TIMESTAMP,
		
		ZAWIERA         VARCHAR(100),            /* wykaz sprawozdan - aktywa, pasywa, ... */

        KRS              VARCHAR(15),
		KODY_PKD         PARAMETRY,
        POLITYKA_RACH    PARAMETRY,              /* od 2019 pozostale dane */
        WYCENA_AKTPAS    PARAMETRY,
        USTALENIE_WYNFIN PARAMETRY,
        SPOSOB_SPORZ     PARAMETRY,
        INFO_SZCZEGOLY   PARAMETRY, 		
		
		DANE             PARAMETRY,
		
		XML              XML2,  
		XML_PODPIS       XML2, 
        ZATWIERDZIL      KLUCZ,		
		
        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE INDEX SPRFIN_DATA_OD ON SPRAWOZDANIAFIN(DATA_OD, LP);
		
CREATE TABLE POZSPRAWOZDANIAFIN               
       (SPRAWOZDANIE	   KLUCZ NOT NULL,
	    RODZAJDANYCH       VARCHAR(10) NOT NULL,
		LP                 INTEGER NOT NULL,

        GRUPA              SYMBOL,
        RODZAJPOZ          VARCHAR(30),
		PODRODZAJPOZ       VARCHAR(30),   /* PODRODZAJ DO XML - pozycja uszczegolawiajaca */
        NAZWA              VARCHAR(200),

		KWOTA_A            WARTOSC,
		KWOTA_B            WARTOSC,
        KWOTA_B1           WARTOSC,

        PRIMARY KEY(SPRAWOZDANIE, RODZAJDANYCH, LP)); 
		
CREATE TABLE POZSPRAWOZDANIAPOD               
       (SPRAWOZDANIE	   KLUCZ NOT NULL,
		LP                 INTEGER NOT NULL,

        RODZAJPOZ          VARCHAR(30),
        NAZWA              VARCHAR(200),

		RB                 WARTOSC,
		RP                 WARTOSC,
		
		RBA                WARTOSC,
		RBB                WARTOSC,
		RBC                WARTOSC,

		RPA                WARTOSC,
		RPB                WARTOSC,
		RPC                WARTOSC,
		
		ART                VARCHAR(10),  
		UST                VARCHAR(10),  
		PKT                VARCHAR(10),  
		LIT                VARCHAR(10),  
		
        PRIMARY KEY(SPRAWOZDANIE, LP)); 

		
/* Tabela not odsetkowych */

CREATE TABLE NOTYODSETKOWE
       (KLUCZ           KLUCZ NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        NR_DOKUM        SYMBOL,

        PODMIOT_FINANSOWY KLUCZ,

        TYP_NOTY        TYP,

        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        KLUCZE          KLUCZEKONT,

        ODSETKIOD       TIMESTAMP,
        DATA_WYST       TIMESTAMP,

        RAZEM           WARTOSC,
        DANE            PARAMETRY,

        ZATWIERDZIL     KLUCZ,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZATWIERDZIL) REFERENCES OSOBY(KLUCZ));

CREATE INDEX NOTY_XROKMIESNR ON NOTYODSETKOWE(ROK, MIESIAC, NR_DOKUM);
CREATE INDEX NOTY_XPODMIOT ON NOTYODSETKOWE(PODMIOT_FINANSOWY);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_NOTYODSETKOWE FOR NOTYODSETKOWE
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DOKUMENTYKSIEGOWE_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^

/*---*/

CREATE TABLE POZYCJE_NOT_ODSETKOWYCH
       (NOTA            KLUCZ NOT NULL,
        SALDO           KLUCZ NOT NULL,
        LP              INTEGER,

        MAX_DOK         KLUCZ,   /* Maksymalny nr dokumentu objty not */

        ODSETKI         WARTOSC,
        DOLICZAC        TAKNIE,

        PRIMARY KEY(NOTA, SALDO));

SET TERM ^ ;

CREATE TRIGGER DELETE_POZYCJE_NOT_ODS FOR POZYCJE_NOT_ODSETKOWYCH
ACTIVE BEFORE DELETE POSITION 0
AS
BEGIN
  UPDATE Salda S
  SET S.odsetki = S.odsetki - OLD.ODSETKI
  WHERE S.KLUCZ = OLD.SALDO;
END ^

COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;

/*---*/

CREATE TABLE KONTASRODKOW
       (SRODEKTRWALY    KLUCZ NOT NULL,
        ROK             INTEGER NOT NULL,
        LP              INTEGER NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        KLUCZE          KLUCZEKONT,
		ZNAK            TYP,
        STRONA          TYP,          /* Winien, Ma, domylnie W */
        EWIDENCJA       DIDENT,       /* Gdy podana, dotyczy > 0 i procent = 0,
                                         to zastpuje procent dla dotyczy */

        PROCENT       WARTOSC,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(SRODEKTRWALY, ROK, LP));

COMMIT WORK;


/* Rejestry VAT */

CREATE TABLE REJESTRYVAT
       (KLUCZ           KLUCZ NOT NULL,
        DOKUMENT        KLUCZ NOT NULL,      /* zawsze klucz pierwotnego dokumentu */

        ROK             INTEGER NOT NULL,    /* dla wersji 0 zgodne z oryginalem */
        MIESIAC         INTEGER NOT NULL,    /* dla pozostalych z dokumentem korekty */
        DATA_REJ        TIMESTAMP,

        ORYGKLUCZ       KLUCZ,               /* gdy korekta wskazuje poprzednia pozycje */
        WERSJA          INTEGER,             /* nr wersji w ciagu korekt od 0 - dla tego samego DOKUMENT */

        DZIALANIE       INTEGER,             /* 0 - lub NULL zaksiegowanie, 1 - wyksiegowanie (naprzemiennie) */

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(DOKUMENT) REFERENCES DOKUMENTYKSIEGOWE(KLUCZ));

CREATE INDEX REJVAT_XROKMIES    ON REJESTRYVAT(ROK, MIESIAC, KLUCZ);
CREATE INDEX REJVAT_ORYGKLUCZ   ON REJESTRYVAT(ORYGKLUCZ);

/* --- */

CREATE TABLE POZYCJEREJESTRUVAT
       (REJESTR         KLUCZ NOT NULL,
        LP              KLUCZ NOT NULL,
        LPORYGINALU     INTEGER,   /* Przy korektach - juz bez znaczenia */

        ROKVAT           INTEGER,            /* rok stawek VAT */
        VATROK           INTEGER NOT NULL,
        VATMIESIAC       INTEGER NOT NULL,

        DLAURZEDU       VARCHAR(2), /* FP - nalezny (faktury), ZP - naliczony (zakupy), FO, ZO - odwrocony */
        WIERSZVAT7      VARCHAR(2), /* 14, 15 - okresla wiersz deklaracji VAT */

        TYPVAT          TYP,        /* stawka Vat */
        VATTYP          TYP,        /* sposb rozliczenia Vat */

        NETTO           WARTOSC,
        VAT             WARTOSC,
        VAT_KOSZTY      WARTOSC,
        BRUTTO          WARTOSC,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(REJESTR, LP));

CREATE INDEX POZREJVAT_XVATROKMIES ON POZYCJEREJESTRUVAT(VATROK, VATMIESIAC, REJESTR);



/* Kopiowanie definicji finansowych */

SET TERM ^ ;

CREATE PROCEDURE KOPIUJDEFINICJEFINANSOWE(STARYROK INTEGER, PODMIOT INTEGER)
AS BEGIN

INSERT INTO AUTOMATYPK
  (KLUCZ, ROK, PODMIOT_FINANSOWY, NAZWA, UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO)
SELECT
  KLUCZ, ROK + 1, PODMIOT_FINANSOWY, NAZWA, UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO
FROM AUTOMATYPK
WHERE ROK = :STARYROK AND PODMIOT_FINANSOWY = :PODMIOT;

INSERT INTO DEFINICJEDOKKSIEGOWYCH
  (KLUCZ, ROK, ZAKLAD, AUTOMATPK, LP, TYP, RODZAJ, PODRODZAJ, NAZWA,
   BEZWYKSIEGOWANIA, PODMIOT_FINANSOWY,
   KLUCZE, TYPDOTYCZY, DOTYCZY, SZABLON, STRONA,
   KLUCZE_VAT, TYPDOTYCZY_VAT, DOTYCZY_VAT, ODEJMOWAC_VAT, CZERWONY_VAT,
   KLUCZE_DRK, TYPDOTYCZY_DRK, DOTYCZY_DRK,
   KLUCZE_URK, TYPDOTYCZY_URK, DOTYCZY_URK,
   KLASYFIKACJA1, KLASYFIKACJA2, KLASYFIKACJA3,
   WYMAGANE1, WYMAGANE2, WYMAGANE3,
   ZALICZKI, DANE,
   UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO)
SELECT
  KLUCZ, ROK + 1, ZAKLAD, AUTOMATPK, LP, TYP, RODZAJ, PODRODZAJ, NAZWA,
  BEZWYKSIEGOWANIA, PODMIOT_FINANSOWY,
  KLUCZE, TYPDOTYCZY, DOTYCZY, SZABLON, STRONA,
  KLUCZE_VAT, TYPDOTYCZY_VAT, DOTYCZY_VAT, ODEJMOWAC_VAT, CZERWONY_VAT,
  KLUCZE_DRK, TYPDOTYCZY_DRK, DOTYCZY_DRK,
  KLUCZE_URK, TYPDOTYCZY_URK, DOTYCZY_URK,
  KLASYFIKACJA1, KLASYFIKACJA2, KLASYFIKACJA3,
  WYMAGANE1, WYMAGANE2, WYMAGANE3,
  ZALICZKI, DANE,
  UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO
FROM DEFINICJEDOKKSIEGOWYCH
WHERE ROK = :STARYROK AND PODMIOT_FINANSOWY = :PODMIOT;

INSERT INTO POZDEFINICJIDOKKSIEGOWYCH
  (DEFINICJA, ROK, LP, IDENT, TYPPOZYCJI, OPERACJA, KLUCZE, TYPDOTYCZY, DOTYCZY,
   ZAKLAD, PODMIOT_FINANSOWY,
   SZABLON, STRONA, DANE,
   UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO)
SELECT
  DEFINICJA, ROK + 1, LP, IDENT, TYPPOZYCJI, OPERACJA, KLUCZE, TYPDOTYCZY, DOTYCZY,
  ZAKLAD, PODMIOT_FINANSOWY,
  SZABLON, STRONA, DANE,
  UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO
FROM POZDEFINICJIDOKKSIEGOWYCH
WHERE ROK = :STARYROK AND PODMIOT_FINANSOWY = :PODMIOT;

INSERT INTO WYRAZENIA
  (ROK, KLUCZ, OPERACJA, IDENT, NAZWA, KLUCZE, TYPDOTYCZY, DOTYCZY, SZABLON,
   STRONA, POCZ_OKRESU, KON_OKRESU, EWIDENCJA, WSPOLCZYNNIK, ZAOKRAGLENIE,
   PODMIOT_FINANSOWY, REJESTRY, ROZL_VAT, RODZAJ_VAT, WIERSZVAT7,
   UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO)
SELECT
  ROK + 1, KLUCZ, OPERACJA, IDENT, NAZWA, KLUCZE, TYPDOTYCZY, DOTYCZY, SZABLON,
   STRONA, POCZ_OKRESU, KON_OKRESU, EWIDENCJA, WSPOLCZYNNIK, ZAOKRAGLENIE,
   PODMIOT_FINANSOWY,  REJESTRY, ROZL_VAT, RODZAJ_VAT, WIERSZVAT7,
   UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO
FROM WYRAZENIA
WHERE ROK = :STARYROK AND PODMIOT_FINANSOWY = :PODMIOT;

INSERT INTO ARGUMENTY
  (ROK, WYRAZENIE, ARGUMENT, LP, ZNAK, PODMIOT_FINANSOWY, UTWORZYL, UTWORZONO)
SELECT
  ROK + 1, WYRAZENIE, ARGUMENT, LP, ZNAK, PODMIOT_FINANSOWY, UTWORZYL, UTWORZONO
FROM ARGUMENTY
WHERE ROK = :STARYROK AND PODMIOT_FINANSOWY = :PODMIOT;

INSERT INTO KONTASRODKOW
  (SRODEKTRWALY, ROK, LP, TYPDOTYCZY, DOTYCZY, KLUCZE, PROCENT,
   STRONA, ZNAK, EWIDENCJA, PODMIOT_FINANSOWY,
   UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO)
SELECT
   SRODEKTRWALY, ROK + 1, LP, TYPDOTYCZY, DOTYCZY, KLUCZE, PROCENT,
   STRONA, ZNAK, EWIDENCJA, PODMIOT_FINANSOWY,
   UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO
FROM KONTASRODKOW
WHERE ROK = :STARYROK AND PODMIOT_FINANSOWY = :PODMIOT;

END ^

COMMIT WORK ^
SET TERM ; ^

/* Opis salda */

SET TERM ^ ;

CREATE PROCEDURE OPISSALDA(
  PROK         INTEGER,
  PDATA_REJ    TIMESTAMP,
  PKLUCZE      VARCHAR(106),
  PTYPDOTYCZY  VARCHAR(1),
  PSYMBOL      VARCHAR(40),
  PDOTYCZY     INTEGER,
  PPODMIOT     INTEGER)
RETURNS(
  NAL_ZOB      VARCHAR(1),
  KWOTA        DOUBLE PRECISION)
AS
DECLARE VARIABLE VTYPPOZYCJI VARCHAR(1);
DECLARE VARIABLE VTYP        VARCHAR(1);

DECLARE VARIABLE STYP        VARCHAR(1);
DECLARE VARIABLE SSTRONA     VARCHAR(1);

DECLARE VARIABLE VWINIEN     DOUBLE PRECISION;
DECLARE VARIABLE VMA         DOUBLE PRECISION;

DECLARE VARIABLE VSTART      INTEGER;
DECLARE VARIABLE JESTNAL     INTEGER;
DECLARE VARIABLE JESTZOB     INTEGER;

DECLARE VARIABLE SWINIEN     DOUBLE PRECISION;
DECLARE VARIABLE SMA         DOUBLE PRECISION;

DECLARE VARIABLE WINIEN      DOUBLE PRECISION;
DECLARE VARIABLE MA          DOUBLE PRECISION;

BEGIN
  VSTART = 1;
  JESTNAL = 0;
  JESTZOB = 0;

  SWINIEN = 0;
  SMA = 0;

  WINIEN = 0;
  MA = 0;

  STYP = ' ';
  SSTRONA = ' ';

  NAL_ZOB = ' ';
  KWOTA = 0;

  FOR SELECT P.TypPozycji, P.Winien, P.Ma, D.Typ
  FROM Pozycje_sald P, DokumentyKsiegowe D
  WHERE
    D.Klucz = P.Dokument AND D.Rok = :PROK AND P.Rok = :PROK AND
    D.Data_rej < :PDATA_REJ AND
    P.Klucze LIKE :PKLUCZE AND P.TypDotyczy = :PTYPDOTYCZY AND
    P.Dotyczy = :PDOTYCZY AND
    UPPER(P.Symbol) = UPPER(:PSYMBOL) AND
    P.Podmiot_finansowy = :PPODMIOT
  ORDER BY P.Data_wyst, P.Dokument, P.Lp
  INTO :VTYPPOZYCJI, :VWINIEN, :VMA, :VTYP
  DO BEGIN
    IF (:VTYPPOZYCJI = 'N')
    THEN JESTNAL = 1;
    IF (:VTYPPOZYCJI = 'Z')
    THEN JESTZOB = 1;

    IF ((:VSTART = 1) AND (:VTYPPOZYCJI <> 'O'))
    THEN BEGIN
      SWINIEN = :VWINIEN;
      SMA = :VMA;
      STYP = :VTYP;
      IF (:SWINIEN > 0)     THEN SSTRONA = 'W';
      ELSE IF (:SMA > 0)    THEN SSTRONA = 'M';
      VSTART = 0;
    END

    IF (:VTYPPOZYCJI <> 'O')
    THEN BEGIN
      WINIEN = :WINIEN + :VWINIEN;
      MA = :MA + :VMA;
    END
  END

  IF ((:JESTNAL = 1) AND (:JESTZOB = 0))      THEN NAL_ZOB = 'N';
  ELSE IF ((:JESTNAL = 0) AND (:JESTZOB = 1)) THEN NAL_ZOB = 'Z';

  ELSE IF (((:STYP = 'K') OR (:STYP = 'B'))
    AND (:SSTRONA = 'W'))                     THEN NAL_ZOB = 'Z';
  ELSE IF (((:STYP = 'K') OR (:STYP = 'B'))
    AND (:SSTRONA = 'M'))                     THEN NAL_ZOB = 'N';

  ELSE IF (:WINIEN > :MA)                     THEN NAL_ZOB = 'N';
  ELSE IF (:WINIEN < :MA)                     THEN NAL_ZOB = 'Z';

  ELSE IF (:SWINIEN > 0)                      THEN NAL_ZOB = 'N';
  ELSE IF (:SMA > 0)                          THEN NAL_ZOB = 'Z';

  IF (:NAL_ZOB = 'N')
  THEN KWOTA = :WINIEN - :MA;
  ELSE IF (:NAL_ZOB = 'Z')
  THEN KWOTA = :MA - :WINIEN;

  SUSPEND;
END^
COMMIT WORK ^

SET TERM ; ^

/* Przelewy */

CREATE TABLE PRZELEWY
       (KLUCZ         KLUCZ NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        TYPDOTYCZY    TYP,
        DOTYCZY       KLUCZ,
        KLUCZE        KLUCZEKONT,

        PRZELEW_Z_LIST KLUCZ,     

        DATA          TIMESTAMP,

        KWOTA         WARTOSC,
        VAT           WARTOSC,
		SPLITPAYMENT  TAKNIE,

        ZLCKONTO      KONTO,
        ODBKONTO      KONTO,

        TYTULEM1      VARCHAR(54) CHARACTER SET DOS852,
        TYTULEM2      VARCHAR(54) CHARACTER SET DOS852,
        DRUK          TYP,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE INDEX PRZELEWY_XDOTYCZY ON PRZELEWY(TYPDOTYCZY, DOTYCZY);
CREATE INDEX PRZELEWY_XLISTY ON PRZELEWY(PRZELEW_Z_LIST);

SET TERM ^ ;
CREATE GENERATOR PRZELEWY_GEN^

CREATE TRIGGER CREATE_PRZELEWY FOR PRZELEWY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(PRZELEWY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_PRZELEW
RETURNS (PRZELEW INTEGER)
AS BEGIN
  PRZELEW = GEN_ID(PRZELEWY_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

CREATE TABLE POZYCJEPRZELEWOW
       (DOKUMENT      KLUCZ NOT NULL,
        LP            INTEGER NOT NULL,

        PODMIOT_FINANSOWY KLUCZ,

        TYPDOTYCZY    TYP,
        DOTYCZY       KLUCZ,
        KLUCZE        KLUCZEKONT,
        SYMBOL        DUZA_NAZWA,
        DATA_WYST     TIMESTAMP,

        KWOTA         WARTOSC,
        VAT           WARTOSC,
        WYPLACONO     WARTOSC,        /* nie uzywane od 07-2018 */
        WYPLACONOVAT  WARTOSC,        /* nie da sie sensownie uzgodnic w bardziej skomplikowanych przypadkach */

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DOKUMENT, LP));

CREATE INDEX POZPRZELEWOW_XDOTYCZYSYMBOL ON
  POZYCJEPRZELEWOW(TYPDOTYCZY, DOTYCZY, SYMBOL);

SET TERM ^;

CREATE PROCEDURE POZOSTALEPRZELEWY(
  PDOKUMENT   INTEGER,
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PSYMBOL     VARCHAR(40))
RETURNS(KWOTA DOUBLE PRECISION)
AS
DECLARE VARIABLE VKWOTA DOUBLE PRECISION;
DECLARE VARIABLE VWYPLACONO DOUBLE PRECISION;
BEGIN
  KWOTA = 0;
  FOR SELECT Kwota, Wyplacono FROM PozycjePrzelewow WHERE
    dokument <> :PDOKUMENT AND
    Klucze = :PKLUCZE AND Dotyczy = :PDOTYCZY AND
    TypDotyczy = :PTYPDOTYCZY AND
    Symbol = :PSYMBOL
  INTO :VKWOTA, :VWYPLACONO
  DO BEGIN
    KWOTA = :KWOTA + :VKWOTA - :VWYPLACONO;
  END
  SUSPEND;
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^;

CREATE PROCEDURE INDSALDAIPRZELEW(
  PKLUCZE     VARCHAR(106),
  PTYPDOTYCZY VARCHAR(1),
  PDOTYCZY    INTEGER,
  PROK        INTEGER)
RETURNS(
  KLUCZE      VARCHAR(106),
  TYPDOTYCZY  VARCHAR(1),
  DOTYCZY     INTEGER,
  SYMBOL      VARCHAR(40),
  SWINIEN     DOUBLE PRECISION,
  SMA         DOUBLE PRECISION,
  WKRAJ       VARCHAR(3),
  WWINIEN     DOUBLE PRECISION,
  WMA         DOUBLE PRECISION,
  PRZELEW     DOUBLE PRECISION,
  MKLUCZ      INTEGER,
  DATA_WYST   TIMESTAMP,
  DATA_OTRZ   TIMESTAMP,
  DATA_PLAT   TIMESTAMP,
  PODMIOT_FINANSOWY INTEGER)
AS
DECLARE VARIABLE MINMIES INTEGER;
BEGIN
  FOR SELECT
    P.klucze, P.TypDotyczy, P.Dotyczy, P.Symbol, P.Wlt_kraj,
    P.Podmiot_finansowy,
    Sum(P.Winien), Sum(P.Ma), Sum(P.Wlt_Winien), Sum(P.Wlt_Ma),
    Min(D.Klucz), Min(D.Miesiac)
  FROM Pozycje_sald P, DokumentyKsiegowe D
  WHERE
    D.Klucz = P.Dokument AND
    D.Rok = :PROK AND P.Rok = :PROK AND
    P.Klucze LIKE :PKLUCZE AND
    P.Dotyczy = :PDOTYCZY AND P.TypDotyczy = :PTYPDOTYCZY
  GROUP BY P.klucze, P.TypDotyczy, P.Dotyczy, P.Symbol, P.Wlt_kraj, P.Podmiot_finansowy
  INTO :KLUCZE, :TYPDOTYCZY, :DOTYCZY, :SYMBOL, :WKRAJ,
    :PODMIOT_FINANSOWY,
    :SWINIEN, :SMA, :WWINIEN, :WMA, :MKLUCZ, :MINMIES
  DO BEGIN
    IF (:MINMIES = 0)
    THEN
      SELECT Min(P.Dokument)
      FROM Pozycje_sald P
      WHERE
        P.Rok = :PROK AND P.Miesiac = 0 AND
        P.Klucze LIKE :KLUCZE AND
        P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
        P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
        P.Symbol = :SYMBOL
      INTO :MKLUCZ;

    SELECT Max(P.Data_wyst), Max(P.Data_otrz), Max(P.Data_plat)
    FROM Pozycje_sald P
    WHERE
      P.Dokument = :MKLUCZ AND P.Rok = :PROK AND
      P.Klucze LIKE :KLUCZE AND
      P.Dotyczy = :DOTYCZY AND P.TypDotyczy = :TYPDOTYCZY AND
      P.Symbol = :SYMBOL
    INTO :DATA_WYST, :DATA_OTRZ, :DATA_PLAT;

    SELECT SUM(Kwota-Wyplacono) FROM PozycjePrzelewow P
    WHERE
      P.Podmiot_finansowy = :PODMIOT_FINANSOWY AND
      P.Klucze LIKE :KLUCZE AND P.Dotyczy = :DOTYCZY AND
      P.TypDotyczy = :TYPDOTYCZY AND P.Symbol = :SYMBOL
    INTO :PRZELEW;

    IF (:PRZELEW IS NULL)
    THEN PRZELEW = 0;

    SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;


/* przeksztacenie bilansu */

CREATE TABLE PRZEKSZTALCENIEBILANSU(
       ROK                 INTEGER NOT NULL,
       SKLUCZE             KLUCZEKONT NOT NULL,

       PODMIOT_FINANSOWY KLUCZ,

       STYPDOTYCZY         TYP,
       SDOTYCZY            KLUCZ,
       SSYMBOL             DUZA_NAZWA,
       SNAZWA              OPIS,
       SBILANS             TYP,

       TRYB                TYP,

       KLUCZE              KLUCZEKONT,
       TYPDOTYCZY          TYP,
       DOTYCZY             KLUCZ,

       UTWORZYL            KLUCZ,
       ZMIENIAL            KLUCZ,
       UTWORZONO           TIMESTAMP,
       ZMIENIANO           TIMESTAMP,

       PRIMARY KEY(ROK, SKLUCZE));

CREATE INDEX PBILANSU_SYMBOL ON PRZEKSZTALCENIEBILANSU(SSYMBOL);
CREATE INDEX PBILANSU_XPODMIOT ON PRZEKSZTALCENIEBILANSU(PODMIOT_FINANSOWY);

COMMIT WORK;

/* ........................................................................ */

/* Faktury */

/* Cenniki sprzeday */

CREATE TABLE CENNIKISPRZEDAZY
       (KLUCZ           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ,
        TYP             TYP,
/*
O=Oglny
M=Materiay/Towary
D=Produkty medyczne
P=Procedury medyczne
*/
        PODMIOT_FINANSOWY KLUCZ,

        IDENT           IDENT,
        NAZWA           DUZA_NAZWA,
        TYPCENY         TYP,
        CENYMAGAZYNU    TYP,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));


CREATE TABLE CENYSPRZEDAZY
       (KLUCZ           KLUCZ NOT NULL,
        CENNIK          KLUCZ,
        TYP             TYP,    /* z cennika */
        DOTYCZY         KLUCZ,  /* produkt magazynu */

        IDENT           SYMBOL,
        NAZWA           VARCHAR(250) CHARACTER SET DOS852 COLLATE PDOX_PLK,

        JM              JM,
        SWW             SYMBOL,
		KODGRUPY        VARCHAR(2), /* to mialo by dla JPK_VDEK, ale nie jest wykorzystywane */
		FRASPLITPAYMENT TAKNIE,
        VAT             TYP,     /* stawka VAT */
        DLAURZEDU       VARCHAR(1), /* P - podstawowy, O - odwrocony */
        CENA            WARTOSC,

        AKTUALNE        TAKNIE,

        RODZAJ          TYP,     /* O - osobodni oddziau,
                                    L - podanie lekw na oddziale,
                                    P, Z, D - pobyt w gab. lekarskim, zabiegowym, diagnostycznym,
                                    R - procedura, S - wiadczenie NFZ,
                                    W - produkty medyczne zoone,
                                    B - produkty medyczne pozostae */
        PUNKTY_ZL       TYP,     /* P - rozliczenie punktowe (zawsze wiadczenia, opcjonalnie procedury),
                                    Z - zotwkowe (pozostae) */
        ROZLICZENIE     TYP,     /* W - wg ceny pozycji (ryczat),
                                    S - dosumowywanie skadnikw */
        SKLWYMAGANE     TAKNIE,  /* nieaktualne, obecnie wsk.: zawiera cene wizyty dla procedury */
        TYPWIZYTY       TYP,

        MIN_DNI         INTEGER, /* Dla osobodni oddziau */
        MAX_DNI         INTEGER,

        DANE            PARAMETRY,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(CENNIK) REFERENCES CENNIKISPRZEDAZY(KLUCZ));

CREATE INDEX CENYSPRZEDAZY_XDOTYCZY ON CENYSPRZEDAZY(TYP, DOTYCZY);
CREATE INDEX CENYSPRZEDAZY_XIDENT ON CENYSPRZEDAZY(IDENT);
/* CREATE INDEX CENYSPRZEDAZY_XNAZWA ON CENYSPRZEDAZY(NAZWA); */

SET TERM ^ ;
CREATE GENERATOR CENNIKISPRZEDAZY_GEN^

CREATE TRIGGER CREATE_CENNIKISPRZEDAZY FOR CENNIKISPRZEDAZY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(CENNIKISPRZEDAZY_GEN, 1);
END ^

CREATE TRIGGER CREATE_CENYSPRZEDAZY FOR CENYSPRZEDAZY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(CENNIKISPRZEDAZY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_CENNIKISPRZEDAZY
RETURNS (CENNIKISPRZEDAZY INTEGER)
AS BEGIN
  CENNIKISPRZEDAZY = GEN_ID(CENNIKISPRZEDAZY_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/* --- */

CREATE TABLE SKLADNIKICEN
       (CENASPRZEDAZY   KLUCZ NOT NULL,
        SKLADNIK        KLUCZ NOT NULL, /* Klucz wg typu poniej */
        TYP             TYP NOT NULL,   /* R - procedura, S - wiadczenie NFZ,
                                           I - Inna cena sprzedazy */

        FOREIGN KEY(CENASPRZEDAZY) REFERENCES CENYSPRZEDAZY(KLUCZ),
        PRIMARY KEY(CENASPRZEDAZY, SKLADNIK, TYP));

CREATE INDEX SKLADNIKICEN_XSKLADNIK ON SKLADNIKICEN(SKLADNIK);

CREATE TABLE JEDNOSTKIWYKONUJACE
       (CENASPRZEDAZY   KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,

        FOREIGN KEY(CENASPRZEDAZY) REFERENCES CENYSPRZEDAZY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

CREATE TABLE OSOBYWYKONUJACE
       (CENASPRZEDAZY   KLUCZ NOT NULL,
        OSOBA          KLUCZ NOT NULL,

        FOREIGN KEY(CENASPRZEDAZY) REFERENCES CENYSPRZEDAZY(KLUCZ),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ));

/* --- */

CREATE TABLE CENYFIRMOWE
       (UMOWA           KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,
        CENASPRZEDAZY   KLUCZ NOT NULL,
        PAKIET          DUZY_SYMBOL NOT NULL,
        PAKIETY         VARCHAR(250),
        SYMBOL          MALA_NAZWA,

        CENA            WARTOSC,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        FOREIGN KEY(CENASPRZEDAZY) REFERENCES CENYSPRZEDAZY(KLUCZ),
        PRIMARY KEY(UMOWA, WERSJA, PAKIET, CENASPRZEDAZY));

/* --- */

CREATE TABLE SPECYFIKACJAFAKTURY
       (DOKUMENT        KLUCZ NOT NULL,
        LP              INTEGER NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        LPORYGINALU     INTEGER,   /* Przy korektach */

        PODMIOT_FINANSOWY KLUCZ,

        FRA_ZAL         KLUCZ,
        LP_ZAL          INTEGER,

        ZAKLAD          KLUCZ,
        CENNIK          KLUCZ,
        POZYCJACENNIKA  KLUCZ,
		KODGRUPY        VARCHAR(2), /* dla JPK_VDEK - korekta podstawy opodatkownia */
		FRASPLITPAYMENT TAKNIE,

        OPIS            VARCHAR(120),

        ILOSC           ILOSC,  /* dla towarw odpowiada ilociom opakowa */
        JM              JM,
        SWW             SYMBOL,

        ROKVAT          INTEGER, /* rok stawki, domyslnie z dokumentu */
        TYPVAT          TYP,     /* stawka Vat */
        VATTYP          TYP,     /* sposb rozliczenia Vat */
        DLAURZEDU       VARCHAR(2), /* FP - nalezny (faktury), ZP - naliczony (zakupy), FO, ZO - odwrocony */
        WIERSZVAT7      VARCHAR(2), /* 14, 15 - okresla wiersz deklaracji VAT */
        WNT             TYP,     /* Dla WNT U - usluga (domyslnie), T - towary */

        TYPCENY         TYP,
        CENA            WARTOSC,
        BONIFIKATA      WARTOSC,
        NETTO           WARTOSC,
        VAT             WARTOSC,
        VAT_KOSZTY      WARTOSC,
        BRUTTO          WARTOSC,

        DO_FRY          TAKNIE,

        WLT_CENA        WARTOSC,
        WLT_NETTO       WARTOSC,

        PROCEDURA        KLUCZ,
        WMAGAZYNIE       KLUCZ,  /* gdy dotyczy konkretnego stanu magazynowego */
        PRODUKT          KLUCZ,  /* gdy dotyczy produktu - f-ry zaliczkowe */
        OBROTYMAGAZYNU   KLUCZ,
        POZYCJAOBROTU    KLUCZ,
        ZDJETOZESTANU    TAKNIE,
        ILOSC_W_OPAK     ILOSC,
        ILOSC_EWID       ILOSC,
        JM_EWID          IDENT,
        NARZUTY          WARTOSC,

        AUTOMAT          TAKNIE,
        PRODUKT_UMOWY    KLUCZ,    /* wskazanie na PRODUKTY_UMOWY.KLUCZ, do faktury NFZ musi by */
        KAPITACJA_NFZ    TAKNIE,
        DOPLATA_PACJ     WARTOSC,

        SWIADCZENIE      KLUCZ,    /* Wykaz wiadcze podczanych do specyfikacji dla kapitacji - podzia na grupy wiekowe - SWIADCZENIA.KLUCZ */
        WAGA_NFZ         WARTOSC,  /* tylko dla kapitacji */
        WYROZNIK_NFZ     INTEGER,

        EROZLICZENIE     KLUCZ,    /* odwolanie do platnosci internetowych pacjenta */
        EZAPLATA         WARTOSC,

        DANE            PARAMETRY,

        KLASYFIKACJA1   KLUCZ,
        KLASYFIKACJA2   KLUCZ,
        KLASYFIKACJA3   KLUCZ,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(POZYCJAOBROTU) REFERENCES POZYCJAOBROTU(KLUCZ),
        FOREIGN KEY(WMAGAZYNIE) REFERENCES WMAGAZYNIE(KLUCZ),
        FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        PRIMARY KEY(DOKUMENT, LP));

CREATE INDEX SPECYFIKACJAFAKTURY_XROKMIES ON
  SPECYFIKACJAFAKTURY(ROK, MIESIAC, CENNIK, POZYCJACENNIKA, DOKUMENT, LP);
CREATE INDEX SPECYFIKACJAFAKTURY_XZAL ON
  SPECYFIKACJAFAKTURY(FRA_ZAL, LP_ZAL);
CREATE INDEX SPECYFIKACJAFAKTURY_XCENA ON SPECYFIKACJAFAKTURY(POZYCJACENNIKA);
CREATE INDEX SPECYFIKACJAFAKTURY_NFZ ON SPECYFIKACJAFAKTURY(PRODUKT_UMOWY, SWIADCZENIE);
CREATE INDEX SPECYFIKACJAFAKTURY_XEROZ ON SPECYFIKACJAFAKTURY(EROZLICZENIE);


/* ........................................................................ */

CREATE TABLE GRUPYPROWIZYJNE
       (KLUCZ           KLUCZ NOT NULL,        /* UNIQUE_KEY_GEN */
        TYP             VARCHAR(1) NOT NULL,   /* G - grupa, I - indywidualnie, P - promocje (tylko 1 rekord) */
        NAZWA           VARCHAR(50),

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

COMMIT WORK;

CREATE TABLE PROWIZJE
       (KLUCZ           KLUCZ NOT NULL,        /* UNIQUE_KEY_GEN */
        GRUPA           KLUCZ NOT NULL,
        DATA_OD         TIMESTAMP NOT NULL,
        DATA_DO         TIMESTAMP,

        SADNI           VARCHAR(1),  /* 1 - sa dni, 2 - bez dni : dla sortowania */
        DNITYGODNIA     VARCHAR(15),
        TYPWIZYTY       TYP,

        DLAZAKLADU      VARCHAR(1),  /* 1 - dla zakladu, 2 - bez zakladu : dla sortowania */
        ZAKLAD          KLUCZ,       /* opcjonalnie odwolanie do gabinetu, oddzialu */

        DOTYCZY         VARCHAR(1),  /* 1 - NFZ, 2 - firma, 3 - umowy z firmami,
                                        4 - indywidualnie (pozostale), 5 - wszystko
                                        numerki wyznaczaja kolejnosc przegladania*/
        FIRMA           KLUCZ,       /* gdy podane, to powyzej powinno byc 2 */

        PROCENT         WARTOSC,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(GRUPA) REFERENCES GRUPYPROWIZYJNE(KLUCZ),
        PRIMARY KEY(KLUCZ));

CREATE TABLE POZYCJEPROWIZJI
       (PROWIZJA        KLUCZ NOT NULL,
        CENNIK          KLUCZ NOT NULL,
        CENASPRZEDAZY   KLUCZ NOT NULL,

        CENA          WARTOSC,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        FOREIGN KEY(CENASPRZEDAZY) REFERENCES CENYSPRZEDAZY(KLUCZ),
        PRIMARY KEY(PROWIZJA, CENASPRZEDAZY));

INSERT INTO GRUPYPROWIZYJNE (KLUCZ, TYP, NAZWA) VALUES (GEN_ID(UNIQUE_KEY_GEN, 1), 'P', 'Promocje');
        
/* ........................................................................ */

/* Aparatura medyczna */


CREATE TABLE APARATURA_MEDYCZNA
       (KLUCZ    KLUCZ NOT NULL,
        TYP      NUMER NOT NULL,
        AKTYWNY  TAKNIE,
        IDENT    SYMBOL,
        NAZWA    OPIS,
        OSOBA    KLUCZ,              /* osoba dyurujca */
        SRODEK   KLUCZ,              /* do ewentualnego powizania ze rodkami trwaymi */
        PROCEDURA KLUCZ,             /* procedura wykonywana na aparacie */
        ILOSC    INTEGER,
        JEDNORAZOWO INTEGER,
        LIMIT_W  INTEGER,            /* czas obsugi w minutach, nazwa jak w Dyzur */

        PUNKTY    WARTOSC,           
        CENA      WARTOSC,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));


CREATE TABLE WYLACZENIA_UZYTKOWANIA
       (APARAT   KLUCZ NOT NULL,
        DATA_OD  TIMESTAMP NOT NULL,
        DATA_DO  TIMESTAMP,
        ILOSC    INTEGER,
        OPIS     OPIS,

        PRIMARY KEY(APARAT, DATA_OD));


CREATE TABLE REZERWACJE_APARATURY
       (APARAT   KLUCZ NOT NULL,
        DYZUR    KLUCZ NOT NULL,
        ZLECENIE KLUCZ NOT NULL,
        DATA_OD  TIMESTAMP NOT NULL,

        FOREIGN KEY(DYZUR) REFERENCES DYZUR(KLUCZ),
        FOREIGN KEY(ZLECENIE) REFERENCES ZLECENIA(KLUCZ),

        PRIMARY KEY(APARAT, DYZUR, ZLECENIE));

CREATE INDEX REZERWACJE_APARATURY_XDYZUR ON REZERWACJE_APARATURY(DYZUR, ZLECENIE, APARAT);

/* ........................................................................ */

/* rodki trwae */

CREATE TABLE KLASYFIKACJASRODKOW
       (GRUPA    TYP NOT NULL,
        KST      NUMER NOT NULL,
        NAZWA    OPIS,
        PRIMARY KEY(GRUPA, KST));


CREATE TABLE SRODKITRWALE
       (KLUCZ            KLUCZ NOT NULL,
        ZAKLAD           KLUCZ,

        SRODEK           KLUCZ NOT NULL,   /* Odniesienie do tablicy INDEKS */
        NR_INWENT        MALA_NAZWA,
        DOSTAWCA         KLUCZ,
        NR_FABRYCZNY     DUZA_NAZWA,
        ROK_PRODUKCJI    INTEGER,
        ODPOWIEDZIALNY   KLUCZ,
        ZESTAW           KLUCZ,
        PODZIAL          DIDENT,
        KSIEGOWOSC       SYMBOL,   /* 0 - rodek, 1 - wart.niemat., 2 - wyposaenie, 3. - Koszty w czasie */
        POLOZENIE        OPIS,

        STAN             TYP,    /* Czynny, Nieczynny, Przenoszony, zLikwidowany */
        AMORTYZACJA      TYP,
        BILANSOWY        TAKNIE,
        CENNOSC          TYP,
        SEZONOWY         TYP,
        POCZ_SEZONU      INTEGER,    /* w miesicach */
        DLUGOSC_SEZONU   INTEGER,

        TYP_AMO          TYP,       /*  Amortyzacja, Umorzenie */
        POWIERZCHNIA     WARTOSC,   /* lub inne */

        ILOSC            INTEGER,

        STAWKA           DOUBLE PRECISION,
        PRZYSPIESZENIE   DOUBLE PRECISION,
        PODSTAWA_AMORT   DOUBLE PRECISION,  /* Dodatkowa podstawa liczenia amortyzacji */

        DATA_ZAK         TIMESTAMP,
        WART_POCZ        WARTOSC,

        WART_BO          WARTOSC,
        AMORT_BO         WARTOSC,

        WART_BIEZACA     WARTOSC,
        WART_POCZ_ROKU   WARTOSC,
        AMORT_BIEZACA    WARTOSC,

        /* bilansowe */

        DATA_P_UZYTK      TIMESTAMP,

        AMORTYZACJA1      TYP,
        BILANSOWY1        TAKNIE,
        CENNOSC1          TYP,
        SEZONOWY1         TYP,
        POCZ_SEZONU1      INTEGER,    /* w miesicach */
        DLUGOSC_SEZONU1   INTEGER,

        TYP_AMO1          TYP,       /*  Amortyzacja, Umorzenie */

        STAWKA1           DOUBLE PRECISION,
        PRZYSPIESZENIE1   DOUBLE PRECISION,
        PODSTAWA_AMORT1   DOUBLE PRECISION,  /* Dodatkowa podstawa liczenia amortyzacji */

        WART_POCZ1        WARTOSC,

        WART_BO1          WARTOSC,
        AMORT_BO1         WARTOSC,

        WART_BIEZACA1     WARTOSC,
        WART_POCZ_ROKU1   WARTOSC,
        AMORT_BIEZACA1    WARTOSC,

        
        DANE             PARAMETRY,

        /* Korekty bdw */

        BL_ILOSC         INTEGER,
        BL_WART          DOUBLE PRECISION,
        BL_AMORT         DOUBLE PRECISION,
        BL_WART_BO       DOUBLE PRECISION,
        BL_AMORT_BO      DOUBLE PRECISION,
        BL_POPRAWA       TAKNIE,        /* = T gdy poprawiono oryginalne wartoci
                                               na podstawie powyszych BL_... */ 

        UTWORZYL         KLUCZ,
        ZMIENIAL         KLUCZ,
        UTWORZONO        TIMESTAMP,
        ZMIENIANO        TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(DOSTAWCA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(ODPOWIEDZIALNY) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZESTAW) REFERENCES SRODKITRWALE(KLUCZ),
        FOREIGN KEY(SRODEK) REFERENCES INDEKS(KLUCZ));

CREATE INDEX SRODKITRWALE_XNUMER ON SRODKITRWALE(NR_INWENT);
CREATE INDEX SRODKITRWALE_XZAKLADNUMER ON SRODKITRWALE(ZAKLAD, NR_INWENT);

COMMIT WORK;


CREATE TABLE SRODKIKONCAROKU
       (KLUCZ            KLUCZ NOT NULL,
        ROK              INTEGER NOT NULL,

        WART_BO          WARTOSC,
        AMORT_BO         WARTOSC,

        WART_BIEZACA     WARTOSC,
        WART_POCZ_ROKU   WARTOSC,
        AMORT_BIEZACA    WARTOSC,

        /* bilansowe */

        WART_BO1          WARTOSC,
        AMORT_BO1         WARTOSC,

        WART_BIEZACA1     WARTOSC,
        WART_POCZ_ROKU1   WARTOSC,
        AMORT_BIEZACA1    WARTOSC,

        DANE             PARAMETRY,

        PRIMARY KEY(ROK, KLUCZ));


CREATE EXCEPTION EXC_SRODKIKONCAROKU 'Wystepuja pozniejsze dokumenty';


/* parametr rok wskazuje na przywracany rok (= bieacy - 1) */

SET TERM ^ ;

CREATE PROCEDURE PRZYWROCSRODKIKONCAROKU(
  ROK INTEGER)
RETURNS(ROK1 INTEGER)   
AS
DECLARE VARIABLE KLUCZ  INTEGER;
DECLARE VARIABLE WART_BO          WARTOSC;
DECLARE VARIABLE AMORT_BO         WARTOSC;
DECLARE VARIABLE WART_BIEZACA     WARTOSC;
DECLARE VARIABLE WART_POCZ_ROKU   WARTOSC;
DECLARE VARIABLE AMORT_BIEZACA    WARTOSC;
DECLARE VARIABLE WART_BO1          WARTOSC;
DECLARE VARIABLE AMORT_BO1         WARTOSC;
DECLARE VARIABLE WART_BIEZACA1     WARTOSC;
DECLARE VARIABLE WART_POCZ_ROKU1   WARTOSC;
DECLARE VARIABLE AMORT_BIEZACA1    WARTOSC;
DECLARE VARIABLE DANE             PARAMETRY;
BEGIN
  FOR SELECT klucz FROM DOKUMENTYSRODKOW
  WHERE ROK = :ROK + 1
  INTO :KLUCZ
  DO EXCEPTION EXC_SRODKIKONCAROKU ;

  FOR SELECT
    KLUCZ,
    WART_BO, AMORT_BO, WART_BIEZACA, WART_POCZ_ROKU, AMORT_BIEZACA,
    WART_BO1, AMORT_BO1, WART_BIEZACA1, WART_POCZ_ROKU1, AMORT_BIEZACA1,
    DANE
  FROM SRODKIKONCAROKU
  WHERE ROK = :ROK
  INTO
    :KLUCZ,
    :WART_BO, :AMORT_BO, :WART_BIEZACA, :WART_POCZ_ROKU, :AMORT_BIEZACA,
    :WART_BO1, :AMORT_BO1, :WART_BIEZACA1, :WART_POCZ_ROKU1, :AMORT_BIEZACA1,
    :DANE
  DO BEGIN
    UPDATE SRODKITRWALE
    SET
      KLUCZ = :KLUCZ,
      WART_BO = :WART_BO,
      AMORT_BO = :AMORT_BO,
      WART_BIEZACA = :WART_BIEZACA,
      WART_POCZ_ROKU = :WART_POCZ_ROKU,
      AMORT_BIEZACA = :AMORT_BIEZACA,
      WART_BO1 = :WART_BO1,
      AMORT_BO1 = :AMORT_BO1,
      WART_BIEZACA1 = :WART_BIEZACA1,
      WART_POCZ_ROKU1 = :WART_POCZ_ROKU1,
      AMORT_BIEZACA1 = :AMORT_BIEZACA1
    WHERE KLUCZ = :KLUCZ;
  END
  ROK1 = :ROK;
  SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^



/*-----------------------------------------------------------*/
/* Przepisuje tabel rodkw podmieniajc dla czci zestawu */
/* opis amortyzacji z nagwka zestawu                       */
/*-----------------------------------------------------------*/

SET TERM ^;

CREATE PROCEDURE WYKAZSRODKOW
RETURNS(
  KLUCZ            INTEGER,
  ZAKLAD           INTEGER,
  SRODEK           INTEGER,
  NR_INWENT        VARCHAR(20),
  DOSTAWCA         INTEGER,
  NR_FABRYCZNY     VARCHAR(40),
  ROK_PRODUKCJI    INTEGER,
  ODPOWIEDZIALNY   INTEGER,
  ZESTAW           INTEGER,
  PODZIAL          VARCHAR(5),
  KSIEGOWOSC       VARCHAR(15),
  POLOZENIE        VARCHAR(60),
  STAN             VARCHAR(1),
  AMORTYZACJA      VARCHAR(1),
  BILANSOWY        VARCHAR(1),
  CENNOSC          VARCHAR(1),
  SEZONOWY         VARCHAR(1),
  POCZ_SEZONU      INTEGER,
  DLUGOSC_SEZONU   INTEGER,
  ILOSC            INTEGER,
  STAWKA           DOUBLE PRECISION,
  PRZYSPIESZENIE   DOUBLE PRECISION,
  DATA_ZAK         TIMESTAMP,
  WART_POCZ        DOUBLE PRECISION,
  WART_BO          DOUBLE PRECISION,
  AMORT_BO         DOUBLE PRECISION,
  WART_BIEZACA     DOUBLE PRECISION,
  WART_POCZ_ROKU   DOUBLE PRECISION,
  AMORT_BIEZACA    DOUBLE PRECISION,
  TYP_AMO          VARCHAR(1),
  POWIERZCHNIA     DOUBLE PRECISION,
  DANE             BLOB SUB_TYPE TEXT SEGMENT SIZE 80,
  UTWORZYL         INTEGER,
  ZMIENIAL         INTEGER,
  UTWORZONO        TIMESTAMP,
  ZMIENIANO        TIMESTAMP
)
AS
BEGIN
  FOR SELECT
    S.KLUCZ, S.ZAKLAD, S.SRODEK, S.NR_INWENT, S.DOSTAWCA, S.NR_FABRYCZNY, S.ROK_PRODUKCJI,
    S.ODPOWIEDZIALNY, S.ZESTAW, S.PODZIAL, S.KSIEGOWOSC, S.POLOZENIE, S.STAN, S.AMORTYZACJA,
    S.BILANSOWY, S.CENNOSC, S.SEZONOWY, S.POCZ_SEZONU, S.DLUGOSC_SEZONU, S.ILOSC, S.STAWKA,
    S.PRZYSPIESZENIE, S.DATA_ZAK, S.WART_POCZ, S.WART_BO, S.AMORT_BO, S.WART_BIEZACA,
    S.WART_POCZ_ROKU, S.AMORT_BIEZACA, S.TYP_AMO, S.POWIERZCHNIA,
    S.DANE, S.UTWORZYL, S.ZMIENIAL, S.UTWORZONO, S.ZMIENIANO
  FROM SrodkiTrwale S
  INTO
    :KLUCZ, :ZAKLAD, :SRODEK, :NR_INWENT, :DOSTAWCA, :NR_FABRYCZNY, :ROK_PRODUKCJI,
    :ODPOWIEDZIALNY, :ZESTAW, :PODZIAL, :KSIEGOWOSC, :POLOZENIE, :STAN, :AMORTYZACJA,
    :BILANSOWY, :CENNOSC, :SEZONOWY, :POCZ_SEZONU, :DLUGOSC_SEZONU, :ILOSC, :STAWKA,
    :PRZYSPIESZENIE, :DATA_ZAK, :WART_POCZ, :WART_BO, :AMORT_BO, :WART_BIEZACA,
    :WART_POCZ_ROKU, :AMORT_BIEZACA, :TYP_AMO, :POWIERZCHNIA,
    :DANE, :UTWORZYL, :ZMIENIAL, :UTWORZONO, :ZMIENIANO
  DO BEGIN
    IF (:ZESTAW > 0)
    THEN SELECT
      T.TYP_AMO, T.AMORTYZACJA, T.BILANSOWY, T.CENNOSC, T.SEZONOWY, T.POCZ_SEZONU, T.DLUGOSC_SEZONU,
      T.STAWKA, T.PRZYSPIESZENIE
    FROM SrodkiTrwale T WHERE T.KLUCZ = :ZESTAW
    INTO
      :TYP_AMO, :AMORTYZACJA, :BILANSOWY, :CENNOSC, :SEZONOWY, :POCZ_SEZONU, :DLUGOSC_SEZONU,
      :STAWKA, :PRZYSPIESZENIE;

    SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

SET TERM ^ ;
CREATE GENERATOR SRODKITRWALE_GEN^

CREATE TRIGGER CREATE_SRODKITRWALE FOR SRODKITRWALE
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(SRODKITRWALE_GEN, 1);
END ^

CREATE PROCEDURE DAJ_SRODKITRWALE
RETURNS (SRODKITRWALE INTEGER)
AS BEGIN
  SRODKITRWALE = GEN_ID(SRODKITRWALE_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/*---*/

CREATE TABLE DOKUMENTYSRODKOW
       (KLUCZ               KLUCZ NOT NULL,
        ZAKLAD              KLUCZ NOT NULL,
        FIRMA               KLUCZ,
        ZAKLAD_POCH         KLUCZ,   /* Zakad pochodzenia - przy przeniesieniu */

        ROK                 INTEGER NOT NULL,
        MIESIAC             INTEGER NOT NULL,
        TYP_NALICZENIA      TYP NOT NULL,
        TYP_DOKUM           DIDENT NOT NULL,
        NR_DOKUM            SYMBOL NOT NULL,
        KOREKTA             TAKNIE,
        ZIMPORTU            TAKNIE,

        TYPSRODKOW          TYP,     /* Srodki, Wyposazenie - nowy program*/
        VATTYP              TYP,     /* sposb rozliczenia Vat */
        DLAURZEDU           VARCHAR(2), /* FP - nalezny (faktury), ZP - naliczony (zakupy), FO, ZO - odwrocony */

        DATA_WYST           TIMESTAMP,

        WPRZYCHOD           WARTOSC,  /* Przyrost wartoci */
        WROZCHOD            WARTOSC,  /* Zmniejszenie wartosci */

        APRZYCHOD           WARTOSC,  /* Przyrost umorzenia */
        AROZCHOD            WARTOSC,  /* Zmniejszenie umorzenia */

        WPRZYCHOD1           WARTOSC,  /* Przyrost wartoci */
        WROZCHOD1            WARTOSC,  /* Zmniejszenie wartosci */

        APRZYCHOD1           WARTOSC,  /* Przyrost umorzenia */
        AROZCHOD1            WARTOSC,  /* Zmniejszenie umorzenia */

        DANE                PARAMETRY,

        UTWORZYL         KLUCZ,
        ZMIENIAL         KLUCZ,
        UTWORZONO        TIMESTAMP,
        ZMIENIANO        TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ));

CREATE INDEX DOKUMENTYSRODKOW_XOKRES ON
  DOKUMENTYSRODKOW(ROK, MIESIAC, TYP_NALICZENIA, TYP_DOKUM, NR_DOKUM);

COMMIT WORK;

SET TERM ^ ;
CREATE GENERATOR DOKUMENTYSRODKOW_GEN^

CREATE TRIGGER CREATE_DOKUMENTYSRODKOW FOR DOKUMENTYSRODKOW
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DOKUMENTYSRODKOW_GEN, 1);
END ^

CREATE PROCEDURE DAJ_DOKUMENTYSRODKOW
RETURNS (DOKUMENTYSRODKOW INTEGER)
AS BEGIN
  DOKUMENTYSRODKOW = GEN_ID(DOKUMENTYSRODKOW_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

/*---*/

CREATE TABLE POZYCJEDOKSRODKOW
       (DOKUMENT             KLUCZ NOT NULL,
        POZYCJA              INTEGER NOT NULL,
        TYP_NALICZENIA       TYP NOT NULL,

        SRODEK               KLUCZ NOT NULL,
        SRODEKWEWIDENCJI     KLUCZ NOT NULL,
        SRODEKPRZENIESIONY   KLUCZ,

        ILOSC               INTEGER,

        WBO                 WARTOSC,
        WPRZYCHOD           WARTOSC,  /* Przyrost wartoci */
        WROZCHOD            WARTOSC,  /* Zmniejszenie wartosci */

        ABO                 WARTOSC,
        APRZYCHOD           WARTOSC,  /* Przyrost umorzenia */
        AROZCHOD            WARTOSC,  /* Zmniejszenie umorzenia */

        WKOREKTA            WARTOSC,  /* Zmiany wartoci (przy przyjciu istniejcego) */
        AKOREKTA            WARTOSC,  /* Zmiany amortyzacji (przy przyjciu istniejcego) */

        KUP                 WARTOSC,
        NKUP                WARTOSC,
        NKUP8               WARTOSC,

        AKUP                WARTOSC,
        ANKUP               WARTOSC,
        ANKUP8              WARTOSC,

        WBO1                 WARTOSC,
        WPRZYCHOD1           WARTOSC,  /* Przyrost wartoci */
        WROZCHOD1            WARTOSC,  /* Zmniejszenie wartosci */

        ABO1                 WARTOSC,
        APRZYCHOD1           WARTOSC,  /* Przyrost umorzenia */
        AROZCHOD1            WARTOSC,  /* Zmniejszenie umorzenia */

        WKOREKTA1            WARTOSC,  /* Zmiany wartoci (przy przyjciu istniejcego) */
        AKOREKTA1            WARTOSC,  /* Zmiany amortyzacji (przy przyjciu istniejcego) */

        TYPVAT          TYP,     /* stawka Vat */

        VAT             WARTOSC,
        BRUTTO          WARTOSC,

        POLOZENIE           OPIS,    /* Nowe pooenie - przy przeniesieniu */
        STAREPOLOZENIE      OPIS,    /* Stare pooenie - przy przeniesieniu */

        DANE                PARAMETRY,  /* W nowym programie jako uwagi, w starym uwagi to dane.uwagi.uwagi */

        UTWORZYL         KLUCZ,
        ZMIENIAL         KLUCZ,
        UTWORZONO        TIMESTAMP,
        ZMIENIANO        TIMESTAMP,

        PRIMARY KEY(DOKUMENT, POZYCJA),
        FOREIGN KEY(SRODEK) REFERENCES INDEKS(KLUCZ),
        FOREIGN KEY(SRODEKWEWIDENCJI) REFERENCES SRODKITRWALE(KLUCZ),
        FOREIGN KEY(SRODEKPRZENIESIONY) REFERENCES SRODKITRWALE(KLUCZ));

/*-----------------------------------------------------------------*/
/* Przepisuje tabel rodkw wyliczajc wartoci na podstawie      */
/* dokumentw uporzdkowanych chronologicznie do podanego miesica */
/*-----------------------------------------------------------------*/

SET TERM ^;

CREATE PROCEDURE WYKAZSRODKOWNAMIESIAC(
  ROK              INTEGER,
  MIESIAC          INTEGER,
  PKSIEGOWOSC1     VARCHAR(1),
  PKSIEGOWOSC2     VARCHAR(1),
  PBILANSOWY       VARCHAR(1),
  PCENNOSC         VARCHAR(1)
  )

RETURNS(

  /* Pola oryginalne */

  KLUCZ            INTEGER,
  ZAKLAD           INTEGER,
  SRODEK           INTEGER,
  NR_INWENT        VARCHAR(20),
  DOSTAWCA         INTEGER,
  NR_FABRYCZNY     VARCHAR(40),
  ROK_PRODUKCJI    INTEGER,
  ODPOWIEDZIALNY   INTEGER,
  ZESTAW           INTEGER,
  PODZIAL          VARCHAR(5),
  KSIEGOWOSC       VARCHAR(15),
  POLOZENIE        VARCHAR(60),
  STAN             VARCHAR(1),
  AMORTYZACJA      VARCHAR(1),
  BILANSOWY        VARCHAR(1),
  CENNOSC          VARCHAR(1),
  SEZONOWY         VARCHAR(1),
  POCZ_SEZONU      INTEGER,
  DLUGOSC_SEZONU   INTEGER,
  ILOSC            INTEGER,
  STAWKA           DOUBLE PRECISION,
  PRZYSPIESZENIE   DOUBLE PRECISION,
  DATA_ZAK         TIMESTAMP,
  WART_POCZ        DOUBLE PRECISION,
  WART_BO          DOUBLE PRECISION,
  AMORT_BO         DOUBLE PRECISION,
  WART_BIEZACA     DOUBLE PRECISION,
  WART_POCZ_ROKU   DOUBLE PRECISION,
  AMORT_BIEZACA    DOUBLE PRECISION,
  TYP_AMO          VARCHAR(1),
  POWIERZCHNIA     DOUBLE PRECISION,
  DANE             BLOB SUB_TYPE TEXT SEGMENT SIZE 80,
  UTWORZYL         INTEGER,
  ZMIENIAL         INTEGER,
  UTWORZONO        TIMESTAMP,
  ZMIENIANO        TIMESTAMP,

  BL_ILOSC         INTEGER,
  BL_WART_BO       DOUBLE PRECISION,
  BL_AMORT_BO      DOUBLE PRECISION,
  BL_WART          DOUBLE PRECISION,
  BL_AMORT         DOUBLE PRECISION,

  /* Pola kalkulacyjne */

  DATADOSTAWY      TIMESTAMP,
  DATALIKWIDACJI   TIMESTAMP,

  UU1  DOUBLE PRECISION,
  UU2  DOUBLE PRECISION,
  UU3  DOUBLE PRECISION,
  UU4  DOUBLE PRECISION,
  UU5  DOUBLE PRECISION,
  UU6  DOUBLE PRECISION,
  UU7  DOUBLE PRECISION,
  UU8  DOUBLE PRECISION,
  UU9  DOUBLE PRECISION,
  UU10 DOUBLE PRECISION,
  UU11 DOUBLE PRECISION,
  UU12 DOUBLE PRECISION,

  MC_OST_NALICZENIA INTEGER,

  WART_ROKU        DOUBLE PRECISION,
  WART_BM          DOUBLE PRECISION,

  AMORT_ROKU       DOUBLE PRECISION,
  AMORT_BM         DOUBLE PRECISION,

  WPRZYCHOD        DOUBLE PRECISION,
  WROZCHOD         DOUBLE PRECISION,

  AAPRZYCHOD       DOUBLE PRECISION,  /* Dodatkowa litera, jak i wyzej, dla odroznienia od pol kalkulacyjnych programu */
  AROZCHOD         DOUBLE PRECISION,

  WART_KOREKTY     DOUBLE PRECISION,
  AMORT_KOREKTY    DOUBLE PRECISION,

  IPRZYCHOD        INTEGER,
  IROZCHOD         INTEGER
)
AS

/* Pamie pol nowego srodka */

DECLARE VARIABLE V_KLUCZ            INTEGER;
DECLARE VARIABLE V_SRODEK           INTEGER;
DECLARE VARIABLE V_NR_INWENT        VARCHAR(20);
DECLARE VARIABLE V_STAN             VARCHAR(1);
DECLARE VARIABLE V_DOSTAWCA         INTEGER;
DECLARE VARIABLE V_NR_FABRYCZNY     VARCHAR(40);
DECLARE VARIABLE V_ROK_PRODUKCJI    INTEGER;
DECLARE VARIABLE V_ODPOWIEDZIALNY   INTEGER;
DECLARE VARIABLE V_ZESTAW           INTEGER;
DECLARE VARIABLE V_PODZIAL          VARCHAR(5);
DECLARE VARIABLE V_KSIEGOWOSC       VARCHAR(15);
DECLARE VARIABLE V_POLOZENIE        VARCHAR(60);
DECLARE VARIABLE V_AMORTYZACJA      VARCHAR(1);
DECLARE VARIABLE V_BILANSOWY        VARCHAR(1);
DECLARE VARIABLE V_CENNOSC          VARCHAR(1);
DECLARE VARIABLE V_SEZONOWY         VARCHAR(1);
DECLARE VARIABLE V_POCZ_SEZONU      INTEGER;
DECLARE VARIABLE V_DLUGOSC_SEZONU   INTEGER;
DECLARE VARIABLE V_STAWKA           DOUBLE PRECISION;
DECLARE VARIABLE V_PRZYSPIESZENIE   DOUBLE PRECISION;
DECLARE VARIABLE V_DATA_ZAK         TIMESTAMP;
DECLARE VARIABLE V_TYP_AMO          VARCHAR(1);
DECLARE VARIABLE V_POWIERZCHNIA     DOUBLE PRECISION;
DECLARE VARIABLE V_DANE             BLOB SUB_TYPE TEXT SEGMENT SIZE 80;
DECLARE VARIABLE V_UTWORZYL         INTEGER;
DECLARE VARIABLE V_ZMIENIAL         INTEGER;
DECLARE VARIABLE V_UTWORZONO        TIMESTAMP;
DECLARE VARIABLE V_ZMIENIANO        TIMESTAMP;

DECLARE VARIABLE V_BL_ILOSC         INTEGER;
DECLARE VARIABLE V_BL_WART_BO       DOUBLE PRECISION;
DECLARE VARIABLE V_BL_AMORT_BO      DOUBLE PRECISION;
DECLARE VARIABLE V_BL_WART          DOUBLE PRECISION;
DECLARE VARIABLE V_BL_AMORT         DOUBLE PRECISION;

/* Pozostale zmienne */

DECLARE VARIABLE KLUCZ_AKT INTEGER;
DECLARE VARIABLE ILOSC_DOK INTEGER;
DECLARE VARIABLE ROK_ZAK   INTEGER;
DECLARE VARIABLE ROK_AKT   INTEGER;

DECLARE VARIABLE D_Zaklad             INTEGER;
DECLARE VARIABLE D_Zaklad_poch        INTEGER;
DECLARE VARIABLE D_Rok                INTEGER;
DECLARE VARIABLE D_Miesiac            INTEGER;
DECLARE VARIABLE D_Data_wyst          TIMESTAMP;
DECLARE VARIABLE P_Typ_naliczenia     VARCHAR(1);
DECLARE VARIABLE P_SrodekWEwidencji   INTEGER;
DECLARE VARIABLE P_SrodekPrzeniesiony INTEGER;
DECLARE VARIABLE P_Ilosc              INTEGER;
DECLARE VARIABLE P_WKorekta           DOUBLE PRECISION;
DECLARE VARIABLE P_AKorekta           DOUBLE PRECISION;
DECLARE VARIABLE P_WBO                DOUBLE PRECISION;
DECLARE VARIABLE P_ABO                DOUBLE PRECISION;
DECLARE VARIABLE P_WPrzychod          DOUBLE PRECISION;
DECLARE VARIABLE P_WRozchod           DOUBLE PRECISION;
DECLARE VARIABLE P_APrzychod          DOUBLE PRECISION;
DECLARE VARIABLE P_ARozchod           DOUBLE PRECISION;
DECLARE VARIABLE P_VAT                DOUBLE PRECISION;
DECLARE VARIABLE P_Polozenie          VARCHAR(60);
DECLARE VARIABLE P_StarePolozenie     VARCHAR(60);

DECLARE VARIABLE V_POCZ               DOUBLE PRECISION;
BEGIN
  KLUCZ_AKT = 0;
  ILOSC_DOK = 0;
  FOR SELECT
    S.KLUCZ, S.SRODEK, S.NR_INWENT, S.STAN, S.DOSTAWCA, S.NR_FABRYCZNY, S.ROK_PRODUKCJI,
    S.ODPOWIEDZIALNY, S.ZESTAW, S.PODZIAL, S.KSIEGOWOSC, S.POLOZENIE, S.AMORTYZACJA,
    S.BILANSOWY, S.CENNOSC, S.SEZONOWY, S.POCZ_SEZONU, S.DLUGOSC_SEZONU, S.STAWKA,
    S.PRZYSPIESZENIE, S.DATA_ZAK, S.DANE, S.TYP_AMO, S.POWIERZCHNIA,
    S.UTWORZYL, S.ZMIENIAL, S.UTWORZONO, S.ZMIENIANO,
    S.BL_ILOSC, S.BL_WART_BO, S.BL_AMORT_BO, S.BL_WART, S.BL_AMORT,
    D.Zaklad, D.Zaklad_poch, D.Rok, D.Miesiac, D.Data_wyst,
    P.Typ_naliczenia, P.SrodekWEwidencji, P.SrodekPrzeniesiony,
    P.Ilosc, P.WKorekta, P.AKorekta,
    P.WBO, P.ABO,
    P.WPrzychod, P.WRozchod, P.APrzychod, P.ARozchod, P.VAT,
    P.Polozenie, P.StarePolozenie
  FROM
    (SrodkiTrwale S
    JOIN PozycjeDokSrodkow P
    ON P.SrodekWEwidencji = S.KLUCZ OR P.SrodekPrzeniesiony = S.KLUCZ)
    JOIN DokumentySrodkow D
    ON D.Klucz = P.Dokument
  WHERE
    S.ZESTAW IS NULL AND
    (S.KSIEGOWOSC LIKE :PKSIEGOWOSC1 OR S.KSIEGOWOSC LIKE :PKSIEGOWOSC2) AND
      S.BILANSOWY LIKE :PBILANSOWY AND S.CENNOSC LIKE :PCENNOSC
    OR
    S.ZESTAW IS NOT NULL AND
      (SELECT COUNT(*) FROM SrodkiTrwale Z
       WHERE Z.Klucz = S.Zestaw AND
        (Z.KSIEGOWOSC LIKE :PKSIEGOWOSC1 OR Z.KSIEGOWOSC LIKE :PKSIEGOWOSC2) AND
          Z.BILANSOWY LIKE :PBILANSOWY AND Z.CENNOSC LIKE :PCENNOSC) > 0
  ORDER BY S.KLUCZ, D.Rok, D.Miesiac, D.Klucz
  INTO
    :V_KLUCZ, :V_SRODEK, :V_NR_INWENT, :V_STAN, :V_DOSTAWCA, :V_NR_FABRYCZNY, :V_ROK_PRODUKCJI,
    :V_ODPOWIEDZIALNY, :V_ZESTAW, :V_PODZIAL, :V_KSIEGOWOSC, :V_POLOZENIE, :V_AMORTYZACJA,
    :V_BILANSOWY, :V_CENNOSC, :V_SEZONOWY, :V_POCZ_SEZONU, :V_DLUGOSC_SEZONU, :V_STAWKA,
    :V_PRZYSPIESZENIE, :V_DATA_ZAK, :V_DANE, :V_TYP_AMO, :V_POWIERZCHNIA,
    :V_UTWORZYL, :V_ZMIENIAL, :V_UTWORZONO, :V_ZMIENIANO,
    :V_BL_ILOSC, :V_BL_WART_BO, :V_BL_AMORT_BO, :V_BL_WART, :V_BL_AMORT,
    :D_Zaklad, :D_Zaklad_poch, :D_Rok, :D_Miesiac, :D_Data_wyst,
    :P_Typ_naliczenia, :P_SrodekWEwidencji, :P_SrodekPrzeniesiony,
    :P_Ilosc, :P_WKorekta, :P_AKorekta,
    :P_WBO, :P_ABO,
    :P_WPrzychod, :P_WRozchod, :P_APrzychod, :P_ARozchod, :P_VAT,
    :P_Polozenie, :P_StarePolozenie
  DO BEGIN
    IF (:V_KLUCZ <> :KLUCZ_AKT)                   /* Nowy srodek */
    THEN BEGIN
      IF ((:KLUCZ_AKT > 0) AND (:ILOSC_DOK > 0))  /* Poprzedni do zapisu */
      THEN BEGIN
        IF (:ROK > :ROK_AKT)
        THEN BEGIN  /* Zamkniecie roku */
          wart_bo = :wart_bo + :amort_biezaca;
          wart_biezaca = :wart_biezaca - :amort_biezaca;
          wart_pocz_roku = :wart_biezaca;
          amort_bo = :amort_bo + :amort_biezaca;
          amort_biezaca = 0;
        END

        /* Korekta ewentualnych bledow */

        IF (:BL_ILOSC IS NOT NULL)
        THEN BEGIN
          ILOSC = :ILOSC + :BL_ILOSC;
          IF (:BL_ILOSC < 0)
          THEN IPRZYCHOD = :IPRZYCHOD + :BL_ILOSC;
          ELSE IROZCHOD = :IROZCHOD - :BL_ILOSC;
        END

        IF (:BL_WART_BO IS NOT NULL)
        THEN WART_BO = :WART_BO + :BL_WART_BO;

        IF (:BL_AMORT_BO IS NOT NULL)
        THEN AMORT_BO = :AMORT_BO + :BL_AMORT_BO;

        IF (:BL_WART IS NOT NULL)
        THEN WART_BIEZACA = :WART_BIEZACA + :BL_WART;

        IF (:BL_AMORT IS NOT NULL)
        THEN AMORT_BIEZACA = :AMORT_BIEZACA + :BL_AMORT;

        /* Zaokraglenie */

        IF ((:WART_POCZ > -0.001)      AND (:WART_POCZ < 0.001))      THEN WART_POCZ = 0;
        IF ((:WART_BO > -0.001)        AND (:WART_BO < 0.001))        THEN WART_BO = 0;
        IF ((:AMORT_BO > -0.001)       AND (:AMORT_BO < 0.001))       THEN AMORT_BO = 0;
        IF ((:WART_BIEZACA > -0.001)   AND (:WART_BIEZACA < 0.001))   THEN WART_BIEZACA = 0;
        IF ((:WART_POCZ_ROKU > -0.001) AND (:WART_POCZ_ROKU < 0.001)) THEN WART_POCZ_ROKU = 0;
        IF ((:AMORT_BIEZACA > -0.001)  AND (:AMORT_BIEZACA < 0.001))  THEN AMORT_BIEZACA = 0;

        IF (:ZESTAW > 0)
        THEN SELECT
          T.AMORTYZACJA, T.BILANSOWY, T.CENNOSC, T.SEZONOWY, T.POCZ_SEZONU, T.DLUGOSC_SEZONU,
          T.STAWKA, T.PRZYSPIESZENIE
        FROM SrodkiTrwale T WHERE T.KLUCZ = :ZESTAW
        INTO
          :AMORTYZACJA, :BILANSOWY, :CENNOSC, :SEZONOWY, :POCZ_SEZONU, :DLUGOSC_SEZONU,
          :STAWKA, :PRZYSPIESZENIE;

        SUSPEND;
      END

      KLUCZ_AKT = :V_KLUCZ;

      ILOSC_DOK = 0;
      ROK_AKT = 0;

      KLUCZ =          :V_KLUCZ;
      SRODEK =         :V_SRODEK;
      NR_INWENT =      :V_NR_INWENT;
      DOSTAWCA =       :V_DOSTAWCA;
      NR_FABRYCZNY =   :V_NR_FABRYCZNY;
      ROK_PRODUKCJI =  :V_ROK_PRODUKCJI;
      ODPOWIEDZIALNY = :V_ODPOWIEDZIALNY;
      ZESTAW =         :V_ZESTAW;
      PODZIAL =        :V_PODZIAL;
      KSIEGOWOSC =     :V_KSIEGOWOSC;
      POLOZENIE =      :V_POLOZENIE;
      AMORTYZACJA =    :V_AMORTYZACJA;
      BILANSOWY =      :V_BILANSOWY;
      CENNOSC =        :V_CENNOSC;
      SEZONOWY =       :V_SEZONOWY;
      POCZ_SEZONU =    :V_POCZ_SEZONU;
      DLUGOSC_SEZONU = :V_DLUGOSC_SEZONU;
      STAWKA =         :V_STAWKA;
      PRZYSPIESZENIE = :V_PRZYSPIESZENIE;
      DATA_ZAK =       :V_DATA_ZAK;
      DANE =           :V_DANE;
      TYP_AMO =        :V_TYP_AMO;
      POWIERZCHNIA =   :V_POWIERZCHNIA;
      UTWORZYL =       :V_UTWORZYL;
      ZMIENIAL =       :V_ZMIENIAL;
      UTWORZONO =      :V_UTWORZONO;
      ZMIENIANO =      :V_ZMIENIANO;

      BL_ILOSC =       :V_BL_ILOSC;
      IF (:BL_ILOSC IS NULL)
      THEN BL_ILOSC = 0;
      BL_WART_BO =     :V_BL_WART_BO;
      BL_AMORT_BO =    :V_BL_AMORT_BO;
      BL_WART =        :V_BL_WART;
      BL_AMORT =       :V_BL_AMORT;

      STAN           = '';
      ZAKLAD         = 0;
      ILOSC          = 0;
      WART_POCZ      = 0;
      WART_BO        = 0;
      AMORT_BO       = 0;
      WART_BIEZACA   = 0;
      WART_POCZ_ROKU = 0;
      AMORT_BIEZACA  = 0;

      DATADOSTAWY    = NULL;
      DATALIKWIDACJI = NULL;

      UU1 = 0;
      UU2 = 0;
      UU3 = 0;
      UU4 = 0;
      UU5 = 0;
      UU6 = 0;
      UU7 = 0;
      UU8 = 0;
      UU9 = 0;
      UU10 = 0;
      UU11 = 0;
      UU12 = 0;

      MC_OST_NALICZENIA = 0;

      WART_ROKU  = 0;
      WART_BM    = 0;

      AMORT_ROKU = 0;
      AMORT_BM   = 0;

      WPRZYCHOD = 0;
      WROZCHOD  = 0;

      AAPRZYCHOD = 0;
      AROZCHOD  = 0;

      WART_KOREKTY  = 0;
      AMORT_KOREKTY = 0;

      IPRZYCHOD = 0;
      IROZCHOD = 0;

      ROK_ZAK = EXTRACT(YEAR FROM :DATA_ZAK);
    END

    IF ((:D_ROK < :ROK) OR (:D_ROK = :ROK AND :D_MIESIAC <= :MIESIAC)) /* Dokumenty do rok.miesiac */
    THEN BEGIN
      ILOSC_DOK = :ILOSC_DOK + 1;

      IF (:P_Ilosc IS NULL)     THEN P_Ilosc = 0;
      IF (:P_WKorekta IS NULL)  THEN P_WKorekta = 0;
      IF (:P_AKorekta IS NULL)  THEN P_AKorekta = 0;
      IF (:P_WBO IS NULL)       THEN P_WBO = 0;
      IF (:P_ABO IS NULL)       THEN P_ABO = 0;
      IF (:P_WPrzychod IS NULL) THEN P_WPrzychod = 0;
      IF (:P_WRozchod IS NULL)  THEN P_WRozchod = 0;
      IF (:P_APrzychod IS NULL) THEN P_APrzychod = 0;
      IF (:P_ARozchod IS NULL)  THEN P_ARozchod = 0;
      IF (:P_VAT IS NULL)       THEN P_VAT = 0;

      IF (:D_Rok > :ROK_AKT)
      THEN BEGIN  /* Zamkniecie roku */
        ROK_AKT = :D_Rok;
        wart_bo = :wart_bo + :amort_biezaca;
        wart_biezaca = :wart_biezaca - :amort_biezaca;
        wart_pocz_roku = :wart_biezaca;
        amort_bo = :amort_bo + :amort_biezaca;
        amort_biezaca = 0;
      END

      /* Przetwarzanie pol oryginalnych tabeli srodkow */

      IF (:P_Typ_naliczenia = 'P')  /* Przyjecie do ewidencji - powinien byc pierwszy dokument */
      THEN BEGIN
        IF (:DATADOSTAWY IS NULL)         /* Dla wyposazenia, dalej z tego powodu dosumowywanie */
        THEN DATADOSTAWY = :D_Data_wyst;
        ZAKLAD = :D_Zaklad;
        ILOSC = :ILOSC + :P_Ilosc;
        STAN = 'C';

        V_POCZ = :P_WPrzychod /*+ :P_VAT */; /* VAT jest rozny od 0 tylko w Aleksandrowie : WPrzychod = brutto - vat */
/*        WART_BO = :WART_BO + :P_WBO;  */
        WART_BO = :WART_BO + :P_ABO;
        AMORT_BO = :AMORT_BO + :P_ABO;
        WART_POCZ = :V_POCZ + :P_WBO;
        WART_POCZ_ROKU = :V_POCZ;
/*        WART_BIEZACA = :WART_BIEZACA + :V_POCZ + :P_WKorekta;  */
        WART_BIEZACA = :WART_BIEZACA + :V_POCZ + :P_WKorekta + (:P_WBO - :P_ABO);
        AMORT_BIEZACA = :AMORT_BIEZACA + :P_APrzychod + :P_AKorekta;
      END

      IF (:P_Typ_naliczenia = 'U')  /* Usuniecie z ewidencji */
      THEN BEGIN
        ILOSC = :ILOSC - :P_Ilosc;
        WART_BIEZACA = :WART_BIEZACA - :P_WRozchod;
        AMORT_BIEZACA = :AMORT_BIEZACA - :P_ARozchod;
        IF (:KSIEGOWOSC <> '2')     /* bez wyposazenia */
        THEN BEGIN
          STAN = 'L';
          DATALIKWIDACJI = :D_Data_wyst;
        END
      END

      IF (:P_Typ_naliczenia = '-')  /* Przeniesienie srodka */
      THEN BEGIN
        IF ((:KLUCZ = :P_SrodekWEwidencji) AND
          ((:P_SrodekPrzeniesiony IS NULL) OR (:P_SrodekPrzeniesiony = 0)))
        THEN BEGIN
          ZAKLAD = :D_Zaklad;
        END

        ELSE IF ((:KLUCZ = :P_SrodekWEwidencji) AND (:P_SrodekPrzeniesiony > 0))
        THEN BEGIN
          ILOSC = :ILOSC - :P_Ilosc;
          WART_BIEZACA = :WART_BIEZACA - :P_WRozchod;
          AMORT_BIEZACA = :AMORT_BIEZACA - :P_ARozchod;
        END

        IF (:KLUCZ = :P_SrodekPrzeniesiony)  /* Moglo go nie byc do tej pory */
        THEN BEGIN
          STAN = 'C';
          ZAKLAD = :D_Zaklad;
          ILOSC = :ILOSC + :P_Ilosc;
          WART_BIEZACA = :WART_BIEZACA + :P_WRozchod; /* Tu wyjatkowo rozchod jest przychodem */
          AMORT_BIEZACA = :AMORT_BIEZACA + :P_ARozchod;
        END
      END

      IF (:P_Typ_naliczenia = 'A')  /* Amortyzacja */
      THEN BEGIN
        AMORT_BIEZACA = :AMORT_BIEZACA + :P_APrzychod;
      END

      IF (:P_Typ_naliczenia = 'K')  /* Korekty */
      THEN BEGIN
        WART_BIEZACA = :WART_BIEZACA + :P_WPrzychod - :P_WRozchod;
        AMORT_BIEZACA = :AMORT_BIEZACA + :P_APrzychod - :P_ARozchod;
      END

      IF (:P_Typ_naliczenia = 'W')  /* Wylaczenie z uzytkowania */
      THEN BEGIN
        STAN = 'N';
      END

      IF (:P_Typ_naliczenia = 'R')  /* Przekazanie do uzytkowania */
      THEN BEGIN
        STAN = 'C';
      END

      IF ((:ILOSC + :BL_ILOSC = 0) AND (:V_STAN = 'L') AND  /* Tylko wyposazenie */
        (:KSIEGOWOSC = '2'))
      THEN BEGIN
        STAN = 'L';
        DATALIKWIDACJI = :D_Data_wyst;
      END

      /* Przetwarzanie pol kalkulacyjnych tabeli srodkow */

      IF ((:ROK = :D_Rok) AND  /* Amortyzacja biezacego roku - pelna - raczej tylko wyposazenie po przeniesieniu */
        (:P_Typ_naliczenia = '-') AND (:KLUCZ = :P_SrodekPrzeniesiony))
      THEN BEGIN
        AMORT_ROKU = :AMORT_ROKU + :P_ARozchod;  /* Tu wyjatkowo rozchod jest przychodem */
        IF (:MIESIAC = :D_Miesiac)
        THEN AMORT_BM = :AMORT_BM + :P_ARozchod;
      END

      IF ((:ROK = :D_Rok) AND  /* Amortyzacja biezacego roku - pelna - raczej tylko wyposazenie po przeniesieniu */
        (:P_Typ_naliczenia = '-') AND (:KLUCZ = :P_SrodekWEwidencji) AND (:P_SrodekPrzeniesiony > 0))
      THEN BEGIN
        AMORT_ROKU = :AMORT_ROKU - :P_ARozchod;  
        IF (:MIESIAC = :D_Miesiac)
        THEN AMORT_BM = :AMORT_BM - :P_ARozchod;
      END

      ELSE IF (:ROK = :D_Rok)  /* Amortyzacja biezacego roku - pelna */
      THEN BEGIN
        AMORT_ROKU = :AMORT_ROKU + :P_APrzychod - :P_ARozchod + :P_AKorekta;
        IF (:MIESIAC = :D_Miesiac)
        THEN AMORT_BM = :AMORT_BM + :P_APrzychod - :P_ARozchod + :P_AKorekta;
      END

      IF ((:ROK = :D_Rok) AND  /* Amortyzacja biezacego roku - tylko umorzenia */
        ((:P_Typ_naliczenia = 'A') OR (:P_Typ_naliczenia = 'P')))
      THEN BEGIN
        IF (:D_Miesiac = 1)     THEN UU1 = :UU1 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 2)     THEN UU2 = :UU2 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 3)     THEN UU3 = :UU3 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 4)     THEN UU4 = :UU4 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 5)     THEN UU5 = :UU5 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 6)     THEN UU6 = :UU6 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 7)     THEN UU7 = :UU7 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 8)     THEN UU8 = :UU8 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 9)     THEN UU9 = :UU9 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 10)    THEN UU10 = :UU10 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 11)    THEN UU11 = :UU11 + :P_APrzychod - :P_ARozchod;
        IF (:D_Miesiac = 12)    THEN UU12 = :UU12 + :P_APrzychod - :P_ARozchod;
        MC_OST_NALICZENIA = :D_Miesiac;
      END

      IF ((:ROK = :D_Rok) AND  /* Wartosc biezacego roku - pelna */
        (:P_Typ_naliczenia = '-') AND (:KLUCZ = :P_SrodekPrzeniesiony))
      THEN BEGIN
        WART_ROKU = :WART_ROKU + :P_WRozchod;  /* Tu wyjatkowo rozchod jest przychodem */
        IF (:MIESIAC = :D_Miesiac)
        THEN WART_BM = :WART_BM + :P_WRozchod;
      END

      ELSE IF ((:ROK = :D_Rok) AND  /* Wartosc biezacego roku - pelna */
        (:P_Typ_naliczenia = '-') AND (:KLUCZ = :P_SrodekWEwidencji) AND (:P_SrodekPrzeniesiony > 0))
      THEN BEGIN
        WART_ROKU = :WART_ROKU - :P_WRozchod;
        IF (:MIESIAC = :D_Miesiac)
        THEN WART_BM = :WART_BM - :P_WRozchod;
      END

      ELSE IF ((:ROK = :D_Rok) AND  /* Korekty biezacego roku - pelna */
        ((:P_Typ_naliczenia <> 'P') OR (:P_Typ_naliczenia = 'P') AND (:ROK_ZAK = :D_Rok)))
      THEN BEGIN
        WART_ROKU = :WART_ROKU + :P_WPrzychod - :P_WRozchod + :P_WKorekta;
        IF (:MIESIAC = :D_Miesiac)
        THEN WART_BM = :WART_BM + :P_WPrzychod - :P_WRozchod + :P_WKorekta;
      END

      ELSE IF ((:ROK = :D_Rok) AND  /* Korekty biezacego roku przy przyjciu starego srodka - pelna */
        (:P_Typ_naliczenia = 'P') AND (:ROK_ZAK < :D_Rok))
      THEN BEGIN
        WART_ROKU = :WART_ROKU + :P_WKorekta;
        IF (:MIESIAC = :D_Miesiac)
        THEN WART_BM = :WART_BM + :P_WKorekta;
      END

      IF (:ROK = :D_Rok)   /* Obroty wartosciowe biezacego roku  */
      THEN BEGIN
        IF (:P_Typ_naliczenia = '-')
        THEN BEGIN
          IF ((:KLUCZ = :P_SrodekWEwidencji) AND (:P_SrodekPrzeniesiony > 0))
          THEN BEGIN
            WROZCHOD = :WROZCHOD + :P_WRozchod;
            AROZCHOD = :AROZCHOD + :P_ARozchod;
          END
          IF (:KLUCZ = :P_SrodekPrzeniesiony)
          THEN BEGIN
            WPRZYCHOD = :WPRZYCHOD + :P_WRozchod; /* Tu wyjatkowo rozchod jest przychodem */
            AAPRZYCHOD = :AAPRZYCHOD + :P_ARozchod;
          END
        END
        ELSE BEGIN
          IF ((:P_Typ_naliczenia <> 'P') OR (:P_Typ_naliczenia = 'P') AND (:ROK_ZAK = :D_Rok))
          THEN WPRZYCHOD = :WPRZYCHOD + :P_WPrzychod;
          WROZCHOD = :WROZCHOD + :P_WRozchod;
          AAPRZYCHOD = :AAPRZYCHOD + :P_APrzychod;
          AROZCHOD = :AROZCHOD + :P_ARozchod;

          IF (:P_WKorekta > 0)
          THEN WPRZYCHOD = :WPRZYCHOD + :P_WKorekta;
          ELSE WROZCHOD = :WROZCHOD - :P_WKorekta;

          IF (:P_AKorekta > 0)
          THEN AAPRZYCHOD = :AAPRZYCHOD + :P_AKorekta;
          ELSE AROZCHOD = :AROZCHOD - :P_AKorekta;
        END

        IF ((:P_Typ_naliczenia = 'K') OR (:P_Typ_naliczenia = 'K'))
        THEN BEGIN
          WART_KOREKTY  = :WART_KOREKTY + :P_WPrzychod - :P_WRozchod;
          AMORT_KOREKTY  = :AMORT_KOREKTY + :P_APrzychod - :P_ARozchod;
        END
        WART_KOREKTY  = :WART_KOREKTY + :P_WKorekta;
        AMORT_KOREKTY  = :AMORT_KOREKTY + :P_AKorekta;
      END

      /* Obroty ilosciowe narastajaco  */
      IF (:P_Typ_naliczenia = '-')
      THEN BEGIN
        IF ((:KLUCZ = :P_SrodekWEwidencji) AND (:P_SrodekPrzeniesiony > 0))
        THEN BEGIN
          IROZCHOD = :IROZCHOD + :P_Ilosc;
        END
        IF (:KLUCZ = :P_SrodekPrzeniesiony)
        THEN BEGIN
          IPRZYCHOD = :IPRZYCHOD + :P_Ilosc;
        END
      END
      ELSE BEGIN
        IF (:P_Typ_naliczenia = 'P')
        THEN IPRZYCHOD = :IPRZYCHOD + :P_Ilosc;
        ELSE IF (:P_Typ_naliczenia = 'U')
        THEN IROZCHOD = :IROZCHOD + :P_Ilosc;
      END
    END
  END

  IF ((:KLUCZ_AKT > 0) AND (:ILOSC_DOK > 0))  /* Ostatni do zapisu */
  THEN BEGIN
    IF (:ROK > :ROK_AKT)
    THEN BEGIN  /* Zamkniecie roku */
      wart_bo = :wart_bo + :amort_biezaca;
      wart_biezaca = :wart_biezaca - :amort_biezaca;
      wart_pocz_roku = :wart_biezaca;
      amort_bo = :amort_bo + :amort_biezaca;
      amort_biezaca = 0;
    END

    /* Korekta ewentualnych bledow */

    IF (:BL_ILOSC IS NOT NULL)
    THEN BEGIN
      ILOSC = :ILOSC + :BL_ILOSC;
      IF (:BL_ILOSC < 0)
      THEN IPRZYCHOD = :IPRZYCHOD + :BL_ILOSC;
      ELSE IROZCHOD = :IROZCHOD - :BL_ILOSC;
    END

    IF (:BL_WART_BO IS NOT NULL)
    THEN WART_BO = :WART_BO + :BL_WART_BO;

    IF (:BL_AMORT_BO IS NOT NULL)
    THEN AMORT_BO = :AMORT_BO + :BL_AMORT_BO;

    IF (:BL_WART IS NOT NULL)
    THEN WART_BIEZACA = :WART_BIEZACA + :BL_WART;

    IF (:BL_AMORT IS NOT NULL)
    THEN AMORT_BIEZACA = :AMORT_BIEZACA + :BL_AMORT;

    /* Zaokraglenie */

    IF ((:WART_POCZ > -0.001)      AND (:WART_POCZ < 0.001))      THEN WART_POCZ = 0;
    IF ((:WART_BO > -0.001)        AND (:WART_BO < 0.001))        THEN WART_BO = 0;
    IF ((:AMORT_BO > -0.001)       AND (:AMORT_BO < 0.001))       THEN AMORT_BO = 0;
    IF ((:WART_BIEZACA > -0.001)   AND (:WART_BIEZACA < 0.001))   THEN WART_BIEZACA = 0;
    IF ((:WART_POCZ_ROKU > -0.001) AND (:WART_POCZ_ROKU < 0.001)) THEN WART_POCZ_ROKU = 0;
    IF ((:AMORT_BIEZACA > -0.001)  AND (:AMORT_BIEZACA < 0.001))  THEN AMORT_BIEZACA = 0;

    IF (:ZESTAW > 0)
    THEN SELECT
      T.AMORTYZACJA, T.BILANSOWY, T.CENNOSC, T.SEZONOWY, T.POCZ_SEZONU, T.DLUGOSC_SEZONU,
      T.STAWKA, T.PRZYSPIESZENIE
    FROM SrodkiTrwale T WHERE T.KLUCZ = :ZESTAW
    INTO
      :AMORTYZACJA, :BILANSOWY, :CENNOSC, :SEZONOWY, :POCZ_SEZONU, :DLUGOSC_SEZONU,
      :STAWKA, :PRZYSPIESZENIE;

    SUSPEND;
  END
END^

SET TERM ;^

COMMIT WORK;

/*---*/

CREATE TABLE INWENTARYZACJASRODKOW
       (KLUCZ               KLUCZ NOT NULL,
        ZAKLAD              KLUCZ NOT NULL,

        ROK                 INTEGER NOT NULL,
        MIESIAC             INTEGER NOT NULL,
        NR_DOKUM            SYMBOL NOT NULL,

        TYPSRODKOW          TYP,     /* Srodki, Wyposazenie - nowy program */

        DATA_WYST           TIMESTAMP,

        DANE                PARAMETRY,

        UTWORZYL         KLUCZ,
        ZMIENIAL         KLUCZ,
        UTWORZONO        TIMESTAMP,
        ZMIENIANO        TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

CREATE INDEX INWENTARYZACJASRODKOW_XOKRES ON
  INWENTARYZACJASRODKOW(ROK, MIESIAC, ZAKLAD, NR_DOKUM);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_INWENTARYZACJASRODKOW FOR INWENTARYZACJASRODKOW
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DOKUMENTYSRODKOW_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^

/*---*/

CREATE TABLE POZYCJEINWSRODKOW
       (DOKUMENT             KLUCZ NOT NULL,
        POZYCJA              INTEGER NOT NULL,

        SRODEKWEWIDENCJI     KLUCZ,
        NR_INWENT            VARCHAR(20),
        INNYSRODEK           DUZY_OPIS,

        ILOSC               INTEGER,
        EWIDENCJA           INTEGER,

        WARTOSC             WARTOSC,
        AMORTYZACJA         WARTOSC,

        DANE                PARAMETRY,

        UTWORZYL         KLUCZ,
        ZMIENIAL         KLUCZ,
        UTWORZONO        TIMESTAMP,
        ZMIENIANO        TIMESTAMP,

        PRIMARY KEY(DOKUMENT, POZYCJA),
        FOREIGN KEY(SRODEKWEWIDENCJI) REFERENCES SRODKITRWALE(KLUCZ));

/* ........................................................................ */

/* Bazy lekw */

CREATE TABLE BAZYL_KODY
       (TYP            VARCHAR(6) NOT NULL,
        BAZYL          VARCHAR(25) NOT NULL,
        LP             INTEGER NOT NULL,
        TECHNICZNE     TYP,
        BLOZ7          VARCHAR(7),
        NAZWA          VARCHAR(120),
        NAZWA_MN       VARCHAR(60),
        POSTAC         VARCHAR(32),
        DAWKA          VARCHAR(32),
        OPAKOWANIE     VARCHAR(42),
        SL_PROD        VARCHAR(6),
        PKWIU          VARCHAR(14),
        VAT            WARTOSC,
        WERSJA         TIMESTAMP,
        OBOWIAZUJE     VARCHAR(30),
        GRUPA_LIMIT    VARCHAR(10),
        NAZWA_LIMIT    VARCHAR(200),
        ZAKRES_WSKAZAN VARCHAR(200),
        ZAKRES_WSKAZAN1 VARCHAR(200),
        ODPLATNOSC     VARCHAR(3),
        CENA_ZBYT      WARTOSC,
        CENA_DET       WARTOSC,
        FIN_LIMIT      WARTOSC,
        DOPLATA        WARTOSC,
        PRIMARY KEY(BAZYL, LP, TYP));

CREATE INDEX BAZYLK_XBLOZ7 ON BAZYL_KODY(BLOZ7);
CREATE INDEX BAZYLK_XNAZWA ON BAZYL_KODY(NAZWA);
CREATE INDEX BAZYLK_XNAZWA_MN ON BAZYL_KODY(NAZWA_MN);


CREATE TABLE BAZYL_PRODUCENCI
       (TYP            VARCHAR(6) NOT NULL,
        SL_PROD        VARCHAR(6) NOT NULL,
        TECHNICZNE     TYP,
        PRODUCENT      VARCHAR(128) CHARACTER SET DOS852,
        KRAJ           VARCHAR(20) CHARACTER SET DOS852,
        PRIMARY KEY(TYP, SL_PROD));

/* CREATE INDEX BAZYL_PRODUCENCI_XPRODUCENT ON BAZYL_PRODUCENCI(PRODUCENT); */


/* --- */
/*
CREATE TABLE CHEMIOTERAPIA
       (NFZ            INTEGER NOT NULL,
        EAN            VARCHAR(25),
        SYMBOL         INTEGER,
        NAZWA          VARCHAR(100),
        GRUPA          INTEGER,
        NAZWA_GRUPY    VARCHAR(250),
        POSTAC         VARCHAR(100),
        DAWKA          VARCHAR(100),
        OPAKOWANIE     VARCHAR(100),
        PODMIOT        VARCHAR(100),
        ILOSC          ILOSC,
        JEDNOSTKA      VARCHAR(20),
        SZTUKI         ILOSC,
        PRIMARY KEY(NFZ));

CREATE INDEX CHEMIOTERAPIA_XEAN ON CHEMIOTERAPIA(EAN);
*/

/* --- */

CREATE TABLE PHI_ODCZYTY
       (CZAS        TIMESTAMP NOT NULL,
        KTO         KLUCZ,
        POPRAWNY    TAKNIE,
        OPIS        PARAMETRY,
        PRIMARY KEY(CZAS));


CREATE TABLE PHI_DiseasePayments
       (PaymentTypeId        INTEGER NOT NULL,
        PaymentType          VARCHAR(255),
        PaymentTypeDesc      VARCHAR(255),
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(PaymentTypeId));


CREATE TABLE PHI_Prescriptions
       (PrescriptionTypeId   INTEGER NOT NULL,
        PrescriptionType     VARCHAR(255),
        PrescriptionTypeDesc VARCHAR(255),
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(PrescriptionTypeId));


CREATE TABLE PHI_Diseases
       (DiseaseId            INTEGER NOT NULL,
        Disease              VARCHAR(255),
        DiseaseDesc          PARAMETRY,
        DiseaseType          INTEGER,            /* 0, 1, 2, 3 */
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(DiseaseId));


CREATE TABLE PHI_Atc
       (AtcCode              VARCHAR(30) NOT NULL,
        AtcName              VARCHAR(255),
        AtcLevel             VARCHAR(30),
        AtcParent            VARCHAR(30),
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(AtcCode));

CREATE  INDEX PHIX_Atc ON PHI_Atc(AtcName);


CREATE TABLE PHI_Subst
       (SubstId              INTEGER NOT NULL,
        SubstName            VARCHAR(255),
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(SubstId));

CREATE  INDEX PHIX_Subst ON PHI_Subst(SubstName);


CREATE TABLE PHI_Status
       (StatusId             VARCHAR(30) NOT NULL,
        StatusName           VARCHAR(255),
        PRIMARY KEY(StatusId));


CREATE TABLE PHI_CompanyList
       (DrugProdId           INTEGER NOT NULL,
        DrugProdName         VARCHAR(255),
        CompanyName          VARCHAR(255),
        CompanyStreet        VARCHAR(255),
        CompanyZip           VARCHAR(30),
        CompanyCity          VARCHAR(50),
        CompanyTel           VARCHAR(100),
        CompanyFax           VARCHAR(50),
        CompanyEmail         VARCHAR(255),
        CompanyWWW           VARCHAR(255),
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(DrugProdId));

CREATE  INDEX PHIX_CompanyList1 ON PHI_CompanyList(DrugProdName);
CREATE  INDEX PHIX_CompanyList2 ON PHI_CompanyList(CompanyName);


CREATE TABLE PHI_Drugs
       (DrugId               INTEGER NOT NULL,
        DrugShortName        VARCHAR(255),
        DrugDescComposition  PARAMETRY,
        DrugDescActivity     PARAMETRY,
        DrugDescIndication   PARAMETRY,
        DrugDescContrInd     PARAMETRY,
        DrugDescWarning      PARAMETRY,
        DrugDescPregn        PARAMETRY,
        DrugDescSideEff      PARAMETRY,
        DrugDescInter        PARAMETRY,
        DrugDescDosage       PARAMETRY,
        DrugDescNotes        PARAMETRY,
        DrugTherClass        VARCHAR(255),
        DrugProdName         VARCHAR(255),
        DrugProdID           INTEGER,
        DrugAtc              PARAMETRY,
        DrugSubst            PARAMETRY,
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(DrugId));

CREATE  INDEX PHIX_Drugs1 ON PHI_Drugs(DrugShortName);
CREATE  INDEX PHIX_Drugs2 ON PHI_Drugs(DrugProdName);
CREATE  INDEX PHIX_Drugs3 ON PHI_Drugs(DrugProdID);

        
CREATE TABLE PHI_DrugForms
       (PackageId            INTEGER NOT NULL,
        DrugId               INTEGER NOT NULL,
        SortForm             INTEGER,
        SortPackage          INTEGER,
        Bloz7                VARCHAR(255),
        DrugFullName         VARCHAR(255),
        DrugShortName        VARCHAR(255),
        DrugDosage           VARCHAR(255),
        DrugForm             VARCHAR(255),
        DrugPackage          VARCHAR(255),
        PrescriptionTypeId   INTEGER,
        IsReimbursed         INTEGER,
        IsNarcPsych          INTEGER,         
        Price                DOUBLE PRECISION,
        PriceLimit           DOUBLE PRECISION,
        DrugRegNr            VARCHAR(255),
        DrugEan              VARCHAR(255),
        PaymentDisease       PARAMETRY,
        PackageIndication    PARAMETRY,
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        Senior               TAKNIE,
        PRIMARY KEY(PackageId));

CREATE  INDEX PHIX_DrugForms1 ON PHI_DrugForms(DrugFullName);
CREATE  INDEX PHIX_DrugForms2 ON PHI_DrugForms(DrugShortName);
CREATE  INDEX PHIX_DrugForms3 ON PHI_DrugForms(Bloz7);
CREATE  INDEX PHIX_DrugForms4 ON PHI_DrugForms(DrugId);

CREATE TABLE PHI_packagesafety
       (PackageId            INTEGER NOT NULL,
        pregnancyid          INTEGER,
        trimester1id         INTEGER,
        trimester2id         INTEGER,
        trimester3id         INTEGER,
        lactationid          INTEGER,
        drivingid            INTEGER,   
        Modified             TIMESTAMP,
        PRIMARY KEY(PackageId));


CREATE TABLE PHI_pregnancycategory
       (pregnancycategoryid    INTEGER NOT NULL,
        pregnancycategorycode  VARCHAR(50),
        pregnancycategorynotes VARCHAR(255),
        ranking                VARCHAR(50),
        Modified               TIMESTAMP,
        Status                 VARCHAR(30),
        PRIMARY KEY(pregnancycategoryid));


CREATE TABLE PHI_drivingcategory
       (drivingcategoryid   INTEGER NOT NULL,
        drivingcategoryname VARCHAR(255),
        Modified            TIMESTAMP,
        PRIMARY KEY(drivingcategoryid));


CREATE TABLE PHI_drugformmarketstatus
       (PackageId            INTEGER NOT NULL,
        marketstatusid       INTEGER,
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(PackageId));

        
CREATE TABLE PHI_marketstatus
       (marketstatusid              INTEGER NOT NULL,
        marketstatusdescshort       VARCHAR(255),
        marketstatusdescription     VARCHAR(255),
        marketstatusfulldescription VARCHAR(255),
        Modified                    TIMESTAMP,
        Status                      VARCHAR(30),
        PRIMARY KEY(drivingcategoryid));


CREATE TABLE PHI_Indications
       (IndicationId         INTEGER NOT NULL,
        IndicationName       PARAMETRY,
        Modified             TIMESTAMP,
        Status               VARCHAR(30),
        PRIMARY KEY(IndicationId));


CREATE TABLE PHI_IndicationConditions
       (IndicationConditionId   INTEGER NOT NULL,
        IndicationConditionName VARCHAR(255),
        Status                  VARCHAR(30),
        PRIMARY KEY(IndicationConditionId));


CREATE TABLE PHI_ActiveComposition
       (PackageId            INTEGER NOT NULL,
        SubstId              INTEGER NOT NULL,
        itemid               INTEGER,
        itemtype             VARCHAR(255),
        itemname             VARCHAR(255),
        itemsperpack         INTEGER,
        amountperitem        VARCHAR(255),
        amountperpackage     VARCHAR(255),
        unitcode             VARCHAR(255),
        activesubstancegroupid INTEGER,
        activesubstancegroupname VARCHAR(255),
        PRIMARY KEY(PackageId, SubstId));


CREATE TABLE PHI_Skladniki
       (SubstId              INTEGER NOT NULL,
        DrugId               INTEGER NOT NULL);

CREATE  INDEX PHIX_Skladniki1 ON PHI_Skladniki(SubstId);
CREATE  INDEX PHIX_Skladniki2 ON PHI_Skladniki(DrugId);


CREATE TABLE PHI_Drug_ATC
       (AtcCode              VARCHAR(30) NOT NULL,
        DrugId               INTEGER NOT NULL);

CREATE  INDEX PHI_Drug_ATC1 ON PHI_Drug_ATC(AtcCode);
CREATE  INDEX PHI_Drug_ATC2 ON PHI_Drug_ATC(DrugId);

/* --- */

CREATE TABLE Produkty_lecznicze
       (IdProd                  VARCHAR(15) NOT NULL,
        IdOpak                  VARCHAR(15) NOT NULL,
        EAN                     VARCHAR(15) NOT NULL,
        NumerEU                 VARCHAR(15),
		TYP                     TYP,                    /* Produkt, Surowiec */
		ATC                     VARCHAR(30),
		NumerPozwolenia         VARCHAR(30),
		WaznoscPozwolenia       VARCHAR(30),
		TypProcedury            VARCHAR(5),
		PodmiotOdpowiedzialny   VARCHAR(100),
		DystrybutorRownolegly   VARCHAR(100),
		Postac                  VARCHAR(50),
		Moc                     VARCHAR(30),
		NazwaProduktu           VARCHAR(100),
		NazwaStosowana          VARCHAR(100),
        SubstancjeCzynne        VARCHAR(500),
        Wielkosc                INTEGER,
        JM                      VARCHAR(20),
        KategoriaDostepnosci    VARCHAR(3), 
        PRIMARY KEY(IdProd, IdOpak)); 		
		
CREATE  INDEX PL_EAN ON Produkty_lecznicze(EAN);
CREATE  INDEX PL_NazwaProd ON Produkty_lecznicze(NazwaProduktu);
CREATE  INDEX PL_NazwaStos ON Produkty_lecznicze(NazwaStosowana);
CREATE  INDEX PL_Subst ON Produkty_lecznicze(SubstancjeCzynne);


/* ........................................................................ */

/* Produkty (indeks towarowy) */

CREATE TABLE PRODUKTY
       (KLUCZ       	KLUCZ NOT NULL,
        MATERIAL     	KLUCZ NOT NULL,    /* odniesienie do tablicy INDEKS */

        NAZWA_HANDLOWA  VARCHAR(120) CHARACTER SET DOS852,
        PRODUCENT       VARCHAR(120) CHARACTER SET DOS852,
        OPIS            VARCHAR(84) CHARACTER SET DOS852,

        CECHY           VARCHAR(100),

        KOD_KRESKOWY    SYMBOL,
        URPL            SYMBOL, /* urz. rej. pr. leczniczych */
        CHEMIOTERAPIA   TAKNIE,
		GR_SUBST_LECZ   VARCHAR(15),
        KOD_NFZ         INTEGER,

        KRAJ_PROD       DUZA_NAZWA,
        KRAJ_KOD        VARCHAR(2),
        PRZECHOWYWANIE  DUZA_NAZWA,

        DO_ZSMOPL       TAKNIE,

        KTO_ATESTUJE    MALA_NAZWA,
        NR_ATESTU       MALA_NAZWA,
        DATA_ATESTU     TIMESTAMP,

        DAWKA           ILOSC,
        JM_EWID         IDENT,
        ILOSC_J_MIARY   ILOSC,
        ILOSC_DAWEK     ILOSC,
        JM_OPAK         IDENT,
        ILOSC_W_OPAK    ILOSC,
        POSTAC          DUZA_NAZWA,

        VAT             TYP,
        SWW             SYMBOL,

        ODPLATNOSC      VARCHAR(3),  /* REFUNDACJA */

        KOD_CN          SYMBOL,
        JM_STAT         IDENT,
        ILOSC_W_STAT    ILOSC,
        MASA_NETTO      ILOSC,

        CENA_PROD       WARTOSC,
        CENA_HURT       WARTOSC,
        CENA_DET        WARTOSC,
        CENA_URZ        WARTOSC,
        CENA_SPEC       WARTOSC,

        DANE            PARAMETRY,

        UTWORZYL     	KLUCZ,
        ZMIENIAL     	KLUCZ,
        UTWORZONO    	TIMESTAMP,
        ZMIENIANO    	TIMESTAMP,

        PRIMARY KEY(KLUCZ),
       	FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ));

CREATE INDEX PRODUKTY_XNAZWA ON PRODUKTY(NAZWA_HANDLOWA);
CREATE INDEX PRODUKTY_XPRODUCENT ON PRODUKTY(PRODUCENT);
CREATE INDEX PRODUKTY_XKODKRES ON PRODUKTY(KOD_KRESKOWY);
CREATE INDEX PRODUKTY_XKOD_NFZ ON PRODUKTY(KOD_NFZ);

SET TERM ^ ;
CREATE TRIGGER CREATE_PRODUKTY FOR PRODUKTY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(WMAGAZYNIE_GEN, 1);
END ^
SET TERM ; ^

CREATE TABLE KODY_PRODUKTOW
       (TYP             VARCHAR(6) NOT NULL,
        KOD             VARCHAR(12) NOT NULL,
        BLOZ7           VARCHAR(7),
        PRODUKT         KLUCZ NOT NULL,
        DOSTAWCA        KLUCZ NOT NULL,
        PRIMARY KEY(TYP, KOD, PRODUKT, DOSTAWCA),
        FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ));

CREATE INDEX KPRODUKTOW_XBLOZ7 ON KODY_PRODUKTOW(BLOZ7);

CREATE TABLE ZAKLADY_PRODUKTOW
       (ZAKLAD          KLUCZ NOT NULL,
        PRODUKT         KLUCZ NOT NULL
        MINIMUM         ILOSC,               /* ewidencyjne */
        PARTIA          ILOSC,               /* opakowania */
        PRIMARY KEY(ZAKLAD, PRODUKT),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ));

CREATE TABLE TARYFY_PRODUKTOW
       (PRODUKT           KLUCZ NOT NULL,
        KOD_KRESKOWY    SYMBOL,
		GR_SUBST_LECZ   VARCHAR(15),
        KOD_KATALOGU      VARCHAR(20) NOT NULL,
        DATA_OD           TIMESTAMP NOT NULL,
        DATA_DO           TIMESTAMP,
        LB_ROZ_JEDNOSTEK  ILOSC,
        TARYFA_BAZOWA     WARTOSC,
        PRIMARY KEY(PRODUKT, KOD_KATALOGU, DATA_OD));
		
CREATE INDEX TPRODUKTOW_XKOD_KRESKOWY ON TARYFY_PRODUKTOW(KOD_KRESKOWY, DATA_OD);

/*---*/

ALTER TABLE WMAGAZYNIE
ADD FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ);

/*---*/

CREATE TABLE ODCZYTY_NMVS
       (KLUCZ             KLUCZ NOT NULL,   /* sluzy jako numer transakcji do NMVS */
	    PRODUKT           KLUCZ,
		WMAGAZYNIE        KLUCZ,            /* chyba nie bedzie uzywane */ 
		TYP_KODU          VARCHAR(5),       /* GTIN, PPN */
        KOD_KRESKOWY      SYMBOL,
        SERIA             DUZA_NAZWA,
        DATA_WAZNOSCI     TIMESTAMP,
		NR_OPAK           VARCHAR(25),      /* wykorzystanych jest 20 */  
        PROCEDURA         VARCHAR(20),      /* nazwa procedury NMVS, wstepna weryfikacja jest pomijana */
		DATA_WYK          TIMESTAMP,        /* czas programowy wykonania */
		KTO               KLUCZ,
        NMVS_TRANS        VARCHAR(35), 		/* wykorzystanych jest 32 */
		NMVS_DATA         TIMESTAMP,
		NMVS_STATUS       VARCHAR(50),
		NMVS_PRZYCZYNA    VARCHAR(50),
		NMVS_RESULT       TAKNIE,
		NMVS_BLAD         UWAGI,
        NMVS_UWAGI        UWAGI,		
		BLAD              TAKNIE,           /* faktycznie B dla bledu */
		AXON_STATUS       VARCHAR(30),      /* BRAK DANYCH, AKTYWNY, NIEAKTYWNY,  
		                                       POBRANY, PRBKA, ZNISZCZONY, SKRADZIONY */
		
		GRUPA_KLUCZ       KLUCZ,

        PRIMARY KEY(KLUCZ));

CREATE INDEX NMVS_PRODUKT ON ODCZYTY_NMVS(PRODUKT);
CREATE INDEX NMVS_WMAGAZYNIE ON ODCZYTY_NMVS(WMAGAZYNIE);
CREATE INDEX NMVS_OPAK ON ODCZYTY_NMVS(NR_OPAK);
CREATE INDEX NMVS_KOD ON ODCZYTY_NMVS(KOD_KRESKOWY);
CREATE INDEX NMVS_DATA ON ODCZYTY_NMVS(DATA_WYK);
CREATE INDEX NMVS_GRUPA ON ODCZYTY_NMVS(GRUPA_KLUCZ);


CREATE TABLE GRUPY_NMVS
       (KLUCZ             KLUCZ NOT NULL,   /* sluzy jako numer transakcji do NMVS */
		DATA_UTWORZENIA   TIMESTAMP,      
		DATA_WYSLANIA     TIMESTAMP,      
		DATA_POBRANIA     TIMESTAMP,      
		KTO               KLUCZ,
        NMVS_TRANS        VARCHAR(35), 		/* wykorzystanych jest 32 */
		NMVS_RESULT       TAKNIE,
		NMVS_BLAD         UWAGI,
        NMVS_UWAGI        UWAGI,		

        PRIMARY KEY(KLUCZ));

CREATE INDEX NMVS_GRUPA_DATA ON GRUPY_NMVS(DATA_WYSLANIA);
		
/*---*/

CREATE TABLE ZAMOWIENIA
       (KLUCZ        	KLUCZ NOT NULL,
        ZAKLAD        KLUCZ NOT NULL,
        ZAKLAD_WYK    KLUCZ,   /* Zakad wykonujcy zamwienie - apteka */
        FIRMA         KLUCZ,
        WARTOSC         WARTOSC,

        PACJENT         KLUCZ,
        POBYT           KLUCZ,


        ROK             INTEGER NOT NULL,
        NR_DOKUM        SYMBOL NOT NULL,

        ZLECAJACY       KLUCZ,
        DATA_WYST       TIMESTAMP,

        TYP_KODU        VARCHAR(6),        /* BAZYL, FIRMA */
        DANE            PARAMETRY,

        UTWORZYL     	KLUCZ,
        ZMIENIAL     	KLUCZ,
        UTWORZONO    	TIMESTAMP,
        ZMIENIANO    	TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(ZAKLAD_WYK) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(ZLECAJACY) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ));

CREATE INDEX ZAMOWIENIA_XOKRES ON ZAMOWIENIA(ZAKLAD, ROK, NR_DOKUM);


CREATE TABLE POZYCJAZAMOWIENIA
       (ZAMOWIENIE      KLUCZ NOT NULL,
        POZYCJA         INTEGER NOT NULL,

        MATERIAL        KLUCZ NOT NULL,    /* odniesienie do tablicy INDEKS */
        PRODUKT         KLUCZ NOT NULL,    /* odniesienie do tablicy PRODUKTY */

        ILOSC           ILOSC,
        CENA            WARTOSC,           /* prognoza */
        ILOSCOPAK       ILOSC,
        CENAOPAK        WARTOSC,           /* prognoza */
        WARTOSC         WARTOSC,

        PACJENT         KLUCZ,
        POBYT           KLUCZ,

        KOD             VARCHAR(12),       /* numer katalogowy dostawcy */
        NAZWA           VARCHAR(120) CHARACTER SET DOS852,
        PRODUCENT       VARCHAR(120) CHARACTER SET DOS852,
        OPIS            VARCHAR(84) CHARACTER SET DOS852,
        POSTAC          DUZA_NAZWA,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(ZAMOWIENIE, POZYCJA),
        FOREIGN KEY(ZAMOWIENIE) REFERENCES ZAMOWIENIA(KLUCZ),
        FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ),
        FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ));

CREATE INDEX POZYCJAZAMOWIENIA_XNAZWA ON POZYCJAZAMOWIENIA(ZAMOWIENIE, NAZWA);

COMMIT WORK;

/* ........................................................................ */

CREATE TABLE NUMERYRECEPT
       (KASACHORYCH     KASACHORYCH NOT NULL,   /* Teraz NFZ */
        LEKARZ          KLUCZ NOT NULL,         /* 0 gdy dla caej jednostki - 0 nieaktualne */
        NR_START        DECIMAL(16) NOT NULL,   /* Nadany przez NFZ */
        NR_END          DECIMAL(16) NOT NULL,   /* Nadany przez NFZ */
        NR_WOLNY        DECIMAL(16) NOT NULL,   /* Pierwszy wolny, gdy > END zamyka pul */  
        LP              INTEGER NOT NULL,       /* Dodatkowy klucz */
        ZAKLAD          INTEGER,

        POCZATEK        VARCHAR(2),
        TYPRECEPTY      TYP,          /* 8 - Rp (moze byc puste), 9 - Rpw */
        DATA            TIMESTAMP,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(NR_START, KASACHORYCH));

CREATE INDEX XNRLEKARZ ON NUMERYRECEPT(LEKARZ);

CREATE TABLE PUSTERECEPTY
       (KLUCZ           KLUCZ NOT NULL,
        NR_NFZ          DECIMAL(16),
        NUMER           VARCHAR(25),  /* Aktualnie wykorzystane 20 cyfr */
        LEKARZ          KLUCZ,
        DATAWYSTAWIENIA TIMESTAMP,
        KASACHORYCH     KASACHORYCH,   /* Teraz NFZ */
        TYPRECEPTY      TYP,          /* 8 - Rp (moze byc puste), 9 - Rpw */
        WYDRUKOWANA     TAKNIE,            /* T - wydrukowana, A - anulowana */

        PRIMARY KEY(KLUCZ));

CREATE INDEX PUSTEXNR_NFZ ON PUSTERECEPTY(NR_NFZ);
CREATE INDEX PUSTEXLEKARZ ON PUSTERECEPTY(LEKARZ);



CREATE TABLE NAGLOWEKRECEPTY
       (KLUCZ           KLUCZ NOT NULL,
        POBYT           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,
        WIZYTA          INTEGER,
        PACJENT         KLUCZ NOT NULL,
        NR_NFZ          DECIMAL(16),
        NUMER           VARCHAR(25),  /* Aktualnie wykorzystane 22 cyfry */

		P1_WYSLANO      TIMESTAMP,
		P1_WERSJA       INTEGER,
        P1_KOD_DOSTEPU  VARCHAR(60),
        P1_KLUCZ        VARCHAR(60),
        P1_ID_ZADANIA   VARCHAR(60),
		P1_RESPONSE     XML2,

        LEKARZ          KLUCZ,
        DATAWYSTAWIENIA TIMESTAMP,
        KASACHORYCH     KASACHORYCH,   /* Teraz NFZ */
        UPRAWNIENIA     VARCHAR(5),
        CHOROBAPRZEWLEKLA TYP,
        CITO            TYP,
        TYPRECEPTY      TYP,          /* 8 - Rp (moze byc puste), 9 - Rpw */

        LP              INTEGER NOT NULL,  /* Kolejna recepta dla tego samego pacjenta w ramach wizyty */
        DOKUMENT        VARCHAR(30),       /* Pesel lub inny dokument */
        KOORDYNACJA     VARCHAR(30),       /* Dane pacjentw UE */
		                                   /* Od 12-01-2019 : P lub pobierane z Pacjent.TypDowodu */
        DATAREALIZACJI  TIMESTAMP,

        WYDRUKOWANA     TAKNIE,            /* T - wydrukowana, A - anulowana */
        UWAGI           UWAGI,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ));

CREATE UNIQUE INDEX XPOBZAKLPAC ON NAGLOWEKRECEPTY(POBYT, ZAKLAD, PACJENT, LP);
CREATE INDEX XNR_NFZ ON NAGLOWEKRECEPTY(NR_NFZ);

SET TERM ^ ;
CREATE GENERATOR NAGLOWEKRECEPTY_GEN^

CREATE TRIGGER CREATE_NAGLOWEKRECEPTY FOR NAGLOWEKRECEPTY
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(NAGLOWEKRECEPTY_GEN, 1);
END ^

CREATE PROCEDURE DAJ_NAGLOWEKRECEPTY
RETURNS (NAGLOWEK INTEGER)
AS BEGIN
  NAGLOWEK = GEN_ID(NAGLOWEKRECEPTY_GEN,1);
END ^
COMMIT WORK ^
SET TERM ; ^

CREATE TABLE RECEPTY
       (POBYT           KLUCZ NOT NULL,
        RECEPTA         KLUCZ NOT NULL,
        POZYCJA         INTEGER NOT NULL,
        STRONA          INTEGER,

        MATERIAL        KLUCZ,
        PRODUKT         KLUCZ,
        TYPKODU         VARCHAR(6),
        KOD             VARCHAR(25),

        KOD_KRESKOWY    SYMBOL,
        URPL            SYMBOL, /* urz. rej. pr. leczniczych */
		
		IDPROD          VARCHAR(15), /* kod CSIOZ */
        WIELKOSC        INTEGER,     /* tez dla CSIOZ */		
		
        P1_KLUCZ        VARCHAR(60),
        P1_STATUS       VARCHAR(30),
        P1_ROOT         VARCHAR(60),   
        P1_EXTENSION    VARCHAR(22),
		XML             XML2,

        NAZWA           VARCHAR(80),
        OPAK            VARCHAR(40),

        NAZWAIOPIS      VARCHAR(120),
        ILOSC           MALA_NAZWA,
        JM              JM,

		DAWKA           VARCHAR(30),
		POSTAC          VARCHAR(30),
		WOPAKOWANIU     VARCHAR(30),
		
        DAWKOWANIE      UWAGI,
		OPIS_PSYCHO     VARCHAR(250),    /* Opis psychotropw */
		NAZWA_PSYCHO    VARCHAR(100),
		RECEPTURA       PARAMETRY,

        ODPLATNOSC      VARCHAR(3),
        NZ              VARCHAR(1),      /* Nie Zmienia */
        SENIOR          VARCHAR(1),      /* S dla seniorow */

        R365            TAKNIE,          /* realizacje do 365 dni */
		
		SUBST_CZ_ILOSC  WARTOSC,
		SUBST_CZ_JEDN   VARCHAR(3),
		
        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(RECEPTA, POBYT, POZYCJA),
        FOREIGN KEY(RECEPTA) REFERENCES NAGLOWEKRECEPTY(KLUCZ),
        FOREIGN KEY(POBYT) REFERENCES POBYTY(KLUCZ),
        FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ),
        FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ));


CREATE TABLE RECEPTURYRECEPTY
       (KLUCZ           KLUCZ NOT NULL,
        ZAKLAD          KLUCZ,
		OSOBA           KLUCZ,
        IDENT           VARCHAR(10),
        NAZWA           VARCHAR(50),
        RECEPTURA       PARAMETRY,

        PRIMARY KEY(KLUCZ));		


/* ........................................................................ */

CREATE TABLE RECEPTURA
       (PRODUKT         KLUCZ NOT NULL,
        MATERIAL        KLUCZ,
        ILOSC           ILOSC,

        DANE            PARAMETRY,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ),
        FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ),
        PRIMARY KEY(PRODUKT));


CREATE TABLE POZRECEPTURY
       (PRODUKT         KLUCZ NOT NULL,
        SKLADNIK        KLUCZ NOT NULL,
        MATERIAL        KLUCZ,
        LP              INTEGER,

        ILOSC           ILOSC,

        UTWORZYL        KLUCZ,
        ZMIENIAL        KLUCZ,
        UTWORZONO       TIMESTAMP,
        ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(PRODUKT, SKLADNIK),
        FOREIGN KEY(PRODUKT) REFERENCES PRODUKTY(KLUCZ),
        FOREIGN KEY(SKLADNIK) REFERENCES PRODUKTY(KLUCZ),
        FOREIGN KEY(MATERIAL) REFERENCES INDEKS(KLUCZ));

/*===================*/
/* Kadrowe i pacowe */
/* ==================*/

CREATE GENERATOR UNIQUE_KEY_GEN;

CREATE TABLE DYZUR
(
  KLUCZ     KLUCZ NOT NULL,
  OSOBA     KLUCZ NOT NULL,
  ANGAZ     KLUCZ NOT NULL,
  ZAKLAD    KLUCZ,

  BLOKADA           TAKNIE, /* Semafor przy rezerwacji wizyty */

  BUDYNEK           DIDENT,
  LOKAL             DIDENT,
  TYP_DYZURU        DIDENT,
  DATA_OD           TIMESTAMP NOT NULL,
  DATA_DO           TIMESTAMP,
  LIMIT_W           INTEGER,
  JEDNORAZOWO       INTEGER,
  LP_START          INTEGER,
  ZAOKRAGLENIEMINUT VARCHAR(2), /* do 10, 15, 20, 30, 60 minut */
  BLOKUJREZERWACJE  TAKNIE,

  DOPORTALU   TAKNIE,
  WPORTALU  KLUCZ,

  ZNANYLEKARZ KLUCZ,

  PRIMARY KEY (OSOBA, ANGAZ, DATA_OD),
  FOREIGN KEY (OSOBA) REFERENCES OSOBY(KLUCZ),
  FOREIGN KEY (ZAKLAD) REFERENCES ZAKLADY(KLUCZ)
);

COMMIT WORK;

CREATE UNIQUE INDEX DYZUR_KLUCZ ON DYZUR(KLUCZ);
CREATE INDEX DYZUR_ANGAZ ON DYZUR(ANGAZ);
CREATE INDEX DYZUR_DATA ON DYZUR(DATA_OD, OSOBA);
CREATE INDEX DYZUR_WPORTALU ON DYZUR(WPORTALU);

SET TERM ^ ;

CREATE TRIGGER CREATE_DYZUR FOR DYZUR
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

SET TERM ; ^

COMMIT WORK;

/* OBSlUGA REZERWACJI WIZYT W GABINETACH */

SET TERM ^ ;
CREATE PROCEDURE REZERWACJA_WIZYTY(
  DYZUR       INTEGER,
  PACJENT     INTEGER,
  POBYT       INTEGER,
  DO_KOGO     INTEGER,
  NA_KIEDY    TIMESTAMP,
  JEDNORAZOWO INTEGER,
  OD_GODZ     TIMESTAMP,
  DO_GODZ     TIMESTAMP,
  UTWORZYL    INTEGER,
  UTWORZONO   TIMESTAMP)
RETURNS (ZLECENIE INTEGER)   /* < 0 - ZAJTE, = 0 - BLOKADA, > 0 - KLUCZ REKORDU */
AS
DECLARE VARIABLE VBLOKADA    VARCHAR(1);
DECLARE VARIABLE VILOSC      INTEGER;
BEGIN
 ZLECENIE = 0;

 SELECT BLOKADA FROM DYZUR
 WHERE KLUCZ = :DYZUR
 INTO :VBLOKADA;

 IF (:VBLOKADA IS NULL)
 THEN BEGIN
   /* Semafor ON */
   UPDATE DYZUR SET BLOKADA = 'T' WHERE KLUCZ = :DYZUR;

   SELECT COUNT(KLUCZ) FROM ZLECENIA
   WHERE
     DYZUR = :DYZUR AND POZAGRAFIKIEM IS NULL AND
     NA_KIEDY >= :OD_GODZ AND NA_KIEDY < :DO_GODZ AND
     STAN IN ('D', 'W')
   INTO :VILOSC;

   IF (:VILOSC >= :JEDNORAZOWO)
   THEN ZLECENIE = -1;
   ELSE BEGIN
     ZLECENIE = GEN_ID(ZLECENIA_GEN, 1);
     INSERT INTO ZLECENIA(KLUCZ, PACJENT, POBYT, DO_KOGO, DYZUR, NA_KIEDY, TYP, STAN, UTWORZYL, UTWORZONO)
     VALUES(:ZLECENIE, :PACJENT, :POBYT, :DO_KOGO, :DYZUR, :NA_KIEDY, 'B', 'D', :UTWORZYL, :UTWORZONO);
   END

   /* Semafor OFF */
   UPDATE DYZUR SET BLOKADA = NULL WHERE KLUCZ = :DYZUR;
 END

 SUSPEND;

END ^

SET TERM ; ^

COMMIT WORK;


/* Schematy dyzurow */

CREATE TABLE GRAFIK
(
  KLUCZ KLUCZ NOT NULL,
  WERSJA INTEGER NOT NULL,     /* Zawsze 1 */
  TYP_GRAFIKU IDENT, /* 1 - standard, 2 - czterobrygadowka */
  WAZNY_OD TIMESTAMP NOT NULL, /* Zawsze data utworzenia dla standard */
  INDYWIDUALNY BOOLEAN,
  NAZWA DUZA_NAZWA,

  PRIMARY KEY (KLUCZ)
);

CREATE UNIQUE INDEX IDX_GRAFIK1 ON GRAFIK(KLUCZ, WERSJA, WAZNY_OD);

COMMIT;

SET TERM ^ ;

CREATE TRIGGER CREATE_GRAFIK FOR GRAFIK
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^



CREATE TABLE TYPY_TYGODNIA
(
  KLUCZ KLUCZ NOT NULL,
  NAZWA DUZA_NAZWA,
  OD_DNIA TIMESTAMP,
  TYP CHAR(1), /* D - standard, K - tydzien z data, P - parzysty, N - nieparzysty, O - ostatni, W - pierwszy */
  WARUNKI PARAMETRY,

  PRIMARY KEY (KLUCZ)
);


SET TERM ^ ;

CREATE TRIGGER CREATE_TYPY_TYGODNIA FOR TYPY_TYGODNIA
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^


CREATE TABLE GRAFIK_TYGODNIOWY
(
  KLUCZ KLUCZ NOT NULL,
  GRAFIK INTEGER NOT NULL,
  TYP_TYGODNIA INTEGER NOT NULL,

  PRIMARY KEY (KLUCZ),
  FOREIGN KEY (GRAFIK) REFERENCES GRAFIK(KLUCZ),
  FOREIGN KEY (TYP_TYGODNIA) REFERENCES TYPY_TYGODNIA(KLUCZ)
);

SET TERM ^ ;

CREATE TRIGGER CREATE_GRAFIK_TYGODNIOWY FOR GRAFIK_TYGODNIOWY
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^


CREATE TABLE DEF_DYZURU
(
  GRAFIK_TYG INTEGER NOT NULL,
  DZIEN NUMERY_DNI_TYGODNIA NOT NULL,
  GODZ_OD TIMESTAMP NOT NULL,
  ILOSC_GODZ TIMESTAMP,
  ZAKLAD KLUCZ,
  BUDYNEK DIDENT,
  LOKAL DIDENT,
  OPIS DUZA_NAZWA,
  TYP_DYZURU DIDENT,
  LIMIT_W INTEGER,
  JEDNORAZOWO INTEGER,
  LP_START INTEGER,
  ZAOKRAGLENIEMINUT VARCHAR(2), /* do 10, 15, 20, 30, 60 minut */

  DOPORTALU  TAKNIE,
  ZNANYLEKARZ KLUCZ,            /* identyfikator specjalnosci lekarza w ZL */

  PRIMARY KEY (GRAFIK_TYG, DZIEN, GODZ_OD),
  FOREIGN KEY (ZAKLAD) REFERENCES ZAKLADY(KLUCZ)
);
CREATE UNIQUE INDEX IDX_DEFDYZURU1 ON DEF_DYZURU(GRAFIK_TYG, DZIEN, GODZ_OD);


SET TERM ^ ;
CREATE PROCEDURE GET_UNIQUE_KEY_GEN
RETURNS
(
  IDENT INTEGER
)
AS
 BEGIN
  IDENT = GEN_ID(UNIQUE_KEY_GEN,1);
END ^
SET TERM ; ^


/* obsluga grafiku dla osob */


CREATE TABLE OSOBA_GRAF
(
  OSOBA KLUCZ NOT NULL,
  GRAFIK KLUCZ NOT NULL,
  ANGAZ KLUCZ NOT NULL,     /* moze byc 0 stad brak Foreign key */
  WAZNY_OD TIMESTAMP,

  PRIMARY KEY (OSOBA, ANGAZ, GRAFIK),     /* Grafik jest nadmiarowy, moze byc tylko 1 */
  FOREIGN KEY (OSOBA) REFERENCES OSOBY(KLUCZ),
  FOREIGN KEY (GRAFIK) REFERENCES GRAFIK(KLUCZ)
);


/* Rzeczywisty czas pracy */


CREATE TABLE GODZ_PRACY
(
  KLUCZ KLUCZ NOT NULL,
  OSOBA KLUCZ NOT NULL,
  ANGAZ KLUCZ NOT NULL,
  DATA_OD TIMESTAMP NOT NULL,
  DATA_DO TIMESTAMP,
  ZAKLAD KLUCZ,
  TYP_DYZURU DIDENT,

  PRIMARY KEY (OSOBA, ANGAZ, DATA_OD),
  FOREIGN KEY (OSOBA) REFERENCES OSOBY(KLUCZ),
  FOREIGN KEY (ZAKLAD) REFERENCES ZAKLADY(KLUCZ)
);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_GODZ_PRACY FOR GODZ_PRACY
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^


/* Podsumowanie czasu pracy */

CREATE TABLE CZAS_PRACY
       (
       DATA                TIMESTAMP NOT NULL,
       OSOBA               KLUCZ NOT NULL,
       ANGAZ               KLUCZ NOT NULL,
       ZAKLAD              KLUCZ NOT NULL,
       TYP_DYZURU          DIDENT NOT NULL,
       RODZAJ_NIEOBECNOSCI DIDENT NOT NULL,  /* "-" oznacza obecno, inne : IDENT z tabeli Rodzaje_nieobecnosci */
       GODZ_NAL            WARTOSC,          /* suma na dzie wynika z grafiku */
       GODZ_RZ             WARTOSC,

       PRIMARY KEY (DATA, OSOBA, ANGAZ, ZAKLAD, TYP_DYZURU, RODZAJ_NIEOBECNOSCI),
       FOREIGN KEY (OSOBA) REFERENCES OSOBY(KLUCZ)
       );


/* ------------------------- */
/* Definicje tabel pacowych */
/* ------------------------- */

CREATE TABLE DEF_LIST_PLAC
       (KLUCZ           KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,

        IDENT           SYMBOL NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,
        BEZ_PFRON       TAKNIE,
		PODATEK_PPK     TAKNIE,

        WAZNA_OD        TIMESTAMP,  /* Nie wykorzystane */

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,
        PRIMARY KEY(KLUCZ, WERSJA)
       );
/*
  OPIS
  ------

  KLUCZ - klucz glowny
  WERSJA - wersja definicji listy plac (1, ..) rozszerza klucz glowny
  IDENT - znakowy odpowiednik klucza, to co bedzie widoczne dla uzytkownika

*/

SET TERM ^ ;

CREATE TRIGGER CREATE_DEF_LIST_PLAC FOR DEF_LIST_PLAC
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^

SET TERM ; ^

/* ------------------------------------ */
/* Definicje skadnikw tabel pacowych */
/* ------------------------------------ */

CREATE TABLE ELEM_DEF_LISTY_PLAC
       (KLUCZ           KLUCZ NOT NULL,
        IDENT           SYMBOL NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,

        DEFINICJA       VARCHAR(60),

        NAGLOWEK_EDYCJI DUZA_NAZWA,
        NAGLOWEK_LISTY  DUZA_NAZWA,

        ZUS             VARCHAR(255),
        WSKAZNIK_RPA    VARCHAR(255);  /* wskaznik, do ktorej czesci RPA skladnik ma isc */
        PODATKI         VARCHAR(25),
        KOSZTY          VARCHAR(25),
        KASA_CH         VARCHAR(25),
        DO_SREDNICH     VARCHAR(255),
        DOT_UB_MCA      TAKNIE,
        UZUP_DO_MCA     TAKNIE,          /* N - bez uzupeniania, T - wg rz.cz.pracy (domylnie), K - wg kal.cz.pracy */
        DOTYCZY_NB      VARCHAR(10),     /* Nieobecnosci */
        DOTYCZY_KP      VARCHAR(15),     /* Karta pracy */
        DOTYCZY_DDT     VARCHAR(10),     /* Dodatki */
        DOTYCZY_PTR     VARCHAR(10),     /* Potrcenia */

        DO_PIT8C        IDENT,

        WYRAZENIE       KLUCZ,
        BLOKADA         TAKNIE,
        PIENIADZE       TAKNIE,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_ELEM_DEF_LISTY_PLAC FOR ELEM_DEF_LISTY_PLAC
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

/*
  OPIS
  -----

  KLUCZ - klucz glowny
  IDENT - widziany przez uzytkownika ident. elementu - nazwa pola tabeli wirtualnej
  DEF_LIST_PLAC - klucz obcy, powiazanie z DEF_LIST_PLAC

  DEFINICJA - zawiera w sobie trzy ponisze pola oddzielone srednikami (w programie kalkulacyjne)

  TYP_PLATNOSCI - jakie to sa pieniadze np. wyplata, potracenie itd.
  ROLA_SYSTEMOWA - rola jaka pelni dany skladnik (ZUS, US itd.)
  IDENT_SYSTEMOWY - identyfiaktor w obrebie danej roli systemowej (np. kod zasilku ZUS)

  NAGLOWEK_EDYCJI - etykieta widoczna podczas edycji elementu na formie
  NAGLOWEK_LISTY - etykieta elementu drukowana np. na pasku
  POWIAZANIA - wykaz identyfikatorow do ktorych nalezy przekazac dane (np. posumowac itd.)

*/

COMMIT WORK;

CREATE TABLE ELEM_LISTY_PLAC
       (DEF_LIST_PLAC   KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,
        WIERSZ          INTEGER,
        KOLUMNA         TYP,    /* Lewa, Prawa */
        ELEM            KLUCZ NOT NULL,
        FOREIGN KEY(ELEM) REFERENCES ELEM_DEF_LISTY_PLAC(KLUCZ),
        FOREIGN KEY(DEF_LIST_PLAC, WERSJA) REFERENCES DEF_LIST_PLAC(KLUCZ, WERSJA));


COMMIT WORK;

/* ------------------------- */
/* Tabele pacowe            */
/* ------------------------- */

CREATE TABLE NAGLOWKI_LIST_PLAC
       (KLUCZ              KLUCZ NOT NULL,
        DEF_LIST_PLAC      KLUCZ NOT NULL,
        WERSJA             INTEGER NOT NULL,
        NUMER              SYMBOL,
        DATA_LISTY         TIMESTAMP,
        DATA_WYPLATY       TIMESTAMP,
        ROK_LISTY          INTEGER,
        MIESIAC_LISTY      INTEGER,
        ROK_PODATKOWY      INTEGER,     /* i ZUS */
        MIESIAC_PODATKOWY  INTEGER,     /* i ZUS */

		PODATEK_PPK        TAKNIE,
        ROK_PPK            INTEGER,     
        MIESIAC_PPK        INTEGER,     

        UJEMNE             TAKNIE,
        OSOBNO             TAKNIE,
        ZAWSZE_KOSZTY_UMOW TAKNIE,      /* T oznacza liczenie kosztw dla umw takze poniej dolnej granicy kwoty */ 
		
        OPIS               VARCHAR(200),

        UTWORZYL KLUCZ,
        UTWORZONO TIMESTAMP,
        ZMIENIAL KLUCZ,
        ZMIENIANO TIMESTAMP,
        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(DEF_LIST_PLAC, WERSJA) REFERENCES DEF_LIST_PLAC(KLUCZ, WERSJA)
       );

SET TERM ^ ;
CREATE TRIGGER CREATE_NAGLOWKI_LIST_PLAC FOR NAGLOWKI_LIST_PLAC
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

/*
  OPIS
  -----
  KLUCZ - klucz glowny
  DEF_LIST_PLAC - klucz obcy, powiazanie z DEF_LIST_PLAC
  NUMER - numer listy plac, nadawany i widziany przez uzytkonika
  DATA_LISTY - data listy plac, (kiedy zostala stworzona)
  DATA_WYPLATY - data wyplaty naleznosci naliczonych na liscie
  ROK_LISTY - rok utworzenia listy
  MIESIAC_LISTY - miesiac utworzenia listy
  ROK_ZUS - rok ZUS, ktorego dotycza obliczenie listy
  MIESIAC_ZUS - miesiac ZUS, ktorego dotycza obliczenia listy
  ROK_PODATKOWY - rok US, ktorego dotycza obliczenia listy
  MIESIAC_PODATKOWY - miesiac US, ktorego dotycza obliczenia listy
*/

CREATE TABLE LISTY_PLAC
       (KLUCZ               KLUCZ NOT NULL,
        NAGLOWEK_LISTY_PLAC KLUCZ NOT NULL,
        PRACOWNIK           KLUCZ NOT NULL,
        ANGAZ               KLUCZ NOT NULL,
        WERSJA              INTEGER NOT NULL,

        KOD_TYT_UBEZP       VARCHAR(6),

        ULGA_PODATKOWA      TYP,   /* wskazniki przepisane z danych rocznych */
        KOSZT_UZYSKANIA     TYP,
        WSKAZNIK_STAWKI     TYP,
        RYCZALT             TAKNIE,

        WSK_FUNDUSZU_PRACY  TAKNIE, /* Przepisany z angazu */
        FUNDUSZ_PRACY_OD_ROK INTEGER,
        FUNDUSZ_PRACY_OD_MIESIAC INTEGER,

        WSK_FUNDUSZU_GSP  TAKNIE, /* Przepisany z angazu */
        FUNDUSZ_GSP_OD_ROK INTEGER,
        FUNDUSZ_GSP_OD_MIESIAC INTEGER,

        WYNAGR_JEST_KOSZT   WARTOSC,
        KWOTA_ULGI          WARTOSC,

        WYNAGR_STAND        WARTOSC,
        WYNAGR_KU           WARTOSC,  /* nauka */
        ZASILKI_US          WARTOSC,
        EMERYTURY           WARTOSC,
        ZASILKI_OR          WARTOSC,
        ARESZT              WARTOSC,
        UMOWY               WARTOSC,
        ORGANY              WARTOSC,
        KONTRAKT            WARTOSC,
        AUTOR               WARTOSC,
        INNE                WARTOSC,
		
		PODATEK_PPK         WARTOSC,

		UB_DOCHOD_WYNAGR      WARTOSC,
        PROC_PD_WYNAGR        WARTOSC,
        PROC_PD_UMOWY         WARTOSC,
        PROC_PD_AUTOR         WARTOSC,

        PROC_KOSZT_UMOWY      WARTOSC,
        PROC_KOSZT_AUTOR      WARTOSC,

        PIT_11_WYNAGR_STAND   WARTOSC,
        PIT_11_WYNAGR_KU      WARTOSC,
        PIT_11_ZASILKI_US     WARTOSC,
        PIT_11_EMERYTURY      WARTOSC,
        PIT_11_ZASILKI_OR     WARTOSC,
        PIT_11_ARESZT         WARTOSC,
        PIT_11_UMOWY          WARTOSC,
        PIT_11_ORGANY         WARTOSC,
        PIT_11_KONTRAKT       WARTOSC,
        PIT_11_AUTOR          WARTOSC,
        PIT_11_INNE           WARTOSC,

        PIT_11_WYNAGR_STAND_ZDROW   WARTOSC,  /* odliczenia zdrowotnego */
        PIT_11_WYNAGR_KU_ZDROW      WARTOSC,
        PIT_11_ZASILKI_US_ZDROW     WARTOSC,
        PIT_11_UMOWY_ZDROW          WARTOSC,
        PIT_11_ORGANY_ZDROW         WARTOSC,
        PIT_11_KONTRAKT_ZDROW       WARTOSC,

        PIT_11_WYNAGR_STAND_ZDROW_26   WARTOSC,  /* odliczenia zdrowotnego z ulgi 26 lat */
        PIT_11_WYNAGR_KU_ZDROW_26      WARTOSC,
        PIT_11_UMOWY_ZDROW_26          WARTOSC,
        PIT_11_ORGANY_ZDROW_26         WARTOSC,  /* nie wystepuje */
        PIT_11_KONTRAKT_ZDROW_26       WARTOSC,  /* nie wystepuje */

        KOSZT_WYNAGR_STAND    WARTOSC,
        KOSZT_WYNAGR_KU       WARTOSC,
        KOSZT_UMOWY           WARTOSC,
        KOSZT_ORGANY          WARTOSC,
        KOSZT_KONTRAKT        WARTOSC,
        KOSZT_AUTOR           WARTOSC,
        KOSZT_STOWARZYSZENIE  WARTOSC,

        PIT_40_NADPLATA       WARTOSC,
        PIT_40_NIEDOPLATA     WARTOSC,

        ZAN_WYKORZYSTANO      WARTOSC,  /* Wykorzystanie zaniechania poboru podatku */
        ULGA_26               TYP,      /* T - uwzgledniac na danej liscie */
        PRAC_26               TYP,      /* T - pracownik 26, niezaleznie od tego czy korzysta z ulgi */
        WYKORZYSTANO_26       WARTOSC,
        WYKORZYSTANO_26_POD   WARTOSC,  /* dla mlodych do 26 lat Liczy program */
        UB_WYKORZYSTANO_26    WARTOSC,  /* w ubieglych miesiacach */
        WYKORZYSTANO_26_POD_ZDROW WARTOSC,  

        ZDROW_PODST           WARTOSC,
        ZDROW_Z_PODATKU_NAL   WARTOSC,
        ZDROW_Z_DOCHODU_NAL   WARTOSC,
        ZDROW_Z_PODATKU       WARTOSC,
        ZDROW_Z_DOCHODU       WARTOSC,

        ZUS_PROC_PRAC_RENT    WARTOSC,
        ZUS_PROC_PRAC_EMERYT  WARTOSC,
        ZUS_PROC_PRAC_CHOROB  WARTOSC,

        ZUS_PROC_FIRMA_RENT   WARTOSC,
        ZUS_PROC_FIRMA_EMERYT WARTOSC,
        ZUS_PROC_FIRMA_WYPAD  WARTOSC,

        ZUS_PODST_PRAC_RENT   WARTOSC,
        ZUS_PODST_PRAC_EMERYT WARTOSC,
        ZUS_PODST_PRAC_CHOROB WARTOSC,

        ZUS_PODST_FIRMA_RENT   WARTOSC,
        ZUS_PODST_FIRMA_EMERYT WARTOSC,
        ZUS_PODST_FIRMA_WYPAD  WARTOSC,

        ZUS_PRAC_RENT         WARTOSC,
        ZUS_PRAC_EMERYT       WARTOSC,
        ZUS_PRAC_CHOROB       WARTOSC,

        ZUS_FIRMA_RENT        WARTOSC,
        ZUS_FIRMA_EMERYT      WARTOSC,
        ZUS_FIRMA_WYPAD       WARTOSC,

        ZUS_BUDZET_RENT       WARTOSC,
        ZUS_BUDZET_EMERYT     WARTOSC,

        ZUS_PFRON_RENT        WARTOSC,
        ZUS_PFRON_EMERYT      WARTOSC,
        ZUS_PFRON_CHOROB      WARTOSC,
        ZUS_PFRON_WYPAD       WARTOSC,

        ZUS_FP_FAKTYCZNE      WARTOSC,
        ZUS_FGSP_FAKTYCZNE    WARTOSC,
        ZUS_FEP_FAKTYCZNE     WARTOSC,

        /* Korekty */

        K_PIT_11_WYNAGR_STAND   WARTOSC,
        K_PIT_11_WYNAGR_KU      WARTOSC,
        K_PIT_11_ZASILKI_US     WARTOSC,
        K_PIT_11_EMERYTURY      WARTOSC,
        K_PIT_11_ZASILKI_OR     WARTOSC,
        K_PIT_11_ARESZT         WARTOSC,
        K_PIT_11_UMOWY          WARTOSC,
        K_PIT_11_ORGANY         WARTOSC,
        K_PIT_11_KONTRAKT       WARTOSC,
        K_PIT_11_AUTOR          WARTOSC,
        K_PIT_11_INNE           WARTOSC,

        K_KOSZT_WYNAGR_STAND    WARTOSC,
        K_KOSZT_WYNAGR_KU       WARTOSC,
        K_KOSZT_UMOWY           WARTOSC,
        K_KOSZT_ORGANY          WARTOSC,
        K_KOSZT_KONTRAKT        WARTOSC,
        K_KOSZT_AUTOR           WARTOSC,
        K_KOSZT_STOWARZYSZENIE  WARTOSC,

        K_ZDROW_Z_PODATKU       WARTOSC,
        K_ZDROW_Z_DOCHODU       WARTOSC,

        K_ZUS_PRAC_RENT         WARTOSC,
        K_ZUS_PRAC_EMERYT       WARTOSC,
        K_ZUS_PRAC_CHOROB       WARTOSC,

        K_ZUS_FIRMA_RENT        WARTOSC,
        K_ZUS_FIRMA_EMERYT      WARTOSC,
        K_ZUS_FIRMA_WYPAD       WARTOSC,

        K_ZUS_BUDZET_RENT       WARTOSC,
        K_ZUS_BUDZET_EMERYT     WARTOSC,

        K_ZUS_PFRON_RENT        WARTOSC,
        K_ZUS_PFRON_EMERYT      WARTOSC,
        K_ZUS_PFRON_CHOROB      WARTOSC,
        K_ZUS_PFRON_WYPAD       WARTOSC,

        K_ZUS_FP_FAKTYCZNE      WARTOSC,
        K_ZUS_FGSP_FAKTYCZNE    WARTOSC,
        K_ZUS_FEP_FAKTYCZNE     WARTOSC,

        /* Podsumowanie */

        BRUTTO              WARTOSC,
        Z_BRUTTA            WARTOSC,   /* wypaty poyczek, ... - do odjcia od brutta */
        Z_ZUS               WARTOSC,
        POTRACENIA          WARTOSC,
        PRZELEW             WARTOSC,
        DO_PRZELEWU         KLUCZ,   /* Do tabeli PRZELEWY_Z_LIST, obcy klucz tame */

        UTWORZYL            KLUCZ,
        UTWORZONO           TIMESTAMP,
        ZMIENIAL            KLUCZ,
        ZMIENIANO           TIMESTAMP,
        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(NAGLOWEK_LISTY_PLAC) REFERENCES NAGLOWKI_LIST_PLAC(KLUCZ),
        FOREIGN KEY(PRACOWNIK) REFERENCES OSOBY(KLUCZ)
       );

SET TERM ^ ;
CREATE TRIGGER CREATE_LISTY_PLAC FOR LISTY_PLAC
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

/* Dane o dniach zasikowych listy pac */

SET TERM ^ ;

CREATE PROCEDURE DNI_ZASILKOWE_LISTY(
  RP                INTEGER,
  MP                INTEGER,
  RK                INTEGER,
  MK                INTEGER)
RETURNS(
  LISTA                     INTEGER,
  Nieobecnosci_Dni_firma    INTEGER,
  Nieobecnosci_Dni_zus      INTEGER)
AS
BEGIN
  FOR SELECT L.KLUCZ
  FROM LISTY_PLAC L, NAGLOWKI_LIST_PLAC N
  WHERE
    L.NAGLOWEK_LISTY_PLAC = N.KLUCZ
    AND
    ((N.MIESIAC_LISTY + N.ROK_LISTY * 100) >= (:MP + :RP * 100) OR
    (N.MIESIAC_PODATKOWY + N.ROK_PODATKOWY * 100) >= (:MP + :RP * 100))
    AND
    ((N.MIESIAC_LISTY + N.ROK_LISTY * 100) <= (:MK + :RK * 100) OR
    (N.MIESIAC_PODATKOWY + N.ROK_PODATKOWY * 100) <= (:MK + :RK * 100))
  INTO :LISTA
  DO BEGIN
    Nieobecnosci_Dni_firma = 0;
    Nieobecnosci_Dni_zus = 0;

    SELECT SUM(R.DNI_FIRMA)
    FROM Rozliczenie_nieobecnosci R, Nieobecnosci N, Rodzaje_nieobecnosci RN
    WHERE
      R.Firma_lista_plac = :LISTA AND
      R.Nieobecnosc = N.Klucz AND N.Typ = RN.Ident AND RN.Rodzaj LIKE 'C.31_'
    INTO :Nieobecnosci_Dni_firma;

    SELECT SUM(R.DNI_ZUS)
    FROM Rozliczenie_nieobecnosci R, Nieobecnosci N, Rodzaje_nieobecnosci RN
    WHERE
      R.ZUS_lista_plac = :LISTA AND
      R.Nieobecnosc = N.Klucz AND N.Typ = RN.Ident AND RN.Rodzaj LIKE 'C.31_'
    INTO :Nieobecnosci_Dni_zus;

    IF (:Nieobecnosci_Dni_firma IS NULL) THEN Nieobecnosci_Dni_firma = 0;
    IF (:Nieobecnosci_Dni_zus IS NULL) THEN Nieobecnosci_Dni_zus = 0;

    IF ((:Nieobecnosci_Dni_firma > 0) OR (:Nieobecnosci_Dni_zus > 0))
    THEN SUSPEND;
  END
END^
COMMIT WORK ^

SET TERM ; ^




CREATE TABLE SKLADNIKI_LISTY_PLAC
       (LISTA_PLAC          KLUCZ NOT NULL,
        ELEM_DEF_LISTY_PLAC KLUCZ NOT NULL,
        KWOTA               WARTOSC,
		PPK_FIRMA           WARTOSC,
        TYP_KWOTY           TYP,       /* Brutto, Zus, Potrcenie, Inne */

        KLUCZ_OBCY          KLUCZ,
        TYP_KLUCZA          IDENT,     /* PTR - potrcenie, PZC - poyczka, DDT - dodatki */

        DO_PRZELEWU         KLUCZ,     /* Do tabeli PRZELEWY_Z_LIST (potrcenia), obcy klucz tame */

        PRIMARY KEY(LISTA_PLAC, ELEM_DEF_LISTY_PLAC)
       );

CREATE INDEX SKLADNIKI_LP_DEFINICJA
  ON SKLADNIKI_LISTY_PLAC(ELEM_DEF_LISTY_PLAC);
CREATE INDEX SKLADNIKI_LP_KLUCZE
  ON SKLADNIKI_LISTY_PLAC(KLUCZ_OBCY, TYP_KLUCZA);

COMMIT WORK;

/* ------------------------- */
/* Definicje angazy          */
/* ------------------------- */


CREATE TABLE DEF_ANGAZY
       (KLUCZ           KLUCZ NOT NULL,

        IDENT           SYMBOL NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,

        KOD_TYT_UBEZP   VARCHAR(5),
        SKLADKIZUS      VARCHAR(255),
        SKLADKIKCH      VARCHAR(255);

        MIESIACE_ZAS    INTEGER,           /* Do sredniej zasilkowej */

        GRAFIK          KLUCZ,
        LISTA           KLUCZ,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,
        PRIMARY KEY(KLUCZ)
       );
/*
  OPIS
  ------

  KLUCZ - klucz glowny
  IDENT - znakowy odpowiednik klucza, to co bedzie widoczne dla uzytkownika

  KOD_TYT_UBEZP - Domyslny kod ZUS z dodatkowym srednikiem rozdzielajacym jego 2 czesci
  GRAFIK - Domyslny grafik pracy
  LISTA - Domyslna lista plac

*/

SET TERM ^ ;

CREATE TRIGGER CREATE_DEF_ANGAZY FOR DEF_ANGAZY
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^

SET TERM ; ^

/* ------------------------------------ */
/* Definicje skadnikw angazy          */
/* ------------------------------------ */

CREATE TABLE ELEM_ANGAZY
       (KLUCZ           KLUCZ NOT NULL,
        IDENT           SYMBOL NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,

        RODZAJ          IDENT,

        NAGLOWEK_EDYCJI DUZA_NAZWA,

        WYRAZENIE       KLUCZ,
        BLOKADA         TAKNIE,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_ELEM_ANGAZY FOR ELEM_ANGAZY
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^


CREATE TABLE ELEM_ANGAZU
       (DEF_ANGAZY        KLUCZ NOT NULL,
        ELEM_ANGAZY       KLUCZ NOT NULL,

        FOREIGN KEY(DEF_ANGAZY) REFERENCES DEF_ANGAZY(KLUCZ),
        FOREIGN KEY(ELEM_ANGAZY) REFERENCES ELEM_ANGAZY(KLUCZ));

/*
  OPIS
  -----

  KLUCZ - klucz glowny
  IDENT - widziany przez uzytkownika ident. elementu - nazwa pola tabeli wirtualnej
  DEF_ANGAZU - klucz obcy, powiazanie z DEF_ANGAZY

  RODZAJ - WYNAGRODZENIE, DODATEK, POTRACENIE

  NAGLOWEK_EDYCJI - etykieta widoczna podczas edycji elementu na formie

*/

COMMIT WORK;


/* ------------------------- */
/* Angaze i umowy            */
/* ------------------------- */

CREATE TABLE ANGAZE
       (KLUCZ           KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,
        OSOBA           KLUCZ NOT NULL,

        DEF_ANGAZU      KLUCZ NOT NULL,

        POCZ_PRACY      TIMESTAMP,
        POCZ_ANGAZU     TIMESTAMP,

        NA_CZAS         TYP,       /* Okreslony, ... */
        DO_DNIA         TIMESTAMP,

        KON_ANGAZU      TIMESTAMP,
        KON_PRACY       TIMESTAMP,

        TRYB_KONCA      DIDENT,    /* Przeszeregowanie, wymowienie pracownika, ... */

        PODST_DOD       TYP,       /* Podstawowy, Dodatkowy - aktualnie bez znaczenia*/

        ETAT_LICZ       INTEGER,   /* Wielkosc etatu - licznik */
        ETAT_MIAN       INTEGER,   /* Wielkosc etatu - mianownik */
        NORMA_DZIENNA   WARTOSC,   /* Nominalna dzienna ilo godzin pracy */

        FIRMA           KLUCZ,     /* 0 - wlasna, > 0 inna, do stazu pracy - nieaktualne */

        ZAKLAD          KLUCZ,
        GRUPA_STAN      DIDENT,
        STANOWISKO      DIDENT,
        FUNKCJA         DIDENT,

        ZASZEREGOWANIE  DUZY_SYMBOL,

        ROBOTNICY       TYP,
        UCZNIOWIE       TYP,
        ZAGRANICA       TYP,
        INTERWENCJE     TYP,

        KOD_TYT_UBEZP   VARCHAR(5),
        SKLADKIZUS      VARCHAR(255),
        SKLADKIKCH      VARCHAR(255);

        PODST_UR_WYCH   WARTOSC,        /* Podstawa skladek ubezp.spol. dla urlopu wychowawczego */

        WSK_FUNDUSZU_PRACY TAKNIE,
        FUNDUSZ_PRACY_OD_ROK INTEGER,
        FUNDUSZ_PRACY_OD_MIESIAC INTEGER,

        WSK_FUNDUSZU_GSP TAKNIE,
        FUNDUSZ_GSP_OD_ROK INTEGER,
        FUNDUSZ_GSP_OD_MIESIAC INTEGER,

        MIESIACE_ZAS    INTEGER,           /* Do sredniej zasilkowej */

        SZCZEGKOD       VARCHAR(9),
        SZCZEGOD        TIMESTAMP,
        SZCZEGDO        TIMESTAMP,

        KON_KOD_WYGASNIECIA    IDENT,  /* kod przyczyny wyganiecia umowy */
        KON_PDST_PRAWNA        IDENT,  /* kod podstawy prawnej zakonczenia umowy */
        KON_PDST_PRAWNA_OPIS   OPIS,   /* opis podstawy prawnej - tylko gdy kod = 550 */
        KON_STRONA             IDENT,  /* strona inicjujaca koniec umowy */
		
        LISTA           KLUCZ,             /* Lista gwna */

        UWAGI           UWAGI,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(DEF_ANGAZU) REFERENCES DEF_ANGAZY(KLUCZ),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        PRIMARY KEY(KLUCZ, WERSJA)
       );


CREATE TABLE SKLADNIKI_ANGAZY
       (ANGAZ               KLUCZ NOT NULL,
        WERSJA              KLUCZ NOT NULL,
        ELEM_ANGAZY         KLUCZ NOT NULL,
        WARTOSC             DOUBLE PRECISION,
        FOREIGN KEY(ELEM_ANGAZY) REFERENCES ELEM_ANGAZY(KLUCZ),
        FOREIGN KEY(ANGAZ, WERSJA) REFERENCES ANGAZE(KLUCZ, WERSJA));


CREATE TABLE KOSZTY_ANGAZY
       (ANGAZ               KLUCZ NOT NULL,
        ZAKLAD              KLUCZ NOT NULL,
        PROCENT             DOUBLE PRECISION,
        PRIMARY KEY(ANGAZ, ZAKLAD));


COMMIT WORK;

/* ------------------------- */
/* Dokumenty                 */
/* ------------------------- */

CREATE TABLE DOKUMENTY_KADROWE
       (KLUCZ           KLUCZ NOT NULL,
        RODZAJ          IDENT NOT NULL,    /*  */
        ANGAZ           KLUCZ NOT NULL,    /* Moe by 0 dla zmian osobowych */
        WERSJA          INTEGER NOT NULL,  /* j.w. */
        OSOBA           KLUCZ NOT NULL,

        DATA            TIMESTAMP NOT NULL,     /* Uwaga - nie tworzy w angau tych pl */
        NUMER           SYMBOL,

        TRESC           DOKUMENT,         /* Ew. opis zmian dla rodzaj = 'OSB' */
        UWAGI           UWAGI,
        WORD            VARCHAR(250),  /* Adres dokumentu WORD */

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));


SET TERM ^ ;
CREATE TRIGGER CREATE_DOKUMENTY_KADROWE FOR DOKUMENTY_KADROWE
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

/* ------------------------- */
/* Nieobecnosci              */
/* ------------------------- */

CREATE TABLE SWIETA
       (DATA           TIMESTAMP NOT NULL,
        NAZWA          DUZA_NAZWA NOT NULL,
        TYP            TYP NOT NULL,

        PRIMARY KEY(DATA));

/*---*/

CREATE TABLE RODZAJE_NIEOBECNOSCI
       (IDENT            DIDENT NOT NULL,
        NAZWA            DUZA_NAZWA NOT NULL,

        RODZAJ           DIDENT NOT NULL,
        TYP_DNI          TYP,               /* Kalendarzowe, Robocze, ... */
        GODZ_Z_KARTY     TAKNIE,            /* Dolicza do podstawy godziny z karty pracy */
        DNI_NIEPLATNE    INTEGER,           /* Dotyczy zasilkow */
        DNI_NiEPLATNE_DO INTEGER,
        DNI_FIRMA        INTEGER,           /* Oplacane przez firme */
        DNI_FIRMA_50     INTEGER,           /* Oplacane przez firme - 50-latki */
        PROCENT          WARTOSC,
        MIESIACE         INTEGER,           /* Do sredniej */
        TYP_MIESIECY     TYP,               /* L - wg m-ca listy, Z - ZUS-owsko, podatkowa */
        BIEZACY_MIESIAC  TAKNIE,            /* Tak - rednie z b.m z list i karty pracy */

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(IDENT));

/*---*/

CREATE TABLE NIEOBECNOSCI
       (KLUCZ           KLUCZ NOT NULL,
        OSOBA           KLUCZ NOT NULL,
        ANGAZ           KLUCZ NOT NULL,
        WPORTALU        KLUCZ,

        TYP             DIDENT NOT NULL,
        POCZATEK        TIMESTAMP NOT NULL,
        KONIEC          TIMESTAMP NOT NULL,
        DNI_KAL         INTEGER,

        KOD_CHOROBY     DIDENT,   /* Kod statystyczny choroby */
        KOD_CHOROBY_1   TYP,
        KOD_CHOROBY_2   TYP,
        PROCENT         WARTOSC,

        NA_ZADANIE      TAKNIE,  /* Urlop na danie */

        OTRZYMANO       TIMESTAMP,

        MIESIACE        INTEGER,           /* Do sredniej */
        STAWKA          WARTOSC,
        
        KLUCZDZIECKA    KLUCZ,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));

CREATE INDEX NIEOBECNOSCI_ANGAZ ON NIEOBECNOSCI(ANGAZ);

SET TERM ^ ;
CREATE TRIGGER CREATE_NIEOBECNOSCI FOR NIEOBECNOSCI
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

/*---*/

CREATE TABLE ROZLICZENIE_NIEOBECNOSCI
       (NIEOBECNOSC     KLUCZ NOT NULL,
        POCZATEK        TIMESTAMP NOT NULL,
        KONIEC          TIMESTAMP NOT NULL,
        KOREKTA         INTEGER NOT NULL,

        ROK             INTEGER,    /* Dotyczy okresu rozliczeniowego */
        MIESIAC         INTEGER,
        NOWY_TYP        DIDENT,     /* gdy korekta wiaze sie ze zmiana typu nieobecnosci */

        DNI_ROB         INTEGER,
        GODZ_ROB        DOUBLE PRECISION,
        DNI_KAL         INTEGER,
        DNI_ROZL        INTEGER,

        DNI_NIEPLATNE   INTEGER,
        DNI_FIRMA       INTEGER,
        DNI_ZUS         INTEGER,

        STAWKA          WARTOSC,
        WYPL_FIRMA      WARTOSC,
        WYPL_ZUS        WARTOSC,

        FIRMA_LISTA_PLAC          KLUCZ,   /* Adres listy rozliczajacej */
        FIRMA_ELEM_DEF_LISTY_PLAC KLUCZ,   /* nieobecnosc dla firmy */

        ZUS_LISTA_PLAC          KLUCZ,   /* Adres listy rozliczajacej */
        ZUS_ELEM_DEF_LISTY_PLAC KLUCZ,   /* nieobecnosc dla ZUS */

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(FIRMA_LISTA_PLAC) REFERENCES LISTY_PLAC(KLUCZ),
        FOREIGN KEY(FIRMA_ELEM_DEF_LISTY_PLAC) REFERENCES ELEM_DEF_LISTY_PLAC(KLUCZ),
        FOREIGN KEY(ZUS_LISTA_PLAC) REFERENCES LISTY_PLAC(KLUCZ),
        FOREIGN KEY(ZUS_ELEM_DEF_LISTY_PLAC) REFERENCES ELEM_DEF_LISTY_PLAC(KLUCZ),
        PRIMARY KEY(NIEOBECNOSC, POCZATEK, KOREKTA));

/*---*/

CREATE TABLE SREDNIE_ZAS_URL
       (OSOBA           KLUCZ NOT NULL,
        ANGAZ           KLUCZ NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        RODZAJ_NB       DIDENT NOT NULL,

        DNI_KAL_NAL     INTEGER,
        DNI_KAL_RZ      INTEGER,
        DNI_ROB_NAL     INTEGER,
        DNI_ROB_RZ      INTEGER,
        GODZ_ROB_NAL    DOUBLE PRECISION,
        GODZ_ROB_RZ     DOUBLE PRECISION,
        DNI_SREDNIEJ    INTEGER,
        DNI_GODZ_SREDNIEJ DOUBLE PRECISION,

        WSPOLCZYNNIK    WARTOSC,
        DO_LICZENIA     TAKNIE,

        PODSTAWA_WYL    WARTOSC,
        PODSTAWA_ZU     WARTOSC,
        PODSTAWA_NM_WYL WARTOSC,  /* nastpny miesic */
        PODSTAWA_NM_ZU  WARTOSC,  /* nastpny miesic */
        PODSTAWA_NN_KR  WARTOSC,  /* uzupelnienie do najnizszej krajowej */

        ROCZNE          WARTOSC,
        KWARTALNE       WARTOSC,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(ANGAZ, ROK, MIESIAC, RODZAJ_NB));


/* ------------------------- */
/* Karta pracy               */
/* ------------------------- */

CREATE TABLE ELEM_KART_PRACY
       (KLUCZ           KLUCZ NOT NULL,
        IDENT           SYMBOL NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,

        DOTYCZY         VARCHAR(10),     /* Czas pracy, nieobecnosci */

        NAGLOWEK_EDYCJI DUZA_NAZWA,

        WYRAZENIE       KLUCZ,
        PIENIADZE       TAKNIE,
        CZASPRACY       TYP,      /* 1=g.nadl 100%, 5=g.nadl 50%, N=noc, S=wito, I=inne */
		UB_MC           TAKNIE,
        BLOKADA         TAKNIE,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_ELEM_KART_PRACY FOR ELEM_KART_PRACY
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

CREATE TABLE ELEM_KARTY_ANGAZU
       (DEF_ANGAZY        KLUCZ NOT NULL,
        WIERSZ            INTEGER,
        KOLUMNA           TYP,    /* Lewa, Prawa */
        ELEM_KART_PRACY   KLUCZ NOT NULL,

        FOREIGN KEY(DEF_ANGAZY) REFERENCES DEF_ANGAZY(KLUCZ),
        FOREIGN KEY(ELEM_KART_PRACY) REFERENCES ELEM_KART_PRACY(KLUCZ));

/*---*/

CREATE TABLE KARTA_PRACY
       (KLUCZ           KLUCZ NOT NULL,
        OSOBA           KLUCZ NOT NULL,
        ANGAZ           KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        DNI_KAL_NAL     INTEGER,
        DNI_KAL_RZ      INTEGER,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(ANGAZ, WERSJA) REFERENCES ANGAZE(KLUCZ, WERSJA),
        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_KARTA_PRACY FOR KARTA_PRACY
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^


CREATE TABLE POZYCJE_KARTY_PRACY
       (KARTA_PRACY     KLUCZ NOT NULL,
        ZAKLAD          KLUCZ NOT NULL,

        DNI_ROB_NAL     INTEGER,
        GODZ_ROB_NAL    DOUBLE PRECISION,
        DNI_ROB_RZ      INTEGER,
        GODZ_ROB_RZ     DOUBLE PRECISION,
                                                                  
      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        PRIMARY KEY(KARTA_PRACY, ZAKLAD));


CREATE TABLE SKLADNIKI_KART_PRACY
       (KARTA_PRACY         KLUCZ NOT NULL,
        ZAKLAD              KLUCZ NOT NULL,
        ELEM_KART_PRACY     KLUCZ NOT NULL,
        WARTOSC             DOUBLE PRECISION,

        LISTA_PLAC          KLUCZ,   /* Adres listy rozliczajacej */
        ELEM_DEF_LISTY_PLAC KLUCZ,   

        FOREIGN KEY(LISTA_PLAC) REFERENCES LISTY_PLAC(KLUCZ),
        FOREIGN KEY(ELEM_DEF_LISTY_PLAC) REFERENCES ELEM_DEF_LISTY_PLAC(KLUCZ),

        FOREIGN KEY(ELEM_KART_PRACY) REFERENCES ELEM_KART_PRACY(KLUCZ),
        FOREIGN KEY(KARTA_PRACY, ZAKLAD)
          REFERENCES POZYCJE_KARTY_PRACY(KARTA_PRACY, ZAKLAD));


/* ------------------------- */
/* Podatki i ZUS             */
/* ------------------------- */

CREATE TABLE TABELA_PODATKOWA
       (ROK             INTEGER NOT NULL,
        KWOTA_OD        WARTOSC NOT NULL,
        KWOTA_DO        WARTOSC,
        KWOTA_WOLNA     WARTOSC,
        PROCENT         WARTOSC,

        PRIMARY KEY(ROK, KWOTA_OD));


/*---*/

CREATE TABLE SKLADKI_ROCZNE_OSOBY
       (OSOBA                 KLUCZ NOT NULL,
        ROK                   INTEGER NOT NULL,

        URZAD_SKARBOWY        KLUCZ,
        ULGA_PODATKOWA        TYP,
        KOSZT_UZYSKANIA       TYP,
        WSKAZNIK_STAWKI       TYP,
        ROZLICZANIE_PIT_40    TAKNIE,
        NIPDOPIT              TAKNIE,

        KWOTA_WOLNA           WARTOSC,  /* Decyzja US - nie uywane*/
        ZANIECHANIE           WARTOSC,  /* Decyzja US */
        WYKORZYSTANO          WARTOSC,  /* Liczy program */
		ULGA_26               TYP,      /* T - uwzldnia w 2019, N - nie uwzgldnia od 2020 */
        WYKORZYSTANO_26       WARTOSC,  /* dla mlodych do 26 lat Liczy program */
        WYKORZYSTANO_26_POD   WARTOSC,  /* dla mlodych do 26 lat podatek Liczy program */
        WYKORZYSTANO_26_POD_ZDROW WARTOSC,  
        KOSZT_ROCZNY          TYP,

        ULGA_NA_DZIECI        WARTOSC,
        ULGA_INNA             WARTOSC,
        ULGA_INNA_OPIS        VARCHAR(60),

        WYNAGR_STAND          WARTOSC,
        WYNAGR_KU             WARTOSC,
        ZASILKI_US            WARTOSC,
        EMERYTURY             WARTOSC,
        ZASILKI_OR            WARTOSC,
        ARESZT                WARTOSC,
        UMOWY                 WARTOSC,
        ORGANY                WARTOSC,
        KONTRAKT              WARTOSC,
        AUTOR                 WARTOSC,
        INNE                  WARTOSC,

        PIT_11_WYNAGR_STAND   WARTOSC,
        PIT_11_WYNAGR_KU      WARTOSC,
        PIT_11_ZASILKI_US     WARTOSC,
        PIT_11_EMERYTURY      WARTOSC,
        PIT_11_ZASILKI_OR     WARTOSC,
        PIT_11_ARESZT         WARTOSC,
        PIT_11_UMOWY          WARTOSC,
        PIT_11_ORGANY         WARTOSC,
        PIT_11_KONTRAKT       WARTOSC,
        PIT_11_AUTOR          WARTOSC,
        PIT_11_INNE           WARTOSC,

        KOSZT_WYNAGR_STAND    WARTOSC,
        KOSZT_WYNAGR_KU       WARTOSC,
        KOSZT_UMOWY           WARTOSC,
        KOSZT_ORGANY          WARTOSC,
        KOSZT_KONTRAKT        WARTOSC,
        KOSZT_AUTOR           WARTOSC,
        KOSZT_STOWARZYSZENIE  WARTOSC,

        PIT_40_ROZLICZENIE    WARTOSC,
        PIT_40_NADPLATA       WARTOSC,    /* UBIEGLY ROK */
        PIT_40_NIEDOPLATA     WARTOSC,    /* UBIEGLY ROK */

        ZDROW_PODST           WARTOSC,
        ZDROW_Z_PODATKU_NAL   WARTOSC,
        ZDROW_Z_DOCHODU_NAL   WARTOSC,
        ZDROW_Z_PODATKU       WARTOSC,
        ZDROW_Z_DOCHODU       WARTOSC,

/*        ZUS_PODST_ER_OBCE     WARTOSC,  kalkulacyjne */
        ZUS_PODST_OB          WARTOSC,  /* Obnizenie podstawy - program emerytalny */

        ZUS_PODST_PRAC_RENT   WARTOSC,
        ZUS_PODST_PRAC_EMERYT WARTOSC,
        ZUS_PODST_PRAC_CHOROB WARTOSC,

        ZUS_PODST_FIRMA_RENT  WARTOSC,
        ZUS_PODST_FIRMA_EMERYT WARTOSC,
        ZUS_PODST_FIRMA_WYPAD WARTOSC,

        ZUS_PRAC_RENT         WARTOSC,
        ZUS_PRAC_EMERYT       WARTOSC,
        ZUS_PRAC_CHOROB       WARTOSC,

        ZUS_FIRMA_RENT        WARTOSC,
        ZUS_FIRMA_EMERYT      WARTOSC,
        ZUS_FIRMA_WYPAD       WARTOSC,

        ZUS_BUDZET_RENT       WARTOSC,
        ZUS_BUDZET_EMERYT     WARTOSC,

        ZUS_PFRON_RENT        WARTOSC,
        ZUS_PFRON_EMERYT      WARTOSC,
        ZUS_PFRON_CHOROB      WARTOSC,
        ZUS_PFRON_WYPAD       WARTOSC,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(OSOBA, ROK));

/*---*/

CREATE TABLE SKLADKI_MIESIECZNE_ANGAZU
       (OSOBA                 KLUCZ NOT NULL,
        ANGAZ                 KLUCZ NOT NULL,
        ROK                   INTEGER NOT NULL,
        MIESIAC               INTEGER NOT NULL,
        KOD_TYT_UBEZP         VARCHAR(6) NOT NULL,

        WYKORZYSTANO          WARTOSC,  /* Zaniechania podatku */
        WYKORZYSTANO_26       WARTOSC,  /* dla mlodych do 26 lat Liczy program */
        WYKORZYSTANO_26_POD   WARTOSC,  /* dla mlodych do 26 podatek lat Liczy program */
        WYKORZYSTANO_26_POD_ZDROW WARTOSC,  

        WYNAGR_JEST_KOSZT     WARTOSC,
        KWOTA_ULGI            WARTOSC,

        WYNAGR_STAND          WARTOSC,
        WYNAGR_KU             WARTOSC,
        ZASILKI_US            WARTOSC,
        EMERYTURY             WARTOSC,
        ZASILKI_OR            WARTOSC,
        ARESZT                WARTOSC,
        UMOWY                 WARTOSC,
        ORGANY                WARTOSC,
        KONTRAKT              WARTOSC,
        AUTOR                 WARTOSC,
        INNE                  WARTOSC,

        PIT_11_WYNAGR_STAND   WARTOSC,
        PIT_11_WYNAGR_KU      WARTOSC,
        PIT_11_ZASILKI_US     WARTOSC,
        PIT_11_EMERYTURY      WARTOSC,
        PIT_11_ZASILKI_OR     WARTOSC,
        PIT_11_ARESZT         WARTOSC,
        PIT_11_UMOWY          WARTOSC,
        PIT_11_ORGANY         WARTOSC,
        PIT_11_KONTRAKT       WARTOSC,
        PIT_11_AUTOR          WARTOSC,
        PIT_11_INNE           WARTOSC,

        KOSZT_WYNAGR_STAND    WARTOSC,
        KOSZT_WYNAGR_KU       WARTOSC,
        KOSZT_UMOWY           WARTOSC,
        KOSZT_ORGANY          WARTOSC,
        KOSZT_KONTRAKT        WARTOSC,
        KOSZT_AUTOR           WARTOSC,
        KOSZT_STOWARZYSZENIE  WARTOSC,

        ZDROW_PODST           WARTOSC,
        ZDROW_Z_PODATKU_NAL   WARTOSC,
        ZDROW_Z_DOCHODU_NAL   WARTOSC,
        ZDROW_Z_PODATKU       WARTOSC,
        ZDROW_Z_DOCHODU       WARTOSC,

        ZUS_PODST_ER_OBCE     WARTOSC,
        ZUS_PODST_OB          WARTOSC,  /* Obnizenie podstawy - program emerytalny */

        ZUS_PODST_PRAC_RENT   WARTOSC,
        ZUS_PODST_PRAC_EMERYT WARTOSC,
        ZUS_PODST_PRAC_CHOROB WARTOSC,

        ZUS_FAKT_PODST_PRAC_RENT   WARTOSC, /* Faktyczna podstawa */
        ZUS_FAKT_PODST_PRAC_EMERYT WARTOSC,

        ZUS_PODST_FIRMA_RENT  WARTOSC,
        ZUS_PODST_FIRMA_EMERYT WARTOSC,
        ZUS_PODST_FIRMA_WYPAD WARTOSC,

        ZUS_PODST_PRZEKR      TYP,      /* Wskaznik przekroczenia 1,2,3 */
        ZUS_PODST_PRZ_KWOTA   WARTOSC,

        ZUS_PRAC_RENT         WARTOSC,
        ZUS_PRAC_EMERYT       WARTOSC,
        ZUS_PRAC_CHOROB       WARTOSC,

        ZUS_FIRMA_RENT        WARTOSC,
        ZUS_FIRMA_EMERYT      WARTOSC,
        ZUS_FIRMA_WYPAD       WARTOSC,

        ZUS_BUDZET_RENT       WARTOSC,
        ZUS_BUDZET_EMERYT     WARTOSC,

        ZUS_PFRON_RENT        WARTOSC,
        ZUS_PFRON_EMERYT      WARTOSC,
        ZUS_PFRON_CHOROB      WARTOSC,
        ZUS_PFRON_WYPAD       WARTOSC,

        /* Korekty */

        K_PIT_11_WYNAGR_STAND   WARTOSC,
        K_PIT_11_WYNAGR_KU      WARTOSC,
        K_PIT_11_ZASILKI_US     WARTOSC,
        K_PIT_11_EMERYTURY      WARTOSC,
        K_PIT_11_ZASILKI_OR     WARTOSC,
        K_PIT_11_ARESZT         WARTOSC,
        K_PIT_11_UMOWY          WARTOSC,
        K_PIT_11_ORGANY         WARTOSC,
        K_PIT_11_KONTRAKT       WARTOSC,
        K_PIT_11_AUTOR          WARTOSC,
        K_PIT_11_INNE           WARTOSC,

        K_KOSZT_WYNAGR_STAND    WARTOSC,
        K_KOSZT_WYNAGR_KU       WARTOSC,
        K_KOSZT_UMOWY           WARTOSC,
        K_KOSZT_ORGANY          WARTOSC,
        K_KOSZT_KONTRAKT        WARTOSC,
        K_KOSZT_AUTOR           WARTOSC,
        K_KOSZT_STOWARZYSZENIE  WARTOSC,

        K_ZDROW_Z_PODATKU       WARTOSC,
        K_ZDROW_Z_DOCHODU       WARTOSC,

        K_ZUS_PRAC_RENT         WARTOSC,
        K_ZUS_PRAC_EMERYT       WARTOSC,
        K_ZUS_PRAC_CHOROB       WARTOSC,

        K_ZUS_FIRMA_RENT        WARTOSC,
        K_ZUS_FIRMA_EMERYT      WARTOSC,
        K_ZUS_FIRMA_WYPAD       WARTOSC,

        K_ZUS_BUDZET_RENT       WARTOSC,
        K_ZUS_BUDZET_EMERYT     WARTOSC,

        K_ZUS_PFRON_RENT        WARTOSC,
        K_ZUS_PFRON_EMERYT      WARTOSC,
        K_ZUS_PFRON_CHOROB      WARTOSC,
        K_ZUS_PFRON_WYPAD       WARTOSC,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(OSOBA, ANGAZ, ROK, MIESIAC, KOD_TYT_UBEZP));


/* ------------------------- */
/* Wyraenia                 */
/* ------------------------- */

CREATE TABLE WYRAZENIA_PLACOWE
       (KLUCZ           KLUCZ NOT NULL,
        OPERACJA        NUMER NOT NULL,
        IDENT           NUMER,
        NAZWA           DUZA_NAZWA,

        ARG1            DUZA_NAZWA,
        ARG2            DUZA_NAZWA,

        WSPOLCZYNNIK    DOUBLE PRECISION,
        ZAOKRAGLENIE    INTEGER,

        MC_POCZ       INTEGER,
        MC_KON        INTEGER,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE INDEX WYRAZENIA_PLACOWE_XIDNAZWA ON WYRAZENIA_PLACOWE(IDENT, NAZWA);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_WYRAZENIA_PLACOWE FOR WYRAZENIA_PLACOWE
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^

CREATE TABLE ARGUMENTY_PLACOWE
       (WYRAZENIE       KLUCZ NOT NULL,
        ARGUMENT        KLUCZ NOT NULL,

        LP              INTEGER,
        ZNAK            TYP,

        UTWORZYL      KLUCZ,
        UTWORZONO     TIMESTAMP,

        FOREIGN KEY(WYRAZENIE) REFERENCES WYRAZENIA_PLACOWE(KLUCZ),
        FOREIGN KEY(ARGUMENT) REFERENCES WYRAZENIA_PLACOWE(KLUCZ),
        PRIMARY KEY(WYRAZENIE, ARGUMENT));

COMMIT WORK;


/* ------------------------- */
/* Dodatki                   */
/* ------------------------- */

CREATE TABLE RODZAJE_DODATKOW
       (IDENT           DIDENT NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,
        TYP             DIDENT,
        JEDNA_LISTA     TAKNIE,
        KWOTA_PROCENT   TYP,
        WIDAC_ILOSC     TAKNIE,

        LATA_OD1        INTEGER,
        LATA_DO1        INTEGER,
        PROC1           WARTOSC,
        PROC_SKOK1      WARTOSC,

        LATA_OD2        INTEGER,
        LATA_DO2        INTEGER,
        PROC2           WARTOSC,
        PROC_SKOK2      WARTOSC,

        LATA_OD3        INTEGER,
        LATA_DO3        INTEGER,
        PROC3           WARTOSC,
        PROC_SKOK3      WARTOSC,

        LATA_OD4        INTEGER,
        LATA_DO4        INTEGER,
        PROC4           WARTOSC,
        PROC_SKOK4      WARTOSC,

        LATA_OD5        INTEGER,
        LATA_DO5        INTEGER,
        PROC5           WARTOSC,
        PROC_SKOK5      WARTOSC,

        HISTORIA        TAKNIE,
        ULAMKOWE        TAKNIE,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(IDENT));


/* --- */

CREATE TABLE DODATKI_ANGAZU
       (KLUCZ           KLUCZ NOT NULL,
        OSOBA           KLUCZ NOT NULL,
        ANGAZ           KLUCZ NOT NULL,
        RODZAJ          DIDENT NOT NULL,

        KWOTA_PROCENT   WARTOSC,
        ILOSC           INTEGER,

      	WAZNE_OD        TIMESTAMP,
      	WAZNE_DO        TIMESTAMP,
        POCZ_PRACY      TIMESTAMP,       /* Dla staowego */

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_DODATKI_ANGAZU FOR DODATKI_ANGAZU
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

/* ------------------------- */
/* Potrcenia                */
/* ------------------------- */

CREATE TABLE RODZAJE_POTRACEN
       (IDENT           DIDENT NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,
        TYP             DIDENT,
        JEDNA_LISTA     TAKNIE,
        KWOTA_PROCENT   TYP,
		
		PROCENT_PRAC    DOUBLE PRECISION,  /* Dla PPK */
		PROCENT_FIRMA   DOUBLE PRECISION,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(IDENT));


/* --- */

CREATE TABLE POTRACENIA_ANGAZU
       (KLUCZ           KLUCZ NOT NULL,
        OSOBA           KLUCZ NOT NULL,
        ANGAZ           KLUCZ NOT NULL,
        RODZAJ          DIDENT NOT NULL,

        DATA_POBRANIA   TIMESTAMP, /* Data wypacenia poyczki */
        KZP             KLUCZ,

        KWOTA_PROCENT   WARTOSC,         /* LUB RATA lub PPK dla pracownika */
        POZYCZKA        WARTOSC,
        ODSETKI         WARTOSC,
        POTRACENIA      WARTOSC,

		PROCENT_PRAC    DOUBLE PRECISION,  /* Dla PPK indywidualnie dla pracownika */
		PROCENT_FIRMA   DOUBLE PRECISION,

        BANK            BANK,            /* Komornik, ... */
        KONTO           KONTO,
        TYTULEM         VARCHAR(54) CHARACTER SET DOS852,

      	WAZNE_OD        TIMESTAMP,
      	WAZNE_DO        TIMESTAMP,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_POTRACENIA_ANGAZU FOR POTRACENIA_ANGAZU
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

/* --- */

CREATE TABLE CZLONKOWIE_KZP
       (KLUCZ           KLUCZ NOT NULL,
        OSOBA           KLUCZ NOT NULL,
        ANGAZ           KLUCZ NOT NULL,

        DATA_PRZYSTAPIENIA TIMESTAMP,
        DATA_KONCA         TIMESTAMP,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_CZLONKOWIE_KZP FOR CZLONKOWIE_KZP
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

/* --- */

CREATE TABLE KASA_PLACOWA
       (OSOBA          KLUCZ NOT NULL,
        KZP            KLUCZ,
        ROK            INTEGER,
        MIESIAC        INTEGER,
        DATA_OPERACJI  TIMESTAMP NOT NULL,
        NUMER          MALA_NAZWA,

        TYP_KWOTY      TYP NOT NULL,    /* Wpata, wYpata */
        KLUCZ_OBCY     KLUCZ NOT NULL,  /* podczenie do potrce, KZP, dodatkw */
        TYP_KLUCZA     IDENT NOT NULL,  /* WPS-wpisowe, SKL-skadka, RPZ-rata poyczki, WKL-wypata wkadu, IWP-inna wpata, IWY-inna wypata */

        KWOTA          WARTOSC,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(OSOBA, KLUCZ_OBCY, DATA_OPERACJI)
       );

CREATE INDEX KASA_PLACOWA_OSOBA ON KASA_PLACOWA(OSOBA);
CREATE INDEX KASA_PLACOWA_KLUCZE  ON KASA_PLACOWA(KLUCZ_OBCY, TYP_KLUCZA);

/* --- */

SET TERM ^ ;

CREATE PROCEDURE DAJ_WPLATY_POZYCZEK(         // w tuszynie trzeba bylo zmienic decimal na double precision ??? //
  POTRACENIE INTEGER,
  ROK INTEGER,
  MC INTEGER)
RETURNS (SUMA DECIMAL(12,2))
AS
DECLARE VARIABLE VSUM DECIMAL(12,2);
DECLARE VARIABLE VSUMPOM DECIMAL(12,2);
BEGIN
  VSUM = 0;
  VSUMPOM = 0;

  SELECT SUM(S.Kwota) FROM Skladniki_listy_plac S
         JOIN Listy_Plac L ON L.Klucz = S.Lista_plac
         JOIN Naglowki_List_Plac N ON N.Klucz = L.Naglowek_Listy_Plac
   WHERE S.Typ_klucza = 'PTR' AND S.Typ_kwoty = 'P' AND S.Klucz_obcy = :POTRACENIE
         AND (N.rok_listy < :rok OR N.Rok_listy = :rok AND N.miesiac_listy <= :mc)
   INTO :VSUMPOM;
  IF (:VSUMPOM IS NULL) THEN VSUMPOM = 0;

  VSUM = :VSUMPOM;

  SELECT SUM(K.Kwota) FROM Kasa_placowa K
   WHERE K.Klucz_obcy = :POTRACENIE AND K.Typ_klucza = 'RPZ' AND K.Typ_kwoty = 'W'
         AND (rok < :rok OR Rok = :rok AND miesiac <= :mc)
   INTO :VSUMPOM;
  IF (:VSUMPOM IS NULL) THEN VSUMPOM = 0;

  VSUM = :VSUM + :VSUMPOM;
  SUMA = :VSUM;
  SUSPEND;
END ^
COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE TABLE DANE_DLA_ROR
       (KLUCZ           KLUCZ NOT NULL,
        OSOBA           KLUCZ NOT NULL,
        ANGAZ           KLUCZ NOT NULL,

        NA_ROR          TYP,
        KWOTA           WARTOSC,

        BANK1           BANK,
        KONTO1          KONTO,
        NA_ROR1         TYP,
        KWOTA1          WARTOSC,

        BANK2           BANK,
        KONTO2          KONTO,
        NA_ROR2         TYP,
        KWOTA2          WARTOSC,

        BANK3           BANK,
        KONTO3          KONTO,
        NA_ROR3         TYP,
        KWOTA3          WARTOSC,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_DANE_DLA_ROR FOR DANE_DLA_ROR
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^


/* --- */

CREATE TABLE PRZELEWY_Z_LIST
       (KLUCZ           KLUCZ NOT NULL,
        DANE_DLA_ROR    KLUCZ NOT NULL,
        LISTA_PLAC      KLUCZ,

        DATA            TIMESTAMP NOT NULL,

        FOREIGN KEY(DANE_DLA_ROR) REFERENCES DANE_DLA_ROR(KLUCZ),
        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_PRZELEWY_Z_LIST FOR PRZELEWY_Z_LIST
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^


ALTER TABLE LISTY_PLAC
ADD FOREIGN KEY(DO_PRZELEWU) REFERENCES PRZELEWY_Z_LIST(KLUCZ);

ALTER TABLE SKLADNIKI_LISTY_PLAC
ADD FOREIGN KEY(DO_PRZELEWU) REFERENCES PRZELEWY_Z_LIST(KLUCZ);


/* ------------------------- */
/* Urlopy                    */
/* ------------------------- */



CREATE TABLE WYMIARY_URLOPOW(
  KLUCZ       KLUCZ NOT NULL,
  OSOBA       KLUCZ NOT NULL,
  ANGAZ       KLUCZ NOT NULL,
  ROK         INTEGER NOT NULL,
  TYP         DIDENT NOT NULL, /*RODZAJ URLOPU -                   */
                               /* U.UWP = Wypoczynkowy             */
                               /* U.UOK = Okolicznociowy          */
                               /* U.URH = Rehabilitacyjny,         */
                               /* U.UDD = Dla dziecka (2 dni/rok)  */
                               /* U.USK = Szkoleniowy              */
                               /* U.UIN = Inny                     */
  WYMIAR1     INTEGER NOT NULL,/*PODSTAWOWY WYMIAR URLOPU WYNIKAJCY ZE STAU*/
  DNI_WOLNE1  ILOSC NOT NULL,  /*PRZELICZENIE Z WIELKOCI ETATU NA IL. PRZYSUGUJCYCH*/
                                /*DNI WOLNYCH PRZELICZANY PRZY PRZESZEREGOWANIU I PO POWROCIE*/
                                /*Z URLOPU BEZPATNEGO, MACIERZYSKIEGO I WYCHOWAWCZEGO*/
  DATA_OD1    TIMESTAMP NOT NULL,   /*DATA UZYSKANIA PRAWA DO TEGO WYMIARU URLOPU */

  WYMIAR2     ILOSC,
  DNI_WOLNE2  ILOSC,
  DATA_OD2    TIMESTAMP,

  WYMIAR3     ILOSC,
  DNI_WOLNE3  ILOSC,
  DATA_OD3    TIMESTAMP,

  WYMIAR4     ILOSC,
  DNI_WOLNE4  ILOSC,
  DATA_OD4    TIMESTAMP,

  WYMIAR5     ILOSC,
  DNI_WOLNE5  ILOSC,
  DATA_OD5    TIMESTAMP,

  WYKORZYSTANO ILOSC,           /*IL. WYKORZYSTANYCH W ROKU DNI WOLNYCH*/
  ZALEGLE      ILOSC,           /*dotyczy urlopw - Wypoczynkowy, Rehabilitacyjny,Inny*/
  ZALEGLE_CALOSC ILOSC,

  GODZ_WYKORZYSTANO   ILOSC,
  GODZ_ZALEGLE_CALOSC ILOSC,
  GODZ_ZALEGLE        ILOSC,

  GODZ_WOLNE1  ILOSC NOT NULL,
  GODZ_WOLNE2  ILOSC,
  GODZ_WOLNE3  ILOSC,
  GODZ_WOLNE4  ILOSC,
  GODZ_WOLNE5  ILOSC,

  WYKORZYSTANO_KOREKTA      ILOSC,
  GODZ_WYKORZYSTANO_KOREKTA ILOSC,

  WYKORZYSTANO_ZADANIE      ILOSC,
  GODZ_WYKORZYSTANO_ZADANIE ILOSC, /* urlop na danie */

  EKWIWALENT        ILOSC,
  GODZ_EKWIWALENT   ILOSC,

  UTWORZYL  KLUCZ,
  UTWORZONO TIMESTAMP,
  ZMIENIAL  KLUCZ,
  ZMIENIANO TIMESTAMP,

  PRIMARY KEY(KLUCZ),
  FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ));

CREATE INDEX WYMIARY_URLOPOW_XOSOBAROKTYP ON WYMIARY_URLOPOW(OSOBA, ANGAZ, ROK, TYP);

SET TERM ^ ;
CREATE TRIGGER CREATE_WYMIARY_URLOPOW FOR WYMIARY_URLOPOW
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

CREATE TABLE PLAN_URLOPOW(
  KLUCZ        KLUCZ NOT NULL,
  OSOBA        KLUCZ NOT NULL,
  ANGAZ        KLUCZ NOT NULL,
  PLAN_OD      TIMESTAMP NOT NULL,
  PLAN_DO      TIMESTAMP NOT NULL,
  TYP          DIDENT NOT NULL,

  UTWORZYL  KLUCZ,
  UTWORZONO TIMESTAMP,
  ZMIENIAL  KLUCZ,
  ZMIENIANO TIMESTAMP,

  PRIMARY KEY(KLUCZ));

CREATE INDEX PLAN_URLOPOW_XOKRESOSOBA ON PLAN_URLOPOW(PLAN_OD, PLAN_DO, OSOBA);

SET TERM ^ ;
CREATE TRIGGER CREATE_PLAN_URLOPOW FOR PLAN_URLOPOW
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

COMMIT WORK;


/* ------------------------- */
/* Inne kadrowe              */
/* ------------------------- */


CREATE TABLE OKRESY_SKLADKOWE
       (OSOBA         KLUCZ NOT NULL,
        KLUCZ         KLUCZ NOT NULL,

        POCZ_PRACY      TIMESTAMP,
        KON_PRACY       TIMESTAMP,

        NAZWAFIRMY    DUZY_OPIS,
        ADRESFIRMY    DUZY_OPIS,

        STANOWISKO    DUZY_OPIS,
        ZAKONCZENIE   DUZY_OPIS,

        DO_STAZU      TYP,
        DO_JUBILEUSZU TYP,
        DO_CZASU_PRACY TAKNIE,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,


        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        PRIMARY KEY(KLUCZ));

SET TERM ^ ;
CREATE TRIGGER CREATE_OKRES_SKLADKOWY FOR OKRESY_SKLADKOWE
BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ=0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END^
SET TERM ; ^

COMMIT WORK;

CREATE TABLE RODZAJE_KURSOW
       (IDENT           IDENT NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,

        UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(IDENT));

COMMIT WORK;

CREATE TABLE KURSY
       (TYP             IDENT NOT NULL,
        OSOBA           KLUCZ NOT NULL,
        TEMAT           DUZA_NAZWA NOT NULL,
        MIEJSCE         DUZY_OPIS,

      	POCZATEK        TIMESTAMP NOT NULL,
        KONIEC          TIMESTAMP NOT NULL,
        NASTEPNY        TIMESTAMP,  /* data nastpnego kursu - przy obowizkowych okresowych */
        OCENA           MALA_NAZWA,

        UWAGI           UWAGI,

        UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(OSOBA, TYP, POCZATEK, KONIEC),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ));

COMMIT WORK;

CREATE TABLE SZKOLY
       (OSOBA           KLUCZ NOT NULL,
        KLUCZ           KLUCZ NOT NULL,

        NAZWA           DUZA_NAZWA NOT NULL,
        ADRES           DUZY_OPIS,
        TYTUL           DUZA_NAZWA,

        LATA_STAZU      ILOSC,
        DO_STAZU        TYP,
        DO_JUBILEUSZU   TYP,

      	POCZATEK        TIMESTAMP,
        KONIEC          TIMESTAMP,

        UWAGI           UWAGI,

        UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(OSOBA, KLUCZ),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ));

COMMIT WORK;

CREATE TABLE BADANIA_LEKARSKIE
       (OSOBA           KLUCZ NOT NULL,
        KLUCZ           KLUCZ NOT NULL,
        RODZAJ          IDENT NOT NULL,

        LEKARZ          DUZA_NAZWA,
        FIRMA           KLUCZ,

      	DATA            TIMESTAMP,
        NASTEPNE        TIMESTAMP,

        WYNIK           TYP,
        DATA_WYNIKU     TIMESTAMP,

        UWAGI           UWAGI,

        UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(OSOBA, KLUCZ),
        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ));

COMMIT WORK;

CREATE TABLE RODZAJE_BADAN
       (IDENT           IDENT NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,
      	
        UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(IDENT));

COMMIT WORK;

/* ------------------------- */
/* Inne                      */
/* ------------------------- */


CREATE TABLE SLOWNIKI_PLACOWE
       (TYP             IDENT NOT NULL,
        IDENT           DIDENT NOT NULL,
        NAZWA           DUZA_NAZWA NOT NULL,
        INNY            DIDENT,
        KOLOR           INTEGER,   /* dla typw pracy - do grafiku */
		PLATNIK         TYP,       /* dla medycyny N - NFZ, P - penopatne */

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(TYP, IDENT));


/*---*/

CREATE TABLE PARAMETRY_PLACOWE
       (IDENT           DIDENT NOT NULL,
        NAZWA           DUZA_NAZWA,
        WARTOSC         WARTOSC,

      	UTWORZYL        KLUCZ,
      	UTWORZONO       TIMESTAMP,
      	ZMIENIAL        KLUCZ,
      	ZMIENIANO       TIMESTAMP,

        PRIMARY KEY(IDENT));




/*=========================*/
/* Umowy i ich rozliczenie */
/* ========================*/



CREATE TABLE DEFINICJEUMOWSTALYCH
       (KLUCZ           KLUCZ NOT NULL,

        IDENT           IDENT,
        NAZWA           DUZA_NAZWA,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));


CREATE TABLE UMOWYSTALE
       (KLUCZ           KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,
        ROK             INTEGER NOT NULL,
        DEFINICJA       KLUCZ NOT NULL,

        FIRMA           KLUCZ,
        ZAKLAD          KLUCZ,   /* Ewentualnie dotyczy zakladu ? */

        NR_DOKUM        SYMBOL,
        DATA_POCZ       TIMESTAMP,
        DATA_KON        TIMESTAMP,

        NUMER         OPIS,
        TYPPLATNOSCI  TYP,
        TERMIN_PLAT   INTEGER,
        ZDNIA         TIMESTAMP,

        MIESIACEFAKTUR VARCHAR(50);

        NETTO           WARTOSC,
        VAT             WARTOSC,
        RAZEM           WARTOSC,

        KLASYFIKACJA1  KLUCZ,
        KLASYFIKACJA2  KLUCZ,
        KLASYFIKACJA3  KLUCZ,

        DANE            PARAMETRY,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ, WERSJA),
        FOREIGN KEY(DEFINICJA) REFERENCES DEFINICJEUMOWSTALYCH(KLUCZ),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ));

CREATE INDEX UMOWYSTALE_XROKNR ON UMOWYSTALE(ROK, DEFINICJA, NR_DOKUM);


CREATE TABLE SPECYFIKACJAUMOWY
       (UMOWA           KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,
        LP              INTEGER NOT NULL,
        TYP             TYP,              /* S - stae, W - wg wykonania */

        CENNIK          KLUCZ,            /* Musz by, gdy typ = 'W' */
        POZYCJACENNIKA  KLUCZ,

        ZAKLAD          KLUCZ,

        OPIS            VARCHAR(120),

        ILOSC           ILOSC,  /* dla towarw odpowiada ilociom opakowa */
        JM              JM,
        SWW             SYMBOL,
        TYPVAT          TYP,
        TYPCENY         TYP,
        CENA            WARTOSC,
        NETTO           WARTOSC,
        VAT             WARTOSC,
        BRUTTO          WARTOSC,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        PRIMARY KEY(UMOWA, WERSJA, LP));

CREATE INDEX SPECYFIKACJAUMOWY_XCENA ON SPECYFIKACJAUMOWY(POZYCJACENNIKA);


CREATE TABLE PAKIETYUMOWY
       (UMOWA           KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,
        IDENT           DUZY_SYMBOL NOT NULL,
        NAZWA           OPIS,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(UMOWA, WERSJA, IDENT));

/*---*/

CREATE TABLE WYKONANIEUMOWY                /* Tabela nieczynna */
       (UMOWA           KLUCZ NOT NULL,
        WERSJA          INTEGER NOT NULL,
        LP              INTEGER NOT NULL,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        CENNIK          KLUCZ,
        POZYCJACENNIKA  KLUCZ,

        ILOSC           ILOSC,  /* dla towarw odpowiada ilociom opakowa */
        JM              JM,

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(UMOWA, WERSJA, LP, ROK, MIESIAC));


COMMIT WORK;

/*---*/

CREATE TABLE WYKONANIA_PROD_MED
       (KLUCZ           KLUCZ NOT NULL,
        PACJENT         KLUCZ NOT NULL,

        DATA            TIMESTAMP,      /* dotyczy utworzenia */
        DATA_R          TIMESTAMP,      /* dotyczy rozliczenia */
        POBYT           KLUCZ,     /* dotyczy pobytu utworzenia */
        POBYT_R         KLUCZ,     /* dotyczy pobytu rozliczenia */
        ETAP            TYP,       /* Z - zlecenie, W - wykonane */

        CENASPRZEDAZY   KLUCZ,     /* Pozycja cennika */
        PAKIET          DUZY_SYMBOL,

        KOREKTA         TAKNIE,    /* Faktycznie K - korekta */
        ORYGINAL        KLUCZ,     /* gdy korekta wskazuje na pozycj oryginau */

        UMOWA           KLUCZ,     /* wskazanie na rozliczana umow */
        WERSJA          INTEGER,
        FIRMA           KLUCZ,     /* Moe by rozliczenie bez umowy */

        FAKTURA         KLUCZ,     /* Wskazanie na faktur wystawion wg wykonania */
        LP              INTEGER,   /* Pozycja faktury, moe nie wystpi, gdy rozlicza si tylko skadniki */
        ROZLICZONO      TYP,       /* I - indywidualnie, Z - zbiorczo */

        UTWORZYL     KLUCZ,
        ZMIENIAL     KLUCZ,
        UTWORZONO    TIMESTAMP,
        ZMIENIANO    TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(CENASPRZEDAZY) REFERENCES CENYSPRZEDAZY(KLUCZ),
        FOREIGN KEY(ORYGINAL) REFERENCES WYKONANIA_PROD_MED(KLUCZ),
        FOREIGN KEY(UMOWA, WERSJA) REFERENCES UMOWYSTALE(KLUCZ, WERSJA),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ),
        FOREIGN KEY(FAKTURA) REFERENCES DOKUMENTYKSIEGOWE(KLUCZ),
        FOREIGN KEY(FAKTURA, LP) REFERENCES SPECYFIKACJAFAKTURY(DOKUMENT, LP));

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_WYKONANIA_PROD_MED FOR WYKONANIA_PROD_MED
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(CENNIKISPRZEDAZY_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*---*/

CREATE TABLE SKL_WYK_PROD_MED
       (WYK_PROD_MED    KLUCZ NOT NULL,
        SKLADNIK        KLUCZ NOT NULL, /* Klucz wg typu poniej, dla oddziau wizyta, dla lekw produkt */
        CENASPRZEDAZY   KLUCZ,          /* Pozycja cennika, niekoniecznie zgodna z WYKONANIA_PROD_MED */
        TYP             TYP NOT NULL,   /* R - procedura (historia),  (typ pobierany z ceny CenaSprzedazy a nie z wykonania)
                                           O - oddzia szpitala,
                                           L - leki oddziau,
                                           P, Z, D - pobyt w gab. lek, zab, diagn - Id_NFZ z RuchPrzychodni,
                                           S - wiadczenie NFZ (swiadczenia_pacjenta) */
        KOREKTA         TAKNIE,    /* Faktycznie K - korekta */

        POBYT           KLUCZ,
        WIZYTA          KLUCZ,
        ZAKLAD          KLUCZ,

        FOREIGN KEY(ZAKLAD) REFERENCES ZAKLADY(KLUCZ),
        FOREIGN KEY(WYK_PROD_MED) REFERENCES WYKONANIA_PROD_MED(KLUCZ),
        PRIMARY KEY(WYK_PROD_MED, SKLADNIK, TYP));

CREATE INDEX SKL_WYK_PROD_MED_XSKL ON SKL_WYK_PROD_MED(SKLADNIK);
CREATE INDEX SKL_WYK_PROD_MED_XPOBYT ON SKL_WYK_PROD_MED(POBYT);
CREATE INDEX SKL_WYK_PROD_MED_XCENA ON SKL_WYK_PROD_MED(CENASPRZEDAZY);

COMMIT WORK;

/*---*/

CREATE TABLE PAKIETYPACJENTOW
       (PACJENT         KLUCZ NOT NULL,
        FIRMA           KLUCZ NOT NULL,
        PAKIET          DUZY_SYMBOL NOT NULL,
        KARTA           DUZY_SYMBOL,
        DATA_OD         TIMESTAMP NOT NULL,
        DATA_DO         TIMESTAMP,

        FOREIGN KEY(PACJENT) REFERENCES PACJENCI(KLUCZ),
        FOREIGN KEY(FIRMA) REFERENCES FIRMY(KLUCZ),
        PRIMARY KEY(PACJENT, FIRMA, PAKIET, DATA_OD));


COMMIT WORK;

/*==========================================================================*/
/* Struktura nieruchomoci */
/*=========================*/

CREATE TABLE OSIEDLA
   (KLUCZ        KLUCZ NOT NULL,
    IDENT        SYMBOL NOT NULL,
    NAZWA        OPIS NOT NULL,

    KONTO_MIESZ  VARCHAR(20),
    KONTO_RESZTA VARCHAR(20),

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ));

CREATE TABLE NIERUCHOMOSCI
   (KLUCZ            KLUCZ NOT NULL,
    IDENT            SYMBOL NOT NULL,  /* jest 30 znakow !!! */
    NAZWA            OPIS,
    RODZAJ_WLASNOSCI IDENT NOT NULL, /* ze zmiennych systemowych */
    WSPOLNOTA        KLUCZ,          /* odnonik do FIRMY */

    AKTYWNE      TAKNIE,
    DATA_ODDANIA   TIMESTAMP,  /* Data oddania do uytku */
    DATA_USUNIECIA TIMESTAMP,  /* Data usunicia z ewidencji */

    OSIEDLE      KLUCZ,

    KONTO_MIESZ  VARCHAR(20),
    KONTO_RESZTA VARCHAR(20),

    ADRWOJEWODZTWO MIEJSCOWOSC,
    ADRPOWIAT      MIEJSCOWOSC,
    ADRMIEJSCOWOSC MIEJSCOWOSC, 
    ADRKODPOCZTOWY KOD_POCZTOWY,
    ADRULICA       ULICA,
    ADRDOM         DOM,

    ADMINISTRATOR      KLUCZ,
    PRRZEKAZANIE_KTO   OPIS,
    PRRZEKAZANIE_KIEDY TIMESTAMP,

    KSIEGAWIECZYSTA DUZA_NAZWA,
    NR_DZIALKI1     SYMBOL,
    NR_DZIALKI2     SYMBOL,
    NR_DZIALKI3     SYMBOL,

    POW_ROZL        WARTOSC,
    POW_OGRZ        WARTOSC,
    POW_WSPOLNA     WARTOSC,

    POW_WSP_CHODNIK    WARTOSC,
    POW_WSP_PODWORKO   WARTOSC,
    POW_WSP_ZIELEN     WARTOSC,
    POW_WSP_PRZESWIT   WARTOSC,

    POW_GM_CHODNIK     WARTOSC,
    POW_GM_JEZDNIA     WARTOSC,
    POW_GM_PLACE       WARTOSC,
    POW_GM_ZIELEN      WARTOSC,

    POW_POZOSTALA      WARTOSC,

    UWAGI        UWAGI,
    
    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ));

CREATE INDEX NIERUCHOMOSCI_XIDENT   ON NIERUCHOMOSCI(IDENT);
CREATE INDEX NIERUCHOMOSCI_XWSPOLNOTA   ON NIERUCHOMOSCI(WSPOLNOTA);

COMMIT WORK;

/* Budynki, parkingi, garae */
CREATE TABLE BUDOWLE
   (KLUCZ        KLUCZ NOT NULL,
    IDENT        SYMBOL NOT NULL,
    RODZAJ       IDENT NOT NULL, /* BDN - budynek, PRK - parking, GRZ - gara */
    NR_INWENT    DUZA_NAZWA,
    STREFA       TYP,
    SEGREGACJA_SMIECI  TAKNIE,

    AKTYWNE      TAKNIE,
    DATA_USUNIECIA TIMESTAMP,  /* Data usunicia z ewidencji */

    NIERUCHOMOSC KLUCZ NOT NULL,
    DATA_ODDANIA TIMESTAMP,           /* Data oddania budynku do uytku */

    ADRWOJEWODZTWO MIEJSCOWOSC,
    ADRPOWIAT      MIEJSCOWOSC,
    ADRMIEJSCOWOSC MIEJSCOWOSC,
    ADRKODPOCZTOWY KOD_POCZTOWY,
    ADRULICA       OPIS,
    ADRDOM         DOM,

    POW_ROZL        WARTOSC,
    POW_OGRZ        WARTOSC,

    POW_KLATKA      WARTOSC,
    POW_PRALNIA     WARTOSC,
    POW_SUSZARNIA   WARTOSC,
    POW_STRYCH      WARTOSC,
    POW_KOR_PIWNICY WARTOSC,
    POW_ZSYP        WARTOSC,
    POW_WC          WARTOSC,
    POW_DZWIGU      WARTOSC,
    POW_LUKSFERY    WARTOSC,
    POW_KORYTARZ    WARTOSC,
    POW_INNE        WARTOSC,

    POW_GOSP        WARTOSC,
    POW_ZGM         WARTOSC,

    WODA_ZIMNA      TAKNIE,
    WODA_CIEPLA     TAKNIE,
    KANALIZACJA     TAKNIE,
    GAZ             TAKNIE,
    CO              TAKNIE,
    WINDA           TAKNIE,
    ANTENA          TAKNIE,
    DOMOFON         TAKNIE,

    PP_WODA         KLUCZ,
    PP_CO           KLUCZ,
    PP_SWIATLO      KLUCZ,
    PP_GAZ          KLUCZ,

    UWAGI        UWAGI,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ),
    FOREIGN KEY(NIERUCHOMOSC) REFERENCES NIERUCHOMOSCI(KLUCZ));

CREATE INDEX BUDOWLE_XIDENT   ON BUDOWLE(IDENT);

/*==========================================================================*/
/* Lokale i liczniki*/
/*==================*/

CREATE TABLE LICZNIKI
   (KLUCZ       KLUCZ NOT NULL,
    IDENT       SYMBOL NOT NULL,
    RODZAJ      IDENT NOT NULL, /* ze zmiennych systemowych */
    NAZWA       DUZY_OPIS,

    KLUCZ_OBCY  KLUCZ NOT NULL,
    /* odnonik do POMIESZCZENIA lub BUDOWLE */
    TYP_KLUCZA  IDENT NOT NULL,
    /* PMS - pomieszczenia, PPB - punkty poboru */

    PION        INTEGER,
    KLATKA      DIDENT,

    ELEKTRONICZNE        TAKNIE,
    POCZATEK             TIMESTAMP,
    KONIEC               TIMESTAMP,
    AKTUALNA_LEGALIZACJA TIMESTAMP,
    NASTEPNA_LEGALIZACJA TIMESTAMP,

    UWAGI       UWAGI,

    UTWORZYL    KLUCZ,
    ZMIENIAL    KLUCZ,
    UTWORZONO   TIMESTAMP,
    ZMIENIANO   TIMESTAMP,

    PRIMARY KEY(KLUCZ));

COMMIT WORK;

CREATE INDEX LICZNIKI_XIDENT   ON LICZNIKI(IDENT);
CREATE INDEX LICZNIKI_XDOTYCZY ON LICZNIKI(KLUCZ_OBCY);

CREATE TABLE POMIESZCZENIA
   (KLUCZ        KLUCZ NOT NULL,
    POPRZEDNI    KLUCZ,     /* Klucz lokalu, z ktrego ten lokal pochodzi (podawany przy zmianie przeznaczenia lokalu) */
    BUDOWLA      KLUCZ NOT NULL,
    IDENT        SYMBOL,         /* nr lokalu */
    RODZAJ       IDENT NOT NULL, /* UZT-lokal uytkowy(niemieszkalny), MSZ-lokal mieszkalny, GRZ-pomieszczenie garaowe
                                    BKS-boks, GSP-pomieszczenie gospodarcze */
    AKTYWNE      TAKNIE,
    DATA_ODDANIA   TIMESTAMP,  /* Data oddania do uytku */
    DATA_USUNIECIA TIMESTAMP,  /* Data usunicia z ewidencji */

    RODZAJ_WLASNOSCI IDENT,    /* Nadpisuje odpowiedni wskaznik w nieruchomosci - w jedna strone - moze byc tylko SPD - poza wspolnota */
    SPD_OD           TIMESTAMP,
    SPD_DO           TIMESTAMP, 

    KLATKA       DIDENT,
    PIETRO       ILOSC,

    STAN_TECHNICZNY IDENT,
    TARYFA          IDENT,
    LOKALIZACJA     IDENT,

    KSIEGAWIECZYSTA DUZA_NAZWA,
    DATA_KW         TIMESTAMP,
    POZYCJA_KW      DUZA_NAZWA,
    HIPOTEKA_KAUC      WARTOSC,
    HIPOTEKA_KAUC_WLT  IDENT,
    HIPOTEKA_ZW        WARTOSC,
    HIPOTEKA_ZW_WLT    IDENT,
    PROC_WLASNOSCI     WARTOSC,
    PROC_UMARZANIA     WARTOSC,
    WSP_KORYGUJACY     WARTOSC,

    ROZKLAD          TYP, /* tylko mieszkalny */
    WSPOLUZYTKOWANIE IDENT,
    DZIALALNOSC      IDENT,
    PODNAJEM         IDENT,
    PODNAJEM_VAT     IDENT,
    DODATKI          IDENT,

    POWIERZCHNIA    WARTOSC,
    POWIERZCHNIAMIESZKALNA ILOSC,
    POWIERZCHNIAUZYTKOWA   ILOSC,
    POWIERZCHNIAOBNIZONA   ILOSC,

    POW_INNAUZYTKOWA    ILOSC,
    POW_INNANIEUZYTKOWA ILOSC,

    POW_ZABUDOWY      ILOSC,
    POW_DODATKOWA     ILOSC,
    POW_CO            WARTOSC,
    WYSOKOSC          WARTOSC,
    KUBATURA          WARTOSC;

    WODA_CIEPLA          IDENT,
    WODA_CIEPLA_ROZL     IDENT,
    WODA_ZIMNA           IDENT,
    ENERGIA_CIEPLNA      IDENT,
    ENERGIA_ELEKTRYCZNA  IDENT,
    GAZ                  IDENT,
    SCIEKI               IDENT,

    PP_WODA         KLUCZ,
    PP_CO           KLUCZ,
    PP_SWIATLO      KLUCZ,
    PP_GAZ          KLUCZ,

    CECHY   DUZY_OPIS,

    DO_BANKU     NUMER,

    PIERW_KOSZT_BUD WARTOSC,    /* Pierwotny koszt budowy */
    KOSZT_METRA     WARTOSC,    /* POCZTKOWY */
    KOSZT_METRA_AKT WARTOSC,    /* BIECY */
    STARY_KOSZT_METRA   WARTOSC, /* pamiec poprawek dla Jaracza */

    OPIS         DUZY_OPIS,
    UWAGI        UWAGI,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ),
    FOREIGN KEY(BUDOWLA) REFERENCES BUDOWLE(KLUCZ));

CREATE INDEX POMIESZCZENIA_XDO_BANKU ON POMIESZCZENIA(DO_BANKU);
CREATE INDEX POMIESZCZENIA_XIDENT    ON POMIESZCZENIA(BUDOWLA, IDENT);

CREATE TABLE SKLADNIKI_POMIESZCZEN
   (POMIESZCZENIE KLUCZ NOT NULL,
    KLUCZ         KLUCZ NOT NULL,
    TYP           IDENT NOT NULL,
    POWIERZCHNIA  WARTOSC,
    WYSOKOSC      WARTOSC,
    WYPOSAZENIE   IDENT,
     
    DATA_OD TIMESTAMP,
    DATA_DO TIMESTAMP,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(POMIESZCZENIE, KLUCZ),
    FOREIGN KEY(POMIESZCZENIE) REFERENCES POMIESZCZENIA(KLUCZ));



CREATE TABLE INNE_OPLATY_CZYNSZU
 (KLUCZ   KLUCZ NOT NULL,
  IDENT   IDENT,
  NAZWA   OPIS,
  DOTYCZY IDENT,      /* OG - opata g. (tylko 1 w zasadzie - od niego ew. zniki), */
                      /* FR - fun.remontowy, RF - rozliczenie FR, AN - antena, DZ - dwig, */
                      /* ZN / ZB - zabudowa nieruch./budowli,                        */
                      /* DP - dodatkowe powierzchnie, IN - inne                      */

  PROCENT_DO_DODATKU  WARTOSC, /* mieszkaniowego - do wyliczania podstawy dla urzdu */
  SWW        SYMBOL,

  ZALEZNE_GRUPA  TYP,
  KLAS_WKL       IDENT,
  BEZ_ROZRACHUNKOW   TAKNIE, /* jesli nieruchomosc we wspolnocie, a lokal nie i wskaznik 'T', to skladnik nie idzie do rozrachunkow */
                             /* w pozostalych przypadkach idzie do rozrachunkow */

  UTWORZYL   KLUCZ,
  ZMIENIAL   KLUCZ,
  UTWORZONO  TIMESTAMP,
  ZMIENIANO  TIMESTAMP,

  PRIMARY KEY(KLUCZ));

COMMIT WORK;


CREATE TABLE ZASADY_CZYNSZOWE 
 (KLUCZ	        KLUCZ NOT NULL,
  WERSJA        KLUCZ NOT NULL,

  TYP_DOTYCZY   TYP NOT NULL,        /* O - oglne, N - nieruchomo */
  DOTYCZY       KLUCZ NOT NULL,      /* O - 0, N - klucz nieruchomoci (TO CHYBA NIEAKTUALNE ?) */

  OSIEDLE       KLUCZ NOT NULL,
  TYP_BUDOWLI   IDENT,
  TYP_LOKALU    IDENT,
  TYP_ZASIEDL   IDENT,

  POCZATEK      TIMESTAMP,
  KONIEC        TIMESTAMP,
  TRYB_KON      TYP,
  
  UTWORZYL   KLUCZ,
  ZMIENIAL   KLUCZ,
  UTWORZONO  TIMESTAMP,
  ZMIENIANO  TIMESTAMP,

  PRIMARY KEY(KLUCZ, TYP_DOTYCZY, DOTYCZY, WERSJA));

COMMIT WORK;


CREATE TABLE SKLADNIKI_ZASAD
 (ZASADA       KLUCZ NOT NULL,
  WERSJA       KLUCZ NOT NULL,
  LP           KLUCZ NOT NULL, 
  RODZAJ       KLUCZ,          /* odniesienie do INNE_OPLATY_CZYNSZU */
  KLATKA       DIDENT,
  ROZLICZENIE  IDENT,
  TYP_VAT      TYP,
  CENA         WARTOSC,
  BRUTTO_NETTO TYP, 
  JM           JM,
  BEZ_PROPORCJI TAKNIE,

  PIETRO_OD    ILOSC,
  PIETRO_DO    ILOSC,
  ADD UCHWALA  DUZY_OPIS,

  UTWORZYL   KLUCZ,
  ZMIENIAL   KLUCZ,
  UTWORZONO  TIMESTAMP,
  ZMIENIANO  TIMESTAMP,

  PRIMARY KEY(ZASADA, WERSJA, LP));

CREATE INDEX SKLADNIKI_ZASAD_XRODZAJ ON SKLADNIKI_ZASAD(RODZAJ);

COMMIT WORK;

CREATE TABLE POZYCJE_CENNIKOW
   (OPLATA   KLUCZ NOT NULL,
    KLUCZ    KLUCZ NOT NULL,
    NAZWA    DUZA_NAZWA,

    TYP_VAT  TYP,
    CENA     WARTOSC,
    BRUTTO_NETTO TYP, /* B - Brutto, N - Netto */

    UTWORZYL  KLUCZ,
    ZMIENIAL  KLUCZ,
    UTWORZONO TIMESTAMP,
    ZMIENIANO TIMESTAMP,
   
    PRIMARY KEY(OPLATA, KLUCZ),
    FOREIGN KEY(OPLATA) REFERENCES INNE_OPLATY_CZYNSZU(KLUCZ));

COMMIT WORK;


CREATE TABLE CENNIKI_INFRASTRUKTURY
 (KLUCZ         KLUCZ NOT NULL,
  TYP           TYP NOT NULL,    /* Nieruchomo, budowla, zasiedlenie */ 
  DOTYCZY       KLUCZ NOT NULL,
  DATA_OD       TIMESTAMP NOT NULL,
  DATA_DO       TIMESTAMP,
  OPLATA        KLUCZ NOT NULL,
  POZYCJA       KLUCZ NOT NULL, /* Odwoanie do dodatkowego cennika POZYCJE_CENNIKOW(KLUCZ) */
  KWOTA         WARTOSC,
  TYP_VAT       TYP,
  BRUTTO_NETTO  TYP,
  BEZ_PROPORCJI TAKNIE,

  ILOSC         ILOSC,

  TYP_LOKALU       IDENT,
  TYP_ZASIEDLENIA  IDENT,
  PIETRO_OD        ILOSC,
  PIETRO_DO        ILOSC,
  KLATKA        DIDENT,

  UCHWALA       DUZY_OPIS,

  UTWORZYL      KLUCZ,
  ZMIENIAL      KLUCZ,
  UTWORZONO     TIMESTAMP,
  ZMIENIANO     TIMESTAMP,
  PRIMARY KEY (KLUCZ, TYP, DOTYCZY, DATA_OD));
COMMIT WORK;

CREATE INDEX CENNIKI_INFRASTRUKTURY_XDOTYCZY ON CENNIKI_INFRASTRUKTURY(DOTYCZY);

COMMIT WORK;

CREATE TABLE ROZL_STAWKI_BUDOWLI
  (
   KLUCZ      KLUCZ NOT NULL,
   BUDOWLA    KLUCZ NOT NULL,
   SKLADNIK   KLUCZ NOT NULL,
   DATA_OD    TIMESTAMP,
   DATA_DO    TIMESTAMP,
   KWOTA      WARTOSC,
   TYP_VAT    TYP,
   
   PRIMARY KEY(KLUCZ),
   FOREIGN KEY(BUDOWLA) REFERENCES BUDOWLE(KLUCZ));


/*==========================================================================*/
/* Pomiary i rozliczenie mediw */
/*==============================*/

CREATE TABLE POMIARY_LICZNIKOW
 (KLUCZ         KLUCZ NOT NULL,
  LICZNIK       KLUCZ NOT NULL,
  LOKAL         KLUCZ NOT NULL,
  DATA          TIMESTAMP NOT NULL,
  KOREKTA       INTEGER NOT NULL,
  WARTOSC       WARTOSC,
  TYP           TYP,   /* I-indywidualnie, G-grupowo, S-szacowany */
                       /* przy S - sposb szacowania wg wskanika w zmiennych systemowych */

  ROZLICZENIE   KLUCZ,    /* Wskanik do ROZLICZENIE_MEDIOW, po rozliczeniu nie mona zmienia, NIE UZYWANE ! */

  UTWORZYL      KLUCZ,
  ZMIENIAL      KLUCZ,
  UTWORZONO     TIMESTAMP,
  ZMIENIANO     TIMESTAMP,

  PRIMARY KEY (KLUCZ),
  FOREIGN KEY(LICZNIK) REFERENCES LICZNIKI(KLUCZ),
  FOREIGN KEY(LOKAL) REFERENCES POMIESZCZENIA(KLUCZ));
COMMIT WORK;

CREATE UNIQUE INDEX POMIARY_LICZNIKOW_XDOTYCZYDATA ON POMIARY_LICZNIKOW(LOKAL, LICZNIK, DATA, KOREKTA);

CREATE TABLE POMIARY_PUNKTU
 (KLUCZ         KLUCZ NOT NULL,
  PUNKT         KLUCZ NOT NULL,
  ROK           INTEGER,
  MIESIAC       INTEGER,
  SYMBOL        DUZY_SYMBOL,
  DATA          TIMESTAMP NOT NULL, /* data pomiaru */
  MEDIUM        IDENT,  /* wykaz - RozliczaneMedia: woda + cieki, woda, cieki, */
                        /* podgrzanie wody, co, gaz, en.elektryczna */

  POMIAR        WARTOSC,
  ZUZYCIE       WARTOSC,
  CENA          WARTOSC,
  PROC_VAT      IDENT,
  NETTO         WARTOSC,
  VAT           WARTOSC,
  BRUTTO        WARTOSC,

  ROZLICZENIE   KLUCZ,    /* Wskanik do ROZLICZENIE_MEDIOW, po rozliczeniu nie mona zmienia */
  WODA_GOSPODARCZA WARTOSC,
  KOREKTA          WARTOSC,

  UTWORZYL      KLUCZ,
  ZMIENIAL      KLUCZ,
  UTWORZONO     TIMESTAMP,
  ZMIENIANO     TIMESTAMP,

  PRIMARY KEY(KLUCZ),
  FOREIGN KEY(PUNKT) REFERENCES LICZNIKI(KLUCZ));
COMMIT WORK;

CREATE INDEX POMIARY_PUNKTU_XDOTYCZYDATA ON POMIARY_PUNKTU(PUNKT, DATA);

CREATE TABLE ROZLICZENIE_MEDIOW 
 (KLUCZ          KLUCZ   NOT NULL,
  PUNKT          KLUCZ   NOT NULL,

  ROK            INTEGER NOT NULL,
  MIESIAC        INTEGER NOT NULL,
  MEDIUM         IDENT   NOT NULL,

  RODZAJ_LOKALU  OPIS,
  SCIEKI_WG_LICZNIKA_WD TAKNIE,

  DATA_OD        TIMESTAMP,
  DATA_DO        TIMESTAMP,
  DATA_PLATNIKA  TIMESTAMP,

  ROZL_ROK       INTEGER,
  ROZL_MIESIAC   INTEGER,

  LICZNIKI       TAKNIE, /* wskaznik, czy ma rozliczac wszystko: W=wszystko, L=licznikowcy, R=ryczaltowcy */

  NORMAOSOBOWA   WARTOSC,

  ZUZYCIE_GOSP   ILOSC,
  AWARIA         ILOSC,
  ILOSC          ILOSC,
  CENA           WARTOSC,
  PROC_VAT       IDENT,
  NETTO          WARTOSC,
  VAT            WARTOSC,
  BRUTTO         WARTOSC,
  ROZNICA        WARTOSC,

  DATA_PLAT      TIMESTAMP,
  PLATNIK        IDENT,
  ZUZYCIE        IDENT,
  ROZLICZENIE    IDENT,
  STARE_ZALICZKI TAKNIE,

  JM             JM,    /* domyslnie woda - m3, CO - kWh */
  SPOSOB         IDENT, /* sposob rozliczania ryczaltowcow (proporcja) - il.osob, powierzchnia */
                        /* jesli bedzie puste - przyjmujemy rozliczenie na dotyczczasowych zasadach */
                        /* (domyslnie wg rodzaju medium, np woda wg il.os.zamieszkalych, CO wg pow.ogrzewanej) */
                        /* slownik RozliczanieProporcjonalneWg */
  UTWORZYL       KLUCZ,
  ZMIENIAL       KLUCZ,
  UTWORZONO      TIMESTAMP,
  ZMIENIANO      TIMESTAMP,

  MSZ_LOK_RYCZ           ILOSC,
  MSZ_LOK_LICZ           ILOSC,
  UZT_LOK_RYCZ           ILOSC,
  UZT_LOK_LICZ           ILOSC,
  GRZ_LOK_RYCZ           ILOSC,
  GRZ_LOK_LICZ           ILOSC,
  BKS_LOK_RYCZ           ILOSC,
  BKS_LOK_LICZ           ILOSC,
  GSP_LOK_RYCZ           ILOSC,
  GSP_LOK_LICZ           ILOSC,
  MSZ_ZUZYCIE_LICZ       ILOSC,
  UZT_ZUZYCIE_LICZ       ILOSC,
  GRZ_ZUZYCIE_LICZ       ILOSC,
  BKS_ZUZYCIE_LICZ       ILOSC,
  GSP_ZUZYCIE_LICZ       ILOSC,
  MSZ_OS_ZAMELD_RYCZ     ILOSC,
  MSZ_OS_ZAMELD_LICZ     ILOSC,
  UZT_OS_ZAMELD_RYCZ     ILOSC,
  UZT_OS_ZAMELD_LICZ     ILOSC,
  GRZ_OS_ZAMELD_RYCZ     ILOSC,
  GRZ_OS_ZAMELD_LICZ     ILOSC,
  BKS_OS_ZAMELD_RYCZ     ILOSC,
  BKS_OS_ZAMELD_LICZ     ILOSC,
  GSP_OS_ZAMELD_RYCZ     ILOSC,
  GSP_OS_ZAMELD_LICZ     ILOSC,
  MSZ_OS_ZAMIESZK_RYCZ   ILOSC,
  MSZ_OS_ZAMIESZK_LICZ   ILOSC,
  UZT_OS_ZAMIESZK_RYCZ   ILOSC,
  UZT_OS_ZAMIESZK_LICZ   ILOSC,
  GRZ_OS_ZAMIESZK_RYCZ   ILOSC,
  GRZ_OS_ZAMIESZK_LICZ   ILOSC,
  BKS_OS_ZAMIESZK_RYCZ   ILOSC,
  BKS_OS_ZAMIESZK_LICZ   ILOSC,
  GSP_OS_ZAMIESZK_RYCZ   ILOSC,
  GSP_OS_ZAMIESZK_LICZ   ILOSC,
  DRZ_LOK_RYCZ           ILOSC,
  DRZ_LOK_LICZ           ILOSC,
  DRZ_ZUZYCIE_LICZ       ILOSC,
  DRZ_OS_ZAMELD_RYCZ     ILOSC,
  DRZ_OS_ZAMELD_LICZ     ILOSC,
  DRZ_OS_ZAMIESZK_RYCZ   ILOSC,
  DRZ_OS_ZAMIESZK_LICZ   ILOSC,

  MSZ_POW_MIESZ_RYCZ   ILOSC,
  MSZ_POW_MIESZ_LICZ   ILOSC,
  MSZ_POW_UZYTK_RYCZ   ILOSC,
  MSZ_POW_UZYTK_LICZ   ILOSC,
  MSZ_POW_OGRZEW_RYCZ  ILOSC,
  MSZ_POW_OGRZEW_LICZ  ILOSC,
  MSZ_KUBATURA_RYCZ    ILOSC,
  MSZ_KUBATURA_LICZ    ILOSC,

  UZT_POW_MIESZ_RYCZ   ILOSC,
  UZT_POW_MIESZ_LICZ   ILOSC,
  UZT_POW_UZYTK_RYCZ   ILOSC,
  UZT_POW_UZYTK_LICZ   ILOSC,
  UZT_POW_OGRZEW_RYCZ  ILOSC,
  UZT_POW_OGRZEW_LICZ  ILOSC,
  UZT_KUBATURA_RYCZ    ILOSC,
  UZT_KUBATURA_LICZ    ILOSC,

  GRZ_POW_MIESZ_RYCZ   ILOSC,
  GRZ_POW_MIESZ_LICZ   ILOSC,
  GRZ_POW_UZYTK_RYCZ   ILOSC,
  GRZ_POW_UZYTK_LICZ   ILOSC,
  GRZ_POW_OGRZEW_RYCZ  ILOSC,
  GRZ_POW_OGRZEW_LICZ  ILOSC,
  GRZ_KUBATURA_RYCZ    ILOSC,
  GRZ_KUBATURA_LICZ    ILOSC,

  BKS_POW_MIESZ_RYCZ   ILOSC,
  BKS_POW_MIESZ_LICZ   ILOSC,
  BKS_POW_UZYTK_RYCZ   ILOSC,
  BKS_POW_UZYTK_LICZ   ILOSC,
  BKS_POW_OGRZEW_RYCZ  ILOSC,
  BKS_POW_OGRZEW_LICZ  ILOSC,
  BKS_KUBATURA_RYCZ    ILOSC,
  BKS_KUBATURA_LICZ    ILOSC,

  GSP_POW_MIESZ_RYCZ   ILOSC,
  GSP_POW_MIESZ_LICZ   ILOSC,
  GSP_POW_UZYTK_RYCZ   ILOSC,
  GSP_POW_UZYTK_LICZ   ILOSC,
  GSP_POW_OGRZEW_RYCZ  ILOSC,
  GSP_POW_OGRZEW_LICZ  ILOSC,
  GSP_KUBATURA_RYCZ    ILOSC,
  GSP_KUBATURA_LICZ    ILOSC,

  DRZ_POW_MIESZ_RYCZ   ILOSC,
  DRZ_POW_MIESZ_LICZ   ILOSC,
  DRZ_POW_UZYTK_RYCZ   ILOSC,
  DRZ_POW_UZYTK_LICZ   ILOSC,
  DRZ_POW_OGRZEW_RYCZ  ILOSC,
  DRZ_POW_OGRZEW_LICZ  ILOSC,
  DRZ_KUBATURA_RYCZ    ILOSC,
  DRZ_KUBATURA_LICZ    ILOSC;

 PRIMARY KEY(KLUCZ),
 FOREIGN KEY(PUNKT) REFERENCES LICZNIKI(KLUCZ));

CREATE INDEX ROZLICZENIE_MEDIOW_XROZLICZENIE ON ROZLICZENIE_MEDIOW(PUNKT, ROZL_ROK, ROZL_MIESIAC);
CREATE INDEX ROZLICZENIE_MEDIOW_XOKRES       ON ROZLICZENIE_MEDIOW(PUNKT, ROK, MIESIAC, MEDIUM);
COMMIT WORK;




CREATE TABLE NAGLOWEK_ROZLICZENIA_MEDIOW 
 (KLUCZ          KLUCZ   NOT NULL,

  MEDIUM         IDENT   NOT NULL,
  ROK            INTEGER NOT NULL, /* do ktorego okresu doliczamy w saldach */
  MIESIAC        INTEGER NOT NULL,

  PUNKT          KLUCZ,
  OSIEDLE        KLUCZ,
  RODZAJ_LOKALU  OPIS,
  BUDOWLE        VARCHAR(3000), /* klucze budowli oddzielone srednikami */
  IGNORUJ_POZA_WSPOLNOTA TAKNIE,

  ROZNICA_ROZPISZ     TAKNIE,   /* czy rozpisac roznice miedzy licznikiem glownym a rozliczeniami lokali (proporcjonalnie do zuzycia ) */

  DATA_OD        TIMESTAMP,   /* okres rozliczenia */
  DATA_DO        TIMESTAMP,
  DATA_PLATNOSCI TIMESTAMP,
  DATA_WYST      TIMESTAMP,

  DATA_PLATNIKA  TIMESTAMP,   /* data, z ktorej pobierany aktualny platnik do rozliczenia */
  PLATNIK        IDENT,  /* sposob pobrania platnika : z m-ca rozliczenia, z daty platnosci, z w/w daty, z koncowej daty rozliczenia... */

  LICZNIKI       TAKNIE, /* wskaznik, czy ma rozliczac wszystko: W=wszystko, L=licznikowcy, R=ryczaltowcy */
  POPRZEDNIE_OKRESY TAKNIE,   /* Tak: spr.czy istnieja wczesniejsze okresy nierozliczone i np.rozliczamy */
                              /* I-XII 2012, a zasiedlenie ma nierozliczony VII-XII 2011, to rozliczy */
                              /* za VII 2011 - XII 2012 */

  ZUZYCIE_SPOSOB IDENT,
  WARTOSC_SPOSOB IDENT,
  NORMAOSOBOWA   WARTOSC,     /* ZUZYCIE_SPOSOB = PDN -> ryczalt wg podanej normy razy os. lub m3 */
  WG_ZUZYCIA_Z_MEDIUM  IDENT, /* ZUZYCIE_SPOSOB = IMD -> pobranie ilosci z rozliczenia z okresu innego medium */
                              /* np. podgrzanie wg ilosci wody cieplej, a sciekow/szamba wg sumy wody zimnej i cieplej */  
                              /* w pozostalych przypadkach nie wystepuje */
  PROPORCJA      IDENT,       /* ZUZYCIE_SPOSOB = RZN, PDN -> sposob rozliczania ryczaltowcow (proporcja) - il.osob, powierzchnia */
                              /* (domyslnie wg rodzaju medium, np woda wg il.os.zamieszkalych, CO wg pow.ogrzewanej) */
  
  ZUZYCIE_GOSP   ILOSC,
  AWARIA         ILOSC,
  ILOSC          ILOSC,
  CENA           WARTOSC,
  PROC_VAT       IDENT,
  NETTO          WARTOSC,
  VAT            WARTOSC,
  BRUTTO         WARTOSC,
  ROZNICA        WARTOSC,
  VAT_ZALICZKOWY TAKNIE,
  NETTOBRUTTO    TAKNIE,

  CENA_DATA      TIMESTAMP,
  CENA_SPOSOB    IDENT,  /* jesli nie podamy ceny, to wg jakiej ma byc rozliczane (pobranej indywidualnie dla zasiedlenia: */
                         /* w/w daty, z konca rozliczenia (DATA_DO), z m-ca rozliczenia, z ZUZYCIE_MEDIOW.DATA_DO */
  RYCZALT_KONIEC_OKRESU   TAKNIE;     /* czy ryczaltowcy sa rozliczani zawsze, czy tylko */
                                      /* jesli sa ryczaltowcami na koniec rozliczanego okresu */

  WLACZAC_KOSZTY       TAKNIE,
  OBIE_WODY_RAZEM      TAKNIE,
  
  RODZAJ_ZASIEDLENIA   VARCHAR(60),
  RODZ_ZASIEDL_WARTOSCIOWO VARCHAR(60),

  UTWORZYL       KLUCZ,
  ZMIENIAL       KLUCZ,
  UTWORZONO      TIMESTAMP,
  ZMIENIANO      TIMESTAMP,

  PRIMARY KEY(KLUCZ));

CREATE INDEX NAGL_ROZLICZENIA_XOKRES        ON NAGLOWEK_ROZLICZENIA_MEDIOW(ROK, MIESIAC, MEDIUM, DATA_OD, DATA_DO);
CREATE INDEX NAGL_ROZLICZENIA_XOKRES_RODZ   ON NAGLOWEK_ROZLICZENIA_MEDIOW(MEDIUM, DATA_OD, DATA_DO, LICZNIKI);
COMMIT WORK;



CREATE TABLE ZUZYCIE_MEDIOW
 (KLUCZ         KLUCZ NOT NULL,
  LOKAL         KLUCZ NOT NULL,
  ZASIEDLENIE   KLUCZ NOT NULL,
  MEDIUM        IDENT NOT NULL,
  TYP           TYP NOT NULL,   /* L-licznik, R-ryczat, O-oba (?), W-wyrwnanie przy szacowanym pomiarze (?) */
  SPOSOB        TYP,            /* I-indywidualnie, G-grupowo (wg zuzycia w punkcie poboru) */

  ZASIEDLENIE_KONTYNUACJA KLUCZ NOT NULL,

  DATA_OD       TIMESTAMP NOT NULL,
  DATA_DO       TIMESTAMP,
  KOREKTA       INTEGER NOT NULL,
  MIES_CZYNSZ   KLUCZ,

  WYLICZONO  ILOSC,
  ZAPLACONO  ILOSC,
  ROZNICA    ILOSC,

  ZAPLACONOKWOTA    WARTOSC,
  ZAPLACONOVAT      WARTOSC,
  ZAPLACONONETTO    WARTOSC,
  WYLICZONOKWOTA    WARTOSC,
  WYLICZONOVAT      WARTOSC,
  WYLICZONONETTO    WARTOSC,

  ROZLICZENIE KLUCZ,  /* klucz do ROZLICZENIE_MEDIOW */
  NOWE        TAKNIE,  /* T: rozliczenie grupowe z nowego programu; NULL: rozlicz.grupowe ze starego lub indywidualne */

  UTWORZYL      KLUCZ,
  ZMIENIAL      KLUCZ,
  UTWORZONO     TIMESTAMP,
  ZMIENIANO     TIMESTAMP,

  PRIMARY KEY(KLUCZ),
  FOREIGN KEY(LOKAL) REFERENCES POMIESZCZENIA(KLUCZ),
  FOREIGN KEY(ZASIEDLENIE) REFERENCES ZASIEDLENIA(KLUCZ));
COMMIT WORK;

CREATE INDEX ZUZYCIE_MEDIOW_XDOTYCZY     ON ZUZYCIE_MEDIOW(LOKAL, ZASIEDLENIE, DATA_OD);
CREATE INDEX ZUZYCIE_MEDIOW_XROZLICZENIE ON ZUZYCIE_MEDIOW(ROZLICZENIE, LOKAL, ZASIEDLENIE);
CREATE INDEX ZUZYCIE_MEDIOW_XOPLATA      ON ZUZYCIE_MEDIOW(ROZLICZENIE, MIES_CZYNSZ);

CREATE TABLE LICZNIKI_ZUZYCIA_MEDIOW
 (ZUZYCIE         KLUCZ NOT NULL,
  LICZNIK         KLUCZ NOT NULL,
  POMIAR_PIERWSZY KLUCZ,
  POMIAR_OSTATNI  KLUCZ,

  PRIMARY KEY(ZUZYCIE, LICZNIK),
  FOREIGN KEY(ZUZYCIE) REFERENCES ZUZYCIE_MEDIOW(KLUCZ),
  FOREIGN KEY(LICZNIK) REFERENCES LICZNIKI(KLUCZ));
COMMIT WORK;

CREATE INDEX LZUZYCIE_MEDIOW_XPIERWSZY      ON LICZNIKI_ZUZYCIA_MEDIOW(POMIAR_PIERWSZY);
CREATE INDEX LZUZYCIE_MEDIOW_XOSTATNI       ON LICZNIKI_ZUZYCIA_MEDIOW(POMIAR_OSTATNI);

/*==========================================================================*/
/* Struktura najmu */
/*=================*/

CREATE GENERATOR KONTYNUACJE_GEN;
COMMIT WORK;

SET TERM ^ ;
CREATE PROCEDURE GET_KONTYNUACJE_GEN
RETURNS (IDENT INTEGER)
AS
 BEGIN
  IDENT = GEN_ID(KONTYNUACJE_GEN,1);
END ^
SET TERM ; ^

COMMIT WORK;


CREATE TABLE ZASIEDLENIA
   (KLUCZ         KLUCZ NOT NULL,
    LOKAL         KLUCZ NOT NULL,

    KLUCZ_KONTYNUACJI KLUCZ NOT NULL,

    DATA_OD       TIMESTAMP,
    DATA_DO       TIMESTAMP,
    PDST_PRAWNA   IDENT,
    DATA_UMOWY    TIMESTAMP,

    GLOWNE        KLUCZ,       /* Odnonik do zasiedlenia gwnego */

    TERMIN        ILOSC,

    NR_EWID       SYMBOL, /* nr ewidencyjny */
    TYP           IDENT,
    PODRODZAJ     IDENT,  /* rozszerzenie typu */

    RODZAJ_WLASNOSCI IDENT,    /* Pobierane z pomieszczenia - moze byc tylko SPD - poza wspolnota */

    CECHY         DUZY_OPIS,

    GLOWNE_NR_EWID SYMBOL,
    WSK_FAKTURY    TAKNIE,

    RODZAJ_POJEMNIKOW     KLUCZ,   /* odwolanie do POJEMNIKI_NA_SMIECI.KLUCZ */
    ILOSC_POJEMNIKOW      INTEGER,
    CZESTOTLIWOSC_ODBIORU WARTOSC,

    UWAGI VARCHAR(500) CHARACTER SET DOS852 COLLATE PDOX_PLK,

    UTWORZYL      KLUCZ,
    ZMIENIAL      KLUCZ,
    UTWORZONO     TIMESTAMP,
    ZMIENIANO     TIMESTAMP,

    PRIMARY KEY(KLUCZ),
    FOREIGN KEY(LOKAL) REFERENCES POMIESZCZENIA(KLUCZ));

COMMIT WORK;

CREATE INDEX ZASIEDLENIA_XGLOWNE ON ZASIEDLENIA(GLOWNE);
CREATE INDEX ZASIEDLENIA_XKONTYNUACJA ON ZASIEDLENIA(KLUCZ_KONTYNUACJI);

CREATE TABLE ZASIEDLENIA_BANK
   (KLUCZ_KONTYNUACJI KLUCZ NOT NULL,
    DO_BANKU     NUMER,
    PRIMARY KEY(KLUCZ_KONTYNUACJI));

CREATE INDEX ZASIEDLENIA_DO_BANKU ON ZASIEDLENIA_BANK(DO_BANKU);


CREATE TABLE LOKATORZY
   (KLUCZ            KLUCZ NOT NULL,
    ZASIEDLENIE      KLUCZ NOT NULL,

    TYP_NAJEMCY      TYP,
    NAJEMCA          KLUCZ,
    TYTUL            IDENT,  /* wykaz - zm. systemowe: G-gwny lokator, P - platnik, L-lokator zwyky */

    IL_OS_ZAMELD  ILOSC,   /* tylko lokale mieszkalne */
    IL_OS_ZAMIESZ ILOSC,   /* tylko lokale mieszkalne */

    DATA_OD          TIMESTAMP NOT NULL,
    DATA_DO          TIMESTAMP,

    PROCENT_CZYNSZ   ILOSC,
    PROCENT_MEDIA    ILOSC,
    PROCENT_INNE     ILOSC,

    KORNAZWA       DUZY_OPIS,
    KORNAZWA1      DUZY_OPIS,
    KORNAZWA2      DUZY_OPIS,
    KORKODPOCZTOWY KOD_POCZTOWY,
    KORULICA       OPIS,
    KORDOM         DOM,
    KORLOKAL       LOKAL,
    KORMIEJSCOWOSC MIEJSCOWOSC,
    KORTELEFON     TEL_FAX,
    KORSKRYTKA     DUZY_SYMBOL,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ),
    FOREIGN KEY(ZASIEDLENIE) REFERENCES ZASIEDLENIA(KLUCZ));

COMMIT WORK;

CREATE INDEX LOKATORZY_XZASIEDLENIE ON LOKATORZY(ZASIEDLENIE, NAJEMCA, DATA_OD);
CREATE INDEX LOKATORZY_XNAJEMCA ON LOKATORZY(NAJEMCA);


CREATE TABLE SMIECI_NA_ZASIEDLENIE
   (KLUCZ         KLUCZ NOT NULL,
    ZASIEDLENIE   KLUCZ NOT NULL,

    DATA_OD       TIMESTAMP NOT NULL,
    DATA_DO       TIMESTAMP,

    RODZAJ_POJEMNIKOW     KLUCZ   NOT NULL,   /* odwolanie do POJEMNIKI_NA_SMIECI.KLUCZ */
    ILOSC_POJEMNIKOW      INTEGER NOT NULL,
    CZESTOTLIWOSC_ODBIORU WARTOSC NOT NULL,


    UTWORZYL      KLUCZ,
    ZMIENIAL      KLUCZ,
    UTWORZONO     TIMESTAMP,
    ZMIENIANO     TIMESTAMP,

    PRIMARY KEY(KLUCZ),
    FOREIGN KEY(ZASIEDLENIE) REFERENCES ZASIEDLENIA(KLUCZ));

COMMIT WORK;

/*==========================================================================*/
/* zasady rozliczania */
/*=================== */


CREATE TABLE NAGLOWEK_ZNIZEK_PODWYZEK
  (KLUCZ     KLUCZ NOT NULL,
   WERSJA    KLUCZ NOT NULL,
   POCZATEK  TIMESTAMP NOT NULL,
   KONIEC    TIMESTAMP,
   TRYB_KON  TYP,

   UTWORZYL  KLUCZ,
   ZMIENIAL  KLUCZ,
   UTWORZONO TIMESTAMP,
   ZMIENIANO TIMESTAMP,

   PRIMARY KEY(KLUCZ, WERSJA, POCZATEK));

COMMIT WORK;


CREATE TABLE ZNIZKI_PODWYZKI
   (KLUCZ        KLUCZ NOT NULL,
    UMOWA        KLUCZ NOT NULL,
    WERSJA       KLUCZ NOT NULL,

    RODZAJ       TYP NOT NULL,
    DOTYCZY      IDENT,
    SPOSOB       TYP NOT NULL,
    WARTOSC      WARTOSC NOT NULL,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(UMOWA, WERSJA, KLUCZ));

COMMIT WORK;

CREATE TABLE ZASADY_MEDIOW
   (KLUCZ        KLUCZ NOT NULL,
    WERSJA       KLUCZ NOT NULL,

    TYP_LOKALU       IDENT,
    TYP_ZASIEDLENIA  IDENT,

    OSIEDLE      KLUCZ,

    TYP_DOTYCZY     TYP,
    DOTYCZY         KLUCZ,

    POCZATEK   TIMESTAMP,
    KONIEC     TIMESTAMP,
    TRYB_KON   TYP, /* Z - zmiana, K - koniec */

    /* Skadniki - media */
    WCIEPLA_LICZ_ROZL    IDENT, /* woda ciepa dla osb z licznikami */
    WCIEPLA_LICZ_TYP_VAT TYP,
    WCIEPLA_LICZ_CENA    WARTOSC,
    WCIEPLA_LICZ_NORMA   WARTOSC,

    WCIEPLA_RYCZ_ROZL    IDENT, /* woda ciepa dla ryczatowcw */
    WCIEPLA_RYCZ_TYP_VAT TYP,
    WCIEPLA_RYCZ_RYCZALT WARTOSC,
    WCIEPLA_RYCZ_NORMA   WARTOSC,

    WZIMNA_ROZL     IDENT, /* woda zimna */
    WZIMNA_TYP_VAT  TYP,
    WZIMNA_CENA     WARTOSC,
    WZIMNA_NORMA    WARTOSC,

    CO_ROZL     IDENT, /* energia cieplna - CO */
    CO_TYP_VAT  TYP,
    CO_CENA     WARTOSC,
    CO_NORMA    WARTOSC,

    SWIATLO_ROZL     IDENT, /* energia elektryczna */
    SWIATLO_TYP_VAT  TYP,
    SWIATLO_CENA     WARTOSC,
    SWIATLO_NORMA    WARTOSC,

    GAZ_ROZL     IDENT, /* gaz */
    GAZ_TYP_VAT  TYP,
    GAZ_CENA     WARTOSC,
    GAZ_NORMA    WARTOSC,

    SCIEKI_ROZL     IDENT, /* kanalizacja - cieki */
    SCIEKI_TYP_VAT  TYP,
    SCIEKI_CENA     WARTOSC,
    SCIEKI_NORMA    WARTOSC,

    NIECZ_ST_ROZL     IDENT, /* nieczystoci stae */
    NIECZ_ST_TYP_VAT  TYP,
    NIECZ_ST_CENA     WARTOSC,
    NIECZ_ST_NORMA    WARTOSC,

    NIECZ_PL_ROZL     IDENT, /* nieczystoci pynne */
    NIECZ_PL_TYP_VAT  TYP,
    NIECZ_PL_CENA     WARTOSC,
    NIECZ_PL_NORMA    WARTOSC,

    WZIMNA_LICZ_ROZL    IDENT,
    WZIMNA_LICZ_TYP_VAT TYP,
    WZIMNA_LICZ_CENA    WARTOSC,
    WZIMNA_LICZ_NORMA   WARTOSC,

    PODGRZANIE_RYCZ_ROZL    IDENT,
    PODGRZANIE_RYCZ_TYP_VAT TYP,
    PODGRZANIE_RYCZ_CENA    WARTOSC,

    PODGRZANIE_LICZ_ROZL    IDENT,
    PODGRZANIE_LICZ_TYP_VAT TYP,
    PODGRZANIE_LICZ_CENA    WARTOSC,

    WODA_ST_ROZL    IDENT,
    WODA_ST_TYP_VAT TYP,
    WODA_ST_CENA    WARTOSC,

    CO_LICZ_ROZL	IDENT,
    CO_LICZ_TYP_VAT	TYP,
    CO_LICZ_CENA	WARTOSC,
    CO_LICZ_NORMA	WARTOSC,

    SWIATLO_LICZ_ROZL     IDENT, /* energia elektryczna */
    SWIATLO_LICZ_TYP_VAT  TYP,
    SWIATLO_LICZ_CENA     WARTOSC,
    SWIATLO_LICZ_NORMA    WARTOSC,

    GAZ_LICZ_ROZL     IDENT, /* gaz */
    GAZ_LICZ_TYP_VAT  TYP,
    GAZ_LICZ_CENA     WARTOSC,
    GAZ_LICZ_NORMA    WARTOSC,

     WZIMNA_LICZ_BRUTTO_NETTO     TYP,
     WZIMNA_RYCZ_BRUTTO_NETTO     TYP,
     WCIEPLA_LICZ_BRUTTO_NETTO    TYP,
     WCIEPLA_RYCZ_BRUTTO_NETTO    TYP,
     PODGRZANIE_LICZ_BRUTTO_NETTO TYP,
     PODGRZANIE_RYCZ_BRUTTO_NETTO TYP,
     WODA_ST_BRUTTO_NETTO TYP,

     CO_LICZ_BRUTTO_NETTO         TYP,
     CO_RYCZ_BRUTTO_NETTO         TYP,
     SWIATLO_LICZ_BRUTTO_NETTO    TYP,
     SWIATLO_RYCZ_BRUTTO_NETTO    TYP,
     GAZ_LICZ_BRUTTO_NETTO        TYP,
     GAZ_RYCZ_BRUTTO_NETTO        TYP,
     SCIEKI_BRUTTO_NETTO          TYP,
     NIECZ_PL_BRUTTO_NETTO        TYP,
     NIECZ_ST_BRUTTO_NETTO        TYP,

     W_CO_KOSZT_ST_ROZL           IDENT,
     W_CO_KOSZT_ST_TYP_VAT        TYP,
     W_CO_KOSZT_ST_CENA           WARTOSC ,
     W_CO_KOSZT_ST_BRUTTO_NETTO   TYP,

     WZIMNA_LICZ_JM      JM,
     WZIMNA_RYCZ_JM      JM,
     WCIEPLA_LICZ_JM     JM,
     WCIEPLA_RYCZ_JM     JM,
     PODGRZANIE_LICZ_JM  JM,
     PODGRZANIE_RYCZ_JM  JM,
     WODA_ST_JM          JM,
     CO_LICZ_JM          JM,
     CO_RYCZ_JM          JM,
     SWIATLO_LICZ_JM     JM,
     SWIATLO_RYCZ_JM     JM,
     GAZ_LICZ_JM         JM,
     GAZ_RYCZ_JM         JM,
     SCIEKI_JM           JM,
     NIECZ_PL_JM         JM,
     NIECZ_ST_JM         JM,
     W_CO_KOSZT_ST_JM    JM,

     WADM_LICZ_ROZL         IDENT,
     WADM_LICZ_TYP_VAT      TYP,
     WADM_LICZ_CENA         WARTOSC,
     WADM_LICZ_NORMA        WARTOSC,
     WADM_LICZ_BRUTTO_NETTO TYP,
     WADM_LICZ_JM           JM,
     WADM_LICZ_PROCENT      WARTOSC,

     WADM_RYCZ_ROZL         IDENT,
     WADM_RYCZ_TYP_VAT      TYP,
     WADM_RYCZ_CENA         WARTOSC,
     WADM_RYCZ_NORMA        WARTOSC,
     WADM_RYCZ_BRUTTO_NETTO TYP,
     WADM_RYCZ_JM           JM,
     WADM_RYCZ_PROCENT      WARTOSC,

    NIECZ_ST_SEG_ROZL         IDENT,
    NIECZ_ST_SEG_TYP_VAT      TYP,
    NIECZ_ST_SEG_CENA         WARTOSC,
    NIECZ_ST_SEG_NORMA        WARTOSC,
    NIECZ_ST_SEG_BRUTTO_NETTO TYP,
    NIECZ_ST_SEG_JM           JM,

    UTWORZYL    KLUCZ,
    ZMIENIAL    KLUCZ,
    UTWORZONO   TIMESTAMP,
    ZMIENIANO   TIMESTAMP,

    PRIMARY KEY(KLUCZ, WERSJA));

CREATE INDEX ZASADY_MEDIOW_XOSIEDLE ON ZASADY_MEDIOW(OSIEDLE);
CREATE INDEX ZASADY_MEDIOW_XTYP_LOKALU ON ZASADY_MEDIOW(TYP_LOKALU);
CREATE INDEX ZASADY_MEDIOW_XTYP_ZASIEDLENIA ON ZASADY_MEDIOW(TYP_ZASIEDLENIA);

COMMIT WORK;

CREATE TABLE NORMY_MEDIOW
 (KLUCZ           KLUCZ NOT NULL,
  TYP             TYP NOT NULL,    /*B-budowla, P-pomieszczenie */
  DOTYCZY         KLUCZ NOT NULL,
  MEDIUM          IDENT NOT NULL,
  LICZNIK         TAKNIE NOT NULL,
  DATA_OD         TIMESTAMP NOT NULL,
  DATA_DO         TIMESTAMP,
  NORMA           WARTOSC,
  NORMA_DOD       WARTOSC,
  NORMA_LICZ_RYCZ WARTOSC,

  UTWORZYL      KLUCZ,
  ZMIENIAL      KLUCZ,
  UTWORZONO     TIMESTAMP,
  ZMIENIANO     TIMESTAMP,
  PRIMARY KEY (KLUCZ, TYP, DOTYCZY, MEDIUM, LICZNIK, DATA_OD));

COMMIT WORK;

CREATE INDEX NORMY_MEDIOW_XDOTYCZY ON NORMY_MEDIOW(DOTYCZY, TYP, MEDIUM);

/* ================ */

CREATE TABLE POJEMNIKI_NA_SMIECI
  (KLUCZ       KLUCZ NOT NULL,
   IDENT       IDENT,
   NAZWA       DUZY_OPIS,

   PRIMARY KEY(KLUCZ));

CREATE TABLE STAWKI_ZA_POJEMNIKI
  (KLUCZ        KLUCZ NOT NULL,
   POJEMNIK     KLUCZ NOT NULL,   /* odwolanie do POJEMNIKI_NA_SMIECI.KLUCZ */
   DATA_OD      TIMESTAMP,
   DATA_DO      TIMESTAMP,
   STAWKA       DOUBLE PRECISION,
   TYP_VAT      TYP,
   BRUTTO_NETTO TYP,

   PRIMARY KEY(KLUCZ),
   FOREIGN KEY(POJEMNIK) REFERENCES POJEMNIKI_NA_SMIECI(KLUCZ));


/*==========================================================================*/
/* Rozliczenia */
/*============ */

CREATE TABLE MIESIECZNE_CZYNSZE
   (KLUCZ          KLUCZ NOT NULL,
    LOKAL          KLUCZ NOT NULL,
    ZASIEDLENIE    KLUCZ,

    ZASIEDLENIE_KONTYNUACJA KLUCZ NOT NULL,

    ROK            INTEGER,
    MIESIAC        INTEGER,

    TYP_NAJEMCY    TYP,
    NAJEMCA        KLUCZ,
    DATA_PLATNOSCI TIMESTAMP,

    OPERACJA     TYP,    /* Naliczenie, Korekta licznika (naliczenia mediw), korekta Rczna (nieuywane), rozliczenia Inne */
    SPOSOB       TYP,    /* I-indywidualnie, G-grupowo (wg zuzycia w punkcie poboru), Istotne tylko przy operacji = 'K' */

    ROZLICZENIE_SKL KLUCZ,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ));

COMMIT WORK;

CREATE INDEX MIESIECZNE_CZYNSZE_NAJEMCA ON MIESIECZNE_CZYNSZE(NAJEMCA);
CREATE INDEX MIESIECZNE_CZYNSZE_XOKRES  ON MIESIECZNE_CZYNSZE(ROK, MIESIAC);
CREATE INDEX MIESIECZNE_CZYNSZE_XLOKAL  ON MIESIECZNE_CZYNSZE(LOKAL, ZASIEDLENIE, NAJEMCA, ROK, MIESIAC);
CREATE INDEX MIESIECZNE_CZYNSZE_XZASIEDLENIE  ON MIESIECZNE_CZYNSZE(ZASIEDLENIE);
CREATE INDEX MIESIECZNE_CZYNSZE_XKONTYNUACJA ON MIESIECZNE_CZYNSZE(ZASIEDLENIE_KONTYNUACJA);
CREATE INDEX ROZLICZENNAGOWEK     ON MIESIECZNE_CZYNSZE(ROZLICZENIE_SKL);



CREATE TABLE SKL_MIESIECZNYCH_CZYNSZOW
   (KLUCZ        KLUCZ NOT NULL,       /* Indywidualny klucz rekordu */
    MIES_CZYNSZ  KLUCZ NOT NULL,

    DATA_OD      TIMESTAMP,
    DATA_DO      TIMESTAMP,

    TYTUL        KLUCZ,

    KOREKTA        TYP,      /* K - korekta */
    DATA_KOR       TIMESTAMP,
    DATA_PLAT_KR   TIMESTAMP,

    LP_ROZLICZENIA INTEGER,  /* Tylko dla korekt */
    LP_ROZLICZENIA_WKLADU INTEGER,

    PRZYPIS      WARTOSC,    /* Brutto */
    VAT          WARTOSC,
    PROCENT_VAT  IDENT,
    NETTO        WARTOSC,
    CENA_NETTO   WARTOSC,
    NETTOBRUTTO  TAKNIE,

    WSKAZNIK_MIESIACA  WARTOSC, /* ??? CO TO JEST */

    LICZNIK      KLUCZ,

    CENA         WARTOSC,
    JM           JM,
    ILOSC        ILOSC,
	ILOSC_PELNY_MIESIAC  WARTOSC,

    OPIS         DUZA_NAZWA,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ),
    FOREIGN KEY(MIES_CZYNSZ) REFERENCES MIESIECZNE_CZYNSZE(KLUCZ));

CREATE INDEX SKL_MIES_CZYNSZOW_TYTUL    ON SKL_MIESIECZNYCH_CZYNSZOW(TYTUL);

COMMIT WORK;

CREATE TABLE FAKTURY_CZYNSZOWE
   (KLUCZ          KLUCZ NOT NULL,
    LOKAL          KLUCZ NOT NULL,
    ZASIEDLENIE    KLUCZ,

    ROK            INTEGER,      /* dotyczy okresu naliczenia */
    MIESIAC        INTEGER,
    OPERACJA       TYP,    /* Naliczenie, Korekta licznika - media, korekta Rczna, rozliczenia Inne */

    NR_DOKUM       INTEGER,
    ROK_WYST       INTEGER,      /* dotyczy miesiaca wystawienia */
    MIESIAC_WYST   INTEGER,
    OPIS           DUZY_OPIS,
    DATA_WYST      TIMESTAMP,
    DATA_SPRZED    TIMESTAMP,
    DATA_PLATNOSCI TIMESTAMP,
    PLATNOSC       TYP,   /* sposb patnoci - gotwka, przelew itp. */

    TYP_NAJEMCY    TYP,
    NAJEMCA        KLUCZ,

    NR_KOREKTY     INTEGER,

    WSK_NALICZEN         TAKNIE, /* wskaxniki zaznaczone przy tworzeniu faktur */
    WSK_KOR_OSOBNO       TAKNIE,
    WSK_KOR_LACZNIE      TAKNIE,
    WSK_ROZL_MEDIOW      TAKNIE,
    WSK_ROZL_SKLADNIKOW  TAKNIE,

    FAK_IL_NAL     INTEGER, /* faktycznie dolaczona ilosc pozycji okreslonego typu */
    FAK_IL_KOR     INTEGER,
    FAK_IL_RZ_MED  INTEGER,
    FAK_IL_RZ_SKL  INTEGER,
    FAK_IL_INNE    INTEGER,

    UWAGI        UWAGI,
    
    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ));

COMMIT WORK;

CREATE        INDEX FAKTURY_CZYNSZOWE_NAJEMCA     ON FAKTURY_CZYNSZOWE(NAJEMCA);
CREATE        INDEX FAKTURY_CZYNSZOWE_XLOKALOKRES ON FAKTURY_CZYNSZOWE(LOKAL, ZASIEDLENIE, ROK_WYST, MIESIAC_WYST, ROK, MIESIAC);
CREATE        INDEX FAKTURY_CZYNSZOWE_XNUMER      ON FAKTURY_CZYNSZOWE(ROK_WYST, NR_DOKUM, NR_KOREKTY);

CREATE TABLE SKL_FAKTUR_CZYNSZOWYCH
   (KLUCZ              KLUCZ NOT NULL,
    FAKTURA_CZYNSZOWA  KLUCZ NOT NULL,
    SKL_FAKTURY_KOREKTY  KLUCZ, /* klucz do pozycji korygujcej */

    LP       INTEGER,
    KOREKTA  INTEGER,    /* 0 - orygina, >0 - korekta */
    BYLOJEST TYP,        /* B - byo, J - jest */
    WEDLUGKOREKTY TYP,   /* przeniesienie z pola KOREKTA dla SKL_MIESIECZNYCH_CZYNSZOW */
    DOTYCZY   VARCHAR(1),/* N:naliczenia, K:kor.reczna, M:rozl.mediow, S:rozl.skladnikow */

    AUTOMAT TAKNIE NOT NULL,
    
    DATA_OD      TIMESTAMP,
    DATA_DO      TIMESTAMP,

    TYTUL        KLUCZ,  /* czynsz, domofon, media itp. */

    SWW          SYMBOL,
    OPIS         DUZA_NAZWA,
    PRZYPIS      WARTOSC,  /* brutto */
    VAT          WARTOSC,
    PROCENT_VAT  IDENT,
    NETTO        WARTOSC,

    LICZNIK      KLUCZ,

    CENA         WARTOSC,
    CENA_NETTO   WARTOSC,
    JM           JM,
    ILOSC        ILOSC,
	ILOSC_PELNY_MIESIAC  WARTOSC,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ),
    FOREIGN KEY(FAKTURA_CZYNSZOWA) REFERENCES FAKTURY_CZYNSZOWE(KLUCZ));

COMMIT WORK;

CREATE TABLE NALICZENIA_DO_FAKTUR
  (MIES_CZYNSZ             KLUCZ NOT NULL,
   SKL_MIES_CZYNSZ         KLUCZ NOT NULL,
   FAKTURA_CZYNSZOWA       KLUCZ NOT NULL,
   SKL_FAKTUR_CZYNSZOWYCH  KLUCZ NOT NULL,

   FOREIGN KEY(MIES_CZYNSZ)            REFERENCES MIESIECZNE_CZYNSZE(KLUCZ),
   FOREIGN KEY(SKL_MIES_CZYNSZ)        REFERENCES SKL_MIESIECZNYCH_CZYNSZOW(KLUCZ),
   FOREIGN KEY(FAKTURA_CZYNSZOWA)      REFERENCES FAKTURY_CZYNSZOWE(KLUCZ),
   FOREIGN KEY(SKL_FAKTUR_CZYNSZOWYCH) REFERENCES SKL_FAKTUR_CZYNSZOWYCH(KLUCZ)
);


/*==========================================================================*/

CREATE TABLE NAGLOWEK_ROZLICZEN_SKLADNIKOW
  (KLUCZ               KLUCZ NOT NULL,

   OSIEDLE             KLUCZ,
   RODZAJ_LOKALU       OPIS,
   RODZAJ_ZASIEDLENIA  OPIS,
   KLATKA              DIDENT,
   PIETRO_OD           INTEGER,
   PIETRO_DO           INTEGER,
   IGNORUJ_POZA_WSPOLNOTA TAKNIE,

   ROK                 INTEGER NOT NULL, /* OKRES W SALDACH */
   MIESIAC             INTEGER NOT NULL,

   SKLADNIK            INTEGER NOT NULL,

   ROZLROK_OD          INTEGER NOT NULL,
   ROZLMIESIAC_OD      INTEGER NOT NULL,
   ROZLROK_DO          INTEGER NOT NULL,
   ROZLMIESIAC_DO      INTEGER NOT NULL,

   DATA_PLATNOSCI      TIMESTAMP,
   DATA_WYSTAWIENIA    TIMESTAMP,
   PLATNIK             IDENT,  /* sposob pobrania platnika : z m-ca rozliczenia, z daty platnosci, z w/w daty, z koncowej daty rozliczenia... */

   TYLKO_Z_KONCA_OKRESU       TAKNIE,
   WARUNEKSQL   PARAMETRY,

   CENA           WARTOSC,
   PROC_VAT       IDENT,
   JM             JM,
   SPOSOB         IDENT,
   PROPORCJA      IDENT,       /* il.osob, powierzchnia */
   PROCENT        WARTOSC,
   MEDIUM_ZALICZEK  IDENT,
   POWTORNEROZLICZENIE TAKNIE,
   BRUTTO_NETTO   TAKNIE,

   OKRES_Z_MEDIUM   TAKNIE,

   UTWORZYL       KLUCZ,
   ZMIENIAL       KLUCZ,
   UTWORZONO      TIMESTAMP,
   ZMIENIANO      TIMESTAMP,

   PRIMARY KEY(KLUCZ));

CREATE TABLE BUDOWLE_ROZLICZEN_SKLADNIKOW
  (NAGLOWEK   KLUCZ NOT NULL,
   BUDOWLA    KLUCZ NOT NULL,
   STAWKA     WARTOSC,
   PROCENT_ZALICZKI WARTOSC,

   PRIMARY KEY(NAGLOWEK, BUDOWLA),
   FOREIGN KEY(NAGLOWEK) REFERENCES NAGLOWEK_ROZLICZEN_SKLADNIKOW(KLUCZ));

/*==========================================================================*/
/* Dodatki mieszkaniowe */
/* ==================== */

CREATE TABLE DODATKI_MIESZKANIOWE
   (KLUCZ        KLUCZ NOT NULL,

    ZASIEDLENIE  KLUCZ,

    NR_DECYZJI   DUZY_SYMBOL,
    ROK          INTEGER,
    MIESIAC      INTEGER,
    ROK_WAZNOSCI      INTEGER,       /* Moe by NULL */
    MIESIAC_WAZNOSCI  INTEGER,       /* Moe by NULL */

    KWOTA        WARTOSC,

    UTWORZYL     KLUCZ,
    ZMIENIAL     KLUCZ,
    UTWORZONO    TIMESTAMP,
    ZMIENIANO    TIMESTAMP,

    PRIMARY KEY(KLUCZ));

COMMIT WORK;

CREATE        INDEX DODATKI_MIESZK_XZASIEDLENIE       ON DODATKI_MIESZKANIOWE(ZASIEDLENIE);

CREATE TABLE ROZLICZENIE_DODATKOW_MIESZK
  (DODATEK    KLUCZ NOT NULL,
   NALICZENIE KLUCZ NOT NULL,

   PRIMARY KEY(DODATEK, NALICZENIE),
   FOREIGN KEY(DODATEK) REFERENCES DODATKI_MIESZKANIOWE(KLUCZ),
   FOREIGN KEY(NALICZENIE) REFERENCES MIESIECZNE_CZYNSZE(KLUCZ));
   
/*==========================================================================*/
/* Dokumenty kasy/banku - czynszowe */

CREATE TABLE DEFINICJEKASYBANKU
       (KLUCZ           KLUCZ NOT NULL,
        TYP             TYP NOT NULL,   /* Kasa, Bank, Inne */
        ID              IDENT,
        NAZWA           DUZA_NAZWA,
		ODEJMOWAC_VAT   TAKNIE,

        BLOKADA         TAKNIE,

        PODMIOT_FINANSOWY KLUCZ,

        WLT_KRAJ        IDENT,

        DANE            PARAMETRY,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ) );

SET TERM ^ ;

CREATE TRIGGER CREATE_DEFINICJEKASYBANKU FOR DEFINICJEKASYBANKU
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DEFINICJEDOKKSIEGOWYCH_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^


CREATE TABLE KASABANK
       (KLUCZ           KLUCZ NOT NULL,
        TYP             TYP NOT NULL,         /* Kasa, Bank, Inne */

        DATA_WYST       TIMESTAMP NOT NULL,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        DEFINICJA       KLUCZ NOT NULL,
        NUMER           INTEGER,

        WLT_KRAJ        IDENT,       /* Przepisywane z definicji */
        WLT_DATA        TIMESTAMP,
        WLT_KURS        ILOSC,
        WLT_BANK        DUZA_NAZWA,
        WLT_NUMER       SYMBOL,

        ZATWIERDZIL     KLUCZ,

        BO              WARTOSC,
        WPLATY          WARTOSC,
        WYPLATY         WARTOSC,

        BO_VAT          WARTOSC,
        WPLATY_VAT      WARTOSC,
        WYPLATY_VAT     WARTOSC,

        WLT_BO          WARTOSC,
        WLT_WPLATY      WARTOSC,
        WLT_WYPLATY     WARTOSC,

        DANE            PARAMETRY,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ),
        FOREIGN KEY(DEFINICJA) REFERENCES DEFINICJEKASYBANKU(KLUCZ),
        FOREIGN KEY(ZATWIERDZIL) REFERENCES OSOBY(KLUCZ));

CREATE INDEX KASABANK_XDATA ON KASABANK(DATA_WYST);
CREATE INDEX KASABANK_XNR   ON KASABANK(ROK, NUMER);


SET TERM ^ ;
CREATE TRIGGER CREATE_KASABANK FOR KASABANK
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DOKUMENTYKSIEGOWE_GEN, 1);
END ^

COMMIT WORK ^
SET TERM ; ^


COMMIT WORK;

CREATE TABLE DOKUMENTYPOZACZYNSZOWE
       (ID              IDENT NOT NULL,
        TYP             IDENT,          /* WPLata, WYPlata, INNe */
        RODZAJ          TYP,            /* Kasa, Bank, (/)kasa/bank, Inne  (K, B, / dotyczy wpat i wypat)*/
        NAZWA           DUZA_NAZWA,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(ID));

COMMIT WORK;

/* --- */

CREATE TABLE SPRAWY_SADOWE
       (KLUCZ           KLUCZ NOT NULL,
        DATA_POZWU      TIMESTAMP,
        NR_POZWU        OPIS,
        DATA_SPRAWY     TIMESTAMP,
        NR_SPRAWY       OPIS,

        DANE            UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_SPRAWY_SADOWE FOR SPRAWY_SADOWE
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

SET TERM ; ^

COMMIT WORK;

/* Rozliczenia rzne, w tym pozycje w kasie/banku UWAGA : zmiany robic takze w ROZLICZENIA_ARCH */

CREATE TABLE ROZLICZENIA
       (DOKUMENT        KLUCZ NOT NULL,       /* Oryginalny dokument moe by z rnych */
                                              /* tabel (dla BO (import) <0), wszystkie tabele pobieraj klucze */
                                              /* z generatora dla dokumentw ksigowych */
        LP              INTEGER NOT NULL,
        TYP             TYP NOT NULL,         /* Kasa, Bank, Inne, Czynsze (naliczenia),
                                                 F - przeksigowania faktur, Windykacja, bilans Otwarcia / korekty
                                                 X - na chwile roboczo przy korektach faktur czynszowych,
                                                 A - przeniesione do archiwum */

        PODTYP          IDENT NOT NULL,       /* kasa, bank : WPLaty, WYPlaty */
                                              /*              IWP, IWY - inne wpaty */
                                              /* Czynsze : */
                                              /* NAL - naliczenie */
                                              /* DDM - Dodatki mieszkaniowe, take w banku  */
                                              /* KOR - korekta */
                                              /* ZWR - zwrot */
                                              /* ARC - archiwum */

        RODZAJ          DIDENT NOT NULL,      /* dla czynszy : C_XXX, gdzie XXX */
                                              /* CZM - czynsz miesiczny */
                                              /* FKT - faktury czynszowe - nowy system */
                                              /* WCZ - udzia czonkowski */
                                              /* WBD - wkad budowlany */
                                              /* WMS - wkad mieszkaniowy */
                                              /* DWJ - Do wyjanienia */
                                              /* W_XXX - inne wpaty */
                                              /* Y_XXX - inne wypaty */
                                              /* I_XXX - inne obroty */

                                              /* DOCZY OBSUG FAKTUR - PODCZENIE PRZEKSIGOWANIA
                                                 Z ROZRACUNKW CZYNSZOWYCH NA FAKTUR PRZY WYSTAWIANIU FAKTURY
                                                 I ROZRACHUNKI Z SYMBOLEM FAKTURY  */


        NALICZENIE      TYP,                  /* Tylko dla C_CZM - przy ustawionych warunkach */
                                              /* F - fund.remont., E - eksploatacja, K - us. komunalne (media) */

        KLAS_WKL        IDENT,                /* Klasyfikacja wkadw wg sownika */
        KLUCZ_OBCY      KLUCZ NOT NULL,       /* dla czynszy - klucz lokalu */
        LP_WINDYKACJI   INTEGER,              /* Lp pozycji windykacji - dla pozycji utworzonych z windykacji*/
        ZAMKNIETE       TAKNIE,               /* T - rozliczone narastajco */

        SPRAWA_SADOWA   KLUCZ,

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        NAL_ROK         INTEGER,              /* wskazanie okresu naliczenia dla zaplaty */
        NAL_MIESIAC     INTEGER,

        KLUCZ           KLUCZ NOT NULL,       /* Dodatkowy klucz identyfikujcy rekord*/
        KLUCZ_PRT       KLUCZ,                /* Odwolanie do anulowanej raty PRT z pozycji anulujacej */

        NUMER           INTEGER,              /* KP/KW lub lp dziaania windykacyjnego*/
                                              /* to ostatnie take w symbolu */

        PODMIOT         INTEGER NOT NULL,     /* Podmiot finansowy - firma, 0 - gowny podmiot */

        DATA_WYST       TIMESTAMP,
        DATA_PLAT       TIMESTAMP,
        DATA_ZAPLATY    TIMESTAMP,

        TYPSALDA        TYP,           /* Biece, Postpowanie sdowe, Wyrok sdowy (zasdzone), koMornik */
        TYPPOZYCJI      TYP,           /* Naleno, Odsetki, Koszty windykacji */
                                       /* O, K - s rozrniane przy dopisywaniu do salda */
        SALDO           KLUCZ,

        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        SYMBOL          DUZA_NAZWA,    /* Symbol dokumentu - przy czynszowych saldach jest zawsze opisem rodzaju - oprcz faktur */

        TECHNICZNE      TYP,           /* Uywane przy zamykaniu sald */
        WINDYKACJA      INTEGER,       /* Take uywane tylko przy zamykaniu sald i windykacji */
                                       /* pole Dokument odpowiada take kluczowi Windykacji dla pozycji windykacyjnych */
        KWOTA           WARTOSC,       /* Pozycja wypeniana w Kasie/Banku */
                                       /* automatycznie wypenia Winien/ma */
		VAT             WARTOSC,       /* VAT dla split payment */

        WINIEN          WARTOSC,
        MA              WARTOSC,

        WINIEN_VAT      WARTOSC,
        MA_VAT          WARTOSC,

        WLT_KRAJ        IDENT,         /* przepisywane z nagwka dokumentu */
        WLT_WINIEN      WARTOSC,
        WLT_MA          WARTOSC,

        KLUCZE          KLUCZEKONT,    /* dla dekretacji finansowych */

        OPIS            VARCHAR(200) CHARACTER SET DOS852 COLLATE PDOX_PLK,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        FOREIGN KEY(SPRAWA_SADOWA) REFERENCES SPRAWY_SADOWE(KLUCZ),
        PRIMARY KEY(DOKUMENT, LP, TYP));

CREATE INDEX ROZLICZENIA_XDOK ON ROZLICZENIA(ROK, DOKUMENT, LP);
CREATE INDEX ROZLICZENIA_XSALDO ON ROZLICZENIA(SALDO);
CREATE INDEX ROZLICZENIA_XKLUCZ ON ROZLICZENIA(KLUCZ);
CREATE INDEX ROZLICZENIA_XLOKAL ON ROZLICZENIA(KLUCZ_OBCY);
CREATE INDEX ROZLICZENIA_XDOTYCZY ON ROZLICZENIA(DOTYCZY, TYPDOTYCZY, SYMBOL);
CREATE INDEX ROZLICZENIA_XDATADOTYCZY ON ROZLICZENIA(DATA_WYST, DOTYCZY, TYPDOTYCZY, SYMBOL);

COMMIT WORK;

/* tylko dla SYSDBA */

CREATE TABLE ROZLICZENIA_ARCH
       (DOKUMENT        KLUCZ NOT NULL,       /* Oryginalny dokument moe by z rnych */
        LP              INTEGER NOT NULL,
        TYP             TYP NOT NULL,         /* Kasa, Bank, Inne, Czynsze (naliczenia), */
        PODTYP          IDENT NOT NULL,       /* kasa, bank : WPLaty, WYPlaty */
        RODZAJ          DIDENT NOT NULL,      /* dla czynszy : C_XXX, gdzie XXX */
        NALICZENIE      TYP,                  /* Tylko dla C_CZM - przy ustawionych warunkach */
        KLAS_WKL        IDENT,                /* Klasyfikacja wkadw wg sownika */
        KLUCZ_OBCY      KLUCZ NOT NULL,       /* dla czynszy - klucz lokalu */
        LP_WINDYKACJI   INTEGER,              /* Lp pozycji windykacji - dla pozycji utworzonych z windykacji*/
        ZAMKNIETE       TAKNIE,               /* T - rozliczone narastajco */
        SPRAWA_SADOWA   KLUCZ,
        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,
        NAL_ROK         INTEGER,              /* wskazanie okresu naliczenia dla zaplaty */
        NAL_MIESIAC     INTEGER,
        KLUCZ           KLUCZ NOT NULL,       /* Dodatkowy klucz identyfikujcy rekord*/
        KLUCZ_PRT       KLUCZ,                /* Odwolanie do anulowanej raty PRT z pozycji anulujacej */
        NUMER           INTEGER,              /* KP/KW lub lp dziaania windykacyjnego*/
        PODMIOT         INTEGER NOT NULL,     /* Podmiot finansowy - firma, 0 - gowny podmiot */
        DATA_WYST       TIMESTAMP,
        DATA_PLAT       TIMESTAMP,
        DATA_ZAPLATY    TIMESTAMP,
        TYPSALDA        TYP,           /* Biece, Postpowanie sdowe, Wyrok sdowy (zasdzone), koMornik */
        TYPPOZYCJI      TYP,           /* Naleno, Odsetki, Koszty windykacji */
        SALDO           KLUCZ,
        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        SYMBOL          DUZA_NAZWA, 
        TECHNICZNE      TYP,           /* Uywane przy zamykaniu sald */
        WINDYKACJA      INTEGER,       /* Take uywane tylko przy zamykaniu sald i windykacji */
        KWOTA           WARTOSC,       /* Pozycja wypeniana w Kasie/Banku */
		VAT             WARTOSC,       /* VAT dla split payment */
        WINIEN          WARTOSC,
        MA              WARTOSC,
        WINIEN_VAT      WARTOSC,
        MA_VAT          WARTOSC,
        WLT_KRAJ        IDENT,         /* przepisywane z nagwka dokumentu */
        WLT_WINIEN      WARTOSC,
        WLT_MA          WARTOSC,
        KLUCZE          KLUCZEKONT,    /* dla dekretacji finansowych */
        OPIS            VARCHAR(200) CHARACTER SET DOS852 COLLATE PDOX_PLK,
        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DOKUMENT, LP, TYP));

CREATE INDEX ROZLICZENIA_ARCH_XDOTYCZY ON ROZLICZENIA_ARCH(DOTYCZY, TYPDOTYCZY);
CREATE INDEX ROZLICZENIA_ARCH_XDOK ON ROZLICZENIA_ARCH(ROK, DOKUMENT, LP);
CREATE INDEX ROZLICZENIA_ARCH_XSALDO ON ROZLICZENIA_ARCH(SALDO);


/* Salda rozlicze */

CREATE TABLE SALDA_ROZLICZEN
       (KLUCZ           KLUCZ NOT NULL,

        RODZAJ          DIDENT NOT NULL,      /* dla czynszy : C_XXX, gdzie XXX..., F_XXX - systemowe rozrachunki */
        KLUCZ_OBCY      KLUCZ NOT NULL,       /* dla czynszy - klucz lokalu */

        WINDYKACJA      KLUCZ,                /* klucz dokumentu gwnego windykacji */

        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,
        SYMBOL          DUZA_NAZWA,    /* Symbol dowodu */
        ROZLICZONE      TAKNIE NOT NULL,
        TYPSALDA        TYP,           /* Biece, Postpowanie sdowe, Wyrok sdowy (zasdzone), koMornik */

        WINIEN          WARTOSC,       /* obroty */
        MA              WARTOSC,
        SWINIEN         WARTOSC,       /* salda */
        SMA             WARTOSC,
        ILOSC           INTEGER,

        ODSETKI_WN      WARTOSC,
        ODSETKI_MA      WARTOSC,
        ODSETKI_ROZL    TAKNIE,        /* zawsze wypenione T/N */

        KOSZTY_WN       WARTOSC,
        KOSZTY_MA       WARTOSC,
        KOSZTY_ROZL     TAKNIE,        /* zawsze wypenione T/N */

        PODMIOT         INTEGER NOT NULL,     /* Podmiot finansowy - firma, 0 - gowny podmiot  */
        WLT_KRAJ        IDENT,    /* Dla sald walutowych - sluzy do przechowywania */

        PRIMARY KEY(KLUCZ));

CREATE INDEX SALDAR_XDOTYCZY ON SALDA_ROZLICZEN(DOTYCZY, TYPDOTYCZY, SYMBOL);
CREATE INDEX SALDAR_XWINDYKACJA ON SALDA_ROZLICZEN(WINDYKACJA);
CREATE INDEX SALDAR_XKLUCZ_OBCY ON SALDA_ROZLICZEN(KLUCZ_OBCY);

COMMIT WORK;

/* Procedury obslugi dat dokumentw sald */

SET TERM ^ ;

CREATE PROCEDURE DATY_DOK_CZYNSZOWYCH(
  SALDO       INTEGER,
  NADZIEN     TIMESTAMP)
RETURNS(
  N_DATA_WYST  TIMESTAMP,
  N_DATA_PLAT  TIMESTAMP,
  K_DATA_WYST  TIMESTAMP,
  K_DATA_PLAT  TIMESTAMP,
  O_DATA_WYST  TIMESTAMP,
  O_DATA_PLAT  TIMESTAMP)
AS
DECLARE VARIABLE WINIEN DOUBLE PRECISION;
DECLARE VARIABLE MA DOUBLE PRECISION;

DECLARE VARIABLE OWINIEN DOUBLE PRECISION;
DECLARE VARIABLE OMA DOUBLE PRECISION;

DECLARE VARIABLE KWINIEN DOUBLE PRECISION;
DECLARE VARIABLE KMA DOUBLE PRECISION;

DECLARE VARIABLE VWINIEN DOUBLE PRECISION;
DECLARE VARIABLE VTYPPOZYCJI VARCHAR(1);
DECLARE VARIABLE V_DATA_WYST TIMESTAMP;
DECLARE VARIABLE V_DATA_PLAT TIMESTAMP;

BEGIN
  N_DATA_WYST = NULL;
  N_DATA_PLAT = NULL;
  K_DATA_WYST = NULL;
  K_DATA_PLAT = NULL;
  O_DATA_WYST = NULL;
  O_DATA_PLAT = NULL;

  WINIEN = 0;
  OWINIEN = 0;
  KWINIEN = 0;

  /* Sumy zapat */

  SELECT SUM(MA)
  FROM ROZLICZENIA
  WHERE SALDO = :SALDO AND MA <> 0 AND TYPPOZYCJI = 'N' AND DATA_WYST <= :NADZIEN
  INTO :MA;

  IF (:MA IS NULL)
  THEN MA = 0;

  SELECT SUM(MA)
  FROM ROZLICZENIA
  WHERE SALDO = :SALDO AND MA <> 0 AND TYPPOZYCJI = 'O' AND DATA_WYST <= :NADZIEN
  INTO :OMA;

  IF (:OMA IS NULL)
  THEN OMA = 0;

  SELECT SUM(MA)
  FROM ROZLICZENIA
  WHERE SALDO = :SALDO AND MA <> 0 AND TYPPOZYCJI = 'K' AND DATA_WYST <= :NADZIEN
  INTO :KMA;

  IF (:KMA IS NULL)
  THEN KMA = 0;

  /* Sumy zapat */

  FOR SELECT TYPPOZYCJI, DATA_WYST, DATA_PLAT, WINIEN
  FROM ROZLICZENIA
  WHERE SALDO = :SALDO AND WINIEN <> 0 AND DATA_WYST <= :NADZIEN
  ORDER BY DATA_PLAT, DATA_WYST, WINIEN       /* WINIEN - wyksigowania na czerwono najpierw */
  INTO :VTYPPOZYCJI, :V_DATA_WYST, :V_DATA_PLAT, :VWINIEN
  DO BEGIN
    IF (:VTYPPOZYCJI = 'O')
    THEN BEGIN
      OWINIEN = :OWINIEN + :VWINIEN;
      IF (O_DATA_WYST IS NULL AND (:OWINIEN - 0.001) > :OMA)
      THEN BEGIN
        O_DATA_WYST = :V_DATA_WYST;
        O_DATA_PLAT = :V_DATA_PLAT;
      END
    END
    ELSE IF (:VTYPPOZYCJI = 'K')
    THEN BEGIN
      KWINIEN = :KWINIEN + :VWINIEN;
      IF (K_DATA_WYST IS NULL AND (:KWINIEN - 0.001) > :KMA)
      THEN BEGIN
        K_DATA_WYST = :V_DATA_WYST;
        K_DATA_PLAT = :V_DATA_PLAT;
      END
    END
    ELSE BEGIN
      WINIEN = :WINIEN + :VWINIEN;
      IF (N_DATA_WYST IS NULL AND (:WINIEN - 0.001) > :MA)
      THEN BEGIN
        N_DATA_WYST = :V_DATA_WYST;
        N_DATA_PLAT = :V_DATA_PLAT;
      END
    END
  END

  SUSPEND;
END^

COMMIT WORK ^

SET TERM ; ^


/*
  Test zalegoci statystycznej dokumentw czynszowych
  w stosunku do miesicznch nalicze okrelonego miesica - w wyniku
  ilo miesicy zalegoci (tylko biece podstawowe)
*/

SET TERM ^ ;

CREATE PROCEDURE ZALEGLOSC_STAT_CZYNSZU(
  SALDO       INTEGER,
  ROK         INTEGER, /* Rok nalicze czynszowych */
  MIESIAC     INTEGER, /* Miesic nalicze czynszowych */
  NADZIEN     TIMESTAMP)
RETURNS(
  ZALEGLOSC  DOUBLE PRECISION)
AS
DECLARE VARIABLE NALICZENIA DOUBLE PRECISION;
DECLARE VARIABLE NALEZNOSCI DOUBLE PRECISION;
BEGIN
  NALICZENIA = 0;
  NALEZNOSCI = 0;
  ZALEGLOSC = 0;

  SELECT SUM(R.WINIEN)
  FROM ROZLICZENIA R, MIESIECZNE_CZYNSZE M
  WHERE
    R.DOKUMENT = M.KLUCZ AND M.OPERACJA = 'N' AND /* Tylko naliczenia bez korekt i rozl.mediw */
    R.SALDO = :SALDO AND R.ROK = :ROK AND R.MIESIAC = :MIESIAC AND
    R.TYPPOZYCJI = 'N' AND R.TYPSALDA = 'B' AND
    R.TYP = 'C' AND R.RODZAJ = 'C_CZM' AND R.WINIEN <> 0
  INTO :NALICZENIA;

  SELECT SUM(WINIEN-MA)
  FROM ROZLICZENIA
  WHERE
    SALDO = :SALDO AND DATA_WYST <= :NADZIEN AND
    TYPPOZYCJI = 'N' AND TYPSALDA = 'B' AND RODZAJ = 'C_CZM'
  INTO :NALEZNOSCI;

  IF ((:NALICZENIA > 0) AND (:NALEZNOSCI > 0))
  THEN ZALEGLOSC = :NALEZNOSCI / :NALICZENIA;

  SUSPEND;
END^

COMMIT WORK ^

SET TERM ; ^


/*
  NOWY Test zaleglosci statystycznej dokumentow czynszowych
  w stosunku do miesiecznch naliczen - w wyniku
  ilosc miesiecy zaleglosci (tylko biezace podstawowe)
  NaRok i NaMiesiac musza byc zgodne z NaDzien
*/

SET TERM ^ ;

CREATE PROCEDURE ZALEGLOSC_STAT_CZYNSZU_NOWE(
  LOKAL       INTEGER,
  DOTYCZY     INTEGER,
  TYPDOTYCZY  VARCHAR(1),
  NADZIEN     TIMESTAMP,
  NAROK       INTEGER,
  NAMIESIAC   INTEGER)
RETURNS(
  ZALEGLOSC        DOUBLE PRECISION,
  NALICZENIA       DOUBLE PRECISION,
  NALEZNOSCI       DOUBLE PRECISION,
  ROKNALICZEN      INTEGER,
  MIESIACNALICZEN  INTEGER
  )
AS
DECLARE VARIABLE WSKAZNIK INTEGER;
DECLARE VARIABLE VMAX INTEGER;
BEGIN
  NALICZENIA = 0;
  NALEZNOSCI = 0;
  ZALEGLOSC = 0;
  ROKNALICZEN = 0;
  MIESIACNALICZEN = 0;
  WSKAZNIK = :NAROK * 100 + :NAMIESIAC;

  /* Wyznaczenie okresu ostatnich naliczen */

  SELECT MAX(Rok * 100 + Miesiac)
  FROM Miesieczne_czynsze
  WHERE
    LOKAL = :LOKAL AND NAJEMCA = :DOTYCZY AND TYP_NAJEMCY = :TYPDOTYCZY AND
    OPERACJA = 'N' AND                  /* Tylko naliczenia bez korekt i rozl.mediow */
    (ROK * 100 + MIESIAC) <= :WSKAZNIK
  INTO :VMAX;

  IF (:VMAX > 0)
  THEN BEGIN

    /* Wyznaczenie naliczen */

    SELECT SUM(S.PRZYPIS), M.ROK, M.MIESIAC
    FROM MIESIECZNE_CZYNSZE M, SKL_MIESIECZNYCH_CZYNSZOW S
    WHERE
      S.MIES_CZYNSZ = M.KLUCZ AND M.OPERACJA = 'N' AND /* Tylko naliczenia bez korekt i rozl.mediow */
      M.LOKAL = :LOKAL AND M.NAJEMCA = :DOTYCZY AND M.TYP_NAJEMCY = :TYPDOTYCZY AND
      (M.ROK * 100 + M.MIESIAC) = :VMAX AND
      (S.KOREKTA IS NULL OR S.KOREKTA <> 'K')
    GROUP BY M.ROK, M.MIESIAC
    INTO :NALICZENIA, :ROKNALICZEN, :MIESIACNALICZEN;

    IF (:NALICZENIA > 0)
    THEN BEGIN

      /* Wyznaczenie salda */

      SELECT SUM(WINIEN-MA)
      FROM ROZLICZENIA
      WHERE
        KLUCZ_OBCY = :LOKAL AND DOTYCZY = :DOTYCZY AND TYPDOTYCZY = :TYPDOTYCZY AND
        TYPPOZYCJI = 'N' AND TYPSALDA = 'B' AND
        RODZAJ = 'C_CZM' AND DATA_WYST <= :NADZIEN
      INTO :NALEZNOSCI;

      ZALEGLOSC = :NALEZNOSCI / :NALICZENIA;
    END
  END

  SUSPEND;
END^

COMMIT WORK ^

SET TERM ; ^


/*
  NOWY Test zaleglosci statystycznej dokumentow czynszowych
  w stosunku do miesiecznch naliczen - w wyniku
  ilosc miesiecy zaleglosci (wedlug rodzaju)
  NaRok i NaMiesiac musza byc zgodne z NaDzien
*/

SET TERM ^ ;

CREATE PROCEDURE ZALEGLOSC_STAT_CZYNSZU_RODZAJ(
  LOKAL       INTEGER,
  DOTYCZY     INTEGER,
  TYPDOTYCZY  VARCHAR(1),
  RODZAJ      VARCHAR(5),
  NADZIEN     TIMESTAMP,
  NAROK       INTEGER,
  NAMIESIAC   INTEGER)
RETURNS(
  ZALEGLOSC        DOUBLE PRECISION,
  NALICZENIA       DOUBLE PRECISION,
  NALEZNOSCI       DOUBLE PRECISION,
  ROKNALICZEN      INTEGER,
  MIESIACNALICZEN  INTEGER
  )
AS
DECLARE VARIABLE WSKAZNIK INTEGER;
DECLARE VARIABLE VMAX INTEGER;
BEGIN
  NALICZENIA = 0;
  NALEZNOSCI = 0;
  ZALEGLOSC = 0;
  ROKNALICZEN = 0;
  MIESIACNALICZEN = 0;
  WSKAZNIK = :NAROK * 100 + :NAMIESIAC;

  /* Wyznaczenie okresu ostatnich naliczen */

  SELECT MAX(Rok * 100 + Miesiac)
  FROM Miesieczne_czynsze
  WHERE
    LOKAL = :LOKAL AND NAJEMCA = :DOTYCZY AND TYP_NAJEMCY = :TYPDOTYCZY AND
    OPERACJA = 'N' AND                  /* Tylko naliczenia bez korekt i rozl.mediow */
    (ROK * 100 + MIESIAC) <= :WSKAZNIK
  INTO :VMAX;

  IF (:VMAX > 0)
  THEN BEGIN

    /* Wyznaczenie naliczen */

    SELECT SUM(S.PRZYPIS), M.ROK, M.MIESIAC
    FROM MIESIECZNE_CZYNSZE M, SKL_MIESIECZNYCH_CZYNSZOW S
    WHERE
      S.MIES_CZYNSZ = M.KLUCZ AND M.OPERACJA = 'N' AND /* Tylko naliczenia bez korekt i rozl.mediow */
      M.LOKAL = :LOKAL AND M.NAJEMCA = :DOTYCZY AND M.TYP_NAJEMCY = :TYPDOTYCZY AND
      (M.ROK * 100 + M.MIESIAC) = :VMAX AND
      (S.KOREKTA IS NULL OR S.KOREKTA <> 'K')
    GROUP BY M.ROK, M.MIESIAC
    INTO :NALICZENIA, :ROKNALICZEN, :MIESIACNALICZEN;

    IF (:NALICZENIA > 0)
    THEN BEGIN

      /* Wyznaczenie salda */

      SELECT SUM(WINIEN-MA)
      FROM ROZLICZENIA
      WHERE
        KLUCZ_OBCY = :LOKAL AND DOTYCZY = :DOTYCZY AND TYPDOTYCZY = :TYPDOTYCZY AND
        TYPPOZYCJI = 'N' AND TYPSALDA = 'B' AND
        RODZAJ = :RODZAJ AND DATA_WYST <= :NADZIEN
      INTO :NALEZNOSCI;

      ZALEGLOSC = :NALEZNOSCI / :NALICZENIA;
    END
  END

  SUSPEND;
END^

COMMIT WORK ^

SET TERM ; ^



/* Procedura obslugi sald */

SET TERM ^ ;

CREATE PROCEDURE DAJ_SALDOR(
  PKLUCZ       INTEGER,                /* Dla istniejcego salda */
  PTYPDOTYCZY  VARCHAR(1),
  PDOTYCZY     INTEGER,
  PRODZAJ      VARCHAR(5),
  PKLUCZ_OBCY  INTEGER,
  PSYMBOL      VARCHAR(40),
  PTYPSALDA    VARCHAR(1),             /* Biece, Postpowanie sdowe, Wyrok sdowy (zasdzone), koMornik */
  PTYPPOZYCJI  VARCHAR(1),             /* Naleno, Odsetki, Koszty windykacji, Raty ugody, Post.sd., Wyrok, koMornik */
  PPODMIOT     INTEGER,
  PILOSC       INTEGER,                /* 1 : nowe, 0 : zmiana wartosci, -1 : usuwanie */
  PWINIEN      DOUBLE PRECISION,       /* Przyrost WN */
  PMA          DOUBLE PRECISION,       /* Przyrost MA */
  WLT_KRAJ     VARCHAR(3))             /* Przekazanie do przechowania - nie jest kontrolowane*/
RETURNS(
  KLUCZ_SALDA  INTEGER)
AS
DECLARE VARIABLE ILOSC INTEGER;
DECLARE VARIABLE SWINIEN DOUBLE PRECISION;
DECLARE VARIABLE SMA DOUBLE PRECISION;
DECLARE VARIABLE SSWINIEN DOUBLE PRECISION;
DECLARE VARIABLE SSMA DOUBLE PRECISION;
DECLARE VARIABLE ROZLICZONE VARCHAR(1);
DECLARE VARIABLE OWINIEN DOUBLE PRECISION;
DECLARE VARIABLE OMA DOUBLE PRECISION;
DECLARE VARIABLE ODSETKI_ROZL VARCHAR(1);
DECLARE VARIABLE KWINIEN DOUBLE PRECISION;
DECLARE VARIABLE KMA DOUBLE PRECISION;
DECLARE VARIABLE KOSZTY_ROZL VARCHAR(1);
BEGIN
  KLUCZ_SALDA = :PKLUCZ;
  SWINIEN = 0;
  SMA = 0;
  ILOSC = 0;
  ROZLICZONE = 'N';
  OWINIEN = 0;
  OMA = 0;
  ODSETKI_ROZL = 'N';
  KWINIEN = 0;
  KMA = 0;
  KOSZTY_ROZL = 'N';

  IF (:KLUCZ_SALDA = 0)
  THEN BEGIN
    SELECT S.KLUCZ, S.ROZLICZONE, S.ILOSC, S.WINIEN, S.MA,
      S.ODSETKI_WN, S.ODSETKI_MA, S.KOSZTY_WN, S.KOSZTY_MA,
      S.ODSETKI_ROZL, S.KOSZTY_ROZL
    FROM SALDA_ROZLICZEN S
    WHERE S.KLUCZ =
      (SELECT MIN(SS.KLUCZ)
       FROM SALDA_ROZLICZEN SS
       WHERE
         (SS.ROZLICZONE = 'N' OR SS.ODSETKI_ROZL = 'N' OR SS.KOSZTY_ROZL = 'N') AND  /* Nowe tylko nierozliczone */
          SS.TYPDOTYCZY = :PTYPDOTYCZY AND
          SS.DOTYCZY = :PDOTYCZY AND
          SS.RODZAJ = :PRODZAJ AND
          SS.TYPSALDA = :PTYPSALDA AND
          SS.KLUCZ_OBCY = :PKLUCZ_OBCY AND
          SS.SYMBOL = :PSYMBOL AND
          SS.PODMIOT = :PPODMIOT)
    INTO :KLUCZ_SALDA, :ROZLICZONE, :ILOSC, :SWINIEN, :SMA,
      :OWINIEN, :OMA, :KWINIEN, :KMA,
      :ODSETKI_ROZL, KOSZTY_ROZL;
  END
  ELSE BEGIN
    SELECT ROZLICZONE, ILOSC, WINIEN, MA,
      ODSETKI_WN, ODSETKI_MA, KOSZTY_WN, KOSZTY_MA,
      ODSETKI_ROZL, KOSZTY_ROZL
    FROM SALDA_ROZLICZEN
    WHERE
      KLUCZ = :KLUCZ_SALDA
    INTO :ROZLICZONE, :ILOSC, :SWINIEN, :SMA,
      :OWINIEN, :OMA, :KWINIEN, :KMA,
      :ODSETKI_ROZL, KOSZTY_ROZL;
  END

  IF (:PTYPPOZYCJI = 'O')
  THEN BEGIN
    OWINIEN = :OWINIEN + :PWINIEN;
    OMA = :OMA + :PMA;
  END
  ELSE IF (:PTYPPOZYCJI = 'K')
  THEN BEGIN
    KWINIEN = :KWINIEN + :PWINIEN;
    KMA = :KMA + :PMA;
  END
  ELSE BEGIN
    SWINIEN = :SWINIEN + :PWINIEN;
    SMA = :SMA + :PMA;
  END
  ILOSC = :ILOSC + :PILOSC;

  IF (:SWINIEN > :SMA)
  THEN BEGIN
    SSWINIEN = :SWINIEN - :SMA;
    SSMA = 0;
  END
  ELSE BEGIN
    SSWINIEN = 0;
    SSMA = :SMA - :SWINIEN;
  END

  /* Usuwanie zbednego opisu salda */

  IF (:ILOSC = 0 AND :KLUCZ_SALDA > 0)
  THEN BEGIN
    DELETE FROM SALDA_ROZLICZEN WHERE KLUCZ = :KLUCZ_SALDA;
    KLUCZ_SALDA = 0;
  END

  /* Usuwanie rozliczenia */

  IF (:ILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    (:SWINIEN - :SMA < -0.001 OR :SWINIEN - :SMA > 0.001) AND
    :ROZLICZONE = 'T')
  THEN ROZLICZONE = 'N';

  /* Wpisywanie rozliczenia - przeniesione do programu */
/*
  IF (:ILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    :SWINIEN - :SMA > -0.001 AND :SWINIEN - :SMA < 0.001 AND
    :ROZLICZONE = 'N')
  THEN ROZLICZONE = 'T';
*/
  /* Usuwanie rozliczenia - odsetki */

  IF (:ILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    (:OWINIEN - :OMA < -0.001 OR :OWINIEN - :OMA > 0.001) AND
    :ODSETKI_ROZL = 'T')
  THEN ODSETKI_ROZL = 'N';

  /* Wpisywanie rozliczenia - odsetki  - przeniesione do programu */
/*
  IF (:ILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    :OWINIEN - :OMA > -0.001 AND :OWINIEN - :OMA < 0.001 AND
    :ODSETKI_ROZL = 'N')
  THEN ODSETKI_ROZL = 'T';
*/
  /* Usuwanie rozliczenia - koszty */

  IF (:ILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    (:KWINIEN - :KMA < -0.001 OR :KWINIEN - :KMA > 0.001) AND
    :KOSZTY_ROZL = 'T')
  THEN KOSZTY_ROZL = 'N';

  /* Wpisywanie rozliczenia - koszty */
/*
  IF (:ILOSC > 0 AND :KLUCZ_SALDA > 0 AND
    :KWINIEN - :KMA > -0.001 AND :KWINIEN - :KMA < 0.001 AND
    :KOSZTY_ROZL = 'N')
  THEN KOSZTY_ROZL = 'T';
*/
  /* Nowe wartosci */

  IF (:ILOSC > 0 AND :KLUCZ_SALDA > 0)
  THEN
    UPDATE SALDA_ROZLICZEN
    SET
      WINIEN = :SWINIEN, MA = :SMA,
      SWINIEN = :SSWINIEN, SMA = :SSMA,
      ILOSC = :ILOSC, ROZLICZONE = :ROZLICZONE,
      ODSETKI_WN = :OWINIEN, ODSETKI_MA = :OMA,
      ODSETKI_ROZL = :ODSETKI_ROZL,
      KOSZTY_WN = :KWINIEN, KOSZTY_MA = :KMA,
      KOSZTY_ROZL = :KOSZTY_ROZL
    WHERE KLUCZ = :KLUCZ_SALDA;

  /* Nowy opis salda */

  IF (:ILOSC > 0 AND :KLUCZ_SALDA = 0)
  THEN BEGIN
    KLUCZ_SALDA = GEN_ID(DOKUMENTYKSIEGOWE_GEN, 1);
    INSERT INTO SALDA_ROZLICZEN(
      KLUCZ, TYPDOTYCZY, DOTYCZY, RODZAJ, KLUCZ_OBCY, SYMBOL, TYPSALDA, PODMIOT,
      ROZLICZONE, WINIEN, MA, ILOSC,
      SWINIEN, SMA,
      ODSETKI_WN, ODSETKI_MA, ODSETKI_ROZL,
      KOSZTY_WN, KOSZTY_MA, KOSZTY_ROZL,
      WLT_KRAJ)
    VALUES(
      :KLUCZ_SALDA, :PTYPDOTYCZY, :PDOTYCZY, :PRODZAJ, :PKLUCZ_OBCY, :PSYMBOL, :PTYPSALDA, :PPODMIOT,
      'N', :SWINIEN, :SMA, 1,
      :SSWINIEN, :SSMA,
      :OWINIEN, :OMA, 'N',
      :KWINIEN, :KMA, 'N',
      :WLT_KRAJ);
  END

  SUSPEND;
END^
COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;

/* Obsuga dokumentw rozlicze */

SET TERM ^ ;

CREATE TRIGGER CREATE_ROZLICZENIA FOR ROZLICZENIA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0 OR NEW.KLUCZ IS NULL)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);

  NEW.SALDO = 0;

  IF ((NEW.TYPDOTYCZY IN ('K', 'C', 'P') AND NEW.DOTYCZY > 0) AND
    (NEW.RODZAJ IN ('C_CZM', 'C_FKT', 'C_WCZ', 'C_WBD', 'C_WMS')))
  THEN BEGIN
    IF (NEW.TYPPOZYCJI IS NULL OR NEW.TYPPOZYCJI = ' ')
    THEN NEW.TYPPOZYCJI = 'N';

    IF (NEW.TYPSALDA IS NULL OR NEW.TYPSALDA = ' ')
    THEN NEW.TYPSALDA = 'B';

    SELECT KLUCZ_SALDA
    FROM DAJ_SALDOR(
      NEW.SALDO, NEW.TYPDOTYCZY, NEW.DOTYCZY, NEW.RODZAJ, NEW.KLUCZ_OBCY, NEW.SYMBOL, NEW.TYPSALDA,
      NEW.TYPPOZYCJI, NEW.PODMIOT, 1,
      NEW.WINIEN, NEW.MA, NEW.WLT_KRAJ)
    INTO NEW.SALDO;
  END
END ^

SET TERM ; ^

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER UPDATE_ROZLICZENIA FOR ROZLICZENIA
ACTIVE BEFORE UPDATE POSITION 0
AS BEGIN
  IF (NEW.TYPDOTYCZY <> OLD.TYPDOTYCZY OR
    NEW.DOTYCZY <> OLD.DOTYCZY OR
    NEW.RODZAJ <> OLD.RODZAJ OR
    NEW.KLUCZ_OBCY <> OLD.KLUCZ_OBCY OR
    NEW.SYMBOL <> OLD.SYMBOL OR
    NEW.TYPSALDA <> OLD.TYPSALDA OR
    NEW.TYPPOZYCJI <> OLD.TYPPOZYCJI OR
    NEW.PODMIOT <> OLD.PODMIOT)
  THEN BEGIN
    IF ((OLD.TYPDOTYCZY IN ('K', 'C', 'P') AND OLD.DOTYCZY > 0) AND
      (OLD.RODZAJ IN ('C_CZM', 'C_FKT', 'C_WCZ', 'C_WBD', 'C_WMS')))
    THEN
      SELECT KLUCZ_SALDA
      FROM DAJ_SALDOR(
        OLD.SALDO, OLD.TYPDOTYCZY, OLD.DOTYCZY, OLD.RODZAJ, OLD.KLUCZ_OBCY, OLD.SYMBOL, OLD.TYPSALDA,
        OLD.TYPPOZYCJI, OLD.PODMIOT, -1,
        -OLD.WINIEN, -OLD.MA, NEW.WLT_KRAJ)
      INTO NEW.SALDO;

    IF ((NEW.TYPDOTYCZY IN ('K', 'C', 'P') AND NEW.DOTYCZY > 0) AND
      (NEW.RODZAJ IN ('C_CZM', 'C_FKT', 'C_WCZ', 'C_WBD', 'C_WMS')))
    THEN
      SELECT KLUCZ_SALDA
      FROM DAJ_SALDOR(
        0, NEW.TYPDOTYCZY, NEW.DOTYCZY, NEW.RODZAJ, NEW.KLUCZ_OBCY, NEW.SYMBOL, NEW.TYPSALDA,
        NEW.TYPPOZYCJI, NEW.PODMIOT, 1,
        NEW.WINIEN, NEW.MA, NEW.WLT_KRAJ)
      INTO NEW.SALDO;
  END

  ELSE BEGIN
    IF ((NEW.TYPDOTYCZY IN ('K', 'C', 'P') AND NEW.DOTYCZY > 0) AND
      (NEW.RODZAJ IN ('C_CZM', 'C_FKT', 'C_WCZ', 'C_WBD', 'C_WMS')))
    THEN
      SELECT KLUCZ_SALDA
      FROM DAJ_SALDOR(
        OLD.SALDO, NEW.TYPDOTYCZY, NEW.DOTYCZY, NEW.RODZAJ, NEW.KLUCZ_OBCY, NEW.SYMBOL, NEW.TYPSALDA,
        NEW.TYPPOZYCJI, NEW.PODMIOT, 0,
        NEW.WINIEN-OLD.WINIEN, NEW.MA-OLD.MA, NEW.WLT_KRAJ)
      INTO NEW.SALDO;
  END
END ^

SET TERM ; ^

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER DELETE_ROZLICZENIA FOR ROZLICZENIA
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE DUMMY INTEGER;
BEGIN
  IF ((OLD.TYPDOTYCZY IN ('K', 'C', 'P') AND OLD.DOTYCZY > 0) AND
    (OLD.RODZAJ IN ('C_CZM', 'C_FKT', 'C_WCZ', 'C_WBD', 'C_WMS')))
  THEN
    SELECT KLUCZ_SALDA
    FROM DAJ_SALDOR(
      OLD.SALDO, OLD.TYPDOTYCZY, OLD.DOTYCZY, OLD.RODZAJ, OLD.KLUCZ_OBCY, OLD.SYMBOL, OLD.TYPSALDA,
      OLD.TYPPOZYCJI, OLD.PODMIOT, -1,
      -OLD.WINIEN, -OLD.MA, OLD.WLT_KRAJ)
    INTO :DUMMY;
END ^

COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;


/* Czonkowie spdzielni */

CREATE TABLE CZLONKOWIE_SPOLDZIELNI
       (DOTYCZY         KLUCZ NOT NULL,
        TYPDOTYCZY      TYP NOT NULL,

        NUMER           SYMBOL,
        STATUS          IDENT,      /* wedug sownika uytkownika */

        DATA_PRZYJECIA  TIMESTAMP,
        DATA_USTANIA    TIMESTAMP,

        UWAGI         UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DOTYCZY, TYPDOTYCZY));

CREATE INDEX CZLONKOWIE_SPOLDZIELNI_XNUMER ON CZLONKOWIE_SPOLDZIELNI(NUMER);

CREATE TABLE HISTORIA_CZLONKOW
       (DOTYCZY         KLUCZ NOT NULL,
        TYPDOTYCZY      TYP NOT NULL,
        LP              INTEGER NOT NULL,

        OPERACJA        IDENT,   /* Rodzaj dziaania */
                                 /* PRZ - przyjcie do ewidencji */
                                 /* ZMS - zmiana statusu */
                                 /* PDL - Ustanowienie prawa do lokalu - zamiana/sprzeda */
                                 /* UPL - Ustanowienie prawa do lokalu - przetarg */
                                 /* PPL - Przeksztacenie prawa do lokalu */
                                 /* WAL - Waloryzacja */
                                 /* INW - Inwestycja */
                                 /* ZWL - Zwolnienie lokalu */
                                 /* WPL - Wyganicie prawa do lokalu */
                                 /* UWL - Ustanowienie wspwasnoci lokalu */
                                 /* WWL - Wyganicie wspwasnoci lokalu */
                                 /* WYP - wypisanie z ewidencji */

        STATUS          IDENT,   /* Nowy status czonka - przyjcie, zmiana */
        POMIESZCZENIE   KLUCZ,   /* Przydzielany, zwalniany lokal */
        LOKAL_CZLONKA   KLUCZ,   /* Odniesienie do LOKALE_CZLONKOW */
        RODZAJ          DIDENT,         /* WBD - wasnociowe prawo do lokalu */
                                        /* WMB - Lokatorskie prawo do lokalu - bez prawa przeksztacenia */
                                        /* WMS - lokatorskie prawo do lokalu */
                                        /* UMN - umowa najmu */
                                        /* OWL - odrbna wasno lokalu */
        KLAS_WKL        IDENT,   /* Klasyfikacja wkadw wg sownika */
        WYPIS           IDENT,   /* Tryb wypisu wedug sownika uytkownika */
        ST_PROCENT_WKL  WARTOSC, /* Stary procent wkadu mieszkaniowego - przy przeksztaceniu */
                                 /* Przy waloryzacji, inwestycji - warto operacji */
        DATA          TIMESTAMP,      /* Data ksigowania */
        DATA_HIST     TIMESTAMP,      /* Data operacji */
        UWAGI         UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DOTYCZY, TYPDOTYCZY, LP));

COMMIT WORK;

CREATE INDEX HISTORIA_CZLONKOW_XLOKAL ON HISTORIA_CZLONKOW(POMIESZCZENIE);
CREATE INDEX HISTORIA_CZLONKOW_XOPERACJA ON HISTORIA_CZLONKOW(POMIESZCZENIE, OPERACJA, RODZAJ);

CREATE TABLE LOKALE_CZLONKOW
       (DOTYCZY         KLUCZ NOT NULL,
        TYPDOTYCZY      TYP NOT NULL,
        POMIESZCZENIE   KLUCZ NOT NULL,

        KLUCZ           INTEGER NOT NULL,  /* Dodatkowy klucz identyfikujacy rekord */

        DATA_DECYZJI    TIMESTAMP NOT NULL,
        DATA_PROTOKOLU  TIMESTAMP,
        DATA_ZWOLNIENIA TIMESTAMP,

        RODZAJ          DIDENT,         /* WBD - wasnociowe prawo do lokalu */
                                        /* WMB - Lokatorskie prawo do lokalu - bez prawa przeksztacenia */
                                        /* WMS - lokatorskie prawo do lokalu */
                                        /* UMN - umowa najmu */
                                        /* OWL - odrbna wasno lokalu */

        PROCENT_WKL   WARTOSC,          /* Procent wymaganego wkadu lokatorskieg */
        WPISOWE       WARTOSC,
		
        UWAGI         UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DOTYCZY, TYPDOTYCZY, POMIESZCZENIE, DATA_DECYZJI));

CREATE INDEX LOKALE_CZLONKOW_XPOMIESZCZENIE ON LOKALE_CZLONKOW(POMIESZCZENIE);
CREATE INDEX LOKALE_CZLONKOW_XKLUCZ ON LOKALE_CZLONKOW(KLUCZ);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_LOKALE_CZLONKOW FOR LOKALE_CZLONKOW
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN,1);
END ^

COMMIT WORK ^
SET TERM ; ^


CREATE TABLE LOKALE_WSPOLCZLONKOW
       (DOTYCZY         KLUCZ NOT NULL,
        TYPDOTYCZY      TYP NOT NULL,
        POMIESZCZENIE   KLUCZ NOT NULL,

        KLUCZ           INTEGER NOT NULL,  /* Dodatkowy klucz - odwoanie do LOKALE_CZLONKOW */

        DATA_DECYZJI    TIMESTAMP NOT NULL,
        DATA_ZWOLNIENIA TIMESTAMP,

        UWAGI         UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(DOTYCZY, TYPDOTYCZY, POMIESZCZENIE, DATA_DECYZJI));

CREATE INDEX LOKALE_WSPOLCZLONKOW_XPOM ON LOKALE_WSPOLCZLONKOW(POMIESZCZENIE);
CREATE INDEX LOKALE_WSPOLCZLONKOW_XKLUCZ ON LOKALE_WSPOLCZLONKOW(KLUCZ);


SET TERM ^ ;

CREATE PROCEDURE LOKALE_CZLONKOW_RAZEM
RETURNS(
  DOTYCZY         INTEGER,
  TYPDOTYCZY      VARCHAR(1),
  POMIESZCZENIE   INTEGER,
  KLUCZ           INTEGER,
  DATA_DECYZJI    TIMESTAMP,
  DATA_PROTOKOLU  TIMESTAMP,
  DATA_ZWOLNIENIA TIMESTAMP,
  RODZAJ          VARCHAR(5),
  NAZWA           VARCHAR(100),
  PROCENT_WKL   DOUBLE PRECISION,
  UWAGI         BLOB  SUB_TYPE TEXT,
  UTWORZYL      INTEGER,
  ZMIENIAL      INTEGER,
  UTWORZONO     TIMESTAMP,
  ZMIENIANO     TIMESTAMP
  )
AS
BEGIN
  FOR SELECT
    DOTYCZY, TYPDOTYCZY, POMIESZCZENIE, KLUCZ, DATA_DECYZJI,
    DATA_PROTOKOLU, DATA_ZWOLNIENIA, RODZAJ, PROCENT_WKL,
    UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO, UWAGI
  FROM Lokale_czlonkow
  INTO
    :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI,
    :DATA_PROTOKOLU, :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL,
    :UTWORZYL, :ZMIENIAL, :UTWORZONO, :ZMIENIANO, :UWAGI
  DO BEGIN
    NAZWA = '';
    IF (:TYPDOTYCZY = 'K')
    THEN SELECT F.NAZWA FROM FIRMY F WHERE F.KLUCZ = :DOTYCZY INTO :NAZWA;
    IF (:TYPDOTYCZY = 'C')
    THEN SELECT P.NAZWISKO || ' ' || P.IMIE FROM PACJENCI P WHERE P.KLUCZ = :DOTYCZY INTO :NAZWA;

    SUSPEND;
  END

  FOR SELECT
    DOTYCZY, TYPDOTYCZY, POMIESZCZENIE, KLUCZ, DATA_DECYZJI,
    DATA_ZWOLNIENIA,
    UTWORZYL, ZMIENIAL, UTWORZONO, ZMIENIANO, UWAGI
  FROM Lokale_wspolczlonkow
  INTO
    :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI,
    :DATA_ZWOLNIENIA,
    :UTWORZYL, :ZMIENIAL, :UTWORZONO, :ZMIENIANO, :UWAGI
  DO BEGIN
    NAZWA = '';
    IF (:TYPDOTYCZY = 'K')
    THEN SELECT F.NAZWA FROM FIRMY F WHERE F.KLUCZ = :DOTYCZY INTO :NAZWA;
    IF (:TYPDOTYCZY = 'C')
    THEN SELECT P.NAZWISKO || ' ' || P.IMIE FROM PACJENCI P WHERE P.KLUCZ = :DOTYCZY INTO :NAZWA;

    SELECT DATA_PROTOKOLU, RODZAJ, PROCENT_WKL
    FROM Lokale_czlonkow
    WHERE KLUCZ = :KLUCZ
    INTO :DATA_PROTOKOLU, :RODZAJ, :PROCENT_WKL;

    SUSPEND;
  END
END^
COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;


SET TERM ^ ;

CREATE PROCEDURE LOKALE_CZLONKOW_I_WSPOLCZLONKOW(
  ADOTYCZY              INTEGER,
  ATYPDOTYCZY           VARCHAR(1),
  APOMIESZCZENIE        INTEGER
  )
RETURNS(
  DOTYCZY               INTEGER,
  TYPDOTYCZY            VARCHAR(1),
  POMIESZCZENIE	        INTEGER,
  KLUCZ                 INTEGER,
  DATA_DECYZJI          TIMESTAMP,
  DATA_PROTOKOLU        TIMESTAMP,
  DATA_ZWOLNIENIA       TIMESTAMP,
  RODZAJ                VARCHAR(5),
  PROCENT_WKL           DOUBLE PRECISION,
  TYP_CZLONKA           VARCHAR(1)         /* C-czlonek, W-wspolczlonek */
  )
AS
BEGIN
  IF ((ADOTYCZY > 0) AND (ATYPDOTYCZY <> '') AND (APOMIESZCZENIE > 0))
  THEN BEGIN
    FOR SELECT 
      LC.DOTYCZY, LC.TYPDOTYCZY, LC.POMIESZCZENIE, LC.KLUCZ, LC.DATA_DECYZJI, LC.DATA_PROTOKOLU,
      LC.DATA_ZWOLNIENIA, LC.RODZAJ, LC.PROCENT_WKL
    FROM LOKALE_CZLONKOW LC
    WHERE LC.DOTYCZY = :ADOTYCZY AND LC.TYPDOTYCZY = :ATYPDOTYCZY AND LC.POMIESZCZENIE = :APOMIESZCZENIE
    INTO
      :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI, :DATA_PROTOKOLU,
      :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL
    DO BEGIN
      TYP_CZLONKA = 'C';
      SUSPEND;
    END

    FOR SELECT 
      LC.DOTYCZY, LC.TYPDOTYCZY, LC.POMIESZCZENIE, LC.KLUCZ, LC.DATA_DECYZJI, NULL,
      LC.DATA_ZWOLNIENIA, '', 0
    FROM LOKALE_WSPOLCZLONKOW LC
    WHERE LC.DOTYCZY = :ADOTYCZY AND LC.TYPDOTYCZY = :ATYPDOTYCZY AND LC.POMIESZCZENIE = :APOMIESZCZENIE
    INTO
      :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI, :DATA_PROTOKOLU,
      :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL
    DO BEGIN
      TYP_CZLONKA = 'W';
      SUSPEND;
    END
  END

  ELSE IF ((ADOTYCZY > 0) AND (ATYPDOTYCZY <> ''))
  THEN BEGIN
    FOR SELECT 
      LC.DOTYCZY, LC.TYPDOTYCZY, LC.POMIESZCZENIE, LC.KLUCZ, LC.DATA_DECYZJI, LC.DATA_PROTOKOLU,
      LC.DATA_ZWOLNIENIA, LC.RODZAJ, LC.PROCENT_WKL
    FROM LOKALE_CZLONKOW LC
    WHERE LC.DOTYCZY = :ADOTYCZY AND LC.TYPDOTYCZY = :ATYPDOTYCZY 
    INTO
      :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI, :DATA_PROTOKOLU,
      :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL
    DO BEGIN
      TYP_CZLONKA = 'C';
      SUSPEND;
    END

    FOR SELECT 
      LC.DOTYCZY, LC.TYPDOTYCZY, LC.POMIESZCZENIE, LC.KLUCZ, LC.DATA_DECYZJI, NULL,
      LC.DATA_ZWOLNIENIA, '', 0
    FROM LOKALE_WSPOLCZLONKOW LC
    WHERE LC.DOTYCZY = :ADOTYCZY AND LC.TYPDOTYCZY = :ATYPDOTYCZY 
    INTO
      :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI, :DATA_PROTOKOLU,
      :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL
    DO BEGIN
      TYP_CZLONKA = 'W';
      SUSPEND;
    END
  END

  ELSE IF (APOMIESZCZENIE > 0)
  THEN BEGIN
    FOR SELECT 
      LC.DOTYCZY, LC.TYPDOTYCZY, LC.POMIESZCZENIE, LC.KLUCZ, LC.DATA_DECYZJI, LC.DATA_PROTOKOLU,
      LC.DATA_ZWOLNIENIA, LC.RODZAJ, LC.PROCENT_WKL
    FROM LOKALE_CZLONKOW LC
    WHERE LC.POMIESZCZENIE = :APOMIESZCZENIE
    INTO
      :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI, :DATA_PROTOKOLU,
      :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL
    DO BEGIN
      TYP_CZLONKA = 'C';
      SUSPEND;
    END

    FOR SELECT 
      LC.DOTYCZY, LC.TYPDOTYCZY, LC.POMIESZCZENIE, LC.KLUCZ, LC.DATA_DECYZJI, NULL,
      LC.DATA_ZWOLNIENIA, '', 0
    FROM LOKALE_WSPOLCZLONKOW LC
    WHERE LC.POMIESZCZENIE = :APOMIESZCZENIE
    INTO
      :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI, :DATA_PROTOKOLU,
      :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL
    DO BEGIN
      TYP_CZLONKA = 'W';
      SUSPEND;
    END
  END

  ELSE BEGIN 
    FOR SELECT 
      LC.DOTYCZY, LC.TYPDOTYCZY, LC.POMIESZCZENIE, LC.KLUCZ, LC.DATA_DECYZJI, LC.DATA_PROTOKOLU,
      LC.DATA_ZWOLNIENIA, LC.RODZAJ, LC.PROCENT_WKL
    FROM LOKALE_CZLONKOW LC
    INTO
      :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI, :DATA_PROTOKOLU,
      :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL
    DO BEGIN
      TYP_CZLONKA = 'C';
      SUSPEND;
    END

    FOR SELECT 
      LC.DOTYCZY, LC.TYPDOTYCZY, LC.POMIESZCZENIE, LC.KLUCZ, LC.DATA_DECYZJI, NULL,
      LC.DATA_ZWOLNIENIA, '', 0
    FROM LOKALE_WSPOLCZLONKOW LC
    INTO
      :DOTYCZY, :TYPDOTYCZY, :POMIESZCZENIE, :KLUCZ, :DATA_DECYZJI, :DATA_PROTOKOLU,
      :DATA_ZWOLNIENIA, :RODZAJ, :PROCENT_WKL
    DO BEGIN
      TYP_CZLONKA = 'W';
      SUSPEND;
    END
  END
END ^

COMMIT WORK ^
SET TERM ; ^

/* --- */

SET TERM ^ ;

CREATE PROCEDURE WLASCICIELE_LOKALU(
  LOKAL           INTEGER,
  NA_DZIEN        TIMESTAMP)     
RETURNS(
  NAZWA           VARCHAR(200)
  )
AS
DECLARE VARIABLE VNAZWA VARCHAR(200);
DECLARE VARIABLE DOTYCZY INTEGER;
DECLARE VARIABLE TYPDOTYCZY VARCHAR(1);
BEGIN
  NAZWA = '';

  FOR SELECT
    DOTYCZY, TYPDOTYCZY
  FROM Lokale_czlonkow
  WHERE
    POMIESZCZENIE = :LOKAL AND
    DATA_DECYZJI <= :NA_DZIEN AND (DATA_ZWOLNIENIA IS NULL OR DATA_ZWOLNIENIA >= :NA_DZIEN)
  INTO
    :DOTYCZY, :TYPDOTYCZY
  DO BEGIN
    VNAZWA = '';
    IF (:TYPDOTYCZY = 'K')
    THEN SELECT F.NAZWA FROM FIRMY F WHERE F.KLUCZ = :DOTYCZY INTO :VNAZWA;
    IF (:TYPDOTYCZY = 'C')
    THEN SELECT P.NAZWISKO || ' ' || P.IMIE FROM PACJENCI P WHERE P.KLUCZ = :DOTYCZY INTO :VNAZWA;

    IF (:VNAZWA <> '')
    THEN BEGIN
      IF (:NAZWA <> '')
      THEN NAZWA = :NAZWA || ', ';
      NAZWA = :NAZWA || ' ' || :VNAZWA;
    END
  END

  FOR SELECT
    DOTYCZY, TYPDOTYCZY
  FROM Lokale_wspolczlonkow
  WHERE
    POMIESZCZENIE = :LOKAL AND
    DATA_DECYZJI <= :NA_DZIEN AND (DATA_ZWOLNIENIA IS NULL OR DATA_ZWOLNIENIA >= :NA_DZIEN)
  INTO
    :DOTYCZY, :TYPDOTYCZY
  DO BEGIN
    VNAZWA = '';
    IF (:TYPDOTYCZY = 'K')
    THEN SELECT F.NAZWA FROM FIRMY F WHERE F.KLUCZ = :DOTYCZY INTO :VNAZWA;
    IF (:TYPDOTYCZY = 'C')
    THEN SELECT P.NAZWISKO || ' ' || P.IMIE FROM PACJENCI P WHERE P.KLUCZ = :DOTYCZY INTO :VNAZWA;

    IF (:VNAZWA <> '')
    THEN BEGIN
      IF (:NAZWA <> '')
      THEN NAZWA = :NAZWA || ', ';
      NAZWA = :NAZWA || ' ' || :VNAZWA;
    END
  END

  SUSPEND;
END^
COMMIT WORK ^

SET TERM ; ^


/* Wkady i udziay spdzielcze */

CREATE TABLE WKLADY_SPOLDZIELCZE
       (KLUCZ           KLUCZ NOT NULL,
        DOKUMENT        KLUCZ,                /* klucz Kasy/Banku, ... */
        RODZAJ          DIDENT NOT NULL,      /* WCZ - udzia czonkowski */
                                              /* WBD - wkad budowlany */
                                              /* WMS - wkad mieszkaniowy */
                                              /* FZS - fundusz zasobw mieszkaniowych */
                                              /* FZP - fundusz zasobw spdzielni */
        OPERACJA        IDENT NOT NULL,       /* WBO - bilans otwarcia */
                                              /* WPL - naliczenie (wpata)  - rozrachunki */
                                              /* WPZ - zaksigowanie bez rozrachunkw */
                                              /* WYP - zwrot                - rozrachunki */
                                              /* WAL - waloryzacja */
                                              /* WKG - wykup gruntu         - rozrachunki */
                                              /* WKL - Wykup lokalu         - rozrachunki */
											  /* OPG - opata przeksztaceniowa gruntu - rozrachunki */
                                              /* SUK - Spata umorz.kredytu - rozrachunki */
                                              /* WKW - Wyksigowanie wkadu */
                                              /* PPL - Przeniesienie wkadu */
                                              /* UZN - Ustawowa znika */
                                              /* UMR - umorzenia */
        TYP_NAL         IDENT,                /*     - bez typu przy rcznym ksigowaniu */
                                              /* AUT - dla automatycznych nalicze umorze */
                                              /* WAL - Waloryzacja */
                                              /* INW - Inwestycja */
                                              /* ... - inne operacje z historii czonkw */
        BEZ_UMORZEN     TAKNIE,               /* na odwrot U - umorzenia, B - brak - WYCOFANE Z UZYCIA */ 
        KLAS_WKL        IDENT,                /* Klasyfikacja wkadw wg sownika */
        POMIESZCZENIE   KLUCZ NOT NULL,       /* klucz lokalu, dla udziaw moe by 0 */
        TYPOSOBY        TYP NOT NULL,         /* Domylnie C */
        OSOBA           KLUCZ NOT NULL,       /* dla zasobw spdzielni moe by 0 */

        ROK             INTEGER NOT NULL,
        MIESIAC         INTEGER NOT NULL,

        HISTORIA        KLUCZ,                /* Odwoanie do rekordu Historia_czlonkow - pole LP */
        DATA_WYST       TIMESTAMP,

        KWOTA           WARTOSC,
        ZWIEKSZENIA     WARTOSC,
        ZMNIEJSZENIA    WARTOSC,

        ILOSC           INTEGER,
        IZWIEKSZENIA    INTEGER,
        IZMNIEJSZENIA   INTEGER,

        ST_KOSZT_METRA  WARTOSC, /* Stary koszt metra - przy waloryzacji, - to byo dawniej */
                                 /* aktualnie przyrost wartoci lokalu */
        OPIS            DUZA_NAZWA,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

CREATE INDEX WKLADY_SPOLDZIELCZE_XPOM ON WKLADY_SPOLDZIELCZE(POMIESZCZENIE);
CREATE INDEX WKLADY_SPOLDZIELCZE_XOSOBA ON WKLADY_SPOLDZIELCZE(OSOBA);

COMMIT WORK;

SET TERM ^ ;

CREATE TRIGGER CREATE_WKLADY_SPOLDZIELCZE FOR WKLADY_SPOLDZIELCZE
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DOKUMENTYKSIEGOWE_GEN, 1);
END ^

SET TERM ; ^

COMMIT WORK;

/* WINDYKACJA */

CREATE TABLE WINDYKACJA
       (KLUCZ           KLUCZ NOT NULL,
        KLUCZ_OBCY      KLUCZ NOT NULL,       /* dla czynszy - klucz lokalu */
        TYP             TYP NOT NULL,         /* Czynsze, ... */
        NUMER           INTEGER,              /* Numer kolejny dla osoby/lokalu */

        PODMIOT         INTEGER NOT NULL,     /* Podmiot finansowy - firma, 0 - gowny podmiot */

        DATA_WYST       TIMESTAMP,
        DATA_ZAK        TIMESTAMP,
        ZAKONCZONE      TAKNIE,               /* Zawsze Tak/Nie */

        TYPDOTYCZY      TYP,
        DOTYCZY         KLUCZ,

        DANE            UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

COMMIT WORK;

CREATE INDEX WINDYKACJA_XDOTYCZY ON WINDYKACJA(DOTYCZY);
CREATE INDEX WINDYKACJA_XKOBCY ON WINDYKACJA(KLUCZ_OBCY);

SET TERM ^ ;

CREATE TRIGGER CREATE_WINDYKACJA FOR WINDYKACJA
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(DOKUMENTYKSIEGOWE_GEN, 1);
END ^

SET TERM ; ^

COMMIT WORK;

CREATE TABLE POZYCJE_WINDYKACJI
       (WINDYKACJA      KLUCZ NOT NULL,
        LP              INTEGER NOT NULL,

        TYP             IDENT,     /* Dziaanie windykacyjne */
        DATA_WYST       TIMESTAMP,
        WAZNOSC_DO      TIMESTAMP,      /* Data ostatniej raty lub termin patnosci dla wyroku */
        DATA_OTRZ       TIMESTAMP,

        DANE_BO         TAKNIE,    /* T - gdy dane pobierane s z rozlicze typu BO (import, korekty) */
        SPRAWA_SADOWA   KLUCZ,

        TYPSALDA_ZALEGLOSCI TYP,
        TYPSALDA_KOSZTOW TYP,
        TYPSALDA_KSIEGOWANIA TYP,

        ZALEGLOSC       WARTOSC,   /* Ewidencja zalegoci dotychczasowych w ramach typu salda */
        ZALEGLOSC_O     WARTOSC,
        ZALEGLOSC_K     WARTOSC,

        ODSETKI         WARTOSC,
        KOSZTY          WARTOSC,
        ADWOKAT         WARTOSC,
        OST_KLUCZ       KLUCZ,     /* Klucz ostatniego rekordu rozliczenia uwzglednionego w pozycji */

        KWOTA_NAL       WARTOSC,
        KWOTA_ODS       WARTOSC,
        KWOTA_KSZ       WARTOSC,
        KWOTA           WARTOSC,   /* Podstawa rat, wniosku sdowego, wyroku, komornika, suma powyszych */

        RATA            WARTOSC,   /* Zawsze miesiczna */
        ILOSCRAT        INTEGER,   /* Zamiennie z rat */

                                   /* Ponisze kwoty zapamitywane s przy wyroku */

        WDS_GLOWNE      WARTOSC,   /* Naleno gwna z wniosku do sdu */
        WDS_ODSETKI     WARTOSC,   /* Odsetki z wniosku do sdu */
        WDS_KOSZTY      WARTOSC,   /* Koszty z wniosku do sdu */

        WDS_Z_GLOWNE    WARTOSC,   /* Zapacona naleno gwna z wniosku do sdu */
        WDS_Z_ODSETKI   WARTOSC,   /* Zapacone odsetki z wniosku do sdu */
        WDS_Z_KOSZTY    WARTOSC,   /* Zapacone koszty z wniosku do sdu */
        WDS_Z_RAZEM     WARTOSC,   /* Razem zapacone wniosku do sdu - moe by wicej ni suma powyszych */

        RODZAJ          DIDENT NOT NULL,      /* dla czynszy : C_XXX, gdzie XXX */
                                              /* CZM - czynsz miesiczny */
                                              /* FKT - faktury czynszowe */
                                              /* WCZ - wkad czonkowski */
                                              /* WBD - wkad budowlany */
                                              /* WMS - wkad mieszkaniowy */
        SYMBOL          DUZA_NAZWA,    /* Symbol dokumentu */

        NALICZENIE      TYP,                  /* Tylko dla C_CZM - przy ustawionych warunkach - dla wskazania (opcjonalnie) czci danych do windykacji */
                                              /* F - fund.remont., E - eksploatacja, K - us. komunalne (media) */
        DANE            UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        FOREIGN KEY(SPRAWA_SADOWA) REFERENCES SPRAWY_SADOWE(KLUCZ),
        PRIMARY KEY(WINDYKACJA, LP));


CREATE INDEX POZ_WINDYKACJI_XTYPDATA ON POZYCJE_WINDYKACJI(TYP, DATA_WYST);
CREATE INDEX POZ_WINDYKACJI_XDATA ON POZYCJE_WINDYKACJI(DATA_WYST);

/* Obliczenia okresowe czynszw */

CREATE TABLE RODZAJE_KOSZTOW_CZYNSZOWYCH
 (KLUCZ       KLUCZ NOT NULL,
  PODMIOT     INTEGER NOT NULL,     /* Podmiot finansowy - firma, 0 - gowny podmiot */
  TYP         TYP,           /* Osiedlowe, Nieruchomoci, Budynkw */
  NAZWA       OPIS,
  AKTYWNE     TAKNIE,

  RODZAJE      VARCHAR(50),  /* UZT-lokal uytkowy(niemieszkalny), MSZ-lokal mieszkalny, ... - kilka naraz */
  ZASIEDLENIA  VARCHAR(50),  /* Typy zasiedle - te moe by kilka naraz*/
  WYRAZENIE    VARCHAR(30),  /* WyraeniE ksigowe */
  ROZLICZENIE  IDENT,        /* wg czego na lokale */

  DOTYCZY_OPLATY INTEGER,    /* ujemne - media, dodatnie - odwolanie do INNE_OPLATY_CZYNSZU */
  NALICZENIE   TYP,          /* F - fund.remont., E - eksploatacja, K - us. komunalne (media) */
  DOTYCZY IDENT,      /* OG - opata g.  */
                      /* FR - fun.remontowy, RF - rozliczenie FR, AN - antena, DZ - dwig, */
                      /* ZN / ZB - zabudowa nieruch./budowli,                        */
                      /* DP - dodatkowe powierzchnie, IN - inne                      */

  UTWORZYL    KLUCZ,
  ZMIENIAL    KLUCZ,
  UTWORZONO   TIMESTAMP,
  ZMIENIANO   TIMESTAMP,

  PRIMARY KEY(KLUCZ));

COMMIT WORK;


CREATE TABLE KOSZTY_OSIEDLI
 (OSIEDLE        KLUCZ NOT NULL,
  ROK            INTEGER NOT NULL,
  MIESIAC        INTEGER NOT NULL,
  RODZAJ_KOSZTOW KLUCZ NOT NULL,

  KWOTA       WARTOSC,

  UTWORZYL    KLUCZ,
  UTWORZONO   TIMESTAMP,

  FOREIGN KEY(OSIEDLE) REFERENCES OSIEDLA(KLUCZ),
  FOREIGN KEY(RODZAJ_KOSZTOW) REFERENCES RODZAJE_KOSZTOW_CZYNSZOWYCH(KLUCZ),
  PRIMARY KEY(ROK, MIESIAC, OSIEDLE, RODZAJ_KOSZTOW));

COMMIT WORK;


CREATE TABLE KOSZTY_NIERUCHOMOSCI
 (NIERUCHOMOSC   KLUCZ NOT NULL,
  ROK            INTEGER NOT NULL,
  MIESIAC        INTEGER NOT NULL,
  RODZAJ_KOSZTOW KLUCZ NOT NULL,

  KWOTA       WARTOSC,

  UTWORZYL    KLUCZ,
  UTWORZONO   TIMESTAMP,

  FOREIGN KEY(NIERUCHOMOSC) REFERENCES NIERUCHOMOSCI(KLUCZ),
  FOREIGN KEY(RODZAJ_KOSZTOW) REFERENCES RODZAJE_KOSZTOW_CZYNSZOWYCH(KLUCZ),
  PRIMARY KEY(ROK, MIESIAC, NIERUCHOMOSC, RODZAJ_KOSZTOW));

COMMIT WORK;


CREATE TABLE KOSZTY_BUDYNKOW
 (BUDOWLA        KLUCZ NOT NULL,
  ROK            INTEGER NOT NULL,
  MIESIAC        INTEGER NOT NULL,
  RODZAJ_KOSZTOW KLUCZ NOT NULL,

  KWOTA       WARTOSC,

  UTWORZYL    KLUCZ,
  UTWORZONO   TIMESTAMP,

  FOREIGN KEY(BUDOWLA) REFERENCES BUDOWLE(KLUCZ),
  FOREIGN KEY(RODZAJ_KOSZTOW) REFERENCES RODZAJE_KOSZTOW_CZYNSZOWYCH(KLUCZ),
  PRIMARY KEY(ROK, MIESIAC, BUDOWLA, RODZAJ_KOSZTOW));

COMMIT WORK;


CREATE TABLE KOSZTY_LOKALI
 (BUDOWLA        KLUCZ NOT NULL,
  POMIESZCZENIE  KLUCZ NOT NULL,
  ZASIEDLENIE    KLUCZ NOT NULL,
  ZASIEDLENIE_KONTYNUACJA KLUCZ NOT NULL,
  ROK            INTEGER NOT NULL,
  MIESIAC        INTEGER NOT NULL,
  RODZAJ_KOSZTOW KLUCZ NOT NULL,

  KWOTA       WARTOSC,

  UTWORZYL    KLUCZ,
  UTWORZONO   TIMESTAMP,

  FOREIGN KEY(BUDOWLA) REFERENCES BUDOWLE(KLUCZ),
  FOREIGN KEY(POMIESZCZENIE) REFERENCES POMIESZCZENIA(KLUCZ),
  FOREIGN KEY(RODZAJ_KOSZTOW) REFERENCES RODZAJE_KOSZTOW_CZYNSZOWYCH(KLUCZ),
  PRIMARY KEY(ROK, MIESIAC, POMIESZCZENIE, ZASIEDLENIE, RODZAJ_KOSZTOW));

COMMIT WORK;

CREATE INDEX KOSZTY_LOKALI_XZASIEDLENIE ON KOSZTY_LOKALI(ZASIEDLENIE);
CREATE INDEX KOSZTY_LOKALI_XKONTYNUACJA ON KOSZTY_LOKALI(ZASIEDLENIE_KONTYNUACJA);

/* ================== */
/* Obsuga dokumentw */
/* ================== */

CREATE TABLE TECZKI_DOKUMENTOW
       (KLUCZ           KLUCZ NOT NULL,
        DOTYCZY         KLUCZ,
        TYPDOTYCZY      TYP,
        TYP             TYP NOT NULL,         /* S - Spdzielnia, M - medyczne, K - kadrowe  */

        DATA            TIMESTAMP,                 /* Data utworzenia */
        OPIS            DUZY_OPIS,            /* Opis zawartoci */

        ZAKLAD          KLUCZ,                /* Miejsce przechowywania */
        POLOZENIE       OPIS,                 /* Gdzie ley */
        OSOBA           KLUCZ,                /* Osoba odpowiedzialna */

        DANE            UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(KLUCZ));

COMMIT WORK;

CREATE INDEX TECZKI_DOKUMENTOW_XDOTYCZY ON TECZKI_DOKUMENTOW(DOTYCZY);

SET TERM ^ ;

CREATE TRIGGER CREATE_TECZKI_DOKUMENTOW FOR TECZKI_DOKUMENTOW
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

SET TERM ; ^

COMMIT WORK;

CREATE TABLE DOKUMENTY_TECZKI
       (KLUCZ           KLUCZ NOT NULL,
        TECZKA          KLUCZ NOT NULL,

        ZAWARTOSC       TYP,                  /* Memo, Rtf, Word, Excel, Pdf, jpG, Bmp */
        PLIK            VARCHAR(500),         /* Adres pliku/plikw dokumentu pliki oddzielone '|' */
        KLUCZ_DOKUMENTU KLUCZ,                /* Zewntrzny identyfikator w bazie dokumentw */

        KLUCZ_OBCY      KLUCZ,                /* Dla spdzielni - lokal */
                                              /* Dla gabinetu - id_nfz w RuchPrzychodni */

        NUMER           DUZY_SYMBOL,
        DATA            TIMESTAMP,                 /* Data utworzenia */
        RODZAJ          IDENT,                /* Rodzaj programowy */
                                              /* INN - inne */
        PODRODZAJ       DIDENT,               /* Sownik dla INN */
        OPIS            DUZY_OPIS,            /* Opis zawartoci */

        SKAD            TYP,                  /* wpisany Rcznie, Scan, Wydruk, Plik, Internet  */
                                              /* Dla wydruku */
        ORYG_TYP        TYP,                  /* W - windykacyjne (odwoanie do pozycji windykacji) */
        ORYG_KLUCZ      KLUCZ,
        ORYG_LP         INTEGER,

        ZAKLAD          KLUCZ,                /* Miejsce przechowywania, dla medycznych zakad utworzenia */
        POLOZENIE       OPIS,                 /* Gdzie ley */
        OSOBA           KLUCZ,                /* Osoba odpowiedzialna */

        DANE            UWAGI,                /* Tre dokumentu dla Memo */

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        FOREIGN KEY(TECZKA) REFERENCES TECZKI_DOKUMENTOW(KLUCZ),
        PRIMARY KEY(KLUCZ));

COMMIT WORK;

CREATE INDEX TECZKI_XKLUCZ_DOKUMENTU ON DOKUMENTY_TECZKI(KLUCZ_DOKUMENTU);
CREATE INDEX TECZKI_XKLUCZ_OBCY ON DOKUMENTY_TECZKI(KLUCZ_OBCY);
CREATE INDEX TECZKI_XORYG_KLUCZ ON DOKUMENTY_TECZKI(ORYG_KLUCZ);

SET TERM ^ ;

CREATE TRIGGER CREATE_DOKUMENTY_TECZKI FOR DOKUMENTY_TECZKI
ACTIVE BEFORE INSERT POSITION 0
AS BEGIN
  IF (NEW.KLUCZ = 0)
  THEN NEW.KLUCZ = GEN_ID(UNIQUE_KEY_GEN, 1);
END ^

SET TERM ; ^

COMMIT WORK;

CREATE TABLE HISTORIA_TECZKI
       (TECZKA          KLUCZ NOT NULL,
        DOKUMENT        KLUCZ NOT NULL,       /* 0 dotyczy caej teczki */
        LP              INTEGER NOT NULL,

        DATA            TIMESTAMP,                 /* Data utworzenia */

        ZAKLAD          KLUCZ,                /* Miejsce przechowywania */
        POLOZENIE       OPIS,                 /* Gdzie ley */
        OSOBA           KLUCZ,                /* Osoba odpowiedzialna */

        DANE            UWAGI,

        UTWORZYL      KLUCZ,
        ZMIENIAL      KLUCZ,
        UTWORZONO     TIMESTAMP,
        ZMIENIANO     TIMESTAMP,

        PRIMARY KEY(TECZKA, DOKUMENT, LP));

/*==========================================================================*/
/* Procedury czynszowe     */
/* ======================= */

SET TERM ^ ;

CREATE PROCEDURE INFRASTRUKTURA_CALOSC(
  NA_DZIEN TIMESTAMP,
  TRYB     VARCHAR(1))
/*
  '' - bez testw
  'A' - testowanie zasiedle i lokatorw wg daty
*/
RETURNS(
  OSIEDLE           INTEGER,
  OIDENT            VARCHAR(15),
  ONAZWA            VARCHAR(60),

  NIERUCHOMOSC      INTEGER,
  NIDENT            VARCHAR(30),
  NNAZWA            VARCHAR(60),

  NRODZAJ_WLASNOSCI VARCHAR(3),
  NWSPOLNOTA        INTEGER,

  NAKTYWNE          VARCHAR(1),
  NDATA_ODDANIA     TIMESTAMP,
  NDATA_USUNIECIA   TIMESTAMP, 

  NADRMIEJSCOWOSC   VARCHAR(40),
  NADRKODPOCZTOWY   VARCHAR(6),
  NADRULICA         VARCHAR(60),
  NADRDOM           VARCHAR(10),
  OPISNIERUCHOMOSCI VARCHAR(100),
  NUWAGI            UWAGI,

  BUDOWLA           INTEGER,
  BIDENT            VARCHAR(15),

  BRODZAJ           VARCHAR(3),
  BAKTYWNE          VARCHAR(1),
  BDATA_ODDANIA     TIMESTAMP,
  BDATA_USUNIECIA   TIMESTAMP,

  BWODA_ZIMNA       VARCHAR(1),
  BWODA_CIEPLA      VARCHAR(1),
  BGAZ              VARCHAR(1),
  BCO               VARCHAR(1),
  BKANALIZACJA      VARCHAR(1),

  B_PP_WODA         INTEGER,
  B_PP_GAZ          INTEGER,
  B_PP_CO           INTEGER,
  B_PP_SWIATLO      INTEGER,

  BADRMIEJSCOWOSC   VARCHAR(40),
  BADRKODPOCZTOWY   VARCHAR(6),
  BADRULICA         VARCHAR(60),
  BADRDOM           VARCHAR(10),
  OPISBUDYNKU       VARCHAR(100),
  BUWAGI            UWAGI,

  POMIESZCZENIE     KLUCZ,
  PIDENT            VARCHAR(15),

  PWODA_ZIMNA       VARCHAR(3),
  PWODA_CIEPLA      VARCHAR(3),
  PCO               VARCHAR(3),
  PSWIATLO          VARCHAR(3),
  PGAZ              VARCHAR(3),
  PKANALIZACJA      VARCHAR(3),

  P_PP_WODA         INTEGER,
  P_PP_GAZ          INTEGER,
  P_PP_CO           INTEGER,
  P_PP_SWIATLO      INTEGER,

  PRODZAJ           VARCHAR(3),
  PRODZAJ_WLASNOSCI VARCHAR(3),
  PSPD_OD           TIMESTAMP,
  PSPD_DO           TIMESTAMP,
  PAKTYWNE          VARCHAR(1),
  PDATA_ODDANIA     TIMESTAMP,
  PDATA_USUNIECIA   TIMESTAMP,
  OPISLOKALU        VARCHAR(100),
  PUWAGI            UWAGI,

  ZASIEDLENIE       INTEGER,
  KZASIEDLENIE      INTEGER,
  ZDATA_OD          TIMESTAMP,
  ZDATA_DO          TIMESTAMP,
  ZNR_EWID          VARCHAR(15),
  ZTYP              VARCHAR(3),
  ZPODRODZAJ        VARCHAR(3),
  ZRODZAJ_POJEMNIKOW     INTEGER, 
  ZILOSC_POJEMNIKOW      INTEGER, 
  ZCZESTOTLIWOSC_ODBIORU DOUBLE PRECISION,

  LOKATOR           INTEGER,
  LTYP              VARCHAR(1),
  LTYTUL            VARCHAR(3),
  LNAZWA            VARCHAR(80),
  LIDENT            VARCHAR(15),      /* Pacjent.Pesel, Firmy.NIP */
  LSYMBOL           VARCHAR(15),      /* Pacjent.Numer, Firmy.Ident */
  LDATAZGONU        TIMESTAMP,

  LDATA_OD          TIMESTAMP,
  LDATA_DO          TIMESTAMP,

  LADRMIEJSCOWOSC   VARCHAR(40),
  LADRKODPOCZTOWY   VARCHAR(6),
  LADRULICA         VARCHAR(60),
  LADRDOM           VARCHAR(10),
  LADRLOKAL         VARCHAR(5),

  OPISREKORDU       VARCHAR(100)
  )
AS
BEGIN
  FOR SELECT
    O.KLUCZ, O.IDENT, O.NAZWA,
    N.KLUCZ, N.IDENT, N.NAZWA,
    N.RODZAJ_WLASNOSCI, N.WSPOLNOTA,
    N.AKTYWNE, N.DATA_ODDANIA, N.DATA_USUNIECIA,
    N.ADRMIEJSCOWOSC, N.ADRKODPOCZTOWY, N.ADRULICA, N.ADRDOM, N.UWAGI
  FROM OSIEDLA O, NIERUCHOMOSCI N
  WHERE N.OSIEDLE = O.KLUCZ
  INTO
    :OSIEDLE, :OIDENT, :ONAZWA,
    :NIERUCHOMOSC, :NIDENT, :NNAZWA,
    :NRODZAJ_WLASNOSCI, :NWSPOLNOTA,
    :NAKTYWNE, :NDATA_ODDANIA, :NDATA_USUNIECIA,
    :NADRMIEJSCOWOSC, :NADRKODPOCZTOWY, :NADRULICA, :NADRDOM, :NUWAGI
  DO BEGIN
    IF (:NADRKODPOCZTOWY IS NULL) THEN NADRKODPOCZTOWY = '';
    IF (:NADRMIEJSCOWOSC IS NULL) THEN NADRMIEJSCOWOSC = '';
    IF (:NADRULICA IS NULL) THEN NADRULICA = '';
    IF (:NADRDOM IS NULL) THEN NADRDOM = '';

    OPISNIERUCHOMOSCI =
      :NADRKODPOCZTOWY || ' ' || :NADRMIEJSCOWOSC || ', ' ||
      :NADRULICA || ' ' || :NADRDOM;
    OPISREKORDU = :OPISNIERUCHOMOSCI;

    BUDOWLA           = NULL;
    BIDENT            = NULL;

    BRODZAJ           = NULL;
    BAKTYWNE          = NULL;
    BDATA_ODDANIA     = NULL;
    BDATA_USUNIECIA   = NULL;

    BADRMIEJSCOWOSC   = NULL;
    BADRKODPOCZTOWY   = NULL;
    BADRULICA         = NULL;
    BADRDOM           = NULL;
    OPISBUDYNKU       = NULL;

    POMIESZCZENIE     = NULL;
    PIDENT            = NULL;

    PRODZAJ           = NULL;
    PRODZAJ_WLASNOSCI = NULL;
    PSPD_OD           = NULL;
    PSPD_DO           = NULL;
    PAKTYWNE          = NULL;
    PDATA_ODDANIA     = NULL;
    PDATA_USUNIECIA   = NULL;
    OPISLOKALU        = NULL;

    ZASIEDLENIE       = NULL;
    KZASIEDLENIE      = NULL;
    ZDATA_OD          = NULL;
    ZDATA_DO          = NULL;
    ZNR_EWID          = NULL;
    ZTYP              = NULL;
    ZPODRODZAJ        = NULL;

    LOKATOR           = NULL;
    LTYP              = NULL;
    LTYTUL            = NULL;
    LNAZWA            = NULL;
    LIDENT            = NULL;
    LSYMBOL           = NULL;
    LDATAZGONU        = NULL;

    LDATA_OD          = NULL;
    LDATA_DO          = NULL;

    LADRMIEJSCOWOSC   = NULL;
    LADRKODPOCZTOWY   = NULL;
    LADRULICA         = NULL;
    LADRDOM           = NULL;
    LADRLOKAL         = NULL;

    FOR SELECT
      B.KLUCZ, B.IDENT, B.RODZAJ,
      B.AKTYWNE, B.DATA_ODDANIA, B.DATA_USUNIECIA,
      B.ADRMIEJSCOWOSC, B.ADRKODPOCZTOWY, B.ADRULICA, B.ADRDOM, B.UWAGI,
      B.PP_WODA, B.PP_GAZ, B.PP_CO, B.PP_SWIATLO,
      B.WODA_ZIMNA, B.WODA_CIEPLA, B.GAZ, B.CO, B.KANALIZACJA
    FROM BUDOWLE B
    WHERE B.NIERUCHOMOSC = :NIERUCHOMOSC
    INTO
      :BUDOWLA, :BIDENT, :BRODZAJ,
      :BAKTYWNE, :BDATA_ODDANIA, :BDATA_USUNIECIA,
      :BADRMIEJSCOWOSC, :BADRKODPOCZTOWY, :BADRULICA, :BADRDOM, :BUWAGI,
      :B_PP_WODA, :B_PP_GAZ, :B_PP_CO, :B_PP_SWIATLO,
      :BWODA_ZIMNA, :BWODA_CIEPLA, :BGAZ, :BCO, :BKANALIZACJA
    DO BEGIN
      IF (:BADRKODPOCZTOWY IS NULL) THEN BADRKODPOCZTOWY = '';
      IF (:BADRMIEJSCOWOSC IS NULL) THEN BADRMIEJSCOWOSC = '';
      IF (:BADRULICA IS NULL) THEN BADRULICA = '';
      IF (:BADRDOM IS NULL) THEN BADRDOM = '';

      OPISBUDYNKU =
        :BADRKODPOCZTOWY || ' ' || :BADRMIEJSCOWOSC || ', ' ||
        :BADRULICA || ' ' || :BADRDOM;
      OPISREKORDU = :OPISBUDYNKU;

      POMIESZCZENIE     = NULL;
      PIDENT            = NULL;

      PRODZAJ           = NULL;
      PRODZAJ_WLASNOSCI = NULL;
      PSPD_OD           = NULL;
      PSPD_DO           = NULL;
      PAKTYWNE          = NULL;
      PDATA_ODDANIA     = NULL;
      PDATA_USUNIECIA   = NULL;
      OPISLOKALU        = NULL;

      ZASIEDLENIE       = NULL;
      KZASIEDLENIE      = NULL;
      ZDATA_OD          = NULL;
      ZDATA_DO          = NULL;
      ZNR_EWID          = NULL;
      ZTYP              = NULL;
      ZPODRODZAJ        = NULL;

      LOKATOR           = NULL;
      LTYP              = NULL;
      LTYTUL            = NULL;
      LNAZWA            = NULL;
      LIDENT            = NULL;
      LSYMBOL           = NULL;
      LDATAZGONU        = NULL;

      LDATA_OD          = NULL;
      LDATA_DO          = NULL;

      LADRMIEJSCOWOSC   = NULL;
      LADRKODPOCZTOWY   = NULL;
      LADRULICA         = NULL;
      LADRDOM           = NULL;
      LADRLOKAL         = NULL;
      
      FOR SELECT
        P.KLUCZ, P.IDENT, P.RODZAJ, P.RODZAJ_WLASNOSCI, P.SPD_OD, P.SPD_DO,
        P.PP_WODA, P.PP_GAZ, P.PP_CO, P.PP_SWIATLO,
        P.WODA_ZIMNA, P.WODA_CIEPLA, P.GAZ, P.ENERGIA_CIEPLNA,
        P.ENERGIA_ELEKTRYCZNA, P.SCIEKI,
        P.AKTYWNE, P.DATA_ODDANIA, P.DATA_USUNIECIA, P.UWAGI
      FROM POMIESZCZENIA P
      WHERE P.BUDOWLA = :BUDOWLA
      INTO
        :POMIESZCZENIE, :PIDENT, :PRODZAJ, :PRODZAJ_WLASNOSCI, :PSPD_OD, :PSPD_DO,
        :P_PP_WODA, :P_PP_GAZ, :P_PP_CO, :P_PP_SWIATLO, 
        :PWODA_ZIMNA, :PWODA_CIEPLA, :PGAZ, :PCO, 
        :PSWIATLO, :PKANALIZACJA,
        :PAKTYWNE, :PDATA_ODDANIA, :PDATA_USUNIECIA, :PUWAGI
      DO BEGIN
        OPISLOKALU = '';
        IF (:PRODZAJ = 'MSZ')      THEN OPISLOKALU = 'Lokal mieszkalny';
        ELSE IF (:PRODZAJ = 'UZT') THEN OPISLOKALU = 'Lokal niemieszkalny';
        ELSE IF (:PRODZAJ = 'GRZ') THEN OPISLOKALU = 'Pomieszczenie garazowe';
        ELSE IF (:PRODZAJ = 'BKS') THEN OPISLOKALU = 'Boks';
        ELSE IF (:PRODZAJ = 'GSP') THEN OPISLOKALU = 'Pomieszczenie gospodarcze';
        ELSE IF (:PRODZAJ = 'DRZ') THEN OPISLOKALU = 'Dzierzawa terenu';
        OPISREKORDU = :OPISLOKALU;

        ZASIEDLENIE       = NULL;
        KZASIEDLENIE      = NULL;
        ZDATA_OD          = NULL;
        ZDATA_DO          = NULL;
        ZNR_EWID          = NULL;
        ZTYP              = NULL;
        ZPODRODZAJ        = NULL;

        LOKATOR           = NULL;
        LTYP              = NULL;
        LTYTUL            = NULL;
        LNAZWA            = NULL;
        LIDENT            = NULL;
        LSYMBOL           = NULL;
        LDATAZGONU        = NULL;

        LDATA_OD          = NULL;
        LDATA_DO          = NULL;

        LADRMIEJSCOWOSC   = NULL;
        LADRKODPOCZTOWY   = NULL;
        LADRULICA         = NULL;
        LADRDOM           = NULL;
        LADRLOKAL         = NULL;

        FOR SELECT
          Z.KLUCZ, Z.KLUCZ_KONTYNUACJI, Z.DATA_OD, Z.DATA_DO,
          Z.NR_EWID, Z.TYP, Z.PODRODZAJ,
          Z.RODZAJ_POJEMNIKOW, Z.ILOSC_POJEMNIKOW, Z.CZESTOTLIWOSC_ODBIORU
        FROM ZASIEDLENIA Z
        WHERE
          Z.LOKAL = :POMIESZCZENIE AND
          (:TRYB = '' OR
          :TRYB IN ('A') AND
          Z.DATA_OD <= :NA_DZIEN AND
          (Z.DATA_DO IS NULL OR Z.DATA_DO >= :NA_DZIEN))
        INTO
          :ZASIEDLENIE, :KZASIEDLENIE, :ZDATA_OD, :ZDATA_DO,
          :ZNR_EWID, :ZTYP, :ZPODRODZAJ,
          :ZRODZAJ_POJEMNIKOW, :ZILOSC_POJEMNIKOW, :ZCZESTOTLIWOSC_ODBIORU
        DO BEGIN
          LOKATOR           = NULL;
          LTYP              = NULL;
          LTYTUL            = NULL;
          LNAZWA            = NULL;
          LIDENT            = NULL;
          LSYMBOL           = NULL;
          LDATAZGONU        = NULL;

          LDATA_OD          = NULL;
          LDATA_DO          = NULL;

          LADRMIEJSCOWOSC   = NULL;
          LADRKODPOCZTOWY   = NULL;
          LADRULICA         = NULL;
          LADRDOM           = NULL;
          LADRLOKAL         = NULL;

          FOR SELECT
            L.NAJEMCA, L.TYP_NAJEMCY, L.TYTUL,
            L.DATA_OD, L.DATA_DO
          FROM LOKATORZY L
          WHERE
            L.ZASIEDLENIE = :ZASIEDLENIE AND L.TYTUL IN ('G', 'P') AND
            (:TRYB = '' OR
            :TRYB IN ('A') AND
            L.DATA_OD <= :NA_DZIEN AND
            (L.DATA_DO IS NULL OR L.DATA_DO >= :NA_DZIEN))
          INTO
            :LOKATOR, :LTYP, :LTYTUL,
            :LDATA_OD, :LDATA_DO
          DO BEGIN
            IF (:LTYP = 'C')
            THEN
              SELECT
                PC.NAZWISKO || ' ' || PC.IMIE, PC.PESEL, PC.NUMER,
                PC.ADRMIEJSCOWOSC, PC.ADRKODPOCZTOWY,
                PC.ADRULICA, PC.ADRDOM, PC.ADRLOKAL, PC.DATAZGONU
              FROM PACJENCI PC
              WHERE PC.KLUCZ = :LOKATOR
              INTO
                :LNAZWA, :LIDENT, :LSYMBOL,
                :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
                :LADRULICA, :LADRDOM, :LADRLOKAL, :LDATAZGONU;

            IF (:LTYP = 'K')
            THEN
              SELECT
                FR.NAZWA, FR.NIP, FR.IDENT,
                FR.ADRMIEJSCOWOSC, FR.ADRKODPOCZTOWY,
                FR.ADRULICA, FR.ADRDOM, FR.ADRLOKAL
              FROM FIRMY FR
              WHERE FR.KLUCZ = :LOKATOR
              INTO
                :LNAZWA, :LIDENT, :LSYMBOL,
                :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
                :LADRULICA, :LADRDOM, :LADRLOKAL;

            OPISLOKALU = :LNAZWA;
            OPISREKORDU = :OPISLOKALU;

            SUSPEND;
          END

          IF (:LOKATOR IS NULL)
          THEN SUSPEND;
        END

        IF (:ZASIEDLENIE IS NULL)
        THEN SUSPEND;
      END
      IF (:POMIESZCZENIE IS NULL)
      THEN SUSPEND;
    END
    IF (:BUDOWLA IS NULL)
    THEN SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE INFRASTRUKTURA_ZASIEDLENIA
RETURNS(
  OSIEDLE            INTEGER,
  OIDENT             VARCHAR(15),
  ONAZWA             VARCHAR(60),

  NIERUCHOMOSC       INTEGER,
  NIDENT             VARCHAR(30),
  NNAZWA             VARCHAR(60),

  NRODZAJ_WLASNOSCI  VARCHAR(3),
  NWSPOLNOTA         INTEGER,

  NADRMIEJSCOWOSC    VARCHAR(40),
  NADRKODPOCZTOWY    VARCHAR(6),
  NADRULICA          VARCHAR(60),
  NADRDOM            VARCHAR(10),
  OPISNIERUCHOMOSCI  VARCHAR(100),

  BUDOWLA            INTEGER,
  BIDENT             VARCHAR(15),
  BRODZAJ            VARCHAR(3),
  BADRMIEJSCOWOSC    VARCHAR(40),
  BADRKODPOCZTOWY    VARCHAR(6),
  BADRULICA          VARCHAR(60),
  BADRDOM            VARCHAR(10),
  OPISBUDYNKU        VARCHAR(100),
  B_PP_WODA          INTEGER,
  B_PP_GAZ           INTEGER,
  B_PP_CO            INTEGER,
  B_PP_SWIATLO       INTEGER,
  BWODA_ZIMNA        VARCHAR(1),
  BWODA_CIEPLA       VARCHAR(1),
  BGAZ               VARCHAR(1),
  BCO                VARCHAR(1),
  BKANALIZACJA       VARCHAR(1),
  BSEGREGACJA_SMIECI VARCHAR(1),

  POMIESZCZENIE      KLUCZ,
  PIDENT             VARCHAR(15),
  PRODZAJ            VARCHAR(3),
  PRODZAJ_WLASNOSCI  VARCHAR(3),
  PSPD_OD            TIMESTAMP,
  PSPD_DO            TIMESTAMP,
  OPISLOKALU         VARCHAR(100),
  KLATKA             VARCHAR(5),
  PIETRO             DOUBLE PRECISION,
  P_PP_WODA          INTEGER,
  P_PP_GAZ           INTEGER,
  P_PP_CO            INTEGER,
  P_PP_SWIATLO       INTEGER,
  PWODA_ZIMNA        VARCHAR(3),
  PWODA_CIEPLA       VARCHAR(3),
  PCO                VARCHAR(3),
  PSWIATLO           VARCHAR(3),
  PGAZ               VARCHAR(3),
  PKANALIZACJA       VARCHAR(3),

  ZASIEDLENIE        INTEGER,
  KZASIEDLENIE       INTEGER,
  ZNR_EWID           VARCHAR(15),
  ZTYP               VARCHAR(3),
  ZPODRODZAJ         VARCHAR(3),
  ZDATA_OD           TIMESTAMP,
  ZDATA_DO           TIMESTAMP,
  ZTERMIN            DOUBLE PRECISION,
  ZRODZAJ_POJEMNIKOW     INTEGER, 
  ZILOSC_POJEMNIKOW      INTEGER, 
  ZCZESTOTLIWOSC_ODBIORU DOUBLE PRECISION,
  ZWSK_FAKTURY       VARCHAR(1),
  ZRODZAJ_WLASNOSCI  VARCHAR(3),

  LOKATOR            INTEGER,
  LTYP               VARCHAR(1),
  LNAZWA             VARCHAR(80),
  LDATAZGONU         TIMESTAMP,

  LADRMIEJSCOWOSC    VARCHAR(40),
  LADRKODPOCZTOWY    VARCHAR(6),
  LADRULICA          VARCHAR(60),
  LADRDOM            VARCHAR(10),
  LADRLOKAL          VARCHAR(5),

  OPISREKORDU        VARCHAR(100)
  )
AS
BEGIN
  FOR SELECT
    O.KLUCZ, O.IDENT, O.NAZWA,
    N.KLUCZ, N.IDENT, N.NAZWA,
    N.RODZAJ_WLASNOSCI, N.WSPOLNOTA,
    N.ADRMIEJSCOWOSC, N.ADRKODPOCZTOWY, N.ADRULICA, N.ADRDOM
  FROM OSIEDLA O, NIERUCHOMOSCI N
  WHERE N.OSIEDLE = O.KLUCZ
  INTO
    :OSIEDLE, :OIDENT, :ONAZWA,
    :NIERUCHOMOSC, :NIDENT, :NNAZWA,
    :NRODZAJ_WLASNOSCI, :NWSPOLNOTA,
    :NADRMIEJSCOWOSC, :NADRKODPOCZTOWY, :NADRULICA, :NADRDOM
  DO BEGIN
    IF (:NADRKODPOCZTOWY IS NULL) THEN NADRKODPOCZTOWY = '';
    IF (:NADRMIEJSCOWOSC IS NULL) THEN NADRMIEJSCOWOSC = '';
    IF (:NADRULICA IS NULL) THEN NADRULICA = '';
    IF (:NADRDOM IS NULL) THEN NADRDOM = '';

    OPISNIERUCHOMOSCI =
      :NADRKODPOCZTOWY || ' ' || :NADRMIEJSCOWOSC || ', ' ||
      :NADRULICA || ' ' || :NADRDOM;
    OPISREKORDU = :OPISNIERUCHOMOSCI;

    BUDOWLA           = NULL;
    BIDENT            = NULL;
    BRODZAJ           = NULL;

    BADRMIEJSCOWOSC   = NULL;
    BADRKODPOCZTOWY   = NULL;
    BADRULICA         = NULL;
    BADRDOM           = NULL;
    OPISBUDYNKU       = NULL;

    POMIESZCZENIE     = NULL;
    PIDENT            = NULL;
    PRODZAJ           = NULL;
    PRODZAJ_WLASNOSCI = NULL;
    PSPD_OD           = NULL;
    PSPD_DO           = NULL;
    OPISLOKALU        = NULL;
    KLATKA            = NULL;
    PIETRO            = NULL;

    ZASIEDLENIE       = NULL;
    KZASIEDLENIE      = NULL;
    ZNR_EWID          = NULL;
    ZTYP              = NULL;
    ZPODRODZAJ        = NULL;

    LOKATOR           = NULL;
    LTYP              = NULL;
    LNAZWA            = NULL;
    LDATAZGONU        = NULL;

    LADRMIEJSCOWOSC   = NULL;
    LADRKODPOCZTOWY   = NULL;
    LADRULICA         = NULL;
    LADRDOM           = NULL;
    LADRLOKAL         = NULL;

    FOR SELECT
      B.KLUCZ, B.IDENT, B.RODZAJ,
      B.PP_WODA, B.PP_GAZ, B.PP_CO, B.PP_SWIATLO, B.SEGREGACJA_SMIECI,
      B.WODA_ZIMNA, B.WODA_CIEPLA, B.GAZ, B.CO, B.KANALIZACJA,
      B.ADRMIEJSCOWOSC, B.ADRKODPOCZTOWY, B.ADRULICA, B.ADRDOM
    FROM BUDOWLE B
    WHERE B.NIERUCHOMOSC = :NIERUCHOMOSC
    INTO
      :BUDOWLA, :BIDENT, :BRODZAJ,
      :B_PP_WODA, :B_PP_GAZ, :B_PP_CO, :B_PP_SWIATLO, :BSEGREGACJA_SMIECI,
      :BWODA_ZIMNA, :BWODA_CIEPLA, :BGAZ, :BCO, :BKANALIZACJA,
      :BADRMIEJSCOWOSC, :BADRKODPOCZTOWY, :BADRULICA, :BADRDOM
    DO BEGIN
      IF (:BADRKODPOCZTOWY IS NULL) THEN BADRKODPOCZTOWY = '';
      IF (:BADRMIEJSCOWOSC IS NULL) THEN BADRMIEJSCOWOSC = '';
      IF (:BADRULICA IS NULL) THEN BADRULICA = '';
      IF (:BADRDOM IS NULL) THEN BADRDOM = '';

      OPISBUDYNKU =
        :BADRKODPOCZTOWY || ' ' || :BADRMIEJSCOWOSC || ', ' ||
        :BADRULICA || ' ' || :BADRDOM;
      OPISREKORDU = :OPISBUDYNKU;

      POMIESZCZENIE     = NULL;
      PIDENT            = NULL;
      PRODZAJ           = NULL;
      PRODZAJ_WLASNOSCI = NULL;
      PSPD_OD           = NULL;
      PSPD_DO           = NULL;
      OPISLOKALU        = NULL;
      KLATKA            = NULL;
      PIETRO            = NULL;

      ZASIEDLENIE       = NULL;
      KZASIEDLENIE      = NULL;
      ZNR_EWID          = NULL;
      ZTYP              = NULL;
      ZPODRODZAJ        = NULL;
      ZWSK_FAKTURY      = NULL;

      LOKATOR           = NULL;
      LTYP              = NULL;
      LNAZWA            = NULL;
      LDATAZGONU        = NULL;

      LADRMIEJSCOWOSC   = NULL;
      LADRKODPOCZTOWY   = NULL;
      LADRULICA         = NULL;
      LADRDOM           = NULL;
      LADRLOKAL         = NULL;
      
      FOR SELECT
        P.KLUCZ, P.IDENT, P.RODZAJ, P.RODZAJ_WLASNOSCI, P.SPD_OD, P.SPD_DO, P.KLATKA, P.PIETRO,
        P.PP_WODA, P.PP_GAZ, P.PP_CO, P.PP_SWIATLO,
        P.WODA_ZIMNA, P.WODA_CIEPLA, P.GAZ, P.ENERGIA_CIEPLNA, 
        P.ENERGIA_ELEKTRYCZNA, P.SCIEKI
      FROM POMIESZCZENIA P
      WHERE P.BUDOWLA = :BUDOWLA
      INTO
        :POMIESZCZENIE, :PIDENT, :PRODZAJ, :PRODZAJ_WLASNOSCI, :PSPD_OD, :PSPD_DO, :KLATKA, :PIETRO,
        :P_PP_WODA, :P_PP_GAZ, :P_PP_CO, :P_PP_SWIATLO,
        :PWODA_ZIMNA, :PWODA_CIEPLA, :PGAZ, :PCO, 
        :PSWIATLO, :PKANALIZACJA
      DO BEGIN
        OPISLOKALU = '';
        IF (:PRODZAJ = 'MSZ')      THEN OPISLOKALU = 'Lokal mieszkalny';
        ELSE IF (:PRODZAJ = 'UZT') THEN OPISLOKALU = 'Lokal niemieszkalny';
        ELSE IF (:PRODZAJ = 'GRZ') THEN OPISLOKALU = 'Pomieszczenie garazowe';
        ELSE IF (:PRODZAJ = 'BKS') THEN OPISLOKALU = 'Boks';
        ELSE IF (:PRODZAJ = 'GSP') THEN OPISLOKALU = 'Pomieszczenie gospodarcze';
        ELSE IF (:PRODZAJ = 'DRZ') THEN OPISLOKALU = 'Dzierzawa terenu';
        OPISREKORDU = :OPISLOKALU;

        ZASIEDLENIE       = NULL;
        KZASIEDLENIE      = NULL;
        ZNR_EWID          = NULL;
        ZTYP              = NULL;
        ZPODRODZAJ        = NULL;

        LOKATOR           = NULL;
        LTYP              = NULL;
        LNAZWA            = NULL;
        LDATAZGONU        = NULL;

        LADRMIEJSCOWOSC   = NULL;
        LADRKODPOCZTOWY   = NULL;
        LADRULICA         = NULL;
        LADRDOM           = NULL;
        LADRLOKAL         = NULL;

        FOR SELECT DISTINCT
          Z.KLUCZ, Z.KLUCZ_KONTYNUACJI,
          Z.NR_EWID, Z.TYP, Z.PODRODZAJ,
          Z.DATA_OD, Z.DATA_DO, Z.TERMIN, Z.WSK_FAKTURY, Z.RODZAJ_WLASNOSCI,
          Z.RODZAJ_POJEMNIKOW, Z.ILOSC_POJEMNIKOW, Z.CZESTOTLIWOSC_ODBIORU
        FROM ZASIEDLENIA Z
        WHERE
          Z.LOKAL = :POMIESZCZENIE
        INTO
          :ZASIEDLENIE, :KZASIEDLENIE,
          :ZNR_EWID, :ZTYP, :ZPODRODZAJ,
          :ZDATA_OD, :ZDATA_DO, :ZTERMIN, :ZWSK_FAKTURY, :ZRODZAJ_WLASNOSCI,
          :ZRODZAJ_POJEMNIKOW, :ZILOSC_POJEMNIKOW, :ZCZESTOTLIWOSC_ODBIORU

        DO BEGIN
          LOKATOR           = NULL;
          LTYP              = NULL;
          LNAZWA            = NULL;
          LDATAZGONU        = NULL;

          LADRMIEJSCOWOSC   = NULL;
          LADRKODPOCZTOWY   = NULL;
          LADRULICA         = NULL;
          LADRDOM           = NULL;
          LADRLOKAL         = NULL;

          FOR SELECT DISTINCT
            L.NAJEMCA, L.TYP_NAJEMCY
          FROM LOKATORZY L
          WHERE
            L.ZASIEDLENIE = :ZASIEDLENIE AND L.TYTUL IN ('G', 'P')
          INTO
            :LOKATOR, :LTYP
          DO BEGIN
            IF (:LTYP = 'C')
            THEN
              SELECT
                PC.NAZWISKO || ' ' || PC.IMIE,
                PC.ADRMIEJSCOWOSC, PC.ADRKODPOCZTOWY,
                PC.ADRULICA, PC.ADRDOM, PC.ADRLOKAL, PC.DATAZGONU
              FROM PACJENCI PC
              WHERE PC.KLUCZ = :LOKATOR
              INTO
                :LNAZWA,
                :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
                :LADRULICA, :LADRDOM, :LADRLOKAL, :LDATAZGONU;

            IF (:LTYP = 'K')
            THEN
              SELECT
                FR.NAZWA,
                FR.ADRMIEJSCOWOSC, FR.ADRKODPOCZTOWY,
                FR.ADRULICA, FR.ADRDOM, FR.ADRLOKAL
              FROM FIRMY FR
              WHERE FR.KLUCZ = :LOKATOR
              INTO
                :LNAZWA,
                :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
                :LADRULICA, :LADRDOM, :LADRLOKAL;

            OPISLOKALU = :LNAZWA;
            OPISREKORDU = :OPISLOKALU;

            SUSPEND;
          END

          IF (:LOKATOR IS NULL)
          THEN SUSPEND;
        END

        IF (:ZASIEDLENIE IS NULL)
        THEN SUSPEND;
      END
      IF (:POMIESZCZENIE IS NULL)
      THEN SUSPEND;
    END
    IF (:BUDOWLA IS NULL)
    THEN SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE INFRASTRUKTURA_LOKATORZY
RETURNS(
  OSIEDLE           INTEGER,
  OIDENT            VARCHAR(15),
  ONAZWA            VARCHAR(60),

  NIERUCHOMOSC      INTEGER,
  NIDENT            VARCHAR(30),
  NNAZWA            VARCHAR(60),

  NRODZAJ_WLASNOSCI VARCHAR(3),
  NWSPOLNOTA        INTEGER,

  NADRMIEJSCOWOSC   VARCHAR(40),
  NADRKODPOCZTOWY   VARCHAR(6),
  NADRULICA         VARCHAR(60),
  NADRDOM           VARCHAR(10),
  OPISNIERUCHOMOSCI VARCHAR(100),

  BUDOWLA           INTEGER,
  BIDENT            VARCHAR(15),
  BRODZAJ           VARCHAR(3),

  BADRMIEJSCOWOSC   VARCHAR(40),
  BADRKODPOCZTOWY   VARCHAR(6),
  BADRULICA         VARCHAR(60),
  BADRDOM           VARCHAR(10),
  OPISBUDYNKU       VARCHAR(100),

  POMIESZCZENIE     KLUCZ,
  PIDENT            VARCHAR(15),
  PRODZAJ           VARCHAR(3),
  PRODZAJ_WLASNOSCI VARCHAR(3),
  PSPD_OD           TIMESTAMP,
  PSPD_DO           TIMESTAMP,
  KLATKA            VARCHAR(5),
  PIETRO            DOUBLE PRECISION,
  OPISLOKALU        VARCHAR(100),

  ZTYP              VARCHAR(3),

  LOKATOR           INTEGER,
  LTYP              VARCHAR(1),
  LNAZWA            VARCHAR(80),
  LDATAZGONU        TIMESTAMP,

  LADRMIEJSCOWOSC   VARCHAR(40),
  LADRKODPOCZTOWY   VARCHAR(6),
  LADRULICA         VARCHAR(60),
  LADRDOM           VARCHAR(10),
  LADRLOKAL         VARCHAR(5),

  OPISREKORDU       VARCHAR(100)
  )
AS
BEGIN
  FOR SELECT
    O.KLUCZ, O.IDENT, O.NAZWA,
    N.KLUCZ, N.IDENT, N.NAZWA,
    N.RODZAJ_WLASNOSCI, N.WSPOLNOTA,
    N.ADRMIEJSCOWOSC, N.ADRKODPOCZTOWY, N.ADRULICA, N.ADRDOM
  FROM OSIEDLA O, NIERUCHOMOSCI N
  WHERE N.OSIEDLE = O.KLUCZ
  INTO
    :OSIEDLE, :OIDENT, :ONAZWA,
    :NIERUCHOMOSC, :NIDENT, :NNAZWA,
    :NRODZAJ_WLASNOSCI, :NWSPOLNOTA,
    :NADRMIEJSCOWOSC, :NADRKODPOCZTOWY, :NADRULICA, :NADRDOM
  DO BEGIN
    IF (:NADRKODPOCZTOWY IS NULL) THEN NADRKODPOCZTOWY = '';
    IF (:NADRMIEJSCOWOSC IS NULL) THEN NADRMIEJSCOWOSC = '';
    IF (:NADRULICA IS NULL) THEN NADRULICA = '';
    IF (:NADRDOM IS NULL) THEN NADRDOM = '';

    OPISNIERUCHOMOSCI =
      :NADRKODPOCZTOWY || ' ' || :NADRMIEJSCOWOSC || ', ' ||
      :NADRULICA || ' ' || :NADRDOM;
    OPISREKORDU = :OPISNIERUCHOMOSCI;

    BUDOWLA           = NULL;
    BIDENT            = NULL;
    BRODZAJ           = NULL;

    BADRMIEJSCOWOSC   = NULL;
    BADRKODPOCZTOWY   = NULL;
    BADRULICA         = NULL;
    BADRDOM           = NULL;
    OPISBUDYNKU       = NULL;

    POMIESZCZENIE     = NULL;
    PIDENT            = NULL;
    PRODZAJ           = NULL;
    PRODZAJ_WLASNOSCI = NULL;
    PSPD_OD           = NULL;
    PSPD_DO           = NULL;
    KLATKA            = NULL;
    PIETRO            = NULL;
    OPISLOKALU        = NULL;

    ZTYP              = NULL;

    LOKATOR           = NULL;
    LTYP              = NULL;
    LNAZWA            = NULL;
    LDATAZGONU        = NULL;

    LADRMIEJSCOWOSC   = NULL;
    LADRKODPOCZTOWY   = NULL;
    LADRULICA         = NULL;
    LADRDOM           = NULL;
    LADRLOKAL         = NULL;

    FOR SELECT
      B.KLUCZ, B.IDENT, B.RODZAJ,
      B.ADRMIEJSCOWOSC, B.ADRKODPOCZTOWY, B.ADRULICA, B.ADRDOM
    FROM BUDOWLE B
    WHERE B.NIERUCHOMOSC = :NIERUCHOMOSC
    INTO
      :BUDOWLA, :BIDENT, :BRODZAJ,
      :BADRMIEJSCOWOSC, :BADRKODPOCZTOWY, :BADRULICA, :BADRDOM
    DO BEGIN
      IF (:BADRKODPOCZTOWY IS NULL) THEN BADRKODPOCZTOWY = '';
      IF (:BADRMIEJSCOWOSC IS NULL) THEN BADRMIEJSCOWOSC = '';
      IF (:BADRULICA IS NULL) THEN BADRULICA = '';
      IF (:BADRDOM IS NULL) THEN BADRDOM = '';

      OPISBUDYNKU =
        :BADRKODPOCZTOWY || ' ' || :BADRMIEJSCOWOSC || ', ' ||
        :BADRULICA || ' ' || :BADRDOM;
      OPISREKORDU = :OPISBUDYNKU;

      POMIESZCZENIE     = NULL;
      PIDENT            = NULL;
      PRODZAJ           = NULL;
      PRODZAJ_WLASNOSCI = NULL;
      PSPD_OD           = NULL;
      PSPD_DO           = NULL;
      KLATKA            = NULL;
      PIETRO            = NULL;
      OPISLOKALU        = NULL;

      ZTYP              = NULL;

      LOKATOR           = NULL;
      LTYP              = NULL;
      LNAZWA            = NULL;
      LDATAZGONU        = NULL;

      LADRMIEJSCOWOSC   = NULL;
      LADRKODPOCZTOWY   = NULL;
      LADRULICA         = NULL;
      LADRDOM           = NULL;
      LADRLOKAL         = NULL;
      
      FOR SELECT
        P.KLUCZ, P.IDENT, P.RODZAJ, P.RODZAJ_WLASNOSCI, P.SPD_OD, P.SPD_DO, P.KLATKA, P.PIETRO
      FROM POMIESZCZENIA P
      WHERE P.BUDOWLA = :BUDOWLA
      INTO
        :POMIESZCZENIE, :PIDENT, :PRODZAJ, :PRODZAJ_WLASNOSCI, :PSPD_OD, :PSPD_DO, :KLATKA, :PIETRO 
      DO BEGIN
        OPISLOKALU = '';
        IF (:PRODZAJ = 'MSZ')      THEN OPISLOKALU = 'Lokal mieszkalny';
        ELSE IF (:PRODZAJ = 'UZT') THEN OPISLOKALU = 'Lokal niemieszkalny';
        ELSE IF (:PRODZAJ = 'GRZ') THEN OPISLOKALU = 'Pomieszczenie garazowe';
        ELSE IF (:PRODZAJ = 'BKS') THEN OPISLOKALU = 'Boks';
        ELSE IF (:PRODZAJ = 'GSP') THEN OPISLOKALU = 'Pomieszczenie gospodarcze';
        ELSE IF (:PRODZAJ = 'DRZ') THEN OPISLOKALU = 'Dzierzawa terenu';
        OPISREKORDU = :OPISLOKALU;

        ZTYP              = NULL;

        LOKATOR           = NULL;
        LTYP              = NULL;
        LNAZWA            = NULL;
        LDATAZGONU        = NULL;

        LADRMIEJSCOWOSC   = NULL;
        LADRKODPOCZTOWY   = NULL;
        LADRULICA         = NULL;
        LADRDOM           = NULL;
        LADRLOKAL         = NULL;

        FOR SELECT DISTINCT
          L.NAJEMCA, L.TYP_NAJEMCY
        FROM ZASIEDLENIA Z, LOKATORZY L
        WHERE
          Z.LOKAL = :POMIESZCZENIE AND
          L.ZASIEDLENIE = Z.KLUCZ AND L.TYTUL IN ('G', 'P')
        INTO
          :LOKATOR, :LTYP
        DO BEGIN
          SELECT TYP
          FROM ZASIEDLENIA Z
          WHERE Z.KLUCZ =
            (SELECT MAX(Z1.KLUCZ)
             FROM ZASIEDLENIA Z1, LOKATORZY L1
             WHERE
               Z1.LOKAL = :POMIESZCZENIE AND L1.ZASIEDLENIE = Z1.KLUCZ AND
               L1.NAJEMCA = :LOKATOR AND L1.TYP_NAJEMCY = :LTYP AND L1.TYTUL IN ('G', 'P'))
          INTO :ZTYP;

          IF (:LTYP = 'C')
          THEN
            SELECT
              PC.NAZWISKO || ' ' || PC.IMIE,
              PC.ADRMIEJSCOWOSC, PC.ADRKODPOCZTOWY,
              PC.ADRULICA, PC.ADRDOM, PC.ADRLOKAL, PC.DATAZGONU
            FROM PACJENCI PC
            WHERE PC.KLUCZ = :LOKATOR
            INTO
              :LNAZWA,
              :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
              :LADRULICA, :LADRDOM, :LADRLOKAL, :LDATAZGONU;

          IF (:LTYP = 'K')
          THEN
            SELECT
              FR.NAZWA,
              FR.ADRMIEJSCOWOSC, FR.ADRKODPOCZTOWY,
              FR.ADRULICA, FR.ADRDOM, FR.ADRLOKAL
            FROM FIRMY FR
            WHERE FR.KLUCZ = :LOKATOR
            INTO
              :LNAZWA,
              :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
              :LADRULICA, :LADRDOM, :LADRLOKAL;

          OPISLOKALU = :LNAZWA;
          OPISREKORDU = :OPISLOKALU;

          SUSPEND;
        END

        IF (:LOKATOR IS NULL)
        THEN SUSPEND;
      END

      IF (:POMIESZCZENIE IS NULL)
      THEN SUSPEND;
    END
    IF (:BUDOWLA IS NULL)
    THEN SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^


/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE INFRASTRUKTURA_ROZRACHUNKI(
  APOMIESZCZENIE     KLUCZ,
  ALOKATOR           INTEGER,
  ALTYP              VARCHAR(1),
  NA_DZIEN           TIMESTAMP
  )
RETURNS(
  OSIEDLE           INTEGER,
  OIDENT            VARCHAR(15),
  ONAZWA            VARCHAR(60),

  NIERUCHOMOSC      INTEGER,
  NIDENT            VARCHAR(30),
  NNAZWA            VARCHAR(60),

  NRODZAJ_WLASNOSCI VARCHAR(3),
  NWSPOLNOTA        INTEGER,

  NADRMIEJSCOWOSC   VARCHAR(40),
  NADRKODPOCZTOWY   VARCHAR(6),
  NADRULICA         VARCHAR(60),
  NADRDOM           VARCHAR(10),
  OPISNIERUCHOMOSCI VARCHAR(100),

  BUDOWLA           INTEGER,
  BIDENT            VARCHAR(15),
  BRODZAJ           VARCHAR(3),

  BADRMIEJSCOWOSC   VARCHAR(40),
  BADRKODPOCZTOWY   VARCHAR(6),
  BADRULICA         VARCHAR(60),
  BADRDOM           VARCHAR(10),
  OPISBUDYNKU       VARCHAR(100),

  POMIESZCZENIE     KLUCZ,
  PIDENT            VARCHAR(15),
  PRODZAJ           VARCHAR(3),
  PRODZAJ_WLASNOSCI VARCHAR(3),
  PSPD_OD           TIMESTAMP,
  PSPD_DO           TIMESTAMP,
  OPISLOKALU        VARCHAR(100),
  KLATKA            VARCHAR(5),
  PIETRO            DOUBLE PRECISION,

  ZTYP              VARCHAR(3),
  NR_EWID           VARCHAR(15),

  LOKATOR           INTEGER,
  LTYP              VARCHAR(1),
  LNAZWA            VARCHAR(80),
  LDATAZGONU        TIMESTAMP,

  LADRMIEJSCOWOSC   VARCHAR(40),
  LADRKODPOCZTOWY   VARCHAR(6),
  LADRULICA         VARCHAR(60),
  LADRDOM           VARCHAR(10),
  LADRLOKAL         VARCHAR(5),

  ILOSC             INTEGER
  )
AS
BEGIN
  OSIEDLE           = NULL;
  OIDENT            = NULL;
  ONAZWA            = NULL;

  NIERUCHOMOSC      = NULL;
  NIDENT            = NULL;
  NNAZWA            = NULL;

  NRODZAJ_WLASNOSCI = NULL;
  NWSPOLNOTA        = NULL;

  NADRMIEJSCOWOSC   = NULL;
  NADRKODPOCZTOWY   = NULL;
  NADRULICA         = NULL;
  NADRDOM           = NULL;
  OPISNIERUCHOMOSCI = NULL;

  BUDOWLA           = NULL;
  BIDENT            = NULL;
  BRODZAJ           = NULL;

  BADRMIEJSCOWOSC   = NULL;
  BADRKODPOCZTOWY   = NULL;
  BADRULICA         = NULL;
  BADRDOM           = NULL;
  OPISBUDYNKU       = NULL;

  PIDENT            = NULL;
  PRODZAJ           = NULL;
  PRODZAJ_WLASNOSCI = NULL;
  PSPD_OD           = NULL;
  PSPD_DO           = NULL;
  OPISLOKALU        = NULL;
  KLATKA            = NULL;
  PIETRO            = NULL;

  ZTYP              = NULL;
  NR_EWID           = NULL;

  LNAZWA            = NULL;
  LDATAZGONU        = NULL;

  LADRMIEJSCOWOSC   = NULL;
  LADRKODPOCZTOWY   = NULL;
  LADRULICA         = NULL;
  LADRDOM           = NULL;
  LADRLOKAL         = NULL;

  POMIESZCZENIE     = NULL;
  LOKATOR           = NULL;
  LTYP              = NULL;

  ILOSC = 0;

  IF (:APOMIESZCZENIE IS NOT NULL AND :APOMIESZCZENIE > 0)
  THEN BEGIN
    SELECT
      O.KLUCZ, O.IDENT, O.NAZWA,
      N.KLUCZ, N.IDENT, N.NAZWA,
      N.RODZAJ_WLASNOSCI, N.WSPOLNOTA,
      N.ADRMIEJSCOWOSC, N.ADRKODPOCZTOWY, N.ADRULICA, N.ADRDOM,
      B.KLUCZ, B.IDENT, B.RODZAJ,
      B.ADRMIEJSCOWOSC, B.ADRKODPOCZTOWY, B.ADRULICA, B.ADRDOM,
      P.KLUCZ, P.BUDOWLA, P.IDENT, P.RODZAJ, P.RODZAJ_WLASNOSCI, P.SPD_OD, P.SPD_DO, P.KLATKA, P.PIETRO
    FROM POMIESZCZENIA P, BUDOWLE B, NIERUCHOMOSCI N, OSIEDLA O
    WHERE
      P.KLUCZ = :APOMIESZCZENIE AND
      B.KLUCZ = P.BUDOWLA AND N.KLUCZ = B.NIERUCHOMOSC AND O.KLUCZ = N.OSIEDLE
    INTO
      :OSIEDLE, :OIDENT, :ONAZWA,
      :NIERUCHOMOSC, :NIDENT, :NNAZWA,
      :NRODZAJ_WLASNOSCI, :NWSPOLNOTA,
      :NADRMIEJSCOWOSC, :NADRKODPOCZTOWY, :NADRULICA, :NADRDOM,
      :BUDOWLA, :BIDENT, :BRODZAJ,
      :BADRMIEJSCOWOSC, :BADRKODPOCZTOWY, :BADRULICA, :BADRDOM,
      :POMIESZCZENIE, :BUDOWLA, :PIDENT, :PRODZAJ, :PRODZAJ_WLASNOSCI, :PSPD_OD, :PSPD_DO, :KLATKA, :PIETRO;

    IF (:NADRKODPOCZTOWY IS NULL) THEN NADRKODPOCZTOWY = '';
    IF (:NADRMIEJSCOWOSC IS NULL) THEN NADRMIEJSCOWOSC = '';
    IF (:NADRULICA IS NULL) THEN NADRULICA = '';
    IF (:NADRDOM IS NULL) THEN NADRDOM = '';

    OPISNIERUCHOMOSCI =
      :NADRKODPOCZTOWY || ' ' || :NADRMIEJSCOWOSC || ', ' ||
      :NADRULICA || ' ' || :NADRDOM;

    IF (:BADRKODPOCZTOWY IS NULL) THEN BADRKODPOCZTOWY = '';
    IF (:BADRMIEJSCOWOSC IS NULL) THEN BADRMIEJSCOWOSC = '';
    IF (:BADRULICA IS NULL) THEN BADRULICA = '';
    IF (:BADRDOM IS NULL) THEN BADRDOM = '';

    OPISBUDYNKU =
      :BADRKODPOCZTOWY || ' ' || :BADRMIEJSCOWOSC || ', ' ||
      :BADRULICA || ' ' || :BADRDOM;

    OPISLOKALU = '';
    IF (:PRODZAJ = 'MSZ')      THEN OPISLOKALU = 'Lokal mieszkalny';
    ELSE IF (:PRODZAJ = 'UZT') THEN OPISLOKALU = 'Lokal niemieszkalny';
    ELSE IF (:PRODZAJ = 'GRZ') THEN OPISLOKALU = 'Pomieszczenie garazowe';
    ELSE IF (:PRODZAJ = 'BKS') THEN OPISLOKALU = 'Boks';
    ELSE IF (:PRODZAJ = 'GSP') THEN OPISLOKALU = 'Pomieszczenie gospodarcze';
    ELSE IF (:PRODZAJ = 'DRZ') THEN OPISLOKALU = 'Dzierzawa terenu';

    SELECT Z.TYP, Z.NR_EWID
    FROM ZASIEDLENIA Z
    WHERE
      Z.LOKAL = :APOMIESZCZENIE AND
      Z.DATA_OD <= :NA_DZIEN AND
      (Z.DATA_DO IS NULL OR Z.DATA_DO >= :NA_DZIEN)
    INTO :ZTYP, :NR_EWID;

    ILOSC = 1;
  END

  IF (:ALOKATOR IS NOT NULL AND :ALOKATOR > 0 AND :ALTYP IS NOT NULL AND :ALTYP <> '')
  THEN BEGIN
    LOKATOR = :ALOKATOR;
    LTYP = :ALTYP;

    IF (:ALTYP = 'C')
    THEN
      SELECT
        PC.NAZWISKO || ' ' || PC.IMIE,
        PC.ADRMIEJSCOWOSC, PC.ADRKODPOCZTOWY,
        PC.ADRULICA, PC.ADRDOM, PC.ADRLOKAL, PC.DATAZGONU
      FROM PACJENCI PC
      WHERE PC.KLUCZ = :ALOKATOR
      INTO
        :LNAZWA,
        :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
        :LADRULICA, :LADRDOM, :LADRLOKAL, :LDATAZGONU;

    IF (:ALTYP = 'K')
    THEN
      SELECT
        FR.NAZWA,
        FR.ADRMIEJSCOWOSC, FR.ADRKODPOCZTOWY,
        FR.ADRULICA, FR.ADRDOM, FR.ADRLOKAL
      FROM FIRMY FR
      WHERE FR.KLUCZ = :ALOKATOR
      INTO
        :LNAZWA,
        :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
        :LADRULICA, :LADRDOM, :LADRLOKAL;

    IF (:APOMIESZCZENIE IS NOT NULL AND :APOMIESZCZENIE > 0)
    THEN BEGIN
      OPISLOKALU = :LNAZWA;
    END

    ILOSC = 1;
  END

  SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE INFRASTRUKTURA_KONTYNUACJE(
  APOCZATEK TIMESTAMP,
  AKONIEC   TIMESTAMP)
RETURNS(
  OSIEDLE            INTEGER,
  OIDENT             VARCHAR(15),
  ONAZWA             VARCHAR(60),

  NIERUCHOMOSC       INTEGER,
  NIDENT             VARCHAR(30),
  NNAZWA             VARCHAR(60),

  NRODZAJ_WLASNOSCI  VARCHAR(3),
  NWSPOLNOTA         INTEGER,

  NADRMIEJSCOWOSC    VARCHAR(40),
  NADRKODPOCZTOWY    VARCHAR(6),
  NADRULICA          VARCHAR(60),
  NADRDOM            VARCHAR(10),
  OPISNIERUCHOMOSCI  VARCHAR(100),

  BUDOWLA            INTEGER,
  BIDENT             VARCHAR(15),
  BRODZAJ            VARCHAR(3),
  BADRMIEJSCOWOSC    VARCHAR(40),
  BADRKODPOCZTOWY    VARCHAR(6),
  BADRULICA          VARCHAR(60),
  BADRDOM            VARCHAR(10),
  OPISBUDYNKU        VARCHAR(100),
  B_PP_WODA          INTEGER,
  B_PP_GAZ           INTEGER,
  B_PP_CO            INTEGER,
  B_PP_SWIATLO       INTEGER,
  BWODA_ZIMNA        VARCHAR(1),
  BWODA_CIEPLA       VARCHAR(1),
  BGAZ               VARCHAR(1),
  BCO                VARCHAR(1),
  BKANALIZACJA       VARCHAR(1),
  BSEGREGACJA_SMIECI VARCHAR(1),

  POMIESZCZENIE      KLUCZ,
  PIDENT             VARCHAR(15),
  PRODZAJ            VARCHAR(3),
  PRODZAJ_WLASNOSCI  VARCHAR(3),
  PSPD_OD           TIMESTAMP,
  PSPD_DO           TIMESTAMP,
  OPISLOKALU         VARCHAR(100),
  KLATKA             VARCHAR(5),
  PIETRO             DOUBLE PRECISION,
  P_PP_WODA          INTEGER,
  P_PP_GAZ           INTEGER,
  P_PP_CO            INTEGER,
  P_PP_SWIATLO       INTEGER,
  PWODA_ZIMNA        VARCHAR(3),
  PWODA_CIEPLA       VARCHAR(3),
  PCO                VARCHAR(3),
  PSWIATLO           VARCHAR(3),
  PGAZ               VARCHAR(3),
  PKANALIZACJA       VARCHAR(3),

  ZASIEDLENIE        INTEGER,
  KZASIEDLENIE       INTEGER,
  ZNR_EWID           VARCHAR(15),
  ZTYP               VARCHAR(3),
  ZPODRODZAJ         VARCHAR(3),
  ZDATA_OD           TIMESTAMP,
  ZDATA_DO           TIMESTAMP,
  ZTERMIN            DOUBLE PRECISION,
  ZRODZAJ_POJEMNIKOW     INTEGER, 
  ZILOSC_POJEMNIKOW      INTEGER, 
  ZCZESTOTLIWOSC_ODBIORU DOUBLE PRECISION,
  ZWSK_FAKTURY       VARCHAR(1),
  ZRODZAJ_WLASNOSCI  VARCHAR(3),

  LOKATOR            INTEGER,
  LTYP               VARCHAR(1),
  LNAZWA             VARCHAR(80),
  LDATAZGONU         TIMESTAMP,

  LADRMIEJSCOWOSC    VARCHAR(40),
  LADRKODPOCZTOWY    VARCHAR(6),
  LADRULICA          VARCHAR(60),
  LADRDOM            VARCHAR(10),
  LADRLOKAL          VARCHAR(5),

  OPISREKORDU        VARCHAR(100)
  )
AS
DECLARE VARIABLE MAXPOCZATEK TIMESTAMP;
DECLARE VARIABLE MAXKONIEC TIMESTAMP;
BEGIN
  FOR SELECT
    O.KLUCZ, O.IDENT, O.NAZWA,
    N.KLUCZ, N.IDENT, N.NAZWA,
    N.RODZAJ_WLASNOSCI, N.WSPOLNOTA,
    N.ADRMIEJSCOWOSC, N.ADRKODPOCZTOWY, N.ADRULICA, N.ADRDOM
  FROM OSIEDLA O, NIERUCHOMOSCI N
  WHERE N.OSIEDLE = O.KLUCZ
  INTO
    :OSIEDLE, :OIDENT, :ONAZWA,
    :NIERUCHOMOSC, :NIDENT, :NNAZWA,
    :NRODZAJ_WLASNOSCI, :NWSPOLNOTA,
    :NADRMIEJSCOWOSC, :NADRKODPOCZTOWY, :NADRULICA, :NADRDOM
  DO BEGIN
    IF (:NADRKODPOCZTOWY IS NULL) THEN NADRKODPOCZTOWY = '';
    IF (:NADRMIEJSCOWOSC IS NULL) THEN NADRMIEJSCOWOSC = '';
    IF (:NADRULICA IS NULL) THEN NADRULICA = '';
    IF (:NADRDOM IS NULL) THEN NADRDOM = '';

    OPISNIERUCHOMOSCI =
      :NADRKODPOCZTOWY || ' ' || :NADRMIEJSCOWOSC || ', ' ||
      :NADRULICA || ' ' || :NADRDOM;
    OPISREKORDU = :OPISNIERUCHOMOSCI;

    BUDOWLA           = NULL;
    BIDENT            = NULL;
    BRODZAJ           = NULL;

    BADRMIEJSCOWOSC   = NULL;
    BADRKODPOCZTOWY   = NULL;
    BADRULICA         = NULL;
    BADRDOM           = NULL;
    OPISBUDYNKU       = NULL;

    POMIESZCZENIE     = NULL;
    PIDENT            = NULL;
    PRODZAJ           = NULL;
    PRODZAJ_WLASNOSCI = NULL;
    PSPD_OD           = NULL;
    PSPD_DO           = NULL;
    OPISLOKALU        = NULL;
    KLATKA            = NULL;
    PIETRO            = NULL;

    ZASIEDLENIE       = NULL;
    KZASIEDLENIE      = NULL;
    ZNR_EWID          = NULL;
    ZTYP              = NULL;
    ZPODRODZAJ        = NULL;

    LOKATOR           = NULL;
    LTYP              = NULL;
    LNAZWA            = NULL;
    LDATAZGONU        = NULL;

    LADRMIEJSCOWOSC   = NULL;
    LADRKODPOCZTOWY   = NULL;
    LADRULICA         = NULL;
    LADRDOM           = NULL;
    LADRLOKAL         = NULL;

    FOR SELECT
      B.KLUCZ, B.IDENT, B.RODZAJ,
      B.PP_WODA, B.PP_GAZ, B.PP_CO, B.PP_SWIATLO, B.SEGREGACJA_SMIECI,
      B.WODA_ZIMNA, B.WODA_CIEPLA, B.GAZ, B.CO, B.KANALIZACJA,
      B.ADRMIEJSCOWOSC, B.ADRKODPOCZTOWY, B.ADRULICA, B.ADRDOM
    FROM BUDOWLE B
    WHERE B.NIERUCHOMOSC = :NIERUCHOMOSC
    INTO
      :BUDOWLA, :BIDENT, :BRODZAJ,
      :B_PP_WODA, :B_PP_GAZ, :B_PP_CO, :B_PP_SWIATLO, :BSEGREGACJA_SMIECI,
      :BWODA_ZIMNA, :BWODA_CIEPLA, :BGAZ, :BCO, :BKANALIZACJA,
      :BADRMIEJSCOWOSC, :BADRKODPOCZTOWY, :BADRULICA, :BADRDOM
    DO BEGIN
      IF (:BADRKODPOCZTOWY IS NULL) THEN BADRKODPOCZTOWY = '';
      IF (:BADRMIEJSCOWOSC IS NULL) THEN BADRMIEJSCOWOSC = '';
      IF (:BADRULICA IS NULL) THEN BADRULICA = '';
      IF (:BADRDOM IS NULL) THEN BADRDOM = '';

      OPISBUDYNKU =
        :BADRKODPOCZTOWY || ' ' || :BADRMIEJSCOWOSC || ', ' ||
        :BADRULICA || ' ' || :BADRDOM;
      OPISREKORDU = :OPISBUDYNKU;

      POMIESZCZENIE     = NULL;
      PIDENT            = NULL;
      PRODZAJ           = NULL;
      PRODZAJ_WLASNOSCI = NULL;
      PSPD_OD           = NULL;
      PSPD_DO           = NULL;
      OPISLOKALU        = NULL;
      KLATKA            = NULL;
      PIETRO            = NULL;

      ZASIEDLENIE       = NULL;
      KZASIEDLENIE      = NULL;
      ZNR_EWID          = NULL;
      ZTYP              = NULL;
      ZPODRODZAJ        = NULL;
      ZWSK_FAKTURY      = NULL;

      LOKATOR           = NULL;
      LTYP              = NULL;
      LNAZWA            = NULL;
      LDATAZGONU        = NULL;

      LADRMIEJSCOWOSC   = NULL;
      LADRKODPOCZTOWY   = NULL;
      LADRULICA         = NULL;
      LADRDOM           = NULL;
      LADRLOKAL         = NULL;
      
      FOR SELECT
        P.KLUCZ, P.IDENT, P.RODZAJ, P.RODZAJ_WLASNOSCI, P.SPD_OD, P.SPD_DO, P.KLATKA, P.PIETRO,
        P.PP_WODA, P.PP_GAZ, P.PP_CO, P.PP_SWIATLO,
        P.WODA_ZIMNA, P.WODA_CIEPLA, P.GAZ, P.ENERGIA_CIEPLNA, 
        P.ENERGIA_ELEKTRYCZNA, P.SCIEKI
      FROM POMIESZCZENIA P
      WHERE P.BUDOWLA = :BUDOWLA
      INTO
        :POMIESZCZENIE, :PIDENT, :PRODZAJ, :PRODZAJ_WLASNOSCI, :PSPD_OD, :PSPD_DO, :KLATKA, :PIETRO,
        :P_PP_WODA, :P_PP_GAZ, :P_PP_CO, :P_PP_SWIATLO,
        :PWODA_ZIMNA, :PWODA_CIEPLA, :PGAZ, :PCO, 
        :PSWIATLO, :PKANALIZACJA
      DO BEGIN
        OPISLOKALU = '';
        IF (:PRODZAJ = 'MSZ')      THEN OPISLOKALU = 'Lokal mieszkalny';
        ELSE IF (:PRODZAJ = 'UZT') THEN OPISLOKALU = 'Lokal niemieszkalny';
        ELSE IF (:PRODZAJ = 'GRZ') THEN OPISLOKALU = 'Pomieszczenie garazowe';
        ELSE IF (:PRODZAJ = 'BKS') THEN OPISLOKALU = 'Boks';
        ELSE IF (:PRODZAJ = 'GSP') THEN OPISLOKALU = 'Pomieszczenie gospodarcze';
        ELSE IF (:PRODZAJ = 'DRZ') THEN OPISLOKALU = 'Dzierzawa terenu';
        OPISREKORDU = :OPISLOKALU;

        ZASIEDLENIE       = NULL;
        KZASIEDLENIE      = NULL;
        ZNR_EWID          = NULL;
        ZTYP              = NULL;
        ZPODRODZAJ        = NULL;

        LOKATOR           = NULL;
        LTYP              = NULL;
        LNAZWA            = NULL;
        LDATAZGONU        = NULL;

        LADRMIEJSCOWOSC   = NULL;
        LADRKODPOCZTOWY   = NULL;
        LADRULICA         = NULL;
        LADRDOM           = NULL;
        LADRLOKAL         = NULL;

        FOR SELECT DISTINCT
          K.KLUCZ_KONTYNUACJI, MIN(K.DATA_OD), MAX(K.DATA_OD)
        FROM ZASIEDLENIA K
        WHERE
          K.LOKAL = :POMIESZCZENIE AND
          (K.DATA_OD <= :AKONIEC AND (K.DATA_DO >= :APOCZATEK OR K.DATA_DO IS NULL))
        GROUP BY K.KLUCZ_KONTYNUACJI
        INTO
          :KZASIEDLENIE, :ZDATA_OD, :MAXPOCZATEK
        DO BEGIN
          FOR SELECT MAX(Z.DATA_DO)
          FROM ZASIEDLENIA Z
          WHERE Z.KLUCZ_KONTYNUACJI = :KZASIEDLENIE AND Z.DATA_OD = :MAXPOCZATEK
          INTO :ZDATA_DO
          DO IF ((:ZDATA_DO = '30-dec-1899') OR (:ZDATA_DO IS NULL))
          THEN MAXKONIEC = :AKONIEC;
          ELSE MAXKONIEC = :ZDATA_DO;

          FOR SELECT DISTINCT
            Z.KLUCZ, Z.NR_EWID, Z.TYP, Z.PODRODZAJ, Z.TERMIN, Z.WSK_FAKTURY,
            Z.RODZAJ_POJEMNIKOW, Z.ILOSC_POJEMNIKOW, Z.CZESTOTLIWOSC_ODBIORU,
            Z.RODZAJ_WLASNOSCI
          FROM ZASIEDLENIA Z
          WHERE Z.KLUCZ_KONTYNUACJI = :KZASIEDLENIE AND Z.DATA_OD = :MAXPOCZATEK
          INTO :ZASIEDLENIE, :ZNR_EWID, :ZTYP, :ZPODRODZAJ, :ZTERMIN, :ZWSK_FAKTURY,
            :ZRODZAJ_POJEMNIKOW, :ZILOSC_POJEMNIKOW, :ZCZESTOTLIWOSC_ODBIORU,
            :ZRODZAJ_WLASNOSCI
          DO BEGIN
            LOKATOR           = NULL;
            LTYP              = NULL;
            LNAZWA            = NULL;
            LDATAZGONU        = NULL;

            LADRMIEJSCOWOSC   = NULL;
            LADRKODPOCZTOWY   = NULL;
            LADRULICA         = NULL;
            LADRDOM           = NULL;
            LADRLOKAL         = NULL;

            FOR SELECT DISTINCT
              L.NAJEMCA, L.TYP_NAJEMCY
            FROM LOKATORZY L
            WHERE
              L.ZASIEDLENIE = :ZASIEDLENIE AND L.TYTUL IN ('G', 'P') AND
              (L.DATA_OD <= :MAXKONIEC AND (L.DATA_DO >= :MAXKONIEC OR L.DATA_DO IS NULL))
            INTO
              :LOKATOR, :LTYP
            DO BEGIN
              IF (:LTYP = 'C')
              THEN
                SELECT
                  PC.NAZWISKO || ' ' || PC.IMIE,
                  PC.ADRMIEJSCOWOSC, PC.ADRKODPOCZTOWY,
                  PC.ADRULICA, PC.ADRDOM, PC.ADRLOKAL, PC.DATAZGONU
                FROM PACJENCI PC
                WHERE PC.KLUCZ = :LOKATOR
                INTO
                  :LNAZWA,
                  :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
                  :LADRULICA, :LADRDOM, :LADRLOKAL, :LDATAZGONU;

              IF (:LTYP = 'K')
              THEN
                SELECT
                  FR.NAZWA,
                  FR.ADRMIEJSCOWOSC, FR.ADRKODPOCZTOWY,
                  FR.ADRULICA, FR.ADRDOM, FR.ADRLOKAL
                FROM FIRMY FR
                WHERE FR.KLUCZ = :LOKATOR
                INTO
                  :LNAZWA,
                  :LADRMIEJSCOWOSC, :LADRKODPOCZTOWY,
                  :LADRULICA, :LADRDOM, :LADRLOKAL;

              OPISLOKALU = :LNAZWA;
              OPISREKORDU = :OPISLOKALU;

              SUSPEND;
            END
          END

          IF (:LOKATOR IS NULL)
          THEN SUSPEND;
        END

        IF (:ZASIEDLENIE IS NULL)
        THEN SUSPEND;
      END
      IF (:POMIESZCZENIE IS NULL)
      THEN SUSPEND;
    END
    IF (:BUDOWLA IS NULL)
    THEN SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE SALDA_OGOLEM(
  aNa_dzien             TIMESTAMP,            /* podajemy dzien pozniej */
  arodzaj               VARCHAR(5),
  apodmiot              INTEGER          /* = 0 - wszystko, < 0 - tylko zera, > 0 - wskazany */
  )
RETURNS(
  TypDotyczy           VARCHAR(1),
  Klas_wkl             VARCHAR(3),
  Dotyczy              INTEGER,
  Klucz_obcy           INTEGER,
  TypSalda             VARCHAR(1),
  TypPozycji           VARCHAR(1),
  Naliczenie           VARCHAR(1),
  Podmiot              INTEGER,
  rodzaj               VARCHAR(5),
  Symbol               VARCHAR(40),
  winien               DOUBLE PRECISION,
  ma                   DOUBLE PRECISION,
  swinien              DOUBLE PRECISION,
  sma                  DOUBLE PRECISION,
  data_plat            TIMESTAMP              /* tylko dla faktur */
  )
AS
BEGIN
  FOR SELECT
    RZ.TypDotyczy, RZ.Dotyczy, RZ.Klucz_obcy, RZ.klas_wkl,
    RZ.TypSalda, RZ.TypPozycji, RZ.rodzaj, RZ.Symbol, RZ.Naliczenie, RZ.Podmiot,
    SUM(RZ.winien) AS winien, SUM(RZ.ma) AS ma
  FROM rozliczenia RZ
  WHERE
    (:apodmiot = 0
    OR
    :apodmiot < 0 AND (RZ.Podmiot = 0 OR
      (SELECT PM.Rodzaj_wlasnosci FROM Pomieszczenia PM
       WHERE PM.Klucz = RZ.Klucz_obcy) = 'SPD')
    OR
     :apodmiot > 0 AND :apodmiot = RZ.Podmiot)
    AND
    (RZ.saldo > 0 OR RZ.Rodzaj = 'C_DWJ') AND RZ.data_wyst < :aNa_dzien

  GROUP BY RZ.Dotyczy, RZ.TypDotyczy, RZ.Klucz_obcy,
    RZ.rodzaj, RZ.Symbol, RZ.TypSalda, RZ.klas_wkl, RZ.TypPozycji, RZ.Naliczenie, RZ.Podmiot
  HAVING (SUM(RZ.winien) - SUM(RZ.ma)) < -0.001 OR (SUM(RZ.winien) - SUM(RZ.ma)) > 0.001
    OR (SUM(RZ.ma) > 0.001 OR SUM(RZ.ma) < -0.001) AND RZ.Naliczenie = 'F'
  INTO
    :TypDotyczy, :Dotyczy, :Klucz_obcy, :klas_wkl, :TypSalda, :TypPozycji, :rodzaj, :Symbol,
    :naliczenie, :podmiot, :winien, :ma

  DO BEGIN
    IF (:aRodzaj = '' OR :Rodzaj = :aRodzaj)
    THEN BEGIN
      data_plat = NULL;
      IF (:rodzaj = 'C_FKT')
      THEN
        SELECT MIN(data_plat)
        FROM rozliczenia
        WHERE
          Winien > 0 AND
          TypDotyczy = :TypDotyczy AND Dotyczy = :Dotyczy AND Klucz_obcy = :Klucz_obcy AND
          TypSalda = :TypSalda AND TypPozycji = :TypPozycji AND klas_wkl = :klas_wkl AND
          Rodzaj = :Rodzaj AND Symbol = :Symbol
        INTO :data_plat;

      IF (:winien > :ma)
      THEN BEGIN
        swinien = :winien - :ma;
        sma = 0;
      END

      ELSE BEGIN
        swinien = 0;
        sma = :ma - :winien;
      END

      SUSPEND;
    END
  END
END ^

COMMIT WORK ^
SET TERM ; ^


COMMIT WORK;

/*---*/

SET TERM ^ ;

CREATE PROCEDURE SALDA_OGOLEM_DT_PLAT(
  aNa_dzien             TIMESTAMP,            /* podajemy dzien pozniej */
  arodzaj               VARCHAR(5),
  adata_plat            TIMESTAMP,            /* do podanej daty - te dzien pozniej */
  apodmiot              INTEGER          /* = 0 - wszystko, < 0 - tylko zera, > 0 - wskazany */
  )
RETURNS(
  TypDotyczy           VARCHAR(1),
  Klas_wkl             VARCHAR(3),
  Dotyczy              INTEGER,
  Klucz_obcy           INTEGER,
  TypSalda             VARCHAR(1),
  TypPozycji           VARCHAR(1),
  Naliczenie           VARCHAR(1),
  Podmiot              INTEGER,
  rodzaj               VARCHAR(5),
  Symbol               VARCHAR(40),
  winien               DOUBLE PRECISION,
  ma                   DOUBLE PRECISION,
  swinien              DOUBLE PRECISION,
  sma                  DOUBLE PRECISION,
  data_plat            TIMESTAMP              /* dla faktur */
  )
AS
BEGIN
  FOR SELECT
    RZ.TypDotyczy, RZ.Dotyczy, RZ.Klucz_obcy, RZ.klas_wkl, 
    RZ.TypSalda, RZ.TypPozycji, RZ.rodzaj, RZ.Symbol, RZ.Naliczenie, RZ.Podmiot,
    SUM(RZ.winien) AS winien, SUM(RZ.ma) AS ma
  FROM rozliczenia RZ
  WHERE
    (:apodmiot = 0
    OR
    :apodmiot < 0 AND (RZ.Podmiot = 0 OR
      (SELECT PM.Rodzaj_wlasnosci FROM Pomieszczenia PM
       WHERE PM.Klucz = RZ.Klucz_obcy) = 'SPD')
    OR
     :apodmiot > 0 AND :apodmiot = RZ.Podmiot)
    AND
    (RZ.saldo > 0 OR RZ.Rodzaj = 'C_DWJ') AND RZ.data_wyst < :aNa_dzien
    AND
    (:adata_plat < '02-jan-1900' OR     /* to na wszelki wypadek, data powinna byc zawsze */
     RZ.Rodzaj = 'C_FKT' OR       /* dla faktur warunek zewnetrzny */
     RZ.Rodzaj <> 'C_FKT' AND
    /* RZ.Winien >= 0.001 AND */ RZ.data_plat < :aData_plat)

  GROUP BY RZ.Dotyczy, RZ.TypDotyczy, RZ.Klucz_obcy,
    RZ.rodzaj, RZ.Symbol, RZ.TypSalda, RZ.klas_wkl, RZ.TypPozycji, RZ.Naliczenie, RZ.Podmiot
  HAVING (SUM(RZ.winien) - SUM(RZ.ma)) < -0.001 OR (SUM(RZ.winien) - SUM(RZ.ma)) > 0.001
    OR (SUM(RZ.ma) > 0.001 OR SUM(RZ.ma) < -0.001) AND RZ.Naliczenie = 'F'
  INTO
    :TypDotyczy, :Dotyczy, :Klucz_obcy, :Klas_wkl, :TypSalda, :TypPozycji, :rodzaj, :Symbol,
    :naliczenie, :podmiot, :winien, :ma

  DO BEGIN
    IF (:aRodzaj = '' OR :Rodzaj = :aRodzaj)
    THEN BEGIN
      data_plat = NULL;
      IF (:rodzaj = 'C_FKT')
      THEN
        SELECT MIN(data_plat)
        FROM rozliczenia
        WHERE
          Winien > 0 AND
          TypDotyczy = :TypDotyczy AND Dotyczy = :Dotyczy AND Klucz_obcy = :Klucz_obcy AND
          TypSalda = :TypSalda AND TypPozycji = :TypPozycji AND Klas_wkl = :klas_wkl AND
          Rodzaj = :Rodzaj AND Symbol = :Symbol
        INTO :data_plat;

      IF (:winien > :ma)
      THEN BEGIN
        swinien = :winien - :ma;
        sma = 0;
      END

      ELSE BEGIN
        swinien = 0;
        sma = :ma - :winien;
      END

      SUSPEND;
    END
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*---*/


SET TERM ^ ;

CREATE PROCEDURE SALDA_DLA_WINDYKACJI(
  aOst_klucz            INTEGER,
  aTypDotyczy           VARCHAR(1),
  aDotyczy              INTEGER,
  aKlucz_obcy           INTEGER,
  arodzaj               VARCHAR(5),
  aSprawaSadowa         INTEGER,
  apodmiot              INTEGER          /* = 0 - wszystko, < 0 - tylko zera, > 0 - wskazany */
  )
RETURNS(
  TypDotyczy           VARCHAR(1),
  Klas_wkl             VARCHAR(3),
  Dotyczy              INTEGER,
  Klucz_obcy           INTEGER,
  TypSalda             VARCHAR(1),
  TypPozycji           VARCHAR(1),
  Naliczenie           VARCHAR(1),
  Podmiot              INTEGER,
  rodzaj               VARCHAR(5),
  Symbol               VARCHAR(40),
  winien               DOUBLE PRECISION,
  ma                   DOUBLE PRECISION,
  swinien              DOUBLE PRECISION,
  sma                  DOUBLE PRECISION,
  data_plat            TIMESTAMP              /* tylko dla faktur */
  )
AS
BEGIN
  FOR SELECT
    RZ.TypDotyczy, RZ.Dotyczy, RZ.Klucz_obcy, RZ.klas_wkl,
    RZ.TypSalda, RZ.TypPozycji, RZ.rodzaj, RZ.Symbol, RZ.Naliczenie, RZ.Podmiot,
    SUM(RZ.winien) AS winien, SUM(RZ.ma) AS ma
  FROM rozliczenia RZ
  WHERE
    (:apodmiot = 0
    OR
    :apodmiot < 0 AND (RZ.Podmiot = 0 OR
      (SELECT PM.Rodzaj_wlasnosci FROM Pomieszczenia PM
       WHERE PM.Klucz = RZ.Klucz_obcy) = 'SPD')
    OR
     :apodmiot > 0 AND :apodmiot = RZ.Podmiot)
    AND
    RZ.saldo > 0 AND RZ.Klucz <= :aOst_klucz
    AND
    RZ.TypDotyczy = :aTypDotyczy AND
    RZ.Dotyczy = :aDotyczy AND
    RZ.Klucz_obcy = :aKlucz_obcy AND
    (:aRodzaj = '' OR RZ.Rodzaj = :aRodzaj) AND
    (:aSprawaSadowa = 0 OR :aSprawaSadowa < 0 AND RZ.Sprawa_sadowa > 0 OR
     :aSprawaSadowa > 0 AND RZ.Sprawa_sadowa = :aSprawaSadowa)

  GROUP BY RZ.Dotyczy, RZ.TypDotyczy, RZ.Klucz_obcy,
    RZ.rodzaj, RZ.Symbol, RZ.TypSalda, RZ.klas_wkl, RZ.TypPozycji, RZ.Naliczenie, RZ.Podmiot
  HAVING (SUM(RZ.winien) - SUM(RZ.ma)) < -0.001 OR (SUM(RZ.winien) - SUM(RZ.ma)) > 0.001
    OR (SUM(RZ.ma) > 0.001 OR SUM(RZ.ma) < -0.001) AND RZ.Naliczenie = 'F'
  INTO
    :TypDotyczy, :Dotyczy, :Klucz_obcy, :klas_wkl, :TypSalda, :TypPozycji, :rodzaj, :Symbol,
    :naliczenie, :podmiot, :winien, :ma

  DO BEGIN
    data_plat = NULL;
    IF (:rodzaj = 'C_FKT')
    THEN
      SELECT MIN(data_plat)
      FROM rozliczenia
      WHERE
        Winien > 0 AND
        TypDotyczy = :TypDotyczy AND Dotyczy = :Dotyczy AND Klucz_obcy = :Klucz_obcy AND
        TypSalda = :TypSalda AND TypPozycji = :TypPozycji AND klas_wkl = :klas_wkl AND
        Rodzaj = :Rodzaj AND Symbol = :Symbol
      INTO :data_plat;

    IF (:winien > :ma)
    THEN BEGIN
      swinien = :winien - :ma;
      sma = 0;
    END

    ELSE BEGIN
      swinien = 0;
      sma = :ma - :winien;
    END

    SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^


/*---*/

SET TERM ^ ;

CREATE PROCEDURE SALDA_OSOB_LOKALI(
  aNa_dzien             TIMESTAMP,            /* podajemy dzien pozniej */
  aTypDotyczy           VARCHAR(1),
  aDotyczy              INTEGER,
  aKlucz_obcy           INTEGER,
  arodzaj               VARCHAR(5),
  adata_plat            TIMESTAMP,             /* do podanej daty - te dzien pozniej */
  aSprawaSadowa         INTEGER,
  apodmiot              INTEGER          /* = 0 - wszystko, < 0 - tylko zera, > 0 - wskazany */
  )
RETURNS(
  TypDotyczy           VARCHAR(1),
  Klas_wkl             VARCHAR(3),
  Dotyczy              INTEGER,
  Klucz_obcy           INTEGER,
  TypSalda             VARCHAR(1),
  TypPozycji           VARCHAR(1),
  Naliczenie           VARCHAR(1),
  Podmiot              INTEGER,
  rodzaj               VARCHAR(5),
  Symbol               VARCHAR(40),
  winien               DOUBLE PRECISION,
  ma                   DOUBLE PRECISION,
  swinien              DOUBLE PRECISION,
  sma                  DOUBLE PRECISION,
  data_plat            TIMESTAMP              /* dla faktur */
  )
AS
BEGIN
  FOR SELECT
    RZ.TypDotyczy, RZ.Dotyczy, RZ.Klucz_obcy, RZ.klas_wkl,
    RZ.TypSalda, RZ.TypPozycji, RZ.rodzaj, RZ.Symbol, RZ.Naliczenie, RZ.Podmiot,
    SUM(RZ.winien) AS winien, SUM(RZ.ma) AS ma
  FROM rozliczenia RZ
  WHERE
    (:apodmiot = 0
    OR
    :apodmiot < 0 AND (RZ.Podmiot = 0 OR
      (SELECT PM.Rodzaj_wlasnosci FROM Pomieszczenia PM
       WHERE PM.Klucz = RZ.Klucz_obcy) = 'SPD')
    OR
     :apodmiot > 0 AND :apodmiot = RZ.Podmiot)
    AND
    (RZ.saldo > 0 OR RZ.Rodzaj = 'C_DWJ') AND RZ.data_wyst < :aNa_dzien
    AND
    RZ.TypDotyczy = :aTypDotyczy AND
    RZ.Dotyczy = :aDotyczy AND
    RZ.Klucz_obcy = :aKlucz_obcy AND
    (:aRodzaj = '' OR RZ.Rodzaj = :aRodzaj) AND
    (:aSprawaSadowa = 0 OR :aSprawaSadowa < 0 AND RZ.Sprawa_sadowa > 0 OR
     :aSprawaSadowa > 0 AND RZ.Sprawa_sadowa = :aSprawaSadowa)
    AND
    (:adata_plat < '02-jan-1900' OR RZ.Rodzaj = 'C_FKT' OR       /* dla faktur warunek zewnetrzny */
     :adata_plat > '01-jan-1900' AND RZ.Rodzaj <> 'C_FKT' AND
    /* RZ.Winien > 0.001 */  RZ.data_plat < :aData_plat)

  GROUP BY RZ.Dotyczy, RZ.TypDotyczy, RZ.Klucz_obcy,
    RZ.rodzaj, RZ.Symbol, RZ.TypSalda, RZ.klas_wkl, RZ.TypPozycji, RZ.Naliczenie, RZ.Podmiot
  HAVING (SUM(RZ.winien) - SUM(RZ.ma)) < -0.001 OR (SUM(RZ.winien) - SUM(RZ.ma)) > 0.001
    OR (SUM(RZ.ma) > 0.001 OR SUM(RZ.ma) < -0.001) AND RZ.Naliczenie = 'F'
  INTO
    :TypDotyczy, :Dotyczy, :Klucz_obcy, :klas_wkl, :TypSalda, :TypPozycji, :rodzaj, :Symbol,
    :naliczenie, :podmiot, :winien, :ma

  DO BEGIN
    data_plat = NULL;
    IF (:rodzaj = 'C_FKT')
    THEN
      SELECT MIN(data_plat)
      FROM rozliczenia
      WHERE
        Winien > 0 AND
        TypDotyczy = :TypDotyczy AND Dotyczy = :Dotyczy AND Klucz_obcy = :Klucz_obcy AND
        TypSalda = :TypSalda AND TypPozycji = :TypPozycji AND Klas_wkl = :klas_wkl AND
        Rodzaj = :Rodzaj AND Symbol = :Symbol
      INTO :data_plat;

    IF (:winien > :ma)
    THEN BEGIN
      swinien = :winien - :ma;
      sma = 0;
    END

    ELSE BEGIN
      swinien = 0;
      sma = :ma - :winien;
    END

    SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*---*/

SET TERM ^ ;

CREATE PROCEDURE SALDA_OSOB(
  aNa_dzien             TIMESTAMP,            /* podajemy dzien pozniej */
  aTypDotyczy           VARCHAR(1),
  aDotyczy              INTEGER,
  arodzaj               VARCHAR(5),
  adata_plat            TIMESTAMP,             /* do podanej daty - te dzien pozniej */
  aSprawaSadowa         INTEGER,
  apodmiot              INTEGER          /* = 0 - wszystko, < 0 - tylko zera, > 0 - wskazany */
  )
RETURNS(
  TypDotyczy           VARCHAR(1),
  Klas_wkl             VARCHAR(3),
  Dotyczy              INTEGER,
  Klucz_obcy           INTEGER,
  TypSalda             VARCHAR(1),
  TypPozycji           VARCHAR(1),
  Naliczenie           VARCHAR(1),
  Podmiot              INTEGER,
  rodzaj               VARCHAR(5),
  Symbol               VARCHAR(40),
  winien               DOUBLE PRECISION,
  ma                   DOUBLE PRECISION,
  swinien              DOUBLE PRECISION,
  sma                  DOUBLE PRECISION,
  data_plat            TIMESTAMP              /* dla faktur */
  )
AS
BEGIN
  FOR SELECT
    RZ.TypDotyczy, RZ.Dotyczy, RZ.Klucz_obcy, RZ.klas_wkl,
    RZ.TypSalda, RZ.TypPozycji, RZ.rodzaj, RZ.Symbol, RZ.Naliczenie, RZ.Podmiot,
    SUM(RZ.winien) AS winien, SUM(RZ.ma) AS ma
  FROM rozliczenia RZ
  WHERE
    (:apodmiot = 0
    OR
    :apodmiot < 0 AND (RZ.Podmiot = 0 OR
      (SELECT PM.Rodzaj_wlasnosci FROM Pomieszczenia PM
       WHERE PM.Klucz = RZ.Klucz_obcy) = 'SPD')
    OR
     :apodmiot > 0 AND :apodmiot = RZ.Podmiot)
    AND
    (RZ.saldo > 0 OR RZ.Rodzaj = 'C_DWJ') AND RZ.data_wyst < :aNa_dzien
    AND
    RZ.TypDotyczy = :aTypDotyczy AND
    RZ.Dotyczy = :aDotyczy AND
    (:aRodzaj = '' OR RZ.Rodzaj = :aRodzaj) AND
    (:aSprawaSadowa = 0 OR :aSprawaSadowa < 0 AND RZ.Sprawa_sadowa > 0 OR
     :aSprawaSadowa > 0 AND RZ.Sprawa_sadowa = :aSprawaSadowa)
    AND
    (:adata_plat < '02-jan-1900' OR RZ.Rodzaj = 'C_FKT' OR       /* dla faktur warunek zewnetrzny */
     :adata_plat > '01-jan-1900' AND RZ.Rodzaj <> 'C_FKT' AND
    /* RZ.Winien > 0.001 AND */ RZ.data_plat < :aData_plat)

  GROUP BY RZ.Dotyczy, RZ.TypDotyczy, RZ.Klucz_obcy,
    RZ.rodzaj, RZ.Symbol, RZ.TypSalda, RZ.klas_wkl, RZ.TypPozycji, RZ.Naliczenie, RZ.Podmiot
  HAVING (SUM(RZ.winien) - SUM(RZ.ma)) < -0.001 OR (SUM(RZ.winien) - SUM(RZ.ma)) > 0.001
    OR (SUM(RZ.ma) > 0.001 OR SUM(RZ.ma) < -0.001) AND RZ.Naliczenie = 'F'
  INTO
    :TypDotyczy, :Dotyczy, :Klucz_obcy, :klas_wkl, :TypSalda, :TypPozycji, :rodzaj, :Symbol,
    :naliczenie, :podmiot, :winien, :ma

  DO BEGIN
    data_plat = NULL;
    IF (:rodzaj = 'C_FKT')
    THEN
      SELECT MIN(data_plat)
      FROM rozliczenia
      WHERE
        Winien > 0 AND
        TypDotyczy = :TypDotyczy AND Dotyczy = :Dotyczy AND Klucz_obcy = :Klucz_obcy AND
        TypSalda = :TypSalda AND TypPozycji = :TypPozycji AND klas_wkl = :klas_wkl AND
        Rodzaj = :Rodzaj AND Symbol = :Symbol
      INTO :data_plat;

    IF (:winien > :ma)
    THEN BEGIN
      swinien = :winien - :ma;
      sma = 0;
    END

    ELSE BEGIN
      swinien = 0;
      sma = :ma - :winien; 
    END

    SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*---*/

SET TERM ^ ;

CREATE PROCEDURE SALDA_LOKALI(
  aNa_dzien             TIMESTAMP,            /* podajemy dzien pozniej */
  aKlucz_obcy           INTEGER,
  arodzaj               VARCHAR(5),
  adata_plat            TIMESTAMP,             /* do podanej daty - te dzien pozniej */
  aSprawaSadowa         INTEGER,
  apodmiot              INTEGER          /* = 0 - wszystko, < 0 - tylko zera, > 0 - wskazany */
  )
RETURNS(
  TypDotyczy           VARCHAR(1),
  Klas_wkl             VARCHAR(3),
  Dotyczy              INTEGER,
  Klucz_obcy           INTEGER,
  TypSalda             VARCHAR(1),
  TypPozycji           VARCHAR(1),
  Naliczenie           VARCHAR(1),
  Podmiot              INTEGER,
  rodzaj               VARCHAR(5),
  Symbol               VARCHAR(40),
  winien               DOUBLE PRECISION,
  ma                   DOUBLE PRECISION,
  swinien              DOUBLE PRECISION,
  sma                  DOUBLE PRECISION,
  data_plat            TIMESTAMP              /* tylko dla faktur */
  )
AS
BEGIN
  FOR SELECT
    RZ.TypDotyczy, RZ.Dotyczy, RZ.Klucz_obcy, RZ.klas_wkl,
    RZ.TypSalda, RZ.TypPozycji, RZ.rodzaj, RZ.Symbol, RZ.Naliczenie, RZ.Podmiot,
    SUM(RZ.winien) AS winien, SUM(RZ.ma) AS ma
  FROM rozliczenia RZ
  WHERE
    (RZ.saldo > 0 OR RZ.Rodzaj = 'C_DWJ') AND RZ.data_wyst < :aNa_dzien
    AND
    (:apodmiot = 0
    OR
    :apodmiot < 0 AND (RZ.Podmiot = 0 OR
      (SELECT PM.Rodzaj_wlasnosci FROM Pomieszczenia PM
       WHERE PM.Klucz = RZ.Klucz_obcy) = 'SPD')
    OR
     :apodmiot > 0 AND :apodmiot = RZ.Podmiot)
    AND
    RZ.Klucz_obcy = :aKlucz_obcy AND
    (:aRodzaj = '' OR RZ.Rodzaj = :aRodzaj) AND
    (:aSprawaSadowa = 0 OR :aSprawaSadowa < 0 AND RZ.Sprawa_sadowa > 0 OR
     :aSprawaSadowa > 0 AND RZ.Sprawa_sadowa = :aSprawaSadowa)
    AND
    (:adata_plat < '02-jan-1900' OR RZ.Rodzaj = 'C_FKT' OR       /* dla faktur warunek zewnetrzny */
     :adata_plat > '01-jan-1900' AND RZ.Rodzaj <> 'C_FKT' AND
    /* RZ.Winien > 0.001 AND */ RZ.data_plat < :aData_plat)

  GROUP BY RZ.Dotyczy, RZ.TypDotyczy, RZ.Klucz_obcy,
    RZ.rodzaj, RZ.Symbol, RZ.TypSalda, RZ.TypPozycji, RZ.Naliczenie, RZ.Podmiot, RZ.klas_wkl
  HAVING (SUM(RZ.winien) - SUM(RZ.ma)) < -0.001 OR (SUM(RZ.winien) - SUM(RZ.ma)) > 0.001
    OR (SUM(RZ.ma) > 0.001 OR SUM(RZ.ma) < -0.001) AND RZ.Naliczenie = 'F'
  INTO
    :TypDotyczy, :Dotyczy, :Klucz_obcy, :klas_wkl, :TypSalda, :TypPozycji, :rodzaj, :Symbol,
    :naliczenie, :podmiot, :winien, :ma

  DO BEGIN
    data_plat = NULL;
    IF (:rodzaj = 'C_FKT')
    THEN
      SELECT MIN(data_plat)
      FROM rozliczenia
      WHERE
        Winien > 0 AND
        TypDotyczy = :TypDotyczy AND Dotyczy = :Dotyczy AND Klucz_obcy = :Klucz_obcy AND
        TypSalda = :TypSalda AND TypPozycji = :TypPozycji AND
        Rodzaj = :Rodzaj AND Symbol = :Symbol
      INTO :data_plat;

    IF (:winien > :ma)
    THEN BEGIN
      swinien = :winien - :ma;
      sma = 0;
    END

    ELSE BEGIN
      swinien = 0;
      sma = :ma - :winien; 
    END

    SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;


/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE WYKAZ_ZASAD_CZYNSZOWYCH(
  NA_DZIEN      TIMESTAMP,
  AOSIEDLE      INTEGER,
  ATYP_BUDOWLI  VARCHAR(3),
  ATYP_LOKALU   VARCHAR(3),
  ATYP_ZASIEDL  VARCHAR(3))
RETURNS(
  OSIEDLE            INTEGER,
  TYP_BUDOWLI        VARCHAR(3),
  TYP_LOKALU         VARCHAR(3),
  TYP_ZASIEDL        VARCHAR(3),

  POCZATEK           TIMESTAMP,
  KONIEC             TIMESTAMP,
  TRYB_KON           VARCHAR(1),

  LP                 INTEGER,
  RODZAJ             INTEGER,
  DOTYCZY            VARCHAR(3),
  GRUPA              VARCHAR(1),
  BEZ_ROZRACHUNKOW   VARCHAR(1),
  ROZLICZENIE        VARCHAR(3),
  TYP_VAT            VARCHAR(1),
  CENA               DOUBLE PRECISION,
  BRUTTO_NETTO       VARCHAR(1),
  JM                 VARCHAR(3),
  NORMA              DOUBLE PRECISION,
  ILOSC              DOUBLE PRECISION,

  PIETRO_OD          DOUBLE PRECISION,
  PIETRO_DO          DOUBLE PRECISION,
  KLATKA             VARCHAR(5),
  UCHWALA            VARCHAR(100),

  BEZ_PROPORCJI      VARCHAR(1)
  )
AS
DECLARE VARIABLE WCIEPLA_LICZ_ROZL          VARCHAR(3);
DECLARE VARIABLE WCIEPLA_LICZ_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE WCIEPLA_LICZ_CENA          DOUBLE PRECISION;
DECLARE VARIABLE WCIEPLA_LICZ_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE WCIEPLA_LICZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE WCIEPLA_LICZ_JM            VARCHAR(3);

DECLARE VARIABLE WCIEPLA_RYCZ_ROZL          VARCHAR(3);
DECLARE VARIABLE WCIEPLA_RYCZ_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE WCIEPLA_RYCZ_RYCZALT       DOUBLE PRECISION;
DECLARE VARIABLE WCIEPLA_RYCZ_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE WCIEPLA_RYCZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE WCIEPLA_RYCZ_JM            VARCHAR(3);

DECLARE VARIABLE WZIMNA_LICZ_ROZL           VARCHAR(3);
DECLARE VARIABLE WZIMNA_LICZ_TYP_VAT        VARCHAR(1);
DECLARE VARIABLE WZIMNA_LICZ_CENA           DOUBLE PRECISION;
DECLARE VARIABLE WZIMNA_LICZ_NORMA          DOUBLE PRECISION;
DECLARE VARIABLE WZIMNA_LICZ_BRUTTO_NETTO   VARCHAR(1);
DECLARE VARIABLE WZIMNA_LICZ_JM             VARCHAR(3);

DECLARE VARIABLE WZIMNA_ROZL                VARCHAR(3);
DECLARE VARIABLE WZIMNA_TYP_VAT             VARCHAR(1);
DECLARE VARIABLE WZIMNA_CENA                DOUBLE PRECISION;
DECLARE VARIABLE WZIMNA_NORMA               DOUBLE PRECISION;
DECLARE VARIABLE WZIMNA_RYCZ_BRUTTO_NETTO   VARCHAR(1);
DECLARE VARIABLE WZIMNA_RYCZ_JM             VARCHAR(3);

DECLARE VARIABLE PODGRZANIE_RYCZ_ROZL         VARCHAR(3);
DECLARE VARIABLE PODGRZANIE_RYCZ_TYP_VAT      VARCHAR(1);
DECLARE VARIABLE PODGRZANIE_RYCZ_CENA         DOUBLE PRECISION;
DECLARE VARIABLE PODGRZANIE_RYCZ_BRUTTO_NETTO VARCHAR(1);
DECLARE VARIABLE PODGRZANIE_RYCZ_JM           VARCHAR(3);

DECLARE VARIABLE PODGRZANIE_LICZ_ROZL         VARCHAR(3);
DECLARE VARIABLE PODGRZANIE_LICZ_TYP_VAT      VARCHAR(1);
DECLARE VARIABLE PODGRZANIE_LICZ_CENA         DOUBLE PRECISION;
DECLARE VARIABLE PODGRZANIE_LICZ_BRUTTO_NETTO VARCHAR(1);
DECLARE VARIABLE PODGRZANIE_LICZ_JM           VARCHAR(3);

DECLARE VARIABLE WODA_ST_ROZL          VARCHAR(3);
DECLARE VARIABLE WODA_ST_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE WODA_ST_CENA          DOUBLE PRECISION;
DECLARE VARIABLE WODA_ST_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE WODA_ST_JM            VARCHAR(3);

DECLARE VARIABLE W_CO_KOSZT_ST_ROZL         VARCHAR(3);
DECLARE VARIABLE W_CO_KOSZT_ST_TYP_VAT      VARCHAR(1);
DECLARE VARIABLE W_CO_KOSZT_ST_CENA         DOUBLE PRECISION;
DECLARE VARIABLE W_CO_KOSZT_ST_BRUTTO_NETTO VARCHAR(1);
DECLARE VARIABLE W_CO_KOSZT_ST_JM           VARCHAR(3);

DECLARE VARIABLE CO_ROZL               VARCHAR(3);
DECLARE VARIABLE CO_TYP_VAT            VARCHAR(1);
DECLARE VARIABLE CO_CENA               DOUBLE PRECISION;
DECLARE VARIABLE CO_NORMA              DOUBLE PRECISION;
DECLARE VARIABLE CO_RYCZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE CO_RYCZ_JM            VARCHAR(3);

DECLARE VARIABLE CO_LICZ_ROZL	         VARCHAR(3);
DECLARE VARIABLE CO_LICZ_TYP_VAT	     VARCHAR(1);
DECLARE VARIABLE CO_LICZ_CENA	         DOUBLE PRECISION;
DECLARE VARIABLE CO_LICZ_NORMA	       DOUBLE PRECISION;
DECLARE VARIABLE CO_LICZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE CO_LICZ_JM            VARCHAR(3);

DECLARE VARIABLE SWIATLO_ROZL               VARCHAR(3);
DECLARE VARIABLE SWIATLO_TYP_VAT            VARCHAR(1);
DECLARE VARIABLE SWIATLO_CENA               DOUBLE PRECISION;
DECLARE VARIABLE SWIATLO_NORMA              DOUBLE PRECISION;
DECLARE VARIABLE SWIATLO_RYCZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE SWIATLO_RYCZ_JM            VARCHAR(3);

DECLARE VARIABLE SWIATLO_LICZ_ROZL          VARCHAR(3);
DECLARE VARIABLE SWIATLO_LICZ_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE SWIATLO_LICZ_CENA          DOUBLE PRECISION;
DECLARE VARIABLE SWIATLO_LICZ_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE SWIATLO_LICZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE SWIATLO_LICZ_JM            VARCHAR(3);

DECLARE VARIABLE GAZ_ROZL               VARCHAR(3);
DECLARE VARIABLE GAZ_TYP_VAT            VARCHAR(1);
DECLARE VARIABLE GAZ_CENA               DOUBLE PRECISION;
DECLARE VARIABLE GAZ_NORMA              DOUBLE PRECISION;
DECLARE VARIABLE GAZ_RYCZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE GAZ_RYCZ_JM            VARCHAR(3);

DECLARE VARIABLE GAZ_LICZ_ROZL          VARCHAR(3);
DECLARE VARIABLE GAZ_LICZ_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE GAZ_LICZ_CENA          DOUBLE PRECISION;
DECLARE VARIABLE GAZ_LICZ_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE GAZ_LICZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE GAZ_LICZ_JM            VARCHAR(3);

DECLARE VARIABLE SCIEKI_ROZL            VARCHAR(3);
DECLARE VARIABLE SCIEKI_TYP_VAT         VARCHAR(1);
DECLARE VARIABLE SCIEKI_CENA            DOUBLE PRECISION;
DECLARE VARIABLE SCIEKI_NORMA           DOUBLE PRECISION;
DECLARE VARIABLE SCIEKI_BRUTTO_NETTO    VARCHAR(1);
DECLARE VARIABLE SCIEKI_JM              VARCHAR(3);

DECLARE VARIABLE NIECZ_ST_ROZL          VARCHAR(3);
DECLARE VARIABLE NIECZ_ST_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE NIECZ_ST_CENA          DOUBLE PRECISION;
DECLARE VARIABLE NIECZ_ST_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE NIECZ_ST_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE NIECZ_ST_JM            VARCHAR(3);

DECLARE VARIABLE NIECZ_ST_SEG_ROZL          VARCHAR(3);
DECLARE VARIABLE NIECZ_ST_SEG_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE NIECZ_ST_SEG_CENA          DOUBLE PRECISION;
DECLARE VARIABLE NIECZ_ST_SEG_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE NIECZ_ST_SEG_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE NIECZ_ST_SEG_JM            VARCHAR(3);

DECLARE VARIABLE NIECZ_PL_ROZL          VARCHAR(3);
DECLARE VARIABLE NIECZ_PL_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE NIECZ_PL_CENA          DOUBLE PRECISION;
DECLARE VARIABLE NIECZ_PL_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE NIECZ_PL_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE NIECZ_PL_JM            VARCHAR(3);

DECLARE VARIABLE WADM_LICZ_ROZL          VARCHAR(3);
DECLARE VARIABLE WADM_LICZ_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE WADM_LICZ_CENA          DOUBLE PRECISION;
DECLARE VARIABLE WADM_LICZ_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE WADM_LICZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE WADM_LICZ_JM            VARCHAR(3);
DECLARE VARIABLE WADM_LICZ_PROCENT       DOUBLE PRECISION;

DECLARE VARIABLE WADM_RYCZ_ROZL          VARCHAR(3);
DECLARE VARIABLE WADM_RYCZ_TYP_VAT       VARCHAR(1);
DECLARE VARIABLE WADM_RYCZ_CENA          DOUBLE PRECISION;
DECLARE VARIABLE WADM_RYCZ_NORMA         DOUBLE PRECISION;
DECLARE VARIABLE WADM_RYCZ_BRUTTO_NETTO  VARCHAR(1);
DECLARE VARIABLE WADM_RYCZ_JM            VARCHAR(3);
DECLARE VARIABLE WADM_RYCZ_PROCENT       DOUBLE PRECISION;

DECLARE VARIABLE DO_ZAPISU              INTEGER;
DECLARE VARIABLE KOLEJNOSC              INTEGER;

BEGIN
  FOR SELECT
    ZC.OSIEDLE, ZC.TYP_BUDOWLI, ZC.TYP_LOKALU, ZC.TYP_ZASIEDL,
    ZC.POCZATEK, ZC.KONIEC, ZC.TRYB_KON,
    SZ.RODZAJ, SZ.ROZLICZENIE, SZ.TYP_VAT, SZ.CENA, SZ.BRUTTO_NETTO, SZ.JM, 1,
    SZ.PIETRO_OD, SZ.PIETRO_DO, SZ.KLATKA, I.DOTYCZY, I.ZALEZNE_GRUPA, SZ.LP, SZ.UCHWALA,
    I.BEZ_ROZRACHUNKOW, SZ.BEZ_PROPORCJI
  FROM ZASADY_CZYNSZOWE ZC, SKLADNIKI_ZASAD SZ, INNE_OPLATY_CZYNSZU I
  WHERE
    SZ.ZASADA = ZC.KLUCZ AND SZ.WERSJA = ZC.WERSJA AND I.KLUCZ = SZ.RODZAJ AND
    ZC.POCZATEK <= :NA_DZIEN AND
    (ZC.KONIEC IS NULL OR ZC.KONIEC >= :NA_DZIEN)
    AND
    (:AOSIEDLE = 0 OR (:AOSIEDLE <> 0 AND (ZC.OSIEDLE = :AOSIEDLE OR ZC.OSIEDLE = 0))) 
    AND
    (:ATYP_BUDOWLI = '' OR ZC.TYP_BUDOWLI = :ATYP_BUDOWLI)
    AND
    (:ATYP_LOKALU = '' OR ZC.TYP_LOKALU = :ATYP_LOKALU)
    AND
    (:ATYP_ZASIEDL = '' OR (:ATYP_ZASIEDL <> '' AND (ZC.TYP_ZASIEDL = :ATYP_ZASIEDL OR ZC.TYP_ZASIEDL = '')))
  ORDER BY SZ.LP
  INTO
    :OSIEDLE, :TYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL,
    :POCZATEK, :KONIEC, :TRYB_KON,
    :RODZAJ, :ROZLICZENIE, :TYP_VAT, :CENA, :BRUTTO_NETTO, :JM, :NORMA,
    :PIETRO_OD, :PIETRO_DO, :KLATKA, :DOTYCZY, :GRUPA, :LP, :UCHWALA,
    :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI
  DO BEGIN
    DO_ZAPISU = 1;
    IF ((:GRUPA = '') OR (:GRUPA IS NULL)) 
    THEN GRUPA = '1'; 
    IF ((:BEZ_ROZRACHUNKOW = '') OR (:BEZ_ROZRACHUNKOW IS NULL)) 
    THEN BEZ_ROZRACHUNKOW = 'N';
    IF ((:BEZ_PROPORCJI = '') OR (:BEZ_PROPORCJI IS NULL)) 
    THEN BEZ_PROPORCJI = 'N';

    IF (:AOSIEDLE <> 0 AND :OSIEDLE = 0) /* pomijamy jesli jest analogiczny dla osiedla */
    THEN IF (
      (SELECT COUNT(*)
       FROM ZASADY_CZYNSZOWE ZC1, SKLADNIKI_ZASAD SZ1
       WHERE
         SZ1.RODZAJ = :RODZAJ AND
         SZ1.ZASADA = ZC1.KLUCZ AND SZ1.WERSJA = ZC1.WERSJA AND
         ZC1.POCZATEK <= :NA_DZIEN AND
         (ZC1.KONIEC IS NULL OR ZC1.KONIEC >= :NA_DZIEN)
         AND
         ZC1.OSIEDLE = :AOSIEDLE
         AND
         ZC1.TYP_BUDOWLI = :TYP_BUDOWLI
         AND
         ZC1.TYP_LOKALU = :TYP_LOKALU
         AND
         ZC1.TYP_ZASIEDL = :TYP_ZASIEDL
       ) > 0)
    THEN DO_ZAPISU = 0;

    /* Uwaga : typ_budowli i typ_lokalu sa zawsze podane, pomijamy gdy analogiczne dla zasiedlenia */

    IF (:DO_ZAPISU = 1 AND :ATYP_ZASIEDL <> '' AND :TYP_ZASIEDL = '')
    THEN IF (
      (SELECT COUNT(*)
       FROM ZASADY_CZYNSZOWE ZC1, SKLADNIKI_ZASAD SZ1
       WHERE
         SZ1.RODZAJ = :RODZAJ AND
         SZ1.ZASADA = ZC1.KLUCZ AND SZ1.WERSJA = ZC1.WERSJA AND
         ZC1.POCZATEK <= :NA_DZIEN AND
         (ZC1.KONIEC IS NULL OR ZC1.KONIEC >= :NA_DZIEN)
         AND
         ZC1.OSIEDLE = :OSIEDLE
         AND
         ZC1.TYP_BUDOWLI = :TYP_BUDOWLI
         AND
         ZC1.TYP_LOKALU = :TYP_LOKALU
         AND
         ZC1.TYP_ZASIEDL = :ATYP_ZASIEDL
       ) > 0)
    THEN DO_ZAPISU = 0;

    IF (:DO_ZAPISU = 1)
    THEN SUSPEND;
    IF (:DO_ZAPISU = 1)
    THEN KOLEJNOSC = :LP;
  END

  TYP_BUDOWLI = '';
  RODZAJ = NULL;
  ROZLICZENIE = '';
  TYP_VAT = '';
  CENA = 0;
  BRUTTO_NETTO = '';
  JM = NULL;
  NORMA = NULL;
  PIETRO_OD = NULL;
  PIETRO_DO = NULL;
  KLATKA = NULL;

  KOLEJNOSC = :KOLEJNOSC + 10;
  FOR SELECT
    OSIEDLE, TYP_LOKALU, TYP_ZASIEDLENIA,
    POCZATEK, KONIEC, TRYB_KON,
    WCIEPLA_LICZ_ROZL, WCIEPLA_LICZ_TYP_VAT, WCIEPLA_LICZ_CENA, WCIEPLA_LICZ_NORMA,
    WCIEPLA_RYCZ_ROZL, WCIEPLA_RYCZ_TYP_VAT, WCIEPLA_RYCZ_RYCZALT, WCIEPLA_RYCZ_NORMA,
    WZIMNA_ROZL, WZIMNA_TYP_VAT, WZIMNA_CENA, WZIMNA_NORMA,
    CO_ROZL, CO_TYP_VAT, CO_CENA, CO_NORMA,
    SWIATLO_ROZL, SWIATLO_TYP_VAT, SWIATLO_CENA, SWIATLO_NORMA,
    GAZ_ROZL, GAZ_TYP_VAT, GAZ_CENA, GAZ_NORMA,
    SCIEKI_ROZL, SCIEKI_TYP_VAT, SCIEKI_CENA, SCIEKI_NORMA,
    NIECZ_ST_ROZL, NIECZ_ST_TYP_VAT, NIECZ_ST_CENA, NIECZ_ST_NORMA,
    NIECZ_PL_ROZL, NIECZ_PL_TYP_VAT, NIECZ_PL_CENA, NIECZ_PL_NORMA,
    WZIMNA_LICZ_ROZL, WZIMNA_LICZ_TYP_VAT, WZIMNA_LICZ_CENA, WZIMNA_LICZ_NORMA, WZIMNA_LICZ_JM,
    PODGRZANIE_RYCZ_ROZL, PODGRZANIE_RYCZ_TYP_VAT, PODGRZANIE_RYCZ_CENA,
    PODGRZANIE_LICZ_ROZL, PODGRZANIE_LICZ_TYP_VAT, PODGRZANIE_LICZ_CENA,
    WODA_ST_ROZL, WODA_ST_TYP_VAT, WODA_ST_CENA,
    CO_LICZ_ROZL, CO_LICZ_TYP_VAT, CO_LICZ_CENA, CO_LICZ_NORMA,
    SWIATLO_LICZ_ROZL, SWIATLO_LICZ_TYP_VAT, SWIATLO_LICZ_CENA, SWIATLO_LICZ_NORMA,
    GAZ_LICZ_ROZL, GAZ_LICZ_TYP_VAT, GAZ_LICZ_CENA, GAZ_LICZ_NORMA,
    WZIMNA_LICZ_BRUTTO_NETTO, WZIMNA_RYCZ_BRUTTO_NETTO, WCIEPLA_LICZ_BRUTTO_NETTO,
    WCIEPLA_RYCZ_BRUTTO_NETTO, PODGRZANIE_LICZ_BRUTTO_NETTO,
    PODGRZANIE_RYCZ_BRUTTO_NETTO, WODA_ST_BRUTTO_NETTO,
    CO_LICZ_BRUTTO_NETTO, CO_RYCZ_BRUTTO_NETTO, SWIATLO_LICZ_BRUTTO_NETTO,
    SWIATLO_RYCZ_BRUTTO_NETTO, GAZ_LICZ_BRUTTO_NETTO, GAZ_RYCZ_BRUTTO_NETTO,
    SCIEKI_BRUTTO_NETTO, NIECZ_PL_BRUTTO_NETTO, NIECZ_ST_BRUTTO_NETTO,
    W_CO_KOSZT_ST_ROZL, W_CO_KOSZT_ST_TYP_VAT, W_CO_KOSZT_ST_CENA,
    W_CO_KOSZT_ST_BRUTTO_NETTO,
    WZIMNA_RYCZ_JM, WCIEPLA_LICZ_JM, WCIEPLA_RYCZ_JM, PODGRZANIE_LICZ_JM,
    PODGRZANIE_RYCZ_JM, WODA_ST_JM, CO_LICZ_JM, CO_RYCZ_JM,
    SWIATLO_LICZ_JM, SWIATLO_RYCZ_JM, GAZ_LICZ_JM, GAZ_RYCZ_JM,
    SCIEKI_JM, NIECZ_PL_JM, NIECZ_ST_JM, W_CO_KOSZT_ST_JM,
    WADM_LICZ_ROZL, WADM_LICZ_TYP_VAT, WADM_LICZ_CENA, WADM_LICZ_NORMA, 
    WADM_LICZ_BRUTTO_NETTO, WADM_LICZ_JM, WADM_LICZ_PROCENT, 
    WADM_RYCZ_ROZL, WADM_RYCZ_TYP_VAT, WADM_RYCZ_CENA, WADM_RYCZ_NORMA, 
    WADM_RYCZ_BRUTTO_NETTO, WADM_RYCZ_JM, WADM_RYCZ_PROCENT,
    NIECZ_ST_SEG_ROZL, NIECZ_ST_SEG_TYP_VAT, NIECZ_ST_SEG_CENA,
    NIECZ_ST_SEG_NORMA, NIECZ_ST_SEG_BRUTTO_NETTO, NIECZ_ST_SEG_JM
  FROM ZASADY_MEDIOW
  WHERE
    POCZATEK <= :NA_DZIEN AND
    (KONIEC IS NULL OR KONIEC >= :NA_DZIEN)
    AND
    (:AOSIEDLE = 0 OR (:AOSIEDLE <> 0 AND (OSIEDLE = :AOSIEDLE OR OSIEDLE = 0)))
    AND
    (:ATYP_LOKALU = '' OR TYP_LOKALU = :ATYP_LOKALU)
    AND
    (:ATYP_ZASIEDL = '' OR (:ATYP_ZASIEDL <> '' AND (TYP_ZASIEDLENIA = :ATYP_ZASIEDL OR TYP_ZASIEDLENIA = '')))
  INTO
    :OSIEDLE, :TYP_LOKALU, :TYP_ZASIEDL,
    :POCZATEK, :KONIEC, :TRYB_KON,
    :WCIEPLA_LICZ_ROZL, :WCIEPLA_LICZ_TYP_VAT, :WCIEPLA_LICZ_CENA, :WCIEPLA_LICZ_NORMA,
    :WCIEPLA_RYCZ_ROZL, :WCIEPLA_RYCZ_TYP_VAT, :WCIEPLA_RYCZ_RYCZALT, :WCIEPLA_RYCZ_NORMA,
    :WZIMNA_ROZL, :WZIMNA_TYP_VAT, :WZIMNA_CENA, :WZIMNA_NORMA,
    :CO_ROZL, :CO_TYP_VAT, :CO_CENA, :CO_NORMA,
    :SWIATLO_ROZL, :SWIATLO_TYP_VAT, :SWIATLO_CENA, :SWIATLO_NORMA,
    :GAZ_ROZL, :GAZ_TYP_VAT, :GAZ_CENA, :GAZ_NORMA,
    :SCIEKI_ROZL, :SCIEKI_TYP_VAT, :SCIEKI_CENA, :SCIEKI_NORMA,
    :NIECZ_ST_ROZL, :NIECZ_ST_TYP_VAT, :NIECZ_ST_CENA, :NIECZ_ST_NORMA,
    :NIECZ_PL_ROZL, :NIECZ_PL_TYP_VAT, :NIECZ_PL_CENA, :NIECZ_PL_NORMA,
    :WZIMNA_LICZ_ROZL, :WZIMNA_LICZ_TYP_VAT, :WZIMNA_LICZ_CENA, :WZIMNA_LICZ_NORMA, :WZIMNA_LICZ_JM,
    :PODGRZANIE_RYCZ_ROZL, :PODGRZANIE_RYCZ_TYP_VAT, :PODGRZANIE_RYCZ_CENA,
    :PODGRZANIE_LICZ_ROZL, :PODGRZANIE_LICZ_TYP_VAT, :PODGRZANIE_LICZ_CENA,
    :WODA_ST_ROZL, :WODA_ST_TYP_VAT, :WODA_ST_CENA,
    :CO_LICZ_ROZL, :CO_LICZ_TYP_VAT, :CO_LICZ_CENA, :CO_LICZ_NORMA,
    :SWIATLO_LICZ_ROZL, :SWIATLO_LICZ_TYP_VAT, :SWIATLO_LICZ_CENA, :SWIATLO_LICZ_NORMA,
    :GAZ_LICZ_ROZL, :GAZ_LICZ_TYP_VAT, :GAZ_LICZ_CENA, :GAZ_LICZ_NORMA,
    :WZIMNA_LICZ_BRUTTO_NETTO, :WZIMNA_RYCZ_BRUTTO_NETTO, :WCIEPLA_LICZ_BRUTTO_NETTO,
    :WCIEPLA_RYCZ_BRUTTO_NETTO, :PODGRZANIE_LICZ_BRUTTO_NETTO,
    :PODGRZANIE_RYCZ_BRUTTO_NETTO, :WODA_ST_BRUTTO_NETTO,
    :CO_LICZ_BRUTTO_NETTO, :CO_RYCZ_BRUTTO_NETTO, :SWIATLO_LICZ_BRUTTO_NETTO,
    :SWIATLO_RYCZ_BRUTTO_NETTO, :GAZ_LICZ_BRUTTO_NETTO, :GAZ_RYCZ_BRUTTO_NETTO,
    :SCIEKI_BRUTTO_NETTO, :NIECZ_PL_BRUTTO_NETTO, :NIECZ_ST_BRUTTO_NETTO,
    :W_CO_KOSZT_ST_ROZL, :W_CO_KOSZT_ST_TYP_VAT, :W_CO_KOSZT_ST_CENA,
    :W_CO_KOSZT_ST_BRUTTO_NETTO,
    :WZIMNA_RYCZ_JM, :WCIEPLA_LICZ_JM, :WCIEPLA_RYCZ_JM, :PODGRZANIE_LICZ_JM,
    :PODGRZANIE_RYCZ_JM, :WODA_ST_JM, :CO_LICZ_JM, :CO_RYCZ_JM,
    :SWIATLO_LICZ_JM, :SWIATLO_RYCZ_JM, :GAZ_LICZ_JM, :GAZ_RYCZ_JM,
    :SCIEKI_JM, :NIECZ_PL_JM, :NIECZ_ST_JM, :W_CO_KOSZT_ST_JM,
    :WADM_LICZ_ROZL, :WADM_LICZ_TYP_VAT, :WADM_LICZ_CENA, :WADM_LICZ_NORMA, 
    :WADM_LICZ_BRUTTO_NETTO, :WADM_LICZ_JM, :WADM_LICZ_PROCENT, 
    :WADM_RYCZ_ROZL, :WADM_RYCZ_TYP_VAT, :WADM_RYCZ_CENA, :WADM_RYCZ_NORMA, 
    :WADM_RYCZ_BRUTTO_NETTO, :WADM_RYCZ_JM, :WADM_RYCZ_PROCENT,
    :NIECZ_ST_SEG_ROZL, :NIECZ_ST_SEG_TYP_VAT, :NIECZ_ST_SEG_CENA,
    :NIECZ_ST_SEG_NORMA, :NIECZ_ST_SEG_BRUTTO_NETTO, :NIECZ_ST_SEG_JM
  DO BEGIN
    DO_ZAPISU = 1;

    IF (:AOSIEDLE <> 0 AND :OSIEDLE = 0)
    THEN IF (
      (SELECT COUNT(*)
       FROM ZASADY_MEDIOW ZM
       WHERE
         ZM.POCZATEK <= :NA_DZIEN AND
         (ZM.KONIEC IS NULL OR ZM.KONIEC >= :NA_DZIEN)
         AND
         ZM.OSIEDLE = :AOSIEDLE
         AND
         ZM.TYP_LOKALU = :TYP_LOKALU
         AND
         ZM.TYP_ZASIEDLENIA = :TYP_ZASIEDL
       ) > 0)
    THEN DO_ZAPISU = 0;

    /* Uwaga : typ_budowli jest pusty a typ_lokalu jest zawsze podany */

    IF (:DO_ZAPISU = 1 AND :ATYP_ZASIEDL <> '' AND :TYP_ZASIEDL = '')
    THEN IF (
      (SELECT COUNT(*)
       FROM ZASADY_MEDIOW ZM
       WHERE
         ZM.POCZATEK <= :NA_DZIEN AND
         (ZM.KONIEC IS NULL OR ZM.KONIEC >= :NA_DZIEN)
         AND
         ZM.OSIEDLE = :OSIEDLE
         AND
         ZM.TYP_LOKALU = :TYP_LOKALU
         AND
         ZM.TYP_ZASIEDLENIA = :ATYP_ZASIEDL
       ) > 0)
    THEN DO_ZAPISU = 0;


    IF (:DO_ZAPISU = 1 AND :WZIMNA_LICZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -1;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :WZIMNA_LICZ_ROZL;
      TYP_VAT = :WZIMNA_LICZ_TYP_VAT;
      CENA = :WZIMNA_LICZ_CENA;
      BRUTTO_NETTO = :WZIMNA_LICZ_BRUTTO_NETTO;
      JM = :WZIMNA_LICZ_JM;
      NORMA = :WZIMNA_LICZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :WZIMNA_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -2;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :WZIMNA_ROZL;
      TYP_VAT = :WZIMNA_TYP_VAT;
      CENA = :WZIMNA_CENA;
      BRUTTO_NETTO = :WZIMNA_RYCZ_BRUTTO_NETTO;
      JM = :WZIMNA_RYCZ_JM;
      NORMA = :WZIMNA_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :WCIEPLA_LICZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -3;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :WCIEPLA_LICZ_ROZL;
      TYP_VAT = :WCIEPLA_LICZ_TYP_VAT;
      CENA = :WCIEPLA_LICZ_CENA;
      BRUTTO_NETTO = :WCIEPLA_LICZ_BRUTTO_NETTO;
      JM = :WCIEPLA_LICZ_JM;
      NORMA = :WCIEPLA_LICZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :WCIEPLA_RYCZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -4;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :WCIEPLA_RYCZ_ROZL;
      TYP_VAT = :WCIEPLA_RYCZ_TYP_VAT;
      CENA = :WCIEPLA_RYCZ_RYCZALT;
      BRUTTO_NETTO = :WCIEPLA_RYCZ_BRUTTO_NETTO;
      JM = :WCIEPLA_RYCZ_JM;
      NORMA = :WCIEPLA_RYCZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :PODGRZANIE_LICZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -5;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :PODGRZANIE_LICZ_ROZL;
      TYP_VAT = :PODGRZANIE_LICZ_TYP_VAT;
      CENA = :PODGRZANIE_LICZ_CENA;
      BRUTTO_NETTO = :PODGRZANIE_LICZ_BRUTTO_NETTO;
      JM = :PODGRZANIE_LICZ_JM;
      NORMA = :WCIEPLA_LICZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :PODGRZANIE_RYCZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -6;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :PODGRZANIE_RYCZ_ROZL;
      TYP_VAT = :PODGRZANIE_RYCZ_TYP_VAT;
      CENA = :PODGRZANIE_RYCZ_CENA;
      BRUTTO_NETTO = :PODGRZANIE_RYCZ_BRUTTO_NETTO;
      JM = :PODGRZANIE_RYCZ_JM;
      NORMA = :WCIEPLA_RYCZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :WODA_ST_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -7;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :WODA_ST_ROZL;
      TYP_VAT = :WODA_ST_TYP_VAT;
      CENA = :WODA_ST_CENA;
      BRUTTO_NETTO = :WODA_ST_BRUTTO_NETTO;
      JM = :WODA_ST_JM;
      NORMA = 1;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :W_CO_KOSZT_ST_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -8;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :W_CO_KOSZT_ST_ROZL;
      TYP_VAT = :W_CO_KOSZT_ST_TYP_VAT;
      CENA = :W_CO_KOSZT_ST_CENA;
      BRUTTO_NETTO = :W_CO_KOSZT_ST_BRUTTO_NETTO;
      JM = :W_CO_KOSZT_ST_JM;
      NORMA = 1;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :CO_LICZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -10;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :CO_LICZ_ROZL;
      TYP_VAT = :CO_LICZ_TYP_VAT;
      CENA = :CO_LICZ_CENA;
      BRUTTO_NETTO = :CO_LICZ_BRUTTO_NETTO;
      JM = :CO_LICZ_JM;
      NORMA = :CO_LICZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :CO_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -11;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :CO_ROZL;
      TYP_VAT = :CO_TYP_VAT;
      CENA = :CO_CENA;
      BRUTTO_NETTO = :CO_RYCZ_BRUTTO_NETTO;
      JM = :CO_RYCZ_JM;
      NORMA = :CO_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :SWIATLO_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -12;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :SWIATLO_ROZL;
      TYP_VAT = :SWIATLO_TYP_VAT;
      CENA = :SWIATLO_CENA;
      BRUTTO_NETTO = :SWIATLO_RYCZ_BRUTTO_NETTO;
      JM = :SWIATLO_RYCZ_JM;
      NORMA = :SWIATLO_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :SWIATLO_LICZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -13;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :SWIATLO_LICZ_ROZL;
      TYP_VAT = :SWIATLO_LICZ_TYP_VAT;
      CENA = :SWIATLO_LICZ_CENA;
      BRUTTO_NETTO = :SWIATLO_LICZ_BRUTTO_NETTO;
      JM = :SWIATLO_LICZ_JM;
      NORMA = :SWIATLO_LICZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :GAZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -14;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :GAZ_ROZL;
      TYP_VAT = :GAZ_TYP_VAT;
      CENA = :GAZ_CENA;
      BRUTTO_NETTO = :GAZ_RYCZ_BRUTTO_NETTO;
      JM = :GAZ_RYCZ_JM;
      NORMA = :GAZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :GAZ_LICZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -15;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :GAZ_LICZ_ROZL;
      TYP_VAT = :GAZ_LICZ_TYP_VAT;
      CENA = :GAZ_LICZ_CENA;
      BRUTTO_NETTO = :GAZ_LICZ_BRUTTO_NETTO;
      JM = :GAZ_LICZ_JM;
      NORMA = :GAZ_LICZ_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :SCIEKI_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -16;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :SCIEKI_ROZL;
      TYP_VAT = :SCIEKI_TYP_VAT;
      CENA = :SCIEKI_CENA;
      BRUTTO_NETTO = :SCIEKI_BRUTTO_NETTO;
      JM = :SCIEKI_JM;
      NORMA = :SCIEKI_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :NIECZ_ST_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -18;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :NIECZ_ST_ROZL;
      TYP_VAT = :NIECZ_ST_TYP_VAT;
      CENA = :NIECZ_ST_CENA;
      BRUTTO_NETTO = :NIECZ_ST_BRUTTO_NETTO;
      JM = :NIECZ_ST_JM;
      NORMA = :NIECZ_ST_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :NIECZ_ST_SEG_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -19;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :NIECZ_ST_SEG_ROZL;
      TYP_VAT = :NIECZ_ST_SEG_TYP_VAT;
      CENA = :NIECZ_ST_SEG_CENA;
      BRUTTO_NETTO = :NIECZ_ST_SEG_BRUTTO_NETTO;
      JM = :NIECZ_ST_SEG_JM;
      NORMA = :NIECZ_ST_SEG_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :NIECZ_PL_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -20;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :NIECZ_PL_ROZL;
      TYP_VAT = :NIECZ_PL_TYP_VAT;
      CENA = :NIECZ_PL_CENA;
      BRUTTO_NETTO = :NIECZ_PL_BRUTTO_NETTO;
      JM = :NIECZ_PL_JM;
      NORMA = :NIECZ_PL_NORMA;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :WADM_LICZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -51;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :WADM_LICZ_ROZL;
      TYP_VAT = :WADM_LICZ_TYP_VAT;
      CENA = :WADM_LICZ_CENA;
      BRUTTO_NETTO = :WADM_LICZ_BRUTTO_NETTO;
      JM = :WADM_LICZ_JM;
      NORMA = :WADM_LICZ_NORMA;
      ILOSC = :WADM_LICZ_PROCENT;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

    IF (:DO_ZAPISU = 1 AND :WADM_RYCZ_ROZL IS NOT NULL)
    THEN BEGIN
      LP = :KOLEJNOSC;
      KOLEJNOSC = :KOLEJNOSC + 10;
      RODZAJ = -52;
      DOTYCZY = 'MD';
      GRUPA = '2';
      BEZ_ROZRACHUNKOW = 'N';
      ROZLICZENIE = :WADM_RYCZ_ROZL;
      TYP_VAT = :WADM_RYCZ_TYP_VAT;
      CENA = :WADM_RYCZ_CENA;
      BRUTTO_NETTO = :WADM_RYCZ_BRUTTO_NETTO;
      JM = :WADM_RYCZ_JM;
      NORMA = :WADM_RYCZ_NORMA;
      ILOSC = :WADM_RYCZ_PROCENT;
      UCHWALA = '';
      BEZ_PROPORCJI = 'N';
      SUSPEND;
    END

  END
END ^

COMMIT WORK ^

SET TERM ; ^

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE WYKAZ_ZASAD_NIERUCHOMOSCI(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  NIERUCHOMOSC INTEGER,
  ATYP_BUDOWLI  VARCHAR(3))

RETURNS(
  TYP_BUDOWLI        VARCHAR(3),
  TYP_LOKALU         VARCHAR(3),
  TYP_ZASIEDL        VARCHAR(3),

  POCZATEK           TIMESTAMP,
  KONIEC             TIMESTAMP,
  TRYB_KON           VARCHAR(1),

  LP                 INTEGER,
  RODZAJ             INTEGER,
  DOTYCZY            VARCHAR(3),
  GRUPA              VARCHAR(1),
  BEZ_ROZRACHUNKOW   VARCHAR(1),
  ROZLICZENIE        VARCHAR(3),
  TYP_VAT            VARCHAR(1),
  CENA               DOUBLE PRECISION,
  BRUTTO_NETTO       VARCHAR(1),
  JM                 VARCHAR(3),
  NORMA              DOUBLE PRECISION,
  ILOSC              DOUBLE PRECISION,       /* Ilosc zawsze bedzie NULL - poza RODZAJ = -51 lub -52 */

  PIETRO_OD          DOUBLE PRECISION,
  PIETRO_DO          DOUBLE PRECISION,
  KLATKA             VARCHAR(5),
  UCHWALA            VARCHAR(100),
  BEZ_PROPORCJI      VARCHAR(1)
  )
AS
DECLARE VARIABLE POZYCJA          INTEGER;
BEGIN

  /* Zasady ogolne */

  ILOSC = NULL;
  FOR SELECT
    ZSC.TYP_BUDOWLI, ZSC.TYP_LOKALU, ZSC.TYP_ZASIEDL,
    ZSC.POCZATEK, ZSC.KONIEC, ZSC.TRYB_KON,
    ZSC.RODZAJ, ZSC.ROZLICZENIE, ZSC.TYP_VAT, ZSC.CENA, ZSC.BRUTTO_NETTO,
    ZSC.JM, ZSC.NORMA, ZSC.PIETRO_OD, ZSC.PIETRO_DO, ZSC.KLATKA, ZSC.DOTYCZY,
    ZSC.GRUPA, ZSC.LP, ZSC.ILOSC, ZSC.UCHWALA, ZSC.BEZ_ROZRACHUNKOW, ZSC.BEZ_PROPORCJI
  FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, '', '', '') ZSC
  INTO
    :TYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL,
    :POCZATEK, :KONIEC, :TRYB_KON,
    :RODZAJ, :ROZLICZENIE, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :JM, :NORMA, :PIETRO_OD, :PIETRO_DO, :KLATKA, :DOTYCZY,
    :GRUPA, :LP, :ILOSC, :UCHWALA, :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI
  DO BEGIN
    IF (    /* nie istnieje identyczna zasada dla nieruchomosci */
      (SELECT COUNT(*) FROM CENNIKI_INFRASTRUKTURY C
       WHERE
         C.TYP = 'N' AND C.DOTYCZY = :NIERUCHOMOSC AND
         C.OPLATA = :RODZAJ AND
         C.DATA_OD <= :NA_DZIEN AND
         (C.DATA_DO IS NULL OR C.DATA_DO >= :NA_DZIEN)
         AND
         (C.TYP_LOKALU = :TYP_LOKALU) AND
         (C.TYP_ZASIEDLENIA = :TYP_ZASIEDL OR C.TYP_ZASIEDLENIA IS NULL) AND
         ((C.PIETRO_OD = :PIETRO_OD AND :PIETRO_OD IS NOT NULL) OR C.PIETRO_OD IS NULL OR C.PIETRO_OD = 0) AND
         ((C.PIETRO_DO = :PIETRO_DO AND :PIETRO_OD IS NOT NULL) OR C.PIETRO_DO IS NULL OR C.PIETRO_DO = 0) AND
         ((C.KLATKA = :KLATKA AND :KLATKA IS NOT NULL) OR C.KLATKA IS NULL OR C.KLATKA = '')
         ) = 0)
    THEN SUSPEND;  /*otrzymujemy dla typu 170*/
  END

  /* Zasady dla nieruchomosci */

  FOR SELECT
    C.OPLATA, C.TYP_LOKALU, C.TYP_ZASIEDLENIA,
    C.DATA_OD, C.DATA_DO,
    C.TYP_VAT, C.KWOTA, C.BRUTTO_NETTO,
    C.PIETRO_OD, C.PIETRO_DO, C.KLATKA,
    C.ILOSC, C.POZYCJA, C.UCHWALA, C.BEZ_PROPORCJI
  FROM CENNIKI_INFRASTRUKTURY C
  WHERE
    C.TYP = 'N' AND C.DOTYCZY = :NIERUCHOMOSC AND
    C.DATA_OD <= :NA_DZIEN AND
    (C.DATA_DO IS NULL OR C.DATA_DO >= :NA_DZIEN)
  INTO
    :RODZAJ, :TYP_LOKALU, :TYP_ZASIEDL,
    :POCZATEK, :KONIEC,
    :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :PIETRO_OD, :PIETRO_DO, :KLATKA,
    :ILOSC, :POZYCJA, :UCHWALA, :BEZ_PROPORCJI
  DO BEGIN
    TYP_BUDOWLI = '';
    ROZLICZENIE = '';
    JM = '';


    IF ((SELECT COUNT(WZ.RODZAJ) FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :ATYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL) WZ
        WHERE WZ.RODZAJ = :RODZAJ AND (WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL  IS NULL OR WZ.TYP_ZASIEDL = :TYP_ZASIEDL)) > 0)
    THEN FOR SELECT ROZLICZENIE, JM, DOTYCZY, GRUPA, LP, BEZ_ROZRACHUNKOW
    FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :ATYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL) WZ
    WHERE WZ.RODZAJ = :RODZAJ AND 
      (WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL  IS NULL OR WZ.TYP_ZASIEDL = :TYP_ZASIEDL)
    ROWS 1
    INTO :ROZLICZENIE, :JM, :DOTYCZY, :GRUPA, :LP, :BEZ_ROZRACHUNKOW
    DO BEGIN
      IF (:ROZLICZENIE IS NULL)
      THEN ROZLICZENIE = '';
      IF (:JM IS NULL)
      THEN JM = '';
      IF (:DOTYCZY IS NULL)
      THEN DOTYCZY = '';
      IF (:GRUPA IS NULL)
      THEN GRUPA = '';
      IF (:BEZ_ROZRACHUNKOW IS NULL)
      THEN BEZ_ROZRACHUNKOW = 'N';

      IF (:POZYCJA > 0)
      THEN
        SELECT TYP_VAT, CENA, BRUTTO_NETTO
        FROM POZYCJE_CENNIKOW
        WHERE OPLATA = :RODZAJ AND KLUCZ = :POZYCJA
        INTO :TYP_VAT, :CENA, :BRUTTO_NETTO;

      SUSPEND;
    END
    
    ELSE FOR SELECT ROZLICZENIE, JM, DOTYCZY, GRUPA, LP, BEZ_ROZRACHUNKOW
    FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :ATYP_BUDOWLI, :TYP_LOKALU, '') WZ
    WHERE WZ.RODZAJ = :RODZAJ AND
      (WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL IS NULL OR WZ.TYP_ZASIEDL = :TYP_ZASIEDL)
    ROWS 1
    INTO :ROZLICZENIE, :JM, :DOTYCZY, :GRUPA, :LP, :BEZ_ROZRACHUNKOW
    DO BEGIN
      IF (:ROZLICZENIE IS NULL)
      THEN ROZLICZENIE = '';
      IF (:JM IS NULL)
      THEN JM = '';
      IF (:DOTYCZY IS NULL)
      THEN DOTYCZY = '';
      IF (:GRUPA IS NULL)
      THEN GRUPA = '';
      IF (:BEZ_ROZRACHUNKOW IS NULL)
      THEN BEZ_ROZRACHUNKOW = 'N';

      IF (:POZYCJA > 0)
      THEN
        SELECT TYP_VAT, CENA, BRUTTO_NETTO
        FROM POZYCJE_CENNIKOW
        WHERE OPLATA = :RODZAJ AND KLUCZ = :POZYCJA
        INTO :TYP_VAT, :CENA, :BRUTTO_NETTO;

      SUSPEND;
    END

  END

END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE WYKAZ_ZASAD_BUDOWLI(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  NIERUCHOMOSC INTEGER,
  BUDOWLA      INTEGER,
  TYP_BUDOWLI  VARCHAR(3))

RETURNS(
  TYP_LOKALU         VARCHAR(3),
  TYP_ZASIEDL        VARCHAR(3),

  POCZATEK           TIMESTAMP,
  KONIEC             TIMESTAMP,
  TRYB_KON           VARCHAR(1),

  LP                 INTEGER,
  RODZAJ             INTEGER,
  DOTYCZY            VARCHAR(3),
  GRUPA              VARCHAR(1),
  BEZ_ROZRACHUNKOW   VARCHAR(1),
  ROZLICZENIE        VARCHAR(3),
  TYP_VAT            VARCHAR(1),
  CENA               DOUBLE PRECISION,
  BRUTTO_NETTO       VARCHAR(1),
  JM                 VARCHAR(3),
  NORMA              DOUBLE PRECISION,
  ILOSC              DOUBLE PRECISION,           /* Ilosc zawsze bedzie NULL */

  PIETRO_OD          DOUBLE PRECISION,
  PIETRO_DO          DOUBLE PRECISION,
  KLATKA             VARCHAR(5),
  UCHWALA            VARCHAR(100),
  BEZ_PROPORCJI      VARCHAR(1) 
  )
AS
DECLARE VARIABLE POZYCJA          INTEGER;
BEGIN

  /* Zasady nieruchomosci */

  ILOSC = NULL;
  FOR SELECT
    ZSC.TYP_LOKALU, ZSC.TYP_ZASIEDL,
    ZSC.POCZATEK, ZSC.KONIEC, ZSC.TRYB_KON,
    ZSC.RODZAJ, ZSC.ROZLICZENIE, ZSC.TYP_VAT, ZSC.CENA, ZSC.BRUTTO_NETTO,
    ZSC.JM, ZSC.NORMA, ZSC.PIETRO_OD, ZSC.PIETRO_DO, ZSC.KLATKA, ZSC.DOTYCZY,
    ZSC.GRUPA, ZSC.UCHWALA, ZSC.LP, ZSC.ILOSC, ZSC.BEZ_ROZRACHUNKOW, ZSC.BEZ_PROPORCJI
  FROM WYKAZ_ZASAD_NIERUCHOMOSCI(:NA_DZIEN, :OSIEDLE, :NIERUCHOMOSC, :TYP_BUDOWLI) ZSC
  WHERE
    (ZSC.TYP_BUDOWLI = :TYP_BUDOWLI OR ZSC.TYP_BUDOWLI = '' OR ZSC.TYP_BUDOWLI IS NULL)
  INTO
    :TYP_LOKALU, :TYP_ZASIEDL,
    :POCZATEK, :KONIEC, :TRYB_KON,
    :RODZAJ, :ROZLICZENIE, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :JM, :NORMA, :PIETRO_OD, :PIETRO_DO, :KLATKA, :DOTYCZY,
    :GRUPA, :UCHWALA, :LP, :ILOSC, :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI
  DO BEGIN
    IF (    /* nie istnieje identyczna zasada dla budowli */
      (SELECT COUNT(*) FROM CENNIKI_INFRASTRUKTURY C
       WHERE
         C.TYP = 'B' AND C.DOTYCZY = :BUDOWLA AND
         C.OPLATA = :RODZAJ AND
         C.DATA_OD <= :NA_DZIEN AND
         (C.DATA_DO IS NULL OR C.DATA_DO >= :NA_DZIEN)
         AND
         (C.TYP_LOKALU = :TYP_LOKALU) AND
         (C.TYP_ZASIEDLENIA = :TYP_ZASIEDL OR C.TYP_ZASIEDLENIA IS NULL) AND
         ((C.PIETRO_OD = :PIETRO_OD AND :PIETRO_OD IS NOT NULL) OR C.PIETRO_OD IS NULL OR C.PIETRO_OD = 0) AND
         ((C.PIETRO_DO = :PIETRO_DO AND :PIETRO_DO IS NOT NULL) OR C.PIETRO_DO IS NULL OR C.PIETRO_DO = 0) AND
         ((C.KLATKA = :KLATKA AND :KLATKA IS NOT NULL) OR C.KLATKA IS NULL OR C.KLATKA = '')
         ) = 0)
    THEN SUSPEND;
  END

  /* Zasady dla budowli */

  TRYB_KON = NULL;
  NORMA = NULL;

  FOR SELECT
    C.TYP_LOKALU, C.TYP_ZASIEDLENIA,
    C.DATA_OD, C.DATA_DO,
    C.OPLATA, C.TYP_VAT, C.KWOTA, C.BRUTTO_NETTO,
    C.PIETRO_OD, C.PIETRO_DO, C.KLATKA,
    C.ILOSC, C.POZYCJA, C.UCHWALA, C.BEZ_PROPORCJI   /* Ilosc zawsze bedzie NULL */
  FROM CENNIKI_INFRASTRUKTURY C
  WHERE                                              /* bez warunku na cene !!! */
    C.TYP = 'B' AND C.DOTYCZY = :BUDOWLA AND
    C.DATA_OD <= :NA_DZIEN AND
    (C.DATA_DO IS NULL OR C.DATA_DO >= :NA_DZIEN)
  INTO
    :TYP_LOKALU, :TYP_ZASIEDL,
    :POCZATEK, :KONIEC,
    :RODZAJ, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :PIETRO_OD, :PIETRO_DO, :KLATKA,
    :ILOSC, :POZYCJA, :UCHWALA, :BEZ_PROPORCJI
  DO BEGIN
    ROZLICZENIE = '';
    JM = '';

    IF ((SELECT COUNT(WZ.RODZAJ) FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :TYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL) WZ
         WHERE WZ.RODZAJ = :RODZAJ AND (WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL  IS NULL OR WZ.TYP_ZASIEDL = :TYP_ZASIEDL)) > 0)
    THEN FOR SELECT WZ.ROZLICZENIE, WZ.JM, WZ.DOTYCZY, WZ.GRUPA, WZ.LP, WZ.BEZ_ROZRACHUNKOW
    FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :TYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL) WZ
    WHERE WZ.RODZAJ = :RODZAJ AND 
      (WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL  IS NULL OR WZ.TYP_ZASIEDL = :TYP_ZASIEDL)
    ROWS 1
    INTO :ROZLICZENIE, :JM, :DOTYCZY, :GRUPA, :LP, :BEZ_ROZRACHUNKOW
    DO BEGIN
      IF (:ROZLICZENIE IS NULL)
      THEN ROZLICZENIE = '';
      IF (:JM IS NULL)
      THEN JM = '';
      IF (:DOTYCZY IS NULL)
      THEN DOTYCZY = '';
      IF (:GRUPA IS NULL)
      THEN GRUPA = '';
      IF (:BEZ_ROZRACHUNKOW IS NULL)
      THEN BEZ_ROZRACHUNKOW = 'N';

      IF (:POZYCJA > 0)
      THEN
        SELECT TYP_VAT, CENA, BRUTTO_NETTO
        FROM POZYCJE_CENNIKOW
        WHERE OPLATA = :RODZAJ AND KLUCZ = :POZYCJA
        INTO :TYP_VAT, :CENA, :BRUTTO_NETTO;

      SUSPEND;
    END

    ELSE FOR SELECT WZ.ROZLICZENIE, WZ.JM, WZ.DOTYCZY, WZ.GRUPA, WZ.LP, WZ.BEZ_ROZRACHUNKOW
    FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :TYP_BUDOWLI, :TYP_LOKALU, '') WZ
    WHERE WZ.RODZAJ = :RODZAJ AND
      (WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL IS NULL OR WZ.TYP_ZASIEDL = :TYP_ZASIEDL)
    ROWS 1
    INTO :ROZLICZENIE, :JM, :DOTYCZY, :GRUPA, :LP, :BEZ_ROZRACHUNKOW
    DO BEGIN
      IF (:ROZLICZENIE IS NULL)
      THEN ROZLICZENIE = '';
      IF (:JM IS NULL)
      THEN JM = '';
      IF (:DOTYCZY IS NULL)
      THEN DOTYCZY = '';
      IF (:GRUPA IS NULL)
      THEN GRUPA = '';
      IF (:BEZ_ROZRACHUNKOW IS NULL)
      THEN BEZ_ROZRACHUNKOW = 'N';

      IF (:POZYCJA > 0)
      THEN
        SELECT TYP_VAT, CENA, BRUTTO_NETTO
        FROM POZYCJE_CENNIKOW
        WHERE OPLATA = :RODZAJ AND KLUCZ = :POZYCJA
        INTO :TYP_VAT, :CENA, :BRUTTO_NETTO;

      SUSPEND;
    END

  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE WYKAZ_ZASAD_ZASIEDLENIA_START(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  NIERUCHOMOSC INTEGER,
  BUDOWLA      INTEGER,
  PIETRO       DOUBLE PRECISION,
  KLATKA       VARCHAR(5),
  ZASIEDLENIE  INTEGER,
  TYP_BUDOWLI  VARCHAR(3),
  TYP_LOKALU   VARCHAR(3),
  TYP_ZASIEDL  VARCHAR(3))

RETURNS(
  POCZATEK           TIMESTAMP,
  KONIEC             TIMESTAMP,
  TRYB_KON           VARCHAR(1),
  LP                 INTEGER,

  RODZAJ             INTEGER,
  DOTYCZY            VARCHAR(3),
  GRUPA              VARCHAR(1),
  BEZ_ROZRACHUNKOW   VARCHAR(1),
  ROZLICZENIE        VARCHAR(3),
  TYP_VAT            VARCHAR(1),
  CENA               DOUBLE PRECISION,
  BRUTTO_NETTO       VARCHAR(1),
  JM                 VARCHAR(3),
  NORMA              DOUBLE PRECISION,
  ILOSC              DOUBLE PRECISION,
  UCHWALA            VARCHAR(100),
  BEZ_PROPORCJI      VARCHAR(1),

  KLATKA_BUD         VARCHAR(5),
  PIETRO_OD_BUD      DOUBLE PRECISION,
  PIETRO_DO_BUD      DOUBLE PRECISION,
  TYP_ZASIEDL_BUD    VARCHAR(3),
  ZAS_BUD            INTEGER                    /* 1 z budowli, 0 z zasiedlenia */
  )
AS
DECLARE VARIABLE POZYCJA          INTEGER;
BEGIN
  /* Zasady budowli */
  ILOSC = NULL;
  ZAS_BUD = 1;
  FOR SELECT
    ZSC.POCZATEK, ZSC.KONIEC, ZSC.TRYB_KON,
    ZSC.RODZAJ, ZSC.ROZLICZENIE, ZSC.TYP_VAT, ZSC.CENA, ZSC.BRUTTO_NETTO,
    ZSC.JM, ZSC.NORMA, ZSC.DOTYCZY, ZSC.GRUPA, 
    ZSC.KLATKA, ZSC.PIETRO_OD, ZSC.PIETRO_DO, ZSC.TYP_ZASIEDL, ZSC.UCHWALA, ZSC.LP, ZSC.ILOSC,
    ZSC.BEZ_ROZRACHUNKOW, ZSC.BEZ_PROPORCJI
  FROM WYKAZ_ZASAD_BUDOWLI(:NA_DZIEN, :OSIEDLE, :NIERUCHOMOSC, :BUDOWLA, :TYP_BUDOWLI) ZSC
  WHERE
    (ZSC.PIETRO_OD <= :PIETRO OR ZSC.PIETRO_OD IS NULL) AND
    (ZSC.PIETRO_DO >= :PIETRO OR ZSC.PIETRO_DO IS NULL OR ZSC.PIETRO_DO = 0) AND
    (ZSC.KLATKA = :KLATKA OR ZSC.KLATKA IS NULL OR ZSC.KLATKA = '')
    AND
    (ZSC.TYP_LOKALU = :TYP_LOKALU) AND
    (ZSC.TYP_ZASIEDL = :TYP_ZASIEDL OR ZSC.TYP_ZASIEDL = '' OR ZSC.TYP_ZASIEDL IS NULL)
  INTO
    :POCZATEK, :KONIEC, :TRYB_KON,
    :RODZAJ, :ROZLICZENIE, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :JM, :NORMA, :DOTYCZY, :GRUPA,
    :KLATKA_BUD, :PIETRO_OD_BUD, :PIETRO_DO_BUD, :TYP_ZASIEDL_BUD, :UCHWALA, :LP, :ILOSC,
    :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI
  DO BEGIN
    IF (:KLATKA_BUD IS NULL)         THEN KLATKA_BUD = '';
    IF (:PIETRO_OD_BUD IS NULL)      THEN PIETRO_OD_BUD = 0;
    IF (:PIETRO_DO_BUD IS NULL)      THEN PIETRO_DO_BUD = 0;
    IF (:TYP_ZASIEDL_BUD IS NULL)    THEN TYP_ZASIEDL_BUD = '';
    SUSPEND;
  END
  /* Zasady dla zasiedlenia */
  TRYB_KON = NULL;
  NORMA = NULL;
  ZAS_BUD = 0;
  TYP_ZASIEDL_BUD = :TYP_ZASIEDL;
  KLATKA_BUD = '';
  PIETRO_OD_BUD = 0;
  PIETRO_DO_BUD = 0;
  FOR SELECT
    C.DATA_OD, C.DATA_DO,
    C.OPLATA, C.TYP_VAT, C.KWOTA, C.BRUTTO_NETTO,
    C.ILOSC, C.POZYCJA, C.UCHWALA, C.BEZ_PROPORCJI
  FROM CENNIKI_INFRASTRUKTURY C
  WHERE                                              /* bez warunku na cene !!! */
    C.TYP = 'Z' AND C.DOTYCZY = :ZASIEDLENIE AND
    C.DATA_OD <= :NA_DZIEN AND
    (C.DATA_DO IS NULL OR C.DATA_DO >= :NA_DZIEN)
  INTO
    :POCZATEK, :KONIEC,
    :RODZAJ, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :ILOSC, :POZYCJA, :UCHWALA, :BEZ_PROPORCJI
  DO BEGIN
    ROZLICZENIE = '';
    JM = '';
    FOR SELECT WZ.ROZLICZENIE, WZ.JM, WZ.DOTYCZY, WZ.GRUPA, WZ.LP, WZ.BEZ_ROZRACHUNKOW
    FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :TYP_BUDOWLI, :TYP_LOKALU, '') WZ
    WHERE WZ.RODZAJ = :RODZAJ AND
      (WZ.TYP_ZASIEDL = :TYP_ZASIEDL OR WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL IS NULL)
    ROWS 1
    INTO :ROZLICZENIE, :JM, :DOTYCZY, :GRUPA, :LP, :BEZ_ROZRACHUNKOW
    DO BEGIN
      IF (:ROZLICZENIE IS NULL)
      THEN ROZLICZENIE = '';
      IF (:JM IS NULL)
      THEN JM = '';
      IF (:DOTYCZY IS NULL)
      THEN DOTYCZY = '';
      IF (:GRUPA IS NULL)
      THEN GRUPA = '';
      IF (:BEZ_ROZRACHUNKOW IS NULL)
      THEN BEZ_ROZRACHUNKOW = 'N';

      IF (:POZYCJA > 0)
      THEN
        SELECT TYP_VAT, CENA, BRUTTO_NETTO
        FROM POZYCJE_CENNIKOW
        WHERE OPLATA = :RODZAJ AND KLUCZ = :POZYCJA
        INTO :TYP_VAT, :CENA, :BRUTTO_NETTO;
      SUSPEND;
    END
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/* --- */

SET TERM ^ ;

CREATE PROCEDURE INDYWIDUALNA_STAWKA
(
  SKLADNIK      INTEGER,
  ZASIEDLENIE   INTEGER,
  ROK           INTEGER,
  MIESIAC       INTEGER
)
RETURNS(
  ILOSC            DOUBLE PRECISION,
  STAWKA           DOUBLE PRECISION,
  JM               VARCHAR(3),
  OPISROZLICZENIA  VARCHAR(500)
  )
AS
BEGIN
  ILOSC = 0;
  STAWKA = 0;
  JM = ' ';
  OPISROZLICZENIA = ' ';
  
  SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^



SET TERM ^ ;

CREATE PROCEDURE WYKAZ_ZASAD_ZASIEDLENIA(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  NIERUCHOMOSC INTEGER,
  BUDOWLA      INTEGER,
  PIETRO       DOUBLE PRECISION,
  KLATKA       VARCHAR(5),
  ZASIEDLENIE  INTEGER,
  TYP_BUDOWLI  VARCHAR(3),
  TYP_LOKALU   VARCHAR(3),
  TYP_ZASIEDL  VARCHAR(3))

RETURNS(
  POCZATEK           TIMESTAMP,
  KONIEC             TIMESTAMP,
  TRYB_KON           VARCHAR(1),

  LP                 INTEGER,
  RODZAJ             INTEGER,
  DOTYCZY            VARCHAR(3),
  GRUPA              VARCHAR(1),
  BEZ_ROZRACHUNKOW   VARCHAR(1),
  ROZLICZENIE        VARCHAR(3),
  TYP_VAT            VARCHAR(1),
  CENA               DOUBLE PRECISION,
  BRUTTO_NETTO       VARCHAR(1),
  JM                 VARCHAR(3),
  NORMA              DOUBLE PRECISION,
  ILOSC              DOUBLE PRECISION,
  UCHWALA            VARCHAR(100),
  BEZ_PROPORCJI      VARCHAR(1)
  )
AS
DECLARE VARIABLE OSTATNIA         INTEGER;
DECLARE VARIABLE ATYP_ZASIEDL     VARCHAR(3);
BEGIN
  OSTATNIA = 0;

  FOR SELECT
    ZS.POCZATEK, ZS.KONIEC, ZS.TRYB_KON, ZS.RODZAJ, ZS.DOTYCZY, ZS.GRUPA, ZS.ROZLICZENIE,
    ZS.TYP_VAT, ZS.CENA, ZS.BRUTTO_NETTO, ZS.JM, ZS.NORMA, ZS.ILOSC, ZS.TYP_ZASIEDL_BUD, ZS.UCHWALA, 
    ZS.LP, ZS.BEZ_ROZRACHUNKOW, ZS.BEZ_PROPORCJI
  FROM WYKAZ_ZASAD_ZASIEDLENIA_START(
    :NA_DZIEN, :OSIEDLE, :NIERUCHOMOSC, :BUDOWLA, :PIETRO, :KLATKA,
    :ZASIEDLENIE, :TYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL) ZS
  ORDER BY ZS.RODZAJ, ZS.ZAS_BUD,
    ZS.TYP_ZASIEDL_BUD DESC, ZS.KLATKA_BUD DESC, ZS.PIETRO_OD_BUD DESC, ZS.PIETRO_DO_BUD DESC
  INTO
    :POCZATEK, :KONIEC, :TRYB_KON, :RODZAJ, :DOTYCZY, :GRUPA, :ROZLICZENIE,
    :TYP_VAT, :CENA, :BRUTTO_NETTO, :JM, :NORMA, :ILOSC, :ATYP_ZASIEDL, :UCHWALA, 
    :LP, :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI
  DO BEGIN
    IF (:OSTATNIA <> :RODZAJ)
    THEN BEGIN
      SUSPEND;
      OSTATNIA = :RODZAJ;

      IF (:ROZLICZENIE = 'S')
      THEN FOR SELECT
        Z.ILOSC_POJEMNIKOW * Z.CZESTOTLIWOSC_ODBIORU, S.STAWKA
      FROM ZASIEDLENIA Z, STAWKI_ZA_POJEMNIKI S
      WHERE
        Z.KLUCZ = :ZASIEDLENIE AND S.POJEMNIK = Z.RODZAJ_POJEMNIKOW AND
        S.DATA_OD <= :NA_DZIEN AND (S.DATA_DO >= :NA_DZIEN OR S.DATA_DO IS NULL)
      INTO
        :ILOSC, :CENA
      DO BEGIN
        IF (:CENA > 0)
        THEN SUSPEND;
      END

      IF (:ROZLICZENIE = 'PW')
      THEN FOR SELECT
        I.STAWKA, I.ILOSC, I.JM
      FROM INDYWIDUALNA_STAWKA(:RODZAJ, :ZASIEDLENIE, EXTRACT(YEAR FROM :NA_DZIEN), EXTRACT(MONTH FROM :NA_DZIEN)) I
      INTO :CENA, :ILOSC, :JM
      DO SUSPEND;
    END
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;


/*------------------------------------------------------------------------*/

/* powierzchnie - wstepnie na podany dzien - wg typow powierzchni */
/* dzielone wg wysokosci: do 140cm, do 220cm, powyzej 220cm */
/* 0X=Powierzchnia mieszkalna / glowna */
/* 0=Pokoj */
/* 0A=Przedpokoj */
/* 1=Kuchnia */
/* 2=Lazienka */
/* 3=WC */
/* 4=Lazienka z WC */
/* 5=Piwnica/komorka */
/* 6=Balkon */
/* 7=Loggia */
/* 7A=Zaplecze */
/* 7B=Kotlownia */
/* 8=inne Uzytkowe */
/* 8A=Zabudowa korytarza */
/* 8B=Dodatkowe powierzchnie */
/* 9=inne Nieuzytkowe */

/* ilosci licznikow, dzielone wedlug rodzaju, proporcjonalnie do dlugugosci okresu */


SET TERM ^ ;

CREATE PROCEDURE DANE_NALICZEN(
  APOMIESZCZENIE     INTEGER, 
  DATA_OD            TIMESTAMP,
  DATA_DO            TIMESTAMP
  )
RETURNS(
  P_RODZAJ            VARCHAR(3),
  B_ANTENA            VARCHAR(1),
  B_DOMOFON           VARCHAR(1),
  B_WINDA             VARCHAR(1),
  B_SEGREGACJA_SMIECI VARCHAR(1),
  B_WODA_ZIMNA        VARCHAR(1),
  B_WODA_CIEPLA       VARCHAR(1),
  B_ENERGIA_CIEPLNA   VARCHAR(1),
  B_GAZ               VARCHAR(1),
  B_KANALIZACJA       VARCHAR(1),
  B_STREFA            VARCHAR(1),

  P_WODA_ZIMNA        VARCHAR(3),
  P_WODA_CIEPLA       VARCHAR(3),
  P_ENERGIA_CIEPLNA   VARCHAR(3),
  P_ENERGIA_ELEKTR    VARCHAR(3),
  P_GAZ               VARCHAR(3),
  P_KANALIZACJA       VARCHAR(3),

  P_STAN_TECH         VARCHAR(3),
  P_WSPOLUZYTKOWANIE  VARCHAR(3),
  P_LOKALIZACJA       VARCHAR(3),
  P_TARYFA            VARCHAR(3),
  P_KLATKA            VARCHAR(5),
  P_PIETRO            INTEGER,

  P_WC                INTEGER,
  P_KUCHNIA           INTEGER,
  P_LAZIENKA          INTEGER,
  
  POWIERZCHNIA_0X_140    DOUBLE PRECISION,
  POWIERZCHNIA_0_140     DOUBLE PRECISION,
  POWIERZCHNIA_0A_140    DOUBLE PRECISION,
  POWIERZCHNIA_1_140     DOUBLE PRECISION,
  POWIERZCHNIA_2_140     DOUBLE PRECISION,
  POWIERZCHNIA_3_140     DOUBLE PRECISION,
  POWIERZCHNIA_4_140     DOUBLE PRECISION,
  POWIERZCHNIA_5_140     DOUBLE PRECISION,
  POWIERZCHNIA_6_140     DOUBLE PRECISION,
  POWIERZCHNIA_7_140     DOUBLE PRECISION,
  POWIERZCHNIA_7A_140    DOUBLE PRECISION,
  POWIERZCHNIA_7B_140    DOUBLE PRECISION,
  POWIERZCHNIA_8_140     DOUBLE PRECISION,
  POWIERZCHNIA_8A_140    DOUBLE PRECISION,
  POWIERZCHNIA_8B_140    DOUBLE PRECISION,
  POWIERZCHNIA_9_140     DOUBLE PRECISION,

  POWIERZCHNIA_0X_220    DOUBLE PRECISION,
  POWIERZCHNIA_0_220     DOUBLE PRECISION,
  POWIERZCHNIA_0A_220    DOUBLE PRECISION,
  POWIERZCHNIA_1_220     DOUBLE PRECISION,
  POWIERZCHNIA_2_220     DOUBLE PRECISION,
  POWIERZCHNIA_3_220     DOUBLE PRECISION,
  POWIERZCHNIA_4_220     DOUBLE PRECISION,
  POWIERZCHNIA_5_220     DOUBLE PRECISION,
  POWIERZCHNIA_6_220     DOUBLE PRECISION,
  POWIERZCHNIA_7_220     DOUBLE PRECISION,
  POWIERZCHNIA_7A_220    DOUBLE PRECISION,
  POWIERZCHNIA_7B_220    DOUBLE PRECISION,
  POWIERZCHNIA_8_220     DOUBLE PRECISION,
  POWIERZCHNIA_8A_220    DOUBLE PRECISION,
  POWIERZCHNIA_8B_220    DOUBLE PRECISION,
  POWIERZCHNIA_9_220     DOUBLE PRECISION,

  POWIERZCHNIA_0X    DOUBLE PRECISION,
  POWIERZCHNIA_0     DOUBLE PRECISION,
  POWIERZCHNIA_0A    DOUBLE PRECISION,
  POWIERZCHNIA_1     DOUBLE PRECISION,
  POWIERZCHNIA_2     DOUBLE PRECISION,
  POWIERZCHNIA_3     DOUBLE PRECISION,
  POWIERZCHNIA_4     DOUBLE PRECISION,
  POWIERZCHNIA_5     DOUBLE PRECISION,
  POWIERZCHNIA_6     DOUBLE PRECISION,
  POWIERZCHNIA_7     DOUBLE PRECISION,
  POWIERZCHNIA_7A    DOUBLE PRECISION,
  POWIERZCHNIA_7B    DOUBLE PRECISION,
  POWIERZCHNIA_8     DOUBLE PRECISION,
  POWIERZCHNIA_8A    DOUBLE PRECISION,
  POWIERZCHNIA_8B    DOUBLE PRECISION,
  POWIERZCHNIA_9     DOUBLE PRECISION,
  
  KUBATURA   DOUBLE PRECISION,

  POW_CALKOWITA        DOUBLE PRECISION,
  POW_MIESZKALNA       DOUBLE PRECISION,
  POW_UZYTKOWA         DOUBLE PRECISION,
  POW_OGRZEWANA        DOUBLE PRECISION,
  POW_ZAB_KORYTARZA    DOUBLE PRECISION,
  POW_DODATKOWA        DOUBLE PRECISION,
  POW_INNA_UZYTKOWA    DOUBLE PRECISION,
  POW_INNA_NIEUZYTKOWA DOUBLE PRECISION,
  POW_OBNIZONA         DOUBLE PRECISION,
  
  LICZNIKI_WODA     DOUBLE PRECISION,
  LICZNIKI_GAZ      DOUBLE PRECISION,
  LICZNIKI_CO       DOUBLE PRECISION,
  LICZNIKI_SWIATLO  DOUBLE PRECISION
  )
AS
DECLARE VARIABLE TYP               VARCHAR(3);
DECLARE VARIABLE WYPOSAZENIE       VARCHAR(3);
DECLARE VARIABLE POWIERZCHNIA      DOUBLE PRECISION;
DECLARE VARIABLE WYSOKOSC          DOUBLE PRECISION;
DECLARE VARIABLE LRODZAJ           VARCHAR(3);
DECLARE VARIABLE LPOCZATEK         TIMESTAMP;
DECLARE VARIABLE LKONIEC           TIMESTAMP;
DECLARE VARIABLE OKRES             DOUBLE PRECISION;
DECLARE VARIABLE OKRESLICZNIKA     DOUBLE PRECISION;
DECLARE VARIABLE KUBATURA_LOKALU   DOUBLE PRECISION;
BEGIN
           
  FOR SELECT 
    B.ANTENA, B.DOMOFON, B.WINDA, B.WODA_ZIMNA, B.WODA_CIEPLA, B.CO,
    B.GAZ, B.KANALIZACJA, B.STREFA,
    P.WODA_ZIMNA, P.WODA_CIEPLA, P.ENERGIA_CIEPLNA, P.ENERGIA_ELEKTRYCZNA,
    P.GAZ, P.SCIEKI, P.STAN_TECHNICZNY, P.WSPOLUZYTKOWANIE, P.LOKALIZACJA,
    P.TARYFA, P.KLATKA, P.PIETRO, P.RODZAJ,
    P.POWIERZCHNIA, P.POWIERZCHNIAMIESZKALNA, P.POWIERZCHNIAUZYTKOWA,
    P.POW_CO, P.POW_ZABUDOWY, P.POW_DODATKOWA, P.POW_INNAUZYTKOWA,
    P.POW_INNANIEUZYTKOWA, P.POWIERZCHNIAOBNIZONA, B.SEGREGACJA_SMIECI, P.KUBATURA
  FROM BUDOWLE B, POMIESZCZENIA P
  WHERE P.KLUCZ = :APOMIESZCZENIE AND B.KLUCZ = P.BUDOWLA
  INTO 
    :B_ANTENA, :B_DOMOFON, :B_WINDA, :B_WODA_ZIMNA, :B_WODA_CIEPLA, :B_ENERGIA_CIEPLNA,
    :B_GAZ, :B_KANALIZACJA, :B_STREFA,
    :P_WODA_ZIMNA, :P_WODA_CIEPLA, :P_ENERGIA_CIEPLNA, :P_ENERGIA_ELEKTR,
    :P_GAZ, :P_KANALIZACJA, :P_STAN_TECH, :P_WSPOLUZYTKOWANIE, :P_LOKALIZACJA,
    :P_TARYFA, :P_KLATKA, :P_PIETRO, :P_RODZAJ,
    :POW_CALKOWITA, :POW_MIESZKALNA, :POW_UZYTKOWA, 
    :POW_OGRZEWANA, :POW_ZAB_KORYTARZA, :POW_DODATKOWA, :POW_INNA_UZYTKOWA, 
    :POW_INNA_NIEUZYTKOWA, :POW_OBNIZONA, :B_SEGREGACJA_SMIECI, :KUBATURA_LOKALU
                  
  DO BEGIN
    P_WC = 1;
    P_KUCHNIA = 1;
    KUBATURA = 0;

    POWIERZCHNIA_0X_140 = 0;
    POWIERZCHNIA_0_140 = 0;
    POWIERZCHNIA_0A_140 = 0;
    POWIERZCHNIA_1_140 = 0;
    POWIERZCHNIA_2_140 = 0;
    POWIERZCHNIA_3_140 = 0;
    POWIERZCHNIA_4_140 = 0;
    POWIERZCHNIA_5_140 = 0;
    POWIERZCHNIA_6_140 = 0;
    POWIERZCHNIA_7_140 = 0;
    POWIERZCHNIA_7A_140 = 0;
    POWIERZCHNIA_7B_140 = 0;
    POWIERZCHNIA_8_140 = 0;
    POWIERZCHNIA_8A_140 = 0;
    POWIERZCHNIA_8B_140 = 0;
    POWIERZCHNIA_9_140 = 0;
           
    POWIERZCHNIA_0X_220 = 0;
    POWIERZCHNIA_0_220 = 0;
    POWIERZCHNIA_0A_220 = 0;
    POWIERZCHNIA_1_220 = 0;
    POWIERZCHNIA_2_220 = 0;
    POWIERZCHNIA_3_220 = 0;
    POWIERZCHNIA_4_220 = 0;
    POWIERZCHNIA_5_220 = 0;
    POWIERZCHNIA_6_220 = 0;
    POWIERZCHNIA_7_220 = 0;
    POWIERZCHNIA_7A_220 = 0;
    POWIERZCHNIA_7B_220 = 0;
    POWIERZCHNIA_8_220 = 0;
    POWIERZCHNIA_8A_220 = 0;
    POWIERZCHNIA_8B_220 = 0;
    POWIERZCHNIA_9_220 = 0;

    POWIERZCHNIA_0X = 0;
    POWIERZCHNIA_0 = 0;
    POWIERZCHNIA_0A = 0;
    POWIERZCHNIA_1 = 0;
    POWIERZCHNIA_2 = 0;
    POWIERZCHNIA_3 = 0;
    POWIERZCHNIA_4 = 0;
    POWIERZCHNIA_5 = 0;
    POWIERZCHNIA_6 = 0;
    POWIERZCHNIA_7 = 0;
    POWIERZCHNIA_7A = 0;
    POWIERZCHNIA_7B = 0;
    POWIERZCHNIA_8 = 0;
    POWIERZCHNIA_8A = 0;
    POWIERZCHNIA_8B = 0;
    POWIERZCHNIA_9 = 0;

    P_LAZIENKA = 0;  

    FOR SELECT S.TYP, S.WYPOSAZENIE, S.POWIERZCHNIA, S.WYSOKOSC
    FROM SKLADNIKI_POMIESZCZEN S
    WHERE S.POMIESZCZENIE = :APOMIESZCZENIE AND 
     S.DATA_OD <= :DATA_DO AND (S.DATA_DO IS NULL OR S.DATA_DO >= :DATA_DO)
    INTO :TYP, :WYPOSAZENIE, :POWIERZCHNIA, :WYSOKOSC
    DO BEGIN
      IF ((:TYP = '1') AND ((:WYPOSAZENIE = '2') OR (:WYPOSAZENIE = '4')))
      THEN P_KUCHNIA = 2;
      ELSE IF (:TYP = '3')
      THEN P_WC = :WYPOSAZENIE;
      ELSE IF ((:TYP = '4') AND 
        ((:WYPOSAZENIE = '2') OR (:WYPOSAZENIE = '5') OR (:WYPOSAZENIE = '6') OR (:WYPOSAZENIE = '7')))
      THEN P_WC = 3;
      ELSE IF (((:TYP = '2') OR (:TYP = '4')) AND
        ((:WYPOSAZENIE = '1') OR (:WYPOSAZENIE = '2') OR (:WYPOSAZENIE = '3') OR (:WYPOSAZENIE = '7')))
      THEN P_LAZIENKA = 1; 
      
      KUBATURA = :KUBATURA + (:POWIERZCHNIA * :WYSOKOSC / 100);
         
      IF ((:TYP = '0X') AND (:WYSOKOSC < 140)) THEN POWIERZCHNIA_0X_140 = :POWIERZCHNIA_0X_140 + :POWIERZCHNIA;
      IF ((:TYP = '0') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_0_140  = :POWIERZCHNIA_0_140  + :POWIERZCHNIA;
      IF ((:TYP = '0A') AND (:WYSOKOSC < 140)) THEN POWIERZCHNIA_0A_140 = :POWIERZCHNIA_0A_140 + :POWIERZCHNIA;
      IF ((:TYP = '1') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_1_140  = :POWIERZCHNIA_1_140  + :POWIERZCHNIA;
      IF ((:TYP = '2') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_2_140  = :POWIERZCHNIA_2_140  + :POWIERZCHNIA;
      IF ((:TYP = '3') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_3_140  = :POWIERZCHNIA_3_140  + :POWIERZCHNIA;
      IF ((:TYP = '4') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_4_140  = :POWIERZCHNIA_4_140  + :POWIERZCHNIA;
      IF ((:TYP = '5') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_5_140  = :POWIERZCHNIA_5_140  + :POWIERZCHNIA;
      IF ((:TYP = '6') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_6_140  = :POWIERZCHNIA_6_140  + :POWIERZCHNIA;
      IF ((:TYP = '7') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_7_140  = :POWIERZCHNIA_7_140  + :POWIERZCHNIA;
      IF ((:TYP = '7A') AND (:WYSOKOSC < 140)) THEN POWIERZCHNIA_7A_140 = :POWIERZCHNIA_7A_140 + :POWIERZCHNIA;
      IF ((:TYP = '7B') AND (:WYSOKOSC < 140)) THEN POWIERZCHNIA_7B_140 = :POWIERZCHNIA_7B_140 + :POWIERZCHNIA;
      IF ((:TYP = '8') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_8_140  = :POWIERZCHNIA_8_140  + :POWIERZCHNIA;
      IF ((:TYP = '8A') AND (:WYSOKOSC < 140)) THEN POWIERZCHNIA_8A_140 = :POWIERZCHNIA_8A_140 + :POWIERZCHNIA;
      IF ((:TYP = '8B') AND (:WYSOKOSC < 140)) THEN POWIERZCHNIA_8B_140 = :POWIERZCHNIA_8B_140 + :POWIERZCHNIA;
      IF ((:TYP = '9') AND (:WYSOKOSC < 140))  THEN POWIERZCHNIA_9_140  = :POWIERZCHNIA_9_140  + :POWIERZCHNIA;
         
      IF ((:TYP = '0X') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220)) THEN POWIERZCHNIA_0X_220 = :POWIERZCHNIA_0X_220 + :POWIERZCHNIA;
      IF ((:TYP = '0') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_0_220  = :POWIERZCHNIA_0_220  + :POWIERZCHNIA;
      IF ((:TYP = '0A') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220)) THEN POWIERZCHNIA_0A_220 = :POWIERZCHNIA_0A_220 + :POWIERZCHNIA;
      IF ((:TYP = '1') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_1_220  = :POWIERZCHNIA_1_220  + :POWIERZCHNIA;
      IF ((:TYP = '2') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_2_220  = :POWIERZCHNIA_2_220  + :POWIERZCHNIA;
      IF ((:TYP = '3') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_3_220  = :POWIERZCHNIA_3_220  + :POWIERZCHNIA;
      IF ((:TYP = '4') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_4_220  = :POWIERZCHNIA_4_220  + :POWIERZCHNIA;
      IF ((:TYP = '5') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_5_220  = :POWIERZCHNIA_5_220  + :POWIERZCHNIA;
      IF ((:TYP = '6') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_6_220  = :POWIERZCHNIA_6_220  + :POWIERZCHNIA;
      IF ((:TYP = '7') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_7_220  = :POWIERZCHNIA_7_220  + :POWIERZCHNIA;
      IF ((:TYP = '7A') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220)) THEN POWIERZCHNIA_7A_220 = :POWIERZCHNIA_7A_220 + :POWIERZCHNIA;
      IF ((:TYP = '7B') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220)) THEN POWIERZCHNIA_7B_220 = :POWIERZCHNIA_7B_220 + :POWIERZCHNIA;
      IF ((:TYP = '8') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_8_220  = :POWIERZCHNIA_8_220  + :POWIERZCHNIA;
      IF ((:TYP = '8A') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220)) THEN POWIERZCHNIA_8A_220 = :POWIERZCHNIA_8A_220 + :POWIERZCHNIA;
      IF ((:TYP = '8B') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220)) THEN POWIERZCHNIA_8B_220 = :POWIERZCHNIA_8B_220 + :POWIERZCHNIA;
      IF ((:TYP = '9') AND (:WYSOKOSC >= 140) AND (:WYSOKOSC < 220))  THEN POWIERZCHNIA_9_220  = :POWIERZCHNIA_9_220  + :POWIERZCHNIA;
             
      IF ((:TYP = '0X') AND (:WYSOKOSC >= 220)) THEN POWIERZCHNIA_0X = :POWIERZCHNIA_0X + :POWIERZCHNIA;
      IF ((:TYP = '0') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_0  = :POWIERZCHNIA_0  + :POWIERZCHNIA;
      IF ((:TYP = '0A') AND (:WYSOKOSC >= 220)) THEN POWIERZCHNIA_0A = :POWIERZCHNIA_0A + :POWIERZCHNIA;
      IF ((:TYP = '1') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_1  = :POWIERZCHNIA_1  + :POWIERZCHNIA;
      IF ((:TYP = '2') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_2  = :POWIERZCHNIA_2  + :POWIERZCHNIA;
      IF ((:TYP = '3') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_3  = :POWIERZCHNIA_3  + :POWIERZCHNIA;
      IF ((:TYP = '4') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_4  = :POWIERZCHNIA_4  + :POWIERZCHNIA;
      IF ((:TYP = '5') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_5  = :POWIERZCHNIA_5  + :POWIERZCHNIA;
      IF ((:TYP = '6') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_6  = :POWIERZCHNIA_6  + :POWIERZCHNIA;
      IF ((:TYP = '7') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_7  = :POWIERZCHNIA_7  + :POWIERZCHNIA;
      IF ((:TYP = '7A') AND (:WYSOKOSC >= 220)) THEN POWIERZCHNIA_7A = :POWIERZCHNIA_7A + :POWIERZCHNIA;
      IF ((:TYP = '7B') AND (:WYSOKOSC >= 220)) THEN POWIERZCHNIA_7B = :POWIERZCHNIA_7B + :POWIERZCHNIA;
      IF ((:TYP = '8') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_8  = :POWIERZCHNIA_8  + :POWIERZCHNIA;
      IF ((:TYP = '8A') AND (:WYSOKOSC >= 220)) THEN POWIERZCHNIA_8A = :POWIERZCHNIA_8A + :POWIERZCHNIA;
      IF ((:TYP = '8B') AND (:WYSOKOSC >= 220)) THEN POWIERZCHNIA_8B = :POWIERZCHNIA_8B + :POWIERZCHNIA;
      IF ((:TYP = '9') AND (:WYSOKOSC >= 220))  THEN POWIERZCHNIA_9  = :POWIERZCHNIA_9  + :POWIERZCHNIA;
    END
    
    LICZNIKI_WODA = 0;
    LICZNIKI_GAZ = 0;
    LICZNIKI_CO = 0;
    LICZNIKI_SWIATLO = 0;
    OKRES = DATEDIFF(DAY, :DATA_OD, :DATA_DO) + 1;
    IF (:OKRES = 0) THEN OKRES = 1;

    FOR SELECT L.RODZAJ, L.POCZATEK, L.KONIEC
    FROM LICZNIKI L
    WHERE L.TYP_KLUCZA = 'PMS' AND L.KLUCZ_OBCY = :APOMIESZCZENIE AND
     (L.POCZATEK <= :DATA_DO AND (L.KONIEC >= :DATA_OD OR L.KONIEC IS NULL))
    INTO :LRODZAJ, :LPOCZATEK, :LKONIEC
    DO BEGIN
      IF (:LPOCZATEK < :DATA_OD) THEN LPOCZATEK = :DATA_OD;
      IF ((:LKONIEC IS NULL) OR (:LKONIEC > :DATA_DO)) THEN LKONIEC = :DATA_DO;
      OKRESLICZNIKA = DATEDIFF(DAY, :LPOCZATEK, :LKONIEC) + 1;
      IF (:OKRESLICZNIKA = 0) THEN OKRESLICZNIKA = 1;

      IF ((:LRODZAJ = 'WZ') OR (:LRODZAJ = 'WC') OR (:LRODZAJ = 'WS'))
      THEN LICZNIKI_WODA = :LICZNIKI_WODA + (:OKRESLICZNIKA / :OKRES);
      IF (:LRODZAJ = 'GZ') THEN LICZNIKI_GAZ     = :LICZNIKI_GAZ + (:OKRESLICZNIKA / :OKRES);
      IF (:LRODZAJ = 'EC') THEN LICZNIKI_CO      = :LICZNIKI_CO + (:OKRESLICZNIKA / :OKRES);
      IF (:LRODZAJ = 'EE') THEN LICZNIKI_SWIATLO = :LICZNIKI_SWIATLO + (:OKRESLICZNIKA / :OKRES);
    END            
   
    IF (:KUBATURA_LOKALU > 0) THEN KUBATURA = :KUBATURA_LOKALU;  
    SUSPEND;
  END
END ^

COMMIT WORK ^
SET TERM ; ^

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE LOKATORZY_ZMIANY(
  APOMIESZCZENIE     INTEGER
  )
RETURNS(
  ZASIEDLENIE        INTEGER,
  KLUCZ_KONTYNUACJI  INTEGER,
  GLOWNE             INTEGER,
  DATA_ZMIANY        TIMESTAMP,
  IL_OS_ZAMELD       DOUBLE PRECISION,
  IL_OS_ZAMIESZ      DOUBLE PRECISION
  )
AS
DECLARE VARIABLE ZDATA_OD        TIMESTAMP;
DECLARE VARIABLE ZDATA_DO        TIMESTAMP;
DECLARE VARIABLE LDATA_OD        TIMESTAMP;
DECLARE VARIABLE LDATA_DO        TIMESTAMP;
DECLARE VARIABLE LIL_OS_ZAMELD   DOUBLE PRECISION;
DECLARE VARIABLE LIL_OS_ZAMIESZ  DOUBLE PRECISION;
BEGIN

  FOR SELECT Z.KLUCZ, Z.KLUCZ_KONTYNUACJI, Z.GLOWNE, Z.DATA_OD, Z.DATA_DO
  FROM ZASIEDLENIA Z
  WHERE Z.LOKAL = :APOMIESZCZENIE
  ORDER BY Z.DATA_OD
  INTO :ZASIEDLENIE, :KLUCZ_KONTYNUACJI, :GLOWNE, :ZDATA_OD, :ZDATA_DO
  DO BEGIN

    FOR SELECT L.IL_OS_ZAMELD, L.IL_OS_ZAMIESZ, L.DATA_OD, L.DATA_DO
    FROM LOKATORZY L
    WHERE L.ZASIEDLENIE = :ZASIEDLENIE
    INTO :LIL_OS_ZAMELD, :LIL_OS_ZAMIESZ, :LDATA_OD, :LDATA_DO
    DO BEGIN
      IF ((:LDATA_OD > :ZDATA_OD) AND
        ((:ZDATA_DO IS NULL) OR (:LDATA_OD <= :ZDATA_DO)))
      THEN DATA_ZMIANY = :LDATA_OD;
      ELSE DATA_ZMIANY = :ZDATA_OD;

      IL_OS_ZAMELD      = :LIL_OS_ZAMELD;
      IL_OS_ZAMIESZ     = :LIL_OS_ZAMIESZ;

      SUSPEND;       /* Przyrost lokatorow */

      IF (:LDATA_DO IS NOT NULL OR :ZDATA_DO IS NOT NULL)
      THEN BEGIN
        IF (:LDATA_DO IS NOT NULL)
        THEN BEGIN
          IF (:ZDATA_DO IS NULL OR :LDATA_DO < :ZDATA_DO)
          THEN DATA_ZMIANY = DATEADD(DAY, 1, :LDATA_DO);
          ELSE DATA_ZMIANY = DATEADD(DAY, 1, :ZDATA_DO);
        END
        ELSE DATA_ZMIANY = DATEADD(DAY, 1, :ZDATA_DO);

        IL_OS_ZAMELD      = -:LIL_OS_ZAMELD;
        IL_OS_ZAMIESZ     = -:LIL_OS_ZAMIESZ;

        SUSPEND;    /* Ubycie lokatorow (od nastepnego dnia) */
      END
    END
  END
END ^

COMMIT WORK ^
SET TERM ; ^

/*---*/

SET TERM ^ ;

CREATE PROCEDURE LOKATORZY_HISTORIA(
  APOMIESZCZENIE     INTEGER
  )
RETURNS(
  ZASIEDLENIE        INTEGER,
  KZASIEDLENIE       INTEGER,
  DATA_OD            TIMESTAMP,
  DATA_DO            TIMESTAMP,
  IL_OS_ZAMELD       DOUBLE PRECISION,
  IL_OS_ZAMIESZ      DOUBLE PRECISION
  )
AS
DECLARE VARIABLE LZDATA_ZMIANY   TIMESTAMP;
DECLARE VARIABLE LZK_ZASIEDLENIE INTEGER;
DECLARE VARIABLE LZZASIEDLENIE   INTEGER;
DECLARE VARIABLE LZIL_OS_ZAMELD  DOUBLE PRECISION;
DECLARE VARIABLE LZIL_OS_ZAMIESZ DOUBLE PRECISION;
BEGIN

  KZASIEDLENIE      = NULL;
  ZASIEDLENIE       = NULL;
  DATA_OD           = NULL;
  DATA_DO           = NULL;
  IL_OS_ZAMELD      = 0;
  IL_OS_ZAMIESZ     = 0;

  FOR SELECT LZ.KLUCZ_KONTYNUACJI, LZ.ZASIEDLENIE, LZ.DATA_ZMIANY, 
    SUM(LZ.IL_OS_ZAMELD), SUM(LZ.IL_OS_ZAMIESZ)
  FROM LOKATORZY_ZMIANY(:APOMIESZCZENIE) LZ
  GROUP BY LZ.KLUCZ_KONTYNUACJI, LZ.ZASIEDLENIE, LZ.DATA_ZMIANY
  HAVING SUM(LZ.IL_OS_ZAMELD) <> 0 OR SUM(LZ.IL_OS_ZAMIESZ) <> 0
  ORDER BY LZ.DATA_ZMIANY, SUM(LZ.IL_OS_ZAMELD), SUM(LZ.IL_OS_ZAMIESZ)
  INTO :LZK_ZASIEDLENIE, :LZZASIEDLENIE, :LZDATA_ZMIANY, 
    :LZIL_OS_ZAMELD, :LZIL_OS_ZAMIESZ
  DO BEGIN

    IF (:ZASIEDLENIE IS NOT NULL AND :ZASIEDLENIE <> :LZZASIEDLENIE)
    THEN BEGIN  /* Poprzednie zasiedlenie - na wszelki wypadek, powinny byc juz zera */
      IF ((:IL_OS_ZAMELD <> 0) OR (:IL_OS_ZAMIESZ <> 0))
      THEN BEGIN
        DATA_DO           = DATEADD(DAY, -1, :LZDATA_ZMIANY);
        SUSPEND;
      END
    END

    IF (:ZASIEDLENIE IS NULL OR :ZASIEDLENIE <> :LZZASIEDLENIE)
    THEN BEGIN  /* Nowe zasiedlenie */
      KZASIEDLENIE      = :LZK_ZASIEDLENIE;
      ZASIEDLENIE       = :LZZASIEDLENIE;
      DATA_OD           = :LZDATA_ZMIANY;
      DATA_DO           = NULL;
      IL_OS_ZAMELD      = :LZIL_OS_ZAMELD;
      IL_OS_ZAMIESZ     = :LZIL_OS_ZAMIESZ;
    END

    ELSE IF (:ZASIEDLENIE IS NOT NULL AND :ZASIEDLENIE = :LZZASIEDLENIE)
    THEN BEGIN  /* Kontynuacja zasiedlenia */
      DATA_DO           = DATEADD(DAY, -1, :LZDATA_ZMIANY);
      SUSPEND;
      IL_OS_ZAMELD      = :IL_OS_ZAMELD + :LZIL_OS_ZAMELD;
      IL_OS_ZAMIESZ     = :IL_OS_ZAMIESZ + :LZIL_OS_ZAMIESZ;
      DATA_OD           = :LZDATA_ZMIANY;
      DATA_DO           = NULL;
    END
  END

  IF ((:ZASIEDLENIE IS NOT NULL) AND ((:IL_OS_ZAMELD <> 0) OR (:IL_OS_ZAMIESZ <> 0)))
  THEN SUSPEND;  /* Niezakonczone zasiedlenie */
END ^

COMMIT WORK ^
SET TERM ; ^


/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE WYKAZ_NORM_BUDOWLI(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  BUDOWLA      INTEGER)

RETURNS(
  TYP_LOKALU      VARCHAR(3),
  MEDIUM          VARCHAR(3),
  LICZNIK         VARCHAR(1),
  DATA_OD         TIMESTAMP,
  DATA_DO         TIMESTAMP,
  NORMA           DOUBLE PRECISION,
  NORMA_DOD       DOUBLE PRECISION,
  NORMA_LICZ_RYCZ DOUBLE PRECISION,
  Z_ZASAD         VARCHAR(1)
  )
AS
DECLARE VARIABLE RODZAJ INTEGER;
DECLARE VNORMA   DOUBLE PRECISION;
BEGIN
  NORMA_DOD = 0;
  NORMA_LICZ_RYCZ = 0;

  FOR SELECT
    TYP_LOKALU, POCZATEK, KONIEC, RODZAJ, NORMA
  FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, '', '', '')
  WHERE RODZAJ < 0
  INTO
    :TYP_LOKALU, :DATA_OD, :DATA_DO, :RODZAJ, :VNORMA
  DO BEGIN
    MEDIUM = '';
    LICZNIK = '';
    NORMA = 0;

    IF (:RODZAJ = -1)
    THEN BEGIN
      MEDIUM = 'WZ';
      LICZNIK = 'T';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -2)
    THEN BEGIN
      MEDIUM = 'WZ';
      LICZNIK = 'N';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -3)
    THEN BEGIN
      MEDIUM = 'WC';
      LICZNIK = 'T';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -4)
    THEN BEGIN
      MEDIUM = 'WC';
      LICZNIK = 'N';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -10)
    THEN BEGIN
      MEDIUM = 'EC';
      LICZNIK = 'T';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -11)
    THEN BEGIN
      MEDIUM = 'EC';
      LICZNIK = 'N';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -12)
    THEN BEGIN
      MEDIUM = 'EE';
      LICZNIK = 'N';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -13)
    THEN BEGIN
      MEDIUM = 'EE';
      LICZNIK = 'T';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -14)
    THEN BEGIN
      MEDIUM = 'GZ';
      LICZNIK = 'N';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -15)
    THEN BEGIN
      MEDIUM = 'GZ';
      LICZNIK = 'T';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -16)
    THEN BEGIN
      MEDIUM = 'SC';
      LICZNIK = 'N';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -18)
    THEN BEGIN
      MEDIUM = 'SM';
      LICZNIK = 'N';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END

    IF (:RODZAJ = -20)
    THEN BEGIN
      MEDIUM = 'SB';
      LICZNIK = 'N';
      NORMA = :VNORMA;
      Z_ZASAD = 'T';
    END


    IF (:MEDIUM <> '')
    THEN BEGIN
      IF (
        (SELECT COUNT(KLUCZ)
        FROM NORMY_MEDIOW
        WHERE
          TYP = 'B' AND DOTYCZY = :BUDOWLA AND
          MEDIUM = :MEDIUM AND LICZNIK = :LICZNIK AND
          DATA_OD <= :NA_DZIEN AND
          (DATA_DO IS NULL OR DATA_DO >= :NA_DZIEN)) = 0)
      THEN SUSPEND;
    END
  END

  TYP_LOKALU = '';
  FOR SELECT MEDIUM, LICZNIK, DATA_OD, DATA_DO, NORMA, NORMA_DOD, NORMA_LICZ_RYCZ, 'N'
  FROM NORMY_MEDIOW
  WHERE
    TYP = 'B' AND DOTYCZY = :BUDOWLA AND
    DATA_OD <= :NA_DZIEN AND
    (DATA_DO IS NULL OR DATA_DO >= :NA_DZIEN)
    INTO :MEDIUM, :LICZNIK, :DATA_OD, :DATA_DO, :NORMA, :NORMA_DOD, :NORMA_LICZ_RYCZ, :Z_ZASAD
  DO SUSPEND;

END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE WYKAZ_NORM_LOKALU(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  BUDOWLA      INTEGER,
  LOKAL        INTEGER,
  TYP_LOKALU   VARCHAR(3))

RETURNS(
  MEDIUM          VARCHAR(3),
  LICZNIK         VARCHAR(1),
  DATA_OD         TIMESTAMP,
  DATA_DO         TIMESTAMP,
  NORMA           DOUBLE PRECISION,
  NORMA_DOD       DOUBLE PRECISION,
  NORMA_LICZ_RYCZ DOUBLE PRECISION,
  Z_ZASAD         VARCHAR(1)
  )
AS
BEGIN

  FOR SELECT
    MEDIUM, LICZNIK, DATA_OD, DATA_DO,
    NORMA, NORMA_DOD, NORMA_LICZ_RYCZ, Z_ZASAD
  FROM WYKAZ_NORM_BUDOWLI(:NA_DZIEN, :OSIEDLE, :BUDOWLA)
  WHERE
    (TYP_LOKALU = :TYP_LOKALU OR TYP_LOKALU = '')  /* To drugie bedzie z norm budynku */
/*    AND */
/*    (NORMA IS NOT NULL AND NORMA > 0) */
  INTO
    :MEDIUM, :LICZNIK, :DATA_OD, :DATA_DO,
    :NORMA, :NORMA_DOD, :NORMA_LICZ_RYCZ, :Z_ZASAD
  DO BEGIN
    IF (
      (SELECT COUNT(KLUCZ)
       FROM NORMY_MEDIOW
       WHERE
         TYP = 'P' AND DOTYCZY = :LOKAL AND
         MEDIUM = :MEDIUM AND LICZNIK = :LICZNIK AND
         DATA_OD <= :NA_DZIEN AND
         (DATA_DO IS NULL OR DATA_DO >= :NA_DZIEN)) = 0)
    THEN SUSPEND;
  END

  FOR SELECT MEDIUM, LICZNIK, DATA_OD, DATA_DO, NORMA, NORMA_DOD, NORMA_LICZ_RYCZ, 'N'
  FROM NORMY_MEDIOW
  WHERE
    TYP = 'P' AND DOTYCZY = :LOKAL AND
    DATA_OD <= :NA_DZIEN AND
    (DATA_DO IS NULL OR DATA_DO >= :NA_DZIEN)
  INTO :MEDIUM, :LICZNIK, :DATA_OD, :DATA_DO, :NORMA, :NORMA_DOD, :NORMA_LICZ_RYCZ, :Z_ZASAD
  DO SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^


COMMIT WORK;

/*------------------------------------------------------------------------*/

CREATE TABLE ZASADY_BUDOWLI(
  CONNECTIONID   KLUCZ NOT NULL,

  TYP_BUDOWLI    VARCHAR(3),
  TYP_LOKALU     VARCHAR(3),
  TYP_ZASIEDL    VARCHAR(3),
  POCZATEK       TIMESTAMP,
  KONIEC         TIMESTAMP,
  TRYB_KON       VARCHAR(1),
  LP             INTEGER,
  RODZAJ         INTEGER,
  DOTYCZY        VARCHAR(3),
  GRUPA          VARCHAR(1),
  ROZLICZENIE    VARCHAR(3),
  TYP_VAT        VARCHAR(1),
  BEZ_ROZRACHUNKOW   TAKNIE, 
  BEZ_PROPORCJI TAKNIE,
  CENA           DOUBLE PRECISION,
  BRUTTO_NETTO   VARCHAR(1),
  JM             VARCHAR(3),
  NORMA          DOUBLE PRECISION,
  ILOSC          DOUBLE PRECISION,
  PIETRO_OD      DOUBLE PRECISION,
  PIETRO_DO      DOUBLE PRECISION,
  KLATKA         VARCHAR(5),
  UCHWALA        VARCHAR(100));

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE ZASADY_BUDOWLI_TBL(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  NIERUCHOMOSC INTEGER,
  BUDOWLA      INTEGER,
  TYP_BUDOWLI  VARCHAR(3),
  ID_CONNECTION INTEGER)

RETURNS(
  TYP_LOKALU         VARCHAR(3),
  TYP_ZASIEDL        VARCHAR(3),

  POCZATEK           TIMESTAMP,
  KONIEC             TIMESTAMP,
  TRYB_KON           VARCHAR(1),

  LP                 INTEGER,
  RODZAJ             INTEGER,
  DOTYCZY            VARCHAR(3),
  GRUPA              VARCHAR(1),
  BEZ_ROZRACHUNKOW   VARCHAR(1),
  ROZLICZENIE        VARCHAR(3),
  TYP_VAT            VARCHAR(1),
  CENA               DOUBLE PRECISION,
  BRUTTO_NETTO       VARCHAR(1),
  JM                 VARCHAR(3),
  NORMA              DOUBLE PRECISION,
  ILOSC              DOUBLE PRECISION,           /* Ilosc zawsze bedzie NULL */

  PIETRO_OD          DOUBLE PRECISION,
  PIETRO_DO          DOUBLE PRECISION,
  KLATKA             VARCHAR(5),
  UCHWALA            VARCHAR(100),
  BEZ_PROPORCJI      VARCHAR(1)
  )
AS
DECLARE VARIABLE POZYCJA          INTEGER;
DECLARE VTYP_BUDOWLI              VARCHAR(3);
BEGIN
  DELETE FROM ZASADY_BUDOWLI 
  WHERE CONNECTIONID = :ID_CONNECTION;

  /* Zasady nieruchomosci */

  ILOSC = NULL;
  FOR SELECT
    ZSC.TYP_BUDOWLI, ZSC.TYP_LOKALU, ZSC.TYP_ZASIEDL,
    ZSC.POCZATEK, ZSC.KONIEC, ZSC.TRYB_KON,
    ZSC.RODZAJ, ZSC.ROZLICZENIE, ZSC.TYP_VAT, ZSC.CENA, ZSC.BRUTTO_NETTO,
    ZSC.JM, ZSC.NORMA, ZSC.PIETRO_OD, ZSC.PIETRO_DO, ZSC.KLATKA, ZSC.DOTYCZY, 
    ZSC.GRUPA, ZSC.UCHWALA, ZSC.LP, ZSC.ILOSC, ZSC.BEZ_ROZRACHUNKOW, ZSC.BEZ_PROPORCJI
  FROM WYKAZ_ZASAD_NIERUCHOMOSCI(:NA_DZIEN, :OSIEDLE, :NIERUCHOMOSC, :TYP_BUDOWLI) ZSC
  WHERE
    (ZSC.TYP_BUDOWLI = :TYP_BUDOWLI OR ZSC.TYP_BUDOWLI = '' OR ZSC.TYP_BUDOWLI IS NULL)
  INTO
    :VTYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL,
    :POCZATEK, :KONIEC, :TRYB_KON,
    :RODZAJ, :ROZLICZENIE, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :JM, :NORMA, :PIETRO_OD, :PIETRO_DO, :KLATKA, :DOTYCZY, 
    :GRUPA, :UCHWALA, :LP, :ILOSC, :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI
  DO BEGIN
    IF (    /* nie istnieje identyczna zasada dla budowli */
      (SELECT COUNT(*) FROM CENNIKI_INFRASTRUKTURY C
       WHERE
         C.TYP = 'B' AND C.DOTYCZY = :BUDOWLA AND
         C.OPLATA = :RODZAJ AND
         C.DATA_OD <= :NA_DZIEN AND
         (C.DATA_DO IS NULL OR C.DATA_DO >= :NA_DZIEN)
         AND
         (C.TYP_LOKALU = :TYP_LOKALU) AND
         (C.TYP_ZASIEDLENIA = :TYP_ZASIEDL OR C.TYP_ZASIEDLENIA IS NULL) AND
         ((C.PIETRO_OD = :PIETRO_OD AND :PIETRO_OD IS NOT NULL) OR C.PIETRO_OD IS NULL OR C.PIETRO_OD = 0) AND
         ((C.PIETRO_DO = :PIETRO_DO AND :PIETRO_DO IS NOT NULL) OR C.PIETRO_DO IS NULL OR C.PIETRO_DO = 0) AND
         ((C.KLATKA = :KLATKA AND :KLATKA IS NOT NULL) OR C.KLATKA IS NULL OR C.KLATKA = '')
         ) = 0)
    THEN BEGIN
      IF (:VTYP_BUDOWLI IS NULL) THEN VTYP_BUDOWLI = '';
      INSERT INTO ZASADY_BUDOWLI 
        (CONNECTIONID, TYP_BUDOWLI, TYP_LOKALU, TYP_ZASIEDL, POCZATEK, KONIEC, TRYB_KON, LP,
         RODZAJ, DOTYCZY, GRUPA, ROZLICZENIE, TYP_VAT, CENA,
         BRUTTO_NETTO, JM, NORMA, ILOSC, PIETRO_OD, PIETRO_DO,
         KLATKA, UCHWALA, BEZ_PROPORCJI)
      VALUES 
        (:ID_CONNECTION, :VTYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL, :POCZATEK, :KONIEC, :TRYB_KON, :LP,
         :RODZAJ, :DOTYCZY, :GRUPA, :ROZLICZENIE, :TYP_VAT, :CENA,
         :BRUTTO_NETTO, :JM, :NORMA, :ILOSC, :PIETRO_OD, :PIETRO_DO,
         :KLATKA, :UCHWALA, :BEZ_PROPORCJI);
      SUSPEND;
    END 
  END

  /* Zasady dla budowli */

  TRYB_KON = NULL;
  NORMA = NULL;

  FOR SELECT
    C.TYP_LOKALU, C.TYP_ZASIEDLENIA,
    C.DATA_OD, C.DATA_DO,
    C.OPLATA, C.TYP_VAT, C.KWOTA, C.BRUTTO_NETTO,
    C.PIETRO_OD, C.PIETRO_DO, C.KLATKA,
    C.ILOSC, C.POZYCJA, C.UCHWALA, C.BEZ_PROPORCJI   /* Ilosc zawsze bedzie NULL */
  FROM CENNIKI_INFRASTRUKTURY C
  WHERE                                              /* bez warunku na cene !!! */
    C.TYP = 'B' AND C.DOTYCZY = :BUDOWLA AND
    C.DATA_OD <= :NA_DZIEN AND
    (C.DATA_DO IS NULL OR C.DATA_DO >= :NA_DZIEN)
  INTO
    :TYP_LOKALU, :TYP_ZASIEDL,
    :POCZATEK, :KONIEC,
    :RODZAJ, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :PIETRO_OD, :PIETRO_DO, :KLATKA,
    :ILOSC, :POZYCJA, :UCHWALA, :BEZ_PROPORCJI
  DO BEGIN
    ROZLICZENIE = '';
    JM = '';

    FOR SELECT WZ.TYP_BUDOWLI, WZ.ROZLICZENIE, WZ.JM, WZ.DOTYCZY, WZ.GRUPA, WZ.LP, WZ.BEZ_ROZRACHUNKOW
    FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :TYP_BUDOWLI, :TYP_LOKALU, '') WZ
    WHERE WZ.RODZAJ = :RODZAJ AND
      (WZ.TYP_ZASIEDL = :TYP_ZASIEDL OR WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL IS NULL)
    ROWS 1
    INTO :VTYP_BUDOWLI, :ROZLICZENIE, :JM, :DOTYCZY, :GRUPA, :LP, :BEZ_ROZRACHUNKOW
    DO BEGIN
      IF (:VTYP_BUDOWLI IS NULL) 
      THEN VTYP_BUDOWLI = '';
      IF (:ROZLICZENIE IS NULL)
      THEN ROZLICZENIE = '';
      IF (:JM IS NULL)
      THEN JM = '';
      IF (:DOTYCZY IS NULL)
      THEN DOTYCZY = '';
      IF (:GRUPA IS NULL)
      THEN GRUPA = '';
      IF (:BEZ_ROZRACHUNKOW IS NULL)
      THEN BEZ_ROZRACHUNKOW = 'N';
      
      IF (:POZYCJA > 0)
      THEN SELECT TYP_VAT, CENA, BRUTTO_NETTO
        FROM POZYCJE_CENNIKOW
        WHERE OPLATA = :RODZAJ AND KLUCZ = :POZYCJA
        INTO :TYP_VAT, :CENA, :BRUTTO_NETTO;
        
      INSERT INTO ZASADY_BUDOWLI 
        (CONNECTIONID, TYP_BUDOWLI, TYP_LOKALU, TYP_ZASIEDL, POCZATEK, KONIEC, TRYB_KON, LP,
         RODZAJ, DOTYCZY, GRUPA, ROZLICZENIE, TYP_VAT, CENA,
         BRUTTO_NETTO, JM, NORMA, ILOSC, PIETRO_OD, PIETRO_DO,
         KLATKA, UCHWALA, BEZ_ROZRACHUNKOW, BEZ_PROPORCJI)
      VALUES 
        (:ID_CONNECTION, :VTYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL, :POCZATEK, :KONIEC, :TRYB_KON, :LP,
         :RODZAJ, :DOTYCZY, :GRUPA, :ROZLICZENIE, :TYP_VAT, :CENA,
         :BRUTTO_NETTO, :JM, :NORMA, :ILOSC, :PIETRO_OD, :PIETRO_DO,
         :KLATKA, :UCHWALA, :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI);
      SUSPEND;
    END
  END
  SUSPEND;
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*------------------------------------------------------------------------*/

SET TERM ^ ;

CREATE PROCEDURE ZASADY_ZASIEDLENIA_START_TBL(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  NIERUCHOMOSC INTEGER,
  BUDOWLA      INTEGER,
  PIETRO       DOUBLE PRECISION,
  KLATKA       VARCHAR(5),
  ZASIEDLENIE  INTEGER,
  TYP_BUDOWLI  VARCHAR(3),
  TYP_LOKALU   VARCHAR(3),
  TYP_ZASIEDL  VARCHAR(3),
  ID_CONNECTION INTEGER)

RETURNS(
  POCZATEK           TIMESTAMP,
  KONIEC             TIMESTAMP,
  TRYB_KON           VARCHAR(1),
  LP                 INTEGER,

  RODZAJ             INTEGER,
  DOTYCZY            VARCHAR(3),
  GRUPA              VARCHAR(1),
  BEZ_ROZRACHUNKOW   VARCHAR(1),
  ROZLICZENIE        VARCHAR(3),
  TYP_VAT            VARCHAR(1),
  CENA               DOUBLE PRECISION,
  BRUTTO_NETTO       VARCHAR(1),
  JM                 VARCHAR(3),
  NORMA              DOUBLE PRECISION,
  ILOSC              DOUBLE PRECISION,
  UCHWALA            VARCHAR(100),
  BEZ_PROPORCJI      VARCHAR(1),

  KLATKA_BUD         VARCHAR(5),
  PIETRO_OD_BUD      DOUBLE PRECISION,
  PIETRO_DO_BUD      DOUBLE PRECISION,
  TYP_ZASIEDL_BUD    VARCHAR(3),
  ZAS_BUD            INTEGER                    /* 1 z budowli, 0 z zasiedlenia */
  )
AS
DECLARE VARIABLE POZYCJA          INTEGER;
BEGIN
  /* Zasady budowli */
  ILOSC = NULL;
  ZAS_BUD = 1;
  FOR SELECT
    ZSC.POCZATEK, ZSC.KONIEC, ZSC.TRYB_KON,
    ZSC.RODZAJ, ZSC.ROZLICZENIE, ZSC.TYP_VAT, ZSC.CENA, ZSC.BRUTTO_NETTO,
    ZSC.JM, ZSC.NORMA, ZSC.DOTYCZY, ZSC.GRUPA, 
    ZSC.KLATKA, ZSC.PIETRO_OD, ZSC.PIETRO_DO, ZSC.TYP_ZASIEDL, ZSC.UCHWALA, 
    ZSC.LP, ZSC.ILOSC, ZSC.BEZ_ROZRACHUNKOW, ZSC.BEZ_PROPORCJI
  FROM ZASADY_BUDOWLI ZSC
  WHERE
    (ZSC.CONNECTIONID = :ID_CONNECTION) AND 
    (ZSC.PIETRO_OD <= :PIETRO OR ZSC.PIETRO_OD IS NULL) AND
    (ZSC.PIETRO_DO >= :PIETRO OR ZSC.PIETRO_DO IS NULL OR ZSC.PIETRO_DO = 0) AND
    (ZSC.KLATKA = :KLATKA OR ZSC.KLATKA IS NULL OR ZSC.KLATKA = '')
    AND
    (ZSC.TYP_LOKALU = :TYP_LOKALU) AND
    (ZSC.TYP_ZASIEDL = :TYP_ZASIEDL OR ZSC.TYP_ZASIEDL = '' OR ZSC.TYP_ZASIEDL IS NULL)
  INTO
    :POCZATEK, :KONIEC, :TRYB_KON,
    :RODZAJ, :ROZLICZENIE, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :JM, :NORMA, :DOTYCZY, :GRUPA,
    :KLATKA_BUD, :PIETRO_OD_BUD, :PIETRO_DO_BUD, :TYP_ZASIEDL_BUD, :UCHWALA, 
    :LP, :ILOSC, :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI
  DO BEGIN
    IF (:KLATKA_BUD IS NULL)         THEN KLATKA_BUD = '';
    IF (:PIETRO_OD_BUD IS NULL)      THEN PIETRO_OD_BUD = 0;
    IF (:PIETRO_DO_BUD IS NULL)      THEN PIETRO_DO_BUD = 0;
    IF (:TYP_ZASIEDL_BUD IS NULL)    THEN TYP_ZASIEDL_BUD = '';
    SUSPEND;
  END
  /* Zasady dla zasiedlenia */
  TRYB_KON = NULL;
  NORMA = NULL;
  ZAS_BUD = 0;
  TYP_ZASIEDL_BUD = :TYP_ZASIEDL;
  KLATKA_BUD = '';
  PIETRO_OD_BUD = 0;
  PIETRO_DO_BUD = 0;
  FOR SELECT
    C.DATA_OD, C.DATA_DO,
    C.OPLATA, C.TYP_VAT, C.KWOTA, C.BRUTTO_NETTO,
    C.ILOSC, C.POZYCJA, C.UCHWALA, C.BEZ_PROPORCJI
  FROM CENNIKI_INFRASTRUKTURY C
  WHERE                                              /* bez warunku na cene !!! */
    C.TYP = 'Z' AND C.DOTYCZY = :ZASIEDLENIE AND
    C.DATA_OD <= :NA_DZIEN AND
    (C.DATA_DO IS NULL OR C.DATA_DO >= :NA_DZIEN)
  INTO
    :POCZATEK, :KONIEC,
    :RODZAJ, :TYP_VAT, :CENA, :BRUTTO_NETTO,
    :ILOSC, :POZYCJA, :UCHWALA, :BEZ_PROPORCJI
  DO BEGIN
    ROZLICZENIE = '';
    JM = '';
    FOR SELECT WZ.ROZLICZENIE, WZ.JM, WZ.DOTYCZY, WZ.GRUPA, WZ.LP, WZ.BEZ_ROZRACHUNKOW
    FROM WYKAZ_ZASAD_CZYNSZOWYCH(:NA_DZIEN, :OSIEDLE, :TYP_BUDOWLI, :TYP_LOKALU, '') WZ
    WHERE WZ.RODZAJ = :RODZAJ AND
      (WZ.TYP_ZASIEDL = :TYP_ZASIEDL OR WZ.TYP_ZASIEDL = '' OR WZ.TYP_ZASIEDL IS NULL)
    ROWS 1
    INTO :ROZLICZENIE, :JM, :DOTYCZY, :GRUPA, :LP, :BEZ_ROZRACHUNKOW
    DO BEGIN
      IF (:ROZLICZENIE IS NULL)
      THEN ROZLICZENIE = '';
      IF (:JM IS NULL)
      THEN JM = '';
      IF (:DOTYCZY IS NULL)
      THEN DOTYCZY = '';
      IF (:GRUPA IS NULL)
      THEN GRUPA = '';
      IF (:POZYCJA > 0)
      THEN
        SELECT TYP_VAT, CENA, BRUTTO_NETTO
        FROM POZYCJE_CENNIKOW
        WHERE OPLATA = :RODZAJ AND KLUCZ = :POZYCJA
        INTO :TYP_VAT, :CENA, :BRUTTO_NETTO;
      SUSPEND;
    END
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/* --- */

SET TERM ^ ;

CREATE PROCEDURE ZASADY_ZASIEDLENIA_TBL(
  NA_DZIEN     TIMESTAMP,
  OSIEDLE      INTEGER,
  NIERUCHOMOSC INTEGER,
  BUDOWLA      INTEGER,
  PIETRO       DOUBLE PRECISION,
  KLATKA       VARCHAR(5),
  ZASIEDLENIE  INTEGER,
  TYP_BUDOWLI  VARCHAR(3),
  TYP_LOKALU   VARCHAR(3),
  TYP_ZASIEDL  VARCHAR(3),
  ID_CONNECTION INTEGER)

RETURNS(
  POCZATEK           TIMESTAMP,
  KONIEC             TIMESTAMP,
  TRYB_KON           VARCHAR(1),

  LP                 INTEGER,
  RODZAJ             INTEGER,
  DOTYCZY            VARCHAR(3),
  GRUPA              VARCHAR(1),
  BEZ_ROZRACHUNKOW   VARCHAR(1),
  ROZLICZENIE        VARCHAR(3),
  TYP_VAT            VARCHAR(1),
  CENA               DOUBLE PRECISION,
  BRUTTO_NETTO       VARCHAR(1),
  JM                 VARCHAR(3),
  NORMA              DOUBLE PRECISION,
  ILOSC              DOUBLE PRECISION,
  UCHWALA            VARCHAR(100),
  BEZ_PROPORCJI      VARCHAR(1)
  )
AS
DECLARE VARIABLE OSTATNIA         INTEGER;
DECLARE VARIABLE ATYP_ZASIEDL     VARCHAR(3);
BEGIN
  OSTATNIA = 0;

  FOR SELECT
    ZS.POCZATEK, ZS.KONIEC, ZS.TRYB_KON, ZS.RODZAJ, ZS.DOTYCZY, ZS.GRUPA, ZS.ROZLICZENIE,
    ZS.TYP_VAT, ZS.CENA, ZS.BRUTTO_NETTO, ZS.JM, ZS.NORMA, ZS.ILOSC, ZS.TYP_ZASIEDL_BUD, 
    ZS.UCHWALA, ZS.LP, ZS.BEZ_ROZRACHUNKOW, ZS.BEZ_PROPORCJI
  FROM ZASADY_ZASIEDLENIA_START_TBL(
    :NA_DZIEN, :OSIEDLE, :NIERUCHOMOSC, :BUDOWLA, :PIETRO, :KLATKA,
    :ZASIEDLENIE, :TYP_BUDOWLI, :TYP_LOKALU, :TYP_ZASIEDL, :ID_CONNECTION) ZS
  ORDER BY ZS.RODZAJ, ZS.ZAS_BUD,
    ZS.TYP_ZASIEDL_BUD DESC, ZS.KLATKA_BUD DESC, ZS.PIETRO_OD_BUD DESC, ZS.PIETRO_DO_BUD DESC
  INTO
    :POCZATEK, :KONIEC, :TRYB_KON, :RODZAJ, :DOTYCZY, :GRUPA, :ROZLICZENIE,
    :TYP_VAT, :CENA, :BRUTTO_NETTO, :JM, :NORMA, :ILOSC, :ATYP_ZASIEDL, 
    :UCHWALA, :LP, :BEZ_ROZRACHUNKOW, :BEZ_PROPORCJI
  DO BEGIN
    IF (:OSTATNIA <> :RODZAJ)
    THEN SUSPEND;
    OSTATNIA = :RODZAJ;
  END
END ^

COMMIT WORK ^
SET TERM ; ^

COMMIT WORK;

/*==========================================================================*/
/* komunikaty czynszowe  */
/* ===================== */

/*
Komunikaty czynszowe w serwisie lokatora

Klucze pobierane s z GET_UNIQUE_KEY_GEN

TEMATY_LOKATORA - definiuja tematy, ktrych dotyczy korespondencja
KOMUNIKATY_LOKATORA - kolejne wysyki lokatora

Typ
W - wiadomosc
A - awaria
S - skarga
D - dokument (do administracji)
L - stan licznika
O - zmiana ilosci osob


Status (tylko dla administracji)
W - wyslany
O - odebrany (jest odpowied)

*/

CREATE TABLE TEMATY_CZYNSZOWE
(
  KLUCZ        KLUCZ NOT NULL,
  LOKAL        KLUCZ NOT NULL,   /* Gdy 0 to dotyczy administracji */
  DOTYCZY      KLUCZ,
  TYPDOTYCZY   TYP,

  DATA         TIMESTAMP,
  STATUS       TYP,
  PRACOWNIK    KLUCZ,            /* Ostatni */
  ZAMKNIETY    TIMESTAMP,
  TYP          TYP,
  TYTUL        VARCHAR(100),

  PRIMARY KEY (KLUCZ));

CREATE INDEX TEMATY_CZYNSZOWE_XLOKAL ON TEMATY_CZYNSZOWE(LOKAL);
CREATE INDEX TEMATY_CZYNSZOWE_XDOTYCZY ON TEMATY_CZYNSZOWE(DOTYCZY);


/* --- */

CREATE TABLE KOMUNIKATY_CZYNSZOWE
(
  KLUCZ        KLUCZ NOT NULL,
  NADAWCA      TYP NOT NULL,      /* Lokator, Administracja */
  PRACOWNIK    KLUCZ,             /* Tylko przy wysyce z administracji */

  O_OSIEDLE      KLUCZ,           /* Te parametry wyznaczaja zakres widocznosci dla odbiorcy*/
  O_NIERUCHOMOSC KLUCZ,           /* komunikatu, NULL oznacza widocznosc dla wszystkich */
  O_BUDOWLA      KLUCZ,           /* 0 - oznacza blokade, wysylka tylko do administracji */
  O_KLATKA       DIDENT,          /* lub do konkretnego lokatora */

  LOKAL        KLUCZ,             /* To zawsze nadawca, gdy L, odbiorca gdy A lub NULL (gdy do wikszej iloci osb) */
  DOTYCZY      KLUCZ,
  TYPDOTYCZY   TYP,

  N_OSIEDLE      KLUCZ,           /* Te parametry wyznaczaja nadawce przy L oraz odbiorc przy A (odpowied)  */
  N_NIERUCHOMOSC KLUCZ,           /* W tym drugim przypadku mog by NULL gdy nie jest to odpowied */
  N_BUDOWLA      KLUCZ,           /* chyba, e wysyka do konkretnego lokatora */
  N_KLATKA       DIDENT,

  DATA         TIMESTAMP,

  TYP          TYP,
  TEMAT        KLUCZ,             /* TEMATY_LOKATORA */
  ADRESMAIL    VARCHAR(100),
  STATUS       TYP,

  TRESC        PARAMETRY,

  ZALACZNIK    KLUCZ,             /* Do bazy dokumentow */

  PRIMARY KEY (KLUCZ));


CREATE INDEX KOM_CZYNSZOWE_XLOKAL ON KOMUNIKATY_CZYNSZOWE(LOKAL);
CREATE INDEX KOM_CZYNSZOWE_XDOTYCZY ON KOMUNIKATY_CZYNSZOWE(DOTYCZY);

CREATE INDEX KOM_CZYNSZOWE_XO_OSIEDLE ON KOMUNIKATY_CZYNSZOWE(O_OSIEDLE);
CREATE INDEX KOM_CZYNSZOWE_XO_NIERUCHOMOSC ON KOMUNIKATY_CZYNSZOWE(O_NIERUCHOMOSC);
CREATE INDEX KOM_CZYNSZOWE_XO_BUDOWLA ON KOMUNIKATY_CZYNSZOWE(O_BUDOWLA);

CREATE INDEX KOM_CZYNSZOWE_XN_OSIEDLE ON KOMUNIKATY_CZYNSZOWE(N_OSIEDLE);
CREATE INDEX KOM_CZYNSZOWE_XN_NIERUCHOMOSC ON KOMUNIKATY_CZYNSZOWE(N_NIERUCHOMOSC);
CREATE INDEX KOM_CZYNSZOWE_XN_BUDOWLA ON KOMUNIKATY_CZYNSZOWE(N_BUDOWLA);


/*==========================================================================*/
/* SMS-y i maile     */
/* ================= */

CREATE TABLE LISTA_WYSYLEK
   (KLUCZ            KLUCZ NOT NULL,
    NUMER            INTEGER,          /* odpuszczamy, wykorzystany jako identyfikator zakladu */
    LP_WYSYLKI       INTEGER,          /* nr kolejnej wysyki od 1 */

    DOWYSLANIA       INTEGER,          /* typ = '0' */
    WYSLANE          INTEGER,          /* typ = '2' */
    BLEDNE           INTEGER,          /* typ = '3' */

    OPIS             OPIS,
    RODZAJ           TYP,              /* P - przychodnia, G - gabinet, C - czynsze, F - finanse (firmy) */
    TYP              TYP,              /* S - SMS, M - mail, O - oba  */
    STATUS           TYP,              /* 0 - do wysania,
                                          2 - potwierdzone poprawne,
                                          3 - bdy ,
                                          reszta nieaktualne
                                          1 - wysane (nieaktualne),
                                          4 - bd caoci (nieaktualne) , 9 - wycofane */

    DATA             TIMESTAMP,
    SMS              VARCHAR(402),     /* nieaktualne zawsze wykorzystywany jest mail */
    MAIL             UWAGI,
    ZALACZNIK        VARCHAR(150),

    PUNKTY           ILOSC,            /* DLA sms */

    UTWORZYL         KLUCZ,
    ZMIENIAL         KLUCZ,
    UTWORZONO        TIMESTAMP,
    ZMIENIANO        TIMESTAMP,

    PRIMARY KEY(KLUCZ));

CREATE INDEX WYSYLKI_XDATA    ON LISTA_WYSYLEK(DATA);


CREATE TABLE PACZKI_WYSYLEK            /* to sluzy tylko do podzialu wysylki
                                          na grupy do 100 osob, istotne jest
                                          tylko pole lista i ilosc, reszta nieaktualna */ 
   (KLUCZ            KLUCZ NOT NULL,
    LISTA            KLUCZ NOT NULL,
    ILOSC            INTEGER,

    LP_WYSYLKI       INTEGER,          /* nr kolejnej wysyki od 1 */
    TYP              TYP,              /* S - SMS, M - mail */
    STATUS           TYP,              /* jak wyzej
                                          0 - do wysania, 1 - wysane,
                                          2 - potwierdzone poprawne, 3 - bdy czciowe,
                                          4 - bd caoci, 9 - wycofane */
    BLAD             UWAGI,            /* Komunikat bdu */

    WYSYLKA          XML2,  /* dla SMS-w nieaktualne */
    ODPOWIEDZ        XML2,  /* dla SMS-w nieaktualne */

    PUNKTY           ILOSC,

    UTWORZYL         KLUCZ,
    ZMIENIAL         KLUCZ,
    UTWORZONO        TIMESTAMP,
    ZMIENIANO        TIMESTAMP,

    FOREIGN KEY(LISTA) REFERENCES LISTA_WYSYLEK(KLUCZ),
    PRIMARY KEY(KLUCZ));


CREATE TABLE WYSYLKI_PACJENTA
   (KLUCZ             KLUCZ NOT NULL,
    PACZKA            KLUCZ NOT NULL,
    PACJENT           KLUCZ,            /* ujemna wartosc oznacza firme */
    ZLECENIE          KLUCZ,
    LP_WYSYLKI        INTEGER,          /* nr kolejnej wysyki od 1 */

    ADRMAIL           DUZY_OPIS,
    ADRSMS            VARCHAR(15),

    TYP               TYP,              /* S - SMS, M - mail */
    STATUS            TYP,              /* jak wyzej
                                           0 - do wysania,
                                           2 - potwierdzone poprawne, 3 - bd,
                                           nieaktualne :
                                           1 - wysane,
                                           9 - wycofane */
    BLAD              UWAGI,            /* Komunikat bdu */

    SMS               VARCHAR(402),     /* nieaktualne zawsze wykorzystywany jest mail */
    MAIL              UWAGI,

    IDENT             VARCHAR(30),
    PUNKTY            ILOSC,

    DATA_WYSYLKI      TIMESTAMP,
    DATA_DOSTARCZENIA TIMESTAMP,

    UTWORZYL          KLUCZ,
    ZMIENIAL          KLUCZ,
    UTWORZONO         TIMESTAMP,
    ZMIENIANO         TIMESTAMP,

    PRIMARY KEY(KLUCZ),
    FOREIGN KEY(PACZKA) REFERENCES PACZKI_WYSYLEK(KLUCZ));

CREATE INDEX WYSYLKI_PACJENTA_XPAC ON WYSYLKI_PACJENTA(PACJENT);
CREATE INDEX WYSYLKI_PACJENTA_XADRSMS ON WYSYLKI_PACJENTA(ADRSMS);


CREATE TABLE POBRANE_SMS
   (KLUCZ             KLUCZ NOT NULL,
    PACJENT           KLUCZ,
    ADRSMS            VARCHAR(15),
    IDENT             VARCHAR(30), /* numer operatora */

    SMS               UWAGI,
    OD_KOGO           UWAGI,       /* moze byc puste lub kilka osob */
    WYSYLKA           UWAGI,       /* ewentualnie tresc ostatniego wyslanego SMS-a */

    DATA_OTRZYMANIA   TIMESTAMP,
    PRZECZYTANE       TAKNIE,


    PRIMARY KEY(KLUCZ));

CREATE INDEX POBRANE_SMS_XADRSMS ON POBRANE_SMS(ADRSMS);
CREATE INDEX POBRANE_SMS_XIDENT ON POBRANE_SMS(IDENT);
CREATE INDEX POBRANE_SMS_XPACJENT ON POBRANE_SMS(PACJENT);


/*==========================================================================*/
/* Telefony i kontakty */
/* =================== */

CREATE TABLE TELEFONY
   (TELEFON          VARCHAR(15) NOT NULL,
    DOTYCZY          KLUCZ NOT NULL,
    TYPDOTYCZY       TYP NOT NULL,     /* P - pracownicy, C - osoby fizyczne, K - kontrahenci */
    SMSY             TAKNIE,
    AKTUALNY         TAKNIE,
    ZAGRANICZNY      TAKNIE,
    OPIS             OPIS,

    UTWORZYL         KLUCZ,
    ZMIENIAL         KLUCZ,
    UTWORZONO        TIMESTAMP,
    ZMIENIANO        TIMESTAMP,

    PRIMARY KEY(TELEFON, DOTYCZY, TYPDOTYCZY));

CREATE INDEX TELEFONY_XDOTYCZY    ON TELEFONY(DOTYCZY, TYPDOTYCZY, TELEFON);

/*---*/

CREATE TABLE POLACZENIA
   (KLUCZ               KLUCZ NOT NULL, /* GET_UNIQUE_KEY_GEN */

    TELEFON_ZEWNETRZNY  VARCHAR(15) NOT NULL,    
    TELEFON_CENTRALI    VARCHAR(15) NOT NULL,
    TELEFON_WEWNETRZNY  VARCHAR(15) NOT NULL,
	LP                  INTEGER NOT NULL,
	KIERUNEK            TYP,          /* In, Out */ 
	GRUPA               VARCHAR(15),

	ID                  VARCHAR(30),  /* id rozmowy dla numeru wewnetrznego */
	ID_CO               VARCHAR(30),  /* id rozmowy dla numeru zewnetrznego, moze dotyczyc kilku id */
	STATUS              VARCHAR(30),  /* biezacy status rozmowy */
	
    POCZATEK            TIMESTAMP,
	OCZEKIWANIE         INTEGER,      /* w sekundach */
    ODEBRANO            TIMESTAMP,
    KONIEC              TIMESTAMP,
	DLUGOSC             INTEGER,      /* w sekundach */
	PLIK_NAGRANIA       VARCHAR(150),
	
    PRIMARY KEY(KLUCZ));

CREATE INDEX POL_XTELEFON_ZEWNETRZNY ON POLACZENIA(TELEFON_ZEWNETRZNY, POCZATEK);
CREATE INDEX POL_XTELEFON_CENTRALI ON POLACZENIA(TELEFON_CENTRALI, POCZATEK);
CREATE INDEX POL_XID ON POLACZENIA(ID_CO, ID);

/*---*/

CREATE TABLE KOM_Z_CENTRALI
   (POLACZENIE          KLUCZ NOT NULL,
	LP                  INTEGER NOT NULL,
    CZAS                TIMESTAMP NOT NULL,
    TELEFON_WEWNETRZNY  VARCHAR(15) NOT NULL,
	STATUS              VARCHAR(30),  /* biezacy status rozmowy */
    ODEBRANE            TAKNIE,   

    PRIMARY KEY(POLACZENIE, LP));

CREATE INDEX Z_CENTR_XTELEFON_WEWNETRZNY ON KOM_Z_CENTRALI(TELEFON_WEWNETRZNY, ODEBRANE);

/*
UWAGA: Komunikaty z centrali sa usuwane po zakonczeniu polaczenia przez PRZYCHODNIA
*/	

/*---*/

CREATE TABLE KOM_DO_CENTRALI
   (KLUCZ               KLUCZ NOT NULL, /* GET_UNIQUE_KEY_GEN */
    CZAS                TIMESTAMP NOT NULL,
    TELEFON_WEWNETRZNY  VARCHAR(15) NOT NULL,
    KTO                 INTEGER NOT NULL, 
	
	KOMENDA             VARCHAR(15),
	TELEFON             VARCHAR(15),   /* przy wybraniu numeru */
	GRUPA               VARCHAR(15),   /* logowanie, wylogowanie */
	
    PRIMARY KEY(KLUCZ));

	
/*---*/

CREATE TABLE KONTAKTY
   (KLUCZ            KLUCZ NOT NULL,     /* GET_UNIQUE_KEY_GEN */
    TYP              TYP NOT NULL,       /* T - Telefon */
    POLACZENIE       KLUCZ,              /* Dla T */
    DOTYCZY          KLUCZ,
    TYPDOTYCZY       TYP,                /* P - pracownicy, C - osoby fizyczne, K - kontrahenci */

    RODZAJ           TYP,                /* R - rejestracja przychodni */
    KLUCZ_OBCY       KLUCZ,              /* dla R - klucz pobytu (niekoniecznie) */

    UWAGI            UWAGI,

    UTWORZYL         KLUCZ,              /* Identyfikuje osob obsugujc */
    UTWORZONO        TIMESTAMP,          /* oraz czas obsugi */

    PRIMARY KEY(KLUCZ));

CREATE INDEX KONTAKTY_XPOLACZENIE ON KONTAKTY(POLACZENIE);
CREATE INDEX KONTAKTY_XDOTYCZY ON KONTAKTY(DOTYCZY, TYPDOTYCZY);
CREATE INDEX KONTAKTY_XOBCY    ON KONTAKTY(KLUCZ_OBCY);
CREATE INDEX KONTAKTY_XOBSLUGA ON KONTAKTY(UTWORZYL, UTWORZONO);


/*==========================================================================*/
/* Dokumenty elektroniczne */
/* ======================= */


CREATE TABLE DOKUMENTY_ELEKTRONICZNE
       (KLUCZ          KLUCZ NOT NULL,        /* GET_UNIQUE_KEY_GEN */
        RODZAJ         VARCHAR(20) NOT NULL,  /* PIT11, PIT11Z, ..., VAT7, ... */
        WERSJA         INTEGER NOT NULL,

        ROK            INTEGER NOT NULL,
        MIESIAC        INTEGER NOT NULL,   /* moze byc zero */
        LP             INTEGER NOT NULL,   /* nr kolejnej wysylki, nie musza to byc korekty */
        DATA           TIMESTAMP NOT NULL,
        KOREKTA        TAKNIE,             /* faktycznie K dla korekty */

        DOKUMENT       BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        WYSLANY        BLOB SUB_TYPE 0 SEGMENT SIZE 80,  /* Po podpisie */
        NR_REF         VARCHAR(100),
        STATUS         INTEGER,
        OPIS_STATUSU   VARCHAR(250),

        UPO            BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        DATA_UPO       TIMESTAMP,
        STATUS_UPO     INTEGER,
        OPIS_STAT_UPO  VARCHAR(250),

        PRIMARY KEY(KLUCZ));

CREATE  INDEX DE_XRODZAJ         ON DOKUMENTY_ELEKTRONICZNE(RODZAJ, ROK, MIESIAC, LP);
CREATE  INDEX DE_XOKRES          ON DOKUMENTY_ELEKTRONICZNE(ROK, MIESIAC, RODZAJ, LP);
CREATE  INDEX DE_XDATA           ON DOKUMENTY_ELEKTRONICZNE(DATA, RODZAJ);
CREATE  INDEX DE_XNR_REF         ON DOKUMENTY_ELEKTRONICZNE(NR_REF);


/* --- */


CREATE TABLE PITY_ELEKTRONICZNE
       (KLUCZ          KLUCZ NOT NULL,        /* GET_UNIQUE_KEY_GEN */
        RODZAJ         VARCHAR(20) NOT NULL,  /* PIT11, PIT40 */
        WERSJA         INTEGER NOT NULL,

        OSOBA          KLUCZ NOT NULL,     /* pracownik */
        ROK            INTEGER NOT NULL,
        LP             INTEGER NOT NULL,   /* nr kolejnej wysylki, tu kolejne to korekty */
        DATA           TIMESTAMP NOT NULL,
        KOREKTA        TAKNIE,             /* faktycznie K dla korekty */

        DOKUMENT       KLUCZ NOT NULL,     /* odwolanie do dokumentu */

        FOREIGN KEY(OSOBA) REFERENCES OSOBY(KLUCZ),
        FOREIGN KEY(DOKUMENT) REFERENCES DOKUMENTY_ELEKTRONICZNE(KLUCZ),
        PRIMARY KEY(KLUCZ));

CREATE  INDEX PITY_XRODZAJ      ON PITY_ELEKTRONICZNE(RODZAJ, ROK, OSOBA, LP);


/*---*/

CREATE TABLE DOKUMENTY_JPK
       (KLUCZ          KLUCZ NOT NULL,        /* GET_UNIQUE_KEY_GEN */
        RODZAJ         VARCHAR(20) NOT NULL,  /* JPK_KR, ... */

        ROK            INTEGER NOT NULL,
        MIESIAC        INTEGER NOT NULL,   /* moze byc zero */
        DATA           TIMESTAMP NOT NULL,
        OKRES          VARCHAR(25),
        KONTROLA       TAKNIE,             /* faktycznie K dla kontroli */

        DOKUMENT       BLOB SUB_TYPE 0 SEGMENT SIZE 80,  /* spakowany oryginalny dokument w xml */
        METADANE       BLOB SUB_TYPE 0 SEGMENT SIZE 80,  /* podpisany dokument przewodni w xml */
                                                         /* Teoretycznie moga sie odnosic do kilku dokumentow */
                                                         /* Aktualnie wysylany jest na raz tylko jeden dokument */
        NR_REF         VARCHAR(100),
        STATUS         INTEGER,
        OPIS_STATUSU   VARCHAR(250),

        UPO            BLOB SUB_TYPE 0 SEGMENT SIZE 80,
        DATA_UPO       TIMESTAMP,
        STATUS_UPO     INTEGER,
        OPIS_STAT_UPO  VARCHAR(250),

        PRIMARY KEY(KLUCZ));

CREATE  INDEX JPK_XRODZAJ         ON DOKUMENTY_JPK(RODZAJ, ROK, MIESIAC);
CREATE  INDEX JPK_XOKRES          ON DOKUMENTY_JPK(ROK, MIESIAC, RODZAJ);
CREATE  INDEX JPK_XDATA           ON DOKUMENTY_JPK(DATA, RODZAJ);
CREATE  INDEX JPK_XNR_REF         ON DOKUMENTY_JPK(NR_REF);


        
/*==========================================================================*/
/* Testy poprawnoci */
/* ================= */

/* Wyjtki */

CREATE EXCEPTION FIRMY_JESTPACJENT '@FIRMY_JESTPACJENT@';
CREATE EXCEPTION FIRMY_JESTSTARYPACJENT '@FIRMY_JESTSTARYPACJENT@';

SET TERM ^ ;

/* Test kasowania firmy */

CREATE TRIGGER DELETE_FIRMA FOR FIRMY
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE ZOZ INTEGER;
BEGIN
  FOR SELECT ZOZ FROM PACJENCI
  WHERE PACJENCI.ZOZ = OLD.KLUCZ
  INTO :ZOZ
  DO EXCEPTION FIRMY_JESTPACJENT ;

  FOR SELECT STARYZOZ FROM PACJENCI
  WHERE PACJENCI.STARYZOZ = OLD.KLUCZ
  INTO :ZOZ
  DO EXCEPTION FIRMY_JESTSTARYPACJENT ;
END ^

COMMIT WORK ^
SET TERM ; ^

/* --- */

CREATE EXCEPTION FAKT_CZ_PRZEKSIEGOWANE 'Faktura przeksiegowana';

SET TERM ^ ;

/* Test kasowania, poprawy faktur czynszowych */

CREATE TRIGGER UPDATE_FAKT_CZ FOR FAKTURY_CZYNSZOWE
ACTIVE BEFORE UPDATE POSITION 0
AS
DECLARE VARIABLE KLUCZ INTEGER;
BEGIN
  FOR SELECT DOKUMENT FROM ROZLICZENIA
  WHERE ROZLICZENIA.DOKUMENT = OLD.KLUCZ AND ROZLICZENIA.TYP = 'F'
  INTO :KLUCZ
  DO EXCEPTION FAKT_CZ_PRZEKSIEGOWANE ;
END ^

CREATE TRIGGER DELETE_FAKT_CZ FOR FAKTURY_CZYNSZOWE
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE KLUCZ INTEGER;
BEGIN
  FOR SELECT DOKUMENT FROM ROZLICZENIA
  WHERE ROZLICZENIA.DOKUMENT = OLD.KLUCZ AND ROZLICZENIA.TYP = 'F'
  INTO :KLUCZ
  DO EXCEPTION FAKT_CZ_PRZEKSIEGOWANE ;
END ^


CREATE TRIGGER UPDATE_SFAKT_CZ FOR SKL_FAKTUR_CZYNSZOWYCH
ACTIVE BEFORE UPDATE POSITION 0
AS
DECLARE VARIABLE KLUCZ INTEGER;
BEGIN
  FOR SELECT DOKUMENT FROM ROZLICZENIA
  WHERE ROZLICZENIA.DOKUMENT = OLD.FAKTURA_CZYNSZOWA AND ROZLICZENIA.TYP = 'F'
  INTO :KLUCZ
  DO EXCEPTION FAKT_CZ_PRZEKSIEGOWANE ;
END ^

CREATE TRIGGER DELETE_SFAKT_CZ FOR SKL_FAKTUR_CZYNSZOWYCH
ACTIVE BEFORE DELETE POSITION 0
AS
DECLARE VARIABLE KLUCZ INTEGER;
BEGIN
  FOR SELECT DOKUMENT FROM ROZLICZENIA
  WHERE ROZLICZENIA.DOKUMENT = OLD.FAKTURA_CZYNSZOWA AND ROZLICZENIA.TYP = 'F'
  INTO :KLUCZ
  DO EXCEPTION FAKT_CZ_PRZEKSIEGOWANE ;
END ^

COMMIT WORK ^
SET TERM ; ^




/*==========================================================================*/
/* Uprawnienia */
/* =========== */

GRANT ALL ON BAZA      TO PUBLIC;
GRANT ALL ON MIN_WERSJE_PROG TO PUBLIC;
GRANT ALL ON SYSTEM    TO PUBLIC;
GRANT ALL ON SYSTEMU_DANE   TO PUBLIC;
GRANT ALL ON SLAD      TO PUBLIC;
GRANT ALL ON ISLAD     TO PUBLIC;
GRANT ALL ON PRACUJACY TO PUBLIC;
GRANT ALL ON ZASOBY    TO PUBLIC;
GRANT ALL ON PODPOWIEDZIMEMO    TO PUBLIC;
GRANT ALL ON WYDRUKI   TO PUBLIC;
GRANT ALL ON SCHEMATYIMPORTU TO PUBLIC;
GRANT ALL ON RYSUNKI   TO PUBLIC;

GRANT ALL ON DEFINICJE_ZADAN TO PUBLIC;
GRANT ALL ON HARMONOGRAM TO PUBLIC;
GRANT ALL ON PROCES_SYSTEMOWY TO PUBLIC;
GRANT ALL ON KOMUNIKATY TO PUBLIC;
GRANT ALL ON ODEBRANE_KOMUNIKATY TO PUBLIC;

GRANT ALL ON KOMUNIKATY_PORTALU  TO PUBLIC;
GRANT ALL ON SERIE_KOM_PORTALU  TO PUBLIC;
GRANT ALL ON POMIARY_PACJENTOW TO PUBLIC;
GRANT ALL ON EROZLICZENIA TO PUBLIC;
GRANT ALL ON OPINIE TO PUBLIC;
GRANT ALL ON FILIE_DLA_PORTALU TO PUBLIC;

GRANT ALL ON POWIATY  TO PUBLIC;
GRANT ALL ON GMINY    TO PUBLIC;
GRANT ALL ON KODY_MIAST TO PUBLIC;

GRANT ALL ON UBEZPIECZYCIELE_UE TO PUBLIC;

GRANT ALL ON BUDYNKI  TO PUBLIC;
GRANT ALL ON LOKALE   TO PUBLIC;
GRANT ALL ON LOZKA    TO PUBLIC;

GRANT ALL ON ZAKLADY  TO PUBLIC;
GRANT ALL ON ZLECENIA_STALE  TO PUBLIC;

GRANT ALL ON POJECIA   TO PUBLIC;
GRANT ALL ON FORMATKI  TO PUBLIC;
GRANT ALL ON ZESTAWY   TO PUBLIC;
GRANT ALL ON POLA      TO PUBLIC;
GRANT ALL ON PROCEDURY TO PUBLIC;
GRANT ALL ON PROCEDURYZAKLADU TO PUBLIC;
GRANT ALL ON ICD_10    TO PUBLIC;

GRANT ALL ON OSOBY    TO PUBLIC;
GRANT ALL ON RODZINA_PRACOWNIKOW TO PUBLIC;
GRANT ALL ON PRACOWNICY TO PUBLIC;
GRANT ALL ON OSOBY_NIESPRAWNOSC TO PUBLIC;

GRANT ALL ON PACJENCI TO PUBLIC;
GRANT ALL ON UPRAWNIENIA_DODATKOWE  TO PUBLIC;
GRANT ALL ON WYDANIE_DOKUMENTACJI  TO PUBLIC;

GRANT ALL ON TABLE WYROBY_MEDYCZNE TO PUBLIC;
GRANT ALL ON TABLE WYROBY_MEDYCZNE_KOM TO PUBLIC;
GRANT ALL ON TABLE WYR_MED_KRYTERIA TO PUBLIC;
GRANT ALL ON TABLE WYR_MED_SLOWNIK TO PUBLIC;

GRANT ALL ON RODZINA  TO PUBLIC;
GRANT ALL ON PACSLAD  TO PUBLIC;

GRANT ALL ON ODPOWIEDZI_EWUS    TO PUBLIC;
GRANT ALL ON AP_KOLCE    TO PUBLIC;

GRANT ALL ON DEFINICJE_KART_PACJENTA    TO PUBLIC;
GRANT ALL ON SKL_DEFINICJI_KARTYPAC    TO PUBLIC;
GRANT ALL ON KARTA_PACJENTA    TO PUBLIC;
GRANT ALL ON SKLADNIKI_KARTYPAC    TO PUBLIC;
GRANT ALL ON HARMONOGRAM_SZCZEPIEN    TO PUBLIC;

GRANT ALL ON FIRMY    TO PUBLIC;
GRANT ALL ON TESTY_VAT    TO PUBLIC;
GRANT ALL ON ZAKLADY_FIRM    TO PUBLIC;
GRANT ALL ON ODDZIALY TO PUBLIC;
GRANT ALL ON PODMIOTY_FINANSOWE TO PUBLIC;

GRANT ALL ON SZKOLY_POZ TO PUBLIC;

GRANT ALL ON POBYTY    TO PUBLIC;
GRANT ALL ON ZLECENIA  TO PUBLIC;
GRANT ALL ON SKIEROWANIA_P1  TO PUBLIC;
GRANT ALL ON KOLEJKINFZMIESIECZNIE  TO PUBLIC;
GRANT ALL ON PROCEDURY_ZLECENIA  TO PUBLIC;
GRANT ALL ON POZ_ZLEC_LEKOW  TO PUBLIC;
GRANT ALL ON POZ_LECZ_DOJELIT  TO PUBLIC;
GRANT ALL ON HISTORIA  TO PUBLIC;
GRANT ALL ON HISTORIA_DO_WYPISU TO PUBLIC;

GRANT ALL ON BADANIA_POZ TO PUBLIC;

GRANT ALL ON NUMERYKSIAG    TO PUBLIC;
GRANT ALL ON DANERUCHUSZPITALNEGO  TO PUBLIC;
GRANT ALL ON NUMERYRUCHUSZPITALNEGO  TO PUBLIC;
GRANT ALL ON RUCHSZPITALNY  TO PUBLIC;
GRANT ALL ON OSTATNIRUCHSZPITALNY  TO PUBLIC;

GRANT ALL ON RUCHODDZIALOWY TO PUBLIC;
GRANT ALL ON PRZEPUSTKIODDZIALU TO PUBLIC;

GRANT ALL ON RUCHZBIORCZO   TO PUBLIC;
GRANT ALL ON RUCHPRZYCHODNI TO PUBLIC;
GRANT ALL ON SESJE_LECZENIA TO PUBLIC;
GRANT ALL ON PACJENCIPORADNI TO PUBLIC;

GRANT ALL ON RUCHLABORATORIUM TO PUBLIC;
GRANT ALL ON ZLECENIAPRACLAB TO PUBLIC;
GRANT ALL ON PROBKILABOR TO PUBLIC;
GRANT ALL ON POMIARYLABOR TO PUBLIC;

GRANT ALL ON NUMERYRECEPT  TO PUBLIC;
GRANT ALL ON RECEPTY    TO PUBLIC;
GRANT ALL ON NAGLOWEKRECEPTY  TO PUBLIC;
GRANT ALL ON PUSTERECEPTY  TO PUBLIC;
GRANT ALL ON RECEPTURYRECEPTY TO PUBLIC;

GRANT ALL ON ZWOLNIENIA TO PUBLIC;
GRANT ALL ON PLATNICY_ZWOLNIENIA TO PUBLIC;
GRANT ALL ON WYSYLKA_ZWOLNIENIA TO PUBLIC;
GRANT ALL ON DOKUMENTY_ZWOLNIENIA TO PUBLIC;

GRANT ALL ON HISTORIAXML        TO PUBLIC;
GRANT ALL ON POZYCJEHISTORIXML  TO PUBLIC;
GRANT ALL ON INSTALACJE_NFZ     TO PUBLIC;
GRANT ALL ON KOMUNIKACJANFZ     TO PUBLIC;
GRANT ALL ON KOMUNIKACJANFZ_WS     TO PUBLIC;
GRANT ALL ON DEKLARACJENFZ      TO PUBLIC;
GRANT ALL ON ROZLICZENIA_DEKLARACJI  TO PUBLIC;

GRANT ALL ON UMOWY_NFZ           TO PUBLIC;
GRANT ALL ON PRODUKTY_UMOWY      TO PUBLIC;
GRANT ALL ON KOMORKI_PRODUKTU    TO PUBLIC;
GRANT ALL ON GRUPY_LIMITOWANIA   TO PUBLIC;

GRANT ALL ON KOSZTYMPK           TO PUBLIC;
GRANT ALL ON KOSZTYZBIORCZO      TO PUBLIC;
GRANT ALL ON PROCEDURYZBIORCZO   TO PUBLIC;

GRANT ALL ON KOSZTY_OPERACJI TO PUBLIC;
GRANT ALL ON KOSZTY_LEK_OPERACJI TO PUBLIC;
GRANT ALL ON STAWKI_OPERACJI TO PUBLIC;

GRANT ALL ON RODZAJE_KOSZTOW_SZPITALA TO PUBLIC;
GRANT ALL ON STAWKI_KOSZTOW_SZPITALA  TO PUBLIC;
GRANT ALL ON KOSZTY_LEK_ODDZIALU      TO PUBLIC;
GRANT ALL ON KOSZTY_OSOBODNI_ODDZIALU TO PUBLIC;

GRANT ALL ON STAWKI_PROCEDUR_SZPITALA TO PUBLIC;
GRANT ALL ON KOSZTY_PROCEDUR_ODDZIALU TO PUBLIC;

GRANT ALL ON EWIDENCJAPOMOCNICZA TO PUBLIC;
GRANT ALL ON INDEKS              TO PUBLIC;
GRANT ALL ON CENNIK              TO PUBLIC;
GRANT ALL ON NORMY               TO PUBLIC;
GRANT ALL ON ZUZYCIE             TO PUBLIC;

GRANT ALL ON WMAGAZYNIE                 TO PUBLIC;
GRANT ALL ON OBROTYMAGAZYNU             TO PUBLIC;
GRANT ALL ON POZYCJAOBROTU              TO PUBLIC;
GRANT ALL ON LISTAPRZYCHODOWDLAROZCHODU TO PUBLIC;
GRANT ALL ON OBROTYMIESIECZNE           TO PUBLIC;
GRANT ALL ON INWENTARYZACJA             TO PUBLIC;
GRANT ALL ON POZYCJAINWENT              TO PUBLIC;

GRANT ALL ON NORMYLABORATORIUM          TO PUBLIC;

GRANT ALL ON SKLADNIKIKONT TO PUBLIC;
GRANT ALL ON WYKAZKONT TO PUBLIC;
GRANT ALL ON OBROTYKONT TO PUBLIC;
GRANT ALL ON DEFINICJEDOKKSIEGOWYCH TO PUBLIC;
GRANT ALL ON POZDEFINICJIDOKKSIEGOWYCH TO PUBLIC;
GRANT ALL ON DOKUMENTYKSIEGOWE TO PUBLIC;
GRANT ALL ON POZDOKUMENTOWKSIEGOWYCH TO PUBLIC;
GRANT ALL ON PRZEKSZTALCENIEBILANSU TO PUBLIC;
GRANT ALL ON REJESTRYVAT          TO PUBLIC;
GRANT ALL ON POZYCJEREJESTRUVAT   TO PUBLIC;

GRANT ALL ON APARATURA_MEDYCZNA TO PUBLIC;
GRANT ALL ON WYLACZENIA_UZYTKOWANIA TO PUBLIC;
GRANT ALL ON REZERWACJE_APARATURY TO PUBLIC;

GRANT ALL ON KLASYFIKACJASRODKOW  TO PUBLIC;
GRANT ALL ON SRODKITRWALE TO PUBLIC;
GRANT ALL ON SRODKIKONCAROKU TO PUBLIC;
GRANT ALL ON KONTASRODKOW TO PUBLIC;
GRANT ALL ON DOKUMENTYSRODKOW TO PUBLIC;
GRANT ALL ON POZYCJEDOKSRODKOW TO PUBLIC;
GRANT ALL ON INWENTARYZACJASRODKOW TO PUBLIC;
GRANT ALL ON POZYCJEINWSRODKOW TO PUBLIC;

GRANT ALL ON AUTOMATYPK TO PUBLIC;
GRANT ALL ON DEFEWIDENCJIPOMOCNICZEJ TO PUBLIC;
GRANT ALL ON DOKUMENTYKASYBANKU TO PUBLIC;
GRANT ALL ON ODSETKI TO PUBLIC;

GRANT ALL ON WYRAZENIA TO PUBLIC;
GRANT ALL ON ARGUMENTY TO PUBLIC;
GRANT ALL ON TABLICEWYRAZEN TO PUBLIC;
GRANT ALL ON POZYCJETABLICWYRAZEN TO PUBLIC;
GRANT ALL ON SPRAWOZDANIAFIN TO PUBLIC;
GRANT ALL ON POZSPRAWOZDANIAFIN TO PUBLIC;
GRANT ALL ON POZSPRAWOZDANIAPOD TO PUBLIC;

GRANT ALL ON NOTYODSETKOWE TO PUBLIC;
GRANT ALL ON SALDA TO PUBLIC;
GRANT ALL ON POZYCJE_SALD TO PUBLIC;
GRANT ALL ON POZYCJE_NOT_ODSETKOWYCH TO PUBLIC;
GRANT ALL ON PRZELEWY TO PUBLIC;
GRANT ALL ON POZYCJEPRZELEWOW TO PUBLIC;

GRANT ALL ON CENNIKISPRZEDAZY TO PUBLIC;
GRANT ALL ON CENYSPRZEDAZY TO PUBLIC;
GRANT ALL ON SKLADNIKICEN TO PUBLIC;
GRANT ALL ON JEDNOSTKIWYKONUJACE TO PUBLIC;
GRANT ALL ON OSOBYWYKONUJACE TO PUBLIC;
GRANT ALL ON CENYFIRMOWE TO PUBLIC;
GRANT ALL ON SPECYFIKACJAFAKTURY TO PUBLIC;

GRANT ALL ON GRUPYPROWIZYJNE TO PUBLIC;
GRANT ALL ON PROWIZJE TO PUBLIC;
GRANT ALL ON POZYCJEPROWIZJI TO PUBLIC;

GRANT ALL ON WYKONANIA_PROD_MED TO PUBLIC;
GRANT ALL ON SKL_WYK_PROD_MED TO PUBLIC;
GRANT ALL ON PAKIETYPACJENTOW TO PUBLIC;

GRANT ALL ON BAZYL_KODY TO PUBLIC;
GRANT ALL ON BAZYL_PRODUCENCI TO PUBLIC;
/*
GRANT ALL ON CHEMIOTERAPIA TO PUBLIC;
*/
GRANT ALL ON PHI_ODCZYTY            TO PUBLIC;
GRANT ALL ON PHI_DiseasePayments    TO PUBLIC;
GRANT ALL ON PHI_Prescriptions      TO PUBLIC;
GRANT ALL ON PHI_Diseases           TO PUBLIC;
GRANT ALL ON PHI_Atc                TO PUBLIC;
GRANT ALL ON PHI_Subst              TO PUBLIC;
GRANT ALL ON PHI_Status             TO PUBLIC;
GRANT ALL ON PHI_CompanyList        TO PUBLIC;
GRANT ALL ON PHI_Drugs              TO PUBLIC;
GRANT ALL ON PHI_DrugForms          TO PUBLIC;
GRANT ALL ON PHI_Indications        TO PUBLIC;
GRANT ALL ON PHI_IndicationConditions TO PUBLIC;
GRANT ALL ON PHI_ActiveComposition  TO PUBLIC;

GRANT ALL ON PHI_packagesafety           TO PUBLIC;
GRANT ALL ON PHI_pregnancycategory       TO PUBLIC;
GRANT ALL ON PHI_drivingcategory         TO PUBLIC;
GRANT ALL ON PHI_marketstatus            TO PUBLIC;
GRANT ALL ON PHI_drugformmarketstatus    TO PUBLIC;
GRANT ALL ON PHI_Skladniki               TO PUBLIC;
GRANT ALL ON PHI_Drug_ATC                TO PUBLIC;

GRANT ALL ON Produkty_lecznicze TO PUBLIC;

GRANT ALL ON PRODUKTY TO PUBLIC;
GRANT ALL ON KODY_PRODUKTOW TO PUBLIC;
GRANT ALL ON ZAKLADY_PRODUKTOW TO PUBLIC;
GRANT ALL ON TARYFY_PRODUKTOW TO PUBLIC;
GRANT ALL ON ODCZYTY_NMVS TO PUBLIC;
GRANT ALL ON GRUPY_NMVS TO PUBLIC;

GRANT ALL ON ZAMOWIENIA TO PUBLIC;
GRANT ALL ON POZYCJAZAMOWIENIA TO PUBLIC;

GRANT ALL ON DYZUR              TO PUBLIC;
GRANT ALL ON GRAFIK             TO PUBLIC;
GRANT ALL ON TYPY_TYGODNIA      TO PUBLIC;
GRANT ALL ON GRAFIK_TYGODNIOWY  TO PUBLIC;
GRANT ALL ON DEF_DYZURU         TO PUBLIC;
GRANT ALL ON OSOBA_GRAF         TO PUBLIC;

GRANT ALL ON GODZ_PRACY  TO PUBLIC;
GRANT ALL ON CZAS_PRACY  TO PUBLIC;

GRANT ALL ON RECEPTURA TO PUBLIC;
GRANT ALL ON POZRECEPTURY TO PUBLIC;


GRANT ALL ON DEFINICJEUMOWSTALYCH TO PUBLIC;
GRANT ALL ON UMOWYSTALE TO PUBLIC;
GRANT ALL ON PAKIETYUMOWY TO PUBLIC;
GRANT ALL ON SPECYFIKACJAUMOWY TO PUBLIC;
GRANT ALL ON WYKONANIEUMOWY TO PUBLIC;

GRANT ALL ON OSIEDLA                  TO PUBLIC;
GRANT ALL ON NIERUCHOMOSCI            TO PUBLIC;
GRANT ALL ON BUDOWLE                  TO PUBLIC;

GRANT ALL ON LICZNIKI                 TO PUBLIC;
GRANT ALL ON POMIESZCZENIA            TO PUBLIC;
GRANT ALL ON SKLADNIKI_POMIESZCZEN    TO PUBLIC;

GRANT ALL ON POMIARY_PUNKTU            TO PUBLIC;
GRANT ALL ON POMIARY_LICZNIKOW         TO PUBLIC;
GRANT ALL ON ROZLICZENIE_MEDIOW        TO PUBLIC;
GRANT ALL ON NAGLOWEK_ROZLICZENIA_MEDIOW    TO PUBLIC;
GRANT ALL ON ZUZYCIE_MEDIOW            TO PUBLIC;
GRANT ALL ON LICZNIKI_ZUZYCIA_MEDIOW   TO PUBLIC;

GRANT ALL ON LOKATORZY                TO PUBLIC;
GRANT ALL ON ZASIEDLENIA              TO PUBLIC;
GRANT ALL ON ZASIEDLENIA_BANK         TO PUBLIC;
GRANT ALL ON NAGLOWEK_ZNIZEK_PODWYZEK TO PUBLIC;
GRANT ALL ON ZNIZKI_PODWYZKI          TO PUBLIC;
GRANT ALL ON ZASADY_MEDIOW            TO PUBLIC;
GRANT ALL ON NORMY_MEDIOW             TO PUBLIC;
GRANT ALL ON SMIECI_NA_ZASIEDLENIE    TO PUBLIC;

GRANT ALL ON INNE_OPLATY_CZYNSZU TO PUBLIC;
GRANT ALL ON ZASADY_CZYNSZOWE    TO PUBLIC;
GRANT ALL ON SKLADNIKI_ZASAD     TO PUBLIC;
GRANT ALL ON ZASADY_BUDOWLI TO PUBLIC;

GRANT ALL ON STAWKI_ZA_POJEMNIKI  TO PUBLIC;
GRANT ALL ON POJEMNIKI_NA_SMIECI  TO PUBLIC;

GRANT ALL ON MIESIECZNE_CZYNSZE         TO PUBLIC;
GRANT ALL ON SKL_MIESIECZNYCH_CZYNSZOW  TO PUBLIC;
GRANT ALL ON FAKTURY_CZYNSZOWE       TO PUBLIC;
GRANT ALL ON SKL_FAKTUR_CZYNSZOWYCH  TO PUBLIC;
GRANT ALL ON NALICZENIA_DO_FAKTUR TO PUBLIC;

GRANT ALL ON NAGLOWEK_ROZLICZEN_SKLADNIKOW TO PUBLIC;
GRANT ALL ON BUDOWLE_ROZLICZEN_SKLADNIKOW TO PUBLIC;

GRANT ALL ON POZYCJE_CENNIKOW        TO PUBLIC;
GRANT ALL ON CENNIKI_INFRASTRUKTURY  TO PUBLIC;
GRANT ALL ON ROZL_STAWKI_BUDOWLI  TO PUBLIC;

GRANT ALL ON DODATKI_MIESZKANIOWE     TO PUBLIC;
GRANT ALL ON ROZLICZENIE_DODATKOW_MIESZK TO PUBLIC;

GRANT ALL ON DEFINICJEKASYBANKU TO PUBLIC;
GRANT ALL ON KASABANK TO PUBLIC;
GRANT ALL ON DOKUMENTYPOZACZYNSZOWE TO PUBLIC;
GRANT ALL ON ROZLICZENIA TO PUBLIC;
GRANT ALL ON ROZLICZENIA_ARCH TO PUBLIC;
GRANT ALL ON SALDA_ROZLICZEN TO PUBLIC;

GRANT ALL ON CZLONKOWIE_SPOLDZIELNI TO PUBLIC;
GRANT ALL ON HISTORIA_CZLONKOW TO PUBLIC;
GRANT ALL ON LOKALE_CZLONKOW TO PUBLIC;
GRANT ALL ON LOKALE_WSPOLCZLONKOW  TO PUBLIC;
GRANT ALL ON WKLADY_SPOLDZIELCZE TO PUBLIC;

GRANT ALL ON WINDYKACJA TO PUBLIC;
GRANT ALL ON POZYCJE_WINDYKACJI TO PUBLIC;

GRANT ALL ON RODZAJE_KOSZTOW_CZYNSZOWYCH TO PUBLIC;
GRANT ALL ON KOSZTY_OSIEDLI TO PUBLIC;
GRANT ALL ON KOSZTY_NIERUCHOMOSCI TO PUBLIC;
GRANT ALL ON KOSZTY_BUDYNKOW TO PUBLIC;
GRANT ALL ON KOSZTY_LOKALI TO PUBLIC;

GRANT ALL ON SPRAWY_SADOWE TO PUBLIC;

GRANT ALL ON KOMUNIKATY_CZYNSZOWE      TO PUBLIC;
GRANT ALL ON TEMATY_CZYNSZOWE      TO PUBLIC;

GRANT ALL ON TECZKI_DOKUMENTOW TO PUBLIC;
GRANT ALL ON DOKUMENTY_TECZKI TO PUBLIC;
GRANT ALL ON HISTORIA_TECZKI TO PUBLIC;

GRANT ALL ON LISTA_WYSYLEK     TO PUBLIC;
GRANT ALL ON PACZKI_WYSYLEK    TO PUBLIC;
GRANT ALL ON WYSYLKI_PACJENTA  TO PUBLIC;
GRANT ALL ON POBRANE_SMS  TO PUBLIC;

GRANT ALL ON TELEFONY  TO PUBLIC;
GRANT ALL ON POLACZENIA  TO PUBLIC;
GRANT ALL ON KOM_Z_CENTRALI  TO PUBLIC;
GRANT ALL ON KOM_DO_CENTRALI  TO PUBLIC;
GRANT ALL ON KONTAKTY  TO PUBLIC;

GRANT ALL ON DOKUMENTY_ELEKTRONICZNE TO PUBLIC;
GRANT ALL ON PITY_ELEKTRONICZNE TO PUBLIC;
GRANT ALL ON DOKUMENTY_JPK TO PUBLIC;

GRANT EXECUTE ON PROCEDURE CZAS_SERWERA     TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_WYDRUK       TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_SCHEMATYIMPORTU  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_OSOBE        TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_LOZKO        TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_ZAKLAD       TO PUBLIC;
GRANT EXECUTE ON PROCEDURE ZAKLADY_NADRZEDNE TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_POJECIE      TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_FORMATKE     TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_PROCEDURE    TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_PACJENTA     TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SZUKAJ_PACJENTA  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_NAGLOWEKRECEPTY  TO PUBLIC;

GRANT EXECUTE ON PROCEDURE LEKARZDLAPACJENTA        TO PUBLIC;
GRANT EXECUTE ON PROCEDURE PIELEGNIARKADLAPACJENTA  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE POLOZNADLAPACJENTA       TO PUBLIC;
GRANT EXECUTE ON PROCEDURE NALEZYDOZOZ              TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_DEKLARACJENFZ        TO PUBLIC;

GRANT EXECUTE ON PROCEDURE WYSYLKI_XML TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_BADANIE_POZ   TO PUBLIC;

GRANT EXECUTE ON PROCEDURE REZERWACJA_WIZYTY   TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_FIRME        TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_POBYT        TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_ZLECENIE     TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_HISTORIA     TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_PROBKILABOR  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_POMIARYLABOR  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_INDEKS       TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_RUCHSZPITALNY  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_RUCHPRZYCHODNI TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_HISTORIEXML    TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_KOMUNIKACJENFZ TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_PRODUKTY_UMOWY  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_UPRAWNIENIA TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_WMAGAZYNIE     TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_OBROTYMAGAZYNU TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_POZYCJAOBROTU  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DO_INWENTARYZACJI  TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_SKLADNIKIKONT TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_DEFINICJEDOKKSIEGOWYCH TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_DOKUMENTYKSIEGOWE TO PUBLIC;
GRANT EXECUTE ON PROCEDURE WYKAZSRODKOW TO PUBLIC;
GRANT EXECUTE ON PROCEDURE PRZYWROCSRODKIKONCAROKU TO PUBLIC;
GRANT EXECUTE ON PROCEDURE WYKAZSRODKOWNAMIESIAC TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_SRODKITRWALE TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_DOKUMENTYSRODKOW TO PUBLIC;

GRANT EXECUTE ON PROCEDURE TABELAODSETKOWA TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_SALDO  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_TYPSALDA  TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DANE_SALDA_DOKUMENTU  TO PUBLIC;

GRANT EXECUTE ON PROCEDURE SALDANADZIEN TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SALDADODNIA TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDANADZIEN TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDADODNIA TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDA TO PUBLIC;

GRANT EXECUTE ON PROCEDURE SALDANADZIEN_ZATW TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SALDADODNIA_ZATW TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDANADZIEN_ZATW TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDADODNIA_ZATW TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDA_ZATW TO PUBLIC;

GRANT EXECUTE ON PROCEDURE SALDANADZIEN_ROB TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SALDADODNIA_ROB TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDANADZIEN_ROB TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDADODNIA_ROB TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDA_ROB TO PUBLIC;

GRANT EXECUTE ON PROCEDURE KOPIUJDEFINICJEFINANSOWE TO PUBLIC;
GRANT EXECUTE ON PROCEDURE OPISSALDA TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_WYRAZENIA TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DAJ_PRZELEW  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE POZOSTALEPRZELEWY  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDSALDAIPRZELEW TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_CENNIKISPRZEDAZY TO PUBLIC;

GRANT EXECUTE ON PROCEDURE GET_UNIQUE_KEY_GEN   TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_WPLATY_POZYCZEK TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DAJ_SALDOR TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DATY_DOK_CZYNSZOWYCH TO PUBLIC;
GRANT EXECUTE ON PROCEDURE LOKALE_CZLONKOW_RAZEM TO PUBLIC;
GRANT EXECUTE ON PROCEDURE LOKALE_CZLONKOW_I_WSPOLCZLONKOW  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE WLASCICIELE_LOKALU TO PUBLIC;

GRANT EXECUTE ON PROCEDURE ZALEGLOSC_STAT_CZYNSZU TO PUBLIC;
GRANT EXECUTE ON PROCEDURE ZALEGLOSC_STAT_CZYNSZU_NOWE TO PUBLIC;
GRANT EXECUTE ON PROCEDURE ZALEGLOSC_STAT_CZYNSZU_RODZAJ TO PUBLIC;
GRANT EXECUTE ON PROCEDURE GET_KONTYNUACJE_GEN   TO PUBLIC;

GRANT EXECUTE ON PROCEDURE INFRASTRUKTURA_CALOSC TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INFRASTRUKTURA_ZASIEDLENIA TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INFRASTRUKTURA_LOKATORZY TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INFRASTRUKTURA_ROZRACHUNKI TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INFRASTRUKTURA_KONTYNUACJE TO PUBLIC;

GRANT EXECUTE ON PROCEDURE SALDA_OGOLEM TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SALDA_OGOLEM_DT_PLAT TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SALDA_DLA_WINDYKACJI TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SALDA_OSOB_LOKALI TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SALDA_OSOB TO PUBLIC;
GRANT EXECUTE ON PROCEDURE SALDA_LOKALI TO PUBLIC;

GRANT EXECUTE ON PROCEDURE WYKAZ_ZASAD_CZYNSZOWYCH TO PUBLIC;
GRANT EXECUTE ON PROCEDURE WYKAZ_ZASAD_NIERUCHOMOSCI TO PUBLIC;
GRANT EXECUTE ON PROCEDURE WYKAZ_ZASAD_BUDOWLI TO PUBLIC;
GRANT EXECUTE ON PROCEDURE WYKAZ_ZASAD_ZASIEDLENIA_START TO PUBLIC;
GRANT EXECUTE ON PROCEDURE WYKAZ_ZASAD_ZASIEDLENIA TO PUBLIC;
GRANT EXECUTE ON PROCEDURE DANE_NALICZEN TO PUBLIC;
GRANT EXECUTE ON PROCEDURE INDYWIDUALNA_STAWKA    TO PUBLIC;

GRANT EXECUTE ON PROCEDURE ZASADY_BUDOWLI_TBL            TO PUBLIC;
GRANT EXECUTE ON PROCEDURE ZASADY_ZASIEDLENIA_START_TBL  TO PUBLIC;
GRANT EXECUTE ON PROCEDURE ZASADY_ZASIEDLENIA_TBL        TO PUBLIC;

GRANT EXECUTE ON PROCEDURE WYKAZ_NORM_BUDOWLI TO PUBLIC;
GRANT EXECUTE ON PROCEDURE WYKAZ_NORM_LOKALU TO PUBLIC;

GRANT EXECUTE ON PROCEDURE LOKATORZY_ZMIANY TO PUBLIC;
GRANT EXECUTE ON PROCEDURE LOKATORZY_HISTORIA TO PUBLIC;

GRANT EXECUTE ON PROCEDURE DNI_ZASILKOWE_LISTY   TO PUBLIC;

GRANT ALL ON DEF_LIST_PLAC  TO PUBLIC;
GRANT ALL ON ELEM_DEF_LISTY_PLAC  TO PUBLIC;
GRANT ALL ON ELEM_LISTY_PLAC  TO PUBLIC;

GRANT ALL ON NAGLOWKI_LIST_PLAC TO PUBLIC;
GRANT ALL ON LISTY_PLAC TO PUBLIC;
GRANT ALL ON SKLADNIKI_LISTY_PLAC TO PUBLIC;

GRANT ALL ON DEF_ANGAZY  TO PUBLIC;
GRANT ALL ON ELEM_ANGAZY  TO PUBLIC;
GRANT ALL ON ELEM_ANGAZU  TO PUBLIC;

GRANT ALL ON ANGAZE TO PUBLIC;
GRANT ALL ON KOSZTY_ANGAZY TO PUBLIC;
GRANT ALL ON SKLADNIKI_ANGAZY TO PUBLIC;

GRANT ALL ON DOKUMENTY_KADROWE TO PUBLIC;

GRANT ALL ON SWIETA TO PUBLIC;
GRANT ALL ON RODZAJE_NIEOBECNOSCI TO PUBLIC;
GRANT ALL ON NIEOBECNOSCI TO PUBLIC;
GRANT ALL ON ROZLICZENIE_NIEOBECNOSCI TO PUBLIC;
GRANT ALL ON SREDNIE_ZAS_URL TO PUBLIC;

GRANT ALL ON ELEM_KART_PRACY TO PUBLIC;
GRANT ALL ON ELEM_KARTY_ANGAZU TO PUBLIC;
GRANT ALL ON KARTA_PRACY TO PUBLIC;
GRANT ALL ON POZYCJE_KARTY_PRACY TO PUBLIC;
GRANT ALL ON SKLADNIKI_KART_PRACY TO PUBLIC;

GRANT ALL ON TABELA_PODATKOWA TO PUBLIC;

GRANT ALL ON SKLADKI_ROCZNE_OSOBY TO PUBLIC;
GRANT ALL ON SKLADKI_MIESIECZNE_ANGAZU TO PUBLIC;

GRANT ALL ON WYRAZENIA_PLACOWE TO PUBLIC;
GRANT ALL ON ARGUMENTY_PLACOWE TO PUBLIC;

GRANT ALL ON RODZAJE_DODATKOW TO PUBLIC;
GRANT ALL ON DODATKI_ANGAZU TO PUBLIC;

GRANT ALL ON RODZAJE_POTRACEN TO PUBLIC;
GRANT ALL ON POTRACENIA_ANGAZU TO PUBLIC;

GRANT ALL ON KASA_PLACOWA TO PUBLIC;

GRANT ALL ON CZLONKOWIE_KZP TO PUBLIC;

GRANT ALL ON DANE_DLA_ROR TO PUBLIC;
GRANT ALL ON PRZELEWY_Z_LIST TO PUBLIC;

GRANT ALL ON SLOWNIKI_PLACOWE TO PUBLIC;
GRANT ALL ON PARAMETRY_PLACOWE TO PUBLIC;

GRANT ALL ON WYMIARY_URLOPOW TO PUBLIC;
GRANT ALL ON PLAN_URLOPOW    TO PUBLIC;

GRANT ALL ON OKRESY_SKLADKOWE TO PUBLIC;
GRANT ALL ON RODZAJE_KURSOW TO PUBLIC;
GRANT ALL ON KURSY TO PUBLIC;
GRANT ALL ON SZKOLY            TO PUBLIC;
GRANT ALL ON BADANIA_LEKARSKIE TO PUBLIC;
GRANT ALL ON RODZAJE_BADAN TO PUBLIC;

GRANT ALL ON SWIADCZENIA TO PUBLIC;
GRANT ALL ON PUNKTY_SWIADCZEN TO PUBLIC;
GRANT ALL ON SWIADCZENIA_ICD_10 TO PUBLIC;
GRANT ALL ON SWIADCZENIA_ZAKLADU TO PUBLIC;
GRANT ALL ON SWIADCZENIA_PACJENTA TO PUBLIC;
GRANT ALL ON BLEDY_PORTALU TO PUBLIC;
GRANT ALL ON FAKTURY_SWIADCZENIA_PACJENTA TO PUBLIC;
GRANT ALL ON UPRAWNIENIA TO PUBLIC;
GRANT ALL ON ROZLICZENIA_SWIADCZEN  TO PUBLIC;
GRANT ALL ON ROZLICZENIA_SIMP  TO PUBLIC;		
GRANT ALL ON ROZLICZENIA_TRANSPORTU_POZ  TO PUBLIC;
GRANT ALL ON SWIADCZENIA_PRODUKTU  TO PUBLIC;

GRANT ALL ON SPEC_ROZLICZENIE TO PUBLIC;
GRANT ALL ON SPEC_ROZLICZENIE_WSP TO PUBLIC;

GRANT ALL ON PRODUKTY_KONTRAKTU TO PUBLIC;
GRANT ALL ON TABELE_USL_PRZYCH TO PUBLIC;
GRANT ALL ON USLUGI_PRZYCHODNI TO PUBLIC;
GRANT ALL ON SLAD_EKSPORTOW TO PUBLIC;

GRANT ALL ON JGP_WERSJA      TO PUBLIC;
GRANT ALL ON JGP_WYL_JEDN      TO PUBLIC;
GRANT ALL ON JGP_GRUPY      TO PUBLIC;
GRANT ALL ON JGP_KAT_1B      TO PUBLIC;
GRANT ALL ON JGP_KAT_1C      TO PUBLIC;
GRANT ALL ON JGP_MAC_SUM_1C      TO PUBLIC;
GRANT ALL ON JGP_ZAKRESY      TO PUBLIC;
GRANT ALL ON JGP_PARAM      TO PUBLIC;
GRANT ALL ON JGP_LPROC      TO PUBLIC;
GRANT ALL ON JGP_LROZP      TO PUBLIC;
GRANT ALL ON JGP_OSOBODNI      TO PUBLIC;
GRANT ALL ON JGP_OGR_POB      TO PUBLIC;
GRANT ALL ON JGP_OGR_WIEKU      TO PUBLIC;
GRANT ALL ON JGP_OGR_PRZYJ      TO PUBLIC;
GRANT ALL ON JGP_OGR_WYPISU      TO PUBLIC;

GRANT ALL ON JGP_AOS_WERSJE     TO PUBLIC;
GRANT ALL ON JGP_AOS_GRUPY      TO PUBLIC;
GRANT ALL ON JGP_AOS_LPROC      TO PUBLIC;
GRANT ALL ON JGP_AOS_LROZP      TO PUBLIC;
GRANT ALL ON JGP_AOS_PARAM      TO PUBLIC;
GRANT ALL ON JGP_AOS_OBCE_PROCEDURY TO PUBLIC;

GRANT ALL ON PROFILE_UZYTKOWNIKOW  TO PUBLIC;
GRANT ALL ON PRAWA_UZYTKOWNIKOW  TO PUBLIC;

GRANT ALL ON WYDRUKI_FR  TO PUBLIC;
GRANT ALL ON WARUNKI_FR  TO PUBLIC;

COMMIT WORK;

/* ------ */
/* KONIEC */
/* ------ */

